!
! $Id: $
!
MODULE logic_mod

IMPLICIT NONE

  LOGICAL purmats ! true if time stepping is purely Matsuno scheme
                  ! false implies Matsuno-Leapfrog time stepping scheme
  LOGICAL forward ! true if during forward phase of Matsuno step
  LOGICAL leapf ! true if during a leapfrog time stepping step
  LOGICAL apphys ! true if during a time step when physics will be called
  LOGICAL statcl
  LOGICAL conser
  LOGICAL apdiss ! true if during a time step when dissipation will be called
  LOGICAL apdelq
  LOGICAL saison
  LOGICAL ecripar
  LOGICAL fxyhypb ! true if using hyperbolic function discretization
                  ! for latitudinal grid 
  LOGICAL ysinus ! true if using sine function discretiation
                 ! for latitudinal grid
  LOGICAL read_start ! true if reading a start.nc file to initialize fields
  LOGICAL ok_guide ! true if nudging
  LOGICAL ok_strato
  LOGICAL ok_gradsfile
  LOGICAL ok_limit  ! true for boundary conditions file creation (limit.nc)
  LOGICAL ok_etat0  ! true for initial states creation (start.nc, startphy.nc)
  LOGICAL read_orop ! true for sub-cell scales orographic params read in file
  LOGICAL hybrid ! vertical coordinate is hybrid if true (sigma otherwise)
                 ! (only used if disvert_type==2)
  LOGICAL adv_qsat_liq ! true if qsat is calculated alwats wrt liquid for
                       ! adapted Van Leer advection scheme
  INTEGER iflag_phys ! type of physics to call: 0 none, 1: phy*** package,
                     ! 2: Held & Suarez, 101-200: aquaplanets & terraplanets
  INTEGER iflag_trac

!$OMP THREADPRIVATE(purmats,forward,leapf,apphys,statcl,conser, &
!$OMP     apdiss,apdelq,saison,ecripar,fxyhypb,ysinus, &
!$OMP     read_start,ok_guide,ok_strato,ok_gradsfile, &
!$OMP     ok_limit,ok_etat0,hybrid, adv_qsat_liq)
!$OMP THREADPRIVATE(iflag_phys,iflag_trac)

!WARNING: when adding a threadprivate variable in this module
!        do not forget to add it to the copyin clause when opening an OpenMP
!        parallel section. e.g. in gcm before call leapfrog_loc 

END MODULE logic_mod

MODULE YOESRTAER

USE PARKIND1  ,ONLY : JPRB

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------
!*    ** *YOESRTAER* - AEROSOL OPTICAL PROPERTIES FOR SRTM 
!     ------------------------------------------------------------------

!-- AEROSOL OPTICAL PROPERTIES

!-- coefficients and parameters related to SRTM_SW 16 sp.int.

REAL(KIND=JPRB) :: RSRTAUA(14,6)
REAL(KIND=JPRB) :: RSRPIZA(14,6)
REAL(KIND=JPRB) :: RSRASYA(14,6)

!     -----------------------------------------------------------------

!        * E.C.M.W.F. PHYSICS PACKAGE *

!     J.-J. MORCRETTE       E.C.M.W.F.      03/03/07

!  NAME     TYPE     PURPOSE
!  ----  :  ----   : -------
!RSRTAUA :  REAL     S.W. NORMALIZED OPTICAL THICKNESS AT 0.55 MICRON
!RSRPIZA :  REAL     S.W. SINGLE SCATTERING ALBEDO
!RSRASYA :  REAL     S.W. ASSYMETRY FACTOR

!     -----------------------------------------------------------------
!$OMP THREADPRIVATE(rsrasya,rsrpiza,rsrtaua)
END MODULE YOESRTAER

! $Id: calwake.F90 6201 2026-04-23 18:18:01Z lguez $
!$gpum horizontal klon nlon
MODULE calwake_mod
  PRIVATE

  LOGICAL, SAVE, ALLOCATABLE :: first(:) ! first(klon) : first calwake computation on columns
  !$OMP THREADPRIVATE(first)

  LOGICAL, SAVE :: first_first=.TRUE.  ! fisrt call to calwake
  !$OMP THREADPRIVATE(first_first)  

  PUBLIC calwake_first, calwake

CONTAINS  

SUBROUTINE calwake_first(dtime)
USE dimphy, ONLY : klon,klev
USE lmdz_wake_first, ONLY : wake_first
  REAL, INTENT(IN)  :: dtime 
  
  IF (first_first) THEN
    ALLOCATE(first(klon))
    first(:)=.TRUE.
    
    CALL wake_first(klev, dtime)

    first_first=.FALSE.
  ENDIF

END SUBROUTINE calwake_first


SUBROUTINE calwake(iflag_wake_tend, paprs, pplay, dtime, &
    t, q, omgb, &
    dt_dwn, dq_dwn, m_dwn, m_up, dt_a, dq_a, wgen, &
    sigd, Cin, &
    wake_deltat, wake_deltaq, wake_s, awake_s, wake_dens, awake_dens, &
    wake_dth, wake_h, &
    wake_pe, wake_fip, wake_gfl, &
    dt_wake, dq_wake, wake_k, t_x, q_x, wake_omgbdth, &
    wake_dp_omgb, &
    wake_dtke, wake_dqke, &
    wake_omg, wake_dp_deltomg, &
    wake_spread, wake_cstar, wake_d_deltat_gw, &
    wake_ddeltat, wake_ddeltaq, wake_ds, awake_ds, wake_ddens, awake_ddens &
#ifdef ISO
     & ,xt,dxt_dwn,dxt_a &
     & ,wake_deltaxt,dxt_wake,xt_x,wake_ddeltaxt &
#endif      
     )
  ! **************************************************************
  ! *
  ! CALWAKE                                                     *
  ! interface avec le schema de calcul de la poche    *
  ! froide                                            *
  ! *
  ! written by   : CHERUY Frederique, 13/03/2000, 10.31.05      *
  ! modified by :  ROEHRIG Romain,    01/30/2007                *
  ! **************************************************************

  USE dimphy
  USE phys_state_var_mod, ONLY: pctsrf
  USE indice_sol_mod, ONLY: is_oce
  USE print_control_mod, ONLY: lunout, prt_level
  USE lmdz_wake, ONLY : wake
  USE lmdz_wake2, ONLY : wake2
  USE lmdz_wake3, ONLY : wake3
  USE conf_phys_m, ONLY: iflag_wake
#ifdef ISO
  USE infotrac_phy, ONLY : ntraciso=>ntiso
#ifdef ISOVERIF
  USE isotopes_mod, ONLY: iso_eau
  USE isotopes_verif_mod
#endif
#endif
  USE yomcst_mod_h
IMPLICIT NONE
  ! ======================================================================


  ! Arguments
  ! ----------
  ! Input
  ! ----
  INTEGER,                       INTENT (IN)         :: iflag_wake_tend
  REAL,                          INTENT (IN)         :: dtime
  REAL, DIMENSION(klon, klev),   INTENT (IN)         :: pplay
  REAL, DIMENSION(klon, klev+1), INTENT (IN)         :: paprs
  REAL, DIMENSION(klon, klev),   INTENT (IN)         :: t, q, omgb
  REAL, DIMENSION(klon, klev),   INTENT (IN)         :: dt_dwn, dq_dwn
  REAL, DIMENSION(klon, klev),   INTENT (IN)         :: m_up, m_dwn
  REAL, DIMENSION(klon, klev),   INTENT (IN)         :: dt_a, dq_a
  REAL, DIMENSION(klon),         INTENT (IN)         :: wgen
  REAL, DIMENSION(klon),         INTENT (IN)         :: sigd
  REAL, DIMENSION(klon),         INTENT (IN)         :: Cin
#ifdef ISO
  REAL, DIMENSION(ntraciso,klon, klev), INTENT (IN)  :: xt,dxt_dwn,dxt_a
#endif
  ! Input/Output
  ! ------------
  REAL, DIMENSION(klon, klev),   INTENT (INOUT)      :: wake_deltat, wake_deltaq
  REAL, DIMENSION(klon),         INTENT (INOUT)      :: wake_s, awake_s
  REAL, DIMENSION(klon),         INTENT (INOUT)      :: wake_dens, awake_dens
#ifdef ISO
  REAL, DIMENSION(ntraciso,klon, klev), INTENT(INOUT):: wake_deltaxt
#endif
  ! Output
  ! ------
  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: dt_wake, dq_wake
!!jyg  REAL, DIMENSION(klon),         INTENT (OUT)        :: wake_k
  INTEGER, DIMENSION(klon),      INTENT (OUT)        :: wake_k
  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: wake_d_deltat_gw
  REAL, DIMENSION(klon),         INTENT (OUT)        :: wake_h
  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: wake_dth
  REAL, DIMENSION(klon),         INTENT (OUT)        :: wake_pe, wake_fip, wake_gfl
  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: t_x, q_x
  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: wake_omgbdth, wake_dp_omgb
  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: wake_dtke, wake_dqke
  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: wake_omg, wake_dp_deltomg
  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: wake_spread
  REAL, DIMENSION(klon),         INTENT (OUT)        :: wake_cstar
  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: wake_ddeltat, wake_ddeltaq
  REAL, DIMENSION(klon),         INTENT (OUT)        :: wake_ds, awake_ds, wake_ddens, awake_ddens
#ifdef ISO
  REAL, DIMENSION(ntraciso,klon, klev), INTENT (OUT) :: dxt_wake
  REAL, DIMENSION(ntraciso,klon, klev), INTENT (OUT) :: xt_x
  REAL, DIMENSION(ntraciso,klon, klev), INTENT (OUT) :: wake_ddeltaxt
  REAL, DIMENSION(ntraciso,klon, klev)               :: wake_dxtke ! pas besoin de la sortir
#endif


  ! Variable internes
  ! -----------------
  INTEGER                                            :: i, l
  INTEGER, DIMENSION(klon)                           :: znatsurf    ! 0 if pctsrf(is_oce)>0.1; 1 else.
  REAL                                               :: aire
  REAL, DIMENSION(klon, klev)                        :: p,  pi
  REAL, DIMENSION(klon, klev+1)                      ::  ph
  REAL, DIMENSION(klon, klev)                        ::  omgbe
  REAL, DIMENSION(klon, klev)                        :: te, qe
  REAL, DIMENSION(klon, klev)                        :: dtdwn, dqdwn
  REAL, DIMENSION(klon, klev)                        :: dta, dqa
  REAL, DIMENSION(klon, klev)                        :: amdwn, amup
  REAL, DIMENSION(klon, klev)                        :: dtw, dqw, dth
  REAL, DIMENSION(klon, klev)                        :: dtls, dqls
  REAL, DIMENSION(klon, klev)                        :: tx, qx
  REAL, DIMENSION(klon)                              :: hw, wape, fip, gfl
  REAL, DIMENSION(klon)                              :: sigmaw, asigmaw, wdens, awdens
  REAL, DIMENSION(klon, klev)                        :: omgbdth
  REAL, DIMENSION(klon, klev)                        :: dp_omgb
  REAL, DIMENSION(klon, klev)                        :: dtke, dqke
  REAL, DIMENSION(klon, klev)                        :: omg
  REAL, DIMENSION(klon, klev)                        :: dp_deltomg, spread
  REAL, DIMENSION(klon)                              :: cstar
  REAL, DIMENSION(klon)                              :: sigd0
  INTEGER, DIMENSION(klon)                           :: ktopw
  REAL, DIMENSION(klon, klev)                        :: d_deltat_gw
  REAL, DIMENSION(klon, klev)                        :: d_deltatw, d_deltaqw
  REAL, DIMENSION(klon)                              :: d_sigmaw, d_asigmaw, d_wdens, d_awdens
#ifdef ISO
  REAL, DIMENSION(ntraciso,klon, klev)               :: xte
  REAL, DIMENSION(ntraciso,klon, klev)               :: dxtdwn
  REAL, DIMENSION(ntraciso,klon, klev)               :: dxta
  REAL, DIMENSION(ntraciso,klon, klev)               :: dxtw
  REAL, DIMENSION(ntraciso,klon, klev)               :: dxtls
  REAL, DIMENSION(ntraciso,klon, klev)               :: xtx
  REAL, DIMENSION(ntraciso,klon, klev)               :: dxtke
  REAL, DIMENSION(ntraciso,klon, klev)               :: d_deltaxtw
  INTEGER                                            :: ixt
#endif

  REAL                                               :: rdcp

  CHARACTER (LEN=20) :: modname = 'calwake'
  CHARACTER (LEN=80) :: abort_message

  IF (prt_level >= 10) THEN
    print *, '-> calwake, wake_s, awake_s, wgen input ', wake_s(1), awake_s(1), wgen(1)
  ENDIF

  rdcp = 1./3.5

  znatsurf(:) = 0
  DO i = 1,klon
    IF (pctsrf(i,is_oce) < 0.1) znatsurf(i) = 1
  ENDDO


  ! -----------------------------------------------------------
  ! IM 290108     DO 999 i=1,klon   ! a vectoriser
  ! ----------------------------------------------------------


  DO l = 1, klev
    DO i = 1, klon
      p(i, l) = pplay(i, l)
      ph(i, l) = paprs(i, l)
      pi(i, l) = (pplay(i,l)/100000.)**rdcp

      te(i, l) = t(i, l)
      qe(i, l) = q(i, l)
      omgbe(i, l) = omgb(i, l)

      dtdwn(i, l) = dt_dwn(i, l)
      dqdwn(i, l) = dq_dwn(i, l)
      dta(i, l) = dt_a(i, l)
      dqa(i, l) = dq_a(i, l)
#ifdef ISO
      DO ixt=1,ntraciso
        xte(ixt,i, l) = xt(ixt,i, l)
        dxtdwn(ixt,i, l) = dxt_dwn(ixt,i, l)
        dxta(ixt,i, l) = dxt_a(ixt,i, l)
      ENDDO
#endif
    ENDDO
  ENDDO

!----------------------------------------------------------------
!         Initialize tendencies to zero
!----------------------------------------------------------------
dtls(:,:) = 0.
dqls(:,:) = 0.
d_deltat_gw(:,:) = 0.
d_deltatw(:,:) = 0.
d_deltaqw(:,:) = 0.
d_sigmaw(:) = 0.
d_asigmaw(:) = 0.
d_wdens(:) = 0.
d_awdens(:) = 0.
#ifdef ISO
dxtls(:,:,:) = 0.
d_deltaxtw(:,:,:) = 0.
#endif
!

  DO i = 1, klon
    sigd0(i) = sigd(i)
  END DO
  ! print*, 'sigd0,sigd', sigd0, sigd(i)
  DO i = 1, klon
    ph(i, klev+1) = 0.
  END DO

!!jyg!  DO i = 1, klon                  
!!jyg!    ktopw(i) = NINT(wake_k(i))    
!!jyg!  END DO                          

  DO i = 1, klon
    hw(i) = wake_h(i)
  END DO
!
!    Make a copy of state variables
  DO l = 1, klev
    DO i = 1, klon
      dtw(i, l) = wake_deltat(i, l)
      dqw(i, l) = wake_deltaq(i, l)
#ifdef ISO
      dxtw(:,i, l) = wake_deltaxt(:,i, l)
#endif
    END DO
  END DO

  DO i = 1, klon
    sigmaw(i)  = wake_s(i)
    asigmaw(i) = awake_s(i)
  END DO

  DO i = 1, klon
    wdens(i) = max(0., wake_dens(i))
    awdens(i) = max(0., awake_dens(i))
  END DO

  ! fkc les flux de masses sont evalues aux niveaux et valent 0 a la surface
  ! fkc  on veut le flux de masse au milieu des couches

  DO l = 1, klev - 1
    DO i = 1, klon
      amdwn(i, l) = 0.5*(m_dwn(i,l)+m_dwn(i,l+1))
      amdwn(i, l) = (m_dwn(i,l+1))
    END DO
  END DO

  ! au sommet le flux de masse est nul

  DO i = 1, klon
    amdwn(i, klev) = 0.5*m_dwn(i, klev)
  END DO

  DO l = 1, klev
    DO i = 1, klon
      amup(i, l) = m_up(i, l)
    END DO
  END DO

#ifdef ISOVERIF
  ! verif des inputs des wakes
  WRITE(*,*) 'calwake 257: verif des inputs des wakes'
  DO l = 1, klev
    DO i = 1, klon
      IF (iso_eau.GT.0) THEN
        CALL iso_verif_egalite(qe(i,l),xte(iso_eau,i,l),'calwake 261a')
        CALL iso_verif_egalite(dqa(i,l),dxta(iso_eau,i,l),'calwake 261b')
        CALL iso_verif_egalite(dqdwn(i,l),dxtdwn(iso_eau,i,l),'calwake 261c')
        CALL iso_verif_egalite(dqw(i,l),dxtw(iso_eau,i,l),'calwake 261d')
      ENDIF
    ENDDO
  ENDDO
#endif

  IF (iflag_wake/10 == 0) THEN
    CALL wake(klon,klev,znatsurf, p, ph, pi, dtime, &
      te, qe, omgbe, &
      dtdwn, dqdwn, amdwn, amup, dta, dqa, wgen, &
      sigd0, Cin, &
      dtw, dqw, sigmaw, asigmaw, wdens, awdens, &                      ! state variables
      dth, hw, wape, fip, gfl, &
      dtls, dqls, ktopw, omgbdth, dp_omgb, tx, qx, &
      dtke, dqke, omg, dp_deltomg, spread, cstar, &
      d_deltat_gw, &
      d_deltatw, d_deltaqw, d_sigmaw, d_asigmaw, d_wdens, d_awdens &   ! tendencies
#ifdef ISO
      ,xte,dxtdwn,dxta,dxtw &
      ,dxtls,xtx,dxtke,d_deltaxtw &
#endif
      )
#ifdef ISOVERIF
  ! verif des ouputs des wakes
  WRITE(*,*) 'calwake 286: verif des outputs des wakes'
  DO l = 1, klev
    DO i = 1, klon
      IF (iso_eau.GT.0) THEN
        CALL iso_verif_egalite(dqls(i,l),dxtls(iso_eau,i,l),'calwake 290a')
        CALL iso_verif_egalite(qx(i,l),xtx(iso_eau,i,l),'calwake 290b')
        CALL iso_verif_egalite(dqke(i,l),dxtke(iso_eau,i,l),'calwake 290c')
        CALL iso_verif_egalite(d_deltaqw(i,l),d_deltaxtw(iso_eau,i,l),'calwake 290d')
        CALL iso_verif_egalite(dqw(i,l),dxtw(iso_eau,i,l),'calwake 290e')
      ENDIF
    ENDDO
  ENDDO
#endif

  ELSE IF (iflag_wake/10 == 2) THEN
#ifdef ISO
    abort_message='Water isotopes not implemented in wake2 yet -> ERROR, ABORT in calwake'
    CALL abort_physic(modname,abort_message, 1)
#endif
    CALL wake2(klon,klev,znatsurf, p, ph, pi, dtime, &
      te, qe, omgbe, &
      dtdwn, dqdwn, amdwn, amup, dta, dqa, wgen, &
      sigd0, Cin, &
      dtw, dqw, sigmaw, asigmaw, wdens, awdens, &                      ! state variables
      dth, hw, wape, fip, gfl, &
      dtls, dqls, ktopw, omgbdth, dp_omgb, tx, qx, &
      dtke, dqke, omg, dp_deltomg, spread, cstar, &
      d_deltat_gw, &
      d_deltatw, d_deltaqw, d_sigmaw, d_asigmaw, d_wdens, d_awdens)    ! tendencies

  ELSE IF (iflag_wake/10 == 3) THEN
#ifdef ISO
    abort_message='Water isotopes not implemented in wake3 yet -> ERROR, ABORT in calwake'
    CALL abort_physic(modname,abort_message, 1)
#endif
    CALL wake3(klon,klev,znatsurf, p, ph, pi, dtime, &
      te, qe, omgbe, &
      dtdwn, dqdwn, amdwn, amup, dta, dqa, wgen, &
      sigd0, Cin, &
      dtw, dqw, sigmaw, asigmaw, wdens, awdens, &                      ! state variables
      dth, hw, wape, fip, gfl, &
      dtls, dqls, ktopw, omgbdth, dp_omgb, tx, qx, &
      dtke, dqke, omg, dp_deltomg, spread, cstar, &
      d_deltat_gw, &
      d_deltatw, d_deltaqw, d_sigmaw, d_asigmaw, d_wdens, d_awdens)      ! tendencies

  END IF  !(iflag_wake/10 == 0)

  DO l = 1, klev
    DO i = 1, klon
      IF (ktopw(i)>0) THEN
        wake_d_deltat_gw(i, l) = d_deltat_gw(i, l)
        wake_omgbdth(i, l) = omgbdth(i, l)
        wake_dp_omgb(i, l) = dp_omgb(i, l)
        wake_dtke(i, l) = dtke(i, l)
        wake_dqke(i, l) = dqke(i, l)
        wake_omg(i, l) = omg(i, l)
        wake_dp_deltomg(i, l) = dp_deltomg(i, l)
        wake_spread(i, l) = spread(i, l)
        wake_dth(i, l) = dth(i, l)
        dt_wake(i, l) = dtls(i, l)*dtime         ! derivative -> tendency
        dq_wake(i, l) = dqls(i, l)*dtime         ! derivative -> tendency
        t_x(i, l) = tx(i, l)
        q_x(i, l) = qx(i, l)
#ifdef ISO
        DO ixt=1,ntraciso
          wake_dxtke(ixt,i, l) = dxtke(ixt,i, l)
          dxt_wake(ixt,i, l) = dxtls(ixt,i, l)*dtime
          xt_x(ixt,i, l) = xtx(ixt,i, l)
        ENDDO
#endif
      ELSE
        wake_d_deltat_gw(i, l) = 0.
        wake_omgbdth(i, l) = 0.
        wake_dp_omgb(i, l) = 0.
        wake_dtke(i, l) = 0.
        wake_dqke(i, l) = 0.
        wake_omg(i, l) = 0.
        wake_dp_deltomg(i, l) = 0.
        wake_spread(i, l) = 0.
        wake_dth(i, l) = 0.
        dt_wake(i, l) = 0.
        dq_wake(i, l) = 0.
        t_x(i, l) = te(i, l)
        q_x(i, l) = qe(i, l)
#ifdef ISO
        DO ixt=1,ntraciso
          wake_dxtke(ixt,i, l) = 0.
          dxt_wake(ixt,i, l) = 0.
          xt_x(ixt,i, l) = xte(ixt,i, l)
        ENDDO
#endif
      ENDIF
    ENDDO
  ENDDO

  DO i = 1, klon
    wake_h(i) = hw(i)
    wake_pe(i) = wape(i)
    wake_fip(i) = fip(i)
    wake_gfl(i) = gfl(i)
    wake_k(i) = ktopw(i)
    wake_cstar(i) = cstar(i)
  ENDDO

!  Tendencies of state variables
  DO l = 1, klev
    DO i = 1, klon
      IF (ktopw(i)>0) THEN
        wake_ddeltat(i, l) = d_deltatw(i, l)*dtime
        wake_ddeltaq(i, l) = d_deltaqw(i, l)*dtime
#ifdef ISO
        DO ixt=1,ntraciso
          wake_ddeltaxt(ixt,i, l) = d_deltaxtw(ixt,i, l)*dtime
        ENDDO
#endif
      ELSE
        wake_ddeltat(i, l) = -wake_deltat(i, l)
        wake_ddeltaq(i, l) = -wake_deltaq(i, l)
#ifdef ISO
        DO ixt=1,ntraciso
          wake_ddeltaxt(ixt,i, l) = -wake_deltaxt(ixt,i, l)
        ENDDO
#endif
      ENDIF
    ENDDO
  ENDDO
  DO i = 1, klon
    IF (ktopw(i)>0) THEN
      wake_ds(i)    = d_sigmaw(i)*dtime
      awake_ds(i)   = d_asigmaw(i)*dtime
      awake_ddens(i)= d_awdens(i)*dtime
      wake_ddens(i) = d_wdens(i)*dtime
    ELSE
      wake_ds(i)    = -wake_s(i)
      awake_ds(i)   = -awake_s(i)
      wake_ddens(i) = -wake_dens(i)
      awake_ddens(i)= -awake_dens(i)
    END IF
  END DO
!

!jyg<  
  IF (iflag_wake_tend .EQ. 0) THEN
!  Update State variables
    DO l = 1, klev
      DO i = 1, klon
        IF (ktopw(i)>0) THEN
          wake_deltat(i, l) = dtw(i, l)
          wake_deltaq(i, l) = dqw(i, l)
#ifdef ISO
          DO ixt=1,ntraciso
            wake_deltaxt(ixt,i, l) = dxtw(ixt,i, l)
          ENDDO
#endif
        ELSE
          wake_deltat(i, l) = 0.
          wake_deltaq(i, l) = 0.
#ifdef ISO
          DO ixt=1,ntraciso
            wake_deltaxt(ixt,i, l) = 0.
          ENDDO
#endif
        END IF
      END DO
    END DO
    DO i = 1, klon
      wake_s(i) = sigmaw(i)
      awake_s(i) = asigmaw(i)
      awake_dens(i) = awdens(i)
      wake_dens(i) = wdens(i)
    END DO
  ENDIF  ! (iflag_wake_tend .EQ. 0)
!
  DO i = 1,klon
    IF (first(i)) THEN
      IF (wake_dens(i) < -1.) THEN
        wake_dens(i) = wdens(i)
      ENDIF
      first(i)=.FALSE.
    ENDIF  ! (first)
  ENDDO

!>jyg
  IF (prt_level >= 10) THEN
    print *, 'calwake ->, wake_s, awake_s ', wake_s(1), awake_s(1)
  ENDIF

  RETURN
END SUBROUTINE calwake

END MODULE calwake_mod

!***************************************************************************
SUBROUTINE RRTM_CMBGB16
!***************************************************************************

!     BAND 16:  2600-3000 cm-1 (low - H2O,CH4; high - nothing)
!     ABozzo 201306 updated to rrtmg v4.85
!     band 16:  2600-3250 cm-1 (low key- h2o,ch4; high key - ch4)
!***************************************************************************

! Parameters
USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOERRTO16, ONLY : KAO,KBO   ,SELFREFO,FORREFO  ,FRACREFAO,FRACREFBO
USE YOERRTA16, ONLY : KA,KB     ,SELFREF,FORREF    ,FRACREFA,FRACREFB
USE YOERRTRWT, ONLY : RWGT
USE YOERRTFTR, ONLY : NGC      ,NGS      ,NGN      

IMPLICIT NONE

INTEGER(KIND=JPIM) :: IGC, IPR, IPRSM, JN, JP, JT

REAL(KIND=JPRB) :: Z_SUMF, Z_SUMK
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('RRTM_CMBGB16',0,ZHOOK_HANDLE)
DO JN = 1,9
  DO JT = 1,5
    DO JP = 1,13
      IPRSM = 0
      DO IGC = 1,NGC(16)
        Z_SUMK = 0.0_JPRB
        DO IPR = 1, NGN(NGS(15)+IGC)
          IPRSM = IPRSM + 1

          Z_SUMK = Z_SUMK + KAO(JN,JT,JP,IPRSM)*RWGT(IPRSM+240)
        ENDDO

        KA(JN,JT,JP,IGC) = Z_SUMK
      ENDDO
    ENDDO
  ENDDO
ENDDO

DO JT = 1,5
   DO JP = 13,59
      IPRSM = 0
      DO IGC = 1,NGC(16)
         Z_SUMK = 0.0_JPRB
         DO IPR = 1, NGN(NGS(15)+IGC)
            IPRSM = IPRSM + 1
            Z_SUMK = Z_SUMK + KBO(JT,JP,IPRSM)*RWGT(IPRSM+240)
         ENDDO
         KB(JT,JP,IGC) = Z_SUMK
      ENDDO
   ENDDO
ENDDO


DO JT = 1,10
  IPRSM = 0
  DO IGC = 1,NGC(16)
    Z_SUMK = 0.0_JPRB
    DO IPR = 1, NGN(NGS(15)+IGC)
      IPRSM = IPRSM + 1

      Z_SUMK = Z_SUMK + SELFREFO(JT,IPRSM)*RWGT(IPRSM+240)
    ENDDO

    SELFREF(JT,IGC) = Z_SUMK
  ENDDO
ENDDO

DO JT = 1,4
   IPRSM = 0
   DO IGC = 1,NGC(16)
      Z_SUMK = 0.0_JPRB
      DO IPR = 1, NGN(NGS(15)+IGC)
         IPRSM = IPRSM + 1
         Z_SUMK = Z_SUMK + FORREFO(JT,IPRSM)*RWGT(IPRSM+240)
      ENDDO
      FORREF(JT,IGC) = Z_SUMK
   ENDDO
ENDDO

IPRSM = 0
DO IGC = 1,NGC(16)
   Z_SUMF = 0.0_JPRB
   DO IPR = 1, NGN(NGS(15)+IGC)
      IPRSM = IPRSM + 1
      Z_SUMF = Z_SUMF + FRACREFBO(IPRSM)
   ENDDO
   FRACREFB(IGC) = Z_SUMF
ENDDO

DO JP = 1,9
  IPRSM = 0
  DO IGC = 1,NGC(16)
    Z_SUMF = 0.0_JPRB
    DO IPR = 1, NGN(NGS(15)+IGC)
      IPRSM = IPRSM + 1

      Z_SUMF = Z_SUMF + FRACREFAO(IPRSM,JP)
    ENDDO

    FRACREFA(IGC,JP) = Z_SUMF
  ENDDO
ENDDO

 
IF (LHOOK) CALL DR_HOOK('RRTM_CMBGB16',1,ZHOOK_HANDLE)
END SUBROUTINE RRTM_CMBGB16

! $Id: regr1_step_av_m.F90 3065 2017-11-10 13:25:09Z fairhead $
module regr1_step_av_m

  ! Author: Lionel GUEZ

  implicit none

  interface regr1_step_av

     ! Each procedure regrids a step function by averaging it.
     ! The regridding operation is done on the first dimension of the
     ! input array.
     ! Source grid contains edges of steps.
     ! Target grid contains positions of cell edges.
     ! The target grid should be included in the source grid: no
     ! extrapolation is allowed.
     ! The difference between the procedures is the rank of the first argument.

     module procedure regr11_step_av, regr12_step_av, regr13_step_av, &
          regr14_step_av
  end interface

  private
  public regr1_step_av

contains

  function regr11_step_av(vs, xs, xt) result(vt)

    ! "vs" has rank 1.

    use assert_eq_m, only: assert_eq
    use assert_m, only: assert
    use interpolation, only: locate

    real, intent(in):: vs(:) ! values of steps on the source grid
    ! (Step "is" is between "xs(is)" and "xs(is + 1)".)

    real, intent(in):: xs(:)
    ! (edges of of steps on the source grid, in strictly increasing order)

    real, intent(in):: xt(:)
    ! (edges of cells of the target grid, in strictly increasing order)

    real vt(size(xt) - 1) ! average values on the target grid
    ! (Cell "it" is between "xt(it)" and "xt(it + 1)".)

    ! Variables local to the procedure:
    integer is, it, ns, nt
    real left_edge

    !---------------------------------------------

    ns = assert_eq(size(vs), size(xs) - 1, "regr11_step_av ns")
    nt = size(xt) - 1
    ! Quick check on sort order:
    call assert(xs(1) < xs(2), "regr11_step_av xs bad order")
    call assert(xt(1) < xt(2), "regr11_step_av xt bad order")

    call assert(xs(1) <= xt(1) .and. xt(nt + 1) <= xs(ns + 1), &
         "regr11_step_av extrapolation")

    is = locate(xs, xt(1)) ! 1 <= is <= ns, because we forbid extrapolation
    do it = 1, nt
       ! 1 <= is <= ns
       ! xs(is) <= xt(it) < xs(is + 1)
       ! Compute "vt(it)":
       left_edge = xt(it)
       vt(it) = 0.
       do while (xs(is + 1) < xt(it + 1))
          ! 1 <= is <= ns - 1
          vt(it) = vt(it) + (xs(is + 1) - left_edge) * vs(is)
          is = is + 1
          left_edge = xs(is)
       end do
       ! 1 <= is <= ns
       vt(it) = (vt(it) + (xt(it + 1) - left_edge) * vs(is)) &
            / (xt(it + 1) - xt(it))
       if (xs(is + 1) == xt(it + 1)) is = is + 1
       ! 1 <= is <= ns .or. it == nt
    end do

  end function regr11_step_av

  !********************************************

  function regr12_step_av(vs, xs, xt) result(vt)

    ! "vs" has rank 2.

    use assert_eq_m, only: assert_eq
    use assert_m, only: assert
    use interpolation, only: locate

    real, intent(in):: vs(:, :) ! values of steps on the source grid
    ! (Step "is" is between "xs(is)" and "xs(is + 1)".)

    real, intent(in):: xs(:)
    ! (edges of steps on the source grid, in strictly increasing order)

    real, intent(in):: xt(:)
    ! (edges of cells of the target grid, in strictly increasing order)

    real vt(size(xt) - 1, size(vs, 2)) ! average values on the target grid
    ! (Cell "it" is between "xt(it)" and "xt(it + 1)".)

    ! Variables local to the procedure:
    integer is, it, ns, nt
    real left_edge

    !---------------------------------------------

    ns = assert_eq(size(vs, 1), size(xs) - 1, "regr12_step_av ns")
    nt = size(xt) - 1

    ! Quick check on sort order:
    call assert(xs(1) < xs(2), "regr12_step_av xs bad order")
    call assert(xt(1) < xt(2), "regr12_step_av xt bad order")

    call assert(xs(1) <= xt(1) .and. xt(nt + 1) <= xs(ns + 1), &
         "regr12_step_av extrapolation")

    is = locate(xs, xt(1)) ! 1 <= is <= ns, because we forbid extrapolation
    do it = 1, nt
       ! 1 <= is <= ns
       ! xs(is) <= xt(it) < xs(is + 1)
       ! Compute "vt(it, :)":
       left_edge = xt(it)
       vt(it, :) = 0.
       do while (xs(is + 1) < xt(it + 1))
          ! 1 <= is <= ns - 1
          vt(it, :) = vt(it, :) + (xs(is + 1) - left_edge) * vs(is, :)
          is = is + 1
          left_edge = xs(is)
       end do
       ! 1 <= is <= ns
       vt(it, :) = (vt(it, :) + (xt(it + 1) - left_edge) * vs(is, :)) &
            / (xt(it + 1) - xt(it))
       if (xs(is + 1) == xt(it + 1)) is = is + 1
       ! 1 <= is <= ns .or. it == nt
    end do

  end function regr12_step_av

  !********************************************

  function regr13_step_av(vs, xs, xt) result(vt)

    ! "vs" has rank 3.

    use assert_eq_m, only: assert_eq
    use assert_m, only: assert
    use interpolation, only: locate

    real, intent(in):: vs(:, :, :) ! values of steps on the source grid
    ! (Step "is" is between "xs(is)" and "xs(is + 1)".)

    real, intent(in):: xs(:)
    ! (edges of steps on the source grid, in strictly increasing order)

    real, intent(in):: xt(:)
    ! (edges of cells of the target grid, in strictly increasing order)

    real vt(size(xt) - 1, size(vs, 2), size(vs, 3)) 
    ! (average values on the target grid)
    ! (Cell "it" is between "xt(it)" and "xt(it + 1)".)

    ! Variables local to the procedure:
    integer is, it, ns, nt
    real left_edge

    !---------------------------------------------

    ns = assert_eq(size(vs, 1), size(xs) - 1, "regr13_step_av ns")
    nt = size(xt) - 1

    ! Quick check on sort order:
    call assert(xs(1) < xs(2), "regr13_step_av xs bad order")
    call assert(xt(1) < xt(2), "regr13_step_av xt bad order")

    call assert(xs(1) <= xt(1) .and. xt(nt + 1) <= xs(ns + 1), &
         "regr13_step_av extrapolation")

    is = locate(xs, xt(1)) ! 1 <= is <= ns, because we forbid extrapolation
    do it = 1, nt
       ! 1 <= is <= ns
       ! xs(is) <= xt(it) < xs(is + 1)
       ! Compute "vt(it, :, :)":
       left_edge = xt(it)
       vt(it, :, :) = 0.
       do while (xs(is + 1) < xt(it + 1))
          ! 1 <= is <= ns - 1
          vt(it, :, :) = vt(it, :, :) + (xs(is + 1) - left_edge) * vs(is, :, :)
          is = is + 1
          left_edge = xs(is)
       end do
       ! 1 <= is <= ns
       vt(it, :, :) = (vt(it, :, :) &
            + (xt(it + 1) - left_edge) * vs(is, :, :)) / (xt(it + 1) - xt(it))
       if (xs(is + 1) == xt(it + 1)) is = is + 1
       ! 1 <= is <= ns .or. it == nt
    end do

  end function regr13_step_av

  !********************************************

  function regr14_step_av(vs, xs, xt) result(vt)

    ! "vs" has rank 4.

    use assert_eq_m, only: assert_eq
    use assert_m, only: assert
    use interpolation, only: locate

    real, intent(in):: vs(:, :, :, :) ! values of steps on the source grid
    ! (Step "is" is between "xs(is)" and "xs(is + 1)".)

    real, intent(in):: xs(:)
    ! (edges of steps on the source grid, in strictly increasing order)

    real, intent(in):: xt(:)
    ! (edges of cells of the target grid, in strictly increasing order)

    real vt(size(xt) - 1, size(vs, 2), size(vs, 3), size(vs, 4))
    ! (average values on the target grid)
    ! (Cell "it" is between "xt(it)" and "xt(it + 1)".)

    ! Variables local to the procedure:
    integer is, it, ns, nt
    real left_edge

    !---------------------------------------------

    ns = assert_eq(size(vs, 1), size(xs) - 1, "regr14_step_av ns")
    nt = size(xt) - 1

    ! Quick check on sort order:
    call assert(xs(1) < xs(2), "regr14_step_av xs bad order")
    call assert(xt(1) < xt(2), "regr14_step_av xt bad order")

    call assert(xs(1) <= xt(1) .and. xt(nt + 1) <= xs(ns + 1), &
         "regr14_step_av extrapolation")

    is = locate(xs, xt(1)) ! 1 <= is <= ns, because we forbid extrapolation
    do it = 1, nt
       ! 1 <= is <= ns
       ! xs(is) <= xt(it) < xs(is + 1)
       ! Compute "vt(it, :, :, :)":
       left_edge = xt(it)
       vt(it, :, :, :) = 0.
       do while (xs(is + 1) < xt(it + 1))
          ! 1 <= is <= ns - 1
          vt(it, :, :, :) = vt(it, :, :, :) + (xs(is + 1) - left_edge) &
               * vs(is, :, :, :)
          is = is + 1
          left_edge = xs(is)
       end do
       ! 1 <= is <= ns
       vt(it, :, :, :) = (vt(it, :, :, :) + (xt(it + 1) - left_edge) &
            * vs(is, :, :, :)) / (xt(it + 1) - xt(it))
       if (xs(is + 1) == xt(it + 1)) is = is + 1
       ! 1 <= is <= ns .or. it == nt
    end do

  end function regr14_step_av

end module regr1_step_av_m

MODULE create_etat0_unstruct_mod

  REAL, SAVE, ALLOCATABLE :: zmea_gw(:)
  !$OMP THREADPRIVATE(zmea_gw)
  REAL, SAVE, ALLOCATABLE :: zpic_gw(:)
  !$OMP THREADPRIVATE(zpic_gw)
  REAL, SAVE, ALLOCATABLE :: zval_gw(:)
  !$OMP THREADPRIVATE(zval_gw)
  REAL, SAVE, ALLOCATABLE :: zstd_gw(:)
  !$OMP THREADPRIVATE(zstd_gw)
  REAL, SAVE, ALLOCATABLE :: zsig_gw(:)
  !$OMP THREADPRIVATE(zsig_gw)
  REAL, SAVE, ALLOCATABLE :: zgam_gw(:)
  !$OMP THREADPRIVATE(zgam_gw)
  REAL, SAVE, ALLOCATABLE :: zthe_gw(:)
  !$OMP THREADPRIVATE(zthe_gw)

  PRIVATE zmea_gw, zpic_gw, zval_gw, zstd_gw, zsig_gw, zgam_gw, zthe_gw


CONTAINS
  
  SUBROUTINE init_create_etat0_unstruct
  USE lmdz_xios
  USE netcdf
  USE mod_phys_lmdz_para
  IMPLICIT NONE
  INTEGER :: file_id, iret

   ! for coupling activate ocean fraction reading from file "ocean_fraction.nc"
    IF (is_omp_master) THEN

      IF (NF90_OPEN("ocean_fraction.nc", NF90_NOWRITE, file_id)==NF90_NOERR) THEN
        CALL xios_set_file_attr("relief",enabled=.FALSE.)
        CALL xios_set_file_attr("frac_ocean",enabled=.TRUE.)
        CALL xios_set_field_attr("mask",field_ref="frac_ocean_read")
        iret=NF90_CLOSE(file_id)
      ELSE IF (NF90_OPEN("land_water_0.05.nc", NF90_NOWRITE, file_id)==NF90_NOERR) THEN
        CALL xios_set_file_attr("relief",enabled=.FALSE.)
        CALL xios_set_file_attr("land_water",name="land_water_0.05",enabled=.TRUE.)
        CALL xios_set_field_attr("mask",field_ref="land_water")
        iret=NF90_CLOSE(file_id)
      ELSE IF (NF90_OPEN("land_water_0.25.nc", NF90_NOWRITE, file_id)==NF90_NOERR) THEN
        CALL xios_set_file_attr("relief",enabled=.FALSE.)
        CALL xios_set_file_attr("land_water",name="land_water_0.25",enabled=.TRUE.)
        CALL xios_set_field_attr("mask",field_ref="land_water")
        iret=NF90_CLOSE(file_id)
      ELSE IF (NF90_OPEN("land_water_0.50.nc", NF90_NOWRITE, file_id)==NF90_NOERR) THEN
        CALL xios_set_file_attr("relief",enabled=.FALSE.)
        CALL xios_set_file_attr("land_water",name="land_water_0.50",enabled=.TRUE.)
        CALL xios_set_field_attr("mask",field_ref="land_water")
        iret=NF90_CLOSE(file_id)
      ENDIF

    ENDIF

  END SUBROUTINE init_create_etat0_unstruct


  SUBROUTINE init_param_gw(zmea, zpic, zval, zstd, zsig, zgam, zthe)
  USE dimphy
    REAL, INTENT(IN) :: zmea(klon)
    REAL, INTENT(IN) :: zpic(klon)
    REAL, INTENT(IN) :: zval(klon)
    REAL, INTENT(IN) :: zstd(klon)
    REAL, INTENT(IN) :: zsig(klon)
    REAL, INTENT(IN) :: zgam(klon)
    REAL, INTENT(IN) :: zthe(klon)

    ALLOCATE(zmea_gw(klon), zpic_gw(klon), zval_gw(klon), zstd_gw(klon), zsig_gw(klon), zgam_gw(klon), zthe_gw(klon))

    zmea_gw(:)=zmea(:)
    zpic_gw(:)=zpic(:)
    zval_gw(:)=zval(:)
    zstd_gw(:)=zstd(:)
    zsig_gw(:)=zsig(:)
    zgam_gw(:)=zgam(:)
    zthe_gw(:)=zthe(:)

  END SUBROUTINE init_param_gw




  SUBROUTINE create_etat0_unstruct
  USE dimphy
  USE lmdz_xios
  USE infotrac_phy
  USE simplehydrol_mod
  USE pbl_surface_mod
  USE phys_state_var_mod
  USE indice_sol_mod
  USE surface_data,      ONLY: landice_opt
  USE mod_phys_lmdz_para
  USE print_control_mod, ONLY: lunout
  USE geometry_mod
  USE ioipsl_getin_p_mod, ONLY: getin_p
  USE dimsoil_mod_h, ONLY: nsoilmx
  USE clesphys_mod_h
  USE conf_phys_m, only: iflag_wake
  USE compbl_mod_h
  IMPLICIT NONE

    LOGICAL :: no_ter_antartique   ! If true, no land points are allowed at Antartic
    REAL,    DIMENSION(klon)                 :: tsol
    REAL,    DIMENSION(klon)                 :: sn
    REAL,    DIMENSION(klon)                 :: rugmer
    REAL,    DIMENSION(klon)                 :: run_off_lic_0
    REAL,    DIMENSION(klon)                 :: lic
    REAL,    DIMENSION(klon)                 :: fder

    REAL,    DIMENSION(klon,nbsrf)           :: qsurf, snsrf
    REAL,    DIMENSION(klon,nsoilmx,nbsrf)   :: tsoil
    
    REAL,    DIMENSION(klon_mpi)             :: tsol_mpi, qsol_mpi, zmasq_mpi, lic_mpi
    REAL,    DIMENSION(klon_mpi)             :: zmea_mpi, zstd_mpi, zsig_mpi, zgam_mpi, zthe_mpi
    REAL,    DIMENSION(klon_mpi)             :: cell_area_mpi
    REAL,    DIMENSION(klon_mpi,nbsrf)       :: pctsrf_mpi

    INTEGER :: ji,j,i
 

!--- Initial atmospheric CO2 conc. from .def file
    co2_ppm0 = co2_ppm

    IF (is_omp_master) THEN
      CALL xios_recv_field("ts",tsol_mpi)
      CALL xios_recv_field("qs",qsol_mpi)
      CALL xios_recv_field("mask",zmasq_mpi)
      IF (landice_opt .LT. 2) CALL xios_recv_field("landice",lic_mpi)
    ENDIF
    CALL scatter_omp(tsol_mpi,tsol)
    CALL scatter_omp(qsol_mpi,qsol)
    CALL scatter_omp(zmasq_mpi,zmasq)
    IF (landice_opt .LT. 2) CALL scatter_omp(lic_mpi,lic)

    radsol(:)   = 0.0
    rugmer(:) = 0.001
    sn(:)     = 0

    WHERE(qsol(:)<0) qsol(:)=0 
        
    WHERE(   zmasq(:)<EPSFRA) zmasq(:)=0.
    WHERE(1.-zmasq(:)<EPSFRA) zmasq(:)=1.

    pctsrf(:,:) = 0
    IF (landice_opt .LT. 2) THEN
       pctsrf(:,is_lic)=lic
       WHERE(pctsrf(:,is_lic)<EPSFRA) pctsrf(:,is_lic)=0.
       WHERE(zmasq(:)<EPSFRA)         pctsrf(:,is_lic)=0.

       pctsrf(:,is_ter)=zmasq(:)
       
       !--- Adequation with soil/sea mask
       DO ji=1,klon
          IF(zmasq(ji)>EPSFRA) THEN 
             IF(pctsrf(ji,is_lic)>=zmasq(ji)) THEN
                pctsrf(ji,is_lic)=zmasq(ji)
                pctsrf(ji,is_ter)=0.
             ELSE
                pctsrf(ji,is_ter)=zmasq(ji)-pctsrf(ji,is_lic)
                IF(pctsrf(ji,is_ter)<EPSFRA) THEN
                   pctsrf(ji,is_ter)=0.
                   pctsrf(ji,is_lic)=zmasq(ji)
                END IF
             END IF
          END IF
       END DO
   
    ELSE
       ! landice_opt=>2 : no land ice
       pctsrf(:,is_lic)=0.0
       pctsrf(:,is_ter)=zmasq(:)
    END IF





  !--- Option no_ter_antartique removes all land fractions souther than 60S.
  !--- Land ice is set instead of the land fractions on these latitudes.
  !--- The ocean and sea-ice fractions are not changed.
  !--- This option is only available if landice_opt<2.   
  IF (landice_opt .LT. 2) THEN
     no_ter_antartique=.FALSE.
     CALL getin_p('no_ter_antartique',no_ter_antartique)
     WRITE(lunout,*)"no_ter_antartique=",no_ter_antartique
     IF (no_ter_antartique) THEN
        ! Remove all land fractions souther than 60S and set land-ice instead
        WRITE(lunout,*) "Remove land fractions souther than 60deg south by increasing"
        WRITE(lunout,*) "the continental ice fractions. No land can now be found at Antartic."
        DO ji=1, klon
           IF (latitude_deg(ji)<-60.0) THEN
              pctsrf(ji,is_lic) = pctsrf(ji,is_lic) + pctsrf(ji,is_ter)
              pctsrf(ji,is_ter) = 0
           END IF
        END DO
     END IF
  END IF
    
! sub-surface ocean and sea ice (sea ice set to zero for start)
!*******************************************************************************
    pctsrf(:,is_oce)=(1.-zmasq(:))
    WHERE(pctsrf(:,is_oce)<EPSFRA) pctsrf(:,is_oce)=0.
    
!    zval(:)=max(0.,zmea-2*zstd(:))
!    zpic(:)=zmea+2*zstd(:)
    
!! WARNING    DON'T FORGET FOR LATER
!!ym  IF(couple) pctsrf(:,is_oce)=ocemask_fi(:)
!! 
    
! Init: tsol, qsol, sn, evap, tsoil, rain_fall, snow_fall, solsw, sollw, frugs
!*******************************************************************************
    DO i=1,nbsrf
     ftsol(:,i) = tsol
    END DO
  
    DO i=1,nbsrf
     snsrf(:,i) = sn
    END DO
!albedo SB >>>
!ym error : the sub surface dimension is the third not second
!    falb_dir(:,is_ter,:)=0.08; falb_dir(:,is_lic,:)=0.6
!    falb_dir(:,is_oce,:)=0.5;  falb_dir(:,is_sic,:)=0.6
    falb_dir(:,:,is_ter)=0.08; falb_dir(:,:,is_lic)=0.6
    falb_dir(:,:,is_oce)=0.5;  falb_dir(:,:,is_sic)=0.6

!ym falb_dif has been forgotten, initialize with defaukt value found in phyetat0 or 0 ?
!ym probably the uninitialized value was 0 for standard (regular grid) case
    falb_dif(:,:,:)=0
    u10m(:,:)=0  
    v10m(:,:)=0  
    treedrg(:,:,:)=0
!albedo SB <<<
    fevap(:,:) = 0.
    qsurf = 0.
    
    DO i=1,nbsrf 
      DO j=1,nsoilmx
        tsoil(:,j,i) = tsol
      END DO
    END DO
 
    rain_fall = 0.; snow_fall = 0.
    solsw = 165.;   sollw = -53.
    solswfdiff = 1. 
!ym warning missing init for sollwdown => set to 0
  sollwdown  = 0.
    
    
    t_ancien = 273.15
    u_ancien=0
    v_ancien=0
    q_ancien = 0.
    ql_ancien = 0.
    qs_ancien = 0.
    prlw_ancien = 0.
    prsw_ancien = 0.
    prw_ancien = 0.
    agesno = 0.
    
    ! LSCP condensation and ice supersaturation
    cf_ancien = 0.
    rvc_ancien = 0.
    ! TKE when advected
    tke_ancien = 0.

    wake_delta_pbl_TKE(:,:,:)=0
    wake_dens(:)=0
    awake_dens = 0.
    cv_gen = 0.
    ale_bl = 0.
    ale_bl_trig =0.
    alp_bl=0.
    ale_wake=0.
    ale_bl_stat=0.
    
    z0m(:,:)=0 ! ym missing 5th subsurface initialization
    z0m(:,is_oce) = rugmer(:)
    z0m(:,is_ter) = 0.01 ! MAX(1.0e-05,zstd(:)*zsig(:)/2.0)
    z0m(:,is_lic) = 0.001 !MAX(1.0e-05,zstd(:)*zsig(:)/2.0)
    z0m(:,is_sic) = 0.001
    z0h(:,:)=z0m(:,:)

    fder = 0.0
    clwcon = 0.0
    rnebcon = 0.0
    ratqs = 0.0
    run_off_lic_0 = 0.0 
    rugoro = 0.0

! Before phyredem calling, surface modules and values to be saved in startphy.nc
! are initialized
!*******************************************************************************
    pbl_tke(:,:,:) = 1.e-8 
    zmax0(:) = 40.
    f0(:) = 1.e-5
    sig1(:,:) = 0.
    w01(:,:) = 0.
    wake_deltat(:,:) = 0.
    wake_deltaq(:,:) = 0.
    wake_s(:) = 0.
    wake_cstar(:) = 0.
    wake_fip(:) = 0.
    wake_pe = 0.
    fm_therm = 0.
    entr_therm = 0.
    detr_therm = 0.
    awake_s = 0.

    CALL simplehydrol_init(run_off_lic_0)
    !GG
    ! CALL pbl_surface_init( fder, snsrf, qsolsrf, tsoil )
    CALL pbl_surface_init( fder, snsrf, qsurf, tsoil, hice, tice, bilg_cumul )
    !GG


    IF (iflag_pbl>1 .AND. iflag_wake>=1  .AND. iflag_pbl_split >=1) then
     delta_tsurf = 0.
     beta_aridity = 0.
    END IF
    ratqs_inter_ = 0.002

    CALL gather_omp(cell_area,cell_area_mpi)
    CALL gather_omp(pctsrf,pctsrf_mpi)
    IF (is_omp_master) THEN
      CALL xios_send_field("area_ce0l",cell_area_mpi)
      CALL xios_send_field("fract_oce_ce0l",pctsrf_mpi(:,is_oce))
      CALL xios_send_field("fract_sic_ce0l",pctsrf_mpi(:,is_sic))
    ENDIF
    
    zmea(:) = zmea_gw(:)
    zpic(:) = zpic_gw(:)
    zval(:) = zval_gw(:)
    zstd(:) = zstd_gw(:)
    zsig(:) = zsig_gw(:)
    zgam(:) = zgam_gw(:)
    zthe(:) = zthe_gw(:)
    DEALLOCATE(zmea_gw, zpic_gw, zval_gw, zstd_gw, zsig_gw, zgam_gw, zthe_gw)

    CALL phyredem( "startphy.nc" )

  END SUBROUTINE create_etat0_unstruct


END MODULE create_etat0_unstruct_mod

! This file has been modified for the use in ICON

!***************************************************************************
SUBROUTINE RRTM_CMBGB4
!***************************************************************************

!     BAND 4:  630-700 cm-1 (low - H2O,CO2; high - O3,CO2)
!     ABozzo 201306 updated to rrtmg v4.85
!***************************************************************************

! Parameters
USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK, JPHOOK

USE YOERRTO4 , ONLY : KAO     ,KBO     ,SELFREFO   , FORREFO, FRACREFAO  ,FRACREFBO
USE YOERRTA4 , ONLY : KA      ,KB      ,SELFREF    , FORREF, FRACREFA   ,FRACREFB
USE YOERRTRWT, ONLY : RWGT
USE YOERRTFTR, ONLY : NGC      ,NGS      ,NGN      

IMPLICIT NONE

INTEGER(KIND=JPIM) :: IGC, IPR, IPRSM, JN, JP, JT

REAL(KIND=JPRB) :: Z_SUMF, Z_SUMK
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('RRTM_CMBGB4',0,ZHOOK_HANDLE)
DO JN = 1,9
  DO JT = 1,5
    DO JP = 1,13
      IPRSM = 0
      DO IGC = 1,NGC(4)
        Z_SUMK = 0.0_JPRB
        DO IPR = 1, NGN(NGS(3)+IGC)
          IPRSM = IPRSM + 1

          Z_SUMK = Z_SUMK + KAO(JN,JT,JP,IPRSM)*RWGT(IPRSM+48)
        ENDDO

        KA(JN,JT,JP,IGC) = Z_SUMK
      ENDDO
    ENDDO
  ENDDO
ENDDO
DO JN = 1,5
  DO JT = 1,5
    DO JP = 13,59
      IPRSM = 0
      DO IGC = 1,NGC(4)
        Z_SUMK = 0.0_JPRB
        DO IPR = 1, NGN(NGS(3)+IGC)
          IPRSM = IPRSM + 1

          Z_SUMK = Z_SUMK + KBO(JN,JT,JP,IPRSM)*RWGT(IPRSM+48)
        ENDDO

        KB(JN,JT,JP,IGC) = Z_SUMK
      ENDDO
    ENDDO
  ENDDO
ENDDO

DO JT = 1,10
  IPRSM = 0
  DO IGC = 1,NGC(4)
    Z_SUMK = 0.0_JPRB
    DO IPR = 1, NGN(NGS(3)+IGC)
      IPRSM = IPRSM + 1

      Z_SUMK = Z_SUMK + SELFREFO(JT,IPRSM)*RWGT(IPRSM+48)
    ENDDO

    SELFREF(JT,IGC) = Z_SUMK
  ENDDO
ENDDO

DO JT = 1,4
   IPRSM = 0
   DO IGC = 1,NGC(4)
     Z_SUMK = 0.0_JPRB
     DO IPR = 1, NGN(NGS(3)+IGC)
       IPRSM = IPRSM + 1
       Z_SUMK = Z_SUMK + FORREFO(JT,IPRSM)*RWGT(IPRSM+48)
     ENDDO
     FORREF(JT,IGC) = Z_SUMK
   ENDDO
ENDDO

DO JP = 1,9
  IPRSM = 0
  DO IGC = 1,NGC(4)
    Z_SUMF = 0.0_JPRB
    DO IPR = 1, NGN(NGS(3)+IGC)
      IPRSM = IPRSM + 1

      Z_SUMF = Z_SUMF + FRACREFAO(IPRSM,JP)
    ENDDO

    FRACREFA(IGC,JP) = Z_SUMF
  ENDDO
ENDDO

DO JP = 1,5
  IPRSM = 0
  DO IGC = 1,NGC(4)
    Z_SUMF = 0.0_JPRB
    DO IPR = 1, NGN(NGS(3)+IGC)
      IPRSM = IPRSM + 1

      Z_SUMF = Z_SUMF + FRACREFBO(IPRSM,JP)
    ENDDO

    FRACREFB(IGC,JP) = Z_SUMF
  ENDDO
ENDDO


!$ACC UPDATE DEVICE(FRACREFA, FRACREFB, KA, KB, SELFREF, FORREF)

IF (LHOOK) CALL DR_HOOK('RRTM_CMBGB4',1,ZHOOK_HANDLE)
END SUBROUTINE RRTM_CMBGB4

!
! $Id: radlwsw_m.F90 6127 2026-03-26 13:59:25Z idelkadi $
!
MODULE lmdz_radiation_post
  IMPLICIT NONE
CONTAINS

  SUBROUTINE radiation_post( &
                           iof,PWV, &
                           ZFSUP,ZFSDN,ZFSUP0,ZFSDN0, &
                           ZFSUPC0,ZFSDNC0,ZFLUP,ZFLDN, &
                           ZFLUP0,ZFLDN0,ZFLUPC0,ZFLDNC0, &
                           zheat,zcool,zheat0,zcool0,zheat_volc,zcool_volc, &
                           ztopsw,ztoplw,zsolsw,zsollw,zalbpla,zsolswfdiff, &
                           zsollwdown,ztopsw0,ztoplw0,zsolsw0,zsollw0, &
                           ztopswadaero,zsolswadaero,ztopswad0aero,zsolswad0aero, &
                           ztopswaiaero,zsolswaiaero,ztoplwadaero,zsollwadaero, &
                           ztoplwad0aero,zsollwad0aero,ztoplwaiaero,zsollwaiaero, &
                           ztopsw_aero,ztopsw0_aero,zsolsw_aero,zsolsw0_aero, &
                           ztopswcf_aero,zsolswcf_aero, &
                           heat,heat0,cool,cool0,albpla,heat_volc, cool_volc,&
                           topsw,toplw,solsw,solswfdiff,sollw,sollwdown,&
                           topsw0,toplw0,solsw0,sollw0,&
                           lwdnc0,lwdn0,lwdn,lwupc0,lwup0,lwup,&
                           swdnc0,swdn0,swdn,swupc0,swup0,swup,&
                           topswad_aero,solswad_aero,topswai_aero,solswai_aero, &
                           topswad0_aero,solswad0_aero,topsw_aero,topsw0_aero,&
                           solsw_aero,solsw0_aero,topswcf_aero,solswcf_aero,&
                           toplwad_aero,sollwad_aero,toplwai_aero,sollwai_aero, &
                           toplwad0_aero,sollwad0_aero, &
                           cloud_cover_sw,ZFLUX_DIR,ZFLUX_DIR_CLEAR,ZFLUX_DIR_INTO_SUN)

    !==================================================================================================
    ! A. Idelkadi, mars 2026 : 
    !                          Recriture de l interface radlwsw_m.F90 entre LMDZ
    !                              et les codes radiatifs oldrad/rrtm/ecrad
    ! 
    !  lmdz_rad_out_m.F90 : calcul des flux radiatif pour les sorties LMDZ (commun aux 3 codes rad)
    ! --------------------------------------------------------------------------------------------------

    ! Modules necessaires
    USE DIMPHY
    USE yoethf_mod_h
    USE aero_mod
    USE conf_phys_m, ONLY: ok_ade, ok_aie, ok_volcan, iflag_rrtm
    USE wxios_mod, ONLY: missing_val
    ! ====================================================================

    ! ==============
    ! DECLARATIONS
    ! ==============

    ! Input arguments
    INTEGER,      INTENT(in) :: iof
    REAL(KIND=8), INTENT(in) :: PWV(kdlon,kflev)
    REAL(KIND=8), INTENT(in) :: ZFSUP(KDLON,KFLEV+1)
    REAL(KIND=8), INTENT(in) :: ZFSDN(KDLON,KFLEV+1)
    REAL(KIND=8), INTENT(in) :: ZFSUP0(KDLON,KFLEV+1)
    REAL(KIND=8), INTENT(in) :: ZFSDN0(KDLON,KFLEV+1)
    REAL(KIND=8), INTENT(in) :: ZFSUPC0(KDLON,KFLEV+1)
    REAL(KIND=8), INTENT(in) :: ZFSDNC0(KDLON,KFLEV+1)
    REAL(KIND=8), INTENT(in) :: ZFLUP(KDLON,KFLEV+1)
    REAL(KIND=8), INTENT(in) :: ZFLDN(KDLON,KFLEV+1)
    REAL(KIND=8), INTENT(in) :: ZFLUP0(KDLON,KFLEV+1)
    REAL(KIND=8), INTENT(in) :: ZFLDN0(KDLON,KFLEV+1)
    REAL(KIND=8), INTENT(in) :: ZFLUPC0(KDLON,KFLEV+1)
    REAL(KIND=8), INTENT(in) :: ZFLDNC0(KDLON,KFLEV+1)
    REAL(KIND=8), INTENT(in) :: zheat(kdlon,kflev), zcool(kdlon,kflev)
    REAL(KIND=8), INTENT(in) :: zheat0(kdlon,kflev), zcool0(kdlon,kflev)
    REAL(KIND=8), INTENT(in) :: zheat_volc(kdlon,kflev), zcool_volc(kdlon,kflev) !NL
    REAL(KIND=8), INTENT(in) :: ztopsw(kdlon), ztoplw(kdlon)
    REAL(KIND=8), INTENT(in) :: zsolsw(kdlon), zsollw(kdlon), zalbpla(kdlon), zsolswfdiff(kdlon)
    REAL(KIND=8), INTENT(in) ::zsollwdown(kdlon)
    REAL(KIND=8), INTENT(in) :: ztopsw0(kdlon), ztoplw0(kdlon)
    REAL(KIND=8), INTENT(in) :: zsolsw0(kdlon), zsollw0(kdlon)
    REAL(KIND=8), INTENT(in) :: ztopswadaero(kdlon), zsolswadaero(kdlon)     ! Aerosol direct forcing at TOAand surface
    REAL(KIND=8), INTENT(in) :: ztopswad0aero(kdlon), zsolswad0aero(kdlon)   ! Aerosol direct forcing at TOAand surface
    REAL(KIND=8), INTENT(in) :: ztopswaiaero(kdlon), zsolswaiaero(kdlon)     ! dito, indirect
    REAL(KIND=8), INTENT(in) :: ztoplwadaero(kdlon), zsollwadaero(kdlon)     ! LW Aerosol direct forcing at TOAand surface
    REAL(KIND=8), INTENT(in) :: ztoplwad0aero(kdlon), zsollwad0aero(kdlon)   ! LW Aerosol direct forcing at TOAand surface
    REAL(KIND=8), INTENT(in) :: ztoplwaiaero(kdlon), zsollwaiaero(kdlon)     ! dito, indirect
    REAL(KIND=8), INTENT(in) :: ztopsw_aero(kdlon,9), ztopsw0_aero(kdlon,9)
    REAL(KIND=8), INTENT(in) :: zsolsw_aero(kdlon,9), zsolsw0_aero(kdlon,9)
    REAL(KIND=8), INTENT(in) :: ztopswcf_aero(kdlon,3), zsolswcf_aero(kdlon,3)

    ! Output arguments
    REAL,    INTENT(out) :: heat(KLON,KLEV), cool(KLON,KLEV)
    REAL,    INTENT(out) :: heat0(KLON,KLEV), cool0(KLON,KLEV)
    REAL,    INTENT(out) :: heat_volc(KLON,KLEV), cool_volc(KLON,KLEV) !NL
    REAL,    INTENT(out) :: topsw(KLON), toplw(KLON)
    REAL,    INTENT(out) :: solsw(KLON), sollw(KLON), solswfdiff(KLON)
    REAL,    INTENT(out) :: topsw0(KLON), toplw0(KLON), solsw0(KLON), sollw0(KLON)
    REAL,    INTENT(out) :: sollwdown(KLON)
    REAL,    INTENT(out) :: swdn(KLON,kflev+1),swdn0(KLON,kflev+1), swdnc0(KLON,kflev+1)
    REAL,    INTENT(out) :: swup(KLON,kflev+1),swup0(KLON,kflev+1), swupc0(KLON,kflev+1)
    REAL,    INTENT(out) :: lwdn(KLON,kflev+1),lwdn0(KLON,kflev+1), lwdnc0(KLON,kflev+1)
    REAL,    INTENT(out) :: lwup(KLON,kflev+1),lwup0(KLON,kflev+1), lwupc0(KLON,kflev+1)
    REAL,    INTENT(out) :: topswad_aero(KLON), solswad_aero(KLON)         ! output: aerosol direct forcing at TOA and surface
    REAL,    INTENT(out) :: topswai_aero(KLON), solswai_aero(KLON)         ! output: aerosol indirect forcing atTOA and surface
    REAL,    INTENT(out) :: toplwad_aero(KLON), sollwad_aero(KLON)         ! output: LW aerosol direct forcing at TOA and surface
    REAL,    INTENT(out) :: toplwai_aero(KLON), sollwai_aero(KLON)         ! output: LW aerosol indirect forcing atTOA and surface
    REAL, DIMENSION(klon), INTENT(out)    :: topswad0_aero 
    REAL, DIMENSION(klon), INTENT(out)    :: solswad0_aero
    REAL, DIMENSION(klon), INTENT(out)    :: toplwad0_aero 
    REAL, DIMENSION(klon), INTENT(out)    :: sollwad0_aero
    REAL, DIMENSION(kdlon,9), INTENT(out) :: topsw_aero
    REAL, DIMENSION(kdlon,9), INTENT(out) :: topsw0_aero
    REAL, DIMENSION(kdlon,9), INTENT(out) :: solsw_aero
    REAL, DIMENSION(kdlon,9), INTENT(out) :: solsw0_aero
    REAL, DIMENSION(kdlon,3), INTENT(out) :: topswcf_aero
    REAL, DIMENSION(kdlon,3), INTENT(out) :: solswcf_aero
    REAL,    INTENT(out) :: albpla(KLON)
    !Ecrad :
    REAL(KIND=8), INTENT(out) :: cloud_cover_sw(klon), &                   ! SW cloud cover issued from Rcrad
                                 ZFLUX_DIR(klon,klev+1), &              ! Direct compt of surf flux into horizontal plane
                                 ZFLUX_DIR_CLEAR(klon,klev+1), &        ! CS Direct
                                 ZFLUX_DIR_INTO_SUN(klon)

    ! Local variables
    INTEGER k, i
    REAL(KIND=8) zznormcp

     ! ----- flux radiatifs => sorties ---------------------------------  
       DO i = 1, kdlon
          topsw(iof+i) = ztopsw(i)
          toplw(iof+i) = ztoplw(i)
          solsw(iof+i) = zsolsw(i)
          solswfdiff(iof+i) = zsolswfdiff(i)
          sollw(iof+i) = zsollw(i)
          sollwdown(iof+i) = zsollwdown(i)
      ENDDO

      DO k = 1, kflev+1
         DO i = 1, kdlon
             lwdn0 ( iof+i,k)   = ZFLDN0 ( i,k)
             lwdn  ( iof+i,k)   = ZFLDN  ( i,k)
             lwup0 ( iof+i,k)   = ZFLUP0 ( i,k)
             lwup  ( iof+i,k)   = ZFLUP  ( i,k)
          ENDDO
      ENDDO

       DO i = 1, kdlon
          topsw0(iof+i) = ztopsw0(i)
          toplw0(iof+i) = ztoplw0(i)
          solsw0(iof+i) = zsolsw0(i)
          sollw0(iof+i) = zsollw0(i)
          albpla(iof+i) = zalbpla(i)
        ENDDO

        DO k = 1, kflev+1
          DO i = 1, kdlon
             swdnc0( iof+i,k)   = ZFSDNC0( i,k)
             swdn0 ( iof+i,k)   = ZFSDN0 ( i,k)
             swdn  ( iof+i,k)   = ZFSDN  ( i,k)
             swupc0( iof+i,k)   = ZFSUPC0( i,k)
             swup0 ( iof+i,k)   = ZFSUP0 ( i,k)
             swup  ( iof+i,k)   = ZFSUP  ( i,k)
             lwdnc0( iof+i,k)   = ZFLDNC0( i,k)
             lwupc0( iof+i,k)   = ZFLUPC0( i,k)
          ENDDO
       ENDDO
       !-transform the aerosol forcings, if they have
       ! to be calculated
       IF (ok_ade) THEN
          DO i = 1, kdlon
             topswad_aero(iof+i) = ztopswadaero(i)
             topswad0_aero(iof+i) = ztopswad0aero(i)
             solswad_aero(iof+i) = zsolswadaero(i)
             solswad0_aero(iof+i) = zsolswad0aero(i)
          ENDDO
          
             topsw_aero(:,:) = ztopsw_aero(:,:)
             topsw0_aero(:,:) = ztopsw0_aero(:,:)
             solsw_aero(:,:) = zsolsw_aero(:,:)
             solsw0_aero(:,:) = zsolsw0_aero(:,:)
             topswcf_aero(:,:) = ztopswcf_aero(:,:)
             solswcf_aero(:,:) = zsolswcf_aero(:,:)   
             !-LW
          DO i = 1, kdlon
             toplwad_aero(iof+i) = ztoplwadaero(i)
             toplwad0_aero(iof+i) = ztoplwad0aero(i)
             sollwad_aero(iof+i) = zsollwadaero(i)
             sollwad0_aero(iof+i) = zsollwad0aero(i)    
          ENDDO
       ELSE
          DO i = 1, kdlon
             topswad_aero(iof+i) = 0.0
             solswad_aero(iof+i) = 0.0
             topswad0_aero(iof+i) = 0.0
             solswad0_aero(iof+i) = 0.0
          ENDDO
             topsw_aero(:,:) = 0.
             topsw0_aero(:,:) =0.
             solsw_aero(:,:) = 0.
             solsw0_aero(:,:) = 0.
             !-LW
          DO i = 1, kdlon
             toplwad_aero(iof+i) = 0.0
             sollwad_aero(iof+i) = 0.0
             toplwad0_aero(iof+i) = 0.0
             sollwad0_aero(iof+i) = 0.0
          ENDDO
       ENDIF
       IF (ok_aie) THEN
          DO i = 1, kdlon
             topswai_aero(iof+i) = ztopswaiaero(i)
             solswai_aero(iof+i) = zsolswaiaero(i)
             !-LW
             toplwai_aero(iof+i) = ztoplwaiaero(i)
             sollwai_aero(iof+i) = zsollwaiaero(i)
          ENDDO
       ELSE
          DO i = 1, kdlon
             topswai_aero(iof+i) = 0.0
             solswai_aero(iof+i) = 0.0
             !-LW
             toplwai_aero(iof+i) = 0.0
             sollwai_aero(iof+i) = 0.0
          ENDDO
       ENDIF
       DO k = 1, kflev
          DO i = 1, kdlon
             !        scale factor to take into account the difference between
             !        dry air and watter vapour scpecifi! heat capacity
             zznormcp=1.0+RVTMP2*PWV(i,k)
             heat(iof+i,k) = zheat(i,k)/zznormcp
             cool(iof+i,k) = zcool(i,k)/zznormcp
             heat0(iof+i,k) = zheat0(i,k)/zznormcp
             cool0(iof+i,k) = zcool0(i,k)/zznormcp
             IF(ok_volcan) THEN !NL
                heat_volc(iof+i,k) = zheat_volc(i,k)/zznormcp
                cool_volc(iof+i,k) = zcool_volc(i,k)/zznormcp
             ENDIF
          ENDDO
       ENDDO
       IF (iflag_rrtm.ne.2) THEN
          cloud_cover_sw(:) = missing_val
          ZFLUX_DIR(:,:) = missing_val
          ZFLUX_DIR_CLEAR(:,:) = missing_val  
          ZFLUX_DIR_INTO_SUN = missing_val
       END IF

  END SUBROUTINE radiation_post
END MODULE lmdz_radiation_post

SUBROUTINE SRTM_KGB27

!     Originally by J.Delamere, Atmospheric & Environmental Research.
!     Revision: 2.4
!     BAND 16: 29000-38000 cm-1 (low - O3; high - O3)
!     Reformatted for F90 by JJMorcrette, ECMWF
!     G.Mozdzynski March 2011 read constants from files
!     T. Wilhelmsson and K. Yessad (Oct 2013) Geometry and setup refactoring.
!     ------------------------------------------------------------------

USE PARKIND1  , ONLY : JPRB
USE YOMHOOK   , ONLY : LHOOK, DR_HOOK
USE YOMLUN    , ONLY : NULRAD
USE YOMMP0    , ONLY : NPROC, MYPROC
USE MPL_MODULE, ONLY : MPL_BROADCAST
USE YOMTAG    , ONLY : MTAGRAD
USE YOESRTA27 , ONLY : KA, KB, KA_D, KB_D, SFLUXREF, RAYL, SCALEKUR, LAYREFFR  

!     ------------------------------------------------------------------

IMPLICIT NONE

! KURUCZ
!     The following values were obtained using the "low resolution"
!     version of the Kurucz solar source function.  For unknown reasons,
!     the total irradiance in this band differs from the corresponding
!     total in the "high-resolution" version of the Kurucz function.
!     Therefore, below these values are scaled by the factor SCALEKUR.
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "abor1.intfb.h"

IF (LHOOK) CALL DR_HOOK('SRTM_KGB27',0,ZHOOK_HANDLE)

IF( MYPROC==1 )THEN
 READ(NULRAD,ERR=1001) KA_D,KB_D
  KA = REAL(KA_D,JPRB)
  KB = REAL(KB_D,JPRB) 
ENDIF
IF( NPROC>1 )THEN
  CALL MPL_BROADCAST (KA,MTAGRAD,1,CDSTRING='SRTM_KGB27:')
  CALL MPL_BROADCAST (KB,MTAGRAD,1,CDSTRING='SRTM_KGB27:')
ENDIF

SFLUXREF = (/ &
 & 14.0526_JPRB    , 11.4794_JPRB    , 8.72590_JPRB    , 5.56966_JPRB    , &
 & 3.80927_JPRB    , 1.57690_JPRB    , 1.15099_JPRB    , 1.10012_JPRB    , &
 & 0.658212_JPRB   , 5.86859E-02_JPRB, 5.56186E-02_JPRB, 4.68040E-02_JPRB, &
 & 3.64897E-02_JPRB, 3.58053E-02_JPRB, 1.38130E-02_JPRB, 1.90193E-03_JPRB /)  

!     Rayleigh extinction coefficient at v = 2925 cm-1.
RAYL = (/ &
 & 3.44534E-06_JPRB,4.14480E-06_JPRB,4.95069E-06_JPRB,5.81204E-06_JPRB, &
 & 6.69748E-06_JPRB,7.56488E-06_JPRB,8.36344E-06_JPRB,9.04135E-06_JPRB, &
 & 9.58324E-06_JPRB,9.81542E-06_JPRB,9.75119E-06_JPRB,9.74533E-06_JPRB, &
 & 9.74139E-06_JPRB,9.73525E-06_JPRB,9.73577E-06_JPRB,9.73618E-06_JPRB /)  

SCALEKUR = 50.15_JPRB/48.37_JPRB

LAYREFFR = 32

!     ------------------------------------------------------------------

!     The array KA contains absorption coefs at the 16 chosen g-values 
!     for a range of pressure levels> ~100mb, temperatures, and binary
!     species parameters (see taumol.f for definition).  The first 
!     index in the array, JS, runs from 1 to 9, and corresponds to 
!     different values of the binary species parameter.  For instance, 
!     JS=1 refers to dry air, JS = 2 corresponds to the paramter value 1/8, 
!     JS = 3 corresponds to the parameter value 2/8, etc.  The second index
!     in the array, JT, which runs from 1 to 5, corresponds to different
!     temperatures.  More specifically, JT = 3 means that the data are for
!     the reference temperature TREF for this  pressure level, JT = 2 refers
!     to TREF-15, JT = 1 is for TREF-30, JT = 4 is for TREF+15, and JT = 5
!     is for TREF+30.  The third index, JP, runs from 1 to 13 and refers
!     to the JPth reference pressure level (see taumol.f for these levels
!     in mb).  The fourth index, IG, goes from 1 to 16, and indicates
!     which g-interval the absorption coefficients are for.
!     -----------------------------------------------------------------

!     -----------------------------------------------------------------
!     The array KB contains absorption coefs at the 16 chosen g-values 
!     for a range of pressure levels < ~100mb and temperatures. The first 
!     index in the array, JT, which runs from 1 to 5, corresponds to 
!     different temperatures.  More specifically, JT = 3 means that the 
!     data are for the reference temperature TREF for this pressure 
!     level, JT = 2 refers to the temperature TREF-15, JT = 1 is for
!     TREF-30, JT = 4 is for TREF+15, and JT = 5 is for TREF+30.  
!     The second index, JP, runs from 13 to 59 and refers to the JPth
!     reference pressure level (see taumol.f for the value of these
!     pressure levels in mb).  The third index, IG, goes from 1 to 16,
!     and tells us which g-interval the absorption coefficients are for.
!     -----------------------------------------------------------------
  
     
!     -----------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('SRTM_KGB27',1,ZHOOK_HANDLE)
RETURN

1001 CONTINUE
CALL ABOR1("SRTM_KGB27:ERROR READING FILE RADSRTM")

END SUBROUTINE SRTM_KGB27

module exner_milieu_loc_m

  USE comgeom_mod_h
    IMPLICIT NONE

contains

  SUBROUTINE  exner_milieu_loc ( ngrid, ps, p, pks, pk, pkf )
    !
    !     Auteurs :  F. Forget , Y. Wanherdrick
    ! P.Le Van  , Fr. Hourdin  .
    !    ..........
    !
    !    ....  ngrid, ps,p             sont des argum.d'entree  au sous-prog ...
    !    ....  pks,pk,pkf   sont des argum.de sortie au sous-prog ...
    !
    !   ************************************************************************
    !    Calcule la fonction d'Exner pk = Cp * (p/preff) ** kappa , aux milieux des
    !    couches .   Pk(l) sera calcule aux milieux  des couches l ,entre les
    !    pressions p(l) et p(l+1) ,definis aux interfaces des llm couches .
    !   ************************************************************************
    !  .. N.B : Au sommet de l'atmosphere,  p(llm+1) = 0. , et ps et pks sont
    !    la pression et la fonction d'Exner  au  sol  .
    !
    !     WARNING : CECI est une version speciale de exner_hyb originale
    !               Utilise dans la version martienne pour pouvoir
    !               tourner avec des coordonnees verticales complexe
    !              => Il ne verifie PAS la condition la proportionalite en
    !              energie totale/ interne / potentielle (F.Forget 2001)
    !    ( voir note de Fr.Hourdin )  ,
    !
    USE parallel_lmdz
    USE mod_filtreg_p
    USE comconst_mod, ONLY: cpp, kappa, r, jmp1
    USE comvert_mod, ONLY: preff

    USE dimensions_mod, ONLY: iim, jjm, llm, ndm
USE paramet_mod_h
IMPLICIT NONE
    !



    INTEGER  ngrid
    REAL p(ijb_u:ije_u,llmp1),pk(ijb_u:ije_u,llm)
    REAL, optional:: pkf(ijb_u:ije_u,llm)
    REAL ps(ijb_u:ije_u),pks(ijb_u:ije_u)

    !    .... variables locales   ...

    INTEGER l, ij
    REAL dum1

    INTEGER ije,ijb,jje,jjb
    logical,save :: firstcall=.true.
    !$OMP THREADPRIVATE(firstcall) 
    character(len=*),parameter :: modname="exner_milieu_loc"

    ! Sanity check
    if (firstcall) then
       ! sanity checks for Shallow Water case (1 vertical layer)
       if (llm.eq.1) then
          if (kappa.ne.1) then
             call abort_gcm(modname, &
                  "kappa!=1 , but running in Shallow Water mode!!",42)
          endif
          if (cpp.ne.r) then
             call abort_gcm(modname, &
                  "cpp!=r , but running in Shallow Water mode!!",42)
          endif
       endif ! of if (llm.eq.1)

       firstcall=.false.
    endif ! of if (firstcall)

    !$OMP BARRIER

    ! Specific behaviour for Shallow Water (1 vertical layer) case:
    if (llm.eq.1) then

       ! Compute pks(:),pk(:),pkf(:)
       ijb=ij_begin
       ije=ij_end
       !$OMP DO SCHEDULE(STATIC)
       DO ij=ijb, ije
          pks(ij) = (cpp/preff) * ps(ij)
          pk(ij,1) = .5*pks(ij)
          if (present(pkf)) pkf(ij,1)=pk(ij,1)
       ENDDO
       !$OMP ENDDO

       !$OMP BARRIER
       if (present(pkf)) then
          jjb=jj_begin
          jje=jj_end
          CALL filtreg_p ( pkf,jjb_u,jje_u,jjb,jje, jmp1, llm, &
               2, 1, .TRUE., 1 )
       end if

       ! our work is done, exit routine
       return
    endif ! of if (llm.eq.1)

    ! General case:

    !     -------------
    !     Calcul de pks
    !     -------------

    ijb=ij_begin
    ije=ij_end

    !$OMP DO SCHEDULE(STATIC)
    DO   ij  = ijb, ije
       pks(ij) = cpp * ( ps(ij)/preff ) ** kappa
    ENDDO
    !$OMP ENDDO
    ! Synchro OPENMP ici

    !$OMP BARRIER
    !
    !
    !    .... Calcul de pk  pour la couche l 
    !    --------------------------------------------
    !
    dum1 = cpp * (2*preff)**(-kappa) 
    DO l = 1, llm-1
       !$OMP DO SCHEDULE(STATIC)
       DO   ij   = ijb, ije
          pk(ij,l) = dum1 * (p(ij,l) + p(ij,l+1))**kappa
       ENDDO
       !$OMP ENDDO NOWAIT
    ENDDO

    !    .... Calcul de pk  pour la couche l = llm ..
    !    (on met la meme distance (en log pression)  entre Pk(llm)
    !    et Pk(llm -1) qu'entre Pk(llm-1) et Pk(llm-2)

    !$OMP DO SCHEDULE(STATIC)
    DO   ij   = ijb, ije
       pk(ij,llm) = pk(ij,llm-1)**2 / pk(ij,llm-2)
    ENDDO
    !$OMP ENDDO NOWAIT        

    if (present(pkf)) then
       !    calcul de pkf

       DO l = 1, llm
          !$OMP DO SCHEDULE(STATIC)
          DO   ij   = ijb, ije
             pkf(ij,l)=pk(ij,l)
          ENDDO
          !$OMP ENDDO NOWAIT
       ENDDO

       !$OMP BARRIER

       jjb=jj_begin
       jje=jj_end
       CALL filtreg_p ( pkf,jjb_u,jje_u,jjb,jje, jmp1, llm, &
            2, 1, .TRUE., 1 )
    end if

  END SUBROUTINE exner_milieu_loc

end module exner_milieu_loc_m

! $Id: readaerosol_optic_ecrad.F90
!
SUBROUTINE readaerosol_optic_ecrad(debut, aerosol_couple, ok_alw, ok_volcan, &
     flag_aerosol, flag_bc_internal_mixture, itap, rjourvrai, &
     pdtphys, pplay, paprs, t_seri, rhcl, presnivs, &
     tr_seri, mass_solu_aero, mass_solu_aero_pi, m_allaer) 
!     tau_aero, piz_aero, cg_aero, &
!     tausum_aero, drytausum_aero, tau3d_aero )

  ! This routine will :
  ! 1) recevie the aerosols(already read and interpolated) corresponding to flag_aerosol
  ! 2) calculate the optical properties for the aerosols
  !

  USE clesphys_mod_h
  USE dimphy
  USE aero_mod
  USE phys_local_var_mod, only: sconcso4,sconcno3,sconcoa,sconcbc,sconcss,sconcdust, &
       concso4,concno3,concoa,concbc,concss,concdust,loadso4,loadoa,loadbc,loadss,loaddust, &
       loadno3,load_tmp1,load_tmp2,load_tmp3,load_tmp4,load_tmp5,load_tmp6,load_tmp7, &
       load_tmp8,load_tmp9,load_tmp10

  USE infotrac_phy, ONLY: tracers, nqtot, nbtr
  USE YOMCST

  IMPLICIT NONE


  ! Input arguments
  !****************************************************************************************
  LOGICAL, INTENT(IN)                      :: debut
  LOGICAL, INTENT(IN)                      :: aerosol_couple
  LOGICAL, INTENT(IN)                      :: ok_alw
  LOGICAL, INTENT(IN)                      :: ok_volcan
  INTEGER, INTENT(IN)                      :: flag_aerosol
  LOGICAL, INTENT(IN)                      :: flag_bc_internal_mixture
  INTEGER, INTENT(IN)                      :: itap
  REAL, INTENT(IN)                         :: rjourvrai
  REAL, INTENT(IN)                         :: pdtphys
  REAL, DIMENSION(klon,klev), INTENT(IN)   :: pplay
  REAL, DIMENSION(klon,klev+1), INTENT(IN) :: paprs
  REAL, DIMENSION(klon,klev), INTENT(IN)   :: t_seri
  REAL, DIMENSION(klon,klev), INTENT(IN)   :: rhcl   ! humidite relative ciel clair
  REAL, DIMENSION(klev), INTENT(IN)        :: presnivs
  REAL, DIMENSION(klon,klev,nbtr), INTENT(IN) :: tr_seri ! concentration tracer

  ! Output arguments
  !****************************************************************************************
  REAL, DIMENSION(klon,klev), INTENT(OUT)     :: mass_solu_aero    ! Total mass for all soluble aerosols
  REAL, DIMENSION(klon,klev), INTENT(OUT)     :: mass_solu_aero_pi !     -"-     preindustrial values
  REAL, DIMENSION(klon,klev,naero_tot), INTENT(OUT) :: m_allaer
  ! AI a passer par la suite en argument si besoin pour ecrad
  !REAL, DIMENSION(klon,klev,naero_tot), INTENT(OUT) :: m_allaer_pi !RAF

!  REAL, DIMENSION(klon,klev,2,NSW), INTENT(OUT) :: tau_aero    ! Aerosol optical thickness
!  REAL, DIMENSION(klon,klev,2,NSW), INTENT(OUT) :: piz_aero    ! Single scattering albedo aerosol
!  REAL, DIMENSION(klon,klev,2,NSW), INTENT(OUT) :: cg_aero     ! asymmetry parameter aerosol
!  REAL, DIMENSION(klon,nwave,naero_tot), INTENT(OUT)       :: tausum_aero
!  REAL, DIMENSION(klon,naero_tot), INTENT(OUT)             :: drytausum_aero
!  REAL, DIMENSION(klon,klev,nwave,naero_tot), INTENT(OUT)  :: tau3d_aero

  ! Local variables
  !****************************************************************************************
  REAL, DIMENSION(klon)        :: aerindex      ! POLDER aerosol index 
  REAL, DIMENSION(klon,klev)   :: sulfacc       ! SO4 accumulation concentration [ug/m3]
  REAL, DIMENSION(klon,klev)   :: sulfcoarse    ! SO4 coarse concentration [ug/m3]
  REAL, DIMENSION(klon,klev)   :: bcsol         ! BC soluble concentration [ug/m3]
  REAL, DIMENSION(klon,klev)   :: bcins         ! BC insoluble concentration [ug/m3]
  REAL, DIMENSION(klon,klev)   :: pomsol        ! POM soluble concentration [ug/m3]
  REAL, DIMENSION(klon,klev)   :: pomins        ! POM insoluble concentration [ug/m3]
  REAL, DIMENSION(klon,klev)   :: cidust        ! DUST aerosol concentration  [ug/m3]
  REAL, DIMENSION(klon,klev)   :: sscoarse      ! SS Coarse concentration [ug/m3]
  REAL, DIMENSION(klon,klev)   :: sssupco       ! SS Super Coarse concentration [ug/m3]
  REAL, DIMENSION(klon,klev)   :: ssacu         ! SS Acumulation concentration [ug/m3]
  REAL, DIMENSION(klon,klev)   :: nitracc       ! nitrate accumulation concentration [ug/m3]
  REAL, DIMENSION(klon,klev)   :: nitrcoarse    ! nitrate coarse concentration [ug/m3]
  REAL, DIMENSION(klon,klev)   :: nitrinscoarse ! nitrate insoluble coarse concentration [ug/m3]
  REAL, DIMENSION(klon,klev)   :: sulfacc_pi
  REAL, DIMENSION(klon,klev)   :: sulfcoarse_pi
  REAL, DIMENSION(klon,klev)   :: bcsol_pi
  REAL, DIMENSION(klon,klev)   :: bcins_pi
  REAL, DIMENSION(klon,klev)   :: pomsol_pi
  REAL, DIMENSION(klon,klev)   :: pomins_pi
  REAL, DIMENSION(klon,klev)   :: cidust_pi
  REAL, DIMENSION(klon,klev)   :: sscoarse_pi
  REAL, DIMENSION(klon,klev)   :: sssupco_pi
  REAL, DIMENSION(klon,klev)   :: ssacu_pi
  REAL, DIMENSION(klon,klev)   :: nitracc_pi
  REAL, DIMENSION(klon,klev)   :: nitrcoarse_pi
  REAL, DIMENSION(klon,klev)   :: nitrinscoarse_pi
  REAL, DIMENSION(klon,klev)   :: pdel, zrho
  REAL, DIMENSION(klon,klev,naero_tot) :: m_allaer_pi

  integer :: id_ASBCM, id_ASPOMM, id_ASSO4M, id_ASMSAM, id_CSSO4M, id_CSMSAM, id_SSSSM
  integer :: id_CSSSM, id_ASSSM, id_CIDUSTM, id_AIBCM, id_AIPOMM, id_ASNO3M, id_CSNO3M, id_CINO3M
  INTEGER :: k, i, iq, itr

  !--air density
  zrho(:,:)=pplay(:,:)/t_seri(:,:)/RD                     !--kg/m3

  !****************************************************************************************
  ! 1) Get aerosol mass
  !    
  !****************************************************************************************
  !
  !
  IF (aerosol_couple) THEN   !--we get aerosols from tr_seri array from INCA
     !
     !--copy fields from INCA tr_seri 
     !--convert to ug m-3 unit for consistency with offline fields
     !
     itr = 0
     DO iq = 1,nqtot
        IF(.NOT. tracers(iq)%isInPhysics) CYCLE
        itr = itr+1
        SELECT CASE(trim(tracers(iq)%name))
           CASE ("ASBCM");  id_ASBCM  = itr
           CASE ("ASPOMM"); id_ASPOMM = itr
           CASE ("ASSO4M"); id_ASSO4M = itr
           CASE ("ASMSAM"); id_ASMSAM = itr
           CASE ("CSSO4M"); id_CSSO4M = itr
           CASE ("CSMSAM"); id_CSMSAM = itr
           CASE ("SSSSM");  id_SSSSM  = itr
           CASE ("CSSSM");  id_CSSSM  = itr
           CASE ("ASSSM");  id_ASSSM  = itr
           CASE ("CIDUSTM");id_CIDUSTM= itr
           CASE ("AIBCM");  id_AIBCM  = itr
           CASE ("AIPOMM"); id_AIPOMM = itr
           CASE ("ASNO3M"); id_ASNO3M = itr
           CASE ("CSNO3M"); id_CSNO3M = itr
           CASE ("CINO3M"); id_CINO3M = itr
        END SELECT
     END DO

     bcsol(:,:)        =   tr_seri(:,:,id_ASBCM)                         *zrho(:,:)*1.e9  ! ASBCM
     pomsol(:,:)       =   tr_seri(:,:,id_ASPOMM)                        *zrho(:,:)*1.e9  ! ASPOMM
     sulfacc(:,:)      =  (tr_seri(:,:,id_ASSO4M)+tr_seri(:,:,id_ASMSAM))*zrho(:,:)*1.e9  ! ASSO4M (=SO4) + ASMSAM (=MSA)
     sulfcoarse(:,:)   =  (tr_seri(:,:,id_CSSO4M)+tr_seri(:,:,id_CSMSAM))*zrho(:,:)*1.e9  ! CSSO4M (=SO4) + CSMSAM (=MSA)
     sssupco(:,:)      =   tr_seri(:,:,id_SSSSM)                         *zrho(:,:)*1.e9  ! SSSSM
     sscoarse(:,:)     =   tr_seri(:,:,id_CSSSM)                         *zrho(:,:)*1.e9  ! CSSSM
     ssacu(:,:)        =   tr_seri(:,:,id_ASSSM)                         *zrho(:,:)*1.e9  ! ASSSM
     cidust(:,:)       =   tr_seri(:,:,id_CIDUSTM)                       *zrho(:,:)*1.e9  ! CIDUSTM
     bcins(:,:)        =   tr_seri(:,:,id_AIBCM)                         *zrho(:,:)*1.e9  ! AIBCM
     pomins(:,:)       =   tr_seri(:,:,id_AIPOMM)                        *zrho(:,:)*1.e9  ! AIPOMM
     nitracc(:,:)      =   tr_seri(:,:,id_ASNO3M)                        *zrho(:,:)*1.e9  ! ASNO3M
     nitrcoarse(:,:)   =   tr_seri(:,:,id_CSNO3M)                        *zrho(:,:)*1.e9  ! CSNO3M
     nitrinscoarse(:,:)=   tr_seri(:,:,id_CINO3M)                        *zrho(:,:)*1.e9  ! CINO3M
     !
     bcsol_pi(:,:)        =   0.0 ! ASBCM pre-ind
     pomsol_pi(:,:)       =   0.0 ! ASPOMM pre-ind
     sulfacc_pi(:,:)      =   0.0 ! ASSO4M (=SO4) + ASMSAM (=MSA) pre-ind
     sulfcoarse_pi(:,:)   =   0.0 ! CSSO4M (=SO4) + CSMSAM (=MSA) pre-ind
     sssupco_pi(:,:)      =   0.0 ! SSSSM pre-ind
     sscoarse_pi(:,:)     =   0.0 ! CSSSM pre-ind
     ssacu_pi(:,:)        =   0.0 ! ASSSM pre-ind
     cidust_pi(:,:)       =   0.0 ! CIDUSTM pre-ind
     bcins_pi(:,:)        =   0.0 ! AIBCM pre-ind
     pomins_pi(:,:)       =   0.0 ! AIPOMM pre-ind
     nitracc_pi(:,:)      =   0.0 ! ASNO3M pre-ind
     nitrcoarse_pi(:,:)   =   0.0 ! CSNO3M pre-ind
     nitrinscoarse_pi(:,:)=   0.0 ! CINO3M
     !
  ELSE !--not aerosol_couple
     !
     ! Read and interpolate sulfate
     IF ( flag_aerosol .EQ. 1 .OR. flag_aerosol .EQ. 6 .OR. flag_aerosol .EQ. 7 ) THEN 

        CALL readaerosol_interp(id_ASSO4M_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, sulfacc, sulfacc_pi,loadso4)
     ELSE
        sulfacc(:,:) = 0. ; sulfacc_pi(:,:) = 0.
        loadso4=0.
     ENDIF

     ! Read and interpolate bcsol and bcins
     IF ( flag_aerosol .EQ. 2 .OR. flag_aerosol .EQ. 6 .OR. flag_aerosol .EQ. 7 ) THEN 

        ! Get bc aerosol distribution 
        CALL readaerosol_interp(id_ASBCM_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, bcsol, bcsol_pi, load_tmp1 )
        CALL readaerosol_interp(id_AIBCM_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, bcins, bcins_pi, load_tmp2 )
        loadbc(:)=load_tmp1(:)+load_tmp2(:)
     ELSE
        bcsol(:,:) = 0. ; bcsol_pi(:,:) = 0.
        bcins(:,:) = 0. ; bcins_pi(:,:) = 0.
        loadbc=0.
     ENDIF

     ! Read and interpolate pomsol and pomins
     IF ( flag_aerosol .EQ. 3 .OR. flag_aerosol .EQ. 6 .OR. flag_aerosol .EQ. 7 ) THEN

        CALL readaerosol_interp(id_ASPOMM_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, pomsol, pomsol_pi, load_tmp3)
        CALL readaerosol_interp(id_AIPOMM_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, pomins, pomins_pi, load_tmp4)
        loadoa(:)=load_tmp3(:)+load_tmp4(:)
     ELSE
        pomsol(:,:) = 0. ; pomsol_pi(:,:) = 0.
        pomins(:,:) = 0. ; pomins_pi(:,:) = 0.
        loadoa=0.
     ENDIF

     ! Read and interpolate csssm, ssssm, assssm
     IF (flag_aerosol .EQ. 4 .OR. flag_aerosol .EQ. 6 .OR. flag_aerosol .EQ. 7 ) THEN 

        CALL readaerosol_interp(id_SSSSM_phy ,itap, pdtphys,rjourvrai, &
        debut, pplay, paprs, t_seri, sssupco, sssupco_pi, load_tmp5) 
        CALL readaerosol_interp(id_CSSSM_phy ,itap, pdtphys,rjourvrai, &
        debut, pplay, paprs, t_seri, sscoarse,sscoarse_pi, load_tmp6) 
        CALL readaerosol_interp(id_ASSSM_phy ,itap, pdtphys,rjourvrai, &
        debut, pplay, paprs, t_seri, ssacu, ssacu_pi, load_tmp7) 
        loadss(:)=load_tmp5(:)+load_tmp6(:)+load_tmp7(:)
     ELSE
        sscoarse(:,:) = 0. ; sscoarse_pi(:,:) = 0. 
        ssacu(:,:)    = 0. ; ssacu_pi(:,:) = 0. 
        sssupco(:,:)  = 0. ; sssupco_pi = 0. 
        loadss=0.
     ENDIF

     ! Read and interpolate cidustm
     IF (flag_aerosol .EQ. 5 .OR. flag_aerosol .EQ. 6 .OR. flag_aerosol .EQ. 7 ) THEN 

        CALL readaerosol_interp(id_CIDUSTM_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, cidust, cidust_pi, loaddust) 

     ELSE
        cidust(:,:) = 0. ; cidust_pi(:,:) = 0. 
        loaddust=0.
     ENDIF
     !
     ! Read and interpolate asno3m, csno3m, cino3m
     IF (flag_aerosol .EQ. 6 .OR. flag_aerosol .EQ. 7 ) THEN 

        CALL readaerosol_interp(id_ASNO3M_phy, itap, pdtphys, rjourvrai, & 
        debut, pplay, paprs, t_seri, nitracc, nitracc_pi, load_tmp8) 
        CALL readaerosol_interp(id_CSNO3M_phy, itap, pdtphys, rjourvrai, & 
        debut, pplay, paprs, t_seri, nitrcoarse, nitrcoarse_pi, load_tmp9) 
        CALL readaerosol_interp(id_CINO3M_phy, itap, pdtphys, rjourvrai, & 
        debut, pplay, paprs, t_seri, nitrinscoarse, nitrinscoarse_pi, load_tmp10) 
        loadno3(:)=load_tmp8(:)+load_tmp9(:)+load_tmp10(:)

     ELSE
        nitracc(:,:)         =   0.0 ; nitracc_pi(:,:)      =   0.0 
        nitrcoarse(:,:)      =   0.0 ; nitrcoarse_pi(:,:)   =   0.0
        nitrinscoarse(:,:)   =   0.0 ; nitrinscoarse_pi(:,:)=   0.0
        loadno3(:)=0.0
     ENDIF
     !
     ! CSSO4M is set to 0 as not reliable
     sulfcoarse(:,:)      =   0.0 ! CSSO4M (=SO4) + CSMSAM (=MSA) 
     sulfcoarse_pi(:,:)   =   0.0 ! CSSO4M (=SO4) + CSMSAM (=MSA) pre-ind

  ENDIF !--not aerosol_couple

  !
  ! Store all aerosols mixing ratios in one variable for radiation scheme (unit kg/kg for ECRAD)
  ! present-day values
  m_allaer(:,:,id_ASBCM_phy)  = bcsol(:,:)        /1.e9/zrho(:,:) ! ASBCM
  m_allaer(:,:,id_ASPOMM_phy) = pomsol(:,:)       /1.e9/zrho(:,:) ! ASPOMM
  m_allaer(:,:,id_ASSO4M_phy) = sulfacc(:,:)      /1.e9/zrho(:,:) ! ASSO4M (= SO4) 
  m_allaer(:,:,id_CSSO4M_phy) = sulfcoarse(:,:)   /1.e9/zrho(:,:) ! CSSO4M 
  m_allaer(:,:,id_SSSSM_phy)  = sssupco(:,:)      /1.e9/zrho(:,:) ! SSSSM
  m_allaer(:,:,id_CSSSM_phy)  = sscoarse(:,:)     /1.e9/zrho(:,:) ! CSSSM
  m_allaer(:,:,id_ASSSM_phy)  = ssacu(:,:)        /1.e9/zrho(:,:) ! ASSSM
  m_allaer(:,:,id_CIDUSTM_phy)= cidust(:,:)       /1.e9/zrho(:,:) ! CIDUSTM
  m_allaer(:,:,id_AIBCM_phy)  = bcins(:,:)        /1.e9/zrho(:,:) ! AIBCM
  m_allaer(:,:,id_ASNO3M_phy) = nitracc(:,:)      /1.e9/zrho(:,:) ! ASNO3M
  m_allaer(:,:,id_CSNO3M_phy) = nitrcoarse(:,:)   /1.e9/zrho(:,:) ! CSNO3M
  m_allaer(:,:,id_CINO3M_phy) = nitrinscoarse(:,:)/1.e9/zrho(:,:) ! CINO3M
  m_allaer(:,:,id_AIPOMM_phy) = pomins(:,:)       /1.e9/zrho(:,:) ! AIPOMM
  m_allaer(:,:,id_STRAT_phy)  = 0.0

  !  pre-industrial (pi) values
  m_allaer_pi(:,:,id_ASBCM_phy)  = bcsol_pi(:,:)        /1.e9/zrho(:,:) ! ASBCM pre-ind
  m_allaer_pi(:,:,id_ASPOMM_phy) = pomsol_pi(:,:)       /1.e9/zrho(:,:) ! ASPOMM pre-ind
  m_allaer_pi(:,:,id_ASSO4M_phy) = sulfacc_pi(:,:)      /1.e9/zrho(:,:) ! ASSO4M (= SO4) pre-ind
  m_allaer_pi(:,:,id_CSSO4M_phy) = sulfcoarse_pi(:,:)   /1.e9/zrho(:,:) ! CSSO4M pre-ind
  m_allaer_pi(:,:,id_SSSSM_phy)  = sssupco_pi(:,:)      /1.e9/zrho(:,:) ! SSSSM pre-ind
  m_allaer_pi(:,:,id_CSSSM_phy)  = sscoarse_pi(:,:)     /1.e9/zrho(:,:) ! CSSSM pre-ind
  m_allaer_pi(:,:,id_ASSSM_phy)  = ssacu_pi(:,:)        /1.e9/zrho(:,:) ! ASSSM pre-ind
  m_allaer_pi(:,:,id_CIDUSTM_phy)= cidust_pi(:,:)       /1.e9/zrho(:,:) ! CIDUSTM pre-ind
  m_allaer_pi(:,:,id_AIBCM_phy)  = bcins_pi(:,:)        /1.e9/zrho(:,:) ! AIBCM pre-ind
  m_allaer_pi(:,:,id_ASNO3M_phy) = nitracc_pi(:,:)      /1.e9/zrho(:,:) ! ASNO3M pre-ind
  m_allaer_pi(:,:,id_CSNO3M_phy) = nitrcoarse_pi(:,:)   /1.e9/zrho(:,:) ! CSNO3M pre-ind
  m_allaer_pi(:,:,id_CINO3M_phy) = nitrinscoarse_pi(:,:)/1.e9/zrho(:,:) ! CINO3M pre-ind
  m_allaer_pi(:,:,id_AIPOMM_phy) = pomins_pi(:,:)       /1.e9/zrho(:,:) ! AIPOMM pre-ind
  m_allaer_pi(:,:,id_STRAT_phy)  = 0.0

  !
  ! Calculate the total mass of all soluble aersosols (in unit ug /m3)
  ! to be revisited for AR6
  mass_solu_aero(:,:)    = sulfacc(:,:)    + bcsol(:,:)    + pomsol(:,:)    + nitracc(:,:)    + ssacu(:,:)
  mass_solu_aero_pi(:,:) = sulfacc_pi(:,:) + bcsol_pi(:,:) + pomsol_pi(:,:) + nitracc_pi(:,:) + ssacu_pi(:,:)

  !****************************************************************************************
  ! 2) Calculate optical properties for the aerosols
  !
  !****************************************************************************************
  DO k = 1, klev
     DO i = 1, klon
        pdel(i,k) = paprs(i,k) - paprs (i,k+1)
     ENDDO
  ENDDO

  ! Diagnostics calculation for CMIP5 protocol unit (in unit kg/m3)
  sconcso4(:)  =m_allaer(:,1,id_ASSO4M_phy)*1.e-9
  sconcno3(:)  =(m_allaer(:,1,id_ASNO3M_phy)+m_allaer(:,1,id_CSNO3M_phy)+m_allaer(:,1,id_CINO3M_phy))*1.e-9
  sconcoa(:)   =(m_allaer(:,1,id_ASPOMM_phy)+m_allaer(:,1,id_AIPOMM_phy))*1.e-9
  sconcbc(:)   =(m_allaer(:,1,id_ASBCM_phy)+m_allaer(:,1,id_AIBCM_phy))*1.e-9
  sconcss(:)   =(m_allaer(:,1,id_ASSSM_phy)+m_allaer(:,1,id_CSSSM_phy)+m_allaer(:,1,id_SSSSM_phy))*1.e-9
  sconcdust(:) =m_allaer(:,1,id_CIDUSTM_phy)*1.e-9
  concso4(:,:) =m_allaer(:,:,id_ASSO4M_phy)*1.e-9
  concno3(:,:) =(m_allaer(:,:,id_ASNO3M_phy)+m_allaer(:,:,id_CSNO3M_phy)+m_allaer(:,:,id_CINO3M_phy))*1.e-9
  concoa(:,:)  =(m_allaer(:,:,id_ASPOMM_phy)+m_allaer(:,:,id_AIPOMM_phy))*1.e-9
  concbc(:,:)  =(m_allaer(:,:,id_ASBCM_phy)+m_allaer(:,:,id_AIBCM_phy))*1.e-9
  concss(:,:)  =(m_allaer(:,:,id_ASSSM_phy)+m_allaer(:,:,id_CSSSM_phy)+m_allaer(:,:,id_SSSSM_phy))*1.e-9
  concdust(:,:)=m_allaer(:,:,id_CIDUSTM_phy)*1.e-9

END SUBROUTINE readaerosol_optic_ecrad

SUBROUTINE nxgrad_gam_loc( klevel, rot, x, y )
  !
  !  P. Le Van
  !
  !   ********************************************************************
  !  calcul du gradient tourne de pi/2 du rotationnel du vect.v
  !   ********************************************************************
  !   rot          est un argument  d'entree pour le s-prog
  !   x  et y    sont des arguments de sortie pour le s-prog
  !
  USE comgeom_mod_h
  USE parallel_lmdz

  USE dimensions_mod, ONLY: iim, jjm, llm, ndm
USE paramet_mod_h
IMPLICIT NONE
  !


  INTEGER :: klevel
  REAL :: rot( ijb_v:ije_v,klevel )
  REAL :: x( ijb_u:ije_u,klevel ),y(ijb_v:ije_v,klevel )
  INTEGER :: l,ij
  integer :: ismin,ismax
  external ismin,ismax
  INTEGER :: ijb,ije
  !
!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
  DO l = 1,klevel
  !
  ijb=ij_begin
  ije=ij_end
  if(pole_sud) ije=ij_end-iip1

  DO  ij = ijb+1, ije
  y( ij,l ) = (rot( ij,l ) - rot( ij-1,l )) * cvscuvgam( ij )
  END DO
  !
  !    ..... correction pour  y ( 1,j,l )  ......
  !
  !    ....    y(1,j,l)= y(iip1,j,l) ....
  !DIR$ IVDEP
  DO  ij = ijb, ije, iip1
  y( ij,l ) = y( ij +iim,l )
  END DO
  !
  ijb=ij_begin
  ije=ij_end+iip1
  if(pole_nord) ijb=ij_begin+iip1
  if(pole_sud) ije=ij_end-iip1

  DO  ij = ijb,ije
  x( ij,l ) = (rot( ij,l ) - rot( ij -iip1,l )) * cuscvugam( ij )
  END DO

  if (pole_nord) then
    DO  ij = 1,iip1
     x(    ij    ,l ) = 0.
    ENDDO
  endif

  if (pole_sud) then
    DO  ij = 1,iip1
     x( ij +ip1jm,l ) = 0.
    ENDDO
  endif
  !
  END DO
!$OMP END DO NOWAIT
  RETURN
END SUBROUTINE nxgrad_gam_loc

!
! $Id: calfis.f90 5927 2025-12-12 16:26:10Z snguyen $
!
!
!
SUBROUTINE calfis(lafin,          &
                  jD_cur, jH_cur, &
                  pucov,          &
                  pvcov,          &
                  pteta,          &
                  pq,             &
                  pmasse,         &
                  pps,            &
                  pp,             &
                  ppk,            &
                  pphis,          &
                  pphi,           &
                  pducov,         &
                  pdvcov,         &
                  pdteta,         &
                  pdq,            &
                  flxw,           &
                  pdufi,          &
                  pdvfi,          &
                  pdhfi,          &
                  pdqfi,          &
                  pdpsfi)
  !
  !    Auteur :  P. Le Van, F. Hourdin
  !   .........
  USE iniprint_mod_h
  USE comgeom2_mod_h
  USE infotrac, ONLY: nqtot, tracers
  USE control_mod, ONLY: planet_type, nsplit_phys
  USE callphysiq_mod, ONLY: call_physiq
  USE comconst_mod, ONLY: cpp, daysec, dtphys, dtvr, kappa, pi
  USE comvert_mod, ONLY: preff, presnivs
  USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_PHYS
  USE dimensions_mod, ONLY: iim, jjm, llm, ndm
  USE paramet_mod_h
  IMPLICIT NONE
  !=======================================================================
  !
  !   1. rearrangement des tableaux et transformation
  !  variables dynamiques  >  variables physiques
  !   2. calcul des termes physiques
  !   3. retransformation des tendances physiques en tendances dynamiques
  !
  !   remarques:
  !   ----------
  !
  !    - les vents sont donnes dans la physique par leurs composantes
  !  naturelles.
  !    - la variable thermodynamique de la physique est une variable
  !  intensive :   T
  !  pour la dynamique on prend    T * ( preff / p(l) ) **kappa
  !    - les deux seules variables dependant de la geometrie necessaires
  !  pour la physique sont la latitude pour le rayonnement et
  !  l'aire de la maille quand on veut integrer une grandeur
  !  horizontalement.
  !    - les points de la physique sont les points scalaires de la
  !  la dynamique; numerotation:
  !      1 pour le pole nord
  !      (jjm-1)*iim pour l'interieur du domaine
  !      ngridmx pour le pole sud
  !  ---> ngridmx=2+(jjm-1)*iim
  !
  ! Input :
  ! -------
  !   pucov           covariant zonal velocity
  !   pvcov           covariant meridional velocity
  !   pteta           potential temperature
  !   pps             surface pressure
  !   pmasse          masse d'air dans chaque maille
  !   pts             surface temperature  (K)
  !   callrad         clef d'appel au rayonnement
  !
  !    Output :
  !    --------
  !    pdufi          tendency for the natural zonal velocity (ms-1)
  !    pdvfi          tendency for the natural meridional velocity
  !    pdhfi          tendency for the potential temperature
  !    pdtsfi         tendency for the surface temperature
  !
  !    pdtrad         radiative tendencies  \  both input
  !    pfluxrad       radiative fluxes      /  and output
  !
  !=======================================================================
  !
  !-----------------------------------------------------------------------
  !
  !    0.  Declarations :
  !    ------------------
  INTEGER :: ngridmx
  PARAMETER( ngridmx = 2+(jjm-1)*iim - 1/jjm   )


  !    Arguments :
  !    -----------
  LOGICAL,INTENT(IN) ::  lafin ! .true. for the very last call to physics
  REAL,INTENT(IN):: jD_cur, jH_cur
  REAL,INTENT(IN) :: pvcov(iip1,jjm,llm) ! covariant meridional velocity
  REAL,INTENT(IN) :: pucov(iip1,jjp1,llm) ! covariant zonal velocity
  REAL,INTENT(IN) :: pteta(iip1,jjp1,llm) ! potential temperature
  REAL,INTENT(IN) :: pmasse(iip1,jjp1,llm) ! mass in each cell ! not used
  REAL,INTENT(IN) :: pq(iip1,jjp1,llm,nqtot) ! tracers
  REAL,INTENT(IN) :: pphis(iip1,jjp1) ! surface geopotential
  REAL,INTENT(IN) :: pphi(iip1,jjp1,llm) ! geopotential

  REAL,INTENT(IN) :: pdvcov(iip1,jjm,llm) ! dynamical tendency on vcov
  REAL,INTENT(IN) :: pducov(iip1,jjp1,llm) ! dynamical tendency on ucov
  REAL,INTENT(IN) :: pdteta(iip1,jjp1,llm) ! dynamical tendency on teta
  ! ! NB: pdteta is used only to compute pcvgt which is in fact not used...
  REAL,INTENT(IN) :: pdq(iip1,jjp1,llm,nqtot) ! dynamical tendency on tracers
  ! ! NB: pdq is only used to compute pcvgq which is in fact not used...

  REAL,INTENT(IN) :: pps(iip1,jjp1) ! surface pressure (Pa)
  REAL,INTENT(IN) :: pp(iip1,jjp1,llmp1) ! pressure at mesh interfaces (Pa)
  REAL,INTENT(IN) :: ppk(iip1,jjp1,llm) ! Exner at mid-layer
  REAL,INTENT(IN) :: flxw(iip1,jjp1,llm) ! Vertical mass flux on lower mesh interfaces (kg/s) (on llm because flxw(:,:,llm+1)=0)

  ! ! tendencies (in */s) from the physics
  REAL,INTENT(OUT) :: pdvfi(iip1,jjm,llm) ! tendency on covariant meridional wind
  REAL,INTENT(OUT) :: pdufi(iip1,jjp1,llm) ! tendency on covariant zonal wind
  REAL,INTENT(OUT) :: pdhfi(iip1,jjp1,llm) ! tendency on potential temperature (K/s)
  REAL,INTENT(OUT) :: pdqfi(iip1,jjp1,llm,nqtot) ! tendency on tracers
  REAL,INTENT(OUT) :: pdpsfi(iip1,jjp1) ! tendency on surface pressure (Pa/s)


  !    Local variables :
  !    -----------------

  INTEGER :: i,j,l,ig0,ig,iq,itr
  REAL :: zpsrf(ngridmx)
  REAL :: zplev(ngridmx,llm+1),zplay(ngridmx,llm)
  REAL :: zphi(ngridmx,llm),zphis(ngridmx)
  !
  REAL :: zrot(iip1,jjm,llm) ! AdlC May 2014
  REAL :: zufi(ngridmx,llm), zvfi(ngridmx,llm)
  REAL :: zrfi(ngridmx,llm) ! relative wind vorticity
  REAL :: ztfi(ngridmx,llm),zqfi(ngridmx,llm,nqtot)
  REAL :: zpk(ngridmx,llm)
  !
  REAL :: pcvgu(ngridmx,llm), pcvgv(ngridmx,llm)
  REAL :: pcvgt(ngridmx,llm), pcvgq(ngridmx,llm,2)
  !
  REAL :: zdufi(ngridmx,llm),zdvfi(ngridmx,llm)
  REAL :: zdtfi(ngridmx,llm),zdqfi(ngridmx,llm,nqtot)
  REAL :: zdpsrf(ngridmx)
  !
  REAL :: zdufic(ngridmx,llm),zdvfic(ngridmx,llm)
  REAL :: zdtfic(ngridmx,llm),zdqfic(ngridmx,llm,nqtot)
  REAL :: jH_cur_split,zdt_split
  LOGICAL :: debut_split,lafin_split
  INTEGER :: isplit

  REAL :: zsin(iim),zcos(iim),z1(iim)
  REAL :: zsinbis(iim),zcosbis(iim),z1bis(iim)
  REAL :: unskap, pksurcp
  !
  REAL :: flxwfi(ngridmx,llm)  ! Flux de masse verticale sur la grille physiq
  !

  REAL :: SSUM

  LOGICAL,SAVE :: firstcal=.true., debut=.true.
   ! REAL rdayvrai

  !
  !-----------------------------------------------------------------------
  !
  !    1. Initialisations :
  !    --------------------
  !
  !
  IF ( firstcal )  THEN
    debut = .TRUE.
    IF (ngridmx.NE.2+(jjm-1)*iim) THEN
      write(lunout,*) 'STOP dans calfis'
      write(lunout,*) &
           'La dimension ngridmx doit etre egale a 2 + (jjm-1)*iim'
      write(lunout,*) '  ngridmx  jjm   iim   '
      write(lunout,*) ngridmx,jjm,iim
      call abort_gcm("calfis", "", 1)
    ENDIF
  ELSE
    debut = .FALSE.
  ENDIF ! of IF (firstcal)

  !
  !
  !-----------------------------------------------------------------------
  !   40. transformation des variables dynamiques en variables physiques:
  !   ---------------------------------------------------------------

  !   41. pressions au sol (en Pascals)
  !   ----------------------------------


  zpsrf(1) = pps(1,1)

  ig0  = 2
  DO j = 2,jjm
     CALL SCOPY( iim,pps(1,j),1,zpsrf(ig0), 1 )
     ig0 = ig0+iim
  ENDDO

  zpsrf(ngridmx) = pps(1,jjp1)


  !   42. pression intercouches et fonction d'Exner:
  !
  !   -----------------------------------------------------------------
  ! .... zplev  definis aux (llm +1) interfaces des couches  ....
  ! .... zplay  definis aux (  llm )    milieux des couches  ....
  !   -----------------------------------------------------------------

  !    ...    Exner = cp * ( p(l) / preff ) ** kappa     ....
  !
   unskap   = 1./ kappa
  !
  DO l = 1, llm
    zpk(   1,l ) = ppk(1,1,l)
    zplev( 1,l ) = pp(1,1,l)
    ig0 = 2
      DO j = 2, jjm
         DO i =1, iim
          zpk(   ig0,l ) = ppk(i,j,l)
          zplev( ig0,l ) = pp(i,j,l)
          ig0 = ig0 +1
         ENDDO
      ENDDO
    zpk(   ngridmx,l ) = ppk(1,jjp1,l)
    zplev( ngridmx,l ) = pp(1,jjp1,l)
  ENDDO
    zplev( 1,llmp1 ) = pp(1,1,llmp1)
    ig0 = 2
      DO j = 2, jjm
         DO i =1, iim
          zplev( ig0,llmp1 ) = pp(i,j,llmp1)
          ig0 = ig0 +1
         ENDDO
      ENDDO
    zplev( ngridmx,llmp1 ) = pp(1,jjp1,llmp1)
  !
  !

  !   43. temperature naturelle (en K) et pressions milieux couches .
  !   ---------------------------------------------------------------

  DO l=1,llm

     pksurcp     =  ppk(1,1,l) / cpp
     zplay(1,l)  =  preff * pksurcp ** unskap
     ztfi(1,l)   =  pteta(1,1,l) *  pksurcp
     pcvgt(1,l)  =  pdteta(1,1,l) * pksurcp / pmasse(1,1,l)
     ig0         = 2

     DO j = 2, jjm
        DO i = 1, iim
          pksurcp        = ppk(i,j,l) / cpp
          zplay(ig0,l)   = preff * pksurcp ** unskap
          ztfi(ig0,l)    = pteta(i,j,l)  * pksurcp
          pcvgt(ig0,l)   = pdteta(i,j,l) * pksurcp / pmasse(i,j,l)
          ig0            = ig0 + 1
        ENDDO
     ENDDO

     pksurcp       = ppk(1,jjp1,l) / cpp
     zplay(ig0,l)  = preff * pksurcp ** unskap
     ztfi (ig0,l)  = pteta(1,jjp1,l)  * pksurcp
     pcvgt(ig0,l)  = pdteta(1,jjp1,l) * pksurcp/ pmasse(1,jjp1,l)

  ENDDO

  !   43.bis traceurs
  !   ---------------
  !
  itr=0
  DO iq=1,nqtot
     IF(tracers(iq)%iadv < 0) CYCLE
     itr = itr + 1
     DO l=1,llm
        zqfi(1,l,itr) = pq(1,1,l,iq)
        ig0           = 2
        DO j=2,jjm
           DO i = 1, iim
              zqfi(ig0,l,itr) = pq(i,j,l,iq)
              ig0             = ig0 + 1
           ENDDO
        ENDDO
        zqfi(ig0,l,itr) = pq(1,jjp1,l,iq)
     ENDDO
  ENDDO

  !   convergence dynamique pour les traceurs "EAU"
  ! Earth-specific treatment of first 2 tracers (water)
   if (planet_type=="earth") then
    DO iq=1,2
     DO l=1,llm
        pcvgq(1,l,iq)= pdq(1,1,l,iq) / pmasse(1,1,l)
        ig0          = 2
        DO j=2,jjm
           DO i = 1, iim
              pcvgq(ig0,l,iq) = pdq(i,j,l,iq) / pmasse(i,j,l)
              ig0             = ig0 + 1
           ENDDO
        ENDDO
        pcvgq(ig0,l,iq)= pdq(1,jjp1,l,iq) / pmasse(1,jjp1,l)
     ENDDO
    ENDDO
   endif ! of if (planet_type=="earth")


  !   Geopotentiel calcule par rapport a la surface locale:
  !   -----------------------------------------------------

  CALL gr_dyn_fi(llm,iip1,jjp1,ngridmx,pphi,zphi)
  CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,pphis,zphis)
  DO l=1,llm
     DO ig=1,ngridmx
       zphi(ig,l)=zphi(ig,l)-zphis(ig)
     ENDDO
  ENDDO

  !   ....  Calcul de la vitesse  verticale  ( en Pa*m*s  ou Kg/s )  ....
  ! JG : ancien calcule de omega utilise dans physiq.F. Maintenant le flux
  !    de masse est calclue dans advtrac.F
   ! DO l=1,llm
   !   pvervel(1,l)=pw(1,1,l) * g /apoln
   !   ig0=2
   !  DO j=2,jjm
   !      DO i = 1, iim
   !         pvervel(ig0,l) = pw(i,j,l) * g * unsaire(i,j)
   !         ig0 = ig0 + 1
   !      ENDDO
  !       ENDDO
   !   pvervel(ig0,l)=pw(1,jjp1,l) * g /apols
   ! ENDDO

  !
  !   45. champ u:
  !   ------------

  DO l=1,llm

     DO j=2,jjm
        ig0 = 1+(j-2)*iim
        zufi(ig0+1,l)= 0.5 * &
              ( pucov(iim,j,l)/cu(iim,j) + pucov(1,j,l)/cu(1,j) )
        pcvgu(ig0+1,l)= 0.5 * &
              ( pducov(iim,j,l)/cu(iim,j) + pducov(1,j,l)/cu(1,j) )
        DO i=2,iim
           zufi(ig0+i,l)= 0.5 * &
                 ( pucov(i-1,j,l)/cu(i-1,j) + pucov(i,j,l)/cu(i,j) )
           pcvgu(ig0+i,l)= 0.5 * &
                 ( pducov(i-1,j,l)/cu(i-1,j) + pducov(i,j,l)/cu(i,j) )
        END DO
     END DO

  END DO


  !  Alvaro de la Camara (May 2014)
  !  46.1 Calcul de la vorticite et passage sur la grille physique
  !  --------------------------------------------------------------
  DO l=1,llm
    do i=1,iim
      do j=1,jjm
        zrot(i,j,l) = (pvcov(i+1,j,l) - pvcov(i,j,l)  &
                     + pucov(i,j+1,l) - pucov(i,j,l)) &
                     / (cu(i,j)+cu(i,j+1)) &
                     / (cv(i+1,j)+cv(i,j)) *4
      enddo
    enddo
  ENDDO

  !   46.champ v:
  !   -----------

  DO l=1,llm
     DO j=2,jjm
        ig0=1+(j-2)*iim
        DO i=1,iim
           zvfi(ig0+i,l)= 0.5 * &
                 ( pvcov(i,j-1,l)/cv(i,j-1) + pvcov(i,j,l)/cv(i,j) )
           pcvgv(ig0+i,l)= 0.5 * &
                 ( pdvcov(i,j-1,l)/cv(i,j-1) + pdvcov(i,j,l)/cv(i,j) )
        ENDDO
           zrfi(ig0 + 1,l)= 0.25 *(zrot(iim,j-1,l)+zrot(iim,j,l) &
                 +zrot(1,j-1,l)+zrot(1,j,l))
        DO i=2,iim
           zrfi(ig0 + i,l)= 0.25 *(zrot(i-1,j-1,l)+zrot(i-1,j,l) &
                 +zrot(i,j-1,l)+zrot(i,j,l))   !  AdlC MAY 2014
        ENDDO
     ENDDO
  ENDDO


  !   47. champs de vents aux pole nord
  !   ------------------------------
     ! U = 1 / pi  *  integrale [ v * cos(long) * d long ]
     ! V = 1 / pi  *  integrale [ v * sin(long) * d long ]

  DO l=1,llm

     z1(1)   =(rlonu(1)-rlonu(iim)+2.*pi)*pvcov(1,1,l)/cv(1,1)
     z1bis(1)=(rlonu(1)-rlonu(iim)+2.*pi)*pdvcov(1,1,l)/cv(1,1)
     DO i=2,iim
        z1(i)   =(rlonu(i)-rlonu(i-1))*pvcov(i,1,l)/cv(i,1)
        z1bis(i)=(rlonu(i)-rlonu(i-1))*pdvcov(i,1,l)/cv(i,1)
     ENDDO

     DO i=1,iim
        zcos(i)   = COS(rlonv(i))*z1(i)
        zcosbis(i)= COS(rlonv(i))*z1bis(i)
        zsin(i)   = SIN(rlonv(i))*z1(i)
        zsinbis(i)= SIN(rlonv(i))*z1bis(i)
     ENDDO

     zufi(1,l)  = SSUM(iim,zcos,1)/pi
     pcvgu(1,l) = SSUM(iim,zcosbis,1)/pi
     zvfi(1,l)  = SSUM(iim,zsin,1)/pi
     pcvgv(1,l) = SSUM(iim,zsinbis,1)/pi
     zrfi(1, l) = 0.
  ENDDO


  !   48. champs de vents aux pole sud:
  !   ---------------------------------
     ! U = 1 / pi  *  integrale [ v * cos(long) * d long ]
     ! V = 1 / pi  *  integrale [ v * sin(long) * d long ]

  DO l=1,llm

     z1(1)   =(rlonu(1)-rlonu(iim)+2.*pi)*pvcov(1,jjm,l)/cv(1,jjm)
     z1bis(1)=(rlonu(1)-rlonu(iim)+2.*pi)*pdvcov(1,jjm,l)/cv(1,jjm)
     DO i=2,iim
        z1(i)   =(rlonu(i)-rlonu(i-1))*pvcov(i,jjm,l)/cv(i,jjm)
        z1bis(i)=(rlonu(i)-rlonu(i-1))*pdvcov(i,jjm,l)/cv(i,jjm)
     ENDDO

     DO i=1,iim
        zcos(i)    = COS(rlonv(i))*z1(i)
        zcosbis(i) = COS(rlonv(i))*z1bis(i)
        zsin(i)    = SIN(rlonv(i))*z1(i)
        zsinbis(i) = SIN(rlonv(i))*z1bis(i)
     ENDDO

     zufi(ngridmx,l)  = SSUM(iim,zcos,1)/pi
     pcvgu(ngridmx,l) = SSUM(iim,zcosbis,1)/pi
     zvfi(ngridmx,l)  = SSUM(iim,zsin,1)/pi
     pcvgv(ngridmx,l) = SSUM(iim,zsinbis,1)/pi
     zrfi(ngridmx, l) = 0.
  ENDDO
  !
  ! On change de grille, dynamique vers physiq, pour le flux de masse verticale
  CALL gr_dyn_fi(llm,iip1,jjp1,ngridmx,flxw,flxwfi)

  !-----------------------------------------------------------------------
  !   Appel de la physique:
  !   ---------------------



   ! write(lunout,*) 'PHYSIQUE AVEC NSPLIT_PHYS=',nsplit_phys
  zdt_split=dtphys/nsplit_phys
  zdufic(:,:)=0.
  zdvfic(:,:)=0.
  zdtfic(:,:)=0.
  zdqfic(:,:,:)=0.

IF (CPPKEY_PHYS) THEN

   do isplit=1,nsplit_phys

     jH_cur_split=jH_cur+(isplit-1) * dtvr / (daysec *nsplit_phys)
     debut_split=debut.and.isplit==1
     lafin_split=lafin.and.isplit==nsplit_phys

   ! if (planet_type=="earth") then
    CALL call_physiq(ngridmx,llm,nqtot,tracers(:)%name, &
                     debut_split,lafin_split, &
                     jD_cur,jH_cur_split,zdt_split, &
                     zplev,zplay, &
                     zpk,zphi,zphis, &
                     presnivs, &
                     zufi,zvfi,zrfi,ztfi,zqfi, &
                     flxwfi,pducov, &
                     zdufi,zdvfi,zdtfi,zdqfi,zdpsrf)
  !
  !  else if ( planet_type=="generic" ) then
  !
  !     CALL physiq (ngridmx,     !! ngrid
  ! .             llm,            !! nlayer
  ! .             nqtot,          !! nq
  ! .             tracers(:)%name,!! tracer names from dynamical core (given in infotrac)
  ! .             debut_split,    !! firstcall
  ! .             lafin_split,    !! lastcall
  ! .             jD_cur,         !! pday. see leapfrog
  ! .             jH_cur_split,   !! ptime "fraction of day"
  ! .             zdt_split,      !! ptimestep
  ! .             zplev,          !! pplev
  ! .             zplay,          !! pplay
  ! .             zphi,           !! pphi
  ! .             zufi,           !! pu
  ! .             zvfi,           !! pv
  ! .             ztfi,           !! pt
  ! .             zqfi,           !! pq
  ! .             flxwfi,         !! pw !! or 0. anyway this is for diagnostic. not used in physiq.
  ! .             zdufi,          !! pdu
  ! .             zdvfi,          !! pdv
  ! .             zdtfi,          !! pdt
  ! .             zdqfi,          !! pdq
  ! .             zdpsrf,         !! pdpsrf
  ! .             tracerdyn)      !! tracerdyn <-- utilite ???
  !
  !  endif ! of if (planet_type=="earth")

     zufi(:,:)=zufi(:,:)+zdufi(:,:)*zdt_split
     zvfi(:,:)=zvfi(:,:)+zdvfi(:,:)*zdt_split
     ztfi(:,:)=ztfi(:,:)+zdtfi(:,:)*zdt_split
     zqfi(:,:,:)=zqfi(:,:,:)+zdqfi(:,:,:)*zdt_split

     zdufic(:,:)=zdufic(:,:)+zdufi(:,:)
     zdvfic(:,:)=zdvfic(:,:)+zdvfi(:,:)
     zdtfic(:,:)=zdtfic(:,:)+zdtfi(:,:)
     zdqfic(:,:,:)=zdqfic(:,:,:)+zdqfi(:,:,:)

   enddo ! of do isplit=1,nsplit_phys

END IF
  ! of #ifdef CPP_PHYS

  zdufi(:,:)=zdufic(:,:)/nsplit_phys
  zdvfi(:,:)=zdvfic(:,:)/nsplit_phys
  zdtfi(:,:)=zdtfic(:,:)/nsplit_phys
  zdqfi(:,:,:)=zdqfic(:,:,:)/nsplit_phys


!!SN 500   CONTINUE !not used

  !-----------------------------------------------------------------------
  !   transformation des tendances physiques en tendances dynamiques:
  !   ---------------------------------------------------------------

  !  tendance sur la pression :
  !  -----------------------------------

  CALL gr_fi_dyn(1,ngridmx,iip1,jjp1,zdpsrf,pdpsfi)
  !
  !   62. enthalpie potentielle
  !   ---------------------

  DO l=1,llm

     DO i=1,iip1
      pdhfi(i,1,l)    = cpp *  zdtfi(1,l)      / ppk(i, 1  ,l)
      pdhfi(i,jjp1,l) = cpp *  zdtfi(ngridmx,l)/ ppk(i,jjp1,l)
     ENDDO

     DO j=2,jjm
        ig0=1+(j-2)*iim
        DO i=1,iim
           pdhfi(i,j,l) = cpp * zdtfi(ig0+i,l) / ppk(i,j,l)
        ENDDO
           pdhfi(iip1,j,l) =  pdhfi(1,j,l)
     ENDDO

  ENDDO


  !   62. humidite specifique
  !   ---------------------
  ! Ehouarn: removed this useless bit: was overwritten at step 63 anyways
   ! DO iq=1,nqtot
   !    DO l=1,llm
   !       DO i=1,iip1
   !          pdqfi(i,1,l,iq)    = zdqfi(1,l,iq)
   !          pdqfi(i,jjp1,l,iq) = zdqfi(ngridmx,l,iq)
   !       ENDDO
   !       DO j=2,jjm
   !          ig0=1+(j-2)*iim
   !          DO i=1,iim
   !             pdqfi(i,j,l,iq) = zdqfi(ig0+i,l,iq)
   !          ENDDO
   !          pdqfi(iip1,j,l,iq) = pdqfi(1,j,l,iq)
   !       ENDDO
   !    ENDDO
   ! ENDDO

  !   63. traceurs
  !   ------------
  ! initialisation des tendances
  pdqfi(:,:,:,:)=0.
  !
  itr = 0
  DO iq=1,nqtot
     IF(tracers(iq)%iadv < 0) CYCLE
     itr = itr + 1
     DO l=1,llm
        DO i=1,iip1
           pdqfi(i,1,l,iq)    = zdqfi(1,l,itr)
           pdqfi(i,jjp1,l,iq) = zdqfi(ngridmx,l,itr)
        ENDDO
        DO j=2,jjm
           ig0=1+(j-2)*iim
           DO i=1,iim
              pdqfi(i,j,l,iq) = zdqfi(ig0+i,l,itr)
           ENDDO
           pdqfi(iip1,j,l,iq) = pdqfi(1,j,l,itr)
        ENDDO
     ENDDO
  ENDDO

  !   65. champ u:
  !   ------------

  DO l=1,llm

     DO i=1,iip1
        pdufi(i,1,l)    = 0.
        pdufi(i,jjp1,l) = 0.
     ENDDO

     DO j=2,jjm
        ig0=1+(j-2)*iim
        DO i=1,iim-1
           pdufi(i,j,l)= &
                 0.5*(zdufi(ig0+i,l)+zdufi(ig0+i+1,l))*cu(i,j)
        ENDDO
        pdufi(iim,j,l)= &
              0.5*(zdufi(ig0+1,l)+zdufi(ig0+iim,l))*cu(iim,j)
        pdufi(iip1,j,l)=pdufi(1,j,l)
     ENDDO

  ENDDO


  !   67. champ v:
  !   ------------

  DO l=1,llm

     DO j=2,jjm-1
        ig0=1+(j-2)*iim
        DO i=1,iim
           pdvfi(i,j,l)= &
                 0.5*(zdvfi(ig0+i,l)+zdvfi(ig0+i+iim,l))*cv(i,j)
        ENDDO
        pdvfi(iip1,j,l) = pdvfi(1,j,l)
     ENDDO
  ENDDO


  !   68. champ v pres des poles:
  !   ---------------------------
   ! v = U * cos(long) + V * SIN(long)

  DO l=1,llm

     DO i=1,iim
        pdvfi(i,1,l)= &
              zdufi(1,l)*COS(rlonv(i))+zdvfi(1,l)*SIN(rlonv(i))
        pdvfi(i,jjm,l)=zdufi(ngridmx,l)*COS(rlonv(i)) &
              +zdvfi(ngridmx,l)*SIN(rlonv(i))
        pdvfi(i,1,l)= &
              0.5*(pdvfi(i,1,l)+zdvfi(i+1,l))*cv(i,1)
        pdvfi(i,jjm,l)= &
              0.5*(pdvfi(i,jjm,l)+zdvfi(ngridmx-iip1+i,l))*cv(i,jjm)
      ENDDO

     pdvfi(iip1,1,l)  = pdvfi(1,1,l)
     pdvfi(iip1,jjm,l)= pdvfi(1,jjm,l)

  ENDDO

  !-----------------------------------------------------------------------

!! SN 700   CONTINUE !not used

  firstcal = .FALSE.

  RETURN
END SUBROUTINE calfis

!
! $Id $
!
SUBROUTINE sw_case_williamson91_6_loc(vcov,ucov,teta,masse,ps)

  !=======================================================================
  !
  !   Author:    Thomas Dubos      original: 26/01/2010
  !   -------
  !
  !   Subject:
  !   ------
  !   Realise le cas-test 6 de Williamson et al. (1991) : onde de Rossby-Haurwitz
  !
  !   Method:
  !   --------
  !
  !   Interface:
  !   ----------
  !
  !  Input:
  !  ------
  !
  !  Output:
  !  -------
  !
  !=======================================================================
  USE iniprint_mod_h
  USE comgeom_mod_h
  USE parallel_lmdz
  USE comconst_mod, ONLY: cpp, omeg, rad
  USE comvert_mod, ONLY: ap, bp, preff

  USE dimensions_mod, ONLY: iim, jjm, llm, ndm
USE paramet_mod_h
IMPLICIT NONE
  !-----------------------------------------------------------------------
  !   Declararations:
  !   ---------------




  !   Arguments:
  !   ----------

  !   variables dynamiques
  REAL :: vcov(ijb_v:ije_v,llm),ucov(ijb_u:ije_u,llm) ! vents covariants
  REAL :: teta(ijb_u:ije_u,llm)                 ! temperature potentielle
  REAL :: ps(ijb_u:ije_u)                       ! pression  au sol
  REAL :: masse(ijb_u:ije_u,llm)                ! masse d'air
  REAL :: phis(ijb_u:ije_u)                     ! geopotentiel au sol

  !   Local:
  !   ------

  real,allocatable :: ucov_glo(:,:)
  real,allocatable :: vcov_glo(:,:)
  real,allocatable :: teta_glo(:,:)
  real,allocatable :: masse_glo(:,:)
  real,allocatable :: ps_glo(:)

   ! REAL p (ip1jmp1,llmp1  )               ! pression aux interfac.des couches
   ! REAL pks(ip1jmp1)                      ! exner au  sol
   ! REAL pk(ip1jmp1,llm)                   ! exner au milieu des couches
   ! REAL pkf(ip1jmp1,llm)                  ! exner filt.au milieu des couches
   ! REAL alpha(ip1jmp1,llm),beta(ip1jmp1,llm)

  real,allocatable :: p(:,:)
  real,allocatable :: pks(:)
  real,allocatable :: pk(:,:)
  real,allocatable :: pkf(:,:)
  real,allocatable :: alpha(:,:),beta(:,:)

  REAL :: sinth,costh,costh2, Ath,Bth,Cth, lon,dps
  INTEGER :: i,j,ij

  REAL, PARAMETER    :: rho=1 ! masse volumique de l'air (arbitraire)
  REAL, PARAMETER    :: K    = 7.848e-6  ! K = \omega
  REAL, PARAMETER    :: gh0  = 9.80616 * 8e3
  INTEGER, PARAMETER :: R0=4, R1=R0+1, R2=R0+2         ! mode 4
  ! NB : rad = 6371220 dans W91 (6371229 dans LMDZ)
   ! omeg = 7.292e-5 dans W91 (7.2722e-5 dans LMDZ)


   ! ! allocate (global) arrays
   allocate(vcov_glo(ip1jm,llm))
   allocate(ucov_glo(ip1jmp1,llm))
   allocate(teta_glo(ip1jmp1,llm))
   allocate(ps_glo(ip1jmp1))
   allocate(masse_glo(ip1jmp1,llm))

   allocate(p(ip1jmp1,llmp1))
   allocate(pks(ip1jmp1))
   allocate(pk(ip1jmp1,llm))
   allocate(pkf(ip1jmp1,llm))
   allocate(alpha(ip1jmp1,llm))
   allocate(beta(ip1jmp1,llm))

  IF(0==0) THEN
  !c Williamson et al. (1991) : onde de Rossby-Haurwitz
     teta_glo(:,:) = preff/rho/cpp
  !c geopotentiel (pression de surface)
     do j=1,jjp1
        costh2 = cos(rlatu(j))**2
        Ath = (R0+1)*(costh2**2) + (2*R0*R0-R0-2)*costh2 - 2*R0*R0
        Ath = .25*(K**2)*(costh2**(R0-1))*Ath
        Ath = .5*K*(2*omeg+K)*costh2 + Ath
        Bth = (R1*R1+1)-R1*R1*costh2
        Bth = 2*(omeg+K)*K/(R1*R2) * (costh2**(R0/2))*Bth
        Cth = R1*costh2 - R2
        Cth = .25*K*K*(costh2**R0)*Cth
        do i=1,iip1
           ij=(j-1)*iip1+i
           lon = rlonv(i)
           dps = Ath + Bth*cos(R0*lon) + Cth*cos(2*R0*lon)
           ps_glo(ij) = rho*(gh0 + (rad**2)*dps)
        enddo
     enddo
      ! write(lunout,*) 'W91 ps', MAXVAL(ps), MINVAL(ps)
  ! vitesse zonale ucov
     do j=1,jjp1
        costh  = cos(rlatu(j))
        costh2 = costh**2
        Ath = rad*K*costh
        Bth = R0*(1-costh2)-costh2
        Bth = rad*K*Bth*(costh**(R0-1))
        do i=1,iip1
           ij=(j-1)*iip1+i
           lon = rlonu(i)
           ucov_glo(ij,1) = (Ath + Bth*cos(R0*lon))
        enddo
     enddo
      ! write(lunout,*) 'W91 u', MAXVAL(ucov(:,1)), MINVAL(ucov(:,1))
     ucov_glo(:,1)=ucov_glo(:,1)*cu
  ! vitesse meridienne vcov
     do j=1,jjm
        sinth  = sin(rlatv(j))
        costh  = cos(rlatv(j))
        Ath = -rad*K*R0*sinth*(costh**(R0-1))
        do i=1,iip1
           ij=(j-1)*iip1+i
           lon = rlonv(i)
           vcov_glo(ij,1) = Ath*sin(R0*lon)
        enddo
     enddo
     write(lunout,*) 'W91 v', MAXVAL(vcov(:,1)), MINVAL(vcov(:,1))
     vcov_glo(:,1)=vcov_glo(:,1)*cv

      ! ucov_glo=0
      ! vcov_glo=0
  ELSE
  ! test non-tournant, onde se propageant en latitude
     do j=1,jjp1
        do i=1,iip1
           ij=(j-1)*iip1+i
           ps_glo(ij) = 1e5*(1 + .1*exp(-100*(1+sin(rlatu(j)))**2))
        enddo
     enddo

  ! rho = preff/(cpp*teta)
     teta_glo(:,:) = .01*preff/cpp   ! rho = 100 ; phi = ps/rho = 1e3 ; c=30 m/s = 2600 km/j = 23 degres / j
     ucov_glo(:,:)=0.
     vcov_glo(:,:)=0.
  END IF

  CALL pression ( ip1jmp1, ap, bp, ps_glo, p       )
  CALL massdair(p,masse_glo)

  ! ! copy data from global array to local array:
  teta(ijb_u:ije_u,:)=teta_glo(ijb_u:ije_u,:)
  ucov(ijb_u:ije_u,:)=ucov_glo(ijb_u:ije_u,:)
  vcov(ijb_v:ije_v,:)=vcov_glo(ijb_v:ije_v,:)
  masse(ijb_u:ije_u,:)=masse_glo(ijb_u:ije_u,:)
  ps(ijb_u:ije_u)=ps_glo(ijb_u:ije_u)

  ! ! cleanup
  deallocate(teta_glo)
  deallocate(ucov_glo)
  deallocate(vcov_glo)
  deallocate(masse_glo)
  deallocate(ps_glo)
  deallocate(p)
  deallocate(pks)
  deallocate(pk)
  deallocate(pkf)
  deallocate(alpha)
  deallocate(beta)

END SUBROUTINE sw_case_williamson91_6_loc
!-----------------------------------------------------------------------

!
! aeropt_lw_rrtm.F90 2014-05-13 C. Kleinschmitt
!                    2016-05-03 O. Boucher 
!                    2016-12-17 O. Boucher
!
! This routine feeds aerosol LW properties to RRTM
! we only consider absorption (not scattering)
! we only consider dust for now

SUBROUTINE AEROPT_LW_RRTM(ok_alw, pdel, zrho, flag_aerosol, m_allaer, m_allaer_pi)

  USE dimphy
  USE aero_mod
  USE phys_state_var_mod, ONLY: tau_aero_lw_rrtm
  USE YOERAD, ONLY: NLW
  USE YOMCST, ONLY: RG
! Temporary fix waiting for cleaner interface (or not)
  USE clesphys_mod_h, ONLY: NSW
  
  IMPLICIT NONE

!!  INCLUDE "clesphys.h"
  !
  ! Input arguments:
  !
  LOGICAL, INTENT(IN)                              :: ok_alw
  INTEGER, INTENT(IN)                              :: flag_aerosol
  REAL, DIMENSION(klon,klev), INTENT(IN)           :: pdel, zrho
  REAL, DIMENSION(klon,klev,naero_tot), INTENT(IN) :: m_allaer, m_allaer_pi
  !
  INTEGER inu, i, k
  REAL :: zdh(klon,klev)
  REAL :: tmp_var, tmp_var_pi
  CHARACTER*20 modname
  !
  !--absorption coefficient for CIDUST
  REAL:: alpha_abs_CIDUST_16bands(nbands_lw_rrtm)   !--unit m2/g 
  DATA alpha_abs_CIDUST_16bands /                         &
  0.001, 0.003, 0.005, 0.006, 0.012, 0.030, 0.148, 0.098, &
  0.017, 0.053, 0.031, 0.008, 0.010, 0.011, 0.013, 0.015  /
  !
  modname='aeropt_lw_rrtm'
  !
  IF (NLW.NE.nbands_lw_rrtm) THEN
    CALL abort_physic(modname,'Erreur NLW doit etre egal a 16 pour cette routine',1)
  ENDIF
  ! 
  IF (ok_alw) THEN                                   !--aerosol LW effects
   !
   IF (flag_aerosol.EQ.5.OR.flag_aerosol.EQ.6.OR.flag_aerosol.EQ.7) THEN  !-Dust
    !
    zdh(:,:)=pdel(:,:)/(RG*zrho(:,:))      ! m
    !
    DO k=1, klev
      DO i=1, klon
         !
         tmp_var   =m_allaer(i,k,id_CIDUSTM_phy)   /1.e6*zdh(i,k)  !--g/m2
         tmp_var_pi=m_allaer_pi(i,k,id_CIDUSTM_phy)/1.e6*zdh(i,k)  !--g/m2
         !
         DO inu=1, NLW
           !
           !--total aerosol
           tau_aero_lw_rrtm(i,k,2,inu) = MAX(1.e-15,tmp_var*alpha_abs_CIDUST_16bands(inu))
           !--natural aerosol 
           tau_aero_lw_rrtm(:,:,1,inu) = MAX(1.e-15,tmp_var_pi*alpha_abs_CIDUST_16bands(inu))
           !
         ENDDO
      ENDDO
      !
    ENDDO
    ! 
   ENDIF
   !
  ELSE !--no aerosol LW effects
    !
    tau_aero_lw_rrtm = 1.e-15
  ENDIF
  !
END SUBROUTINE AEROPT_LW_RRTM

!
! $Id: acama_gwd_rando_m.f90 5767 2025-07-10 10:04:51Z rkazeroni $
!
!$gpum horizontal klon
module lmdz_gwd_front

   IMPLICIT NONE

contains

!===========================================================================
   SUBROUTINE ACAMA_GWD_rando(klon, klev, DTIME, pp, presnivs, plat, tt, uu, vv, rot, &
                              zustr, zvstr, d_u, d_v, east_gwstress, west_gwstress)

      ! Parametrization of the momentum flux deposition due to a discrete
      ! number of gravity waves.
      ! Author: F. Lott, A. de la Camara
      ! July, 24th, 2014
      ! Gaussian distribution of the source, source is vorticity squared
      ! Reference: de la Camara and Lott (GRL, 2015, vol 42, 2071-2078 )
      ! Lott et al (JAS, 2010, vol 67, page 157-170)
      ! Lott et al (JAS, 2012, vol 69, page 2134-2151)

!  ONLINE:

      USE lmdz_gwd_ini, ONLY: GWD_FRONT_RUWMAX, GWD_FRONT_SAT, RPI, RG, RD, RCPD
      USE lmdz_gwd_ini, ONLY: ROMEGA, NK, NP, NO, NA, NW
      USE lmdz_gwd_ini, ONLY: gwd_reproductibilite_mpiomp
      USE assert_m, ONLY: assert

!  OFFLINE:
!   include "dimensions_mod.f90"
!   include "dimphy.h"
!END DIFFERENCE

      IMPLICIT NONE

      ! 0. DECLARATIONS:

      ! 0.1 INPUTS
      INTEGER, intent(in) :: klon, klev ! horizontal and vertical dimension
      REAL, intent(in):: DTIME ! Time step of the Physics [s]
      REAL, intent(in):: presnivs(KLEV) ! equivalent pressure of model levels
      REAL, intent(in):: PP(KLON, KLEV) ! (KLON, KLEV) Pressure at full levels [Pa]
      REAL, intent(in):: ROT(KLON, KLEV) ! Relative vorticity
      REAL, intent(in):: TT(KLON, KLEV) ! (KLON, KLEV) Temp at full levels  [K]
      REAL, intent(in):: UU(KLON, KLEV) ! (KLON, KLEV) Zonal wind at full levels [m/s]
      REAL, intent(in):: VV(KLON, KLEV) ! (KLON, KLEV) Merid wind at full levels [m/s]
      REAL, intent(in):: PLAT(KLON) ! (KLON) LATITUDE

      ! 0.2 OUTPUTS
      REAL, intent(out):: zustr(KLON), zvstr(KLON) ! (KLON) Surface Stresses

      REAL, intent(inout):: d_u(KLON, KLEV), d_v(KLON, KLEV) !
      REAL, intent(inout):: east_gwstress(KLON, KLEV) !  Profile of eastward stress
      REAL, intent(inout):: west_gwstress(KLON, KLEV) !  Profile of westward stress

      ! O.3 INTERNAL ARRAYS
      REAL BVLOW(klon)  !  LOW LEVEL BV FREQUENCY
      REAL ROTBA(KLON), CORIO(KLON)  !  BAROTROPIC REL. VORTICITY AND PLANETARY
      REAL UZ(KLON, KLEV + 1)

      INTEGER II, JJ, LL

      ! 0.3.0 TIME SCALE OF THE LIFE CYCLE OF THE WAVES PARAMETERIZED

      REAL DELTAT

      ! 0.3.1 GRAVITY-WAVES SPECIFICATIONS

      INTEGER JK, JP, JO, JW
      REAL KMIN, KMAX ! Min and Max horizontal wavenumbers
      REAL CMIN, CMAX ! Min and Max absolute ph. vel.
      REAL CPHA ! absolute PHASE VELOCITY frequency
      REAL ZK(KLON, NW) ! Horizontal wavenumber amplitude
      REAL ZP(KLON, NW) ! Horizontal wavenumber angle
      REAL ZO(KLON, NW) ! Absolute frequency !

      ! Waves Intr. freq. at the 1/2 lev surrounding the full level
      REAL ZOM(KLON, NW), ZOP(KLON, NW)

      ! Wave EP-fluxes at the 2 semi levels surrounding the full level
      REAL WWM(KLON, NW), WWP(KLON, NW)

      REAL RUW0(KLON, NW) ! Fluxes at launching level

      REAL RUWP(KLON, NW), RVWP(KLON, NW)
      ! Fluxes X and Y for each waves at 1/2 Levels

      INTEGER LAUNCH, LTROP ! Launching altitude and tropo altitude

      REAL XLAUNCH ! Controle the launching altitude
      REAL XTROP ! SORT of Tropopause altitude
      REAL RUW(KLON, KLEV + 1) ! Flux x at semi levels
      REAL RVW(KLON, KLEV + 1) ! Flux y at semi levels

      REAL PRMAX ! Maximum value of PREC, and for which our linear formula
      ! for GWs parameterisation apply

      ! 0.3.2 PARAMETERS OF WAVES DISSIPATIONS

      REAL RDISS, ZOISEC ! COEFF DE DISSIPATION, SECURITY FOR INTRINSIC FREQ
      REAL CORSEC ! SECURITY FOR INTRINSIC CORIOLIS
      REAL RUWFRT, SATFRT

      ! 0.3.3 BACKGROUND FLOW AT 1/2 LEVELS AND VERTICAL COORDINATE

      REAL H0 ! Characteristic Height of the atmosphere
      REAL DZ ! Characteristic depth of the source!
      REAL PR, TR ! Reference Pressure and Temperature

      REAL ZH(KLON, KLEV + 1) ! Log-pressure altitude

      REAL UH(KLON, KLEV + 1), VH(KLON, KLEV + 1) ! Winds at 1/2 levels
      REAL PH(KLON, KLEV + 1) ! Pressure at 1/2 levels
      REAL PSEC ! Security to avoid division by 0 pressure
      REAL PHM1(KLON, KLEV + 1) ! 1/Press at 1/2 levels
      REAL BV(KLON, KLEV + 1) ! Brunt Vaisala freq. (BVF) at 1/2 levels
      REAL BVSEC ! Security to avoid negative BVF

      REAL, DIMENSION(klev + 1) ::HREF

      CHARACTER(LEN=20), PARAMETER :: modname = 'acama_gwd_rando_m'
      CHARACTER(LEN=80) :: abort_message

      !-----------------------------------------------------------------

      ! 1. INITIALISATIONS

      ! 1.1 Basic parameter

      ! Are provided from elsewhere (latent heat of vaporization, dry
      ! gaz constant for air, gravity constant, heat capacity of dry air
      ! at constant pressure, earth rotation rate, pi).

      ! 1.2 Tuning parameters of V14

! Values for linear in rot (recommended):
!   RUWFRT=0.005 ! As RUWMAX but for frontal waves
!   SATFRT=1.00  ! As SAT    but for frontal waves
! Values when rot^2 is used
!    RUWFRT=0.02  ! As RUWMAX but for frontal waves
!    SATFRT=1.00  ! As SAT    but for frontal waves
!    CMAX = 30.   ! Characteristic phase speed
! Values when rot^2*EXP(-pi*sqrt(J)) is used
!   RUWFRT=2.5   ! As RUWMAX but for frontal waves ~ N0*F0/4*DZ
!   SATFRT=0.60   ! As SAT    but for frontal waves
      RUWFRT = gwd_front_ruwmax
      SATFRT = gwd_front_sat
      CMAX = 50.    ! Characteristic phase speed
! Phase speed test
!   RUWFRT=0.01
!   CMAX = 50.   ! Characteristic phase speed (TEST)
! Values when rot^2 and exp(-m^2*dz^2) are used
!   RUWFRT=0.03  ! As RUWMAX but for frontal waves
!   SATFRT=1.00  ! As SAT    but for frontal waves
! CRUCIAL PARAMETERS FOR THE WIND FILTERING
      XLAUNCH = 0.95 ! Parameter that control launching altitude
      RDISS = 0.5  ! Diffusion parameter

      ! maximum of rain for which our theory applies (in kg/m^2/s)

      DZ = 1000. ! Characteristic depth of the source
      XTROP = 0.2 ! Parameter that control tropopause altitude
      DELTAT = 24.*3600. ! Time scale of the waves (first introduced in 9b)
!   DELTAT=DTIME     ! No AR-1 Accumulation, OR OFFLINE

      KMIN = 2.E-5
      ! minimum horizontal wavenumber (inverse of the subgrid scale resolution)

      KMAX = 1.E-3  ! Max horizontal wavenumber
      CMIN = 1.     ! Min phase velocity

      TR = 240. ! Reference Temperature
      PR = 101300. ! Reference pressure
      H0 = RD*TR/RG ! Characteristic vertical scale height

      BVSEC = 5.E-3 ! Security to avoid negative BVF
      PSEC = 1.E-6 ! Security to avoid division by 0 pressure
      ZOISEC = 1.E-6 ! Security FOR 0 INTRINSIC FREQ
      CORSEC = ROMEGA*2.*SIN(2.*RPI/180.)! Security for CORIO

!  ONLINE
      call assert(klon == (/size(pp, 1), size(tt, 1), size(uu, 1), &
                            size(vv, 1), size(rot, 1), size(zustr), size(zvstr), size(d_u, 1), &
                            size(d_v, 1), &
                            size(east_gwstress, 1), size(west_gwstress, 1)/), &
                  "ACAMA_GWD_RANDO klon")
      call assert(klev == (/size(pp, 2), size(tt, 2), size(uu, 2), &
                            size(vv, 2), size(d_u, 2), size(d_v, 2), &
                            size(east_gwstress, 2), size(west_gwstress, 2)/), &
                  "ACAMA_GWD_RANDO klev")
!  END ONLINE

      IF (DELTAT < DTIME) THEN
!       PRINT *, 'flott_gwd_rando: deltat < dtime!'
!       STOP 1
         abort_message = ' deltat < dtime! '
         CALL abort_physic(modname, abort_message, 1)
      END IF

      IF (KLEV < NW) THEN
!       PRINT *, 'flott_gwd_rando: you will have problem with random numbers'
!       STOP 1
         abort_message = ' you will have problem with random numbers'
         CALL abort_physic(modname, abort_message, 1)
      END IF

      ! 2. EVALUATION OF THE BACKGROUND FLOW AT SEMI-LEVELS

      ! Pressure and Inv of pressure
      DO LL = 2, KLEV
         PH(:, LL) = EXP((LOG(PP(:, LL)) + LOG(PP(:, LL - 1)))/2.)
         PHM1(:, LL) = 1./PH(:, LL)
      end DO

      PH(:, KLEV + 1) = 0.
      PHM1(:, KLEV + 1) = 1./PSEC
      PH(:, 1) = 2.*PP(:, 1) - PH(:, 2)

      ! Launching altitude

      IF (gwd_reproductibilite_mpiomp) THEN
         ! Reprend la formule qui calcule PH en fonction de PP=play
         DO LL = 2, KLEV
            HREF(LL) = EXP((LOG(presnivs(LL)) + LOG(presnivs(LL - 1)))/2.)
         end DO
         HREF(KLEV + 1) = 0.
         HREF(1) = 2.*presnivs(1) - HREF(2)
      ELSE
         HREF(1:KLEV) = PH(KLON/2, 1:KLEV)
      END IF

      LAUNCH = 0
      LTROP = 0
      DO LL = 1, KLEV
         IF (HREF(LL)/HREF(1) > XLAUNCH) LAUNCH = LL
      END DO
      DO LL = 1, KLEV
         IF (HREF(LL)/HREF(1) > XTROP) LTROP = LL
      END DO

      ! Log pressure vert. coordinate
      DO LL = 1, KLEV + 1
         ZH(:, LL) = H0*LOG(PR/(PH(:, LL) + PSEC))
      end DO

      ! BV frequency
      DO LL = 2, KLEV
         ! BVSEC: BV Frequency (UH USED IS AS A TEMPORARY ARRAY DOWN TO WINDS)
         UH(:, LL) = 0.5*(TT(:, LL) + TT(:, LL - 1)) &
                     *RD**2/RCPD/H0**2 + (TT(:, LL) &
                                          - TT(:, LL - 1))/(ZH(:, LL) - ZH(:, LL - 1))*RD/H0
      end DO
      BVLOW(:) = 0.5*(TT(:, LTROP) + TT(:, LAUNCH)) &
                 *RD**2/RCPD/H0**2 + (TT(:, LTROP) &
                                      - TT(:, LAUNCH))/(ZH(:, LTROP) - ZH(:, LAUNCH))*RD/H0

      UH(:, 1) = UH(:, 2)
      UH(:, KLEV + 1) = UH(:, KLEV)
      BV(:, 1) = UH(:, 2)
      BV(:, KLEV + 1) = UH(:, KLEV)
      ! SMOOTHING THE BV HELPS
      DO LL = 2, KLEV
         BV(:, LL) = (UH(:, LL + 1) + 2.*UH(:, LL) + UH(:, LL - 1))/4.
      end DO

      BV = MAX(SQRT(MAX(BV, 0.)), BVSEC)
      BVLOW = MAX(SQRT(MAX(BVLOW, 0.)), BVSEC)

      ! WINDS
      DO LL = 2, KLEV
         UH(:, LL) = 0.5*(UU(:, LL) + UU(:, LL - 1)) ! Zonal wind
         VH(:, LL) = 0.5*(VV(:, LL) + VV(:, LL - 1)) ! Meridional wind
         UZ(:, LL) = ABS((SQRT(UU(:, LL)**2 + VV(:, LL)**2) &
                          - SQRT(UU(:, LL - 1)**2 + VV(:, LL - 1)**2)) &
                         /(ZH(:, LL) - ZH(:, LL - 1)))
      end DO
      UH(:, 1) = 0.
      VH(:, 1) = 0.
      UH(:, KLEV + 1) = UU(:, KLEV)
      VH(:, KLEV + 1) = VV(:, KLEV)

      UZ(:, 1) = UZ(:, 2)
      UZ(:, KLEV + 1) = UZ(:, KLEV)
      UZ(:, :) = MAX(UZ(:, :), PSEC)

      ! BAROTROPIC VORTICITY AND INTEGRATED CORIOLIS PARAMETER

      CORIO(:) = MAX(ROMEGA*2.*ABS(SIN(PLAT(:)*RPI/180.)), CORSEC)
      ROTBA(:) = 0.
      DO LL = 1, KLEV - 1
         !ROTBA(:) = ROTBA(:) + (ROT(:,LL)+ROT(:,LL+1))/2./RG*(PP(:,LL)-PP(:,LL+1))
         ! Introducing the complete formula (exp of Richardson number):
         ROTBA(:) = ROTBA(:) + &
                    !((ROT(:,LL)+ROT(:,LL+1))/2.)**2 &
                    (CORIO(:)*TANH(ABS(ROT(:, LL) + ROT(:, LL + 1))/2./CORIO(:)))**2 &
                    /RG*(PP(:, LL) - PP(:, LL + 1)) &
                    *EXP(-RPI*BV(:, LL + 1)/UZ(:, LL + 1)) &
                    !               * DZ*BV(:,LL+1)/4./ABS(CORIO(:))
                    *DZ*BV(:, LL + 1)/4./1.E-4           !  Changes after 1991
!ARRET
      END DO
      !   PRINT *,'MAX ROTBA:',MAXVAL(ROTBA)
      !   ROTBA(:)=(1.*ROTBA(:)  & ! Testing zone
      !           +0.15*CORIO(:)**2                &
      !           /(COS(PLAT(:)*RPI/180.)+0.02)  &
      !           )*DZ*0.01/0.0001/4. ! & ! Testing zone
      !   MODIF GWD4 AFTER 1985
      !            *(1.25+SIN(PLAT(:)*RPI/180.))/(1.05+SIN(PLAT(:)*RPI/180.))/1.25
      !          *1./(COS(PLAT(:)*RPI/180.)+0.02)
      !    CORIO(:) = MAX(ROMEGA*2.*ABS(SIN(PLAT(:)*RPI/180.)),ZOISEC)/RG*PP(:,1)

      ! 3 WAVES CHARACTERISTICS CHOSEN RANDOMLY AT THE LAUNCH ALTITUDE

      ! The mod functions of weird arguments are used to produce the
      ! waves characteristics in an almost stochastic way

      JW = 0
      DO JW = 1, NW
         ! Angle
         DO II = 1, KLON
            ! Angle (0 or PI so far)
            ! ZP(II,JW) = (SIGN(1., 0.5 - MOD(TT(II, JW) * 10., 1.)) + 1.) &
            !      * RPI / 2.
            ! Angle between 0 and pi
            ZP(II, JW) = MOD(TT(II, JW)*10., 1.)*RPI
! TEST WITH POSITIVE WAVES ONLY (Part I/II)
!               ZP(II,JW) = 0.
            ! Horizontal wavenumber amplitude
            ZK(II, JW) = KMIN + (KMAX - KMIN)*MOD(TT(II, JW)*100., 1.)
            ! Horizontal phase speed
            CPHA = 0.
            DO JJ = 1, NA
               CPHA = CPHA + &
                      CMAX*2.*(MOD(TT(II, JW + 4*(JJ - 1) + JJ)**2, 1.) - 0.5)*SQRT(3.)/SQRT(NA*1.)
            END DO
            IF (CPHA .LT. 0.) THEN
               CPHA = -1.*CPHA
               ZP(II, JW) = ZP(II, JW) + RPI
! TEST WITH POSITIVE WAVES ONLY (Part II/II)
!               ZP(II,JW) = 0.
            END IF
            CPHA = CPHA + CMIN !we dont allow |c|<1m/s
            ! Absolute frequency is imposed
            ZO(II, JW) = CPHA*ZK(II, JW)
            ! Intrinsic frequency is imposed
            ZO(II, JW) = ZO(II, JW) &
                         + ZK(II, JW)*COS(ZP(II, JW))*UH(II, LAUNCH) &
                         + ZK(II, JW)*SIN(ZP(II, JW))*VH(II, LAUNCH)
            ! Momentum flux at launch lev
            ! LAUNCHED RANDOM WAVES WITH LOG-NORMAL AMPLITUDE
            !  RIGHT IN THE SH (GWD4 after 1990)
            RUW0(II, JW) = 0.
            DO JJ = 1, NA
               RUW0(II, JW) = RUW0(II, JW) + &
                              2.*(MOD(TT(II, JW + 4*(JJ - 1) + JJ)**2, 1.) - 0.5)*SQRT(3.)/SQRT(NA*1.)
            END DO
            RUW0(II, JW) = RUWFRT &
                           *EXP(RUW0(II, JW))/1250. &  ! 2 mpa at south pole
                           *((1.05 + SIN(PLAT(II)*RPI/180.))/(1.01 + SIN(PLAT(II)*RPI/180.)) - 2.05/2.01)
            ! RUW0(II,JW) = RUWFRT
         END DO
      end DO

      ! 4. COMPUTE THE FLUXES

      ! 4.0

      ! 4.1 Vertical velocity at launching altitude to ensure
      ! the correct value to the imposed fluxes.

      DO JW = 1, NW

         ! Evaluate intrinsic frequency at launching altitude:
         ZOP(:, JW) = ZO(:, JW) &
                      - ZK(:, JW)*COS(ZP(:, JW))*UH(:, LAUNCH) &
                      - ZK(:, JW)*SIN(ZP(:, JW))*VH(:, LAUNCH)

         ! VERSION WITH FRONTAL SOURCES

         ! Momentum flux at launch level imposed by vorticity sources

         ! tanh limitation for values above CORIO (inertial instability).
         ! WWP(:,JW) = RUW0(:,JW) &
         WWP(:, JW) = RUWFRT &
                      !     * (CORIO(:)*TANH(ROTBA(:)/CORIO(:)))**2 &
                      !    * ABS((CORIO(:)*TANH(ROTBA(:)/CORIO(:)))*CORIO(:)) &
                      !  CONSTANT FLUX
                      !    * (CORIO(:)*CORIO(:)) &
                      ! MODERATION BY THE DEPTH OF THE SOURCE (DZ HERE)
                      !      *EXP(-BVLOW(:)**2/MAX(ABS(ZOP(:,JW)),ZOISEC)**2 &
                      !      *ZK(:,JW)**2*DZ**2) &
                      ! COMPLETE FORMULA:
                      !* CORIO(:)**2*TANH(ROTBA(:)/CORIO(:)**2) &
                      *ROTBA(:) &
                      !  RESTORE DIMENSION OF A FLUX
                      !     *RD*TR/PR
                      !     *1. + RUW0(:,JW)
                      *1.

         ! Factor related to the characteristics of the waves: NONE

         ! Moderation by the depth of the source (dz here): NONE

         ! Put the stress in the right direction:

         RUWP(:, JW) = SIGN(1., ZOP(:, JW))*COS(ZP(:, JW))*WWP(:, JW)
         RVWP(:, JW) = SIGN(1., ZOP(:, JW))*SIN(ZP(:, JW))*WWP(:, JW)

      end DO

      ! 4.2 Uniform values below the launching altitude

      DO LL = 1, LAUNCH
         RUW(:, LL) = 0
         RVW(:, LL) = 0
         DO JW = 1, NW
            RUW(:, LL) = RUW(:, LL) + RUWP(:, JW)
            RVW(:, LL) = RVW(:, LL) + RVWP(:, JW)
         end DO
      end DO

      ! 4.3 Loop over altitudes, with passage from one level to the next
      ! done by i) conserving the EP flux, ii) dissipating a little,
      ! iii) testing critical levels, and vi) testing the breaking.

      DO LL = LAUNCH, KLEV - 1
         ! Warning: all the physics is here (passage from one level
         ! to the next)
         DO JW = 1, NW
            ZOM(:, JW) = ZOP(:, JW)
            WWM(:, JW) = WWP(:, JW)
            ! Intrinsic Frequency
            ZOP(:, JW) = ZO(:, JW) - ZK(:, JW)*COS(ZP(:, JW))*UH(:, LL + 1) &
                         - ZK(:, JW)*SIN(ZP(:, JW))*VH(:, LL + 1)

            ! No breaking (Eq.6)
            ! Dissipation (Eq. 8)
            WWP(:, JW) = WWM(:, JW)*EXP(-4.*RDISS*PR/(PH(:, LL + 1) &
                                                      + PH(:, LL))*((BV(:, LL + 1) + BV(:, LL))/2.)**3 &
                                        /MAX(ABS(ZOP(:, JW) + ZOM(:, JW))/2., ZOISEC)**4 &
                                        *ZK(:, JW)**3*(ZH(:, LL + 1) - ZH(:, LL)))

            ! Critical levels (forced to zero if intrinsic frequency changes sign)
            ! Saturation (Eq. 12)
            WWP(:, JW) = min(WWP(:, JW), MAX(0., &
                                             SIGN(1., ZOP(:, JW)*ZOM(:, JW)))*ABS(ZOP(:, JW))**3 &
                             !    / BV(:, LL + 1) * EXP(- ZH(:, LL + 1) / H0) * SATFRT**2 * KMIN**2 &
                             /BV(:, LL + 1)*EXP(-ZH(:, LL + 1)/H0)*KMIN**2 &
                             !              *(SATFRT*(2.5+1.5*TANH((ZH(:,LL+1)/H0-8.)/2.)))**2 &
                             *SATFRT**2 &
                             /ZK(:, JW)**4)
         end DO

         ! Evaluate EP-flux from Eq. 7 and give the right orientation to
         ! the stress

         DO JW = 1, NW
            RUWP(:, JW) = SIGN(1., ZOP(:, JW))*COS(ZP(:, JW))*WWP(:, JW)
            RVWP(:, JW) = SIGN(1., ZOP(:, JW))*SIN(ZP(:, JW))*WWP(:, JW)
         end DO

         RUW(:, LL + 1) = 0.
         RVW(:, LL + 1) = 0.

         DO JW = 1, NW
            RUW(:, LL + 1) = RUW(:, LL + 1) + RUWP(:, JW)
            RVW(:, LL + 1) = RVW(:, LL + 1) + RVWP(:, JW)
            EAST_GWSTRESS(:, LL) = EAST_GWSTRESS(:, LL) + MAX(0., RUWP(:, JW))/REAL(NW)
            WEST_GWSTRESS(:, LL) = WEST_GWSTRESS(:, LL) + MIN(0., RUWP(:, JW))/REAL(NW)
         end DO
      end DO

      ! 5 CALCUL DES TENDANCES:

      ! 5.1 Rectification des flux au sommet et dans les basses couches

      RUW(:, KLEV + 1) = 0.
      RVW(:, KLEV + 1) = 0.
      RUW(:, 1) = RUW(:, LAUNCH)
      RVW(:, 1) = RVW(:, LAUNCH)
      DO LL = 1, LAUNCH
         RUW(:, LL) = RUW(:, LAUNCH + 1)
         RVW(:, LL) = RVW(:, LAUNCH + 1)
         EAST_GWSTRESS(:, LL) = EAST_GWSTRESS(:, LAUNCH)
         WEST_GWSTRESS(:, LL) = WEST_GWSTRESS(:, LAUNCH)
      end DO

      ! AR-1 RECURSIVE FORMULA (13) IN VERSION 4
      DO LL = 1, KLEV
         D_U(:, LL) = (1.-DTIME/DELTAT)*D_U(:, LL) + DTIME/DELTAT/REAL(NW)* &
                      RG*(RUW(:, LL + 1) - RUW(:, LL)) &
                      /(PH(:, LL + 1) - PH(:, LL))*DTIME
!  NO AR1 FOR MERIDIONAL TENDENCIES
!      D_V(:, LL) = (1.-DTIME/DELTAT) * D_V(:, LL) + DTIME/DELTAT/REAL(NW) * &
         D_V(:, LL) = 1./REAL(NW)* &
                      RG*(RVW(:, LL + 1) - RVW(:, LL)) &
                      /(PH(:, LL + 1) - PH(:, LL))*DTIME
      END DO

      ! Cosmetic: evaluation of the cumulated stress
      ZUSTR = 0.
      ZVSTR = 0.
      DO LL = 1, KLEV
         ZUSTR = ZUSTR + D_U(:, LL)/RG*(PH(:, LL + 1) - PH(:, LL))/DTIME
!      ZVSTR = ZVSTR + D_V(:, LL) / RG * (PH(:, LL + 1) - PH(:, LL))/DTIME
      END DO
! COSMETICS TO VISUALIZE ROTBA
      ZVSTR = ROTBA

   END SUBROUTINE ACAMA_GWD_RANDO

end module lmdz_gwd_front

! This file has been modified for the use in ICON

!----------------------------------------------------------------------------
SUBROUTINE RRTM_TAUMOL15 (KIDIA,KFDIA,KLEV,taug,&
 & P_TAUAERL,fac00,fac01,fac10,fac11,forfac,forfrac,indfor,jp,jt,jt1,oneminus,&
 & colh2o,colco2,coln2o,laytrop,selffac,selffrac,indself,fracs, &
 & rat_n2oco2, rat_n2oco2_1,minorfrac,indminor,scaleminor,colbrd)  

!     BAND 15:  2380-2600 cm-1 (low - N2O,CO2; high - nothing)

!     AUTHOR.
!     -------
!      JJMorcrette, ECMWF

!     MODIFICATIONS.
!     --------------
!      M.Hamrud      01-Oct-2003 CY28 Cleaning
!      NEC           25-Oct-2007 Optimisations
!      JJMorcrette 20110613 flexible number of g-points
!     ABozzo 2001306 updated to rrtmg v4.85
!     band 15:  2380-2600 cm-1 (low - n2o,co2; low minor - n2)
!                              (high - nothing)
! ---------------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE PARRRTM  , ONLY : JPBAND
USE YOERRTM  , ONLY : JPGPT  ,NGS14  ,NG15
USE YOERRTWN , ONLY : NSPA   
USE YOERRTA15, ONLY : ABSA   ,KA_MN2,FRACREFA,SELFREF,FORREF
USE YOERRTRF, ONLY : CHI_MLS

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KIDIA
INTEGER(KIND=JPIM),INTENT(IN)    :: KFDIA
INTEGER(KIND=JPIM),INTENT(IN)    :: KLEV 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: taug(KIDIA:KFDIA,JPGPT,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: P_TAUAERL(KIDIA:KFDIA,KLEV,JPBAND) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: fac00(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: fac01(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: fac10(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: fac11(KIDIA:KFDIA,KLEV) 
INTEGER(KIND=JPIM),INTENT(IN)    :: jp(KIDIA:KFDIA,KLEV) 
INTEGER(KIND=JPIM),INTENT(IN)    :: jt(KIDIA:KFDIA,KLEV) 
INTEGER(KIND=JPIM),INTENT(IN)    :: jt1(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: oneminus
REAL(KIND=JPRB)   ,INTENT(IN)    :: colh2o(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: colco2(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: coln2o(KIDIA:KFDIA,KLEV) 
INTEGER(KIND=JPIM),INTENT(IN)    :: laytrop(KIDIA:KFDIA) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: selffac(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: selffrac(KIDIA:KFDIA,KLEV) 
INTEGER(KIND=JPIM),INTENT(IN)    :: indself(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: fracs(KIDIA:KFDIA,JPGPT,KLEV) 

REAL(KIND=JPRB)   ,INTENT(IN)   :: rat_n2oco2(KIDIA:KFDIA,KLEV)
REAL(KIND=JPRB)   ,INTENT(IN)   :: rat_n2oco2_1(KIDIA:KFDIA,KLEV)
INTEGER(KIND=JPIM),INTENT(IN)   :: indfor(KIDIA:KFDIA,KLEV)
REAL(KIND=JPRB)   ,INTENT(IN)   :: forfac(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)   :: forfrac(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)   :: minorfrac(KIDIA:KFDIA,KLEV)
INTEGER(KIND=JPIM),INTENT(IN)   :: indminor(KIDIA:KFDIA,KLEV)
REAL(KIND=JPRB)   ,INTENT(IN)    :: scaleminor(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: colbrd(KIDIA:KFDIA,KLEV)         
! ---------------------------------------------------------------------------

INTEGER(KIND=JPIM) :: IG, IND0, IND1, INDS,INDF,INDM, JS,JS1,JPL,JMN2, lay
REAL(KIND=JPRB) :: refrat_planck_a, refrat_m_a
REAL(KIND=JPRB) :: taufor,tauself,tau_major(ng15),tau_major1(ng15), n2m1, n2m2, taun2,scalen2
REAL(KIND=JPRB) ::  fac000, fac100, fac200,&
 & fac010, fac110, fac210, &
 & fac001, fac101, fac201, &
 & fac011, fac111, fac211
REAL(KIND=JPRB) :: p, p4, fk0, fk1, fk2

REAL(KIND=JPRB) :: fs, specmult, specparm,speccomb,  &
& fs1, specmult1, specparm1,speccomb1, &
& fmn2, specmult_mn2, specparm_mn2,speccomb_mn2, &
& fpl, specmult_planck, specparm_planck,speccomb_planck
    !     local integer arrays
    INTEGER(KIND=JPIM) :: laytrop_min, laytrop_max
    integer(KIND=JPIM) :: ixc(KLEV), ixlow(KFDIA,KLEV), ixhigh(KFDIA,KLEV)
    INTEGER(KIND=JPIM) :: ich, icl, ixc0, ixp, jc, jl

#define MOD1(x) ((x) - AINT((x)))

    !$ACC DATA PRESENT(taug, P_TAUAERL, fac00, fac01, fac10, fac11, jp, jt, jt1, &
    !$ACC             colh2o,  colco2,  coln2o,  laytrop, selffac, selffrac, &
    !$ACC             indself, fracs, rat_n2oco2, rat_n2oco2_1, indfor, forfac, &
    !$ACC             forfrac, minorfrac, indminor, scaleminor, colbrd)

#ifndef _OPENACC
    laytrop_min = MINVAL(laytrop)
    laytrop_max = MAXVAL(laytrop)

    ixlow  = 0
    ixhigh = 0
    ixc    = 0

    ! create index lists for mixed layers
    do lay = laytrop_min+1, laytrop_max
      icl = 0
      ich = 0
      do jc = KIDIA, KFDIA
        if ( lay <= laytrop(jc) ) then
          icl = icl + 1
          ixlow(icl,lay) = jc
        else
          ich = ich + 1
          ixhigh(ich,lay) = jc
        endif
      enddo
      ixc(lay) = icl
    enddo
#else
    laytrop_min = HUGE(laytrop_min) 
    laytrop_max = -HUGE(laytrop_max)
    !$ACC PARALLEL DEFAULT(NONE) ASYNC(1)
    !$ACC LOOP GANG VECTOR REDUCTION(min:laytrop_min) REDUCTION(max:laytrop_max)
    do jc = KIDIA,KFDIA
      laytrop_min = MIN(laytrop_min, laytrop(jc))
      laytrop_max = MAX(laytrop_max, laytrop(jc))
    end do
    !$ACC END PARALLEL
#endif

      ! Minor gas mapping level :
      !     Lower - Nitrogen Continuum, P = 1053., T = 294.

      ! Calculate reference ratio to be used in calculation of Planck
      ! fraction in lower atmosphere.
      ! P = 1053. mb (Level 1)
      refrat_planck_a = chi_mls(4,1)/chi_mls(2,1)

      ! P = 1053.
      refrat_m_a = chi_mls(4,1)/chi_mls(2,1)

      ! Compute the optical depth by interpolating in ln(pressure),
      ! temperature, and appropriate species.  Below laytrop, the water
      ! vapor self-continuum and foreign continuum is interpolated
      ! (in temperature) separately.

      ! Lower atmosphere loop
      !$ACC WAIT
      !$ACC PARALLEL DEFAULT(NONE) ASYNC(1)
      !$ACC LOOP GANG VECTOR COLLAPSE(2) &
      !$ACC   PRIVATE(ind0, ind1, inds, indf, indm, &
      !$ACC           js, js1, jpl, jmn2, &
      !$ACC           fac000, fac100, fac200, &
      !$ACC           fac010, fac110, fac210, &
      !$ACC           fac001, fac101, fac201, &
      !$ACC           fac011, fac111, fac211, &
      !$ACC           p, p4, fk0, fk1, fk2, scalen2, &
      !$ACC           fs, specmult, specparm,speccomb,  &
      !$ACC           fs1, specmult1, specparm1,speccomb1, &
      !$ACC           fmn2, specmult_mn2, specparm_mn2,speccomb_mn2, &
      !$ACC           fpl, specmult_planck, &
      !$ACC           specparm_planck,speccomb_planck, &
      !$ACC           tau_major, tau_major1)
      do lay = 1, laytrop_min
        do jl = KIDIA, KFDIA

          speccomb = coln2o(jl,lay) + rat_n2oco2(jl,lay)*colco2(jl,lay)
          specparm = MIN(coln2o(jl,lay)/speccomb,oneminus)
          specmult = 8._JPRB*(specparm)
          js = 1 + int(specmult)
          fs = MOD1(specmult)

          speccomb1 = coln2o(jl,lay) + rat_n2oco2_1(jl,lay)*colco2(jl,lay)
          specparm1 = MIN(coln2o(jl,lay)/speccomb1,oneminus)
          specmult1 = 8._JPRB*(specparm1)
          js1 = 1 + int(specmult1)
          fs1 = MOD1(specmult1)

          speccomb_mn2 = coln2o(jl,lay) + refrat_m_a*colco2(jl,lay)
          specparm_mn2 = MIN(coln2o(jl,lay)/speccomb_mn2,oneminus)
          specmult_mn2 = 8._JPRB*specparm_mn2
          jmn2 = 1 + int(specmult_mn2)
          fmn2 = MOD1(specmult_mn2)

          speccomb_planck = coln2o(jl,lay)+refrat_planck_a*colco2(jl,lay)
          specparm_planck = MIN(coln2o(jl,lay)/speccomb_planck,oneminus)
          specmult_planck = 8._JPRB*specparm_planck
          jpl = 1 + int(specmult_planck)
          fpl = MOD1(specmult_planck)

          ind0 = ((jp(jl,lay)-1)*5+(jt(jl,lay)-1))*nspa(15) + js
          ind1 = (jp(jl,lay)*5+(jt1(jl,lay)-1))*nspa(15) + js1
          inds = indself(jl,lay)
          indf = indfor(jl,lay)
          indm = indminor(jl,lay)

          scalen2 = colbrd(jl,lay)*scaleminor(jl,lay)

          if (specparm .lt. 0.125_JPRB) then
            p = fs - 1._JPRB
            p4 = p**4
            fk0 = p4
            fk1 = 1._JPRB - p - 2.0_JPRB*p4
            fk2 = p + p4
            fac000 = fk0*fac00(jl,lay)
            fac100 = fk1*fac00(jl,lay)
            fac200 = fk2*fac00(jl,lay)
            fac010 = fk0*fac10(jl,lay)
            fac110 = fk1*fac10(jl,lay)
            fac210 = fk2*fac10(jl,lay)
          else if (specparm .gt. 0.875_JPRB) then
            p = -fs
            p4 = p**4
            fk0 = p4
            fk1 = 1._JPRB - p - 2.0_JPRB*p4
            fk2 = p + p4
            fac000 = fk0*fac00(jl,lay)
            fac100 = fk1*fac00(jl,lay)
            fac200 = fk2*fac00(jl,lay)
            fac010 = fk0*fac10(jl,lay)
            fac110 = fk1*fac10(jl,lay)
            fac210 = fk2*fac10(jl,lay)
          else
            fac000 = (1._JPRB - fs) * fac00(jl,lay)
            fac010 = (1._JPRB - fs) * fac10(jl,lay)
            fac100 = fs * fac00(jl,lay)
            fac110 = fs * fac10(jl,lay)
            fac200 = 0._JPRB
            fac210 = 0._JPRB
          endif

          if (specparm1 .lt. 0.125_JPRB) then
            p = fs1 - 1._JPRB
            p4 = p**4
            fk0 = p4
            fk1 = 1._JPRB - p - 2.0_JPRB*p4
            fk2 = p + p4
            fac001 = fk0*fac01(jl,lay)
            fac101 = fk1*fac01(jl,lay)
            fac201 = fk2*fac01(jl,lay)
            fac011 = fk0*fac11(jl,lay)
            fac111 = fk1*fac11(jl,lay)
            fac211 = fk2*fac11(jl,lay)
          else if (specparm1 .gt. 0.875_JPRB) then
            p = -fs1
            p4 = p**4
            fk0 = p4
            fk1 = 1._JPRB - p - 2.0_JPRB*p4
            fk2 = p + p4
            fac001 = fk0*fac01(jl,lay)
            fac101 = fk1*fac01(jl,lay)
            fac201 = fk2*fac01(jl,lay)
            fac011 = fk0*fac11(jl,lay)
            fac111 = fk1*fac11(jl,lay)
            fac211 = fk2*fac11(jl,lay)
          else
            fac001 = (1._JPRB - fs1) * fac01(jl,lay)
            fac011 = (1._JPRB - fs1) * fac11(jl,lay)
            fac101 = fs1 * fac01(jl,lay)
            fac111 = fs1 * fac11(jl,lay)
            fac201 = 0._JPRB
            fac211 = 0._JPRB
          endif

          if (specparm .lt. 0.125_JPRB) then
!$NEC unroll(NG15)
            tau_major(1:ng15) = speccomb *    &
             (fac000 * absa(ind0,1:ng15)    + &
              fac100 * absa(ind0+1,1:ng15)  + &
              fac200 * absa(ind0+2,1:ng15)  + &
              fac010 * absa(ind0+9,1:ng15)  + &
              fac110 * absa(ind0+10,1:ng15) + &
              fac210 * absa(ind0+11,1:ng15))
          else if (specparm .gt. 0.875_JPRB) then
!$NEC unroll(NG15)
            tau_major(1:ng15) = speccomb *   &
             (fac200 * absa(ind0-1,1:ng15) + &
              fac100 * absa(ind0,1:ng15)   + &
              fac000 * absa(ind0+1,1:ng15) + &
              fac210 * absa(ind0+8,1:ng15) + &
              fac110 * absa(ind0+9,1:ng15) + &
              fac010 * absa(ind0+10,1:ng15))
          else
!$NEC unroll(NG15)
            tau_major(1:ng15) = speccomb *   &
             (fac000 * absa(ind0,1:ng15)   + &
              fac100 * absa(ind0+1,1:ng15) + &
              fac010 * absa(ind0+9,1:ng15) + &
              fac110 * absa(ind0+10,1:ng15))
          endif

          if (specparm1 .lt. 0.125_JPRB) then
!$NEC unroll(NG15)
            tau_major1(1:ng15) = speccomb1 *  &
             (fac001 * absa(ind1,1:ng15)    + &
              fac101 * absa(ind1+1,1:ng15)  + &
              fac201 * absa(ind1+2,1:ng15)  + &
              fac011 * absa(ind1+9,1:ng15)  + &
              fac111 * absa(ind1+10,1:ng15) + &
              fac211 * absa(ind1+11,1:ng15))
          else if (specparm1 .gt. 0.875_JPRB) then
!$NEC unroll(NG15)
            tau_major1(1:ng15) = speccomb1 * &
             (fac201 * absa(ind1-1,1:ng15) + &
              fac101 * absa(ind1,1:ng15)   + &
              fac001 * absa(ind1+1,1:ng15) + &
              fac211 * absa(ind1+8,1:ng15) + &
              fac111 * absa(ind1+9,1:ng15) + &
              fac011 * absa(ind1+10,1:ng15))
          else
!$NEC unroll(NG15)
            tau_major1(1:ng15) = speccomb1 * &
             (fac001 * absa(ind1,1:ng15)   + &
              fac101 * absa(ind1+1,1:ng15) + &
              fac011 * absa(ind1+9,1:ng15) + &
              fac111 * absa(ind1+10,1:ng15))
          endif

          !$ACC LOOP SEQ PRIVATE(taufor, tauself, n2m1, n2m2, taun2)
!$NEC unroll(NG15)
          do ig = 1, ng15
            tauself = selffac(jl,lay)* (selfref(inds,ig) + selffrac(jl,lay) * &
                 (selfref(inds+1,ig) - selfref(inds,ig)))
            taufor =  forfac(jl,lay) * (forref(indf,ig) + forfrac(jl,lay) * &
                 (forref(indf+1,ig) - forref(indf,ig)))
            n2m1 = ka_mn2(jmn2,indm,ig) + fmn2 * &
                 (ka_mn2(jmn2+1,indm,ig) - ka_mn2(jmn2,indm,ig))
            n2m2 = ka_mn2(jmn2,indm+1,ig) + fmn2 * &
                 (ka_mn2(jmn2+1,indm+1,ig) - ka_mn2(jmn2,indm+1,ig))
            taun2 = scalen2 * (n2m1 + minorfrac(jl,lay) * (n2m2 - n2m1))

            taug(jl,ngs14+ig,lay) = tau_major(ig) + tau_major1(ig) &
                 + tauself + taufor &
                 + taun2
            fracs(jl,ngs14+ig,lay) = fracrefa(ig,jpl) + fpl * &
                 (fracrefa(ig,jpl+1)-fracrefa(ig,jpl))
          enddo
        enddo
      enddo
      !$ACC END PARALLEL

      ! Upper atmosphere loop
      !$ACC PARALLEL DEFAULT(NONE) ASYNC(1)
      !$ACC LOOP GANG VECTOR COLLAPSE(3)
      do ig = 1, ng15
        do lay = laytrop_max+1, KLEV
          do jl = KIDIA, KFDIA
            taug(jl,ngs14+ig,lay) = 0.0_JPRB
            fracs(jl,ngs14+ig,lay) = 0.0_JPRB
          enddo
        enddo
      enddo
      !$ACC END PARALLEL

      IF (laytrop_max /= laytrop_min) THEN
        ! Mixed loop
        ! Lower atmosphere part
        !$ACC PARALLEL DEFAULT(NONE) ASYNC(1)
        !$ACC LOOP GANG VECTOR COLLAPSE(2) PRIVATE(speccomb, specparm, specmult, js, fs, speccomb1, specparm1, &
        !$ACC   specmult1, js1, fs1, speccomb_mn2, specparm_mn2, specmult_mn2, jmn2, fmn2, scalen2, speccomb_planck, &
        !$ACC   specparm_planck, specmult_planck, jpl, fpl, ind0, ind1, inds, indf, indm, p, p4, fk0, fk1, fk2, &
        !$ACC   fac000, fac100, fac200, fac010, fac110, fac210, fac001, fac101, fac201, fac011, fac111, fac211, &
        !$ACC   tau_major, tau_major1)
        do lay = laytrop_min+1, laytrop_max
#ifdef _OPENACC
          do jl = KIDIA, KFDIA
            if ( lay <= laytrop(jl) ) then
#else
          ixc0 = ixc(lay)

!$NEC ivdep
          do ixp = 1, ixc0
            jl = ixlow(ixp,lay)
#endif

            speccomb = coln2o(jl,lay) + rat_n2oco2(jl,lay)*colco2(jl,lay)
            specparm = MIN(coln2o(jl,lay)/speccomb,oneminus)
            specmult = 8._JPRB*(specparm)
            js = 1 + int(specmult)
            fs = MOD1(specmult)

            speccomb1 = coln2o(jl,lay) + rat_n2oco2_1(jl,lay)*colco2(jl,lay)
            specparm1 = MIN(coln2o(jl,lay)/speccomb1,oneminus)
            specmult1 = 8._JPRB*(specparm1)
            js1 = 1 + int(specmult1)
            fs1 = MOD1(specmult1)

            speccomb_mn2 = coln2o(jl,lay) + refrat_m_a*colco2(jl,lay)
            specparm_mn2 = MIN(coln2o(jl,lay)/speccomb_mn2,oneminus)
            specmult_mn2 = 8._JPRB*specparm_mn2
            jmn2 = 1 + int(specmult_mn2)
            fmn2 = MOD1(specmult_mn2)

            speccomb_planck = coln2o(jl,lay)+refrat_planck_a*colco2(jl,lay)
            specparm_planck = MIN(coln2o(jl,lay)/speccomb_planck,oneminus)
            specmult_planck = 8._JPRB*specparm_planck
            jpl = 1 + int(specmult_planck)
            fpl = MOD1(specmult_planck)

            ind0 = ((jp(jl,lay)-1)*5+(jt(jl,lay)-1))*nspa(15) + js
            ind1 = (jp(jl,lay)*5+(jt1(jl,lay)-1))*nspa(15) + js1
            inds = indself(jl,lay)
            indf = indfor(jl,lay)
            indm = indminor(jl,lay)

            scalen2 = colbrd(jl,lay)*scaleminor(jl,lay)

            if (specparm .lt. 0.125_JPRB) then
              p = fs - 1._JPRB
              p4 = p**4
              fk0 = p4
              fk1 = 1._JPRB - p - 2.0_JPRB*p4
              fk2 = p + p4
              fac000 = fk0*fac00(jl,lay)
              fac100 = fk1*fac00(jl,lay)
              fac200 = fk2*fac00(jl,lay)
              fac010 = fk0*fac10(jl,lay)
              fac110 = fk1*fac10(jl,lay)
              fac210 = fk2*fac10(jl,lay)
            else if (specparm .gt. 0.875_JPRB) then
              p = -fs
              p4 = p**4
              fk0 = p4
              fk1 = 1._JPRB - p - 2.0_JPRB*p4
              fk2 = p + p4
              fac000 = fk0*fac00(jl,lay)
              fac100 = fk1*fac00(jl,lay)
              fac200 = fk2*fac00(jl,lay)
              fac010 = fk0*fac10(jl,lay)
              fac110 = fk1*fac10(jl,lay)
              fac210 = fk2*fac10(jl,lay)
            else
              fac000 = (1._JPRB - fs) * fac00(jl,lay)
              fac010 = (1._JPRB - fs) * fac10(jl,lay)
              fac100 = fs * fac00(jl,lay)
              fac110 = fs * fac10(jl,lay)
              fac200 = 0._JPRB
              fac210 = 0._JPRB
            endif

            if (specparm1 .lt. 0.125_JPRB) then
              p = fs1 - 1._JPRB
              p4 = p**4
              fk0 = p4
              fk1 = 1._JPRB - p - 2.0_JPRB*p4
              fk2 = p + p4
              fac001 = fk0*fac01(jl,lay)
              fac101 = fk1*fac01(jl,lay)
              fac201 = fk2*fac01(jl,lay)
              fac011 = fk0*fac11(jl,lay)
              fac111 = fk1*fac11(jl,lay)
              fac211 = fk2*fac11(jl,lay)
            else if (specparm1 .gt. 0.875_JPRB) then
              p = -fs1
              p4 = p**4
              fk0 = p4
              fk1 = 1._JPRB - p - 2.0_JPRB*p4
              fk2 = p + p4
              fac001 = fk0*fac01(jl,lay)
              fac101 = fk1*fac01(jl,lay)
              fac201 = fk2*fac01(jl,lay)
              fac011 = fk0*fac11(jl,lay)
              fac111 = fk1*fac11(jl,lay)
              fac211 = fk2*fac11(jl,lay)
            else
              fac001 = (1._JPRB - fs1) * fac01(jl,lay)
              fac011 = (1._JPRB - fs1) * fac11(jl,lay)
              fac101 = fs1 * fac01(jl,lay)
              fac111 = fs1 * fac11(jl,lay)
              fac201 = 0._JPRB
              fac211 = 0._JPRB
            endif

            if (specparm .lt. 0.125_JPRB) then
!$NEC unroll(NG15)
              tau_major(1:ng15) = speccomb *    &
              (fac000 * absa(ind0,1:ng15)    + &
                fac100 * absa(ind0+1,1:ng15)  + &
                fac200 * absa(ind0+2,1:ng15)  + &
                fac010 * absa(ind0+9,1:ng15)  + &
                fac110 * absa(ind0+10,1:ng15) + &
                fac210 * absa(ind0+11,1:ng15))
            else if (specparm .gt. 0.875_JPRB) then
!$NEC unroll(NG15)
              tau_major(1:ng15) = speccomb *   &
              (fac200 * absa(ind0-1,1:ng15) + &
                fac100 * absa(ind0,1:ng15)   + &
                fac000 * absa(ind0+1,1:ng15) + &
                fac210 * absa(ind0+8,1:ng15) + &
                fac110 * absa(ind0+9,1:ng15) + &
                fac010 * absa(ind0+10,1:ng15))
            else
!$NEC unroll(NG15)
              tau_major(1:ng15) = speccomb *   &
              (fac000 * absa(ind0,1:ng15)   + &
                fac100 * absa(ind0+1,1:ng15) + &
                fac010 * absa(ind0+9,1:ng15) + &
                fac110 * absa(ind0+10,1:ng15))
            endif

            if (specparm1 .lt. 0.125_JPRB) then
!$NEC unroll(NG15)
              tau_major1(1:ng15) = speccomb1 *  &
              (fac001 * absa(ind1,1:ng15)    + &
                fac101 * absa(ind1+1,1:ng15)  + &
                fac201 * absa(ind1+2,1:ng15)  + &
                fac011 * absa(ind1+9,1:ng15)  + &
                fac111 * absa(ind1+10,1:ng15) + &
                fac211 * absa(ind1+11,1:ng15))
            else if (specparm1 .gt. 0.875_JPRB) then
!$NEC unroll(NG15)
              tau_major1(1:ng15) = speccomb1 * &
              (fac201 * absa(ind1-1,1:ng15) + &
                fac101 * absa(ind1,1:ng15)   + &
                fac001 * absa(ind1+1,1:ng15) + &
                fac211 * absa(ind1+8,1:ng15) + &
                fac111 * absa(ind1+9,1:ng15) + &
                fac011 * absa(ind1+10,1:ng15))
            else
!$NEC unroll(NG15)
              tau_major1(1:ng15) = speccomb1 * &
              (fac001 * absa(ind1,1:ng15)   + &
                fac101 * absa(ind1+1,1:ng15) + &
                fac011 * absa(ind1+9,1:ng15) + &
                fac111 * absa(ind1+10,1:ng15))
            endif

!$NEC unroll(NG15)
            !$ACC LOOP SEQ PRIVATE(tauself, taufor, n2m1, n2m2, taun2)
            do ig = 1, ng15
              tauself = selffac(jl,lay)* (selfref(inds,ig) + selffrac(jl,lay) * &
                  (selfref(inds+1,ig) - selfref(inds,ig)))
              taufor =  forfac(jl,lay) * (forref(indf,ig) + forfrac(jl,lay) * &
                  (forref(indf+1,ig) - forref(indf,ig)))
              n2m1 = ka_mn2(jmn2,indm,ig) + fmn2 * &
                  (ka_mn2(jmn2+1,indm,ig) - ka_mn2(jmn2,indm,ig))
              n2m2 = ka_mn2(jmn2,indm+1,ig) + fmn2 * &
                  (ka_mn2(jmn2+1,indm+1,ig) - ka_mn2(jmn2,indm+1,ig))
              taun2 = scalen2 * (n2m1 + minorfrac(jl,lay) * (n2m2 - n2m1))

              taug(jl,ngs14+ig,lay) = tau_major(ig) + tau_major1(ig) &
                  + tauself + taufor &
                  + taun2
              fracs(jl,ngs14+ig,lay) = fracrefa(ig,jpl) + fpl * &
                  (fracrefa(ig,jpl+1)-fracrefa(ig,jpl))
            enddo
#ifdef _OPENACC
         else
#else
          enddo

          ! Upper atmosphere part
          ixc0 = KFDIA - KIDIA + 1 - ixc0
#endif

          !$ACC LOOP SEQ
          do ig = 1, ng15
#ifndef _OPENACC
!$NEC ivdep
            do ixp = 1, ixc0
              jl = ixhigh(ixp,lay)
#endif

              taug(jl,ngs14+ig,lay) = 0.0_JPRB
              fracs(jl,ngs14+ig,lay) = 0.0_JPRB
            enddo
#ifdef _OPENACC
           endif
#endif
          enddo

        enddo
        !$ACC END PARALLEL

      ENDIF

      !$ACC END DATA

END SUBROUTINE RRTM_TAUMOL15

! This file has been modified for the use in ICON

MODULE YOESRTA25

USE PARKIND1  ,ONLY : JPIM     ,JPRB,JPRD

IMPLICIT NONE

PUBLIC

SAVE

!     -----------------------------------------------------------------
!*    ** *YOESRTA25* - SRTM COEFFICIENTS FOR INTERVAL 25
!     BAND 25: 16000-22650 cm-1 (low - H2O; high - nothing)
!     -----------------------------------------------------------------

INTEGER(KIND=JPIM), PARAMETER :: JPG = 16, NG25 = 16

REAL(KIND=JPRB) :: KA(5,13,JPG) 
REAL(KIND=JPRD) :: KA_D(5,13,JPG) 
REAL(KIND=JPRB) :: SFLUXREF(JPG)
REAL(KIND=JPRB) :: RAYL(JPG), ABSO3A(JPG), ABSO3B(JPG)
INTEGER(KIND=JPIM) :: LAYREFFR

REAL(KIND=JPRB) :: KAC(5,13,NG25) ,ABSA(65,NG25)
REAL(KIND=JPRB) :: SFLUXREFC(NG25)
REAL(KIND=JPRB) :: RAYLC(NG25), ABSO3AC(NG25), ABSO3BC(NG25)

!EQUIVALENCE (KA(1,1,1),ABSA(1,1))
EQUIVALENCE (KAC(1,1,1),ABSA(1,1))

!$ACC DECLARE CREATE(KAC, ABSA, SFLUXREFC, RAYLC, ABSO3AC, ABSO3BC)

!     -----------------------------------------------------------------
!        * E.C.M.W.F. PHYSICS PACKAGE ** RRTM SW RADIATION **

!     J.-J. MORCRETTE       E.C.M.W.F.      02/10/29
!     M. J. IACONO          AER             12/09/03

!  NAME     TYPE     PURPOSE
!  ----   : ----   : ---------------------------------------------------
! KA      : REAL     absorption coefficient of major absorber
! SFLUXREF: REAL     Incident solar radiation in the spectral interval
! RAYL    : REAL     Rayleigh scattering parameter
! ABSO3A  : REAL     O3 absorption coefficient in first part of band
! ABSO3B  : REAL     O3 absorption coefficient in second part of band
! LAYREFFR: INTEGER  reference level for the transition
! KAC     : REAL     Reduced g-point array for KA
!SFLUXREFC: REAL     Reduced g-point array for SFLUXREF
! RAYLC   : REAL     Reduced g-point array for RAYL
! ABSO3AC : REAL     Reduced g-point array for ABSO3A
! ABSO3BC : REAL     Reduced g-point array for ABSO3B
!     -----------------------------------------------------------------
END MODULE YOESRTA25

! This file has been modified for the use in ICON

MODULE YOERRTA1

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

PUBLIC

SAVE

!     -----------------------------------------------------------------
!*    ** *YOERRTA1* - RRTM COEFFICIENTS FOR INTERVAL 1
!     BAND 1:  10-250 cm-1 (low - H2O; high - H2O)
!     ABozzo may 2013 update to last version of rrtmg
!     band 1:  10-350 cm-1
!     -----------------------------------------------------------------

INTEGER(KIND=JPIM), PARAMETER :: NG1  = 10

REAL(KIND=JPRB) :: FRACREFA(NG1)  , FRACREFB(NG1)
REAL(KIND=JPRB) :: KA(5,13,NG1)   , ABSA(65,NG1)
REAL(KIND=JPRB) :: KB(5,13:59,NG1), ABSB(235,NG1)
REAL(KIND=JPRB) :: KA_MN2(19,NG1) , KB_MN2(19,NG1)
REAL(KIND=JPRB) :: SELFREF(10,NG1), FORREF(4,NG1)

EQUIVALENCE (KA(1,1,1),ABSA(1,1)), (KB(1,13,1),ABSB(1,1))

!$ACC DECLARE CREATE(FRACREFA, FRACREFB, KA, ABSA, KB, ABSB, KA_MN2, KB_MN2, &
!$ACC                SELFREF, FORREF)

!     -----------------------------------------------------------------
!        * E.C.M.W.F. PHYSICS PACKAGE ** RRTM LW RADIATION **

!     J.-J. MORCRETTE       E.C.M.W.F.      98/07/14

!  NAME     TYPE     PURPOSE
!  ----   : ----   : ---------------------------------------------------
! ABSA    : REAL     absorption coefficient of major absorber for M reference tropospheric 
!                    pressures and N reference tropospheric temperatures
! ABSB    : REAL     absorption coefficient of secondary absorber for M reference stratospheric
!                    pressures and N reference stratospheric temperatures 
! FRACREFA: REAL     distance from r and T reference tabulated points (troposphere)
! FRACREFB: REAL     distance from r and T reference tabulated points (stratosphere)
! FORREF  : REAL     foreign broadening coefficient for water vapour
! KA      : REAL     absorption coefficient of major absorber    
! KB      : REAL     absorption coefficient of secondary absorber    
! SELFREF : REAL     self broadening coefficient for water vapour
!     -----------------------------------------------------------------
END MODULE YOERRTA1

MODULE divgrad2_mod

  REAL,POINTER,SAVE ::  divgra( :,: )
  
CONTAINS

  SUBROUTINE divgrad2_allocate
  USE bands
  USE allocate_field_mod
  USE parallel_lmdz
  USE dimensions_mod, ONLY: iim, jjm, llm, ndm
  IMPLICIT NONE
    TYPE(distrib),POINTER :: d
    d=>distrib_dissip

    CALL allocate_u(divgra,llm,d)

    
  END SUBROUTINE divgrad2_allocate
  
  SUBROUTINE divgrad2_switch_dissip(dist)
  USE allocate_field_mod
  USE bands
  USE parallel_lmdz
  IMPLICIT NONE
    TYPE(distrib),INTENT(IN) :: dist

    CALL switch_u(divgra,distrib_dissip,dist)


  END SUBROUTINE divgrad2_switch_dissip
  
END MODULE divgrad2_mod  

MODULE gradiv2_mod

  REAL,POINTER,SAVE ::  gdx( :,: )
  REAL,POINTER,SAVE ::  gdy( :,: )
  REAL,POINTER,SAVE ::  div( :,: )
  
CONTAINS

  SUBROUTINE gradiv2_allocate
  USE bands
  USE allocate_field_mod
  USE parallel_lmdz
  USE dimensions_mod, ONLY: iim, jjm, llm, ndm
  IMPLICIT NONE
    TYPE(distrib),POINTER :: d
    d=>distrib_dissip

    CALL allocate_u(gdx,llm,d)
    CALL allocate_v(gdy,llm,d)
    CALL allocate_u(div,llm,d)

    
  END SUBROUTINE gradiv2_allocate
  
  SUBROUTINE gradiv2_switch_dissip(dist)
  USE allocate_field_mod
  USE bands
  USE parallel_lmdz
  IMPLICIT NONE
    TYPE(distrib),INTENT(IN) :: dist

    CALL switch_u(gdx,distrib_dissip,dist)
    CALL switch_v(gdy,distrib_dissip,dist)
    CALL switch_u(div,distrib_dissip,dist)


  END SUBROUTINE gradiv2_switch_dissip
  
END MODULE gradiv2_mod  

! radiation_spectral_definition.F90 - Derived type to describe a spectral definition
!
! (C) Copyright 2020- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!
! Author:  Robin Hogan
! Email:   r.j.hogan@ecmwf.int
! License: see the COPYING file for details
!

#include "ecrad_config.h"

module radiation_spectral_definition

  use parkind1,    only : jprb

  implicit none

  public

  real(jprb), parameter :: SolarReferenceTemperature       = 5777.0_jprb ! K
  real(jprb), parameter :: TerrestrialReferenceTemperature = 273.15_jprb ! K

  !---------------------------------------------------------------------
  ! A derived type describing the contribution of the g points of a
  ! correlated k-distribution gas-optics model from each part of the
  ! spectrum. This is used primarily to map the cloud and aerosol
  ! optical properties on to the gas g points.
  type spectral_definition_type
    
    ! Spectral mapping of g points

    ! Number of wavenumber intervals
    integer :: nwav = 0
    ! Number of k terms / g points
    integer :: ng   = 0
    ! Start and end wavenumber (cm-1), dimensioned (nwav)
    real(jprb), allocatable :: wavenumber1(:)
    real(jprb), allocatable :: wavenumber2(:)
    ! Fraction of each g point in each wavenumber interval,
    ! dimensioned (nwav, ng)
    real(jprb), allocatable :: gpoint_fraction(:,:)

    ! Spectral weighting information for generating mappings to/from
    ! different spectral grids: this can be in terms of a reference
    ! temperature (K) to generate a Planck function, or the
    ! solar_spectral_irradiance (W m-2) if available in the gas-optics
    ! file.
    real(jprb) :: reference_temperature = -1.0_jprb
    real(jprb), allocatable :: solar_spectral_irradiance(:)
    
    ! Band information

    ! Number of bands
    integer :: nband = 0
    ! Lower and upper bounds of wavenumber bands (cm-1), dimensioned
    ! (nband)
    real(jprb), allocatable :: wavenumber1_band(:)
    real(jprb), allocatable :: wavenumber2_band(:)
    ! Band (one based) to which each g point belongs
    integer,    allocatable :: i_band_number(:)

  contains
    procedure :: read => read_spectral_definition
    procedure :: allocate_bands_only
    procedure :: deallocate
    procedure :: find => find_wavenumber
    procedure :: calc_mapping
    procedure :: calc_mapping_from_bands
    procedure :: calc_mapping_from_wavenumber_bands
    procedure :: print_mapping_from_bands
    procedure :: min_wavenumber, max_wavenumber

  end type spectral_definition_type

contains

  !---------------------------------------------------------------------
  ! Read the description of a spectral definition from a NetCDF
  ! file of the type used to describe an ecCKD model
  subroutine read_spectral_definition(this, file)

#ifdef EASY_NETCDF_READ_MPI
    use easy_netcdf_read_mpi, only : netcdf_file
#else
    use easy_netcdf,          only : netcdf_file
#endif
    use yomhook,     only : lhook, dr_hook, jphook

    class(spectral_definition_type), intent(inout) :: this
    type(netcdf_file),               intent(inout) :: file

    real(jphook) :: hook_handle

    if (lhook) call dr_hook('radiation_spectral_definition:read',0,hook_handle)

    ! Read spectral mapping of g points
    call file%get('wavenumber1', this%wavenumber1)
    call file%get('wavenumber2', this%wavenumber2)
    call file%get('gpoint_fraction', this%gpoint_fraction)

    ! Read band information
    call file%get('wavenumber1_band', this%wavenumber1_band)
    call file%get('wavenumber2_band', this%wavenumber2_band)
    call file%get('band_number', this%i_band_number)

    ! Read spectral weighting information
    if (file%exists('solar_spectral_irradiance')) then
      ! This is on the same grid as wavenumber1,2
      call file%get('solar_spectral_irradiance', &
           &        this%solar_spectral_irradiance)
    end if
    if (file%exists('solar_irradiance')) then
      ! Shortwave default temperature
      this%reference_temperature = SolarReferenceTemperature
    else
      ! Longwave reference temperature
      this%reference_temperature = TerrestrialReferenceTemperature
    end if
    
    ! Band number is 0-based: add 1
    this%i_band_number = this%i_band_number + 1

    this%nwav  = size(this%wavenumber1)
    this%ng    = size(this%gpoint_fraction, 2);
    this%nband = size(this%wavenumber1_band)

    if (lhook) call dr_hook('radiation_spectral_definition:read',1,hook_handle)

  end subroutine read_spectral_definition


  !---------------------------------------------------------------------
  ! Store a simple band description by copying over the reference
  ! temperature and the lower and upper wavenumbers of each band
  subroutine allocate_bands_only(this, reference_temperature, wavenumber1, wavenumber2)

    use yomhook,     only : lhook, dr_hook, jphook

    class(spectral_definition_type), intent(inout) :: this
    real(jprb),                      intent(in)    :: reference_temperature    ! K
    real(jprb),        dimension(:), intent(in)    :: wavenumber1, wavenumber2 ! cm-1

    real(jphook) :: hook_handle

    if (lhook) call dr_hook('radiation_spectral_definition:allocate_bands_only',0,hook_handle)

    call this%deallocate()

    this%nband = size(wavenumber1)
    allocate(this%wavenumber1_band(this%nband))
    allocate(this%wavenumber2_band(this%nband))
    this%wavenumber1_band = wavenumber1
    this%wavenumber2_band = wavenumber2
    this%reference_temperature = reference_temperature
    
    if (lhook) call dr_hook('radiation_spectral_definition:allocate_bands_only',1,hook_handle)

  end subroutine allocate_bands_only


  !---------------------------------------------------------------------
  ! Deallocate memory inside a spectral definition object
  subroutine deallocate(this)

    class(spectral_definition_type), intent(inout) :: this
    
    this%nwav  = 0
    this%ng    = 0
    this%nband = 0
    this%reference_temperature = -1.0_jprb

    if (allocated(this%wavenumber1))      deallocate(this%wavenumber1)
    if (allocated(this%wavenumber2))      deallocate(this%wavenumber2)
    if (allocated(this%wavenumber1_band)) deallocate(this%wavenumber1_band)
    if (allocated(this%wavenumber2_band)) deallocate(this%wavenumber2_band)
    if (allocated(this%gpoint_fraction))  deallocate(this%gpoint_fraction)
    if (allocated(this%i_band_number))    deallocate(this%i_band_number)

  end subroutine deallocate


  !---------------------------------------------------------------------
  ! Find the index to the highest wavenumber in the spectral
  ! definition that is lower than or equal to "wavenumber", used for
  ! implementing look-up tables
  pure function find_wavenumber(this, wavenumber)
    class(spectral_definition_type), intent(in) :: this
    real(jprb),                      intent(in) :: wavenumber ! cm-1
    integer                                     :: find_wavenumber

    if (wavenumber < this%wavenumber1(1) .or. wavenumber > this%wavenumber2(this%nwav)) then
      ! Wavenumber not present
      find_wavenumber = 0
    else
      find_wavenumber = 1
      do while (wavenumber > this%wavenumber2(find_wavenumber) &
           &    .and. find_wavenumber < this%nwav)
        find_wavenumber = find_wavenumber + 1
      end do
    end if
  end function find_wavenumber


  !---------------------------------------------------------------------
  ! Compute a mapping matrix "mapping" that can be used in an
  ! expression y=matmul(mapping,x) where x is a variable containing
  ! optical properties at each input "wavenumber", and y is this
  ! variable mapped on to the spectral intervals in the spectral
  ! definition "this". 
  subroutine calc_mapping(this, wavenumber, mapping, weighting_temperature, use_bands)

    use yomhook,      only : lhook, dr_hook, jphook
    use radiation_io, only : nulerr, radiation_abort

    class(spectral_definition_type), intent(in)    :: this
    real(jprb),                      intent(in)    :: wavenumber(:) ! cm-1
    real(jprb), allocatable,         intent(inout) :: mapping(:,:)
    real(jprb), optional,            intent(in)    :: weighting_temperature ! K
    logical,    optional,            intent(in)    :: use_bands

    ! Spectral weights to apply, same length as wavenumber above
    real(jprb), dimension(:), allocatable :: weight, planck_weight

    ! Wavenumbers (cm-1) marking triangle of influence of a cloud
    ! spectral point
    real(jprb) :: wavenum0, wavenum1, wavenum2

    integer    :: nwav ! Number of wavenumbers describing cloud

    ! Indices to wavenumber intervals in spectral definition structure
    integer    :: isd, isd0, isd1, isd2

    ! Wavenumber index
    integer    :: iwav
    
    ! Loop indices
    integer    :: jg, jwav, jband

    logical    :: use_bands_local

    real(jphook) :: hook_handle

    if (lhook) call dr_hook('radiation_spectral_definition:calc_mapping',0,hook_handle)

    if (present(use_bands)) then
      use_bands_local = use_bands
    else
      use_bands_local = .false.
    end if

    nwav = size(wavenumber)

    if (allocated(mapping)) then
      deallocate(mapping)
    end if
    
    ! Define the mapping matrix
    if (use_bands_local) then
      ! Cloud properties per band

      allocate(mapping(this%nband, nwav))
      allocate(weight(nwav))

      ! Planck weight uses the wavenumbers of the cloud points
      allocate(planck_weight(nwav))
      if (present(weighting_temperature)) then
        if (weighting_temperature > 0.0_jprb) then
          planck_weight = calc_planck_function_wavenumber(wavenumber, &
               &                          weighting_temperature)
        else
          ! Legacy mode: unweighted average
          planck_weight = 1.0_jprb
        end if
      else
        planck_weight = calc_planck_function_wavenumber(wavenumber, &
             &                          this%reference_temperature)
      end if

      do jband = 1,this%nband
        weight = 0.0_jprb
        do jwav = 1,nwav
          ! Work out wavenumber range for which this cloud wavenumber
          ! will be applicable
          if (wavenumber(jwav) >= this%wavenumber1_band(jband) &
               & .and. wavenumber(jwav) <= this%wavenumber2_band(jband)) then
            if (jwav > 1) then
              wavenum1 = max(this%wavenumber1_band(jband), &
                   &  0.5_jprb*(wavenumber(jwav-1)+wavenumber(jwav)))
            else
              wavenum1 = this%wavenumber1_band(jband)
            end if
            if (jwav < nwav) then
              wavenum2 = min(this%wavenumber2_band(jband), &
                   &  0.5_jprb*(wavenumber(jwav)+wavenumber(jwav+1)))
            else
              wavenum2 = this%wavenumber2_band(jband)
            end if
            ! This cloud wavenumber is weighted by the wavenumber
            ! range of its applicability multiplied by the Planck
            ! function at an appropriate temperature
            weight(jwav) = (wavenum2-wavenum1) * planck_weight(jwav)
          end if
        end do
        if (sum(weight) <= 0.0_jprb) then
          ! No cloud wavenumbers lie in the band; interpolate to
          ! central wavenumber of band instead
          if (wavenumber(1) >= this%wavenumber2_band(jband)) then
            ! Band is entirely below first cloudy wavenumber
            weight(1) = 1.0_jprb
          else if (wavenumber(nwav) <= this%wavenumber1_band(jband)) then
            ! Band is entirely above last cloudy wavenumber
            weight(nwav) = 1.0_jprb
          else
            ! Find interpolating points
            iwav = 2
            do while (wavenumber(iwav) < this%wavenumber2_band(jband))
              iwav = iwav+1
            end do
            weight(iwav-1) = planck_weight(iwav-1) * (wavenumber(iwav) &
                 &  - 0.5_jprb*(this%wavenumber2_band(jband)+this%wavenumber1_band(jband)))
            weight(iwav) = planck_weight(iwav) * (-wavenumber(iwav-1) &
                 &  + 0.5_jprb*(this%wavenumber2_band(jband)+this%wavenumber1_band(jband)))
          end if
        end if
        mapping(jband,:) = weight / sum(weight)
      end do

      deallocate(weight)
      deallocate(planck_weight)

    else
      ! Cloud properties per g-point

      if (this%ng == 0) then
        write(nulerr,'(a)') '*** Error: requested cloud/aerosol mapping per g-point but only available per band'
        call radiation_abort('Radiation configuration error')
      end if

      allocate(mapping(this%ng, nwav))
      allocate(weight(this%nwav))
      allocate(planck_weight(this%nwav))

      if (allocated(this%solar_spectral_irradiance)) then
        planck_weight = this%solar_spectral_irradiance
      else
        planck_weight = calc_planck_function_wavenumber(0.5_jprb &
             &  * (this%wavenumber1 + this%wavenumber2), &
             &  this%reference_temperature)
      end if

      mapping = 0.0_jprb
      ! Loop over wavenumbers representing cloud
      do jwav = 1,nwav
        ! Clear the weights. The weight says for one wavenumber in the
        ! cloud file, what is its fractional contribution to each of
        ! the spectral-definition intervals
        weight = 0.0_jprb

        ! Cloud properties are linearly interpolated between each of
        ! the nwav cloud points; therefore, the influence of a
        ! particular cloud point extends as a triangle between
        ! wavenum0 and wavenum2, peaking at wavenum1
        wavenum1 = wavenumber(jwav)
        isd1 = this%find(wavenum1)
        if (isd1 < 1) then
          cycle
        end if
        if (jwav > 1) then
          wavenum0 = wavenumber(jwav-1)

          ! Map triangle under (wavenum0,0) to (wavenum1,1) to the
          ! wavenumbers in this%gpoint_fraction
          isd0 = this%find(wavenum0)
          if (isd0 == isd1) then
            ! Triangle completely within the range
            ! this%wavenumber1(isd0)-this%wavenumber2(isd0)
            weight(isd0) = 0.5_jprb*(wavenum1-wavenum0) &
                 &       / (this%wavenumber2(isd0)-this%wavenumber1(isd0))
          else
            if (isd0 >= 1) then
              ! Left part of triangle
              weight(isd0) = 0.5_jprb * (this%wavenumber2(isd0)-wavenum0)**2 &
                   &       / ((this%wavenumber2(isd0)-this%wavenumber1(isd0)) &
                   &         *(wavenum1-wavenum0))
            end if
            ! Right part of triangle (trapezium)
!            weight(isd1) = 0.5_jprb * (wavenum1-this%wavenumber1(isd1)) &
!                 &       * (wavenum1 + this%wavenumber1(isd1) - 2.0_jprb*wavenum0) &
!                 &       / (wavenum1-wavenum0)
            weight(isd1) = 0.5_jprb * (1.0_jprb &
                 &  + (this%wavenumber1(isd1)-wavenum1)/(wavenum1-wavenum0)) &
                 &  * (wavenum1-this%wavenumber1(isd1)) &
                 &  / (this%wavenumber2(isd1)-this%wavenumber1(isd1))
            if (isd1-isd0 > 1) then
              do isd = isd0+1,isd1-1
                ! Intermediate trapezia
                weight(isd) = 0.5_jprb * (this%wavenumber1(isd)+this%wavenumber2(isd) &
                     &                    - 2.0_jprb*wavenum0) &
                     &      / (wavenum1-wavenum0)
              end do
            end if
          end if

        else
          ! First cloud wavenumber: all wavenumbers in the spectral
          ! definition below this will use the first one
          if (isd1 >= 1) then
            weight(1:isd1-1) = 1.0_jprb
            weight(isd1) = (wavenum1-this%wavenumber1(isd1)) &
                 &       / (this%wavenumber2(isd1)-this%wavenumber1(isd1))
          end if
        end if

        if (jwav < nwav) then
          wavenum2 = wavenumber(jwav+1)

          ! Map triangle under (wavenum1,1) to (wavenum2,0) to the
          ! wavenumbers in this%gpoint_fraction
          isd2 = this%find(wavenum2)

          if (isd1 == isd2) then
            ! Triangle completely within the range
            ! this%wavenumber1(isd1)-this%wavenumber2(isd1)
            weight(isd1) = weight(isd1) + 0.5_jprb*(wavenum2-wavenum1) &
                 &       / (this%wavenumber2(isd1)-this%wavenumber1(isd1))
          else
            if (isd2 >= 1 .and. isd2 <= this%nwav) then
              ! Right part of triangle
              weight(isd2) = weight(isd2) + 0.5_jprb * (wavenum2-this%wavenumber1(isd2))**2 &
                   &       / ((this%wavenumber2(isd2)-this%wavenumber1(isd2)) &
                   &         *(wavenum2-wavenum1))
            end if
            ! Left part of triangle (trapezium)
!            weight(isd1) = weight(isd1) + 0.5_jprb * (this%wavenumber2(isd1)-wavenum1) &
!                 &       * (wavenum1 + this%wavenumber2(isd1) - 2.0_jprb*wavenum2) &
!                 &       / (wavenum2-wavenum1)
            weight(isd1) = weight(isd1) + 0.5_jprb * (1.0_jprb &
                 &  + (wavenum2-this%wavenumber2(isd1)) / (wavenum2-wavenum1)) &
                 &  * (this%wavenumber2(isd1)-wavenum1) &
                 &  / (this%wavenumber2(isd1)-this%wavenumber1(isd1))
            if (isd2-isd1 > 1) then
              do isd = isd1+1,isd2-1
                ! Intermediate trapezia
                weight(isd) = weight(isd) + 0.5_jprb * (2.0_jprb*wavenum2 &
                     & - this%wavenumber1(isd) - this%wavenumber2(isd)) &
                     &      / (wavenum2-wavenum1)
              end do
            end if
          end if

        else
          ! Last cloud wavenumber: all wavenumbers in the spectral
          ! definition above this will use the last one
          if (isd1 <= this%nwav) then
            weight(isd1+1:this%nwav) = 1.0_jprb
            weight(isd1) = (this%wavenumber2(isd1)-wavenum1) &
                 &       / (this%wavenumber2(isd1)-this%wavenumber1(isd1))
          end if
        end if

        weight = weight * planck_weight

        do jg = 1,this%ng
          mapping(jg, jwav) = sum(weight * this%gpoint_fraction(:,jg))
        end do

      end do

      deallocate(weight)
      deallocate(planck_weight)

      ! Normalize mapping matrix
      do jg = 1,this%ng
        mapping(jg,:) = mapping(jg,:) * (1.0_jprb/sum(mapping(jg,:)))
      end do

    end if

    if (lhook) call dr_hook('radiation_spectral_definition:calc_mapping',1,hook_handle)

  end subroutine calc_mapping


  !---------------------------------------------------------------------
  ! Under normal operation (if use_fluxes is .false. or not present),
  ! compute a mapping matrix "mapping" that can be used in an
  ! expression y=matmul(mapping^T,x) where x is a variable containing
  ! optical properties in input bands (e.g. albedo in shortwave albedo
  ! bands), and y is this variable mapped on to the spectral intervals
  ! in the spectral definition "this". Note that "mapping" is here
  ! transposed from the convention in the calc_mapping routine.  Under
  ! the alternative operation (if use_fluxes is present and .true.),
  ! the mapping works in the reverse sense: if y contains fluxes in
  ! each ecRad band or g-point, then x=matmul(mapping,y) would return
  ! fluxes in x averaged to user-supplied "input" bands. In this
  ! version, the bands are described by their wavelength bounds
  ! (wavelength_bound, which must be increasing and exclude the end
  ! points) and the index of the mapping matrix that each band
  ! corresponds to (i_intervals, which has one more element than
  ! wavelength_bound and can have duplicated values if an
  ! albedo/emissivity value is to be associated with more than one
  ! discontinuous ranges of the spectrum).
  subroutine calc_mapping_from_bands(this, &
       &  wavelength_bound, i_intervals, mapping, use_bands, use_fluxes)

    use yomhook,      only : lhook, dr_hook, jphook
    use radiation_io, only : nulerr, radiation_abort

    class(spectral_definition_type), intent(in)    :: this
    ! Monotonically increasing wavelength bounds (m) between
    ! intervals, not including the outer bounds (which are assumed to
    ! be zero and infinity)
    real(jprb),                      intent(in)    :: wavelength_bound(:)
    ! The albedo band indices corresponding to each interval
    integer,                         intent(in)    :: i_intervals(:)
    real(jprb), allocatable,         intent(inout) :: mapping(:,:)
    logical,    optional,            intent(in)    :: use_bands
    logical,    optional,            intent(in)    :: use_fluxes

    ! Planck function and central wavenumber of each wavenumber
    ! interval of the spectral definition
    real(jprb) :: planck(this%nwav)         ! W m-2 (cm-1)-1
    real(jprb) :: wavenumber_mid(this%nwav) ! cm-1

    real(jprb), allocatable :: mapping_denom(:,:)

    real(jprb) :: wavenumber1_bound, wavenumber2_bound

    ! To work out weights we sample the Planck function at five points
    ! in the interception between an input interval and a band, and
    ! use the Trapezium Rule
    integer, parameter :: nsample = 5
    integer :: isamp
    real(jprb), dimension(nsample) :: wavenumber_sample, planck_sample
    real(jprb), parameter :: weight_sample(nsample) &
         &        = [0.5_jprb, 1.0_jprb, 1.0_jprb, 1.0_jprb, 0.5_jprb]

    ! Index of input value corresponding to each wavenumber interval
    integer :: i_input(this%nwav)

    ! Number of albedo/emissivity values that will be provided, some
    ! of which may span discontinuous intervals in wavelength space
    integer :: ninput

    ! Number of albedo/emissivity intervals represented, where some
    ! may be grouped to have the same value of albedo/emissivity (an
    ! example is in the thermal infrared where classically the IFS has
    ! ninput=2 and ninterval=3, since only two emissivities are
    ! provided representing (1) the infrared window, and (2) the
    ! intervals to each side of the infrared window.
    integer :: ninterval

    logical    :: use_bands_local, use_fluxes_local

    ! Loop indices
    integer    :: jg, jband, jin, jint, jwav

    real(jphook) :: hook_handle

    if (lhook) call dr_hook('radiation_spectral_definition:calc_mapping_from_bands',0,hook_handle)

    if (present(use_bands)) then
      use_bands_local = use_bands
    else
      use_bands_local = .false.
    end if

    if (present(use_fluxes)) then
      use_fluxes_local = use_fluxes
    else
      use_fluxes_local = .false.
    end if

    ! Count the number of input intervals 
    ninterval = size(i_intervals)
    ninput    = maxval(i_intervals)
    
    if (allocated(mapping)) then
      deallocate(mapping)
    end if
    
    ! Check wavelength is monotonically increasing
    if (ninterval > 2) then
      do jint = 2,ninterval-1
        if (wavelength_bound(jint) <= wavelength_bound(jint-1)) then
          write(nulerr, '(a)') '*** Error: wavelength bounds must be monotonically increasing'
          call radiation_abort()
        end if
      end do
    end if

    ! Define the mapping matrix
    if (use_bands_local) then
      ! Require properties per band

      allocate(mapping(ninput, this%nband))
      mapping = 0.0_jprb

      if (use_fluxes_local) then
        allocate(mapping_denom(ninput, this%nband))
        mapping_denom = 0.0_jprb
      end if

      do jband = 1,this%nband
        do jint = 1,ninterval
          if (jint == 1) then
            ! First input interval in wavelength space: lower
            ! wavelength bound is 0 m, so infinity cm-1
            wavenumber2_bound = this%wavenumber2_band(jband)
          else
            wavenumber2_bound = min(this%wavenumber2_band(jband), &
                 &                  0.01_jprb/wavelength_bound(jint-1))
          end if

          if (jint == ninterval) then
            ! Final input interval in wavelength space: upper
            ! wavelength bound is infinity m, so 0 cm-1
            wavenumber1_bound = this%wavenumber1_band(jband)
          else
            wavenumber1_bound = max(this%wavenumber1_band(jband), &
                 &                  0.01_jprb/wavelength_bound(jint))

          end if

          if (wavenumber2_bound > wavenumber1_bound) then
            ! Current input interval contributes to current band;
            ! compute the weight of the contribution in proportion to
            ! an approximate calculation of the integral of the Planck
            ! function over the relevant part of the spectrum
            wavenumber_sample = wavenumber1_bound + [(isamp,isamp=0,nsample-1)] &
                 &  * (wavenumber2_bound-wavenumber1_bound) / real(nsample-1,jprb)
            planck_sample = calc_planck_function_wavenumber(wavenumber_sample, &
                 &                                 this%reference_temperature)
            mapping(i_intervals(jint),jband) = mapping(i_intervals(jint),jband) &
                 &  + sum(planck_sample*weight_sample) * (wavenumber2_bound-wavenumber1_bound)
            if (use_fluxes_local) then
              ! Compute an equivalent sample containing the entire ecRad band
              wavenumber_sample = this%wavenumber1_band(jband) + [(isamp,isamp=0,nsample-1)] &
                   &  * (this%wavenumber2_band(jband)-this%wavenumber1_band(jband)) &
                   &  / real(nsample-1,jprb)
              planck_sample = calc_planck_function_wavenumber(wavenumber_sample, &
                   &                                 this%reference_temperature)
              mapping_denom(i_intervals(jint),jband) = mapping_denom(i_intervals(jint),jband) &
                 &  + sum(planck_sample*weight_sample) * (this%wavenumber2_band(jband)-this%wavenumber1_band(jband))
            end if
          end if

        end do
      end do

      if (use_fluxes_local) then
        mapping = mapping / max(1.0e-12_jprb, mapping_denom)
        deallocate(mapping_denom)
      end if

    else
      ! Require properties per g-point

      if (this%ng == 0) then
        write(nulerr,'(a)') '*** Error: requested surface mapping per g-point but only available per band'
        call radiation_abort('Radiation configuration error')
      end if

      allocate(mapping(ninput,this%ng))
      mapping = 0.0_jprb

      wavenumber_mid = 0.5_jprb * (this%wavenumber1 + this%wavenumber2)
      if (allocated(this%solar_spectral_irradiance)) then
        planck = this%solar_spectral_irradiance
      else
        planck = calc_planck_function_wavenumber(wavenumber_mid, &
             &                       this%reference_temperature)
      end if

#ifdef USE_COARSE_MAPPING
      ! In the processing that follows, we assume that the wavenumber
      ! grid on which the g-points are defined in the spectral
      ! definition is much finer than the albedo/emissivity intervals
      ! that the user will provide.  This means that each wavenumber
      ! is assigned to only one of the albedo/emissivity intervals.

      ! By default set all wavenumbers to use first input
      ! albedo/emissivity
      i_input = 1
      
      ! All bounded intervals
      do jint = 2,ninterval-1
        wavenumber1_bound = 0.01_jprb / wavelength_bound(jint)
        wavenumber2_bound = 0.01_jprb / wavelength_bound(jint-1)
        where (wavenumber_mid > wavenumber1_bound &
             & .and. wavenumber_mid <= wavenumber2_bound)
          i_input = i_intervals(jint)
        end where
      end do

      ! Final interval in wavelength space goes up to wavelength of
      ! infinity (wavenumber of zero)
      if (ninterval > 1) then
        wavenumber2_bound = 0.01_jprb / wavelength_bound(ninterval-1)
        where (wavenumber_mid <= wavenumber2_bound)
          i_input = i_intervals(ninterval)
        end where
      end if

      do jg = 1,this%ng
        do jin = 1,ninput
          mapping(jin,jg) = sum(this%gpoint_fraction(:,jg) * planck, &
               &                 mask=(i_input==jin))
          if (use_fluxes_local) then
            mapping(jin,jg) = mapping(jin,jg) / sum(this%gpoint_fraction(:,jg) * planck)
          end if
        end do
      end do

#else

      ! Loop through all intervals
      do jint = 1,ninterval
        ! Loop through the wavenumbers for gpoint_fraction
        do jwav = 1,this%nwav
          if (jint == 1) then
            ! First input interval in wavelength space: lower
            ! wavelength bound is 0 m, so infinity cm-1
            wavenumber2_bound = this%wavenumber2(jwav)
          else
            wavenumber2_bound = min(this%wavenumber2(jwav), &
                 &                  0.01_jprb/wavelength_bound(jint-1))
          end if

          if (jint == ninterval) then
            ! Final input interval in wavelength space: upper
            ! wavelength bound is infinity m, so 0 cm-1
            wavenumber1_bound = this%wavenumber1(jwav)
          else
            wavenumber1_bound = max(this%wavenumber1(jwav), &
                 &                  0.01_jprb/wavelength_bound(jint))

          end if

          if (wavenumber2_bound > wavenumber1_bound) then
            ! Overlap between input interval and gpoint_fraction
            ! interval: compute the weight of the contribution in
            ! proportion to an approximate calculation of the integral
            ! of the Planck function over the relevant part of the
            ! spectrum
            mapping(i_intervals(jint),:) = mapping(i_intervals(jint),:) + this%gpoint_fraction(jwav,:) &
                 &  * (planck(jwav) * (wavenumber2_bound - wavenumber1_bound) &
                 &                  / (this%wavenumber2(jwav)-this%wavenumber1(jwav)))
          end if
        end do
      end do
      if (use_fluxes_local) then
        do jg = 1,this%ng
          mapping(:,jg) = mapping(:,jg) / sum(this%gpoint_fraction(:,jg) * planck)
        end do
      end if

#endif
      
    end if

    if (.not. use_fluxes_local) then
      ! Normalize mapping matrix
      do jg = 1,size(mapping,dim=2)
        mapping(:,jg) = mapping(:,jg) * (1.0_jprb/sum(mapping(:,jg)))
      end do
    end if

    if (lhook) call dr_hook('radiation_spectral_definition:calc_mapping_from_bands',1,hook_handle)

  end subroutine calc_mapping_from_bands


  !---------------------------------------------------------------------
  ! As calc_mapping_from_bands but in terms of wavenumber bounds from
  ! wavenumber1 to wavenumber2
  subroutine calc_mapping_from_wavenumber_bands(this, &
       &  wavenumber1, wavenumber2, mapping, use_bands, use_fluxes)

    use yomhook,      only : lhook, dr_hook, jphook

    class(spectral_definition_type), intent(in)    :: this
    real(jprb), intent(in)    :: wavenumber1(:), wavenumber2(:)
    real(jprb), allocatable,         intent(inout) :: mapping(:,:)
    logical,    optional,            intent(in)    :: use_bands
    logical,    optional,            intent(in)    :: use_fluxes

    ! Monotonically increasing wavelength bounds (m) between
    ! intervals, not including the outer bounds (which are assumed to
    ! be zero and infinity)
    real(jprb) :: wavelength_bound(size(wavenumber1)-1)
    ! The albedo band indices corresponding to each interval
    integer    :: i_intervals(size(wavenumber1))

    ! Lower wavelength bound (m) of each band
    real(jprb) :: wavelength1(size(wavenumber1))

    logical    :: is_band_unassigned(size(wavenumber1))

    ! Number of albedo/emissivity intervals represented, where some
    ! may be grouped to have the same value of albedo/emissivity (an
    ! example is in the thermal infrared where classically the IFS has
    ! ninput=2 and ninterval=3, since only two emissivities are
    ! provided representing (1) the infrared window, and (2) the
    ! intervals to each side of the infrared window.
    integer :: ninterval

    ! Index to next band in order of increasing wavelength
    integer :: inext

    ! Loop indices
    integer :: jint

    real(jphook) :: hook_handle

    if (lhook) call dr_hook('radiation_spectral_definition:calc_mapping_from_wavenumber_bands',0,hook_handle)

    wavelength1 = 0.01_jprb / wavenumber2
    ninterval = size(wavelength1)
    
    is_band_unassigned = .true.

    do jint = 1,ninterval
      inext = minloc(wavelength1, dim=1, mask=is_band_unassigned)
      if (jint > 1) then
        wavelength_bound(jint-1) = wavelength1(inext)
      end if
      is_band_unassigned(inext) = .false.
      i_intervals(jint) = inext
    end do

    call calc_mapping_from_bands(this, wavelength_bound, i_intervals, mapping, use_bands, use_fluxes)

    if (lhook) call dr_hook('radiation_spectral_definition:calc_mapping_from_wavenumber_bands',1,hook_handle)

  end subroutine calc_mapping_from_wavenumber_bands


  !---------------------------------------------------------------------
  ! Print out the mapping computed by calc_mapping_from_bands
  subroutine print_mapping_from_bands(this, mapping, use_bands)

    use radiation_io, only : nulout

    class(spectral_definition_type), intent(in) :: this
    real(jprb), allocatable,         intent(in) :: mapping(:,:) ! (ninput,nband/ng)
    logical,    optional,            intent(in) :: use_bands

    logical :: use_bands_local

    integer :: nin, nout
    integer :: jin, jout

    if (present(use_bands)) then
      use_bands_local = use_bands
    else
      use_bands_local = .false.
    end if

    nin = size(mapping,1)
    nout = size(mapping,2)

    if (nin <= 1) then
      write(nulout, '(a)') '  All spectral intervals will use the same albedo/emissivity'
    else if (use_bands_local) then
      write(nulout, '(a,i0,a,i0,a)') '  Mapping from ', nin, ' values to ', nout, ' bands (wavenumber ranges in cm-1)'
      if (nout <= 40) then
        do jout = 1,nout
          write(nulout,'(i6,a,i6,a)',advance='no') nint(this%wavenumber1_band(jout)), ' to', &
               &                        nint(this%wavenumber2_band(jout)), ':'
          do jin = 1,nin
            write(nulout,'(f5.2)',advance='no') mapping(jin,jout)
          end do
          write(nulout, '()')
        end do
      else
        do jout = 1,30
          write(nulout,'(i6,a,i6,a)',advance='no') nint(this%wavenumber1_band(jout)), ' to', &
               &                        nint(this%wavenumber2_band(jout)), ':'
          do jin = 1,nin
            write(nulout,'(f5.2)',advance='no') mapping(jin,jout)
          end do
          write(nulout, '()')
        end do
        write(nulout,'(a)') '  ...'
        write(nulout,'(i6,a,i6,a)',advance='no') nint(this%wavenumber1_band(nout)), ' to', &
             &                        nint(this%wavenumber2_band(nout)), ':'
        do jin = 1,nin
          write(nulout,'(f5.2)',advance='no') mapping(jin,nout)
        end do
        write(nulout, '()')
      end if
    else
      write(nulout, '(a,i0,a,i0,a)') '  Mapping from ', nin, ' values to ', nout, ' g-points'
      if (nout <= 40) then
        do jout = 1,nout
          write(nulout,'(i3,a)',advance='no') jout, ':'
          do jin = 1,nin
            write(nulout,'(f5.2)',advance='no') mapping(jin,jout)
          end do
          write(nulout, '()')
        end do
      else
        do jout = 1,30
          write(nulout,'(i3,a)',advance='no') jout, ':'
          do jin = 1,nin
            write(nulout,'(f5.2)',advance='no') mapping(jin,jout)
          end do
          write(nulout, '()')
        end do
        write(nulout,'(a)') '  ...'
        write(nulout,'(i3,a)',advance='no') nout, ':'
        do jin = 1,nin
          write(nulout,'(f5.2)',advance='no') mapping(jin,nout)
        end do
        write(nulout, '()')
      end if
    end if

  end subroutine print_mapping_from_bands


  !---------------------------------------------------------------------
  ! Return the minimum wavenumber of this object in cm-1
  pure function min_wavenumber(this)

    class(spectral_definition_type), intent(in)    :: this
    real(jprb) :: min_wavenumber

    if (this%nwav > 0) then
      min_wavenumber = this%wavenumber1(1)
    else
      min_wavenumber = minval(this%wavenumber1_band)
    end if

  end function min_wavenumber


  !---------------------------------------------------------------------
  ! Return the maximum wavenumber of this object in cm-1
  pure function max_wavenumber(this)

    class(spectral_definition_type), intent(in)    :: this
    real(jprb) :: max_wavenumber

    if (this%nwav > 0) then
      max_wavenumber = this%wavenumber1(this%nwav)
    else
      max_wavenumber = maxval(this%wavenumber2_band)
    end if

  end function max_wavenumber


  !---------------------------------------------------------------------
  ! Return the Planck function (in W m-2 (cm-1)-1) for a given
  ! wavenumber (cm-1) and temperature (K), ensuring double precision
  ! for internal calculation.  If temperature is 0 or less then unity
  ! is returned; since this function is primarily used to weight an
  ! integral by the Planck function, a temperature of 0 or less means
  ! no weighting is to be applied.
  elemental function calc_planck_function_wavenumber(wavenumber, temperature)

    use parkind1,            only : jprb, jprd
    use radiation_constants, only : SpeedOfLight, BoltzmannConstant, PlanckConstant

    real(jprb), intent(in) :: wavenumber  ! cm-1
    real(jprb), intent(in) :: temperature ! K
    real(jprb) :: calc_planck_function_wavenumber

    real(jprd) :: freq ! Hz
    real(jprd) :: planck_fn_freq ! W m-2 Hz-1

    if (temperature > 0.0_jprd) then
      freq = 100.0_jprd * real(SpeedOfLight,jprd) * real(wavenumber,jprd)
      planck_fn_freq = 2.0_jprd * real(PlanckConstant,jprd) * freq**3 &
           &  / (real(SpeedOfLight,jprd)**2 * (exp(real(PlanckConstant,jprd)*freq &
           &     /(real(BoltzmannConstant,jprd)*real(temperature,jprd))) - 1.0_jprd))
      calc_planck_function_wavenumber = real(planck_fn_freq * 100.0_jprd * real(SpeedOfLight,jprd), jprb)
    else
      calc_planck_function_wavenumber = 1.0_jprb
    end if

  end function calc_planck_function_wavenumber

end module radiation_spectral_definition

! This file has been modified for the use in ICON

! radiation_mcica_lw.F90 - Monte-Carlo Independent Column Approximation longtwave solver
!
! (C) Copyright 2015- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!
! Author:  Robin Hogan
! Email:   r.j.hogan@ecmwf.int
!
! Modifications
!   2017-04-11  R. Hogan  Receive emission/albedo rather than planck/emissivity
!   2017-04-22  R. Hogan  Store surface fluxes at all g-points
!   2017-07-12  R. Hogan  Call fast adding method if only clouds scatter
!   2017-10-23  R. Hogan  Renamed single-character variables

module radiation_mcica_lw

  public

contains

  !---------------------------------------------------------------------
  ! Longwave Monte Carlo Independent Column Approximation
  ! (McICA). This implementation performs a clear-sky and a cloudy-sky
  ! calculation, and then weights the two to get the all-sky fluxes
  ! according to the total cloud cover. This method reduces noise for
  ! low cloud cover situations, and exploits the clear-sky
  ! calculations that are usually performed for diagnostic purposes
  ! simultaneously. The cloud generator has been carefully written
  ! such that the stochastic cloud field satisfies the prescribed
  ! overlap parameter accounting for this weighting.
  subroutine solver_mcica_lw(nlev,istartcol,iendcol, &
       &  config, single_level, cloud, & 
       &  od, ssa, g, od_cloud, ssa_cloud, g_cloud, planck_hl, &
       &  emission, albedo, &
       &  flux)

    use parkind1, only           : jprb
    use yomhook,  only           : lhook, dr_hook, jphook

    use radiation_io,   only           : nulerr, radiation_abort
    use radiation_config, only         : config_type
    use radiation_single_level, only   : single_level_type
    use radiation_cloud, only          : cloud_type
    use radiation_flux, only           : flux_type
    use radiation_two_stream, only     : calc_ref_trans_lw, &
         &                               calc_no_scattering_transmittance_lw
    use radiation_adding_ica_lw, only  : adding_ica_lw, fast_adding_ica_lw, &
         &                               calc_fluxes_no_scattering_lw
    use radiation_lw_derivatives, only : calc_lw_derivatives_ica, modify_lw_derivatives_ica
    use radiation_cloud_generator, only: cloud_generator

    implicit none

    ! Inputs
    integer, intent(in) :: nlev               ! number of model levels
    integer, intent(in) :: istartcol, iendcol ! range of columns to process
    type(config_type),        intent(in) :: config
    type(single_level_type),  intent(in) :: single_level
    type(cloud_type),         intent(in) :: cloud

    ! Gas and aerosol optical depth, single-scattering albedo and
    ! asymmetry factor at each longwave g-point
    real(jprb), intent(in), dimension(config%n_g_lw, nlev, istartcol:iendcol) :: &
         &  od
    real(jprb), intent(in), dimension(config%n_g_lw_if_scattering, nlev, istartcol:iendcol) :: &
         &  ssa, g

    ! Cloud and precipitation optical depth, single-scattering albedo and
    ! asymmetry factor in each longwave band
    real(jprb), intent(in), dimension(config%n_bands_lw,nlev,istartcol:iendcol)   :: &
         &  od_cloud
    real(jprb), intent(in), dimension(config%n_bands_lw_if_scattering, &
         &  nlev,istartcol:iendcol) :: ssa_cloud, g_cloud

    ! Planck function at each half-level and the surface
    real(jprb), intent(in), dimension(config%n_g_lw,nlev+1,istartcol:iendcol) :: &
         &  planck_hl

    ! Emission (Planck*emissivity) and albedo (1-emissivity) at the
    ! surface at each longwave g-point
    real(jprb), intent(in), dimension(config%n_g_lw, istartcol:iendcol) :: emission, albedo

    ! Output
    type(flux_type), intent(inout):: flux

    ! Local variables

    ! Diffuse reflectance and transmittance for each layer in clear
    ! and all skies
    real(jprb), dimension(config%n_g_lw, nlev) :: ref_clear, trans_clear, reflectance, transmittance

    ! Emission by a layer into the upwelling or downwelling diffuse
    ! streams, in clear and all skies
    real(jprb), dimension(config%n_g_lw, nlev) :: source_up_clear, source_dn_clear, source_up, source_dn

    ! Fluxes per g point
    real(jprb), dimension(config%n_g_lw, nlev+1) :: flux_up, flux_dn
    real(jprb), dimension(config%n_g_lw, nlev+1) :: flux_up_clear, flux_dn_clear

    ! Combined gas+aerosol+cloud optical depth, single scattering
    ! albedo and asymmetry factor
    real(jprb), dimension(config%n_g_lw) :: od_total, ssa_total, g_total

    ! Combined scattering optical depth
    real(jprb) :: scat_od, scat_od_total(config%n_g_lw)

    ! Optical depth scaling from the cloud generator, zero indicating
    ! clear skies
    real(jprb), dimension(config%n_g_lw,nlev) :: od_scaling

    ! Modified optical depth after McICA scaling to represent cloud
    ! inhomogeneity
    real(jprb), dimension(config%n_g_lw) :: od_cloud_new

    ! Total cloud cover output from the cloud generator
    real(jprb) :: total_cloud_cover

    ! Identify clear-sky layers
    logical :: is_clear_sky_layer(nlev)

    ! Temporary working array
    real(jprb), dimension(config%n_g_lw,nlev+1) :: tmp_work_albedo, &
      &                                            tmp_work_source
    real(jprb), dimension(config%n_g_lw,nlev) :: tmp_work_inv_denominator


    ! Index of the highest cloudy layer
    integer :: i_cloud_top

    ! Number of g points
    integer :: ng

    ! Loop indices for level, column and g point
    integer :: jlev, jcol, jg

    real(jphook) :: hook_handle

    if (lhook) call dr_hook('radiation_mcica_lw:solver_mcica_lw',0,hook_handle)

    if (.not. config%do_clear) then
      write(nulerr,'(a)') '*** Error: longwave McICA requires clear-sky calculation to be performed'
      call radiation_abort()      
    end if

    ng = config%n_g_lw

    ! Loop through columns
    do jcol = istartcol,iendcol

      ! Clear-sky calculation
      if (config%do_lw_aerosol_scattering) then
        ! Scattering case: first compute clear-sky reflectance,
        ! transmittance etc at each model level
        call calc_ref_trans_lw(ng*nlev, &
             &  od(:,:,jcol), ssa(:,:,jcol), g(:,:,jcol), &
             &  planck_hl(:,1:nlev,jcol), planck_hl(:,2:nlev+1,jcol), &
             &  ref_clear, trans_clear, &
             &  source_up_clear, source_dn_clear)
        ! Then use adding method to compute fluxes
        call adding_ica_lw(ng, nlev, &
             &  ref_clear, trans_clear, source_up_clear, source_dn_clear, &
             &  emission(:,jcol), albedo(:,jcol), &
             &  flux_up_clear, flux_dn_clear)
      else
        ! Non-scattering case: use simpler functions for
        ! transmission and emission
        call calc_no_scattering_transmittance_lw(ng*nlev, od(:,:,jcol), &
             &  planck_hl(:,1:nlev,jcol), planck_hl(:,2:nlev+1, jcol), &
             &  trans_clear, source_up_clear, source_dn_clear)
        ! Ensure that clear-sky reflectance is zero since it may be
        ! used in cloudy-sky case
        ref_clear = 0.0_jprb
        ! Simpler down-then-up method to compute fluxes
        call calc_fluxes_no_scattering_lw(ng, nlev, &
             &  trans_clear, source_up_clear, source_dn_clear, &
             &  emission(:,jcol), albedo(:,jcol), &
             &  flux_up_clear, flux_dn_clear)       
      end if

      ! Sum over g-points to compute broadband fluxes
      flux%lw_up_clear(jcol,:) = sum(flux_up_clear,1)
      flux%lw_dn_clear(jcol,:) = sum(flux_dn_clear,1)
      ! Store surface spectral downwelling fluxes
      flux%lw_dn_surf_clear_g(:,jcol) = flux_dn_clear(:,nlev+1)

      ! Do cloudy-sky calculation; add a prime number to the seed in
      ! the longwave
      call cloud_generator(ng, nlev, config%i_overlap_scheme, &
           &  single_level%iseed(jcol) + 997, &
           &  config%cloud_fraction_threshold, &
           &  cloud%fraction(jcol,:), cloud%overlap_param(jcol,:), &
           &  config%cloud_inhom_decorr_scaling, cloud%fractional_std(jcol,:), &
           &  config%pdf_sampler, od_scaling, total_cloud_cover, &
           &  use_beta_overlap=config%use_beta_overlap, &
           &  use_vectorizable_generator=config%use_vectorizable_generator)
      
      ! Store total cloud cover
      flux%cloud_cover_lw(jcol) = total_cloud_cover
      
      if (total_cloud_cover >= config%cloud_fraction_threshold) then
        ! Total-sky calculation

        is_clear_sky_layer = .true.
        i_cloud_top = nlev+1
        do jlev = 1,nlev
          ! Compute combined gas+aerosol+cloud optical properties
          if (cloud%fraction(jcol,jlev) >= config%cloud_fraction_threshold) then
            is_clear_sky_layer(jlev) = .false.
            ! Get index to the first cloudy layer from the top
            if (i_cloud_top > jlev) then
              i_cloud_top = jlev
            end if

            do jg = 1,ng
              od_cloud_new(jg) = od_scaling(jg,jlev) &
                 &  * od_cloud(config%i_band_from_reordered_g_lw(jg),jlev,jcol)
              od_total(jg)  = od(jg,jlev,jcol) + od_cloud_new(jg)
              ssa_total(jg) = 0.0_jprb
              g_total(jg)   = 0.0_jprb
            end do

            if (config%do_lw_cloud_scattering) then
              ! Scattering case: calculate reflectance and
              ! transmittance at each model level

              if (config%do_lw_aerosol_scattering) then
                ! In single precision we need to protect against the
                ! case that od_total > 0.0 and ssa_total > 0.0 but
                ! od_total*ssa_total == 0 due to underflow
                do jg = 1,ng
                  if (od_total(jg) > 0.0_jprb) then
                    scat_od_total(jg) = ssa(jg,jlev,jcol)*od(jg,jlev,jcol) &
                     &     + ssa_cloud(config%i_band_from_reordered_g_lw(jg),jlev,jcol) &
                     &     *  od_cloud_new(jg)
                    ssa_total(jg) = scat_od_total(jg) / od_total(jg)

                    if (scat_od_total(jg) > 0.0_jprb) then
                      g_total(jg) = (g(jg,jlev,jcol)*ssa(jg,jlev,jcol)*od(jg,jlev,jcol) &
                         &     +   g_cloud(config%i_band_from_reordered_g_lw(jg),jlev,jcol) &
                         &     * ssa_cloud(config%i_band_from_reordered_g_lw(jg),jlev,jcol) &
                         &     *  od_cloud_new(jg)) &
                         &     / scat_od_total(jg)
                    end if
                  end if
                end do

              else

                do jg = 1,ng
                  if (od_total(jg) > 0.0_jprb) then
                    scat_od = ssa_cloud(config%i_band_from_reordered_g_lw(jg),jlev,jcol) &
                         &     * od_cloud_new(jg)
                    ssa_total(jg) = scat_od / od_total(jg)
                    if (scat_od > 0.0_jprb) then
                      g_total(jg) = g_cloud(config%i_band_from_reordered_g_lw(jg),jlev,jcol) &
                           &     * ssa_cloud(config%i_band_from_reordered_g_lw(jg),jlev,jcol) &
                           &     *  od_cloud_new(jg) / scat_od
                    end if
                  end if
                end do

              end if
            
              ! Compute cloudy-sky reflectance, transmittance etc at
              ! each model level
              call calc_ref_trans_lw(ng, &
                   &  od_total, ssa_total, g_total, &
                   &  planck_hl(:,jlev,jcol), planck_hl(:,jlev+1,jcol), &
                   &  reflectance(:,jlev), transmittance(:,jlev), &
                   &  source_up(:,jlev), source_dn(:,jlev))
            else
              ! No-scattering case: use simpler functions for
              ! transmission and emission
              call calc_no_scattering_transmittance_lw(ng, od_total, &
                   &  planck_hl(:,jlev,jcol), planck_hl(:,jlev+1, jcol), &
                   &  transmittance(:,jlev), source_up(:,jlev), source_dn(:,jlev))
            end if

          else
            ! Clear-sky layer: copy over clear-sky values
            reflectance(:,jlev) = ref_clear(:,jlev)
            transmittance(:,jlev) = trans_clear(:,jlev)
            source_up(:,jlev) = source_up_clear(:,jlev)
            source_dn(:,jlev) = source_dn_clear(:,jlev)
          end if
        end do
        
        if (config%do_lw_aerosol_scattering) then
          ! Use adding method to compute fluxes for an overcast sky,
          ! allowing for scattering in all layers
          call adding_ica_lw(ng, nlev, reflectance, transmittance, source_up, source_dn, &
               &  emission(:,jcol), albedo(:,jcol), &
               &  flux_up, flux_dn)
        else if (config%do_lw_cloud_scattering) then
          ! Use adding method to compute fluxes but optimize for the
          ! presence of clear-sky layers
          call fast_adding_ica_lw(ng, nlev, reflectance, transmittance, source_up, source_dn, &
               &  emission(:,jcol), albedo(:,jcol), &
               &  is_clear_sky_layer, i_cloud_top, flux_dn_clear, &
               &  flux_up, flux_dn, &
               &  albedo=tmp_work_albedo, &
               &  source=tmp_work_source, &
               &  inv_denominator=tmp_work_inv_denominator)
        else
          ! Simpler down-then-up method to compute fluxes
          call calc_fluxes_no_scattering_lw(ng, nlev, &
               &  transmittance, source_up, source_dn, emission(:,jcol), albedo(:,jcol), &
               &  flux_up, flux_dn)
        end if
        
        ! Store overcast broadband fluxes
        flux%lw_up(jcol,:) = sum(flux_up,1)
        flux%lw_dn(jcol,:) = sum(flux_dn,1)

        ! Cloudy flux profiles currently assume completely overcast
        ! skies; perform weighted average with clear-sky profile
        flux%lw_up(jcol,:) =  total_cloud_cover *flux%lw_up(jcol,:) &
             &  + (1.0_jprb - total_cloud_cover)*flux%lw_up_clear(jcol,:)
        flux%lw_dn(jcol,:) =  total_cloud_cover *flux%lw_dn(jcol,:) &
             &  + (1.0_jprb - total_cloud_cover)*flux%lw_dn_clear(jcol,:)
        ! Store surface spectral downwelling fluxes
        flux%lw_dn_surf_g(:,jcol) = total_cloud_cover*flux_dn(:,nlev+1) &
             &  + (1.0_jprb - total_cloud_cover)*flux%lw_dn_surf_clear_g(:,jcol)

        ! Compute the longwave derivatives needed by Hogan and Bozzo
        ! (2015) approximate radiation update scheme
        if (config%do_lw_derivatives) then
          call calc_lw_derivatives_ica(ng, nlev, jcol, transmittance, flux_up(:,nlev+1), &
               &                       flux%lw_derivatives)
          if (total_cloud_cover < 1.0_jprb - config%cloud_fraction_threshold) then
            ! Modify the existing derivative with the contribution from the clear sky
            call modify_lw_derivatives_ica(ng, nlev, jcol, trans_clear, flux_up_clear(:,nlev+1), &
                 &                         1.0_jprb-total_cloud_cover, flux%lw_derivatives)
          end if
        end if

      else
        ! No cloud in profile and clear-sky fluxes already
        ! calculated: copy them over
        flux%lw_up(jcol,:) = flux%lw_up_clear(jcol,:)
        flux%lw_dn(jcol,:) = flux%lw_dn_clear(jcol,:)
        flux%lw_dn_surf_g(:,jcol) = flux%lw_dn_surf_clear_g(:,jcol)
        if (config%do_lw_derivatives) then
          call calc_lw_derivatives_ica(ng, nlev, jcol, trans_clear, flux_up_clear(:,nlev+1), &
               &                       flux%lw_derivatives)
 
        end if
      end if ! Cloud is present in profile
    end do

    if (lhook) call dr_hook('radiation_mcica_lw:solver_mcica_lw',1,hook_handle)
    
  end subroutine solver_mcica_lw

end module radiation_mcica_lw

SUBROUTINE SRTM_CMBGB25

!     BAND 25:  16000-22650 cm-1 (low - H2O; high - nothing)
!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM , JPRB
USE YOMHOOK   ,ONLY : LHOOK, DR_HOOK

USE YOESRTM  , ONLY : NGN
USE YOESRTWN , ONLY : NGC, NGS, RWGT
!USE YOESRTWN , ONLY : NGC, NGS, NGN, RWGT
USE YOESRTA25, ONLY : KA, SFLUXREF, ABSO3A, ABSO3B, RAYL, &
                    & KAC, SFLUXREFC, ABSO3AC, ABSO3BC, RAYLC

IMPLICIT NONE

! Local variables
INTEGER(KIND=JPIM) :: JT, JP, IGC, IPR, IPRSM
REAL(KIND=JPRB)    :: ZSUMK, ZSUMF1, ZSUMF2, ZSUMF3, ZSUMF4

REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('SRTM_CMBGB25',0,ZHOOK_HANDLE)

DO JT = 1,5
  DO JP = 1,13
    IPRSM = 0
    DO IGC = 1,NGC(10)
      ZSUMK = 0.
      DO IPR = 1, NGN(NGS(9)+IGC)
        IPRSM = IPRSM + 1
        ZSUMK = ZSUMK + KA(JT,JP,IPRSM)*RWGT(IPRSM+144)
      ENDDO
      KAC(JT,JP,IGC) = ZSUMK
    ENDDO
  ENDDO
ENDDO

IPRSM = 0
DO IGC = 1,NGC(10)
  ZSUMF1 = 0.
  ZSUMF2 = 0.
  ZSUMF3 = 0.
  ZSUMF4 = 0.
  DO IPR = 1, NGN(NGS(9)+IGC)
    IPRSM = IPRSM + 1
    ZSUMF1 = ZSUMF1 + SFLUXREF(IPRSM)
    ZSUMF2 = ZSUMF2 + ABSO3A(IPRSM)*RWGT(IPRSM+144)
    ZSUMF3 = ZSUMF3 + ABSO3B(IPRSM)*RWGT(IPRSM+144)
    ZSUMF4 = ZSUMF4 + RAYL(IPRSM)*RWGT(IPRSM+144)
  ENDDO
  SFLUXREFC(IGC) = ZSUMF1
  ABSO3AC(IGC) = ZSUMF2
  ABSO3BC(IGC) = ZSUMF3
  RAYLC(IGC) = ZSUMF4
ENDDO

!     -----------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('SRTM_CMBGB25',1,ZHOOK_HANDLE)
END SUBROUTINE SRTM_CMBGB25

! $Header$
!$gpum horizontal klon
MODULE ajsec_mod
  PRIVATE

  PUBLIC ajsec, ajsec_convv2, ajsec_old

  CONTAINS

SUBROUTINE ajsec(paprs, pplay, t, q, limbas, d_t, d_q &
#ifdef ISO      
               ,xt,d_xt &
#endif
          )
  USE dimphy
#ifdef ISO
  USE infotrac_phy, ONLY: ntraciso =>ntiso   
#ifdef ISOVERIF
  USE isotopes_mod, ONLY : iso_eau,iso_HDO
  USE isotopes_verif_mod, ONLY: iso_verif_egalite, &
        iso_verif_egalite_choix,iso_verif_noNaN,errmax,errmaxrel 
#ifdef ISOTRAC
  USE isotopes_verif_mod, ONLY: iso_verif_traceur,iso_verif_traceur_justmass
#endif
#endif
#endif
  USE yomcst_mod_h
IMPLICIT NONE
  ! ======================================================================
  ! Auteur(s): Z.X. Li (LMD/CNRS) date: 19930818
  ! Objet: ajustement sec (adaptation du GCM du LMD)
  ! ======================================================================
  ! Arguments:
  ! t-------input-R- Temperature

  ! d_t-----output-R-Incrementation de la temperature
  ! ======================================================================

  REAL paprs(klon, klev+1), pplay(klon, klev)
  REAL t(klon, klev), q(klon, klev)
  REAL d_t(klon, klev), d_q(klon, klev)

  INTEGER limbas(klon), limhau ! les couches a ajuster

  LOGICAL mixq
  ! cc      PARAMETER (mixq=.TRUE.)
  PARAMETER (mixq=.FALSE.)

  REAL zh(klon, klev)
  REAL zho(klon, klev)
  REAL zq(klon, klev)
  REAL zpk(klon, klev)
  REAL zpkdp(klon, klev)
  REAL hm, sm, qm
  LOGICAL modif(klon), down
  INTEGER i, k, k1, k2
#ifdef ISO
  REAL xt(ntraciso,klon,klev)
  REAL d_xt(ntraciso,klon,klev)
  REAL zxt(ntraciso,klon,klev)
  REAL xtm(ntraciso)
  INTEGER ixt
#endif

  ! Initialisation:

#ifdef ISO
#ifdef ISOVERIF
  DO i=1,klon
    DO k=1,klev         
      IF (iso_eau.GT.0) THEN
        CALL iso_verif_egalite_choix(q(i,k),xt(iso_eau,i,k), &
             'ajsec 67',errmax,errmaxrel)
      ENDIF !if (iso_eau.gt.0) then
    ENDDO !do k=limbas,limhau
  ENDDO !do i=1,klon
#endif
#endif

  ! ym
  limhau = klev

  DO k = 1, klev
    DO i = 1, klon
      d_t(i, k) = 0.0
      d_q(i, k) = 0.0
#ifdef ISO
      DO ixt=1,ntraciso
         d_xt(ixt,i,k)=0.0
      ENDDO
#endif
    ENDDO
  ENDDO
  ! ------------------------------------- detection des profils a modifier
  DO k = 1, limhau
    DO i = 1, klon
      zpk(i, k) = pplay(i, k)**rkappa
      zh(i, k) = rcpd*t(i, k)/zpk(i, k)
      zho(i, k) = zh(i, k)
      zq(i, k) = q(i, k)
#ifdef ISO
      DO ixt=1,ntraciso
         zxt(ixt,i,k)=xt(ixt,i,k)
      ENDDO
#endif
    ENDDO
  ENDDO

  DO k = 1, limhau
    DO i = 1, klon
      zpkdp(i, k) = zpk(i, k)*(paprs(i,k)-paprs(i,k+1))
    ENDDO
  ENDDO

  DO i = 1, klon
    modif(i) = .FALSE.
  ENDDO
  DO k = 2, limhau
    DO i = 1, klon
      IF (.NOT. modif(i) .AND. k-1>limbas(i)) THEN
        IF (zh(i,k)<zh(i,k-1)) modif(i) = .TRUE.
      ENDIF
    ENDDO
  ENDDO
  ! ------------------------------------- correction des profils instables
  DO i = 1, klon
    IF (modif(i)) THEN
      k2 = limbas(i)
8000  CONTINUE
      k2 = k2 + 1
      IF (k2>limhau) GO TO 8001
      IF (zh(i,k2)<zh(i,k2-1)) THEN
        k1 = k2 - 1
        k = k1
        sm = zpkdp(i, k2)
        hm = zh(i, k2)
        qm = zq(i, k2)
#ifdef ISO
        DO ixt=1,ntraciso
           xtm(ixt)=zxt(ixt,i,k2)
        ENDDO    
#ifdef ISOVERIF
        IF (iso_eau.GT.0) THEN
           CALL iso_verif_egalite_choix(qm,xtm(iso_eau), &
                             'ajsec 126',errmax,errmaxrel)
        ENDIF !if (iso_eau.gt.0) then      
#endif
#endif
8020    CONTINUE
        sm = sm + zpkdp(i, k)
        hm = hm + zpkdp(i, k)*(zh(i,k)-hm)/sm
        qm = qm + zpkdp(i, k)*(zq(i,k)-qm)/sm
#ifdef ISO
        DO ixt=1,ntraciso
           xtm(ixt)=xtm(ixt) &
                   +zpkdp(i,k)*(zxt(ixt,i,k)-xtm(ixt))/sm
        ENDDO    
#ifdef ISOVERIF
        IF (iso_eau.GT.0) THEN
           CALL iso_verif_egalite_choix(qm,xtm(iso_eau), &
                             'ajsec 136',errmax,errmaxrel)
        ENDIF !if (iso_eau.gt.0) then      
#endif
#endif
        down = .FALSE.
        IF (k1/=limbas(i)) THEN
          IF (hm<zh(i,k1-1)) down = .TRUE.
        ENDIF
        IF (down) THEN
          k1 = k1 - 1
          k = k1
        ELSE
          IF ((k2==limhau)) GO TO 8021
          IF ((zh(i,k2+1)>=hm)) GO TO 8021
          k2 = k2 + 1
          k = k2
        ENDIF
        GO TO 8020
8021    CONTINUE
        ! ------------ nouveau profil : constant (valeur moyenne)
        DO k = k1, k2
          zh(i, k) = hm
          zq(i, k) = qm
#ifdef ISO
          DO ixt=1,ntraciso
             zxt(ixt,i,k)=xtm(ixt)
          ENDDO
#endif
        ENDDO
        k2 = k2 + 1
      ENDIF
      GO TO 8000
8001  CONTINUE
    ENDIF
  ENDDO

#ifdef ISO
      ! cam verif
#ifdef ISOVERIF
  DO i=1,klon
    DO k=1,klev
      DO ixt=1,ntraciso
        CALL iso_verif_noNaN(zxt(ixt,i,k),'ajsec 173')
      ENDDO !do ixt=1,niso           
      IF (iso_eau.GT.0) THEN
        CALL iso_verif_egalite_choix(zq(i,k),zxt(iso_eau,i,k), &
             'ajsec 168',errmax,errmaxrel)
      ENDIF !if (iso_eau.gt.0) then
#ifdef ISOTRAC      
      CALL iso_verif_traceur(zxt(1,i,k),'ajsec 181')
#endif           
    ENDDO !do k=limbas,limhau
  ENDDO !do i=1,klon
#endif
      ! end cam verif
#endif

  DO k = 1, limhau
    DO i = 1, klon
      d_t(i, k) = (zh(i,k)-zho(i,k))*zpk(i, k)/rcpd
      d_q(i, k) = zq(i, k) - q(i, k)
#ifdef ISO
      DO ixt=1,ntraciso
        d_xt(ixt,i,k)=zxt(ixt,i,k)-xt(ixt,i,k)
      ENDDO
#endif
    ENDDO
  ENDDO

#ifdef ISO
      ! cam verif
#ifdef ISOVERIF
  DO i = 1, klon
    DO k = 1, limhau
      IF (iso_eau.GT.0) THEN
        CALL iso_verif_egalite_choix(d_q(i,k),d_xt(iso_eau,i,k), &
             'ajsec 198',errmax,errmaxrel)
      ENDIF
#ifdef ISOTRAC      
      CALL iso_verif_traceur_justmass(d_xt(1,i,k),'physiq 210')
#endif         
    ENDDO
  ENDDO
#endif
      ! end cam verif      
#endif

  ! FH : les d_q et d_t sont maintenant calcules de facon a valoir
  ! effectivement 0. si on ne fait rien.

  ! IF (limbas.GT.1) THEN
  ! DO k = 1, limbas-1
  ! DO i = 1, klon
  ! d_t(i,k) = 0.0
  ! d_q(i,k) = 0.0
  ! ENDDO
  ! ENDDO
  ! ENDIF

  ! IF (limhau.LT.klev) THEN
  ! DO k = limhau+1, klev
  ! DO i = 1, klon
  ! d_t(i,k) = 0.0
  ! d_q(i,k) = 0.0
  ! ENDDO
  ! ENDDO
  ! ENDIF

  IF (.NOT. mixq) THEN
    DO k = 1, klev
      DO i = 1, klon
        d_q(i, k) = 0.0
#ifdef ISO
        DO ixt=1,ntraciso
           d_xt(ixt,i,k)=0.0
        ENDDO
#endif
      ENDDO
    ENDDO
  ENDIF

#ifdef ISO
      ! cam verif
#ifdef ISOVERIF
  DO i = 1, klon
    DO k = 1, klev
      IF (iso_eau.GT.0) THEN
        CALL iso_verif_egalite(d_q(i,k),d_xt(iso_eau,i,k),'ajsec 270')
      ENDIF
#ifdef ISOTRAC      
      CALL iso_verif_traceur_justmass(d_xt(1,i,k),'physiq 3045')
#endif         
    ENDDO
  ENDDO
#endif
      ! end cam verif
#endif

  RETURN
END SUBROUTINE ajsec

SUBROUTINE ajsec_convv2(paprs, pplay, t, q, d_t, d_q &
#ifdef ISO
           ,xt,d_xt &     
#endif         
        )
  USE dimphy
#ifdef ISO
  USE infotrac_phy, ONLY: ntraciso=>ntiso    
#ifdef ISOVERIF
  USE isotopes_mod, ONLY : iso_eau,iso_HDO
  USE isotopes_verif_mod, ONLY: iso_verif_egalite, &
        iso_verif_egalite_choix,iso_verif_noNaN,errmax,errmaxrel
#ifdef ISOTRAC
  USE isotopes_verif_mod, ONLY: iso_verif_traceur,iso_verif_traceur_justmass
#endif
#endif
#endif
  USE yomcst_mod_h
IMPLICIT NONE
  ! ======================================================================
  ! Auteur(s): Z.X. Li (LMD/CNRS) date: 19930818
  ! Objet: ajustement sec (adaptation du GCM du LMD)
  ! ======================================================================
  ! Arguments:
  ! t-------input-R- Temperature

  ! d_t-----output-R-Incrementation de la temperature
  ! ======================================================================

  REAL paprs(klon, klev+1), pplay(klon, klev)
  REAL t(klon, klev), q(klon, klev)
  REAL d_t(klon, klev), d_q(klon, klev)

  INTEGER limbas, limhau ! les couches a ajuster
  ! cc      PARAMETER (limbas=klev-3, limhau=klev)
  ! ym      PARAMETER (limbas=1, limhau=klev)

  LOGICAL mixq
  ! cc      PARAMETER (mixq=.TRUE.)
  PARAMETER (mixq=.FALSE.)

  REAL zh(klon, klev)
  REAL zq(klon, klev)
  REAL zpk(klon, klev)
  REAL zpkdp(klon, klev)
  REAL hm, sm, qm
  LOGICAL modif(klon), down
  INTEGER i, k, k1, k2

#ifdef ISO
  REAL xt(ntraciso,klon,klev)
  REAL d_xt(ntraciso,klon,klev)
  REAL zxt(ntraciso,klon,klev)
  REAL xtm(ntraciso)
  INTEGER ixt
#endif


#ifdef ISO
  ! cam verif
#ifdef ISOVERIF
  DO i=1,klon
    DO k=1,klev
      DO ixt=1,ntraciso
        CALL iso_verif_noNAN(xt(ixt,i,k),'ajsec 320')
      ENDDO !do ixt=1,niso           
      IF (iso_eau.GT.0) THEN
        CALL iso_verif_egalite_choix(q(i,k),xt(iso_eau,i,k), &
             'ajsec 324',errmax,errmaxrel)
      ENDIF !if (iso_eau.gt.0) then
#ifdef ISOTRAC      
      CALL iso_verif_traceur(xt(1,i,k),'ajsec 327')
#endif           
    ENDDO !do k=1,klev
  ENDDO !do i=1,klon
#endif
      ! end cam verif
#endif

  ! Initialisation:

  ! ym
  limbas = 1
  limhau = klev

  DO k = 1, klev
    DO i = 1, klon
      d_t(i, k) = 0.0
      d_q(i, k) = 0.0
#ifdef ISO
      DO ixt=1,ntraciso
        d_xt(ixt,i,k)=0.0
      ENDDO
#endif
    ENDDO
  ENDDO
  ! ------------------------------------- detection des profils a modifier
  DO k = limbas, limhau
    DO i = 1, klon
      zpk(i, k) = pplay(i, k)**rkappa
      zh(i, k) = rcpd*t(i, k)/zpk(i, k)
      zq(i, k) = q(i, k)
#ifdef ISO
      DO ixt=1,ntraciso
        zxt(ixt,i,k)=xt(ixt,i,k)
      ENDDO
#endif
    ENDDO
  ENDDO

  DO k = limbas, limhau
    DO i = 1, klon
      zpkdp(i, k) = zpk(i, k)*(paprs(i,k)-paprs(i,k+1))
    ENDDO
  ENDDO

  DO i = 1, klon
    modif(i) = .FALSE.
  ENDDO
  DO k = limbas + 1, limhau
    DO i = 1, klon
      IF (.NOT. modif(i)) THEN
        IF (zh(i,k)<zh(i,k-1)) modif(i) = .TRUE.
      ENDIF
    ENDDO
  ENDDO
  ! ------------------------------------- correction des profils instables
  DO i = 1, klon
    IF (modif(i)) THEN
      k2 = limbas
8000  CONTINUE
      k2 = k2 + 1
      IF (k2>limhau) GO TO 8001
      IF (zh(i,k2)<zh(i,k2-1)) THEN
        k1 = k2 - 1
        k = k1
        sm = zpkdp(i, k2)
        hm = zh(i, k2)
        qm = zq(i, k2)
#ifdef ISO
        DO ixt=1,ntraciso
          xtm(ixt)=zxt(ixt,i,k2)
        ENDDO
#endif
8020    CONTINUE
        sm = sm + zpkdp(i, k)
        hm = hm + zpkdp(i, k)*(zh(i,k)-hm)/sm
        qm = qm + zpkdp(i, k)*(zq(i,k)-qm)/sm
#ifdef ISO
        DO ixt=1,ntraciso
          xtm(ixt)=xtm(ixt) &
                  +zpkdp(i,k)*(zxt(ixt,i,k)-xtm(ixt))/sm
        ENDDO
#endif
        down = .FALSE.
        IF (k1/=limbas) THEN
          IF (hm<zh(i,k1-1)) down = .TRUE.
        ENDIF
        IF (down) THEN
          k1 = k1 - 1
          k = k1
        ELSE
          IF ((k2==limhau)) GO TO 8021
          IF ((zh(i,k2+1)>=hm)) GO TO 8021
          k2 = k2 + 1
          k = k2
        ENDIF
        GO TO 8020
8021    CONTINUE
        ! ------------ nouveau profil : constant (valeur moyenne)
        DO k = k1, k2
          zh(i, k) = hm
          zq(i, k) = qm
#ifdef ISO
          DO ixt=1,ntraciso
            zxt(ixt,i,k)=xtm(ixt)
          ENDDO
#endif
        ENDDO
        k2 = k2 + 1
      ENDIF
      GO TO 8000
8001  CONTINUE
    ENDIF
  ENDDO

#ifdef ISO
      ! cam verif
#ifdef ISOVERIF
  DO i=1,klon
    DO k=limbas,limhau
      DO ixt=1,ntraciso
        CALL iso_verif_noNAN(zxt(ixt,i,k),'ajsec 428')
      ENDDO !do ixt=1,niso           
      IF (iso_eau.GT.0) THEN
        CALL iso_verif_egalite_choix(zq(i,k),zxt(iso_eau,i,k), &
             'ajsec 432',errmax,errmaxrel)
      ENDIF !if (iso_eau.gt.0) then
#ifdef ISOTRAC      
      CALL iso_verif_traceur(zxt(1,i,k),'ajsec 436')
#endif           
    ENDDO !do k=limbas,limhau
  ENDDO !do i=1,klon
#endif
      ! end cam verif
#endif   


  DO k = limbas, limhau
    DO i = 1, klon
      d_t(i, k) = zh(i, k)*zpk(i, k)/rcpd - t(i, k)
      d_q(i, k) = zq(i, k) - q(i, k)
#ifdef ISO
      DO ixt=1,ntraciso
         d_xt(ixt,i,k)=zxt(ixt,i,k)-xt(ixt,i,k)
      ENDDO
#endif
    ENDDO
  ENDDO

  IF (limbas>1) THEN
    DO k = 1, limbas - 1
      DO i = 1, klon
        d_t(i, k) = 0.0
        d_q(i, k) = 0.0
#ifdef ISO
        DO ixt=1,ntraciso
          d_xt(ixt,i,k)=0.0
        ENDDO
#endif
      ENDDO
    ENDDO
  ENDIF

  IF (limhau<klev) THEN
    DO k = limhau + 1, klev
      DO i = 1, klon
        d_t(i, k) = 0.0
        d_q(i, k) = 0.0
#ifdef ISO
        DO ixt=1,ntraciso
          d_xt(ixt,i,k)=0.0
        ENDDO
#endif
      ENDDO
    ENDDO
  ENDIF

  IF (.NOT. mixq) THEN
    DO k = 1, klev
      DO i = 1, klon
        d_q(i, k) = 0.0
#ifdef ISO
        DO ixt=1,ntraciso
          d_xt(ixt,i,k)=0.0
        ENDDO
#endif
      ENDDO
    ENDDO
  ENDIF


#ifdef ISO
      ! cam verif
#ifdef ISOVERIF
  DO i = 1, klon
    DO k = limbas, limhau
      IF (iso_eau.GT.0) THEN
        CALL iso_verif_egalite(d_q(i,k),d_xt(iso_eau,i,k),'ajsec 270')
      ENDIF
#ifdef ISOTRAC      
      CALL iso_verif_traceur_justmass(d_xt(1,i,k),'physiq 3045')
#endif         
    ENDDO
  ENDDO
#endif
      ! end cam verif
#endif

  RETURN
END SUBROUTINE ajsec_convv2

SUBROUTINE ajsec_old(paprs, pplay, t, d_t)
  USE dimphy
  USE yomcst_mod_h
  IMPLICIT NONE
  ! ======================================================================
  ! Auteur(s): Z.X. Li (LMD/CNRS) date: 19930818
  ! Objet: ajustement sec (adaptation du GCM du LMD)
  ! ======================================================================
  ! Arguments:
  ! t-------input-R- Temperature

  ! d_t-----output-R-Incrementation de la temperature
  ! ======================================================================

  REAL paprs(klon, klev+1), pplay(klon, klev)
  REAL t(klon, klev)
  REAL d_t(klon, klev)

  REAL local_h(klon, klev)
  REAL hm, sm
  LOGICAL modif(klon), down
  INTEGER i, l, l1, l2
  ! ------------------------------------- detection des profils a modifier
  DO i = 1, klon
    modif(i) = .FALSE.
  END DO

  DO l = 1, klev
    DO i = 1, klon
      local_h(i, l) = rcpd*t(i, l)/(pplay(i,l)**rkappa)
    END DO
  END DO

  DO l = 2, klev
    DO i = 1, klon
      IF (local_h(i,l)<local_h(i,l-1)) THEN
        modif(i) = .TRUE.
      ELSE
        modif(i) = modif(i)
      END IF
    END DO
  END DO
  ! ------------------------------------- correction des profils instables
  DO i = 1, klon
    IF (modif(i)) THEN
      l2 = 1
8000  CONTINUE
      l2 = l2 + 1
      IF (l2>klev) GO TO 8001
      IF (local_h(i,l2)<local_h(i,l2-1)) THEN
        l1 = l2 - 1
        l = l1
        sm = pplay(i, l2)**rkappa*(paprs(i,l2)-paprs(i,l2+1))
        hm = local_h(i, l2)
8020    CONTINUE
        sm = sm + pplay(i, l)**rkappa*(paprs(i,l)-paprs(i,l+1))
        hm = hm + pplay(i, l)**rkappa*(paprs(i,l)-paprs(i,l+1))*(local_h(i,l) &
          -hm)/sm
        down = .FALSE.
        IF (l1/=1) THEN
          IF (hm<local_h(i,l1-1)) THEN
            down = .TRUE.
          END IF
        END IF
        IF (down) THEN
          l1 = l1 - 1
          l = l1
        ELSE
          IF ((l2==klev)) GO TO 8021
          IF ((local_h(i,l2+1)>=hm)) GO TO 8021
          l2 = l2 + 1
          l = l2
        END IF
        GO TO 8020
8021    CONTINUE
        ! ------------ nouveau profil : constant (valeur moyenne)
        DO l = l1, l2
          local_h(i, l) = hm
        END DO
        l2 = l2 + 1
      END IF
      GO TO 8000
8001  CONTINUE
    END IF
  END DO

  DO l = 1, klev
    DO i = 1, klon
      d_t(i, l) = local_h(i, l)*(pplay(i,l)**rkappa)/rcpd - t(i, l)
    END DO
  END DO

  RETURN
END SUBROUTINE ajsec_old

END MODULE ajsec_mod

! This file has been modified for the use in ICON

MODULE YOERRTA7

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

PUBLIC

SAVE

!     -----------------------------------------------------------------
!*    ** *YOERRTA7* - RRTM COEFFICIENTS FOR INTERVAL 7
!     BAND 7:  980-1080 cm-1 (low - H2O,O3; high - O3)
!     ABozzo updated to rrtmg v4.85
!     -----------------------------------------------------------------

INTEGER(KIND=JPIM), PARAMETER :: NG7  = 12

REAL(KIND=JPRB) :: FRACREFA(NG7,9)

REAL(KIND=JPRB) , DIMENSION(NG7) :: FRACREFB
REAL(KIND=JPRB) :: KA(9,5,13,NG7) ,ABSA(585,NG7)
REAL(KIND=JPRB) :: KB(5,13:59,NG7),ABSB(235,NG7)
REAL(KIND=JPRB) :: SELFREF(10,NG7)
REAL(KIND=JPRB) :: KA_MCO2(9,19,NG7)
REAL(KIND=JPRB) :: KB_MCO2(19,NG7)
REAL(KIND=JPRB) :: FORREF(4,NG7)

EQUIVALENCE (KA(1,1,1,1),ABSA(1,1)),(KB(1,13,1),ABSB(1,1))

!$ACC DECLARE CREATE(FRACREFA, FRACREFB, KA, ABSA, KB, ABSB, SELFREF, KA_MCO2, &
!$ACC                KB_MCO2, FORREF)

!     -----------------------------------------------------------------
!        * E.C.M.W.F. PHYSICS PACKAGE *

!     J.-J. MORCRETTE       E.C.M.W.F.      98/07/14

!  NAME     TYPE     PURPOSE
!  ----   : ----   : --------------------------------------------------- 
! ABSA    : REAL     absorption coefficient of major absorber for M reference tropospheric 
!                    pressures and N reference tropospheric temperatures 
! ABSB    : REAL     absorption coefficient of secondary absorber for M reference stratospheric
!                    pressures and N reference stratospheric temperatures 
! ABSCO2  : REAL     absorption coefficient for CO2
! FRACREFA: REAL     distance from r and T reference tabulated points (troposphere)
! FRACREFB: REAL     distance from r and T reference tabulated points (stratosphere)
! KA      : REAL     absorption coefficient of major absorber (equiv. to ABSA)   
! KB      : REAL     absorption coefficient of secondary absorber (equiv. to ABSB)   
! SELFREF : REAL     self broadening coefficient for water vapour
! STRRAT  : REAL     weighting factors for the transition between tropospheric 
!                    and stratospheric computations
!     -----------------------------------------------------------------
END MODULE YOERRTA7

!
! $Id: ocean_forced_mod.F90 6180 2026-04-20 18:53:25Z evignon $
!
MODULE ocean_forced_mod
!
! This module is used for both the sub-surfaces ocean and sea-ice for the case of a
! forced ocean,  "ocean=force".
!
   IMPLICIT NONE

CONTAINS
!
!****************************************************************************************
!
   SUBROUTINE ocean_forced_noice( &
      itime, dtime, jour, knon, knindex, &
      p1lay, cdragh, cdragq, cdragm, precip_rain, precip_snow, &
      temp_air, spechum, &
      AcoefH, AcoefQ, BcoefH, BcoefQ, &
      AcoefU, AcoefV, BcoefU, BcoefV, &
      ps, u1, v1, gustiness, tsurf_in, &
      radsol, snow, agesno, &
      qsurf, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
      tsurf_new, dflux_s, dflux_l, sens_prec_liq, rhoa, &
      dthetadz300, pctsrf, Ampl &
#ifdef ISO
      , xtprecip_rain, xtprecip_snow, xtspechum, Roce, rlat, &
      xtsnow, xtevap, h1 &
#endif
      )
!$gpum horizontal knon klon

!===========================================================================================
! This subroutine treats the "open ocean" tile in forced mode that is, when LMDZ is not
! coupled to the slab or to NEMO.
! The routine receives data from boundary-file limit.nc and does some calculations at the
! surface.
!===========================================================================================

      USE dimphy
      USE calcul_fluxs_mod
      USE limit_read_mod
      USE mod_grid_phy_lmdz
      USE indice_sol_mod
      USE surface_data, ONLY: iflag_leads
      USE phys_output_var_mod, ONLY: sens_prec_liq_o, sens_prec_sol_o, lat_prec_liq_o, lat_prec_sol_o
      use config_ocean_skin_m, only: activate_ocean_skin
      USE calbeta_mod, ONLY: calbeta

#ifdef ISO
      USE infotrac_phy, ONLY: ntiso, niso
      USE isotopes_routines_mod, ONLY: calcul_iso_surf_oce_vectall, calcul_iso_surf_sic_vectall
#ifdef ISOVERIF
      USE isotopes_mod, ONLY: iso_eau, ridicule
      !USE isotopes_verif_mod, ONLY: errmax,errmaxrel,iso_verif_egalite_choix
      USE isotopes_verif_mod
#endif
#endif
      USE flux_arp_mod_h
      USE clesphys_mod_h
      USE yomcst_mod_h

! Input arguments
!****************************************************************************************
      INTEGER, INTENT(IN)                      :: itime, jour, knon
      INTEGER, DIMENSION(knon), INTENT(IN)     :: knindex
      REAL, INTENT(IN)                         :: dtime
      REAL, DIMENSION(knon), INTENT(IN)        :: p1lay
      REAL, DIMENSION(knon), INTENT(IN)        :: cdragh, cdragq, cdragm
      REAL, DIMENSION(knon), INTENT(IN)        :: precip_rain, precip_snow
      REAL, DIMENSION(knon), INTENT(IN)        :: temp_air, spechum
      REAL, DIMENSION(knon), INTENT(IN)        :: AcoefH, AcoefQ, BcoefH, BcoefQ
      REAL, DIMENSION(knon), INTENT(IN)        :: AcoefU, AcoefV, BcoefU, BcoefV
      REAL, DIMENSION(knon), INTENT(IN)        :: ps
      REAL, DIMENSION(knon), INTENT(IN)        :: u1, v1, gustiness
      REAL, DIMENSION(knon), INTENT(IN)        :: tsurf_in
      REAL, INTENT(IN) :: rhoa(knon) ! (knon) density of moist air  (kg / m3)
      REAL, DIMENSION(knon), INTENT(IN)        :: dthetadz300
      REAL, DIMENSION(klon, nbsrf), INTENT(IN)  :: pctsrf

#ifdef ISO
      REAL, DIMENSION(ntiso, knon), INTENT(IN)  :: xtprecip_rain, xtprecip_snow
      REAL, DIMENSION(ntiso, knon), INTENT(IN)  :: xtspechum
      REAL, DIMENSION(klon), INTENT(IN)  :: rlat
#endif

! In/Output arguments
!****************************************************************************************
      REAL, DIMENSION(knon), INTENT(INOUT)     :: radsol
      REAL, DIMENSION(knon), INTENT(INOUT)     :: snow
      REAL, DIMENSION(knon), INTENT(INOUT)     :: agesno !? put to 0 in ocean
#ifdef ISO
      REAL, DIMENSION(niso, knon), INTENT(IN)   :: xtsnow
      REAL, DIMENSION(niso, knon), INTENT(INOUT):: Roce
#endif

! Output arguments
!****************************************************************************************
      REAL, DIMENSION(knon), INTENT(OUT)       :: qsurf
      REAL, DIMENSION(knon), INTENT(OUT)       :: evap, fluxsens, fluxlat
      REAL, DIMENSION(knon), INTENT(OUT)       :: flux_u1, flux_v1
      REAL, DIMENSION(knon), INTENT(OUT)       :: tsurf_new
      REAL, DIMENSION(knon), INTENT(OUT)       :: dflux_s, dflux_l
      REAL, INTENT(out):: sens_prec_liq(:) ! (knon)
      REAL, DIMENSION(knon), INTENT(OUT)       :: Ampl

#ifdef ISO
      REAL, DIMENSION(ntiso, knon), INTENT(OUT) :: xtevap ! isotopes in evaporation flux
      REAL, DIMENSION(knon), INTENT(OUT) :: h1 ! just a diagnostic, not useful for the simulation
#endif

! Local variables
!****************************************************************************************
      INTEGER                     :: i, j
      REAL, DIMENSION(knon)       :: cal, beta, dif_grnd
      REAL, DIMENSION(knon)       :: alb_neig, tsurf_lim, zx_sl
      REAL, DIMENSION(knon)       :: u0, v0
      REAL, DIMENSION(knon)       :: u1_lay, v1_lay
      LOGICAL                     :: check = .FALSE.
      REAL, DIMENSION(knon)       :: sens_prec_sol
      REAL, DIMENSION(knon)       :: lat_prec_liq, lat_prec_sol
      REAL, DIMENSION(knon)       :: l_CBL, sicfra
#ifdef ISO
      REAL, PARAMETER :: t_coup = 273.15
#endif

!****************************************************************************************
! Start calculation
!****************************************************************************************
      IF (check) WRITE (*, *) ' Entering ocean_forced_noice'

#ifdef ISO
#ifdef ISOVERIF
      DO i = 1, knon
         IF (iso_eau > 0) THEN
            CALL iso_verif_egalite_choix(xtspechum(iso_eau, i), &
         &                  spechum(i), 'ocean_forced_mod 111', &
         &                  errmax, errmaxrel)
            CALL iso_verif_egalite_choix(snow(i), &
         &                  xtsnow(iso_eau, i), 'ocean_forced_mod 117', &
         &                  errmax, errmaxrel)
         END IF !IF (iso_eau > 0) THEN
      END DO !DO i=1,knon
#endif
#endif

!****************************************************************************************
! 1)
! Read sea-surface temperature from file limit.nc
!
!****************************************************************************************
      IF (klon_glo .eq. 1) THEN ! single-column model
         DO i = 1, knon
            tsurf_lim(i) = tg
         END DO

      ELSE ! GCM
         CALL limit_read_sst(knon, knindex, tsurf_lim &
#ifdef ISO
                             , Roce, rlat &
#endif
                             )
      END IF ! knon

!****************************************************************************************
! 2)
! Flux calculation
!
!****************************************************************************************
! Set some variables for calcul_fluxs

      ! Use calbeta to calculate beta
      ! Need to initialize qsurf for calbeta but it is not modified by this routine
      qsurf(:) = 0.
      CALL calbeta(dtime, is_oce, knon, snow, qsurf, beta, cal, dif_grnd)

      alb_neig(:) = 0.
      agesno(:) = 0.
      lat_prec_liq = 0.; lat_prec_sol = 0.

! Suppose zero surface speed
      u0(:) = 0.0
      v0(:) = 0.0
      u1_lay(:) = u1(:) - u0(:)
      v1_lay(:) = v1(:) - v0(:)

! Computation of  tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l and qsurf
! EV: does that make sense to have activate_ocean_skin in ocean_forced?
! in anycase; cal=dif=0 for ocean surfaces, so tsurf_new=tsurf_in.
! the two options below should give the same result in principle.

      IF (activate_ocean_skin == 2) THEN
         CALL calcul_fluxs(knon, is_oce, dtime, &
                           tsurf_in, p1lay, cal, &
                           beta, cdragh, cdragq, ps, &
                           precip_rain, precip_snow, snow, qsurf, &
                           radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, gustiness, &
                           f_qsat_oce, AcoefH, AcoefQ, BcoefH, BcoefQ, &
                           tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
                           sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol, rhoa)
         tsurf_new = tsurf_lim
      ELSE
         CALL calcul_fluxs(knon, is_oce, dtime, &
                           tsurf_lim, p1lay, cal, &
                           beta, cdragh, cdragq, ps, &
                           precip_rain, precip_snow, snow, qsurf, &
                           radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, gustiness, &
                           f_qsat_oce, AcoefH, AcoefQ, BcoefH, BcoefQ, &
                           tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
                           sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol, rhoa)
      END IF

      do j = 1, knon
         i = knindex(j)
         sens_prec_liq_o(i, 1) = sens_prec_liq(j)
         sens_prec_sol_o(i, 1) = sens_prec_sol(j)
         lat_prec_liq_o(i, 1) = lat_prec_liq(j)
         lat_prec_sol_o(i, 1) = lat_prec_sol(j)
      end do

      IF (iflag_leads .GE. 1) THEN
!ym hyper faux, melange de champ compresse et non compresse, je rétabli...
!ym      l_CBL = -52381.*dthetadz300 + 3008.1
!ym      Ampl = 6.012e-08*l_CBL**2 - 4.036e-04*l_CBL + 1.4979
!ym      WHERE(Ampl(:)>1.2) Ampl(:)=1.2
!ym      sicfra(:)=pctsrf(:,is_sic)/(1.-pctsrf(:,is_lic)-pctsrf(:,is_ter))
!ym      WHERE(pctsrf(:,is_sic)+pctsrf(:,is_oce)<EPSFRA) sicfra(:)=0.
!ym      WHERE(sicfra<0.7) Ampl(:)=1.
!ym      WHERE((sicfra>0.7).and.(sicfra<0.9)) Ampl=((sicfra-0.7)/0.2)*Ampl+((0.9-sicfra)/0.2)
!ym      fluxsens=Ampl*fluxsens
!ym      dflux_s=Ampl*dflux_s

! Amplification of surface fluxes over leads regions by G. Gastineau
! Ref: Tian Tian et al. 2025, The Cryosphere
!      Isau I. 2007, JGR
!      Davy and Gao 2019, zenodo
! Only sensible heat flux is accounted for if iflag_leads=1,  evaporative and latent
! heat fluxes are also considered if >1.

         DO j = 1, knon
            i = knindex(j)
            l_CBL(j) = -52381.*dthetadz300(j) + 3008.1
            Ampl(j) = 6.012e-08*l_CBL(j)**2 - 4.036e-04*l_CBL(j) + 1.4979
            IF (Ampl(j) > 1.2) Ampl(j) = 1.2
            sicfra(j) = pctsrf(i, is_sic)/(1.-pctsrf(i, is_lic) - pctsrf(i, is_ter))
            IF (pctsrf(i, is_sic) + pctsrf(i, is_oce) < EPSFRA) sicfra(j) = 0.
            IF (sicfra(j) < 0.7) Ampl(j) = 1.
            IF (sicfra(j) > 0.7 .and. sicfra(j) < 0.9) Ampl(j) = ((sicfra(j) - 0.7)/0.2)*Ampl(j) + ((0.9 - sicfra(j))/0.2)
            fluxsens(j) = Ampl(j)*fluxsens(j)
            dflux_s(j) = Ampl(j)*dflux_s(j)
         END DO

         IF (iflag_leads .GE. 2) THEN
            fluxlat(j) = Ampl(j)*fluxlat(j)
            dflux_l(j) = Ampl(j)*dflux_l(j)
            evap(j) = Ampl(j)*evap(j)
         END IF

      END IF

! - Flux calculation at first model level for U and V
      CALL calcul_flux_wind(knon, dtime, &
                            u0, v0, u1, v1, gustiness, cdragm, &
                            AcoefU, AcoefV, BcoefU, BcoefV, &
                            p1lay, temp_air, &
                            flux_u1, flux_v1)

#ifdef ISO
      CALL calcul_iso_surf_oce_vectall(knon, knon, t_coup, &
                                       ps, tsurf_new, spechum, u1_lay, v1_lay, xtspechum, &
                                       evap, Roce, xtevap, h1 &
#ifdef ISOTRAC
                                       , knindex &
#endif
                                       )
#endif

#ifdef ISO
#ifdef ISOVERIF
      IF (iso_eau > 0) THEN
         DO i = 1, knon
            CALL iso_verif_egalite_choix(snow(i), &
                                         xtsnow(iso_eau, i), 'ocean_forced_mod 180', &
                                         errmax, errmaxrel)
         END DO ! DO j=1,knon
      END IF !IF (iso_eau > 0) THEN
#endif
#endif

   END SUBROUTINE ocean_forced_noice
!
!***************************************************************************************
!
   SUBROUTINE ocean_forced_ice( &
      itime, dtime, jour, knon, knindex, &
      tsurf_in, p1lay, cdragh, cdragm, precip_rain, precip_snow, temp_air, spechum, &
      AcoefH, AcoefQ, BcoefH, BcoefQ, &
      AcoefU, AcoefV, BcoefU, BcoefV, &
      ps, u1, v1, gustiness, pctsrf, &
      radsol, snow, qsol, agesno, tsoil, &
      qsurf, alb1_new, alb2_new, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
      icesub, icemelt, &
      tsurf_new, dflux_s, dflux_l, rhoa, swnet, hice, tice, bilg_cumul, &
      fcds, fcdi, dh_basal_growth, dh_basal_melt, dh_top_melt, dh_snow2sic, &
      dtice_melt, dtice_snow2sic &
#ifdef ISO
      , xtprecip_rain, xtprecip_snow, xtspechum, Roce, &
      xtsnow, xtsol, xtevap, Rland_ice &
#endif
      )
!$gpum horizontal knon klon
!
!===========================================================================================
! This subroutine treats the sea ice tile in when LMDZ is not coupled to the slab or NEMO
! The routine reads data from boundary-condition file limit.nc and does flux calculations
! at the surface.
!===========================================================================================

      USE dimphy
      USE geometry_mod, ONLY: longitude, latitude
      USE calcul_fluxs_mod
      USE surface_data, ONLY: calice, calsno, iflag_seaice, iflag_seaice_alb, &
                              sice_cond, sisno_cond, sisno_den, sisno_min, sithick_min, sisno_wfact, &
                              amax_s, amax_n, rn_alb_sdry, rn_alb_smlt, rn_alb_idry, rn_alb_imlt, &
                              si_pen_frac, si_pen_ext, fseaN, fseaS, iflag_leads, sic_hice_fixed

      USE geometry_mod, ONLY: longitude, latitude, latitude_deg
      USE limit_read_mod
      USE simplehydrol_mod, ONLY: simplehydrol
      USE indice_sol_mod
      USE albsno_mod, ONLY: albsno
      USE soil_mod, ONLY: soil
      USE calbeta_mod, ONLY: calbeta
      USE phys_output_var_mod, ONLY: sens_prec_liq_o, sens_prec_sol_o, lat_prec_liq_o, lat_prec_sol_o
#ifdef ISO
      USE infotrac_phy, ONLY: niso, ntiso
      USE isotopes_routines_mod, ONLY: calcul_iso_surf_oce_vectall, calcul_iso_surf_sic_vectall
#ifdef ISOVERIF
      USE isotopes_mod, ONLY: iso_eau, ridicule
      !USE isotopes_verif_mod, ONLY: errmax,errmaxrel,iso_verif_egalite_choix
      USE isotopes_verif_mod
#endif
#endif
      USE flux_arp_mod_h
      USE clesphys_mod_h
      USE yomcst_mod_h
      USE dimsoil_mod_h, ONLY: nsoilmx

! Input arguments
!****************************************************************************************
      INTEGER, INTENT(IN)                  :: itime, jour, knon
      INTEGER, DIMENSION(knon), INTENT(IN) :: knindex
      REAL, INTENT(IN)                     :: dtime
      REAL, DIMENSION(knon), INTENT(IN)    :: tsurf_in
      REAL, DIMENSION(knon), INTENT(IN)    :: p1lay
      REAL, DIMENSION(knon), INTENT(IN)    :: cdragh, cdragm
      REAL, DIMENSION(knon), INTENT(IN)    :: precip_rain, precip_snow
      REAL, DIMENSION(knon), INTENT(IN)    :: temp_air, spechum
      REAL, DIMENSION(knon), INTENT(IN)    :: AcoefH, AcoefQ, BcoefH, BcoefQ
      REAL, DIMENSION(knon), INTENT(IN)    :: AcoefU, AcoefV, BcoefU, BcoefV
      REAL, DIMENSION(knon), INTENT(IN)    :: ps
      REAL, DIMENSION(knon), INTENT(IN)    :: u1, v1, gustiness
      real, intent(in):: rhoa(knon) ! (knon) density of moist air  (kg / m3)
      REAL, DIMENSION(knon), INTENT(IN)    :: swnet
      REAL, DIMENSION(klon, nbsrf), INTENT(IN)  :: pctsrf
#ifdef ISO
      REAL, DIMENSION(ntiso, knon), INTENT(IN) :: xtprecip_rain, xtprecip_snow
      REAL, DIMENSION(ntiso, knon), INTENT(IN) :: xtspechum
      REAL, DIMENSION(niso, knon), INTENT(IN) :: Roce
      REAL, DIMENSION(niso, knon), INTENT(IN) :: Rland_ice
#endif

! In/Output arguments
!****************************************************************************************
      REAL, DIMENSION(knon), INTENT(INOUT)          :: radsol
      REAL, DIMENSION(knon), INTENT(INOUT)          :: snow, qsol
      REAL, DIMENSION(knon), INTENT(INOUT)          :: agesno
      REAL, DIMENSION(knon, nsoilmx), INTENT(INOUT) :: tsoil
      REAL, DIMENSION(klon), INTENT(INOUT)          :: hice !ym WARNING uncompressed
      REAL, DIMENSION(klon), INTENT(INOUT)          :: tice !ym WARNING uncompressed
      REAL, DIMENSION(klon), INTENT(INOUT)          :: bilg_cumul !ym WARNING uncompressed
      REAL, DIMENSION(klon), INTENT(INOUT)          :: fcds !ym WARNING uncompressed
      REAL, DIMENSION(klon), INTENT(INOUT)          :: fcdi !ym WARNING uncompressed
      REAL, DIMENSION(klon), INTENT(INOUT)          :: dh_basal_growth !ym WARNING uncompressed
      REAL, DIMENSION(klon), INTENT(INOUT)          :: dh_basal_melt !ym WARNING uncompressed
      REAL, DIMENSION(klon), INTENT(INOUT)          :: dh_top_melt !ym WARNING uncompressed
      REAL, DIMENSION(klon), INTENT(INOUT)          :: dh_snow2sic !ym WARNING uncompressed
      REAL, DIMENSION(klon), INTENT(INOUT)          :: dtice_melt !ym WARNING uncompressed
      REAL, DIMENSION(klon), INTENT(INOUT)          :: dtice_snow2sic !ym WARNING uncompressed

#ifdef ISO
      REAL, DIMENSION(niso, knon), INTENT(INOUT)     :: xtsnow
      REAL, DIMENSION(niso, knon), INTENT(IN)        :: xtsol
#endif

! Output arguments
!****************************************************************************************
      REAL, DIMENSION(knon), INTENT(OUT)            :: qsurf
      REAL, DIMENSION(knon), INTENT(OUT)            :: alb1_new  ! new albedo in visible SW interval
      REAL, DIMENSION(knon), INTENT(OUT)            :: alb2_new  ! new albedo in near IR interval
      REAL, DIMENSION(knon), INTENT(OUT)            :: evap, fluxsens, fluxlat
      REAL, DIMENSION(knon), INTENT(OUT)            :: flux_u1, flux_v1
      REAL, DIMENSION(knon), INTENT(OUT)            :: tsurf_new
      REAL, DIMENSION(knon), INTENT(OUT)            :: dflux_s, dflux_l
      REAL, DIMENSION(knon), INTENT(OUT)            :: icesub, icemelt
#ifdef ISO
      REAL, DIMENSION(ntiso, knon), INTENT(OUT)      :: xtevap
#endif

! Local variables
!****************************************************************************************
      LOGICAL, PARAMETER           :: check = .FALSE.
      INTEGER                     :: i, j
      REAL                        :: zfra
      REAL, PARAMETER             :: t_grnd = 271.35
      REAL, DIMENSION(knon)       :: cal, beta, dif_grnd, capsol
      REAL, DIMENSION(knon)       :: alb_neig, tsurf_tmp
      REAL, DIMENSION(knon)       :: soilcap, soilflux
      REAL, DIMENSION(knon)       :: u0, v0
      REAL, DIMENSION(knon)       :: u1_lay, v1_lay
      REAL, DIMENSION(knon)       :: sens_prec_liq, sens_prec_sol
      REAL, DIMENSION(knon)       :: lat_prec_liq, lat_prec_sol
      REAL, DIMENSION(knon)       :: yhice ! compressed version of hice
      INTEGER                     :: ki
      INTEGER                     :: cpl_pas
      REAL, DIMENSION(knon)       :: bilg
      REAL, DIMENSION(knon)       :: fsic
      REAL, DIMENSION(knon)       :: f_bot
      REAL, PARAMETER             :: latent_ice = 334.0e3
      REAL, PARAMETER             :: rau_ice = 917.0
      REAL, PARAMETER             :: kice = 2.2
      REAL                  :: f_cond, f_swpen, f_cond_s, f_cond_i
      REAL                  :: ustar, uscap, ustau
      ! for snow/ice albedo:
      REAL                  :: alb_snow, alb_ice, alb_pond
      REAL                  :: frac_snow, frac_ice, frac_pond
      REAL                  :: z1_i, z2_i, z1_s, zlog ! height parameters
      ! for ice melt / freeze
      REAL                  :: e_melt, snow_evap, h_test
      ! dhsic, dfsic change in ice mass, fraction.
      REAL                  :: dhsic, dfsic, frac_mf
      REAL                        :: fsea, amax
      REAL                  :: hice_i, tice_i, fsic_new
      ! snow and ice physical characteristics:
      REAL, PARAMETER :: t_freeze = 271.35 ! freezing sea water temp
      REAL, PARAMETER :: t_melt = 273.15   ! melting ice temp
      REAL :: sno_den!=sisno_den !mean snow density, kg/m3
      REAL, PARAMETER :: ice_den = 917. ! ice density
      REAL, PARAMETER :: sea_den = 1025. ! sea water density
      REAL :: ice_cond!=sice_cond*ice_den !conductivity of ice
      REAL :: sno_cond!=sisno_cond*sno_den ! conductivity of snow
      REAL, PARAMETER :: ice_cap = 2067.   ! specific heat capacity, snow and ice
      REAL, PARAMETER :: sea_cap = 3995.   ! specific heat capacity, water
      REAL, PARAMETER :: ice_lat = 334000. ! freeze /melt latent heat snow and ice

      ! control of snow and ice cover & freeze / melt (heights converted to kg/m2)
      REAL :: snow_min!=sisno_min*sno_den !critical snow height 5 cm
      REAL :: snow_wfact!=sisno_wfact ! max fraction of falling snow blown into ocean
      REAL, PARAMETER :: ice_frac_min = 0.005
      REAL :: h_ice_min!=sithick_min ! min ice thickness
      ! below ice_thin, priority is melt lateral / grow height
      ! ice_thin is also height of new ice
      REAL, PARAMETER :: h_ice_max = 7 ! max ice height
      ! Ice thickness parameter for lateral growth
      REAL, PARAMETER :: h_ice_thick = 1.5
      REAL, PARAMETER :: h_ice_thin = 0.15

! albedo  and radiation parameters
      REAL :: alb_sno_dry!=rn_alb_sdry !dry snow albedo
      REAL :: alb_sno_wet!=rn_alb_smlt !wet snow albedo
      REAL :: alb_ice_dry!=rn_alb_idry !dry thick ice
      REAL :: alb_ice_wet!=rn_alb_imlt !melting thick ice
! Toyoda 2020' albedo
! Values for snow / ice, dry / melting, visible / near IR
      REAL, PARAMETER :: alb_sdry_vis = 0.98
      REAL, PARAMETER :: alb_smlt_vis = 0.88
      REAL, PARAMETER :: alb_sdry_nir = 0.7
      REAL, PARAMETER :: alb_smlt_nir = 0.55
      REAL, PARAMETER :: alb_idry_vis = 0.78
      REAL, PARAMETER :: alb_imlt_vis = 0.705
      REAL, PARAMETER :: alb_idry_nir = 0.36
      REAL, PARAMETER :: alb_imlt_nir = 0.285
      REAL, PARAMETER :: h_ice_alb = 0.5*ice_den ! height for full ice albedo
      REAL, PARAMETER :: h_sno_alb = 0.02*300 ! height for control of snow fraction

      REAL :: pen_frac !=si_pen_frac !fraction of shortwave penetrating into the
      ! ice (not snow). Should be visible only, not NIR
      REAL :: pen_ext !=si_pen_ext !extinction length of penetrating shortwave (m-1)
      REAl :: lon(knon), lat(knon)   ! for indexation

#ifdef ISO
      REAL, PARAMETER :: t_coup = 273.15
      REAL, DIMENSION(knon) :: fq_fonte_diag
      REAL, DIMENSION(knon) :: fqfonte_diag
      REAL, DIMENSION(knon) :: snow_evap_diag
      REAL, DIMENSION(knon) :: fqcalving_diag
      REAL, DIMENSION(knon) :: run_off_lic_diag
      REAL :: coeff_rel_diag
      REAL :: max_eau_sol_diag
      REAL, DIMENSION(knon) :: runoff_diag
      INTEGER IXT
      REAL, DIMENSION(niso, knon) :: xtsnow_prec, xtsol_prec
      REAL, DIMENSION(knon) :: snow_prec, qsol_prec
#endif

!****************************************************************************************
! Initialisation
!****************************************************************************************
      IF (check) WRITE (*, *) 'Entering surface_seaice, knon=', knon

      IF (iflag_seaice .GE. 1 .OR. iflag_seaice_alb .GE. 1) THEN
         sno_den = sisno_den !mean snow density, kg/m3
         ice_cond = sice_cond*ice_den !conductivity of ice
         sno_cond = sisno_cond*sno_den ! conductivity of snow
         snow_min = sisno_min*sno_den !critical snow height 5 cm
         snow_wfact = sisno_wfact ! max fraction of falling snow blown into ocean
         h_ice_min = sithick_min ! min ice thickness
         alb_sno_dry = rn_alb_sdry !dry snow albedo
         alb_sno_wet = rn_alb_smlt !wet snow albedo
         alb_ice_dry = rn_alb_idry !dry thick ice
         alb_ice_wet = rn_alb_imlt !melting thick ice
         pen_frac = si_pen_frac !fraction of shortwave penetrating into the
         pen_ext = si_pen_ext !extinction length of penetrating shortwave (m-1)

         cpl_pas = NINT(86400./dtime*1.0) ! once a day

      END IF

!***************************************************************************************************
! 1)  Heat diffusion in the snow/sea-ice, surface turbulent flux and surface temperature calculation
! if iflag_seaice=0, we use the old-style method considering a constant inertia for
! sea ice (or uperlying snow) and eventually using the soil routine to compute heat diffusion
! in sea ice
! if iflag_seaice>1, we compute the sea-ice thermal properties using the scheme of the slab
! from Liu, Risi, Codron et al. 2021, nature comm.
! if iflag_seaice=1, we read the sea-ice thickness from limit.nc
! if iflag_seaice=2, sea-ice thickness is computed using a prognostic evolution model.
! see also PhD thesis by N. Michalezyk (LOCEAN)
!***************************************************************************************************

      tsurf_tmp(:) = tsurf_in(:)

      IF (iflag_seaice == 0) THEN ! Old LMDZ sea ice surface
         ! calculate the parameters cal, beta, capsol and dif_grnd and then recalculate cal
         CALL calbeta(dtime, is_sic, knon, snow, qsol, beta, capsol, dif_grnd)

         IF (soil_model) THEN
            ! update tsoil and calculate soilcap and soilflux
            lon(1:knon) = longitude(knindex(1:knon))
            lat(1:knon) = latitude(knindex(1:knon))
            CALL soil(dtime, is_sic, knon, snow, tsurf_tmp, qsol, &
             & lon, lat, tsoil, soilcap, soilflux)
            cal(1:knon) = RCPD/soilcap(1:knon)
            radsol(1:knon) = radsol(1:knon) + soilflux(1:knon)
            dif_grnd = 1.0/tau_gl
         ELSE
            dif_grnd = 1.0/tau_gl
            cal = RCPD*calice
            WHERE (snow > 0.0) cal = RCPD*calsno
         END IF

      ELSEIF (iflag_seaice .GE. 1) THEN
         ! if iflag_seaice>=1, advanced computation of snow and sea-ice thermal properties.
         ! They become dependent on sea-ice thickness hice.
         bilg(:) = 0.
         dif_grnd(:) = 0.
         beta(:) = 1.
         cpl_pas = NINT(86400./dtime*1.0) ! once a day

         DO i = 1, knon
            ki = knindex(i)
            fsic(i) = pctsrf(ki, is_sic)
            IF (snow(i) .GT. snow_min) THEN
               !  1 / snow-layer heat capacity
               cal(i) = 2.*RCPD/(snow(i)*ice_cap)
               ! adjustment time-scale of conductive flux
               dif_grnd(i) = cal(i)*sno_cond/snow(i)/RCPD
               ! for conductive flux
               f_cond_s = sno_cond*(tice(ki) - t_freeze)/snow(i)
               radsol(i) = radsol(i) + f_cond_s
               ! all shortwave flux absorbed
               f_swpen = 0.
            ELSE ! bare ice.
               f_cond_s = 0.
               ! 1 / ice-layer heat capacity
               cal(i) = 2.*RCPD/(max(hice(ki),h_ice_min)*ice_den*ice_cap)
               ! adjustment time-scale of conductive flux
               dif_grnd(i) = cal(i)*ice_cond/(max(hice(ki),h_ice_min)*ice_den)/RCPD
               ! penetrative shortwave flux...
               f_swpen = swnet(i)*pen_frac*exp(-pen_ext*hice(ki))
               radsol(i) = radsol(i) - f_swpen
               ! GG no conductive flux in this case?
            END IF
            bilg(i) = f_swpen - f_cond_s
         END DO

      END IF

      lat_prec_liq(:) = 0.0
      lat_prec_sol(:) = 0.0
      ! Suppose zero surface speed
      u0(:) = 0.0
      v0(:) = 0.0
      u1_lay(:) = u1(:) - u0(:)
      v1_lay(:) = v1(:) - v0(:)
      CALL calcul_fluxs(knon, is_sic, dtime, &
                        tsurf_tmp, p1lay, cal, beta, cdragh, cdragh, ps, &
                        precip_rain, precip_snow, snow, qsurf, &
                        radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, gustiness, &
                        f_qsat_oce, AcoefH, AcoefQ, BcoefH, BcoefQ, &
                        tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
                        sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol, rhoa)

      DO j = 1, knon
         i = knindex(j)
         sens_prec_liq_o(i, 2) = sens_prec_liq(j)
         sens_prec_sol_o(i, 2) = sens_prec_sol(j)
         lat_prec_liq_o(i, 2) = lat_prec_liq(j)
         lat_prec_sol_o(i, 2) = lat_prec_sol(j)
      END DO

! - Flux calculation at first modele level for U and V
      CALL calcul_flux_wind(knon, dtime, &
                            u0, v0, u1, v1, gustiness, cdragm, &
                            AcoefU, AcoefV, BcoefU, BcoefV, &
                            p1lay, temp_air, &
                            flux_u1, flux_v1)

! - If iflag_seaice >=1, we also compute ice temperature and heat flux in the ice

      IF (iflag_seaice .GE. 1) THEN
         DO i = 1, knon
            ki = knindex(i)

            ! ocean-ice heat flux
            fsea = fseaS
            amax = amax_s
            if (latitude(ki) > 0) THEN
               fsea = fseaN
               amax = amax_n
            END IF

            IF (snow(i) .GT. snow_min) THEN
               ! snow conductive flux after calcul_fluxs (pos up)
               f_cond_s = sno_cond*(tice(ki) - tsurf_new(i))/snow(i)
               ! 1 / heat capacity and conductive timescale
               uscap = 2./ice_cap/(snow(i) + max(hice(ki),h_ice_min)*ice_den)
               ustau = uscap*ice_cond/(max(hice(ki),h_ice_min)*ice_den)
               ! update ice temp
               tice(ki) = (tice(ki) + dtime*(ustau*t_freeze - uscap*f_cond_s)) &
                          /(1 + dtime*ustau)
            ELSE ! bare ice
               tice(ki) = tsurf_new(i)
            END IF
            ! ice conductive flux (pos up)
            f_cond_i = ice_cond*(t_freeze - tice(ki))/(max(hice(ki),h_ice_min)*ice_den)
            f_bot(i) = fsea - f_cond_i
            fcdi(ki) = f_cond_i - fsea
            fcds(i) = f_cond_s
            !bilg(i) = bilg(i)+f_cond_i
         END DO

      END IF

!****************************************************************************************
! 2) Treatment of snow and ice hydrology and computation of sea ice thickness
!    two different treatments if iflag_seaice = 0 (old-style) or >0 (slab style)
!****************************************************************************************

      IF (iflag_seaice .EQ. 0) THEN

         ! if iflag_seaice = 0, we fix the sea-ice thickness to a constant value
         ! this only serves for albedo calculation if iflag_seaice_alb >=1
         DO i = 1, knon
            ki = knindex(i)
            hice(ki) = sic_hice_fixed
         END DO

#ifdef ISO
#ifdef ISOVERIF
         DO i = 1, knon
            IF (iso_eau > 0) THEN
               IF (snow(i) > ridicule) THEN
                  CALL iso_verif_egalite_choix(xtsnow(iso_eau, i), snow(i), &
                       & 'interfsurf 964', errmax, errmaxrel)
               END IF !IF ((snow(i) > ridicule)) THEN
            END IF !IF (iso_eau > 0) THEN
         END DO !DO i=1,knon
#endif

         DO i = 1, knon
            snow_prec(i) = snow(i)
            DO ixt = 1, niso
               xtsnow_prec(ixt, i) = xtsnow(ixt, i)
            END DO !DO ixt=1,niso
            ! initialisation:
            fq_fonte_diag(i) = 0.0
            fqfonte_diag(i) = 0.0
            snow_evap_diag(i) = 0.0
         END DO !DO i=1,knon
#endif

         CALL simplehydrol(knon, is_sic, knindex, dtime, &
                           tsurf_tmp, precip_rain, precip_snow, &
                           snow, qsol, tsurf_new, evap, icesub, icemelt &
#ifdef ISO
                           , fq_fonte_diag, fqfonte_diag, snow_evap_diag, fqcalving_diag &
                           , max_eau_sol_diag, runoff_diag, run_off_lic_diag, coeff_rel_diag &
#endif
                           )

#ifdef ISO
         CALL calcul_iso_surf_sic_vectall(knon, knon, &
                                          evap, snow_evap_diag, Tsurf_new, Roce, snow, &
                                          fq_fonte_diag, fqfonte_diag, dtime, t_coup, &
                                          precip_snow, xtprecip_snow, xtprecip_rain, snow_prec, xtsnow_prec, &
                                          xtspechum, spechum, ps, &
                                          xtevap, xtsnow, fqcalving_diag, &
                                          knindex, is_sic, run_off_lic_diag, coeff_rel_diag, Rland_ice)
#ifdef ISOVERIF

         IF (iso_eau > 0) THEN
            DO i = 1, knon
               CALL iso_verif_egalite_choix(snow(i), &
                                            xtsnow(iso_eau, i), 'ocean_forced_mod 396', &
                                            errmax, errmaxrel)
            END DO ! DO j=1,knon
         END IF !IF (iso_eau > 0) then
#endif
!#ifdef ISOVERIF
#endif
!#ifdef ISO

      ELSE ! iflag_seaice >= 1

         icesub(:) = 0.
         icemelt(:) = 0.

         ! if iflag_seaice = 1, we fix the sea-ice thickness to a constant value
         ! NB another idea could be testing the formula by Krinner et al. 1997 : h = (0.2 + 3.8(f**2))(1 + 2(f- f_min))
         ! Over the Svalbard region in April 2022, G. Nitti found h = (a + b f**2)(1 + 2(f-fmin)) a=0.166, b=0.911 and fmin=0.351
         IF (iflag_seaice .EQ. 1) THEN
               hice(:) = sic_hice_fixed
!            DO i = 1, knon
!               ki = knindex(i)
!               fsic(i) = pctsrf(ki, is_sic)
!               hice(ki) = (0.166 + 0.911 * (fsic(i)**2))*(1. + 2.*(fsic(i)-0.351))
!               hice(ki) = max(h_ice_min , hice(ki))
!            END DO
          END IF


         IF (iflag_seaice .EQ. 2) THEN
            ! if iflag_seaice=2 we read the thickness of the sea ice in the limit.nc file
            !ym   totally wrong since "hice" is an uncompressed field (klon) and limit_read_hice return a compressed field (knon)
            !ym    CALL limit_read_hice(knon,knindex,hice)
            CALL limit_read_hice(knon, knindex, yhice)
            DO i = 1, knon
               ki = knindex(i)
               hice(ki) = yhice(i)
            END DO
         END IF

         ! snow and sea ice hydrology. If iflag_seaice==3, interactive computation of hice

         ! let's start with snow on ice hydrology
         DO i = 1, knon

            ki = knindex(i)
            !ym WARNING : fsic uninitilazed, take initialisation similar to  iflag_seaice==2
            fsic(i) = pctsrf(ki, is_sic)
            IF (precip_snow(i) > 0.) THEN
               snow(i) = snow(i) + precip_snow(i)*dtime*(1.-snow_wfact*(1.-fsic(i)))
            END IF
            ! snow and ice sublimation
               snow_evap = MIN(snow(i)/dtime, evap(i)) 
               snow(i) = snow(i) - snow_evap*dtime
               snow(i) = MAX(0.0, snow(i))
               icesub(i) = evap(i) - snow_evap ! diagnostics
               ! in case of interactive calculation of hice
               IF (iflag_seaice == 3) THEN
                  hice(ki) = MAX(0.0, hice(ki) - (icesub(i))*dtime/ice_den)
               END IF
            ! Melt / Freeze snow from above if Tsurf>0
            IF (tsurf_new(i) .GT. t_melt) THEN
               ! energy available for melting snow (in kg of melted snow /m2)
               e_melt = MIN(MAX(snow(i)*(tsurf_new(i) - t_melt)*ice_cap/2. &
                                /(ice_lat + ice_cap/2.*(t_melt - tice(ki))), 0.0), snow(i))
               ! remove snow
               tice_i = tice(ki)
               IF (snow(i) .GT. e_melt) THEN
                  snow(i) = snow(i) - e_melt
                  tsurf_new(i) = t_melt
               ELSE ! all snow is melted
                    ! add remaining heat flux to ice
                  e_melt = e_melt - snow(i)
                  tice(ki) = tice(ki) + e_melt*ice_lat*2./(ice_cap*hice(ki)*ice_den)
                  tsurf_new(i) = tice(ki)
               END IF
               dtice_melt(ki) = (tice(ki) - tice_i)/dtime
            END IF

            ! ice hydrology

            ! melt ice from above if Tice>t_melt
            tice_i = tice(ki)
            IF (tice(ki) .GT. t_melt) THEN

              ! quantity of ice melted (kg/m2)
              e_melt = MAX(hice(ki)*ice_den*(tice(ki) - t_melt)*ice_cap/2. &
                               /(ice_lat + ice_cap/2.*(t_melt - t_freeze)), 0.0)
              icemelt(i) = e_melt 
              IF (iflag_seaice .EQ. 3) THEN
                  ! melt from above, height only
                  hice_i = hice(ki)
                  dhsic = MIN(hice(ki) - h_ice_min, e_melt/ice_den)
                  dh_top_melt(i) = dhsic
                  e_melt = e_melt - dhsic
                  IF (e_melt .GT. 0) THEN
                     ! lateral melt if ice too thin
                     dfsic = MAX(fsic(i) - ice_frac_min, e_melt/(h_ice_min*ice_den)*fsic(i))
                     ! if all melted do nothing with remaining heat
                     e_melt = MAX(0., e_melt*fsic(i) - dfsic*h_ice_min*ice_den)
                     ! slab_bilg(ki) = slab_bilg(ki) + e_melt*ice_lat/dtime
                  END IF
                  hice(ki) = hice(ki) - dhsic
                  dh_top_melt(ki) = (hice(ki) - hice_i)/dtime
                  ! surface temperature at melting point
               END IF

               tice(ki) = t_melt
               tsurf_new(i) = t_melt
            END IF
            dtice_melt(ki) = dtice_melt(ki) + tice(ki) - tice_i

            ! Bottom melt / grow if iflag_seaice == 3
            ! bottom freeze if bottom flux (cond + oce-ice) < t_melt
            ! + snow below floating line adjustment 
            IF (iflag_seaice .EQ. 3) THEN
               IF (f_bot(i) .LT. 0) THEN
                  ! larger fraction of bottom growth
                  frac_mf = MIN(1., MAX(0., (hice(ki) - h_ice_thick) &
                                        /(h_ice_max - h_ice_thick)))
                  ! quantity of new ice (formed at mean ice temp)
                  e_melt = -f_bot(i)*dtime*fsic(i) &
                           /(ice_lat + ice_cap/2.*(t_freeze - tice(ki)))
                  ! first increase height to h_thick
                  dhsic = MAX(0., MIN(h_ice_thick - hice(ki), e_melt/(fsic(i)*ice_den)))
                  hice_i = hice(ki)
                  hice(ki) = dhsic + hice(ki)
                  e_melt = e_melt - fsic(i)*dhsic
                  IF (e_melt .GT. 0.) THEN
                     ! frac_mf fraction used for lateral increase
                     dfsic = MIN(amax - fsic(i), e_melt*frac_mf/(hice(ki)*ice_den))
                     ! No lateral growth -> forced ocean
                     !fsic(ki)=fsic(ki)+dfsic
                     e_melt = e_melt - dfsic*hice(ki)*ice_den
                     ! rest used to increase height
                     hice(ki) = MIN(h_ice_max, hice(ki) + e_melt/(fsic(i)*ice_den))
                  END IF
                  dh_basal_growth(ki) = (hice(ki) - hice_i)/dtime

                  ! melt from below if bottom flux >0
               ELSE
                  ! larger fraction of lateral melt from warm ocean
                  frac_mf = MIN(1., MAX(0., (hice(ki) - h_ice_thin) &
                                        /(h_ice_thick - h_ice_thin)))
                  ! bring ice to freezing and melt from below
                  ! quantity of melted ice
                  e_melt = f_bot(i)*dtime*fsic(i) &
                           /(ice_lat + ice_cap/2.*(tice(ki) - t_freeze))
                  ! first decrease height to h_thick
                  hice_i = hice(ki)
                  dhsic = MAX(0., MIN(hice(ki) - h_ice_thick, e_melt/(fsic(i)*ice_den)))
                  hice(ki) = hice(ki) - dhsic
                  e_melt = e_melt - fsic(i)*dhsic*ice_den

                  IF (e_melt .GT. 0) THEN
                     ! frac_mf fraction used for height decrease
                     dhsic = MAX(0., MIN(hice(ki) - h_ice_min, e_melt/ice_den*frac_mf/fsic(i)))
                     hice(ki) = hice(ki) - dhsic
                     e_melt = e_melt - fsic(i)*dhsic*ice_den
                     ! rest used to decrease fraction (up to 0!)
                     dfsic = MIN(fsic(i), e_melt/(hice(ki)*ice_den))
                     ! Remaining heat not used if everything melted
                     e_melt = e_melt - dfsic*hice(ki)*ice_den
                     ! slab_bilg(ki) = slab_bilg(ki) + e_melt*ice_lat/dtime
                  END IF
                  dh_basal_melt(ki) = (hice(ki) - hice_i)/dtime
               END IF

               ! convert snow to ice if below floating line
               h_test = (hice(ki)*ice_den + snow(i)) - hice(ki)*sea_den
               IF ((h_test .GT. 0.) .AND. (hice(ki) .GT. h_ice_min)) THEN !snow under water
                  ! extra snow converted to ice (with added frozen sea water)
                  dhsic = h_test/(sea_den - ice_den + sno_den)
                  hice(ki) = hice(ki) + dhsic
                  snow(i) = snow(i) - dhsic*sno_den
                  ! available energy (freeze sea water + bring to tice)
                  e_melt = dhsic*ice_den*(1.-sno_den/ice_den)*(ice_lat + &
                                                            ice_cap/2.*(t_freeze - tice(ki)))
                  ! update ice temperature
                  tice_i = tice(ki)
                  tice(ki) = tice(ki) + 2.*e_melt/ice_cap/(snow(i) + hice(ki)*ice_den)
                  dh_snow2sic(ki) = dhsic/dtime
                  dtice_snow2sic(ki) = (tice(ki) - tice_i)/dtime
               END IF

            END IF ! iflag_seaice == 3
         
         END DO ! loop on horizontal indices

! cumulated ice-ocean fluxes, update tslab, lateral grow
         DO j = i, knon
            ki = knindex(i)
            bilg_cumul(ki) = bilg_cumul(ki) + bilg(j)/float(cpl_pas)
         END DO

!YM Pb for GPU port, done on an compressed field inside a compressed Kernel
!YM ==> move outside of subroutine
!YM CALL ocean_forced_ice_reset_bilg_cumul()
!YM    IF (MOD(itime,cpl_pas).EQ.0) THEN ! time to update tslab
!YM        bilg_cumul(1:klon)=0.
!YM    END IF ! coupling time
         !tests ice fraction
!YM Pb for GPU port : done on uncompressed field inside a compressed kernel
!YM update fsic only on compressed index
!YM    WHERE (fsic.LT.ice_frac_min)
!YM        tice=t_melt
!YM        hice=h_ice_min
!YM    END WHERE

         DO j = i, knon
            ki = knindex(i)
            IF (fsic(i) .LT. ice_frac_min) THEN
               tice(ki) = t_melt
               hice(ki) = h_ice_min
            END IF
         END DO

      END IF ! if iflag_seaice .eq. 0

!****************************************************************************************
! 3) Compute sea-ice / snow albedo
!    there are currently 4 options
!****************************************************************************************

      SELECT CASE (iflag_seaice_alb)
      CASE (0)
         ! default option. Calculation of albedo at snow (alb_neig) and update the age of snow (agesno)
         ! Note that where the is no snow, the albedo of bare sea ice is taken as the
         ! value of aged snow (computation with agesno=0).
         ! when looking at albsno, it is in fact a typical value of a desert (0.55)!
         CALL albsno(knon, knon, dtime, agesno(:), alb_neig(:), precip_snow(:))
         WHERE (snow(1:knon) .LT. 0.0001) agesno(1:knon) = 0.
         alb1_new(:) = 0.0
         DO i = 1, knon
            zfra = MAX(0.0, MIN(1.0, snow(i)/(snow(i) + 10.0)))
            alb1_new(i) = alb_neig(i)*zfra + 0.6*(1.0 - zfra)
         END DO
         alb2_new(:) = alb1_new(:)

      CASE (1)
         ! New visible and IR albedos, dry / melting snow
         ! based on Toyoda et al, 2020, from the slab model
         DO i = 1, knon
            ki = knindex(i)
            ! snow fraction
            frac_snow = snow(i)/(snow(i) + h_sno_alb)
            ! dependence of ice albedo with ice thickness
            frac_ice = MIN(1., ATAN(4.*hice(ki)*ice_den)/ATAN(4.*h_ice_alb))
            ! Total (for ice, min = 0.066 = alb_ocean)
            IF (tice(ki) .GT. t_melt) THEN
               alb_ice = 0.066 + (alb_imlt_vis - 0.066)*frac_ice
               alb1_new(i) = alb_smlt_vis*frac_snow + alb_ice*(1.-frac_snow)
               alb_ice = 0.066 + (alb_imlt_nir - 0.066)*frac_ice
               alb2_new(i) = alb_smlt_nir*frac_snow + alb_ice*(1.-frac_snow)
            ELSEIF (tice(ki) .GT. t_melt - 1.) THEN
               frac_pond = tice(ki) - t_freeze
               alb_snow = alb_smlt_vis*frac_pond + alb_sdry_vis*(1.-frac_pond)
               alb_ice = alb_imlt_vis*frac_pond + alb_idry_vis*(1.-frac_pond)
               alb_ice = 0.066 + (alb_ice - 0.66)*frac_ice
               alb1_new(i) = alb_snow*frac_snow + alb_ice*(1.-frac_snow)
               alb_snow = alb_smlt_nir*frac_pond + alb_sdry_nir*(1.-frac_pond)
               alb_ice = alb_imlt_nir*frac_pond + alb_idry_nir*(1.-frac_pond)
               alb_ice = 0.066 + (alb_ice - 0.66)*frac_ice
               alb2_new(i) = alb_snow*frac_snow + alb_ice*(1.-frac_snow)
            ELSE
               alb_ice = 0.066 + (alb_idry_vis - 0.066)*frac_ice
               alb1_new(i) = alb_sdry_vis*frac_snow + alb_ice*(1.-frac_snow)
               alb_ice = 0.066 + (alb_idry_nir - 0.066)*frac_ice
               alb2_new(i) = alb_sdry_nir*frac_snow + alb_ice*(1.-frac_snow)
            END IF
         END DO

      CASE (2)
         ! LIM3 scheme. Uses clear sky / overcast value, assuming 50% clear sky
         ! EV: change to 81% cloud cover to be consistent with NEMO implementation
         ! note that this is what is implemented in the coupled model (CMIP5, 6, 7)
         z1_i = 1.5*ice_den
         z2_i = 0.05*ice_den
         zlog = 1./(LOG(1.5) - LOG(0.05))
         z1_s = 1./(0.025*sno_den)
         DO i = 1, knon
            ki = knindex(i)
            ! temperature above / below 0
            IF (tice(ki) .GE. t_melt) THEN
               alb_ice = alb_ice_wet
               alb_snow = alb_sno_wet
            ELSE
               alb_ice = alb_ice_dry
               alb_snow = alb_sno_dry
            END IF
            ! ice thickness
            IF (hice(ki)*ice_den .LT. z2_i) THEN
               alb_ice = 0.066 + 0.114*hice(ki)*ice_den/z2_i
            ELSEIF (hice(ki)*ice_den .LT. z1_i) THEN
               alb_ice = alb_ice + (0.18 - alb_ice) &
                         *(LOG(z1_i) - LOG((hice(ki)+0.001)*ice_den))*zlog
            END IF
            ! ice or snow depending on snow thickness
            alb_snow = alb_snow - (alb_snow - alb_ice)*EXP(-snow(i)*z1_s)
            ! Effect of clouds (polynomial fit with 81% clouds)
            alb1_new(i) = alb_snow - 0.81*(-0.1010*alb_snow*alb_snow &
                                          + 0.1933*alb_snow - 0.0148)
            alb2_new(i) = alb1_new(i)
         END DO

      CASE (3)
         ! old slab albedo : single value. age of snow, melt ponds.
         DO i = 1, knon
            ki = knindex(i)
            ! snow albedo: update snow age
            IF (snow(i) .GT. 0.0001) THEN
               agesno(i) = (agesno(i) + (1.-agesno(i)/50.)*dtime/86400.) &
                           *EXP(-1.*MAX(0.0, precip_snow(i))*dtime/5.)
            ELSE
               agesno(i) = 0.0
            END IF
            ! snow albedo
            alb_snow = alb_sno_wet + (alb_sno_dry - alb_sno_wet)*EXP(-agesno(i)/50.)
            ! ice albedo (varies with ice thickness and temp)
            alb_ice = MAX(0.0, 0.13*LOG(100.*(hice(ki)+0.001)) + 0.1)
            !alb_ice=MAX(0.0,0.13*LOG(100.*seaice(ki)/ice_den)+0.1)
            IF (tice(ki) .GT. t_freeze - 0.01) THEN
               alb_ice = MIN(alb_ice, alb_ice_wet)
            ELSE
               alb_ice = MIN(alb_ice, alb_ice_dry)
            END IF
            ! pond albedo
            alb_pond = 0.36 - 0.1*(2.0 + MIN(0.0, MAX(tice(ki) - t_melt, -2.0)))
            ! pond fraction
            frac_pond = 0.2*(2.0 + MIN(0.0, MAX(tice(ki) - t_melt, -2.0)))
            ! snow fraction
            frac_snow = MAX(0.0, MIN(1.0 - frac_pond, snow(i)/snow_min))
            ! ice fraction
            frac_ice = MAX(0.0, 1.-frac_pond - frac_snow)
            ! total albedo
            alb1_new(i) = alb_snow*frac_snow + alb_ice*frac_ice + alb_pond*frac_pond
         END DO
         alb2_new(:) = alb1_new(:)

      END SELECT

      ! ------ End Albedo ----------

   END SUBROUTINE ocean_forced_ice
!*************************************************************************************

   SUBROUTINE ocean_forced_ice_reset_bilg_cumul(itime, dtime, bilg_cumul)
      USE dimphy, ONLY: klon
      USE surface_data, ONLY: iflag_seaice, type_ocean, version_ocean
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: itime
      REAL, INTENT(IN)    :: dtime
      REAL, DIMENSION(klon), INTENT(INOUT) :: bilg_cumul
      INTEGER :: cpl_pas

      IF (iflag_seaice /= 0) THEN
         cpl_pas = NINT(86400./dtime*1.0) ! une fois par jour
         IF (MOD(itime, cpl_pas) .EQ. 0) THEN ! time to update tslab
            IF (.NOT. (type_ocean == 'couple' .OR. (type_ocean == 'slab' .AND. version_ocean == 'sicINT'))) THEN
               bilg_cumul(1:klon) = 0.
            END IF
         END IF ! coupling time
      END IF

   END SUBROUTINE ocean_forced_ice_reset_bilg_cumul

END MODULE ocean_forced_mod

! $Id: phys_output_mod.F90 6190 2026-04-23 15:22:46Z lguez $
!

MODULE phys_output_mod 
  USE indice_sol_mod
  USE phys_output_var_mod
  USE phys_output_write_mod, ONLY : phys_output_write

  REAL, DIMENSION(nfiles),SAVE :: ecrit_files
  LOGICAL, DIMENSION(nfiles)   :: phys_out_filekeys


! Abderrahmane 12 2007
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Ecreture des Sorties du modele dans les fichiers Netcdf :
! histmth.nc : moyennes mensuelles
! histday.nc : moyennes journalieres
! histhf.nc  : moyennes toutes les 3 heures
! histins.nc : valeurs instantanees
! AI. nov 2024 : Modifs pour rajouter plus de choix pour la frequence temporelle d'archivage
!                dans les fichiers de sorties (avec IOIPSL) :
!                month(s),m,mth,mois,m,day(s),d,jour(s),j, ...
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

CONTAINS

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!! Ouverture des fichier et definition des variable de sortie !!!!!!!!
  !! histbeg, histvert et histdef
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

  SUBROUTINE phys_output_open(rlon,rlat,pim,tabij,ipt,jpt,plon,plat, &
       jjmp1,nlevSTD,clevSTD,rlevSTD, dtime, &
       phys_out_filestations, pdtphys, paprs, pphis, &
       pplay, lmax_th, ptconv, ptconvth, ivap, &
       d_u, d_t, qx, d_qx, zmasse, ok_sync)   

    USE iophy 
    USE dimphy
    USE infotrac_phy, ONLY: nqtot, tracers, niso, ntraciso=>ntiso
    USE strings_mod,  ONLY: maxlen
    USE ioipsl
    USE phys_cal_mod, only : hour, calend
    USE mod_phys_lmdz_para
    !Martin
    USE surface_data, ONLY : landice_opt
    USE phys_output_ctrlout_mod
    USE mod_grid_phy_lmdz, only: klon_glo,nbp_lon,nbp_lat
    USE print_control_mod, ONLY: prt_level,lunout
    USE vertical_layers_mod, ONLY: ap,bp,preff,presnivs, aps, bps, pseudoalt, presinter
    USE time_phylmdz_mod, ONLY: day_ini, itau_phy, start_time, annee_ref, day_ref
    USE AERO_MOD, ONLY : nbands_lw_rrtm !FC
    ! ug Pour les sorties XIOS
    USE wxios_mod
    USE infotrac_phy, ONLY: nbtr_bin
#ifdef ISO
    USE isotopes_mod, ONLY: isoName,iso_HTO
#ifdef ISOTRAC
    USE isotrac_mod, ONLY: index_zone,index_iso,strtrac
#endif
#endif
    USE clesphys_mod_h
    USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_STRATAER
    USE yomcst_mod_h
    USE surface_data,     ONLY : type_ocean, ok_veget
    USE conf_phys_m, ONLY : ok_mensuel,ok_journe, &
                            ok_hf,ok_instan,ok_LES,ok_ade,ok_aie, &
                            aerosol_couple, flag_aerosol_strat
    USE compbl_mod_h, ONLY : iflag_pbl,iflag_pbl_split

    IMPLICIT NONE


    ! ug Nouveaux arguments necessaires au histwrite_mod:
    INTEGER, INTENT(IN)                         :: ivap
    INTEGER, DIMENSION(klon), INTENT(IN)        :: lmax_th
    LOGICAL, INTENT(IN)                         :: ok_sync
    LOGICAL, DIMENSION(klon, klev), INTENT(IN)  :: ptconv, ptconvth
    REAL, INTENT(IN)                            :: pdtphys
    REAL, DIMENSION(klon), INTENT(IN)           :: pphis
    REAL, DIMENSION(klon, klev), INTENT(IN)     :: pplay, d_u, d_t
    REAL, DIMENSION(klon, klev+1), INTENT(IN)   :: paprs
    REAL, DIMENSION(klon,klev,nqtot), INTENT(IN):: qx, d_qx
    REAL, DIMENSION(klon, klev), INTENT(IN)     :: zmasse


    REAL,DIMENSION(klon),INTENT(IN) :: rlon
    REAL,DIMENSION(klon),INTENT(IN) :: rlat
    INTEGER, INTENT(IN)             :: pim
    INTEGER, DIMENSION(pim)            :: tabij
    INTEGER,DIMENSION(pim), INTENT(IN) :: ipt, jpt
    REAL,DIMENSION(pim), INTENT(IN) :: plat, plon
    REAL,DIMENSION(pim,2) :: plat_bounds, plon_bounds

    INTEGER                               :: jjmp1
    INTEGER                               :: nlevSTD, radpas
    REAL                                  :: dtime
    INTEGER                               :: idayref
    REAL                                  :: zjulian_start, zjulian
    CHARACTER(LEN=4), DIMENSION(nlevSTD)  :: clevSTD
    REAL, DIMENSION(nlevSTD)              :: rlevSTD
    INTEGER                               :: nsrf, k, iq, iff, i, j, ilev, itr, itrb, ixt, iiso, izone
    INTEGER                               :: naero
    CHARACTER(LEN=4)                      :: bb2
    CHARACTER(LEN=2)                      :: bb3
    INTEGER, DIMENSION(nbp_lon*jjmp1)         ::  ndex2d
    INTEGER, DIMENSION(nbp_lon*jjmp1*klev)    :: ndex3d
    INTEGER                               :: imin_ins, imax_ins
    INTEGER                               :: jmin_ins, jmax_ins
    INTEGER, DIMENSION(nfiles)            :: phys_out_levmin, phys_out_levmax
    INTEGER, DIMENSION(nfiles)            :: phys_out_filelevels
    CHARACTER(LEN=20), DIMENSION(nfiles)  :: chtimestep = (/ 'Default', 'Default', 'Default', 'Default', 'Default', &
                                                             'Default', 'Default', 'Default', 'Default', 'Default' /)
    LOGICAL, DIMENSION(nfiles)            :: phys_out_filestations

#ifdef ISO
    CHARACTER(LEN=maxlen) :: outiso
    CHARACTER(LEN=20) :: unit
#endif
    CHARACTER(LEN=maxlen) :: tnam, lnam, dn
    INTEGER :: flag(nfiles)

!!!!!!!!!! stockage dans une region limitee pour chaque fichier !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !                 entre [phys_out_lonmin,phys_out_lonmax] et [phys_out_latmin,phys_out_latmax]
    LOGICAL, DIMENSION(nfiles), SAVE :: phys_out_regfkey = [.FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE.]
    REAL, DIMENSION(nfiles), SAVE ::  phys_out_lonmin  = [  -180.,   -180.,   -180.,   -180.,   -180.,   -180.,   -180.,   -180.,   -180.,   -180.]
    REAL, DIMENSION(nfiles), SAVE ::  phys_out_lonmax  = [   180.,    180.,    180.,    180.,    180.,    180.,    180.,    180.,    180.,    180.]
    REAL, DIMENSION(nfiles), SAVE ::  phys_out_latmin  = [   -90.,    -90.,    -90.,    -90.,    -90.,    -90.,    -90.,    -90.,    -90.,    -90.]
    REAL, DIMENSION(nfiles), SAVE ::  phys_out_latmax  = [    90.,     90.,     90.,     90.,     90.,     90.,     90.,     90.,     90.,     90.]

    REAL, DIMENSION(klev,2) :: Ahyb_bounds, Bhyb_bounds
    REAL, DIMENSION(klev+1)   :: lev_index
                
    ! ug Variables utilisees pour recuperer le calendrier pour xios
    INTEGER :: x_an, x_mois, x_jour
    REAL :: x_heure
    INTEGER :: ini_an, ini_mois, ini_jour
    REAL :: ini_heure

    INTEGER                         :: ISW
    REAL, DIMENSION(NSW)            :: wl1_sun, wl2_sun !wavelength bounds (in um) for SW
    REAL, DIMENSION(NSW)            :: wn1_sun, wn2_sun !wavenumber bounds (in m-1) for SW 
    REAL, DIMENSION(NSW)            :: spectband  !mean wavenumb. of each sp.band
    REAL, DIMENSION(NSW,2)          :: spbnds_sun !bounds of spectband
!FC
    INTEGER                         :: ILW
    REAL,  DIMENSION(nbands_lw_rrtm):: wl1_lw, wl2_lw

    WRITE(lunout,*) 'Debut phys_output_mod.F90'
! Initialisations (Valeurs par defaut
!FC
       wl1_lw = [ 10., 250., 500., 630., 700., 820., 980.,1080. &
     & ,1180.,1390.,1480.,1800.,2080.,2250.,2380.,2600.]
       wl2_lw = [250., 500., 630., 700., 820., 980.,1080.,1180. &
     & ,1390.,1480.,1800.,2080.,2250.,2380.,2600.,3000.]
!         print*, 'avant boucle', nbands_lw_rrtm
!        DO ILW=1,nbands_lw_rrtm
!        spectbandLW(ILW)= (wl1_lw(ilw) + wl2_lw(ILW) )/2
!        print*, 'on a les canaux ? ',ILW,spectbandLW(ILW),wl1_lw(ILW),wl2_lw(ilw)
!        enddo
!        print*, 'spectbandLW',spectbandLW

!FC


    DO ilev=1,klev
      Ahyb_bounds(ilev,1) = ap(ilev)
      Ahyb_bounds(ilev,2) = ap(ilev+1)
      Bhyb_bounds(ilev,1) = bp(ilev)
      Bhyb_bounds(ilev,2) = bp(ilev+1)
      lev_index(ilev) = REAL(ilev)
    END DO
    lev_index(klev+1) = REAL(klev+1)

    IF (.NOT. ALLOCATED(o_trac)) ALLOCATE(o_trac(nqtot))
    IF (.NOT. ALLOCATED(o_trac_cum)) ALLOCATE(o_trac_cum(nqtot))
    ALLOCATE(o_dtr_the(nqtot),o_dtr_con(nqtot),o_dtr_lessi_impa(nqtot))
    ALLOCATE(o_dtr_lessi_nucl(nqtot),o_dtr_insc(nqtot),o_dtr_bcscav(nqtot))
    ALLOCATE(o_dtr_evapls(nqtot),o_dtr_ls(nqtot),o_dtr_trsp(nqtot))
    ALLOCATE(o_dtr_sscav(nqtot),o_dtr_sat(nqtot),o_dtr_uscav(nqtot))
    ALLOCATE(o_dtr_wet_cv(nqtot), o_dtr_wet(nqtot))
    ALLOCATE(o_dtr_dry(nqtot),o_dtr_vdf(nqtot))
IF (CPPKEY_STRATAER) THEN
    ALLOCATE(o_nd_mode(nbtr_bin),o_sulfmmr_mode(nbtr_bin))
END IF
#ifdef ISO
    ALLOCATE(o_xtprw(ntraciso)) ! CAa
    ALLOCATE(o_uxtflux(ntraciso))   ! CAa
    ALLOCATE(o_vxtflux(ntraciso))   ! CAa
    ALLOCATE(o_xtprecip(ntraciso))
    ALLOCATE(o_Rland_ice(ntraciso))         ! Niels
    ALLOCATE(o_xtsnow_srf(ntraciso, nbsrf)) ! Niels 18 janvier 2024
    ALLOCATE(o_xtplul(ntraciso))
    ALLOCATE(o_xtpluc(ntraciso))
    ALLOCATE(o_xtevap(ntraciso))
    ALLOCATE(o_xtevap_srf(ntraciso,4))
    ALLOCATE(o_xtovap(ntraciso))
    ALLOCATE(o_xtoliq(ntraciso))
    ALLOCATE(o_xtcond(ntraciso))
    ALLOCATE(o_xtrunoff_diag(ntraciso))
    ALLOCATE(o_xtriverflow(ntraciso))   !PRSN
    ALLOCATE(o_xtcoastalflow(ntraciso))
    ALLOCATE(o_Rsol(ntraciso))          !PRSN
    ALLOCATE(o_dxtdyn(ntraciso))
    ALLOCATE(o_dxtldyn(ntraciso))
    ALLOCATE(o_dxtcon(ntraciso))
    ALLOCATE(o_dxtlsc(ntraciso))
    ALLOCATE(o_dxteva(ntraciso))
    ALLOCATE(o_dxtajs(ntraciso))
    ALLOCATE(o_dxtvdf(ntraciso))
    ALLOCATE(o_dxtthe(ntraciso))
    ALLOCATE(o_dxtch4(ntraciso))
    IF (iso_HTO.GT.0) THEN
      ALLOCATE(o_dxtprod_nucl(ntraciso))
      ALLOCATE(o_dxtcosmo(ntraciso))
      ALLOCATE(o_dxtdecroiss(ntraciso))
    ENDIF
#endif

    levmax = [klev, klev, klev, klev, klev, klev, nlevSTD, nlevSTD, nlevSTD, klev]

    phys_out_filenames(1) = 'histmth'
    phys_out_filenames(2) = 'histday'
    phys_out_filenames(3) = 'histhf6h'
    phys_out_filenames(4) = 'histhf3h'
    phys_out_filenames(5) = 'histhf3hm'
    phys_out_filenames(6) = 'histstn'
    phys_out_filenames(7) = 'histmthNMC'
    phys_out_filenames(8) = 'histdayNMC'
    phys_out_filenames(9) = 'histhfNMC'
    phys_out_filenames(10)= 'histstrataer'

    type_ecri(1) = 'ave(X)'
    type_ecri(2) = 'ave(X)'
    type_ecri(3) = 'inst(X)'
    type_ecri(4) = 'inst(X)'
    type_ecri(5) = 'ave(X)'
    type_ecri(6) = 'inst(X)'
    type_ecri(7) = 'inst(X)'
    type_ecri(8) = 'inst(X)'
    type_ecri(9) = 'inst(X)'
    type_ecri(10)= 'ave(X)'

    clef_files(1:3) = .TRUE.
    clef_files(4:10) = .FALSE.
    IF (CPPKEY_STRATAER) THEN
      clef_files(10)= .TRUE.
    ELSE
      clef_files(10)= .FALSE.
    END IF

    !sortir des fichiers "stations" si clef_stations(:)=.TRUE.
    clef_stations(1:10) = .FALSE.
    lev_files(1:10) = 5

    print*,'A ecrit_mth=',ecrit_mth
    ! Frequencies of the history files;
    ! Defaut
    ! overwritten by chtimestep given to convers_timesteps
    ecrit_files(1) = ecrit_mth
    ecrit_files(2) = ecrit_day
    ecrit_files(3) = ecrit_hf
    ecrit_files(4) = ecrit_ins
    ecrit_files(5) = ecrit_LES
    ecrit_files(6:10) = ecrit_ins

    !! Lectures des parametres de sorties dans physiq.def

    CALL getin('phys_out_regfkey',phys_out_regfkey)
    CALL getin('phys_out_lonmin',phys_out_lonmin)
    CALL getin('phys_out_lonmax',phys_out_lonmax)
    CALL getin('phys_out_latmin',phys_out_latmin)
    CALL getin('phys_out_latmax',phys_out_latmax)
    phys_out_levmin(:)=levmin(:)
    CALL getin('phys_out_levmin',levmin)
    phys_out_levmax(:)=levmax(:)
    CALL getin('phys_out_levmax',levmax)
    CALL getin('phys_out_filenames',phys_out_filenames)
    phys_out_filekeys(:)=clef_files(:)
    CALL getin('phys_out_filekeys',clef_files)
    phys_out_filestations(:)=clef_stations(:)
    CALL getin('phys_out_filestations',clef_stations)
    phys_out_filelevels(:)=lev_files(:)
    CALL getin('phys_out_filelevels',lev_files)
    CALL getin('phys_out_filetimesteps',chtimestep)
    phys_out_filetypes(:)=type_ecri(:)
    CALL getin('phys_out_filetypes',type_ecri)

    type_ecri_files(:)=type_ecri(:)

!    if (ok_all_xml) phys_out_filelevels = 999

    WRITE(lunout,*)'phys_out_lonmin=',phys_out_lonmin
    WRITE(lunout,*)'phys_out_lonmax=',phys_out_lonmax
    WRITE(lunout,*)'phys_out_latmin=',phys_out_latmin
    WRITE(lunout,*)'phys_out_latmax=',phys_out_latmax
    WRITE(lunout,*)'phys_out_filenames=',phys_out_filenames
    WRITE(lunout,*)'phys_out_filetypes=',type_ecri
    WRITE(lunout,*)'phys_out_filekeys=',clef_files
    WRITE(lunout,*)'phys_out_filestations=',clef_stations
    WRITE(lunout,*)'phys_out_filelevels=',lev_files
    WRITE(lunout,*)'phys_out_regfkey=',phys_out_regfkey

! A noter pour
! l heure initiale - dans les fichiers histoire hist* - on met comme  
! heure de debut soit la vraie heure (pour le 1D) soit 0h (pour le 3D) 
! afin d avoir une seule sortie mensuelle par mois lorsque l on tourne 
! par annee (IM).
!
     idayref = day_ref
     IF (klon_glo==1) THEN
       ! current_time (used to compute hour) is updated at the begining of
       ! the physics; to set the correct outputs "initial time" we thus 
       ! have to use (hour-dtphys).
         CALL ymds2ju(annee_ref, 1, idayref, hour-pdtphys, zjulian)
         print *,'phys_output_mod: annee,iday,hour,zjulian=',annee_ref,idayref, hour, zjulian
     ELSE
         CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)
         CALL ymds2ju(annee_ref, 1, day_ini, start_time*rday, zjulian_start)
     ENDIF

    IF (using_xios) THEN
      ! ug R\'eglage du calendrier xios
      !Temps julian => an, mois, jour, heure
      CALL ju2ymds(zjulian, x_an, x_mois, x_jour, x_heure)
      CALL ju2ymds(zjulian_start, ini_an, ini_mois, ini_jour, ini_heure)
      CALL wxios_set_cal(dtime, calend, x_an, x_mois, x_jour, x_heure, ini_an, &
                         ini_mois, ini_jour, ini_heure )
    ENDIF

!!!!!!!!!!!!!!!!!!!!!!! Boucle sur les fichiers !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Appel de histbeg et histvert pour creer le fichier et les niveaux verticaux !!
    ! Appel des histbeg pour definir les variables (nom, moy ou inst, freq de sortie ..
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    zdtime_moy = dtime         ! Frequence ou l on moyenne


  ecrit_files(7) = ecrit_files(1)
  ecrit_files(8) = ecrit_files(2)
  ecrit_files(9) = ecrit_files(3)

  DO iff=1,nfiles

       ! Calculate ecrit_files for all files
      IF ( chtimestep(iff).eq.'Default' ) THEN
          ! Par defaut ecrit_files = (ecrit_mensuel ecrit_jour ecrit_hf
          ! ...)*86400.
          ecrit_files(iff)=ecrit_files(iff)*86400.
      ELSE IF (chtimestep(iff).eq.'-1') THEN
          PRINT*,'ecrit_files(',iff,') < 0 so IOIPSL work on different'
          PRINT*,'months length'
          ecrit_files(iff)=-1.
      ELSE
       CALL convers_timesteps(chtimestep(iff),dtime,ecrit_files(iff)) 
       PRINT*,'Dans phys_output_open, iff=',iff,' ecrit_files=',ecrit_files(iff)
      ENDIF
      ! ecrit_files contains frequency of file iif in seconds 


       WRITE(lunout,*)'ecrit_files(',iff,')= ',ecrit_files(iff)
       zoutm(iff) = ecrit_files(iff) ! Frequence ou l on ecrit en seconde


    IF (using_xios) THEN 
      !!! Ouverture de chaque fichier XIOS !!!!!!!!!!!
      IF (.not. ok_all_xml) THEN
        IF (prt_level >= 10) THEN
         print*,'phys_output_open: call wxios_add_file with phys_out_filenames(iff)=',trim(phys_out_filenames(iff))    
        ENDIF
        CALL wxios_add_file(phys_out_filenames(iff),chtimestep(iff),lev_files(iff))  
      ENDIF

      !!! Declaration des axes verticaux de chaque fichier:
      IF (prt_level >= 10) THEN
        print*,'phys_output_open: Declare vertical axes for each file'
      ENDIF

      IF (iff.LE.6.OR.iff.EQ.10) THEN
        CALL wxios_add_vaxis("presnivs", &
              levmax(iff) - levmin(iff) + 1, presnivs(levmin(iff):levmax(iff)))
        CALL wxios_add_vaxis("presinter", &
              klev + 1, presinter(1:klev+1))
        CALL wxios_add_vaxis("Ahyb", &
              levmax(iff) - levmin(iff) + 1, aps(levmin(iff):levmax(iff)), positif='down', &
              bnds=Ahyb_bounds(levmin(iff):levmax(iff),:))
        CALL wxios_add_vaxis("Bhyb", &
              levmax(iff) - levmin(iff) + 1, bps(levmin(iff):levmax(iff)), positif='down', &
              bnds=Bhyb_bounds(levmin(iff):levmax(iff),:))
        CALL wxios_add_vaxis("klev", levmax(iff) - levmin(iff) + 1, &
                              lev_index(levmin(iff):levmax(iff)))
        CALL wxios_add_vaxis("klevp1", klev+1, &
                              lev_index(1:klev+1))
        CALL wxios_add_vaxis("bnds", 2, (/1.,2./))
  
        CALL wxios_add_vaxis("Alt", &
                levmax(iff) - levmin(iff) + 1, pseudoalt)

        ! wl1_sun/wl2_sun: minimum/maximum bound of wavelength (in um)
        SELECT CASE(NSW)
          CASE(6)
            wl1_sun(1:6) = [0.180, 0.250, 0.440, 0.690, 1.190, 2.380]
            wl2_sun(1:6) = [0.250, 0.440, 0.690, 1.190, 2.380, 4.000]
          CASE(2)
            wl1_sun(1:2) = [0.250, 0.690]
            wl2_sun(1:2) = [0.690, 4.000]
        END SELECT

        DO ISW=1, NSW
          wn1_sun(ISW)=1.e+6/wl1_sun(ISW) 
          wn2_sun(ISW)=1.e+6/wl2_sun(ISW) 
          spbnds_sun(ISW,1)=wn2_sun(ISW)
          spbnds_sun(ISW,2)=wn1_sun(ISW)
          spectband(ISW)=(wn1_sun(ISW)+wn2_sun(ISW))/2
        ENDDO
!
!!! ajout axe vertical spectband : solar band number
        CALL wxios_add_vaxis("spectband", NSW, spectband, positif='down')
      ELSE
        ! NMC files
        CALL wxios_add_vaxis("plev", &
                levmax(iff) - levmin(iff) + 1, rlevSTD(levmin(iff):levmax(iff)))
      ENDIF
    ENDIF !using_xios 

        IF (clef_files(iff)) THEN
!!!!!!!!!!!!!!!!! Traitement dans le cas ou l'on veut stocker sur un domaine limite !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          IF (phys_out_regfkey(iff)) THEN
             imin_ins=1
             imax_ins=nbp_lon
             jmin_ins=1
             jmax_ins=jjmp1

             ! correction abderr        
             DO i=1,nbp_lon
                WRITE(lunout,*)'io_lon(i)=',io_lon(i)
                IF (io_lon(i).le.phys_out_lonmin(iff)) imin_ins=i
                IF (io_lon(i).le.phys_out_lonmax(iff)) imax_ins=i+1
             ENDDO

             DO j=1,jjmp1
                WRITE(lunout,*)'io_lat(j)=',io_lat(j)
                IF (io_lat(j).ge.phys_out_latmin(iff)) jmax_ins=j+1
                IF (io_lat(j).ge.phys_out_latmax(iff)) jmin_ins=j
             ENDDO

             WRITE(lunout,*)'On stoke le fichier histoire numero ',iff,' sur ', &
                  imin_ins,imax_ins,jmin_ins,jmax_ins
             WRITE(lunout,*)'longitudes : ', &
                  io_lon(imin_ins),io_lon(imax_ins), &
                  'latitudes : ', &
                  io_lat(jmax_ins),io_lat(jmin_ins)

             CALL histbeg(phys_out_filenames(iff),nbp_lon,io_lon,jjmp1,io_lat, &
                  imin_ins,imax_ins-imin_ins+1, &
                  jmin_ins,jmax_ins-jmin_ins+1, &
                  itau_phy,zjulian,dtime,nhorim(iff),nid_files(iff))
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
             !IM fichiers stations
          ELSE IF (clef_stations(iff)) THEN

             IF (prt_level >= 10) THEN
             WRITE(lunout,*)'phys_output_open: iff=',iff,'  phys_out_filenames(iff)=',phys_out_filenames(iff)
             ENDIF
             
             CALL histbeg_phy_all(rlon,rlat,pim,tabij,ipt,jpt,plon,plat,plon_bounds,plat_bounds, &
                  phys_out_filenames(iff), &
                  itau_phy,zjulian,dtime,nhorim(iff),nid_files(iff))
          ELSE

             IF (prt_level >= 10) THEN
             WRITE(lunout,*)'phys_output_open: iff=',iff,'  phys_out_filenames(iff)=',phys_out_filenames(iff)
             ENDIF

             CALL histbeg_phy_all(phys_out_filenames(iff),itau_phy,zjulian,&
                 dtime,nhorim(iff),nid_files(iff))
          ENDIF

#ifndef CPP_IOIPSL_NO_OUTPUT 
          IF (iff.LE.6.OR.iff.EQ.10) THEN
             CALL histvert(nid_files(iff), "presnivs", "Vertical levels", "Pa", &  
               levmax(iff) - levmin(iff) + 1, &
               presnivs(levmin(iff):levmax(iff)), nvertm(iff),"down")
!!!! Composantes de la coordonnee sigma-hybride 
          CALL histvert(nid_files(iff), "Ahyb","Ahyb comp of Hyb Cord ", "Pa", &
               levmax(iff) - levmin(iff) + 1,aps,nvertap(iff))

          CALL histvert(nid_files(iff), "Bhyb","Bhyb comp of Hyb Cord", " ", &
               levmax(iff) - levmin(iff) + 1,bps,nvertbp(iff))

          CALL histvert(nid_files(iff), "Alt","Height approx for scale heigh of 8km at levels", "Km", &                       
               levmax(iff) - levmin(iff) + 1,pseudoalt,nvertAlt(iff))
!FC
!          CALL histvert(nid_files(iff), "spectbandLW"," LW bands ", "cm-1", &
!                  nbands_lw_rrtm ,wl1_lw, ncanaux(iff))
!          print *, ' apres ncanaux = ' , ncanaux(iff),iff
!FC


          ELSE
          ! NMC files
             CALL histvert(nid_files(iff), "plev", "pressure", "Pa", &
               levmax(iff) - levmin(iff) + 1, &
              rlevSTD(levmin(iff):levmax(iff)), nvertm(iff), "down")
          ENDIF
#endif

     ENDIF ! clef_files

          itr = 0; itrb = 0
          DO iq = 1, nqtot 
            IF(.NOT.tracers(iq)%isInPhysics) CYCLE
            itr = itr + 1
            dn = 'd'//TRIM(tracers(iq)%name)//'_'

            flag = [1, 5, 5, 5, 10, 10, 11, 11, 11, 11]
            lnam = 'Tracer '//TRIM(tracers(iq)%longName)
            tnam = TRIM(tracers(iq)%name);  o_trac          (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])

            flag = [4, 7, 7, 7, 10, 10, 11, 11, 11, 11]
            lnam = 'Tendance tracer '//TRIM(tracers(iq)%longName)
            tnam = TRIM(dn)//'vdf';         o_dtr_vdf       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])

            flag = [5, 7, 7, 7, 10, 10, 11, 11, 11, 11]
            tnam = TRIM(dn)//'the';         o_dtr_the       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
            tnam = TRIM(dn)//'con';         o_dtr_con       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])

            flag = [7, 7, 7, 7, 10, 10, 11, 11, 11, 11]
            tnam = TRIM(dn)//'lessi_impa';  o_dtr_lessi_impa(itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
            tnam = TRIM(dn)//'lessi_nucl';  o_dtr_lessi_nucl(itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
            tnam = TRIM(dn)//'insc';        o_dtr_insc      (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
            tnam = TRIM(dn)//'bcscav';      o_dtr_bcscav    (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
            tnam = TRIM(dn)//'evapls';      o_dtr_evapls    (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
            tnam = TRIM(dn)//'ls';          o_dtr_ls        (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
            tnam = TRIM(dn)//'trsp';        o_dtr_trsp      (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
            tnam = TRIM(dn)//'sscav';       o_dtr_sscav     (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
            tnam = TRIM(dn)//'sat';         o_dtr_sat       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
            tnam = TRIM(dn)//'uscav';       o_dtr_uscav     (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])

            lnam = 'tracer convective wet deposition'//TRIM(tracers(iq)%longName)
            tnam = TRIM(dn)//'wet_cv';       o_dtr_wet_cv       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
            lnam = 'tracer total wet deposition'//TRIM(tracers(iq)%longName)
            tnam = TRIM(dn)//'wet';       o_dtr_wet       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
            lnam = 'tracer tendency dry deposition'//TRIM(tracers(iq)%longName)
            tnam = 'cum'//TRIM(dn)//'dry';  o_dtr_dry       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])

            flag = [1, 4, 10, 10, 10, 10, 11, 11, 11, 11]
            lnam = 'Cumulated tracer '//TRIM(tracers(iq)%longName)
            tnam = 'cum'//TRIM(tracers(iq)%name); o_trac_cum(itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
            
IF (CPPKEY_STRATAER) THEN
            if(tracers(iq)%name(1:3)=='BIN') then
               itrb = itrb + 1
               flag = [11, 11, 11, 11, 11, 11, 11, 11, 11, 1]
               lnam = 'Dry particle concentration in '//TRIM(tracers(iq)%longName)
               tnam = TRIM(tracers(iq)%name)//'_nd_mode';     o_nd_mode       (itrb) = ctrl_out(flag, tnam, lnam, "part/m3", [('',i=1,nfiles)])
               lnam = 'Sulfate MMR in '//TRIM(tracers(iq)%longName)
               tnam = TRIM(tracers(iq)%name)//'_sulfmmr_mode';o_sulfmmr_mode  (itrb) = ctrl_out(flag, tnam, lnam, "kg(H2SO4)/kg(air)", [('',i=1,nfiles)])
            endif
END IF
         ENDDO

   ENDDO !  iff

#ifdef ISO
    write(*,*) 'phys_output_mid 589'
    do ixt=1,ntraciso
      outiso = TRIM(isoName(ixt))
      i = INDEX(outiso, '_', .TRUE.)
      outiso = outiso(1:i-1)//outiso(i+1:LEN_TRIM(outiso))

      flag = [1, 1, 10, 10, 10, 10, 11, 11, 11, 11]
      unit = 'kg/m2'
      o_xtprw(ixt)=ctrl_out(flag, 'prw'//TRIM(outiso), 'Precipitable water', unit, [('',i=1,nfiles)])
      unit = 'kg/m/s'
      o_uxtflux(ixt)=ctrl_out(flag, 'uq'//TRIM(outiso), 'Zonal humidity transport', unit, [('',i=1,nfiles)])
      o_vxtflux(ixt)=ctrl_out(flag, 'vq'//TRIM(outiso), 'Merid humidity transport', unit, [('',i=1,nfiles)])

      flag = [1,  1,  1, 10,  5, 10, 11, 11, 11, 11]; unit = 'kg/(s*m2)'
      o_xtprecip(ixt)=ctrl_out(flag, 'precip'//TRIM(outiso), 'Precip Totale liq+sol', unit, [('',i=1,nfiles)])
      o_xtpluc  (ixt)=ctrl_out(flag,   'pluc'//TRIM(outiso),    'Convective Precip.', unit, [('',i=1,nfiles)])

      flag = [1,  1,  1, 10, 10, 10, 11, 11, 11, 11]
      o_xtplul  (ixt)=ctrl_out(flag,   'plul'//TRIM(outiso),   'Large-scale Precip.', unit, [('',i=1,nfiles)])
      o_xtevap  (ixt)=ctrl_out(flag,   'evap'//TRIM(outiso),             'Evaporat.', unit, [('',i=1,nfiles)])

      ! ajout Camille 8 mai 2023
      flag = [1, 6, 10, 10, 10, 10, 11, 11, 11, 11]
      o_xtevap_srf (ixt,1)=ctrl_out(flag,   'evap_ter'//TRIM(outiso), 'Evap sfc'//clnsurf(1), unit, [('',i=1,nfiles)])
      o_xtevap_srf (ixt,2)=ctrl_out(flag,   'evap_lic'//TRIM(outiso), 'Evap sfc'//clnsurf(2), unit, [('',i=1,nfiles)])
      o_xtevap_srf (ixt,3)=ctrl_out(flag,   'evap_oce'//TRIM(outiso), 'Evap sfc'//clnsurf(3), unit, [('',i=1,nfiles)])
      o_xtevap_srf (ixt,4)=ctrl_out(flag,   'evap_sic'//TRIM(outiso), 'Evap sfc'//clnsurf(4), unit, [('',i=1,nfiles)])

      flag = [2,  3,  4, 10, 10, 10, 11, 11, 11, 11]; unit = 'kg/kg'
      o_xtovap  (ixt)=ctrl_out(flag,   'ovap'//TRIM(outiso),     'Specific humidity', unit, [('',i=1,nfiles)])
      o_xtoliq  (ixt)=ctrl_out(flag,   'oliq'//TRIM(outiso),          'Liquid water', unit, [('',i=1,nfiles)])
      o_xtcond  (ixt)=ctrl_out(flag,  'ocond'//TRIM(outiso),       'Condensed water', unit, [('',i=1,nfiles)])

      flag = [1,  1,  1, 10, 5, 10, 11, 11, 11, 11]; unit = 'kg/m2/s'
      o_xtrunoff_diag  (ixt)=ctrl_out(flag, 'runoffland'//TRIM(outiso), 'Run-off rate land for bucket', unit, [('',i=1,nfiles)])

      ! Niels 14 janvier 2024
      flag = [1,  1,  1, 10, 10, 10, 11, 11, 11, 11]; unit = '1'
      o_Rland_ice(ixt) = ctrl_out(flag, 'Rland_ice'//TRIM(outiso), 'R land ice', unit, [('',i=1,nfiles)])
      
      ! Snow above soil
      flag = [1,  1,  1, 10, 10, 10, 11, 11, 11, 11]; unit = 'kg/m2'
      !do nsrf = 1, nbsrf
      !  o_xtsnow_srf (ixt, nsrf) = &
      !      ctrl_out(flag, 'snow_'//clnsurf(nsrf)//TRIM(outiso), 'Snow sfc'//clnsurf(nsrf), unit, [('',i=1,nfiles)])
      !end do
      o_xtsnow_srf (ixt,1)=ctrl_out(flag, 'snow_ter'//TRIM(outiso), 'Snow sfc'//clnsurf(1), unit, [('',i=1,nfiles)])
      o_xtsnow_srf (ixt,2)=ctrl_out(flag, 'snow_lic'//TRIM(outiso), 'Snow sfc'//clnsurf(2), unit, [('',i=1,nfiles)])
      o_xtsnow_srf (ixt,3)=ctrl_out(flag, 'snow_oce'//TRIM(outiso), 'Snow sfc'//clnsurf(3), unit, [('',i=1,nfiles)])
      o_xtsnow_srf (ixt,4)=ctrl_out(flag, 'snow_sic'//TRIM(outiso), 'Snow sfc'//clnsurf(4), unit, [('',i=1,nfiles)])
      ! end Niels

      !PRSN

      flag = [1,  1,  1, 10, 5, 10, 11, 11, 11, 11]; unit = 'kg/(s*m2)'
      o_xtriverflow  (ixt)=ctrl_out(flag, 'rivflow'//TRIM(outiso), 'River flow to ocean', unit, [('',i=1,nfiles)])
      o_xtcoastalflow  (ixt)=ctrl_out(flag, 'coastflow'//TRIM(outiso), 'Coastal flow to ocean', unit, [('',i=1,nfiles)])

      flag = [1,  1,  1, 10, 5, 10, 11, 11, 11, 11]; unit = 'kg/kg'
      o_Rsol  (ixt)=ctrl_out(flag, 'Rsol'//TRIM(outiso), 'Isotopic soil ratio', unit, [('',i=1,nfiles)])
      !PRSN

      flag = [4, 10, 10, 10, 10, 10, 11, 11, 11, 11]; unit = '(kg/kg)/s'
      o_dxtdyn  (ixt)=ctrl_out(flag,  'dqdyn'//TRIM(outiso),           'Dynamics dQ', unit, [('',i=1,nfiles)])
      o_dxtldyn (ixt)=ctrl_out(flag, 'dqldyn'//TRIM(outiso),          'Dynamics dQL', unit, [('',i=1,nfiles)])
      o_dxtcon  (ixt)=ctrl_out(flag,  'dqcon'//TRIM(outiso),         'Convection dQ', unit, [('',i=1,nfiles)])
      o_dxteva  (ixt)=ctrl_out(flag,  'dqeva'//TRIM(outiso),      'Reevaporation dQ', unit, [('',i=1,nfiles)])
      o_dxtlsc  (ixt)=ctrl_out(flag,  'dqlsc'//TRIM(outiso),       'Condensation dQ', unit, [('',i=1,nfiles)])
      o_dxtajs  (ixt)=ctrl_out(flag,  'dqajs'//TRIM(outiso),        'Dry adjust. dQ', unit, [('',i=1,nfiles)])
      o_dxtvdf  (ixt)=ctrl_out(flag,  'dqvdf'//TRIM(outiso),     'Boundary-layer dQ', unit, [('',i=1,nfiles)])
      o_dxtthe  (ixt)=ctrl_out(flag,  'dqthe'//TRIM(outiso),            'Thermal dQ', unit, [('',i=1,nfiles)])

      IF(ok_qch4) o_dxtch4(ixt)=ctrl_out(flag, 'dqch4'//TRIM(outiso), 'H2O due to CH4 oxidation & photolysis', &
                                                                                      unit, [('',i=1,nfiles)])
      IF(ixt == iso_HTO) THEN
      o_dxtprod_nucl(ixt)=ctrl_out(flag, 'dqprodnucl'//TRIM(outiso), 'dHTO/dt due to nuclear production',      &
                                                                                      unit, [('',i=1,nfiles)])
      o_dxtcosmo    (ixt)=ctrl_out(flag,    'dqcosmo'//TRIM(outiso), 'dHTO/dt due to cosmogenic production',   &
                                                                                      unit, [('',i=1,nfiles)])
      o_dxtdecroiss (ixt)=ctrl_out(flag, 'dqdecroiss'//TRIM(outiso), 'dHTO/dt due to radiative destruction',   &
                                                                                      unit, [('',i=1,nfiles)])
      END IF
    enddo !do ixt=1,niso
    write(*,*) 'phys_output_mid 596'
#endif

   ! Updated write frequencies due to phys_out_filetimesteps. 
    ! Write frequencies are now in seconds.  
! WHY CHANGING ecrit_mth ?
! For Cosp ?
!    ecrit_mth = ecrit_files(1)
!    print*,'B ecrit_mth=',ecrit_mth
!    ecrit_day = ecrit_files(2)
!    ecrit_hf  = ecrit_files(3)
!    ecrit_ins = ecrit_files(4)
!    ecrit_LES = ecrit_files(5)
!    ecrit_ins = ecrit_files(6)

    IF (prt_level >= 10) THEN
      WRITE(lunout,*)'swaerofree_diag=',swaerofree_diag
      WRITE(lunout,*)'swaero_diag=',swaero_diag
      WRITE(lunout,*)'dryaod_diag=',dryaod_diag
      WRITE(lunout,*)'ok_4xCO2atm=',ok_4xCO2atm
      WRITE(lunout,*)'phys_output_open: ends here'
    ENDIF
    PRINT*,'Dans phys_output_open,ecrit_files B',ecrit_files(1:6)

!  DO iq=1,nqtot
!    IF(.NOT.tracers(iq)%isInPhysics) CYCLE
!    WRITE(*,'(a,i1,a,10i3)')'trac(',iq,')%flag = ',o_trac(iq)%flag
!    WRITE(*,'(a,i1,a)')'trac(',iq,')%name = '//TRIM(o_trac(iq)%name)
!    WRITE(*,'(a,i1,a)')'trac(',iq,')%description = '//TRIM(o_trac(iq)%description)
!  END DO

  END SUBROUTINE phys_output_open

  SUBROUTINE convers_timesteps(str,dtime,timestep)

    use ioipsl
    USE phys_cal_mod
    USE time_phylmdz_mod, ONLY: day_ref, annee_ref
    USE print_control_mod, ONLY: lunout

    IMPLICIT NONE

    CHARACTER(LEN=20)   :: str
    CHARACTER(LEN=10)   :: type
    INTEGER             :: ipos,il
    real                :: ttt,xxx,timestep,dayseconde,dtime
    parameter (dayseconde=86400.)

    ipos=scan(str,'0123456789.',.TRUE.)
    !  
    il=len_trim(str)
    WRITE(lunout,*) "ipos = ", ipos
    WRITE(lunout,*) "il = ", il
    IF (ipos == 0) CALL abort_physic("convers_timesteps", "bad str", 1)
    read(str(1:ipos),*) ttt
    WRITE(lunout,*)ttt
    type=str(ipos+1:il)

    IF ( il == ipos ) THEN
       type='day'
    ENDIF

    IF ( type == 'day'.or.type == 'days'.or.type == 'd'.or.type == 'jours'.or.type == 'jour'.or.type == 'j' )&
           &  timestep = ttt * dayseconde
    IF ( type == 'months'.or.type == 'month'.or.type == 'mth'.or.type == 'mois'.or.type == 'm' .or.type == 'mo' ) THEN
       WRITE(lunout,*)'annee_ref,day_ref mon_len',annee_ref,day_ref,mth_len
       timestep = ttt * dayseconde * mth_len
    ENDIF
    IF ( type == 'hours'.or.type == 'hour'.or.type == 'hr'.or.type == 'heures'.or.type == 'heure'.or.type =='h' )&
           &  timestep = ttt * dayseconde / 24.
    IF ( type == 'mn'.or.type == 'minutes'.or.type == 'minute'.or.type == 'm' ) timestep = ttt * 60.
    IF ( type == 's'.or.type == 'sec'.or.type == 'secondes'.or.type =='seconde'   ) timestep = ttt
    IF ( type == 'TS' .or. type == 'ts' ) timestep = ttt * dtime

    WRITE(lunout,*)'type =      ',type
    WRITE(lunout,*)'nb j/h/m =  ',ttt
    WRITE(lunout,*)'timestep(s)=',timestep

  END SUBROUTINE convers_timesteps

END MODULE phys_output_mod

!***************************************************************************
SUBROUTINE RRTM_CMBGB6
!***************************************************************************

!     BAND 6:  820-980 cm-1 (low - H2O; high - nothing)
!     ABozzo 201306 updated to rrtmg v4.85
!     band 6:  820-980 cm-1 (low key - h2o; low minor - co2)
!                           (high key - nothing; high minor - cfc11, cfc12)
!***************************************************************************

! Parameters
USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK, JPHOOK

USE YOERRTO6 , ONLY : KAO     ,SELFREFO   , FORREFO, FRACREFAO  ,&
 & KAO_MCO2 ,CFC11ADJO,CFC12O  
USE YOERRTA6 , ONLY : KA      ,SELFREF    , FORREF, FRACREFA   ,&
 & KA_MCO2  ,CFC11ADJ ,CFC12  
USE YOERRTRWT, ONLY : RWGT
USE YOERRTFTR, ONLY : NGC      ,NGS      ,NGN      

IMPLICIT NONE

INTEGER(KIND=JPIM) :: IGC, IPR, IPRSM, JP, JT

REAL(KIND=JPRB) :: Z_SUMF, Z_SUMK, Z_SUMK2, Z_SUMK3
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('RRTM_CMBGB6',0,ZHOOK_HANDLE)
DO JT = 1,5
  DO JP = 1,13
    IPRSM = 0
    DO IGC = 1,NGC(6)
      Z_SUMK = 0.0_JPRB
      DO IPR = 1, NGN(NGS(5)+IGC)
        IPRSM = IPRSM + 1

        Z_SUMK = Z_SUMK + KAO(JT,JP,IPRSM)*RWGT(IPRSM+80)
      ENDDO

      KA(JT,JP,IGC) = Z_SUMK
    ENDDO
  ENDDO
ENDDO

DO JT = 1,19
    IPRSM = 0
    DO IGC = 1,NGC(6)
        Z_SUMK = 0.0_JPRB
        DO IPR = 1, NGN(NGS(5)+IGC)
            IPRSM = IPRSM + 1
            Z_SUMK = Z_SUMK + KAO_MCO2(JT,IPRSM)*RWGT(IPRSM+80)
        ENDDO
        KA_MCO2(JT,IGC) = Z_SUMK
    ENDDO
ENDDO

DO JT = 1,10
  IPRSM = 0
  DO IGC = 1,NGC(6)
    Z_SUMK = 0.0_JPRB
    DO IPR = 1, NGN(NGS(5)+IGC)
      IPRSM = IPRSM + 1

      Z_SUMK = Z_SUMK + SELFREFO(JT,IPRSM)*RWGT(IPRSM+80)
    ENDDO

    SELFREF(JT,IGC) = Z_SUMK
  ENDDO
ENDDO

DO JT = 1,4
   IPRSM = 0
   DO IGC = 1,NGC(6)
      Z_SUMK = 0.0_JPRB
      DO IPR = 1, NGN(NGS(5)+IGC)
         IPRSM = IPRSM + 1
         Z_SUMK = Z_SUMK + FORREFO(JT,IPRSM)*RWGT(IPRSM+80)
      ENDDO
      FORREF(JT,IGC) = Z_SUMK
   ENDDO
ENDDO

IPRSM = 0
DO IGC = 1,NGC(6)
  Z_SUMF = 0.0_JPRB
  Z_SUMK2= 0.0_JPRB
  Z_SUMK3= 0.0_JPRB
  DO IPR = 1, NGN(NGS(5)+IGC)
    IPRSM = IPRSM + 1

    Z_SUMF = Z_SUMF + FRACREFAO(IPRSM)
    Z_SUMK2= Z_SUMK2+ CFC11ADJO(IPRSM)*RWGT(IPRSM+80)
    Z_SUMK3= Z_SUMK3+ CFC12O(IPRSM)*RWGT(IPRSM+80)
  ENDDO

  FRACREFA(IGC) = Z_SUMF
  CFC11ADJ(IGC) = Z_SUMK2
  CFC12(IGC) = Z_SUMK3
ENDDO


IF (LHOOK) CALL DR_HOOK('RRTM_CMBGB6',1,ZHOOK_HANDLE)
END SUBROUTINE RRTM_CMBGB6

MODULE lmdz_cv_ini

  !------------------------------------------------------------
  ! Parameters for convectL, iflag_con=3:
  ! (includes - microphysical parameters,
  !            - parameters that control the rate of approach
  !               to quasi-equilibrium)
  !            - noff & minorig (previously in input of convect1)
  !------------------------------------------------------------
  IMPLICIT NONE; PRIVATE
  PUBLIC :: sigdz, spfac, pbcrit, ptcrit, elcrit, tlcrit, coef_peel, omtrain, dtovsh, dpbase, &
          dttrig, dtcrit, tau, beta, alpha, alpha1, T_top_max, tau_stop, noconv_stop, wbmax, &
          delta, betad, ejectliq, ejectice, flag_wb, flag_epKEorig, cv_flag_feed, noff, minorig, &
          nl, nlp, nlm
  PUBLIC :: cpd, cpv, cl, ci, rrv, rrd, lv0, lf0, g, rowl, t0, clmcpv, clmcpd, cpdmcp, cpvmcpd, cpvmcl,  &
          clmci, eps, epsi, epsim1, ginv, hrd, grav, keep_bug_indices_cv3_tracer, restore_bug_cvdn, iflag_phytrac

  PUBLIC :: retv,rtt,r ! From ymocst_mod_h
  PUBLIC :: iflag_cld_cv, tau_cld_cv, coefw_cld_cv, tmax_fonte_cv

PUBLIC :: cv3_param, cv_param, cv_flag, cv_thermo ! Provisoire Replayisation. A retirer . Elles doivent devenir internes
PUBLIC :: cv_ini



  ! provenant de cvparam
  PUBLIC :: entp, sigs,sigd, omtsnow,coeffr, coeffs, dtmax, cu, damp


  INTEGER flag_epKEorig
  REAL flag_wb
  INTEGER cv_flag_feed
  INTEGER noff, minorig, nl, nlp, nlm
  REAL sigdz, spfac
  REAL pbcrit, ptcrit
  REAL elcrit, tlcrit
  REAL coef_peel
  REAL omtrain
  REAL dtovsh, dpbase, dttrig
  REAL dtcrit, tau, beta, alpha, alpha1
  REAL T_top_max
  REAL tau_stop, noconv_stop
  REAL wbmax
  REAL delta
  REAL betad
  REAL ejectliq
  REAL ejectice
  INTEGER iflag_phytrac

  !$OMP THREADPRIVATE(sigdz, spfac, pbcrit, ptcrit, elcrit, tlcrit, coef_peel, omtrain, dtovsh, dpbase, &
  !$OMP      dttrig, dtcrit, tau, beta, alpha, alpha1, T_top_max, tau_stop, noconv_stop, wbmax, &
  !$OMP      delta, betad, ejectliq, ejectice, flag_wb, flag_epKEorig, cv_flag_feed, noff, minorig, &
  !$OMP      nl, nlp, nlm, iflag_phytrac)

  ! Thermodynamical constants for convectL:
  REAL cpd, cpv, cl, ci, rrv, rrd, lv0, lf0, g, rowl, t0
  REAL clmcpv, clmcpd, cpdmcp, cpvmcpd, cpvmcl, clmci
  REAL eps, epsi, epsim1
  REAL ginv, hrd
  REAL grav

  !$OMP THREADPRIVATE(cpd, cpv, cl, ci, rrv, rrd, lv0, lf0, g, rowl, t0, clmcpv, clmcpd, cpdmcp, cpvmcpd, cpvmcl  &
  !$OMP      , clmci, eps, epsi, epsim1, ginv, hrd, grav)


   REAL retv,rtt,r
  !$OMP THREADPRIVATE(retv,rtt,r)

!==========================================================================================
  ! provenant de cvparam
!==========================================================================================
  ! provenant de cvparam
  real entp
  real sigs, sigd
  real omtsnow, coeffr, coeffs
  real dtmax
  real cu
  real damp

  !$OMP THREADPRIVATE( entp &
  !$OMP          , sigs, sigd &
  !$OMP          , omtsnow, coeffr, coeffs &
  !$OMP          , dtmax, cu, damp)

LOGICAL keep_bug_indices_cv3_tracer,restore_bug_cvdn
 !$OMP THREADPRIVATE( keep_bug_indices_cv3_tracer,restore_bug_cvdn)

!==========================================================================================
! Previously in cvflag_mod_h
!==========================================================================================
  PUBLIC :: icvflag_Tpa, cvflag_grav, cvflag_ice, ok_optim_yield, ok_entrain, ok_homo_tend, &
            ok_convstop, ok_intermittent, cvflag_prec_eject, qsat_depends_on_qt, adiab_ascent_mass_flux_depends_on_ejectliq, keepbug_ice_frac

  LOGICAL cvflag_grav
  LOGICAL cvflag_ice
  LOGICAL ok_optim_yield
  LOGICAL ok_entrain
  LOGICAL ok_homo_tend
  LOGICAL ok_convstop
  LOGICAL ok_intermittent
  LOGICAL cvflag_prec_eject
  LOGICAL qsat_depends_on_qt
  LOGICAL adiab_ascent_mass_flux_depends_on_ejectliq
  LOGICAL keepbug_ice_frac
  INTEGER icvflag_Tpa

  !$OMP THREADPRIVATE(icvflag_Tpa, cvflag_grav, cvflag_ice, ok_optim_yield, ok_entrain, ok_homo_tend, &
  !$OMP      ok_convstop, ok_intermittent, cvflag_prec_eject, qsat_depends_on_qt, adiab_ascent_mass_flux_depends_on_ejectliq, keepbug_ice_frac)

! Previously END MODULE cvflag_mod_h
!==========================================================================================
! Previously in MODULE conema3_mod_h
!==========================================================================================
  PUBLIC :: epmax, coef_epmax_cape, cvl_comp_threshold, cvl_sig2feed
  PUBLIC :: iflag_cvl_sigd, iflag_clw, ok_adj_ema

  REAL epmax             ! 0.993
  REAL coef_epmax_cape             ! 0.993
  REAL  cvl_comp_threshold     ! 0.
  LOGICAL ok_adj_ema      ! F
  INTEGER iflag_clw      ! 0
  INTEGER iflag_cvl_sigd
  REAL cvl_sig2feed      ! 0.97

  !$OMP THREADPRIVATE(epmax,coef_epmax_cape, cvl_comp_threshold, cvl_sig2feed)
  !$OMP THREADPRIVATE(iflag_cvl_sigd, iflag_clw, ok_adj_ema)

! From MODULE yomcst2_mod_h
PUBLIC :: gammas, alphas, betas, Fmax, scut, qqa1, qqa2, qqa3, Qcoef1max, &
         Qcoef2max, Supcrit1, Supcrit2, choice, iflag_mix, coef_clos_ls, iflag_mix_adiab

  INTEGER choice, iflag_mix, iflag_mix_adiab
  REAL  gammas, alphas, betas, Fmax, qqa1, qqa2, qqa3, scut
  REAL  Qcoef1max, Qcoef2max, Supcrit1, Supcrit2
  REAL coef_clos_ls

  !$OMP THREADPRIVATE(gammas, alphas, betas, Fmax, scut, qqa1, qqa2, qqa3, Qcoef1max, &
  !$OMP     Qcoef2max, Supcrit1, Supcrit2, choice, iflag_mix, coef_clos_ls, iflag_mix_adiab)

  PUBLIC :: fl_cor_ebil
  INTEGER  :: fl_cor_ebil
  !$OMP THREADPRIVATE(fl_cor_ebil)


  PUBLIC :: prt_level, lunout
  INTEGER  :: prt_level, lunout
  !$OMP THREADPRIVATE(prt_level, lunout)

!=========================================================================================
! control of convection clouds
!=========================================================================================

  REAL, SAVE, PROTECTED :: tau_cld_cv  ! characteristic time of dissipation of mixing fluxes
  REAL, SAVE, PROTECTED :: coefw_cld_cv ! coefficient for updraft velocity in convection
  REAL, SAVE, PROTECTED :: tmax_fonte_cv ! threshold temperature to control snow melting in convection
  INTEGER, SAVE, PROTECTED :: iflag_cld_cv ! flag that controls the treatment of convective clouds

!$OMP THREADPRIVATE(tau_cld_cv,coefw_cld_cv,tmax_fonte_cv,iflag_cld_cv)


CONTAINS


SUBROUTINE cv_ini(iflag_con_IN,iflag_ice_thermo_IN,rcpd_IN,rcpv_IN,rcw_IN,rv_IN,rcs_IN,rd_IN,rlvtt_IN,rlstt_IN,rg_IN,&
                retv_IN,rtt_IN,r_IN,nd,k_upper,delt,fl_cor_ebil_IN,prt_level_IN, lunout_IN, iflag_phytrac_IN)
  

USE ioipsl_getin_p_mod, ONLY : getin_p

INTEGER, INTENT(IN)              :: nd,k_upper
REAL, INTENT(IN)              :: delt
  
  
  ! Argument : iflag_ice_thermo : ice thermodynamics is taken into account if
  ! iflag_ice_thermo >=1
integer, intent(in) :: iflag_con_IN,iflag_ice_thermo_IN
real, intent(in) :: rcpd_IN,rcpv_IN,rcw_IN,rv_IN,rcs_IN,rd_IN,rlvtt_IN,rlstt_IN,rg_IN
real, intent(in) :: retv_IN,rtt_IN,r_IN
integer, intent(in) :: prt_level_IN, lunout_IN,fl_cor_ebil_IN

INTEGER, intent(in) :: iflag_phytrac_IN

    CALL cv_ini_previously_in_conf_phys
    CALL cv_thermo(iflag_con_IN,rcpd_IN,rcpv_IN,rcw_IN,rv_IN,rcs_IN,rd_IN,rlvtt_IN,rlstt_IN,rg_IN)
    retv=retv_IN
    rtt=rtt_IN
    r=r_IN
    fl_cor_ebil=fl_cor_ebil_IN
    prt_level=prt_level_IN
    lunout=lunout_IN
    iflag_phytrac=iflag_phytrac_IN

    IF ( iflag_con_IN==30 ) then ! Previously un cv_driver
        ! -- set simulation flags:
        CALL cv_flag(0)
        ! -- set thermodynamical constants:
    ELSE ! Previously in cva_driver_pre
        ! -- set simulation flags:
        CALL cv_flag(iflag_ice_thermo_IN)
        ! (common cvthermo)
    ENDIF

  ! -- set convect parameters

    ! -- set convect parameters

    ! includes microphysical parameters and parameters that
    ! control the rate of approach to quasi-equilibrium)
    ! (common cvparam)

    IF (iflag_con_IN==3) THEN
      CALL cv3_param(nd, k_upper, delt)
    ELSE IF (iflag_con_IN==4) THEN
      CALL cv_param(nd)
    ELSE IF (iflag_con_IN==30) THEN
      CALL cv30_param(nd, delt)
    ELSE
      print*,'iflag_con_IN=',iflag_con_IN,' non prevu' ; stop
    END IF

    !CALL cv3_routine_pre(ok_conserv_q)

    ! parameters for convective clouds
    iflag_cld_cv = 0
    CALL getin_p('iflag_cld_cv',iflag_cld_cv)
    tau_cld_cv = 10.
    CALL getin_p('tau_cld_cv',tau_cld_cv)
    coefw_cld_cv = 0.1
    CALL getin_p('coefw_cld_cv',coefw_cld_cv)
    tmax_fonte_cv = 275.15
    CALL getin_p('tmax_fonte_cv',tmax_fonte_cv)

    WRITE (*, *) 'iflag_cld_cv=', iflag_cld_cv
    WRITE (*, *) 'tau_cld_cv=', tau_cld_cv
    WRITE (*, *) 'coefw_cld_cv=', coefw_cld_cv
    WRITE (*, *) 'tmax_fonte_cv=', tmax_fonte_cv

END SUBROUTINE cv_ini

SUBROUTINE cv3_param(nd, k_upper, delt)

! Replayisation USE cvflag_mod_h
  USE ioipsl_getin_p_mod, ONLY : getin_p
! Replayisation USE conema3_mod_h
!   USE lmdz_cv_ini, ONLY : alpha,alpha1,beta,betad,coef_peel,cv_flag_feed,delta,dpbase,dtcrit,dtovsh,dttrig,ejectice,ejectliq,elcrit,flag_epkeorig,flag_wb,minorig,nl,nlm,nlp,noconv_stop,noff,omtrain,pbcrit,ptcrit,sigdz,spfac,t_top_max,tau,tau_stop,tlcrit,wbmax
!   USE lmdz_cv_ini, ONLY : keep_bug_indices_cv3_tracer,restore_bug_cvdn


  IMPLICIT NONE

!------------------------------------------------------------
!Set parameters for convectL for iflag_con = 3
!------------------------------------------------------------


!***  PBCRIT IS THE CRITICAL CLOUD DEPTH (MB) BENEATH WHICH THE ***
!***      PRECIPITATION EFFICIENCY IS ASSUMED TO BE ZERO     ***
!***  PTCRIT IS THE CLOUD DEPTH (MB) ABOVE WHICH THE PRECIP. ***
!***            EFFICIENCY IS ASSUMED TO BE UNITY            ***
!***  SIGD IS THE FRACTIONAL AREA COVERED BY UNSATURATED DNDRAFT  ***
!***  SPFAC IS THE FRACTION OF PRECIPITATION FALLING OUTSIDE ***
!***                        OF CLOUD                         ***

![TAU: CHARACTERISTIC TIMESCALE USED TO COMPUTE ALPHA & BETA]
!***    ALPHA AND BETA ARE PARAMETERS THAT CONTROL THE RATE OF ***
!***                 APPROACH TO QUASI-EQUILIBRIUM           ***
!***    (THEIR STANDARD VALUES ARE 1.0 AND 0.96, RESPECTIVELY) ***
!***           (BETA MUST BE LESS THAN OR EQUAL TO 1)        ***

!***    DTCRIT IS THE CRITICAL BUOYANCY (K) USED TO ADJUST THE ***
!***                 APPROACH TO QUASI-EQUILIBRIUM           ***
!***                     IT MUST BE LESS THAN 0              ***

  INTEGER, INTENT(IN)              :: nd
  INTEGER, INTENT(IN)              :: k_upper
  REAL, INTENT(IN)                 :: delt ! timestep (seconds)

! Local variables
  CHARACTER (LEN=20),PARAMETER :: modname = 'cv3_param'
  CHARACTER (LEN=80) :: abort_message

  LOGICAL, SAVE :: first = .TRUE.
!$OMP THREADPRIVATE(first)

!glb  noff: integer limit for convection (nd-noff)
! minorig: First level of convection

! -- limit levels for convection:

!jyg<
!  noff is chosen such that nl = k_upper so that upmost loops end at about 22 km
!
  write(lunout,*) 'cv3_param dans lmdz_cv_ini Replay post OK3'
  noff = min(max(nd-k_upper, 1), (nd+1)/2)
!!  noff = 1
!>jyg
  minorig = 1
  nl = nd - noff
  nlp = nl + 1
  nlm = nl - 1

  IF (first) THEN
! -- "microphysical" parameters:
! IM beg: ajout fis. reglage ep
! CR+JYG: shedding coefficient (used when iflag_mix_adiab=1)
! IM lu dans physiq.def via conf_phys.F90     epmax  = 0.993

    omtrain = 45.0 ! used also for snow (no disctinction rain/snow)
! -- misc:
    dtovsh = -0.2 ! dT for overshoot
! cc      dttrig = 5.   ! (loose) condition for triggering
    dttrig = 10. ! (loose) condition for triggering
    dtcrit = -2.0
! -- end of convection
! -- interface cloud parameterization:
    delta = 0.01 ! cld
! -- interface with boundary-layer (gust factor): (sb)
    betad = 10.0 ! original value (from convect 4.3)

    

! Var interm pour le getin
     cv_flag_feed=1
     CALL getin_p('cv_flag_feed',cv_flag_feed)
     T_top_max = 1000.
     CALL getin_p('t_top_max',T_top_max)
     dpbase=-40.
     CALL getin_p('dpbase',dpbase)
     pbcrit=150.0
     CALL getin_p('pbcrit',pbcrit)
     ptcrit=500.0
     CALL getin_p('ptcrit',ptcrit)
     sigdz=0.01
     CALL getin_p('sigdz',sigdz)
     spfac=0.15
     CALL getin_p('spfac',spfac)
     tau=8000.
     CALL getin_p('tau',tau)
     flag_wb=1
     CALL getin_p('flag_wb',flag_wb)
     wbmax=6.
     CALL getin_p('wbmax',wbmax)
     ok_convstop=.False.
     CALL getin_p('ok_convstop',ok_convstop)
     tau_stop=15000.
     CALL getin_p('tau_stop',tau_stop)
     ok_intermittent=.False.
     CALL getin_p('ok_intermittent',ok_intermittent)
     ok_optim_yield=.False.
     CALL getin_p('ok_optim_yield',ok_optim_yield)
     ok_homo_tend=.TRUE.
     CALL getin_p('ok_homo_tend',ok_homo_tend)
     ok_entrain=.TRUE.
     CALL getin_p('ok_entrain',ok_entrain)

     coef_peel=0.25
     CALL getin_p('coef_peel',coef_peel)

     flag_epKEorig=1
     CALL getin_p('flag_epKEorig',flag_epKEorig)
     elcrit=0.0003
     CALL getin_p('elcrit',elcrit)
     tlcrit=-55.0
     CALL getin_p('tlcrit',tlcrit)
     ejectliq=0.
     CALL getin_p('ejectliq',ejectliq)
     ejectice=0.
     CALL getin_p('ejectice',ejectice)
     cvflag_prec_eject = .FALSE.
     CALL getin_p('cvflag_prec_eject',cvflag_prec_eject)
     qsat_depends_on_qt = .FALSE.
     CALL getin_p('qsat_depends_on_qt',qsat_depends_on_qt)
     adiab_ascent_mass_flux_depends_on_ejectliq = .FALSE.
     CALL getin_p('adiab_ascent_mass_flux_depends_on_ejectliq',adiab_ascent_mass_flux_depends_on_ejectliq)
     keepbug_ice_frac = .TRUE.
     CALL getin_p('keepbug_ice_frac', keepbug_ice_frac)
     keep_bug_indices_cv3_tracer = .FALSE.
     CALL getin_p('keep_bug_indices_cv3_tracer', keep_bug_indices_cv3_tracer)
     restore_bug_cvdn=.false.
     CALL getin_p('restore_bug_cvdn',restore_bug_cvdn)


    WRITE (*, *) 't_top_max=', t_top_max
    WRITE (*, *) 'dpbase=', dpbase
    WRITE (*, *) 'pbcrit=', pbcrit
    WRITE (*, *) 'ptcrit=', ptcrit
    WRITE (*, *) 'sigdz=', sigdz
    WRITE (*, *) 'spfac=', spfac
    WRITE (*, *) 'tau=', tau
    WRITE (*, *) 'flag_wb=', flag_wb
    WRITE (*, *) 'wbmax=', wbmax
    WRITE (*, *) 'ok_convstop=', ok_convstop
    WRITE (*, *) 'tau_stop=', tau_stop
    WRITE (*, *) 'ok_intermittent=', ok_intermittent
    WRITE (*, *) 'ok_optim_yield =', ok_optim_yield
    WRITE (*, *) 'coef_peel=', coef_peel

    WRITE (*, *) 'flag_epKEorig=', flag_epKEorig
    WRITE (*, *) 'elcrit=', elcrit
    WRITE (*, *) 'tlcrit=', tlcrit
    WRITE (*, *) 'ejectliq=', ejectliq
    WRITE (*, *) 'ejectice=', ejectice
    WRITE (*, *) 'cvflag_prec_eject =', cvflag_prec_eject 
    WRITE (*, *) 'qsat_depends_on_qt =', qsat_depends_on_qt 
    WRITE (*, *) 'adiab_ascent_mass_flux_depends_on_ejectliq =', adiab_ascent_mass_flux_depends_on_ejectliq
    WRITE (*, *) 'keepbug_ice_frac =', keepbug_ice_frac 
    WRITE (*, *) 'keep_bug_indices_cv3_tracer =', keep_bug_indices_cv3_tracer 
    WRITE (*, *) 'restore_bug_cvdn=',restore_bug_cvdn

    first = .FALSE.
  END IF ! (first)

  beta = 1.0 - delt/tau
  alpha1 = 1.5E-3
!JYG    Correction bug alpha
  alpha1 = alpha1*1.5
  alpha = alpha1*delt/tau
!JYG    Bug
! cc increase alpha to compensate W decrease:
! c      alpha  = alpha*1.5

  noconv_stop = max(2.,tau_stop/delt)

  RETURN
END SUBROUTINE cv3_param

SUBROUTINE cv_param(nd)
  !USE lmdz_cv_ini, ONLY : alpha,betad,coeffr,coeffs,cu,damp,delta,dtmax,elcrit,entp,minorig,nl,nlm,nlp,noff,omtrain,omtsnow,sigd,sigs,tlcrit

  IMPLICIT NONE

  ! ------------------------------------------------------------
  ! Set parameters for convectL
  ! (includes microphysical parameters and parameters that
  ! control the rate of approach to quasi-equilibrium)
  ! ------------------------------------------------------------

  ! *** ELCRIT IS THE AUTOCONVERSION THERSHOLD WATER CONTENT (gm/gm) ***
  ! ***  TLCRIT IS CRITICAL TEMPERATURE BELOW WHICH THE AUTO-        ***
  ! ***       CONVERSION THRESHOLD IS ASSUMED TO BE ZERO             ***
  ! ***     (THE AUTOCONVERSION THRESHOLD VARIES LINEARLY            ***
  ! ***               BETWEEN 0 C AND TLCRIT)                        ***
  ! ***   ENTP IS THE COEFFICIENT OF MIXING IN THE ENTRAINMENT       ***
  ! ***                       FORMULATION                            ***
  ! ***  SIGD IS THE FRACTIONAL AREA COVERED BY UNSATURATED DNDRAFT  ***
  ! ***  SIGS IS THE FRACTION OF PRECIPITATION FALLING OUTSIDE       ***
  ! ***                        OF CLOUD                              ***
  ! ***        OMTRAIN IS THE ASSUMED FALL SPEED (P/s) OF RAIN       ***
  ! ***     OMTSNOW IS THE ASSUMED FALL SPEED (P/s) OF SNOW          ***
  ! ***  COEFFR IS A COEFFICIENT GOVERNING THE RATE OF EVAPORATION   ***
  ! ***                          OF RAIN                             ***
  ! ***  COEFFS IS A COEFFICIENT GOVERNING THE RATE OF EVAPORATION   ***
  ! ***                          OF SNOW                             ***
  ! ***     CU IS THE COEFFICIENT GOVERNING CONVECTIVE MOMENTUM      ***
  ! ***                         TRANSPORT                            ***
  ! ***    DTMAX IS THE MAXIMUM NEGATIVE TEMPERATURE PERTURBATION    ***
  ! ***        A LIFTED PARCEL IS ALLOWED TO HAVE BELOW ITS LFC      ***
  ! ***    ALPHA AND DAMP ARE PARAMETERS THAT CONTROL THE RATE OF    ***
  ! ***                 APPROACH TO QUASI-EQUILIBRIUM                ***
  ! ***   (THEIR STANDARD VALUES ARE  0.20 AND 0.1, RESPECTIVELY)    ***
  ! ***                   (DAMP MUST BE LESS THAN 1)                 ***

  INTEGER nd
  CHARACTER (LEN=20) :: modname = 'cv_routines'
  CHARACTER (LEN=80) :: abort_message

  ! noff: integer limit for convection (nd-noff)
  ! minorig: First level of convection

  write(lunout,*) 'cv_param dans lmdz_cv_ini Replay post OK3'
  noff = 2
  minorig = 2

  nl = nd - noff
  nlp = nl + 1
  nlm = nl - 1

  elcrit = 0.0011
  tlcrit = -55.0
  entp = 1.5
  sigs = 0.12
  sigd = 0.05
  omtrain = 50.0
  omtsnow = 5.5
  coeffr = 1.0
  coeffs = 0.8
  dtmax = 0.9

  cu = 0.70

  betad = 10.0

  damp = 0.1
  alpha = 0.2

  delta = 0.01 ! cld

  RETURN
END SUBROUTINE cv_param
  SUBROUTINE cv30_param(nd, delt)
! Replayisation USE conema3_mod_h

    IMPLICIT NONE

    ! ------------------------------------------------------------
    ! Set parameters for convectL for iflag_con = 3
    ! ------------------------------------------------------------


    ! ***  PBCRIT IS THE CRITICAL CLOUD DEPTH (MB) BENEATH WHICH THE ***
    ! ***      PRECIPITATION EFFICIENCY IS ASSUMED TO BE ZERO     ***
    ! ***  PTCRIT IS THE CLOUD DEPTH (MB) ABOVE WHICH THE PRECIP. ***
    ! ***            EFFICIENCY IS ASSUMED TO BE UNITY            ***
    ! ***  SIGD IS THE FRACTIONAL AREA COVERED BY UNSATURATED DNDRAFT  ***
    ! ***  SPFAC IS THE FRACTION OF PRECIPITATION FALLING OUTSIDE ***
    ! ***                        OF CLOUD                         ***

    ! [TAU: CHARACTERISTIC TIMESCALE USED TO COMPUTE ALPHA & BETA]
    ! ***    ALPHA AND BETA ARE PARAMETERS THAT CONTROL THE RATE OF ***
    ! ***                 APPROACH TO QUASI-EQUILIBRIUM           ***
    ! ***    (THEIR STANDARD VALUES ARE 1.0 AND 0.96, RESPECTIVELY) ***
    ! ***           (BETA MUST BE LESS THAN OR EQUAL TO 1)        ***

    ! ***    DTCRIT IS THE CRITICAL BUOYANCY (K) USED TO ADJUST THE ***
    ! ***                 APPROACH TO QUASI-EQUILIBRIUM           ***
    ! ***                     IT MUST BE LESS THAN 0              ***

    INTEGER nd
    REAL delt ! timestep (seconds)

    ! noff: integer limit for convection (nd-noff)
    ! minorig: First level of convection

    ! -- limit levels for convection:

    noff = 1
    minorig = 1
    nl = nd - noff
    nlp = nl + 1
    nlm = nl - 1

    ! -- "microphysical" parameters:

    sigd = 0.01
    spfac = 0.15
    pbcrit = 150.0
    ptcrit = 500.0
    ! IM cf. FH     epmax  = 0.993

    omtrain = 45.0 ! used also for snow (no disctinction rain/snow)

    ! -- misc:

    dtovsh = -0.2 ! dT for overshoot
    dpbase = -40. ! definition cloud base (400m above LCL)
    dttrig = 5. ! (loose) condition for triggering

    ! -- rate of approach to quasi-equilibrium:

    dtcrit = -2.0
    tau = 8000.
    beta = 1.0 - delt / tau
    alpha = 1.5E-3 * delt / tau
    ! increase alpha to compensate W decrease:
    alpha = alpha * 1.5

    ! -- interface cloud parameterization:

    delta = 0.01 ! cld

    ! -- interface with boundary-layer (gust factor): (sb)

    betad = 10.0 ! original value (from convect 4.3)

  END SUBROUTINE cv30_param



! ==================================================================
SUBROUTINE cv_flag(iflag_ice_thermo)

! Replayisation USE cvflag_mod_h
!  USE lmdz_cv_ini, ONLY : cvflag_grav, cvflag_ice, icvflag_Tpa
  USE ioipsl_getin_p_mod, ONLY : getin_p

  IMPLICIT NONE

  ! Argument : iflag_ice_thermo : ice thermodynamics is taken into account if
  ! iflag_ice_thermo >=1
  INTEGER iflag_ice_thermo


  ! -- si .TRUE., on rend la gravite plus explicite et eventuellement
  ! differente de 10.0 dans convect3:
  cvflag_grav = .TRUE.
  cvflag_ice = iflag_ice_thermo >= 1
  !
! si icvflag_Tpa=0, alors la fraction de glace dans l'ascendance adiabatique est
  ! fonction de la temperature de l'environnement et la temperature de l'ascendance est
  ! calculee en deux it�rations, une en supposant qu'il n'y a pas de glace et l'autre
  ! en ajoutant la glace (ancien sch�ma d'Arnaud Jam).
! si icvflag_Tpa=1, alors la fraction de glace dans l'ascendance adiabatique est
  ! fonction de la temperature de l'environnement et la temperature de l'ascendance est
  ! calculee en une seule iteration.
! si icvflag_Tpa=2, alors la fraction de glace dans l'ascendance adiabatique est
  ! fonction de la temperature de l'ascendance et la temperature de l'ascendance est
  ! calculee en une seule iteration.
  icvflag_Tpa=0
  call getin_p('icvflag_Tpa', icvflag_Tpa)

  RETURN
END SUBROUTINE cv_flag

! ==================================================================
SUBROUTINE cv_thermo(iflag_con,rcpd,rcpv,rcw,rv,rcs,rd,rlvtt,rlstt,rg)
! Replayisation USE yomcst_mod_h
!  USE lmdz_cv_ini, ONLY : ci,cl,clmci,clmcpd,clmcpv,cpd,cpdmcp,cpv,cpvmcl,cpvmcpd,eps,epsi,epsim1,g,ginv,grav,hrd,lf0,lv0,rowl,rrd,rrv,t0

IMPLICIT NONE

  ! -------------------------------------------------------------
  ! Set thermodynamical constants for convectL
  ! -------------------------------------------------------------



  INTEGER iflag_con
real, intent(in) :: rcpd,rcpv,rcw,rv,rcs,rd,rlvtt,rlstt,rg


  ! original set from convect:
  IF (iflag_con==4) THEN
    cpd = 1005.7
    cpv = 1870.0
    cl = 4190.0
    rrv = 461.5
    rrd = 287.04
    lv0 = 2.501E6
    g = 9.8
    t0 = 273.15
    grav = g
  ELSE

    ! constants consistent with LMDZ:
    cpd = rcpd
    cpv = rcpv
    cl = rcw
    ci = rcs
    rrv = rv
    rrd = rd
    lv0 = rlvtt
    lf0 = rlstt - rlvtt
    g = rg ! not used in convect3
    ! ori      t0  = RTT
    t0 = 273.15 ! convect3 (RTT=273.16)
    ! maf       grav= 10.    ! implicitely or explicitely used in convect3
    grav = g ! implicitely or explicitely used in convect3
  END IF

  rowl = 1000.0 !(a quelle variable de YOMCST cela correspond-il?)

  clmcpv = cl - cpv
  clmcpd = cl - cpd
  clmci = cl - ci
  cpdmcp = cpd - cpv
  cpvmcpd = cpv - cpd
  cpvmcl = cl - cpv ! for convect3
  eps = rrd/rrv
  epsi = 1.0/eps
  epsim1 = epsi - 1.0
  ! ginv=1.0/g
  ginv = 1.0/grav
  hrd = 0.5*rrd

  RETURN
END SUBROUTINE cv_thermo

SUBROUTINE cv_ini_previously_in_conf_phys
! Previously in conema3.h and then conema3_mod_h : 

USE ioipsl_getin_p_mod, ONLY : getin_p
implicit none

    epmax=0.993
    CALL getin_p('epmax', epmax)
    
    coef_epmax_cape=0.0   
    CALL getin_p('coef_epmax_cape', coef_epmax_cape)      

    cvl_comp_threshold= 1.00
    CALL getin_p('cvl_comp_threshold', cvl_comp_threshold)

    ok_adj_ema = .FALSE.
    CALL getin_p('ok_adj_ema',ok_adj_ema)
    
    iflag_clw = 0
    CALL getin_p('iflag_clw',iflag_clw)
    
    iflag_cvl_sigd = 0
    CALL getin_p('iflag_cvl_sigd',iflag_cvl_sigd)
    
    cvl_sig2feed = 0.97
    CALL getin_p('cvl_sig2feed', cvl_sig2feed)

    ! Previously in yomcst2
    alphas = -5.
    CALL getin_p('alphas',alphas)
    
    coef_clos_ls = 0.
    CALL getin_p('coef_clos_ls',coef_clos_ls)

    supcrit1 = .540
    CALL getin_p('supcrit1',supcrit1)
    
    supcrit2 = .600
    CALL getin_p('supcrit2',supcrit2)
    
    iflag_mix = 1
    CALL getin_p('iflag_mix',iflag_mix)
    
    iflag_mix_adiab = 0
    CALL getin_p('iflag_mix_adiab',iflag_mix_adiab)
    
    scut = 0.95
    CALL getin_p('scut',scut)

    qqa1 = 1.0
    CALL getin_p('qqa1',qqa1)

    qqa2 = 0.0
    CALL getin_p('qqa2',qqa2)

    gammas = 0.05
    CALL getin_p('gammas',gammas)

    Fmax = 0.65
    CALL getin_p('Fmax',Fmax)

END SUBROUTINE cv_ini_previously_in_conf_phys

END MODULE lmdz_cv_ini

! This file has been modified for the use in ICON

!***************************************************************************
SUBROUTINE RRTM_CMBGB8
!***************************************************************************

!     BAND 8:  1080-1180 cm-1 (low (i.e.>~300mb) - H2O; high - O3)
!     ABozzo 201306 updated to rrtmg v4.85
!***************************************************************************

! Parameters
USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK, JPHOOK

USE YOERRTO8 , ONLY : KAO     ,KBO     ,SELFREFO   ,FORREFO, FRACREFAO  ,&
 & FRACREFBO, KAO_MCO2, KAO_MN2O ,KAO_MO3, KBO_MCO2, KBO_MN2O, &
 & CFC12O   , CFC22ADJO  
USE YOERRTA8 , ONLY : KA      ,KB      ,SELFREF    ,FORREF, FRACREFA   ,&
 & FRACREFB , KA_MCO2, KA_MN2O ,KA_MO3, KB_MCO2, KB_MN2O,&
 & CFC12    , CFC22ADJ  
USE YOERRTRWT, ONLY : RWGT
USE YOERRTFTR, ONLY : NGC      ,NGS      ,NGN      

IMPLICIT NONE

INTEGER(KIND=JPIM) :: IGC, IPR, IPRSM, JP, JT

REAL(KIND=JPRB) :: Z_SUMF1, Z_SUMF2, Z_SUMK, Z_SUMK1, Z_SUMK2, Z_SUMK3, Z_SUMK4, Z_SUMK5
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('RRTM_CMBGB8',0,ZHOOK_HANDLE)
DO JT = 1,5
  DO JP = 1,13
    IPRSM = 0
    DO IGC = 1,NGC(8)
      Z_SUMK = 0.0_JPRB
      DO IPR = 1, NGN(NGS(7)+IGC)
        IPRSM = IPRSM + 1
        Z_SUMK = Z_SUMK + KAO(JT,JP,IPRSM)*RWGT(IPRSM+112)
      ENDDO
      KA(JT,JP,IGC) = Z_SUMK
    ENDDO
  ENDDO
ENDDO
DO JT = 1,5
  DO JP = 13,59
    IPRSM = 0
    DO IGC = 1,NGC(8)
      Z_SUMK = 0.0_JPRB
      DO IPR = 1, NGN(NGS(7)+IGC)
        IPRSM = IPRSM + 1
        Z_SUMK = Z_SUMK + KBO(JT,JP,IPRSM)*RWGT(IPRSM+112)
      ENDDO
      KB(JT,JP,IGC) = Z_SUMK
    ENDDO
  ENDDO
ENDDO

DO JT = 1,10
  IPRSM = 0
  DO IGC = 1,NGC(8)
    Z_SUMK = 0.0_JPRB
    DO IPR = 1, NGN(NGS(7)+IGC)
      IPRSM = IPRSM + 1
      Z_SUMK = Z_SUMK + SELFREFO(JT,IPRSM)*RWGT(IPRSM+112)
    ENDDO
    SELFREF(JT,IGC) = Z_SUMK
  ENDDO
ENDDO
DO JT = 1,4
   IPRSM = 0
   DO IGC = 1,NGC(8)
      Z_SUMK = 0.0_JPRB
      DO IPR = 1, NGN(NGS(7)+IGC)
         IPRSM = IPRSM + 1
         Z_SUMK = Z_SUMK + FORREFO(JT,IPRSM)*RWGT(IPRSM+112)
      ENDDO
      FORREF(JT,IGC) = Z_SUMK
   ENDDO
ENDDO

DO JT = 1,19
IPRSM = 0
DO IGC = 1,NGC(8)
  Z_SUMK1= 0.0_JPRB
  Z_SUMK2= 0.0_JPRB
  Z_SUMK3= 0.0_JPRB
  Z_SUMK4= 0.0_JPRB
  Z_SUMK5= 0.0_JPRB
  DO IPR = 1, NGN(NGS(7)+IGC)
    IPRSM = IPRSM + 1
    Z_SUMK1= Z_SUMK1+ KAO_MCO2(JT,IPRSM)*RWGT(IPRSM+112)
    Z_SUMK2= Z_SUMK2+ KBO_MCO2(JT,IPRSM)*RWGT(IPRSM+112)
    Z_SUMK3= Z_SUMK3+ KAO_MO3(JT,IPRSM)*RWGT(IPRSM+112)
    Z_SUMK4= Z_SUMK4+ KAO_MN2O(JT,IPRSM)*RWGT(IPRSM+112)
    Z_SUMK5= Z_SUMK5+ KBO_MN2O(JT,IPRSM)*RWGT(IPRSM+112)
  ENDDO
  KA_MCO2(JT,IGC) = Z_SUMK1
  KB_MCO2(JT,IGC) = Z_SUMK2
  KA_MO3(JT,IGC) = Z_SUMK3
  KA_MN2O(JT,IGC) = Z_SUMK4
  KB_MN2O(JT,IGC) = Z_SUMK5
ENDDO
ENDDO



IPRSM = 0
DO IGC = 1,NGC(8)
  Z_SUMF1= 0.0_JPRB
  Z_SUMF2= 0.0_JPRB
  Z_SUMK1= 0.0_JPRB
  Z_SUMK2= 0.0_JPRB
  DO IPR = 1, NGN(NGS(7)+IGC)
    IPRSM = IPRSM + 1
    Z_SUMF1= Z_SUMF1+ FRACREFAO(IPRSM)
    Z_SUMF2= Z_SUMF2+ FRACREFBO(IPRSM)
    Z_SUMK1= Z_SUMK1+ CFC12O(IPRSM)*RWGT(IPRSM+112)
    Z_SUMK2= Z_SUMK2+ CFC22ADJO(IPRSM)*RWGT(IPRSM+112)
  ENDDO
  FRACREFA(IGC) = Z_SUMF1
  FRACREFB(IGC) = Z_SUMF2
  CFC12(IGC) = Z_SUMK1
  CFC22ADJ(IGC) = Z_SUMK2
ENDDO


!$ACC UPDATE DEVICE(FRACREFA, FRACREFB, CFC12, CFC22ADJ, KA, KB, KA_MCO2, &
!$ACC               KA_MN2O, KA_MO3, KB_MCO2, KB_MN2O, SELFREF, FORREF)

IF (LHOOK) CALL DR_HOOK('RRTM_CMBGB8',1,ZHOOK_HANDLE)
END SUBROUTINE RRTM_CMBGB8

SUBROUTINE scm

   USE flux_arp_mod_h
   USE compbl_mod_h
   USE clesphys_mod_h
   USE ioipsl, only: ju2ymds, ymds2ju, ioconf_calendar,getin
   USE phyetat0_get_mod, ONLY : phyetat0_get, phyetat0_srf
   USE phys_state_var_mod, ONLY : phys_state_var_init, phys_state_var_end, &
       clwcon, detr_therm, &
       qsol, fevap, z0m, z0h, agesno, &
       frac_tersrf, z0m_tersrf, ratio_z0m_z0h_tersrf, &
       albedo_tersrf, beta_tersrf, inertie_tersrf, &
       alpha_soil_tersrf, period_tersrf, hcond_tersrf, &
       tsurfi_tersrf, tsoili_tersrf, tsoil_depth, &
       du_gwd_rando, du_gwd_front, entr_therm, f0, fm_therm, &
       falb_dir, falb_dif, &
       ftsol, beta_aridity, pbl_tke, pctsrf, radsol, rain_fall, snow_fall, ratqs, &
       rnebcon, rugoro, sig1, w01, solaire_etat0, sollw, sollwdown, &
       solsw, solswfdiff, t_ancien, q_ancien, u_ancien, v_ancien, &
       wake_delta_pbl_TKE, delta_tsurf, wake_fip, wake_pe, &
       wake_deltaq, wake_deltat, wake_s, awake_s, wake_dens, &
       awake_dens, cv_gen, wake_cstar, &
       zgam, zmax0, zmea, zpic, zsig, &
       zstd, zthe, zval, ale_bl, ale_bl_trig, alp_bl, &
       ql_ancien, qs_ancien, qbs_ancien, cf_ancien, rvc_ancien, &
       prlw_ancien, prsw_ancien, prbsw_ancien, prw_ancien, &
       u10m,v10m,ale_wake,ale_bl_stat, ratqs_inter_


   USE dimphy
   USE surface_data, only : type_ocean,ok_veget
   USE pbl_surface_mod, only : ftsoil, pbl_surface_init, &
                                 pbl_surface_final
   USE simplehydrol_mod, only : simplehydrol_init, simplehydrol_final

   USE infotrac ! new
   USE control_mod
   USE indice_sol_mod
   USE phyaqua_mod
   USE mod_1D_cases_read_std
   USE print_control_mod, ONLY: lunout, prt_level
   USE iniphysiq_mod, ONLY: iniphysiq
   USE mod_const_mpi, ONLY: comm_lmdz
   USE physiq_mod, ONLY: physiq
   USE comvert_mod, ONLY: presnivs, ap, bp, dpres,nivsig, nivsigs, pa, &
                          preff, aps, bps, pseudoalt, scaleheight
   USE temps_mod, ONLY: annee_ref, calend, day_end, day_ini, day_ref, &
                        itau_dyn, itau_phy, start_time, year_len
   USE phys_cal_mod, ONLY : year_len_phys_cal_mod => year_len
   USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_OUTPUTPHYSSCM

   USE dimensions_mod, ONLY: iim, jjm, llm, ndm
   USE dimsoil_mod_h, ONLY: nsoilmx
   USE yomcst_mod_h
   USE tsoilnudge_mod_h
   USE fcg_gcssold_mod_h
   USE compar1d_mod_h
   USE date_cas_mod_h
implicit none

!=====================================================================
! DECLARATIONS
!=====================================================================

!---------------------------------------------------------------------
!  Externals
!---------------------------------------------------------------------
      external fq_sat
      real fq_sat

!---------------------------------------------------------------------
!  Arguments d' initialisations de la physique (USER DEFINE)
!---------------------------------------------------------------------

      integer, parameter :: ngrid=1
      real :: zcufi    = 1.
      real :: zcvfi    = 1.
      real :: fnday 
      real :: day, daytime 
      real :: day1
      real :: heure
      integer :: jour
      integer :: mois
      integer :: an
 
!---------------------------------------------------------------------
!  Declarations related to forcing and initial profiles 
!---------------------------------------------------------------------

        integer :: kmax = llm
        integer llm700,nq1,nq2,iflag_1d_vert_adv
        INTEGER, PARAMETER :: nlev_max=1000, nqmx=1000
        real timestep, frac
        real height(nlev_max),tttprof(nlev_max),qtprof(nlev_max)
        real  uprof(nlev_max),vprof(nlev_max),e12prof(nlev_max)
        real  ugprof(nlev_max),vgprof(nlev_max),wfls(nlev_max)
        real  dqtdxls(nlev_max),dqtdyls(nlev_max)
        real  dqtdtls(nlev_max),thlpcar(nlev_max)
        real  qprof(nlev_max,nqmx)

!        integer :: forcing_type
        logical :: forcing_les     = .false.
        logical :: forcing_armcu   = .false.
        logical :: forcing_rico    = .false.
        logical :: forcing_radconv = .false.
        logical :: forcing_toga    = .false.
        logical :: forcing_twpice  = .false.
        logical :: forcing_amma    = .false.
        logical :: forcing_dice    = .false.
        logical :: forcing_gabls4  = .false.

        logical :: forcing_GCM2SCM = .false.
        logical :: forcing_GCSSold = .false.
        logical :: forcing_sandu   = .false.
        logical :: forcing_astex   = .false.
        logical :: forcing_fire    = .false.
        logical :: forcing_case    = .false.
        logical :: forcing_case2   = .false.
        logical :: forcing_SCM   = .false.

!flag forcings
        logical :: nudge_wind=.true.
        logical :: nudge_thermo=.false.
        logical :: cptadvw=.true.


!=====================================================================
! DECLARATIONS FOR EACH CASE
!=====================================================================
!
      INCLUDE "1D_decl_cases.h"
!
!---------------------------------------------------------------------
!  Declarations related to nudging
!---------------------------------------------------------------------
     integer :: nudge_max
     parameter (nudge_max=9)
     integer :: inudge_RHT=1
     integer :: inudge_UV=2
     logical :: nudge(nudge_max)
     real :: t_targ(llm)
     real :: rh_targ(llm)
     real :: u_targ(llm)
     real :: v_targ(llm)
!
!---------------------------------------------------------------------
!  Declarations related to vertical discretization:
!---------------------------------------------------------------------
      real :: pzero=1.e5
      real :: play (llm),zlay (llm),sig_s(llm),plev(llm+1)
      real :: playd(llm),zlayd(llm),ap_amma(llm+1),bp_amma(llm+1)

!---------------------------------------------------------------------
!  Declarations related to variables
!---------------------------------------------------------------------

      real :: phi(llm)
      real :: teta(llm),tetal(llm),temp(llm),u(llm),v(llm),w(llm)
      REAL rot(1, llm) ! relative vorticity, in s-1
      real :: rlat_rad(1),rlon_rad(1)
      real :: omega(llm),omega2(llm),rho(llm+1)
      real :: ug(llm),vg(llm),fcoriolis
      real :: sfdt, cfdt
      real :: du_phys(llm),dv_phys(llm),dt_phys(llm)
      real :: w_adv(llm),z_adv(llm)
      real :: d_t_vert_adv(llm),d_u_vert_adv(llm),d_v_vert_adv(llm)
      real :: dt_cooling(llm),d_t_adv(llm),d_t_nudge(llm)
      real :: d_u_nudge(llm),d_v_nudge(llm)
      real :: d_u_age(llm),d_v_age(llm)
      real :: alpha
      real :: ttt

      REAL, ALLOCATABLE, DIMENSION(:,:):: q
      REAL, ALLOCATABLE, DIMENSION(:,:):: dq
      REAL, ALLOCATABLE, DIMENSION(:,:):: d_q_vert_adv
      REAL, ALLOCATABLE, DIMENSION(:,:):: d_q_adv
      REAL, ALLOCATABLE, DIMENSION(:,:):: d_q_nudge

!---------------------------------------------------------------------
!  Initialization of surface variables
!---------------------------------------------------------------------
      real :: run_off_lic_0(1)
      real :: fder(1),snsrf(1,nbsrf),qsurfsrf(1,nbsrf)
      real :: hice(1), tice(1), bilg_cumul(1)
      real :: tsoil(1,nsoilmx,nbsrf)
      ! AM
      REAL, ALLOCATABLE, DIMENSION(:,:) :: tsoil_ter_srf2 ! resized initial soil temperature on vertical levels (K) 
      REAL, ALLOCATABLE, DIMENSION(:,:) :: tsoil_depths2  ! resized soil depth at which inititial temperature is given (m)

!---------------------------------------------------------------------
!  Call to phyredem
!---------------------------------------------------------------------
      logical :: ok_writedem =.true.
      real :: sollw_in = 0.
      real :: solsw_in = 0.
      
!---------------------------------------------------------------------
!  Call to physiq
!---------------------------------------------------------------------
      logical :: firstcall=.true.
      logical :: lastcall=.false.
      real :: phis(1)    = 0.0
      real :: dpsrf(1)

!---------------------------------------------------------------------
!  Initializations of boundary conditions 
!---------------------------------------------------------------------
      real, allocatable :: phy_nat (:)  ! 0=ocean libre,1=land,2=glacier,3=banquise
      real, allocatable :: phy_alb (:)  ! Albedo land only (old value condsurf_jyg=0.3)
      real, allocatable :: phy_sst (:)  ! SST (will not be used; cf read_tsurf1d.F)
      real, allocatable :: phy_bil (:)  ! Ne sert que pour les slab_ocean
      real, allocatable :: phy_rug (:) ! Longueur rugosite utilisee sur land only
      real, allocatable :: phy_ice (:) ! Fraction de glace
      real, allocatable :: phy_fter(:) ! Fraction de terre
      real, allocatable :: phy_foce(:) ! Fraction de ocean
      real, allocatable :: phy_fsic(:) ! Fraction de glace
      real, allocatable :: phy_flic(:) ! Fraction de glace

!---------------------------------------------------------------------
!  Fichiers et d'autres variables
!---------------------------------------------------------------------
      integer :: k,l,i,it=1,mxcalc
      integer :: nsrf
      integer jcode
      integer :: it_end ! iteration number of the last call
      integer ecrit_slab_oc !1=ecrit,-1=lit,0=no file
      data ecrit_slab_oc/-1/

!     if flag_inhib_forcing = 0, tendencies of forcing are added
!                           <> 0, tendencies of forcing are not added
      INTEGER :: flag_inhib_forcing = 0
      CHARACTER(len=80) :: abort_message
      CHARACTER(len=20) :: modname = 'scm'
      LOGICAL :: found

      print*,'VOUS ENTREZ DANS LE 1D FORMAT STANDARD'

!=====================================================================
! INITIALIZATIONS 
!=====================================================================
      du_phys(:)=0.
      dv_phys(:)=0.
      dt_phys(:)=0.
      d_t_vert_adv(:)=0.
      d_u_vert_adv(:)=0.
      d_v_vert_adv(:)=0.
      dt_cooling(:)=0.
      d_t_adv(:)=0.
      d_t_nudge(:)=0.
      d_u_nudge(:)=0.
      d_v_nudge(:)=0.
      d_u_adv(:)=0.
      d_v_adv(:)=0.
      d_u_age(:)=0.
      d_v_age(:)=0.
      
      
! Initialization of Common turb_forcing
       dtime_frcg = 0.
       Turb_fcg_gcssold=.false.
       hthturb_gcssold = 0.
       hqturb_gcssold = 0.




!---------------------------------------------------------------------
! OPTIONS OF THE 1D SIMULATION (lmdz1d.def => unicol.def)
!---------------------------------------------------------------------
        call conf_unicol
!Al1 moves this gcssold var from common fcg_gcssold to 
        Turb_fcg_gcssold = xTurb_fcg_gcssold
! --------------------------------------------------------------------
        close(1)
        write(*,*) 'lmdz1d.def lu => unicol.def'

       forcing_SCM = .true.
       year_ini_cas=1997
       ! It is possible that those parameters are run twice.
       ! A REVOIR : LIRE PEUT ETRE AN MOIS JOUR DIRECETEMENT


       call getin('anneeref',year_ini_cas)
       call getin('dayref',day_deb)
       mth_ini_cas=1 ! pour le moment on compte depuis le debut de l'annee
       call getin('time_ini',heure_ini_cas)
      print*,'NATURE DE LA SURFACE ',nat_surf

! Initialization of the logical switch for nudging

     jcode = iflag_nudge
     do i = 1,nudge_max
       nudge(i) = mod(jcode,10) .ge. 1
       jcode = jcode/10
     enddo
! numerical scheme for vertical advection

     iflag_1d_vert_adv=1
     call getin('iflag_1d_vert_adv',iflag_1d_vert_adv)

!-----------------------------------------------------------------------
!  Definition of the run
!-----------------------------------------------------------------------

      call conf_gcm( 99, .TRUE. )
      
!-----------------------------------------------------------------------
      allocate( phy_nat (year_len))  ! 0=ocean libre,1=land,2=glacier,3=banquise
      phy_nat(:)=0.0
      allocate( phy_alb (year_len))  ! Albedo land only (old value condsurf_jyg=0.3)
      allocate( phy_sst (year_len))  ! SST (will not be used; cf read_tsurf1d.F)
      allocate( phy_bil (year_len))  ! Ne sert que pour les slab_ocean
      phy_bil(:)=1.0
      allocate( phy_rug (year_len)) ! Longueur rugosite utilisee sur land only
      allocate( phy_ice (year_len)) ! Fraction de glace
      phy_ice(:)=0.0
      allocate( phy_fter(year_len)) ! Fraction de terre
      phy_fter(:)=0.0
      allocate( phy_foce(year_len)) ! Fraction de ocean
      phy_foce(:)=0.0
      allocate( phy_fsic(year_len)) ! Fraction de glace
      phy_fsic(:)=0.0
      allocate( phy_flic(year_len)) ! Fraction de glace
      phy_flic(:)=0.0


!-----------------------------------------------------------------------
!   Choix du calendrier
!   -------------------

!      calend = 'earth_365d'
      if (calend == 'earth_360d') then
        call ioconf_calendar('360_day')
        write(*,*)'CALENDRIER CHOISI: Terrestre a 360 jours/an'
      else if (calend == 'earth_365d') then
        call ioconf_calendar('noleap')
        write(*,*)'CALENDRIER CHOISI: Terrestre a 365 jours/an'
      else if (calend == 'earth_366d') then
        call ioconf_calendar('all_leap')
        write(*,*)'CALENDRIER CHOISI: Terrestre bissextile'
      else if (calend == 'gregorian') then
        stop 'gregorian calend should not be used by normal user'
        call ioconf_calendar('gregorian') ! not to be used by normal users
        write(*,*)'CALENDRIER CHOISI: Gregorien'
      else
        write (*,*) 'ERROR : unknown calendar ', calend
        stop 'calend should be 360d,earth_365d,earth_366d,gregorian'
      endif
!-----------------------------------------------------------------------
!
!c Date :
!      La date est supposee donnee sous la forme [annee, numero du jour dans 
!      l annee] ; l heure est donnee dans time_ini, lu dans lmdz1d.def.
!      On appelle ymds2ju pour convertir [annee, jour] en [jour Julien].
!      Le numero du jour est dans "day". L heure est traitee separement.
!      La date complete est dans "daytime" (l'unite est le jour).


      if (nday>0) then
         fnday=nday
      else
         fnday=-nday/float(day_step)
      endif
      print *,'fnday=',fnday
!     start_time doit etre en FRACTION DE JOUR
      start_time=time_ini/24.

      annee_ref = anneeref
      mois = 1
      day_ref = dayref
      heure = 0.
      itau_dyn = 0
      itau_phy = 0
      call ymds2ju(annee_ref,mois,day_ref,heure,day)
      day_ini = int(day)
      day_end = day_ini + int(fnday)

! Convert the initial date to Julian day
      day_ini_cas=day_deb
      print*,'time case',year_ini_cas,mth_ini_cas,day_ini_cas
      call ymds2ju                                                         &
     & (year_ini_cas,mth_ini_cas,day_ini_cas,heure_ini_cas*3600            &
     & ,day_ju_ini_cas)
      print*,'time case 2',day_ini_cas,day_ju_ini_cas
      daytime = day + heure_ini_cas/24. ! 1st day and initial time of the simulation 

! Print out the actual date of the beginning of the simulation :
      call ju2ymds(daytime,year_print, month_print,day_print,sec_print)
      print *,' Time of beginning : ',                                      &
     &        year_print, month_print, day_print, sec_print

!---------------------------------------------------------------------
! Initialization of dimensions, geometry and initial state
!---------------------------------------------------------------------
!     call init_phys_lmdz(1,1,llm,1,(/1/)) ! job now done via iniphysiq
!     but we still need to initialize dimphy module (klon,klev,etc.)  here.
      call init_dimphy1D(1,llm,nb_ter_srf,nb_tsoil_depths)
      call suphel
      call init_infotrac

      if (nqtot>nqmx) STOP 'Augmenter nqmx dans lmdz1d.F'
      allocate(q(llm,nqtot)) ; q(:,:)=0.
      allocate(dq(llm,nqtot)) 
      allocate(d_q_vert_adv(llm,nqtot)) 
      allocate(d_q_adv(llm,nqtot)) 
      allocate(d_q_nudge(llm,nqtot)) 

      q(:,:) = 0.
      dq(:,:) = 0.
      d_q_vert_adv(:,:) = 0.
      d_q_adv(:,:) = 0.
      d_q_nudge(:,:) = 0.

      nsw=6

      call phys_state_var_init

      if (ngrid.ne.klon) then
         print*,'stop in inifis'
         print*,'Probleme de dimensions :'
         print*,'ngrid = ',ngrid
         print*,'klon  = ',klon
         stop
      endif
!!!=====================================================================
!!! Feedback forcing values for Gateaux differentiation (al1)
!!!=====================================================================
      
      qsol = qsolinp
      qsurf = fq_sat(tsurf,psurf/100.)
      beta_aridity(:,:) = beta_surf
      day1= day_ini
      time=daytime-day
      ts_toga(1)=tsurf ! needed by read_tsurf1d.F
      rho(1)=psurf/(rd*tsurf*(1.+(rv/rd-1.)*qsurf)) 

!! mpl et jyg le 22/08/2012 : 
!!  pour que les cas a flux de surface imposes marchent
      IF(.NOT.ok_flux_surf.or.max(abs(wtsurf),abs(wqsurf))>0.) THEN
       fsens=-wtsurf*rcpd*rho(1)
       flat=-wqsurf*rlvtt*rho(1)
       print *,'Flux: ok_flux wtsurf wqsurf',ok_flux_surf,wtsurf,wqsurf
      ENDIF
      print*,'Flux sol ',fsens,flat

! Vertical discretization and pressure levels at half and mid levels:

      pa   = 5e4
!!      preff= 1.01325e5
      preff = psurf
      IF (ok_old_disvert) THEN
        call disvert0(pa,preff,ap,bp,dpres,presnivs,nivsigs,nivsig)
        print *,'On utilise disvert0'
        aps(1:llm)=0.5*(ap(1:llm)+ap(2:llm+1))
        bps(1:llm)=0.5*(bp(1:llm)+bp(2:llm+1))
        scaleheight=8.
        pseudoalt(1:llm)=-scaleheight*log(presnivs(1:llm)/preff)
      ELSE
        call disvert()
        print *,'On utilise disvert'
!       Nouvelle version disvert permettant d imposer ap,bp (modif L.Guez) MPL 18092012
!       Dans ce cas, on lit ap,bp dans le fichier hybrid.txt
      ENDIF

      sig_s=presnivs/preff
      plev =ap+bp*psurf
      play = 0.5*(plev(1:llm)+plev(2:llm+1))
      zlay=-rd*300.*log(play/psurf)/rg ! moved after reading profiles. 

      IF (forcing_type .eq. 59) THEN
! pour forcing_sandu, on cherche l'indice le plus proche de 700hpa#3000m
      write(*,*) '***********************'
      do l = 1, llm
       write(*,*) 'l,play(l),presnivs(l): ',l,play(l),presnivs(l)
       if (trouve_700 .and. play(l).le.70000) then
         llm700=l
         print *,'llm700,play=',llm700,play(l)/100.
         trouve_700= .false.
       endif
      enddo
      write(*,*) '***********************'
      ENDIF

!
!=====================================================================
! EVENTUALLY, READ FORCING DATA :
!=====================================================================

      INCLUDE "1D_read_forc_cases.h"

      if (forcing_GCM2SCM) then
        write (*,*) 'forcing_GCM2SCM not yet implemented'
        stop 'in initialization'
      endif ! forcing_GCM2SCM


!=====================================================================
! Initialisation de la physique : 
!=====================================================================

!  Rq: conf_phys.F90 lit tous les flags de physiq.def; conf_phys appele depuis physiq.F
!
! day_step, iphysiq lus dans gcm.def ci-dessus
! timestep: calcule ci-dessous from rday et day_step
! ngrid=1
! llm: defini dans .../modipsl/modeles/LMDZ4/libf/grid/dimension
! rday: defini dans suphel.F (86400.)
! day_ini: lu dans run.def (dayref)
! rlat_rad,rlon-rad: transformes en radian de rlat,rlon lus dans lmdz1d.def (en degres)
! airefi,zcufi,zcvfi initialises au debut de ce programme
! rday,ra,rg,rd,rcpd declares dans YOMCST.h et calcules dans suphel.F


      day_step = float(nsplit_phys)*day_step/float(iphysiq)
      write (*,*) 'Time step divided by nsplit_phys (=',nsplit_phys,')'
      timestep =rday/day_step
      dtime_frcg = timestep
!
      zcufi=airefi
      zcvfi=airefi
!
      rlat_rad(1)=xlat*rpi/180.
      rlon_rad(1)=xlon*rpi/180.

     ! iniphysiq will call iniaqua who needs year_len from phys_cal_mod
     year_len_phys_cal_mod=year_len
           
     ! Ehouarn: iniphysiq requires arrays related to (3D) dynamics grid,
     ! e.g. for cell boundaries, which are meaningless in 1D; so pad these 
     ! with '0.' when necessary

      call iniphysiq(iim,jjm,llm, &
           1,comm_lmdz, &
           rday,day_ini,timestep,  &
           (/rlat_rad(1),0./),(/0./), &
           (/0.,0./),(/rlon_rad(1),0./),  &
           (/ (/airefi,0./),(/0.,0./) /), &
           (/zcufi,0.,0.,0./), &
           (/zcvfi,0./), &
           ra,rg,rd,rcpd,1)
      print*,'apres iniphysiq'

! 2 PARAMETRES QUI DEVRAIENT ETRE LUS DANS run.def MAIS NE LE SONT PAS ICI:
      co2_ppm= 330.0
      solaire=1370.0

! Ecriture du startphy avant le premier appel a la physique.
! On le met juste avant pour avoir acces a tous les champs

      if (ok_writedem) then

!--------------------------------------------------------------------------
! pbl_surface_init (called here) and pbl_surface_final (called by phyredem)
! need : qsol fder snow qsurf evap rugos agesno ftsoil
!--------------------------------------------------------------------------

        type_ocean = "force"
        run_off_lic_0(1) = restart_runoff 
        call simplehydrol_init(run_off_lic_0)

        fder=0.
        snsrf(1,:)=snowmass ! masse de neige des sous surface
        qsurfsrf(1,:)=qsurf ! humidite de l'air des sous surface
        fevap=0.
        z0m(1,:)=rugos     ! couverture de neige des sous surface
        z0h(1,:)=rugosh    ! couverture de neige des sous surface
        agesno  = xagesno
        tsoil(:,:,:)=tsurf

        iflag_hetero_surf = 0
        CALL getin('iflag_hetero_surf',iflag_hetero_surf)

        IF (iflag_hetero_surf .GT. 0) THEN
          PRINT*, 'scm iflag_hetero_surf', iflag_hetero_surf
          IF ((nbtersrf .LT. 2) .OR. (nbtersrf .GT. max_nbtersrf)) THEN
            abort_message='The number of continental sub-surfaces (nb_ter_srf) must be between 2 and 5'
            CALL abort_physic(modname,abort_message,1)
          ENDIF
          ! resized initial soil temperature on vertical levels and soil depth at which inititial temperature is given
          ALLOCATE(tsoil_ter_srf2(nbtsoildepths,nbtersrf))
          ALLOCATE(tsoil_depths2(nbtsoildepths,nbtersrf))
          tsoil_ter_srf2(:,:) = 0.
          tsoil_depths2(:,:) = 0.
          DO i=1, nbtersrf
            DO l=1, nbtsoildepths
              k = nbtsoildepths*(i-1)+l
              tsoil_ter_srf2(l,i) = tsoil_ter_srf(k)
              tsoil_depths2(l,i) = tsoil_depths(k)
            ENDDO
          ENDDO
          !
          DO i=1, nbtersrf
            frac_tersrf(:,i) = frac_ter_srf(i)                   ! fraction of land surface heterogeneity (-)
            z0m_tersrf(:,i) = rugos_ter_srf(i)                   ! roughness length for momentum of land sub-surfaces (m)
            ratio_z0m_z0h_tersrf(:,i) = ratio_z0m_z0h_ter_srf(i) ! ratio of heat to momentum roughness length of land sub-surfaces (-)
            albedo_tersrf(:,i) = albedo_ter_srf(i)               ! albedo of land sub-surfaces (-)
            beta_tersrf(:,i) = beta_ter_srf(i)                   ! evapotranspiration coef of land sub-surfaces (-)
            inertie_tersrf(:,i) = inertie_ter_srf(i)             ! soil thermal inertia of land sub-surfaces (J/m2/K/s1/2)
            hcond_tersrf(:,i) = hcond_ter_srf(i)                 ! soil heat conductivity (W/(m.K))
            tsurfi_tersrf(:,i) = tsurf_ter_srf(i)                ! initial surface temperature (K)
            DO l=1, nbtsoildepths
              tsoili_tersrf(:,l,i) = tsoil_ter_srf2(l,i)         ! initial soil temperature on vertical levels (K)
              tsoil_depth(:,l,i) = tsoil_depths2(l,i)
            ENDDO
          ENDDO
          alpha_soil_tersrf = alpha_soil_ter_srf               ! ratio between the thicknesses of 2 successive layers (-)
          period_tersrf = period_ter_srf                       ! temperature oscillation amplitude period
          !
          DEALLOCATE(tsoil_ter_srf2)
          DEALLOCATE(tsoil_depths2)
        ENDIF

!-----------------------------------------------------------------------
  !GG
  ! Sea ice
  !IF (iflag_seaice == 2) THEN

  found=phyetat0_get(hice,"hice","Ice thickness",0.)
  IF (.NOT. found) THEN
       PRINT*, "phyetat0: Le champ <hice> est absent"
       PRINT*, "Initialisation a hice=1m "
       hice(:)=1.0
  END IF
  found=phyetat0_get(tice,"tice","Sea Ice temperature",0.)
  IF (.NOT. found) THEN
       PRINT*, "phyetat0: Le champ <tice> est absent"
       PRINT*, "Initialisation a tsol_sic"
       tice(:)=ftsol(:,is_sic)
  END IF
  found=phyetat0_get(bilg_cumul,"bilg_cumul","Flux conductivite + transmit sea-ice",0.)
  IF (.NOT. found) THEN
       PRINT*, "phyetat0: Le champ <bilg_cumul> est absent"
       PRINT*, "Initialisation a zero"
       bilg_cumul(:)=0.0
  END IF

  !END IF
  !GG
        call pbl_surface_init(fder, snsrf, qsurfsrf, tsoil, hice, tice, bilg_cumul)

!------------------ prepare limit conditions for limit.nc -----------------
!--   Ocean force

        print*,'avant phyredem'
        pctsrf(1,:)=0.
          if (nat_surf.eq.0.) then
          pctsrf(1,is_oce)=1.
          pctsrf(1,is_ter)=0.
          pctsrf(1,is_lic)=0.
          pctsrf(1,is_sic)=0.
        else if (nat_surf .eq. 1) then 
          pctsrf(1,is_oce)=0.
          pctsrf(1,is_ter)=1.
          pctsrf(1,is_lic)=0.
          pctsrf(1,is_sic)=0.
        else if (nat_surf .eq. 2) then 
          pctsrf(1,is_oce)=0.
          pctsrf(1,is_ter)=0.
          pctsrf(1,is_lic)=1.
          pctsrf(1,is_sic)=0.
        else if (nat_surf .eq. 3) then 
          pctsrf(1,is_oce)=0.
          pctsrf(1,is_ter)=0.
          pctsrf(1,is_lic)=0.
          pctsrf(1,is_sic)=1.

     end if


        print*,'nat_surf,pctsrf(1,is_oce),pctsrf(1,is_ter)',nat_surf         &
     &        ,pctsrf(1,is_oce),pctsrf(1,is_ter)

        zmasq=pctsrf(1,is_ter)+pctsrf(1,is_lic)
        zpic = zpicinp
        ftsol=tsurf
        falb_dir=albedo
        falb_dif=albedo
        rugoro=rugos 
        t_ancien(1,:)=temp(:)
        q_ancien(1,:)=q(:,1)
        ql_ancien = 0.
        qs_ancien = 0.
        prlw_ancien = 0.
        prsw_ancien = 0.
        prw_ancien = 0.
        IF ( ok_bs ) THEN
           qbs_ancien = 0.
           prbsw_ancien = 0.
        ENDIF
        IF ( ok_ice_supersat ) THEN
          cf_ancien = 0.
          rvc_ancien = 0.
        ENDIF
        rain_fall=0.
        snow_fall=0.
        solsw=0.
        solswfdiff=0.
        sollw=0.
        sollwdown=rsigma*tsurf**4
        radsol=0.
        rnebcon=0.
        ratqs=0.
        clwcon=0.
        zmax0 = 0.
        zmea=zsurf
        zstd=0.
        zsig=0.
        zgam=0.
        zval=0. 
        zthe=0. 
        sig1=0.
        w01=0.
!
        wake_deltaq = 0.
        wake_deltat = 0.
        wake_delta_pbl_TKE(:,:,:) = 0.
        delta_tsurf = 0.
        wake_fip = 0.
        wake_pe = 0.
        wake_s = 0.
        awake_s = 0.
        wake_dens = 0.
        awake_dens = 0.
        cv_gen = 0.
        wake_cstar = 0.
        ale_bl = 0.
        ale_bl_trig = 0.
        alp_bl = 0.
        IF (ALLOCATED(du_gwd_rando)) du_gwd_rando = 0.
        IF (ALLOCATED(du_gwd_front)) du_gwd_front = 0.
        entr_therm = 0.
        detr_therm = 0.
        f0 = 0.
        fm_therm = 0.
        u_ancien(1,:)=u(:)
        v_ancien(1,:)=v(:)
 
        u10m=0.
        v10m=0.
        ale_wake=0.
        ale_bl_stat=0.
        ratqs_inter_(:,:)= 0.002

!------------------------------------------------------------------------
! Make file containing restart for the physics (startphy.nc)
!
! NB: List of the variables to be written by phyredem (via put_field):
! rlon,rlat,zmasq,pctsrf(:,is_ter),pctsrf(:,is_lic),pctsrf(:,is_oce)
! pctsrf(:,is_sic),ftsol(:,nsrf),tsoil(:,isoil,nsrf),qsurf(:,nsrf)
! qsol,falb_dir(:,nsrf),falb_dif(:,nsrf),evap(:,nsrf),snow(:,nsrf)
! radsol,solsw,solswfdiff,sollw, sollwdown,fder,rain_fall,snow_fall,frugs(:,nsrf)
! agesno(:,nsrf),zmea,zstd,zsig,zgam,zthe,zpic,zval,rugoro
! t_ancien,q_ancien,,frugs(:,is_oce),clwcon(:,1),rnebcon(:,1),ratqs(:,1)
! run_off_lic_0,pbl_tke(:,1:klev,nsrf), zmax0,f0,sig1,w01
! wake_deltat,wake_deltaq,wake_s,awake_s,wake_dens,awake_dens,cv_gen,wake_cstar,
! wake_fip,wake_delta_pbl_tke(:,1:klev,nsrf)
!
! NB2: The content of the startphy.nc file depends on some flags defined in
! the ".def" files. However, since conf_phys is not called in lmdz1d.F90, these flags have 
! to be set at some arbitratry convenient values.
!------------------------------------------------------------------------
!Al1 =============== restart option ======================================
        iflag_physiq=0
        call getin('iflag_physiq',iflag_physiq)

        if (.not.restart) then
          iflag_pbl = 5
          call phyredem ("startphy.nc")
        else
! (desallocations)
        print*,'callin surf final'
          call pbl_surface_final( fder, snsrf, qsurfsrf, tsoil)
        print*,'after surf final'
          CALL simplehydrol_final(run_off_lic_0)
        endif

        ok_writedem=.false.
        print*,'apres phyredem'

      endif ! ok_writedem
      
!------------------------------------------------------------------------
! Make file containing boundary conditions (limit.nc) **Al1->restartdyn***
! --------------------------------------------------
! NB: List of the variables to be written in limit.nc 
!     (by writelim.F, subroutine of 1DUTILS.h):
!        phy_nat,phy_alb,phy_sst,phy_bil,phy_rug,phy_ice,
!        phy_fter,phy_foce,phy_flic,phy_fsic)
!------------------------------------------------------------------------
      do i=1,year_len
        phy_nat(i)  = nat_surf
        phy_alb(i)  = albedo
        phy_sst(i)  = tsurf ! read_tsurf1d will be used instead
        phy_rug(i)  = rugos
        phy_fter(i) = pctsrf(1,is_ter)
        phy_foce(i) = pctsrf(1,is_oce)
        phy_fsic(i) = pctsrf(1,is_sic)
        phy_flic(i) = pctsrf(1,is_lic)
      enddo

! fabrication de limit.nc
      call writelim (1,phy_nat,phy_alb,phy_sst,phy_bil,phy_rug,             &
     &               phy_ice,phy_fter,phy_foce,phy_flic,phy_fsic)


      call phys_state_var_end
      if (restart) then
        print*,'call to restart dyn 1d'
        Call dyn1deta0("start1dyn.nc",plev,play,phi,phis,presnivs,          &
     &              u,v,temp,q,omega2)

       print*,'fnday,annee_ref,day_ref,day_ini',                            &
     &     fnday,annee_ref,day_ref,day_ini
       day = day_ini
       day_end = day_ini + nday
       daytime = day + time_ini/24. ! 1st day and initial time of the simulation 

! Print out the actual date of the beginning of the simulation :
       call ju2ymds(daytime, an, mois, jour, heure)
       print *,' Time of beginning : y m d h',an, mois,jour,heure/3600.

       day = int(daytime)
       time=daytime-day
  
       print*,'****** intialised fields from restart1dyn *******'
       print*,'plev,play,phi,phis,presnivs,u,v,temp,q,omega2'
       print*,'temp(1),q(1,1),u(1),v(1),plev(1),phis :'
       print*,temp(1),q(1,1),u(1),v(1),plev(1),phis(1)
! raz for safety
       do l=1,llm
         d_q_vert_adv(l,:) = 0.
       enddo
      endif
!======================  end restart =================================
      IF (ecrit_slab_oc.eq.1) then
         open(97,file='div_slab.dat',STATUS='UNKNOWN')
       elseif (ecrit_slab_oc.eq.0) then
         open(97,file='div_slab.dat',STATUS='OLD')
       endif
!
!=====================================================================
IF (CPPKEY_OUTPUTPHYSSCM) THEN
       CALL iophys_ini(timestep)
END IF

!=====================================================================
! START OF THE TEMPORAL LOOP :
!=====================================================================
           
      it_end = nint(fnday*day_step)
      do while(it.le.it_end)

       if (prt_level.ge.1) then
         print*,'XXXXXXXXXXXXXXXXXXX ITAP,day,time=',                       &
     &             it,day,time,it_end,day_step
         print*,'PAS DE TEMPS ',timestep
       endif
       if (it.eq.it_end) lastcall=.True.

!---------------------------------------------------------------------
! Interpolation of forcings in time and onto model levels
!---------------------------------------------------------------------

      INCLUDE "1D_interp_cases.h"

!---------------------------------------------------------------------
!  Geopotential :
!---------------------------------------------------------------------
        phis(1)=zsurf*RG

        ! Calculate geopotential from the ground surface since phi and phis are added in physiq_mod
        phi(1)=RD*temp(1)*(plev(1)-play(1))/(.5*(plev(1)+play(1)))

        do l = 1, llm-1
          phi(l+1)=phi(l)+RD*(temp(l)+temp(l+1))*                           &
     &    (play(l)-play(l+1))/(play(l)+play(l+1))
        enddo

!---------------------------------------------------------------------
!  Vertical advection
!---------------------------------------------------------------------

   IF ( forc_w+forc_omega > 0 ) THEN

      IF ( forc_w == 1 ) THEN
         w_adv=w_mod_cas
         z_adv=phi/RG
      ELSE
         w_adv=omega
         z_adv=play
      ENDIF
      
      ! calculation of potential temperature for the advection
      teta=temp*(pzero/play)**rkappa

      ! vertical tendencies computed as d X / d t = -W  d X / d z

      IF (iflag_1d_vert_adv .EQ. 0) THEN

      ! old centered numerical scheme
      do l=2,llm-1
        d_u_vert_adv(l)=-w_adv(l)*(u(l+1)-u(l-1))/(z_adv(l+1)-z_adv(l-1))
        d_v_vert_adv(l)=-w_adv(l)*(v(l+1)-v(l-1))/(z_adv(l+1)-z_adv(l-1))
        ! d theta / dt = -W d theta / d z, transformed into d temp / d t dividing by (pzero/play(l))**rkappa
        d_t_vert_adv(l)=-w_adv(l)*(teta(l+1)-teta(l-1))/(z_adv(l+1)-z_adv(l-1)) / (pzero/play(l))**rkappa
        d_q_vert_adv(l,:)=-w_adv(l)*(q(l+1,:)-q(l-1,:))/(z_adv(l+1)-z_adv(l-1))
      enddo


      ELSE IF (iflag_1d_vert_adv .EQ. 1) THEN
      ! upstream numerical scheme

      do l=2,llm-1
        IF ( ( ( forc_w .EQ. 1 ) .AND. ( w_adv(l) .GT. 0. ) ) .OR. &
             ( ( forc_w .NE. 1 ) .AND. ( w_adv(l) .LT. 0. ) ) ) THEN
          d_u_vert_adv(l)=-w_adv(l)*(u(l)-u(l-1))/(z_adv(l)-z_adv(l-1))
          d_v_vert_adv(l)=-w_adv(l)*(v(l)-v(l-1))/(z_adv(l)-z_adv(l-1))
          ! d theta / dt = -W d theta / d z, transformed into d temp / d t dividing by (pzero/play(l))**rkappa
          d_t_vert_adv(l)=-w_adv(l)*(teta(l)-teta(l-1))/(z_adv(l)-z_adv(l-1)) / (pzero/play(l))**rkappa
          d_q_vert_adv(l,:)=-w_adv(l)*(q(l,:)-q(l-1,:))/(z_adv(l)-z_adv(l-1))
        ELSE
          d_u_vert_adv(l)=-w_adv(l)*(u(l+1)-u(l))/(z_adv(l+1)-z_adv(l))
          d_v_vert_adv(l)=-w_adv(l)*(v(l+1)-v(l))/(z_adv(l+1)-z_adv(l))
          ! d theta / dt = -W d theta / d z, transformed into d temp / d t dividing by (pzero/play(l))**rkappa
          d_t_vert_adv(l)=-w_adv(l)*(teta(l+1)-teta(l))/(z_adv(l+1)-z_adv(l)) / (pzero/play(l))**rkappa
          d_q_vert_adv(l,:)=-w_adv(l)*(q(l+1,:)-q(l,:))/(z_adv(l+1)-z_adv(l))
        ENDIF
      enddo


      ENDIF ! numerical scheme for vertical advection
      
      
      IF (flag_inhib_forcing == 0) then ! if tendency of forcings should be added
          u(1:mxcalc)=u(1:mxcalc) + timestep * d_u_vert_adv(1:mxcalc)
          v(1:mxcalc)=v(1:mxcalc) + timestep * d_v_vert_adv(1:mxcalc)
          q(1:mxcalc,:)=q(1:mxcalc,:) + timestep * d_q_vert_adv(1:mxcalc,:)
          temp(1:mxcalc)=temp(1:mxcalc) + timestep * d_t_vert_adv(1:mxcalc)
          teta=temp*(pzero/play)**rkappa
      ENDIF
   
   ENDIF

!---------------------------------------------------------------------
! Listing output for debug prt_level>=1
!---------------------------------------------------------------------
       if (prt_level>=1) then
         print *,' avant physiq : -------- day time ',day,time
         write(*,*) 'firstcall,lastcall,phis',                               &
     &               firstcall,lastcall,phis
       end if
       if (prt_level>=5) then
         write(*,'(a10,2a4,4a13)') 'BEFOR1 IT=','it','l',                   &
     &        'presniv','plev','play','phi'
         write(*,'(a10,2i4,4f13.2)') ('BEFOR1 IT= ',it,l,                   &
     &         presnivs(l),plev(l),play(l),phi(l),l=1,llm)
         write(*,'(a11,2a4,a11,6a8)') 'BEFOR2','it','l',                    &
     &         'presniv','u','v','temp','q1','q2','omega2'
         write(*,'(a11,2i4,f11.2,5f8.2,e10.2)') ('BEFOR2 IT= ',it,l,         &
     &   presnivs(l),u(l),v(l),temp(l),q(l,1),q(l,2),omega2(l),l=1,llm)
       endif

!---------------------------------------------------------------------
!   Call physiq :
!---------------------------------------------------------------------
       call physiq(ngrid,llm, &
                    firstcall,lastcall,timestep, &
                    plev,play,phi,phis,presnivs, &
                    u,v, rot, temp,q,omega2, &
                    du_phys,dv_phys,dt_phys,dq,dpsrf)
                firstcall=.false.

!---------------------------------------------------------------------
! Listing output for debug
!---------------------------------------------------------------------
        if (prt_level>=5) then
          write(*,'(a11,2a4,4a13)') 'AFTER1 IT=','it','l',                  &
     &        'presniv','plev','play','phi'
          write(*,'(a11,2i4,4f13.2)') ('AFTER1 it= ',it,l,                  &
     &    presnivs(l),plev(l),play(l),phi(l),l=1,llm)
          write(*,'(a11,2a4,a11,6a8)') 'AFTER2','it','l',                   &
     &         'presniv','u','v','temp','q1','q2','omega2'
          write(*,'(a11,2i4,f11.2,5f8.2,e10.2)') ('AFTER2 it= ',it,l,       &
     &    presnivs(l),u(l),v(l),temp(l),q(l,1),q(l,2),omega2(l),l=1,llm)
          write(*,'(a11,2a4,a11,5a8)') 'AFTER3','it','l',                   &
     &         'presniv','du_phys','dv_phys','dt_phys','dq1','dq2'    
           write(*,'(a11,2i4,f11.2,5f8.2)') ('AFTER3 it= ',it,l,            &
     &      presnivs(l),86400*du_phys(l),86400*dv_phys(l),                   &
     &       86400*dt_phys(l),86400*dq(l,1),dq(l,2),l=1,llm)
          write(*,*) 'dpsrf',dpsrf
        endif
!---------------------------------------------------------------------
!   Add physical tendencies :
!---------------------------------------------------------------------

       fcoriolis=2.*sin(rpi*xlat/180.)*romega

      IF (prt_level >= 5) print*, 'fcoriolis, xlat,mxcalc ', &
                                   fcoriolis, xlat,mxcalc

!---------------------------------------------------------------------
! Geostrophic forcing 
!---------------------------------------------------------------------

      IF ( forc_geo == 0 ) THEN
              d_u_age(1:mxcalc)=0.
              d_v_age(1:mxcalc)=0.
      ELSE
       sfdt = sin(0.5*fcoriolis*timestep)
       cfdt = cos(0.5*fcoriolis*timestep)

        d_u_age(1:mxcalc)= -2.*sfdt/timestep*                                &
     &          (sfdt*(u(1:mxcalc)-ug(1:mxcalc)) -                          &
     &           cfdt*(v(1:mxcalc)-vg(1:mxcalc))  )
!!     : fcoriolis*(v(1:mxcalc)-vg(1:mxcalc))
!
       d_v_age(1:mxcalc)= -2.*sfdt/timestep*                                 &
     &          (cfdt*(u(1:mxcalc)-ug(1:mxcalc)) +                           &
     &           sfdt*(v(1:mxcalc)-vg(1:mxcalc))  )
!!     : -fcoriolis*(u(1:mxcalc)-ug(1:mxcalc))
      ENDIF
!
!---------------------------------------------------------------------
!  Nudging
!---------------------------------------------------------------------
      d_t_nudge(:) = 0.
      d_u_nudge(:) = 0.
      d_v_nudge(:) = 0.
      d_q_nudge(:,:) = 0.

      DO l=1,llm

         IF (nudging_u .LT. 0) THEN
              
             d_u_nudge(l)=(u_nudg_mod_cas(l)-u(l))*invtau_u_nudg_mod_cas(l)
       
         ELSE

             IF ( play(l) < p_nudging_u .AND. nint(nudging_u) /= 0 ) &
             & d_u_nudge(l)=(u_nudg_mod_cas(l)-u(l))/nudging_u

         ENDIF 


         IF (nudging_v .LT. 0) THEN
              
             d_v_nudge(l)=(v_nudg_mod_cas(l)-v(l))*invtau_v_nudg_mod_cas(l)
       
         ELSE


             IF ( play(l) < p_nudging_v .AND. nint(nudging_v) /= 0 ) &
             & d_v_nudge(l)=(v_nudg_mod_cas(l)-v(l))/nudging_v

         ENDIF


         IF (nudging_t .LT. 0) THEN
              
             d_t_nudge(l)=(temp_nudg_mod_cas(l)-temp(l))*invtau_temp_nudg_mod_cas(l)
       
         ELSE


             IF ( play(l) < p_nudging_t .AND. nint(nudging_t) /= 0 ) &
             & d_t_nudge(l)=(temp_nudg_mod_cas(l)-temp(l))/nudging_t

          ENDIF


         IF (nudging_qv .LT. 0) THEN
              
             d_q_nudge(l,1)=(qv_nudg_mod_cas(l)-q(l,1))*invtau_qv_nudg_mod_cas(l)
       
         ELSE

             IF ( play(l) < p_nudging_qv .AND. nint(nudging_qv) /= 0 ) &
             & d_q_nudge(l,1)=(qv_nudg_mod_cas(l)-q(l,1))/nudging_qv

         ENDIF

      ENDDO

!-----------------------------------------------------------
! horizontal forcings (advection) and nudging
!-----------------------------------------------------------

    IF (flag_inhib_forcing == 0) then ! if tendency of forcings should be added

        u(1:mxcalc)=u(1:mxcalc) + timestep*(                                &
     &              du_phys(1:mxcalc)                                       &
     &             +d_u_age(1:mxcalc)+d_u_adv(1:mxcalc)                       &
     &             +d_u_nudge(1:mxcalc) )            
        v(1:mxcalc)=v(1:mxcalc) + timestep*(                                 &
     &              dv_phys(1:mxcalc)                                       &
     &             +d_v_age(1:mxcalc)+d_v_adv(1:mxcalc)                       &
     &             +d_v_nudge(1:mxcalc) )
        q(1:mxcalc,:)=q(1:mxcalc,:)+timestep*(                              &
     &                dq(1:mxcalc,:)                                        &
     &               +d_q_adv(1:mxcalc,:)                                   &
     &               +d_q_nudge(1:mxcalc,:) )


        temp(1:mxcalc)=temp(1:mxcalc)+timestep*(                            &
     &              dt_phys(1:mxcalc)                                       &
     &             +d_t_adv(1:mxcalc)                                       &
     &             +d_t_nudge(1:mxcalc)                                     &
     &             +dt_cooling(1:mxcalc))  ! Taux de chauffage ou refroid.

!---------------------------------------------------------------------
!  Optional outputs
!---------------------------------------------------------------------

IF (CPPKEY_OUTPUTPHYSSCM) THEN
      CALL iophys_ecrit('w_adv',klev,'w_adv','K/day',w_adv)
      CALL iophys_ecrit('z_adv',klev,'z_adv','K/day',z_adv)
      CALL iophys_ecrit('dtadv',klev,'dtadv','K/day',86400*d_t_adv)
      CALL iophys_ecrit('dtdyn',klev,'dtdyn','K/day',86400*d_t_vert_adv)
      CALL iophys_ecrit('qv',klev,'qv','g/kg',1000*q(:,1))
      CALL iophys_ecrit('qvnud',klev,'qvnud','g/kg',1000*u_nudg_mod_cas)
      CALL iophys_ecrit('u',klev,'u','m/s',u)
      CALL iophys_ecrit('unud',klev,'unud','m/s',u_nudg_mod_cas)
      CALL iophys_ecrit('v',klev,'v','m/s',v)
      CALL iophys_ecrit('vnud',klev,'vnud','m/s',v_nudg_mod_cas)
      CALL iophys_ecrit('temp',klev,'temp','K',temp)
      CALL iophys_ecrit('tempnud',klev,'temp_nudg_mod_cas','K',temp_nudg_mod_cas)
      CALL iophys_ecrit('dtnud',klev,'dtnud','K/day',86400*d_t_nudge)
      CALL iophys_ecrit('dqnud',klev,'dqnud','K/day',1000*86400*d_q_nudge(:,1))
END IF



! CONSERVE EN ATTENDANT QUE LE CAS EN QUESTION FONCTIONNE EN STD !!

        teta=temp*(pzero/play)**rkappa

!---------------------------------------------------------------------
!   Nudge soil temperature if requested
!---------------------------------------------------------------------

      IF (nudge_tsoil .AND. .NOT. lastcall) THEN
       ftsoil(1,isoil_nudge,:) = ftsoil(1,isoil_nudge,:)                     &
     &  -timestep/tau_soil_nudge*(ftsoil(1,isoil_nudge,:)-Tsoil_nudge)
      ENDIF


   END IF ! end if in case tendency should be added

!---------------------------------------------------------------------
!   Air temperature :
!---------------------------------------------------------------------        
        if (lastcall) then
          print*,'Pas de temps final ',it
          call ju2ymds(daytime, an, mois, jour, heure)
          print*,'a la date : a m j h',an, mois, jour ,heure/3600.
        endif

!  incremente day time
        daytime = daytime+1./day_step
        day = int(daytime+0.1/day_step)
        time = time_ini/24.+real(mod(it,day_step))/day_step
        it=it+1

      enddo

      if (ecrit_slab_oc.ne.-1) close(97)

!Al1 Call to 1D equivalent of dynredem (an,mois,jour,heure ?)
! ---------------------------------------------------------------------------
       call dyn1dredem("restart1dyn.nc",                                    &
     &              plev,play,phi,phis,presnivs,                            &
     &              u,v,temp,q,omega2)

        CALL abort_gcm ('lmdz1d   ','The End  ',0)

END SUBROUTINE scm

! radiation_save.F90 - Save data to NetCDF files
!
! (C) Copyright 2014- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!
! Author:  Robin Hogan
! Email:   r.j.hogan@ecmwf.int
!
! Modifications
!   2017-04-22  R. Hogan  Adapt for new way of describing longwave properties
!   2019-01-02  R. Hogan  Only save cloud properties if do_clouds==.true.

module radiation_save

  use parkind1, only : jprb

  implicit none

  ! Two available subroutines: save final fluxes and save intermediate
  ! radiative properties
  public :: save_fluxes, save_radiative_properties, save_inputs

contains

  !---------------------------------------------------------------------
  ! Save fluxes in "flux" to NetCDF file_name, plus pressure from the
  ! thermodynamics object
  subroutine save_fluxes(file_name, config, thermodynamics, flux, &
       &                 iverbose, is_hdf5_file, experiment_name, &
       &                 is_double_precision)

    use yomhook,                  only : lhook, dr_hook

    use easy_netcdf

    use radiation_io,             only : nulout
    use radiation_config,         only : config_type, IGasModelMonochromatic
    use radiation_thermodynamics, only : thermodynamics_type
    use radiation_flux,           only : flux_type

    character(len=*),           intent(in) :: file_name
    type(config_type),          intent(in) :: config
    type(thermodynamics_type),  intent(in) :: thermodynamics
    type(flux_type),            intent(in) :: flux
    integer,          optional, intent(in) :: iverbose
    logical,          optional, intent(in) :: is_hdf5_file
    logical,          optional, intent(in) :: is_double_precision
    character(len=*), optional, intent(in) :: experiment_name

    type(netcdf_file)                      :: out_file
    integer                                :: ncol, n_lev_plus1
    character(5), parameter                :: default_lw_units_str = 'W m-2'
    character(5)                           :: lw_units_str
    integer                                :: i_local_verbose

    real(jprb) :: hook_handle

    if (lhook) call dr_hook('radiation_save:save_fluxes',0,hook_handle)
    
    if (present(iverbose)) then
      i_local_verbose = iverbose
    else
      i_local_verbose = config%iverbose
    end if

    ! Work out array dimensions
    if (config%do_sw) then
      ncol = size(flux%sw_up,1)
      n_lev_plus1 = size(flux%sw_up,2)
    elseif (config%do_lw) then
      ncol = size(flux%lw_up,1)
      n_lev_plus1 = size(flux%lw_up,2)
    else
      if (i_local_verbose >= 1) then
        write(nulout,'(a,a,a)') 'Warning: neither longwave nor shortwave computed so ', &
             &                  file_name,' not written'
      end if
      return
    end if

    if (config%i_gas_model == IGasModelMonochromatic &
         .and. config%mono_lw_wavelength > 0.0_jprb) then
      lw_units_str = 'W m-3'
    else
      lw_units_str = default_lw_units_str
    end if

    ! Open the file
    call out_file%create(trim(file_name), iverbose=i_local_verbose, is_hdf5_file=is_hdf5_file)

    ! Variables stored internally with column varying fastest, but in
    ! output file column varies most slowly so need to transpose
    call out_file%transpose_matrices(.true.)

    ! Set default precision for file, if specified
    if (present(is_double_precision)) then
      call out_file%double_precision(is_double_precision)
    end if

    ! Spectral fluxes in memory are dimensioned (nband,ncol,nlev), but
    ! are reoriented in the output file to be (nband,nlev,ncol), where
    ! the convention here is first dimension varying fastest
    call out_file%permute_3d_arrays( (/ 1, 3, 2 /) )

    ! Define dimensions
    call out_file%define_dimension("column", ncol)
    call out_file%define_dimension("half_level", n_lev_plus1)

    if (config%do_save_spectral_flux) then
      if (config%do_lw) then
        call out_file%define_dimension("band_lw", config%n_spec_lw)
      end if
      if (config%do_sw) then
        call out_file%define_dimension("band_sw", config%n_spec_sw)
      end if
    else if (config%do_surface_sw_spectral_flux) then
      if (config%do_sw) then
        call out_file%define_dimension("band_sw", config%n_bands_sw)
      end if
    end if

    if (config%do_lw .and. config%do_canopy_fluxes_lw) then
      call out_file%define_dimension("canopy_band_lw", &
           &  size(flux%lw_dn_surf_canopy, 1))
    end if
    if (config%do_sw .and. config%do_canopy_fluxes_sw) then
      call out_file%define_dimension("canopy_band_sw", &
           &  size(flux%sw_dn_diffuse_surf_canopy, 1))
    end if

    ! Put global attributes
    call out_file%put_global_attributes( &
         &   title_str="Radiative flux profiles from the ecRad offline radiation model", &
         &   references_str="Hogan, R. J., and A. Bozzo, 2018: A flexible and efficient radiation " &
         &   //"scheme for the ECMWF model. J. Adv. Modeling Earth Sys., 10, 1990–2008", &
         &   source_str="ecRad offline radiation model")

    ! Save "experiment" global attribute if present and not empty
    if (present(experiment_name)) then
      if (experiment_name /= " ") then
        call out_file%put_global_attribute("experiment", experiment_name)
      end if
    end if

    ! Define variables
    call out_file%define_variable("pressure_hl", &
         &   dim2_name="column", dim1_name="half_level", &
         &   units_str="Pa", long_name="Pressure", &
         &   standard_name="air_pressure")

    if (config%do_lw) then
      call out_file%define_variable("flux_up_lw", &
           &   dim2_name="column", dim1_name="half_level", &
           &   units_str=lw_units_str, long_name="Upwelling longwave flux", &
           &   standard_name="upwelling_longwave_flux_in_air")
      call out_file%define_variable("flux_dn_lw", &
           &   dim2_name="column", dim1_name="half_level", &
           &   units_str=lw_units_str, long_name="Downwelling longwave flux", &
           &   standard_name="downwelling_longwave_flux_in_air")
      if (config%do_clear) then
        call out_file%define_variable("flux_up_lw_clear", &
             &   dim2_name="column", dim1_name="half_level", &
             &   units_str=lw_units_str, &
             &   long_name="Upwelling clear-sky longwave flux")
        call out_file%define_variable("flux_dn_lw_clear", &
             &   dim2_name="column", dim1_name="half_level", &
             &   units_str=lw_units_str, &
             &   long_name="Downwelling clear-sky longwave flux")
      end if

      if (config%do_lw_derivatives) then
        call out_file%define_variable("lw_derivative", &
             &  dim2_name="column", dim1_name="half_level", &
             &  units_str="1", &
             &  long_name="Derivative of upwelling LW flux w.r.t. surface value")
      end if

      if (config%do_save_spectral_flux) then
        call out_file%define_variable("spectral_flux_up_lw", &
             &   dim3_name="column", dim2_name="half_level", &
             &   dim1_name="band_lw", units_str=lw_units_str, &
             &   long_name="Spectral upwelling longwave flux")
        call out_file%define_variable("spectral_flux_dn_lw", &
             &   dim3_name="column", dim2_name="half_level", &
             &   dim1_name="band_lw", units_str=lw_units_str, &
             &   long_name="Spectral downwelling longwave flux")
        if (config%do_clear) then
          call out_file%define_variable("spectral_flux_up_lw_clear", &
               &   dim3_name="column", dim2_name="half_level", &
               &   dim1_name="band_lw", units_str=lw_units_str, &
               &   long_name="Spectral upwelling clear-sky longwave flux")
          call out_file%define_variable("spectral_flux_dn_lw_clear", &
               &   dim3_name="column", dim2_name="half_level", &
               &   dim1_name="band_lw", units_str=lw_units_str, &
               &   long_name="Spectral downwelling clear-sky longwave flux")
        end if
      end if
   
      if (config%do_canopy_fluxes_lw) then
        call out_file%define_variable("canopy_flux_dn_lw_surf", &
             &   dim2_name="column", dim1_name="canopy_band_lw", units_str=lw_units_str, &
             &   long_name="Surface downwelling longwave flux in canopy bands")
      end if

    end if

    if (config%do_sw) then
      call out_file%define_variable("flux_up_sw", &
           &   dim2_name="column", dim1_name="half_level", &
           &   units_str="W m-2", long_name="Upwelling shortwave flux", &
           &   standard_name="upwelling_shortwave_flux_in_air")
      call out_file%define_variable("flux_dn_sw", &
           &   dim2_name="column", dim1_name="half_level", &
           &   units_str="W m-2", long_name="Downwelling shortwave flux", &
           &   standard_name="downwelling_shortwave_flux_in_air")
      if (config%do_sw_direct) then
        call out_file%define_variable("flux_dn_direct_sw", &
             &   dim2_name="column", dim1_name="half_level", &
             &   units_str="W m-2", &
             &   long_name="Downwelling direct shortwave flux")
      end if
      if (config%do_clear) then
        call out_file%define_variable("flux_up_sw_clear", &
             &   dim2_name="column", dim1_name="half_level", &
             &   units_str="W m-2", &
             &   long_name="Upwelling clear-sky shortwave flux")
        call out_file%define_variable("flux_dn_sw_clear", &
             &   dim2_name="column", dim1_name="half_level", &
             &   units_str="W m-2", &
             &   long_name="Downwelling clear-sky shortwave flux")
        if (config%do_sw_direct) then
          call out_file%define_variable("flux_dn_direct_sw_clear", &
               &   dim2_name="column", dim1_name="half_level", &
               &   units_str="W m-2", &
               &   long_name="Downwelling clear-sky direct shortwave flux")
        end if
      end if

      if (config%do_save_spectral_flux) then
        call out_file%define_variable("spectral_flux_up_sw", &
             &   dim3_name="column", dim2_name="half_level", &
             &   dim1_name="band_sw", units_str="W m-2", &
             &   long_name="Spectral upwelling shortwave flux")
        call out_file%define_variable("spectral_flux_dn_sw", &
             &   dim3_name="column", dim2_name="half_level", &
             &   dim1_name="band_sw", units_str="W m-2", &
             &   long_name="Spectral downwelling shortwave flux")
        if (config%do_sw_direct) then
          call out_file%define_variable("spectral_flux_dn_direct_sw", &
               &   dim3_name="column", dim2_name="half_level", &
               &   dim1_name="band_sw", units_str="W m-2", &
               &   long_name="Spectral downwelling direct shortwave flux")
        end if
        if (config%do_clear) then
          call out_file%define_variable("spectral_flux_up_sw_clear", &
               &   dim3_name="column", dim2_name="half_level", &
               &   dim1_name="band_sw", units_str="W m-2", &
               &   long_name="Spectral upwelling clear-sky shortwave flux")
          call out_file%define_variable("spectral_flux_dn_sw_clear", &
               &   dim3_name="column", dim2_name="half_level", &
               &   dim1_name="band_sw", units_str="W m-2", &
               &   long_name="Spectral downwelling clear-sky shortwave flux")
          if (config%do_sw_direct) then
            call out_file%define_variable("spectral_flux_dn_direct_sw_clear", &
                 &   dim3_name="column", dim2_name="half_level", &
                 &   dim1_name="band_sw", units_str="W m-2", &
                 &   long_name="Spectral downwelling clear-sky direct shortwave flux")
          end if
        end if
      else if (config%do_surface_sw_spectral_flux) then
        call out_file%define_variable("spectral_flux_dn_sw_surf", &
             &   dim2_name="column", dim1_name="band_sw", units_str="W m-2", &
             &   long_name="Spectral downwelling shortwave flux at surface")
        call out_file%define_variable("spectral_flux_dn_direct_sw_surf", &
             &   dim2_name="column", dim1_name="band_sw", units_str="W m-2", &
             &   long_name="Spectral downwelling direct shortwave flux at surface")
        if (config%do_clear) then
          call out_file%define_variable("spectral_flux_dn_sw_surf_clear", &
               &   dim2_name="column", dim1_name="band_sw", units_str="W m-2", &
               &   long_name="Spectral downwelling clear-sky shortwave flux at surface")
          call out_file%define_variable("spectral_flux_dn_direct_sw_surf_clear", &
               &   dim2_name="column", dim1_name="band_sw", units_str="W m-2", &
               &   long_name="Spectral downwelling clear-sky direct shortwave flux at surface")
        end if
      end if
   
      if (config%do_canopy_fluxes_sw) then
        call out_file%define_variable("canopy_flux_dn_diffuse_sw_surf", &
             &   dim2_name="column", dim1_name="canopy_band_sw", units_str="W m-2", &
             &   long_name="Surface downwelling diffuse shortwave flux in canopy bands")
        call out_file%define_variable("canopy_flux_dn_direct_sw_surf", &
             &   dim2_name="column", dim1_name="canopy_band_sw", units_str="W m-2", &
             &   long_name="Surface downwelling direct shortwave flux in canopy bands")
      end if

    end if
   
    if (config%do_lw .and. config%do_clouds) then
      call out_file%define_variable("cloud_cover_lw", &
           &  dim1_name="column", units_str="1", &
           &  long_name="Total cloud cover diagnosed by longwave solver", &
           &  standard_name="cloud_area_fraction")
    end if
    if (config%do_sw .and. config%do_clouds) then
      call out_file%define_variable("cloud_cover_sw", &
           &  dim1_name="column", units_str="1", &
           &  long_name="Total cloud cover diagnosed by shortwave solver", &
           &  standard_name="cloud_area_fraction")
    end if

    ! Write variables

    call out_file%put("pressure_hl", thermodynamics%pressure_hl)

    if (config%do_lw) then
      call out_file%put("flux_up_lw", flux%lw_up)
      call out_file%put("flux_dn_lw", flux%lw_dn)
      if (config%do_clear) then
        call out_file%put("flux_up_lw_clear", flux%lw_up_clear)
        call out_file%put("flux_dn_lw_clear", flux%lw_dn_clear)
      end if

      if (config%do_lw_derivatives) then
        call out_file%put("lw_derivative", flux%lw_derivatives)
      end if

      if (config%do_save_spectral_flux) then
        call out_file%put("spectral_flux_up_lw", flux%lw_up_band)
        call out_file%put("spectral_flux_dn_lw", flux%lw_dn_band)
        if (config%do_clear) then
          call out_file%put("spectral_flux_up_lw_clear", flux%lw_up_clear_band)
          call out_file%put("spectral_flux_dn_lw_clear", flux%lw_dn_clear_band)
        end if
      end if

      if (config%do_canopy_fluxes_lw) then
        call out_file%put("canopy_flux_dn_lw_surf", flux%lw_dn_surf_canopy, &
             &            do_transp = .false.)
      end if

    end if

    if (config%do_sw) then
      call out_file%put("flux_up_sw", flux%sw_up)
      call out_file%put("flux_dn_sw", flux%sw_dn)
      if (config%do_sw_direct) then
        call out_file%put("flux_dn_direct_sw", flux%sw_dn_direct)
      end if
      if (config%do_clear) then
        call out_file%put("flux_up_sw_clear", flux%sw_up_clear)
        call out_file%put("flux_dn_sw_clear", flux%sw_dn_clear)
        if (config%do_sw_direct) then
          call out_file%put("flux_dn_direct_sw_clear", flux%sw_dn_direct_clear)
        end if
      end if

      if (config%do_save_spectral_flux) then
        call out_file%put("spectral_flux_up_sw", flux%sw_up_band)
        call out_file%put("spectral_flux_dn_sw", flux%sw_dn_band)
        if (config%do_sw_direct) then
          call out_file%put("spectral_flux_dn_direct_sw", &
               &   flux%sw_dn_direct_band)
        end if
        if (config%do_clear) then
          call out_file%put("spectral_flux_up_sw_clear", flux%sw_up_clear_band)
          call out_file%put("spectral_flux_dn_sw_clear", flux%sw_dn_clear_band)
          if (config%do_sw_direct) then
            call out_file%put("spectral_flux_dn_direct_sw_clear", &
                 &   flux%sw_dn_direct_clear_band)
          end if
        end if
      else if (config%do_surface_sw_spectral_flux) then
        call out_file%put("spectral_flux_dn_sw_surf", flux%sw_dn_surf_band, &
               &   do_transp=.false.)
        call out_file%put("spectral_flux_dn_direct_sw_surf", flux%sw_dn_direct_surf_band, &
               &   do_transp=.false.)
        if (config%do_clear) then
          call out_file%put("spectral_flux_dn_sw_surf_clear", flux%sw_dn_surf_clear_band, &
               &   do_transp=.false.)
          call out_file%put("spectral_flux_dn_direct_sw_surf_clear", &
               &            flux%sw_dn_direct_surf_clear_band, do_transp=.false.)
        end if
      end if

      if (config%do_canopy_fluxes_sw) then
        call out_file%put("canopy_flux_dn_diffuse_sw_surf", flux%sw_dn_diffuse_surf_canopy, &
             &            do_transp = .false.)
        call out_file%put("canopy_flux_dn_direct_sw_surf",  flux%sw_dn_direct_surf_canopy, &
             &            do_transp = .false.)
      end if

    end if

    if (config%do_lw .and. config%do_clouds) then
      call out_file%put("cloud_cover_lw", flux%cloud_cover_lw)
    end if
    if (config%do_sw .and. config%do_clouds) then
      call out_file%put("cloud_cover_sw", flux%cloud_cover_sw)
    end if

    ! Close file
    call out_file%close()

    if (lhook) call dr_hook('radiation_save:save_fluxes',1,hook_handle)

  end subroutine save_fluxes
  

  !---------------------------------------------------------------------
  ! Save intermediate radiative properties, specifically the
  ! scattering and absorption properties at each g-point/band
  subroutine save_radiative_properties(file_name, nlev, &
       &  istartcol, iendcol, &
       &  config, single_level, thermodynamics, cloud, &
       &  planck_hl, lw_emission, lw_albedo, &
       &  sw_albedo_direct, sw_albedo_diffuse, &
       &  incoming_sw, &
       &  od_lw, ssa_lw, g_lw, &
       &  od_sw, ssa_sw, g_sw, &
       &  od_lw_cloud, ssa_lw_cloud, g_lw_cloud, &
       &  od_sw_cloud, ssa_sw_cloud, g_sw_cloud)

    use radiation_config,        only : config_type
    use radiation_single_level,  only : single_level_type
    use radiation_thermodynamics,only : thermodynamics_type
    use radiation_cloud,         only : cloud_type
    use easy_netcdf

    character(len=*),         intent(in) :: file_name
    type(config_type),        intent(in) :: config
    type(single_level_type),  intent(in) :: single_level
    type(thermodynamics_type),intent(in) :: thermodynamics
    type(cloud_type),         intent(in) :: cloud

    integer, intent(in) :: nlev, istartcol, iendcol

    ! Input variables, as defined in radiation_interface.F90

    ! Layer optical depth, single scattering albedo and asymmetry factor of
    ! gases and aerosols at each shortwave g-point
    real(jprb), intent(in), dimension(config%n_g_sw,nlev,istartcol:iendcol) :: od_sw, ssa_sw, g_sw

   ! Layer optical depth, single scattering albedo and asymmetry factor of
    ! hydrometeors in each shortwave band
    real(jprb), intent(in), dimension(config%n_bands_sw,nlev,istartcol:iendcol)   :: &
         &  od_sw_cloud, ssa_sw_cloud, g_sw_cloud

    ! Direct and diffuse surface albedo, and the incoming shortwave
    ! flux into a plane perpendicular to the incoming radiation at
    ! top-of-atmosphere in each of the shortwave g-points
    real(jprb), intent(in), dimension(config%n_g_sw,istartcol:iendcol) &
         &  :: sw_albedo_direct, sw_albedo_diffuse, incoming_sw

    ! Layer optical depth, single scattering albedo and asymmetry factor of
    ! gases and aerosols at each longwave g-point, where the latter
    ! two variables are only defined if aerosol longwave scattering is
    ! enabled (otherwise both are treated as zero).
    real(jprb), intent(in), dimension(config%n_g_lw,nlev,istartcol:iendcol) :: od_lw
    real(jprb), intent(in), dimension(config%n_g_lw_if_scattering,nlev,istartcol:iendcol) :: &
         &  ssa_lw, g_lw

    ! Layer optical depth, single scattering albedo and asymmetry factor of
    ! hydrometeors in each longwave band, where the latter two
    ! variables are only defined if hydrometeor longwave scattering is
    ! enabled (otherwise both are treated as zero).
    real(jprb), intent(in), dimension(config%n_bands_lw,nlev,istartcol:iendcol) :: od_lw_cloud
    real(jprb), intent(in), dimension(config%n_bands_lw_if_scattering,nlev,istartcol:iendcol) :: &
         &  ssa_lw_cloud, g_lw_cloud

    ! The Planck function (emitted flux from a black body) at half
    ! levels and at the surface at each longwave g-point
    real(jprb), intent(in), dimension(config%n_g_lw,nlev+1,istartcol:iendcol) :: planck_hl

    ! Emission (Planck*emissivity) and albedo (1-emissivity) at the
    ! surface at each longwave g-point
    real(jprb), dimension(config%n_g_lw, istartcol:iendcol) :: lw_emission, lw_albedo

    integer :: n_col_local ! Number of columns from istartcol to iendcol

    ! Object for output NetCDF file
    type(netcdf_file) :: out_file

    n_col_local = iendcol + 1 - istartcol

    ! Alas the NetCDF library is not thread-safe for writing, so we
    ! must write radiative-property files serially

    !$OMP CRITICAL

    ! Open the file
    call out_file%create(trim(file_name), iverbose=config%iverbose)

    ! Configure matrix and 3D-array orientation
    call out_file%transpose_matrices(.true.)

    ! Sometimes the Planck function values are very large or small
    ! even if the fluxes are within a manageable range
    call out_file%double_precision(.true.)

    ! Define dimensions
    !    call out_file%define_dimension("column", n_col_local)
    call out_file%define_dimension("column", 0) ! "Unlimited" dimension
    call out_file%define_dimension("level", nlev)
    call out_file%define_dimension("half_level", nlev+1)
    if (config%do_clouds) then
      call out_file%define_dimension("level_interface", nlev-1)
    end if

    if (config%do_lw) then
      call out_file%define_dimension("gpoint_lw", config%n_g_lw) 
      if (config%do_clouds) then
        call out_file%define_dimension("band_lw", config%n_bands_lw)
      end if
    end if
    if (config%do_sw) then
      call out_file%define_dimension("gpoint_sw", config%n_g_sw) 
      if (config%do_clouds) then
        call out_file%define_dimension("band_sw", config%n_bands_sw)
      end if
    end if

    ! Put global attributes
    call out_file%put_global_attributes( &
         &   title_str="Spectral radiative properties from the ecRad offline radiation model", &
         &   references_str="Hogan, R. J., and A. Bozzo, 2018: A flexible and efficient radiation " &
         &   //"scheme for the ECMWF model. J. Adv. Modeling Earth Sys., 10, 1990–2008", &
         &   source_str="ecRad offline radiation model")

    ! Define variables
    call out_file%define_variable("pressure_hl", &
         &  dim2_name="column", dim1_name="half_level", &
         &  units_str="Pa", long_name="Pressure on half-levels")

    if (allocated(thermodynamics%h2o_sat_liq) .and. config%use_aerosols) then
      call out_file%define_variable("q_sat_liquid", &
           &  dim2_name="column", dim1_name="level", &
           &  units_str="kg kg-1", long_name="Specific humidity at liquid saturation")
    end if

    if (config%do_sw) then
      call out_file%define_variable("cos_solar_zenith_angle", &
           &  dim1_name="column", units_str="1", &
           &  long_name="Cosine of the solar zenith angle")
    end if

    if (config%do_clouds) then
      call out_file%define_variable("cloud_fraction", &
           &  dim2_name="column", dim1_name="level", &
           &  units_str="1", long_name="Cloud fraction")
      call out_file%define_variable("overlap_param", &
           &  dim2_name="column", dim1_name="level_interface", &
           &  units_str="1", long_name="Cloud overlap parameter")
    end if

    if (config%do_lw) then
      call out_file%define_variable("planck_hl", &
           &  dim3_name="column", dim2_name="half_level", dim1_name="gpoint_lw", &
           &  units_str="W m-2", long_name="Planck function on half-levels")
      call out_file%define_variable("lw_emission", &
           &  dim2_name="column", dim1_name="gpoint_lw", &
           &  units_str="W m-2", long_name="Longwave surface emission")
      call out_file%define_variable("lw_emissivity", &
           &  dim2_name="column", dim1_name="gpoint_lw", &
           &  units_str="1", long_name="Surface longwave emissivity")

      call out_file%define_variable("od_lw", &
           &  dim3_name="column", dim2_name="level", dim1_name="gpoint_lw", &
           &  units_str="1", long_name="Clear-sky longwave optical depth")
      if (config%do_lw_aerosol_scattering) then
        call out_file%define_variable("ssa_lw", &
           &  dim3_name="column", dim2_name="level", dim1_name="gpoint_lw", &
           &  units_str="1", long_name="Clear-sky longwave single scattering albedo")
        call out_file%define_variable("asymmetry_lw", &
           &  dim3_name="column", dim2_name="level", dim1_name="gpoint_lw", &
           &  units_str="1", long_name="Clear-sky longwave asymmetry factor")
      end if

      if (config%do_clouds) then
        call out_file%define_variable("od_lw_cloud", &
             &  dim3_name="column", dim2_name="level", dim1_name="band_lw", &
             &  units_str="1", long_name="In-cloud longwave optical depth")
        if (config%do_lw_cloud_scattering) then
          call out_file%define_variable("ssa_lw_cloud", &
               &  dim3_name="column", dim2_name="level", dim1_name="band_lw", &
               &  units_str="1", long_name="Cloud longwave single scattering albedo")
          call out_file%define_variable("asymmetry_lw_cloud", &
               &  dim3_name="column", dim2_name="level", dim1_name="band_lw", &
               &  units_str="1", long_name="Cloud longwave asymmetry factor")
        end if
      end if ! do_clouds
    end if ! do_lw
    
    if (config%do_sw) then
      call out_file%define_variable("incoming_sw", &
           &  dim2_name="column", dim1_name="gpoint_sw", &
           &  units_str="W m-2", long_name="Incoming shortwave flux at top-of-atmosphere in direction of sun")

      call out_file%define_variable("sw_albedo", &
           &  dim2_name="column", dim1_name="gpoint_sw", &
           &  units_str="1", long_name="Surface shortwave albedo to diffuse radiation")
      call out_file%define_variable("sw_albedo_direct", &
           &  dim2_name="column", dim1_name="gpoint_sw", &
           &  units_str="1", long_name="Surface shortwave albedo to direct radiation")

      call out_file%define_variable("od_sw", &
           &  dim3_name="column", dim2_name="level", dim1_name="gpoint_sw", &
           &  units_str="1", long_name="Clear-sky shortwave optical depth")
      call out_file%define_variable("ssa_sw", &
           &  dim3_name="column", dim2_name="level", dim1_name="gpoint_sw", &
           &  units_str="1", long_name="Clear-sky shortwave single scattering albedo")
      call out_file%define_variable("asymmetry_sw", &
           &  dim3_name="column", dim2_name="level", dim1_name="gpoint_sw", &
           &  units_str="1", long_name="Clear-sky shortwave asymmetry factor")

      if (config%do_clouds) then
        call out_file%define_variable("od_sw_cloud", &
             &  dim3_name="column", dim2_name="level", dim1_name="band_sw", &
             &  units_str="1", long_name="In-cloud shortwave optical depth")
        call out_file%define_variable("ssa_sw_cloud", &
             &  dim3_name="column", dim2_name="level", dim1_name="band_sw", &
             &  units_str="1", long_name="Cloud shortwave single scattering albedo")
        call out_file%define_variable("asymmetry_sw_cloud", &
             &  dim3_name="column", dim2_name="level", dim1_name="band_sw", &
             &  units_str="1", long_name="Cloud shortwave asymmetry factor")
      end if
    end if
   
    if (config%do_clouds) then
      if (allocated(cloud%fractional_std)) then
        call out_file%define_variable("fractional_std", &
             &  dim2_name="column", dim1_name="level", units_str="1", &
             &  long_name="Fractional standard deviation of cloud optical depth")
      end if
      if (allocated(cloud%inv_cloud_effective_size)) then
        call out_file%define_variable("inv_cloud_effective_size", &
             &  dim2_name="column", dim1_name="level", units_str="m-1", &
             &  long_name="Inverse of cloud effective horizontal size")
      end if
      if (allocated(cloud%inv_inhom_effective_size)) then
        call out_file%define_variable("inv_inhom_effective_size", &
             &  dim2_name="column", dim1_name="level", units_str="m-1", &
             &  long_name="Inverse of cloud inhomogeneity effective horizontal size")
      end if
   end if

    ! Write variables
    call out_file%put("pressure_hl", thermodynamics%pressure_hl(istartcol:iendcol,:))

    if (allocated(thermodynamics%h2o_sat_liq) .and. config%use_aerosols) then
      call out_file%put("q_sat_liquid", thermodynamics%h2o_sat_liq(istartcol:iendcol,:))
    end if

    if (config%do_clouds) then
      call out_file%put("cloud_fraction", cloud%fraction(istartcol:iendcol,:))
      call out_file%put("overlap_param", cloud%overlap_param(istartcol:iendcol,:))
    end if

    if (config%do_sw) then
      call out_file%put("cos_solar_zenith_angle", single_level%cos_sza(istartcol:iendcol))
      call out_file%put("sw_albedo", sw_albedo_diffuse, do_transp=.false.)
      call out_file%put("sw_albedo_direct", sw_albedo_direct, do_transp=.false.)
    end if

    if (config%do_lw) then
      call out_file%put("lw_emissivity", 1.0_jprb - lw_albedo, do_transp=.false.)
      call out_file%put("planck_hl", planck_hl)
      call out_file%put("lw_emission", lw_emission, do_transp=.false.)
      
      call out_file%put("od_lw", od_lw)
      if (config%do_lw_aerosol_scattering) then
        call out_file%put("ssa_lw", ssa_lw)
        call out_file%put("asymmetry_lw", g_lw)
      end if
      
      if (config%do_clouds) then
        call out_file%put("od_lw_cloud", od_lw_cloud)
        if (config%do_lw_cloud_scattering) then
          call out_file%put("ssa_lw_cloud", ssa_lw_cloud)
          call out_file%put("asymmetry_lw_cloud", g_lw_cloud)
        end if
      end if
    end if
    
    if (config%do_sw) then
      call out_file%put("incoming_sw", incoming_sw, do_transp=.false.)
      
      call out_file%put("od_sw", od_sw)
      call out_file%put("ssa_sw", ssa_sw)
      call out_file%put("asymmetry_sw", g_sw)
      
      if (config%do_clouds) then
        call out_file%put("od_sw_cloud", od_sw_cloud)
        call out_file%put("ssa_sw_cloud", ssa_sw_cloud)
        call out_file%put("asymmetry_sw_cloud", g_sw_cloud)
      end if
    end if
    
    if (config%do_clouds) then
      if (allocated(cloud%fractional_std)) then
        call out_file%put("fractional_std", cloud%fractional_std(istartcol:iendcol,:))
      end if
      if (allocated(cloud%inv_cloud_effective_size)) then
        call out_file%put("inv_cloud_effective_size", cloud%inv_cloud_effective_size(istartcol:iendcol,:))
      end if
      if (allocated(cloud%inv_inhom_effective_size)) then
        call out_file%put("inv_inhom_effective_size", cloud%inv_inhom_effective_size(istartcol:iendcol,:))
      end if
    end if

    ! Close the file
    call out_file%close()

    !$OMP END CRITICAL
    
  end subroutine save_radiative_properties
  

  !---------------------------------------------------------------------
  ! Save inputs to the radiation scheme
  subroutine save_inputs(file_name, config, single_level, thermodynamics, &
       &                 gas, cloud, aerosol, lat, lon, iverbose)
    use yomhook,                  only : lhook, dr_hook

    use radiation_config,         only : config_type
    use radiation_single_level,   only : single_level_type
    use radiation_thermodynamics, only : thermodynamics_type
    use radiation_gas
    use radiation_cloud,          only : cloud_type
    use radiation_aerosol,        only : aerosol_type
    use easy_netcdf

    character(len=*),             intent(in)   :: file_name
    type(config_type),            intent(in)   :: config
    type(single_level_type),      intent(in)   :: single_level
    type(thermodynamics_type),    intent(in)   :: thermodynamics
    type(gas_type),               intent(inout):: gas
    type(cloud_type),             intent(in)   :: cloud
    type(aerosol_type), optional, intent(in)   :: aerosol
    real(jprb),         optional, intent(in)   :: lat(:), lon(:)
    integer,            optional, intent(in)   :: iverbose

    real(jprb), allocatable :: mixing_ratio(:,:)
    real(jprb), allocatable :: aerosol_mmr(:,:,:)
    real(jprb), allocatable :: seed(:)
    integer       :: i_local_verbose
    integer       :: ncol, nlev
    integer       :: jgas
    character(32) :: var_name, long_name

    ! Object for output NetCDF file
    type(netcdf_file) :: out_file

    logical :: do_aerosol

    real(jprb) :: hook_handle

    if (lhook) call dr_hook('radiation_save:save_inputs',0,hook_handle)

    if (present(iverbose)) then
      i_local_verbose = iverbose
    else
      i_local_verbose = config%iverbose
    end if

    ! Work out array dimensions
    ncol = size(thermodynamics%pressure_hl,1)
    nlev = size(thermodynamics%pressure_hl,2)
    nlev = nlev - 1
    
    do_aerosol = config%use_aerosols .and. present(aerosol)

    ! Open the file
    call out_file%create(trim(file_name), iverbose=i_local_verbose)

    ! Variables stored internally with column varying fastest, but in
    ! output file column varies most slowly so need to transpose
    call out_file%transpose_matrices(.true.)

    ! In the case of aerosols we convert dimensions (ncol,nlev,ntype)
    ! in memory to (nlev,ntype,ncol) in file (in both cases the first
    ! dimension varying fastest).
    call out_file%permute_3d_arrays( (/ 2, 3, 1 /) ) ! For aerosols

    ! Define dimensions
    call out_file%define_dimension("column",     ncol)
    call out_file%define_dimension("level",      nlev)
    call out_file%define_dimension("half_level", nlev+1)
    if (allocated(cloud%overlap_param)) then
      call out_file%define_dimension("level_interface", nlev-1)
    end if
    call out_file%define_dimension("sw_albedo_band", &
         &                         size(single_level%sw_albedo,2))
    call out_file%define_dimension("lw_emissivity_band", &
         &                         size(single_level%lw_emissivity,2))

    if (do_aerosol) then
      call out_file%define_dimension("aerosol_type", size(aerosol%mixing_ratio,3))
    end if

    ! Put global attributes
    call out_file%put_global_attributes( &
         &   title_str="Input profiles to the ecRad offline radiation model", &
         &   references_str="Hogan, R. J., and A. Bozzo, 2018: A flexible and efficient radiation " &
         &   //"scheme for the ECMWF model. J. Adv. Modeling Earth Sys., 10, 1990–2008", &
         &   source_str="ecRad offline radiation model")

    ! Define single-level variables
    call out_file%define_variable("solar_irradiance", &
         &   units_str="W m-2", long_name="Solar irradiance at Earth's orbit")
    if (present(lat)) then
      call out_file%define_variable("lat", &
           &   dim1_name="column", units_str="degrees_north", long_name="Latitude")
    end if
    if (present(lon)) then
      call out_file%define_variable("lon", &
           &   dim1_name="column", units_str="degrees_east", long_name="Longitude")
    end if
    call out_file%define_variable("skin_temperature", &
         &   dim1_name="column", units_str="K", long_name="Skin_temperature")
    if (config%do_sw) then
      call out_file%define_variable("cos_solar_zenith_angle", &
           &   dim1_name="column", units_str="1", &
           &   long_name="Cosine of the solar zenith angle")
    end if

    if (allocated(single_level%sw_albedo_direct)) then
      call out_file%define_variable("sw_albedo", &
           &   dim2_name="column", dim1_name="sw_albedo_band", &
           &   units_str="1", long_name="Shortwave surface albedo to diffuse radiation")
            call out_file%define_variable("sw_albedo_direct", &
           &   dim2_name="column", dim1_name="sw_albedo_band", &
           &   units_str="1", long_name="Shortwave surface albedo to direct radiation")
    else
      call out_file%define_variable("sw_albedo", &
           &   dim2_name="column", dim1_name="sw_albedo_band", &
           &   units_str="1", long_name="Shortwave surface albedo")
      
    end if
    call out_file%define_variable("lw_emissivity", &
         &   dim2_name="column", dim1_name="lw_emissivity_band", &
         &   units_str="1", long_name="Longwave surface emissivity")

    if (allocated(single_level%iseed)) then
      call out_file%define_variable("iseed", &
           &   dim1_name="column", units_str="1", is_double=.true., &
           &   long_name="Seed for random-number generator")
    end if

    ! Define thermodynamic variables on half levels
    call out_file%define_variable("pressure_hl", &
         &   dim2_name="column", dim1_name="half_level", &
         &   units_str="Pa", long_name="Pressure")
    call out_file%define_variable("temperature_hl", &
         &   dim2_name="column", dim1_name="half_level", &
         &   units_str="K", long_name="Temperature")

    ! Define gas mixing ratios on full levels
    call out_file%define_variable("q", &
         &   dim2_name="column", dim1_name="level", &
         &   units_str="1", long_name="Specific humidity")
    call out_file%define_variable("o3_mmr", &
         &   dim2_name="column", dim1_name="level", &
         &   units_str="1", long_name="Ozone mass mixing ratio")
    do jgas = 1,NMaxGases
      if (gas%is_present(jgas) .and. jgas /= IH2O .and. jgas /= IO3) then
        write(var_name,'(a,a)') trim(GasLowerCaseName(jgas)), '_vmr'
        write(long_name,'(a,a)') trim(GasName(jgas)), ' volume mixing ratio'
        call out_file%define_variable(trim(var_name), &
             &   dim2_name="column", dim1_name="level", &
             &   units_str="1", long_name=trim(long_name))
      end if
    end do

    if (config%do_clouds) then
      ! Define cloud variables on full levels
      call out_file%define_variable("cloud_fraction", &
           &   dim2_name="column", dim1_name="level", &
           &   units_str="1", long_name="Cloud fraction")
      call out_file%define_variable("q_liquid", &
           &   dim2_name="column", dim1_name="level", &
           &   units_str="1", long_name="Gridbox-mean liquid water mixing ratio")
      call out_file%define_variable("q_ice", &
           &   dim2_name="column", dim1_name="level", &
           &   units_str="1", long_name="Gridbox-mean ice water mixing ratio")
      call out_file%define_variable("re_liquid", &
           &   dim2_name="column", dim1_name="level", &
           &   units_str="m", long_name="Ice effective radius")
      if (associated(cloud%re_ice)) then
        call out_file%define_variable("re_ice", &
             &   dim2_name="column", dim1_name="level", &
             &   units_str="m", long_name="Ice effective radius")
      end if
      if (allocated(cloud%overlap_param)) then
        call out_file%define_variable("overlap_param", &
             &  dim2_name="column", dim1_name="level_interface", &
             &  units_str="1", long_name="Cloud overlap parameter")
      end if
      if (allocated(cloud%fractional_std)) then
        call out_file%define_variable("fractional_std", &
             &  dim2_name="column", dim1_name="level", units_str="1", &
             &  long_name="Fractional standard deviation of cloud optical depth")
      end if
      if (allocated(cloud%inv_cloud_effective_size)) then
        call out_file%define_variable("inv_cloud_effective_size", &
             &   dim2_name="column", dim1_name="level", units_str="m-1", &
             &   long_name="Inverse of cloud effective horizontal size")
      end if
      if (allocated(cloud%inv_inhom_effective_size)) then
        call out_file%define_variable("inv_inhom_effective_size", &
             &  dim2_name="column", dim1_name="level", units_str="m-1", &
             &  long_name="Inverse of cloud inhomogeneity effective horizontal size")
      end if
    end if ! do_clouds

    ! Define aerosol mass mixing ratio
    if (do_aerosol) then
      call out_file%define_variable("aerosol_mmr", &
           &   dim3_name="column", dim2_name="aerosol_type", &
           &   dim1_name="level", units_str="kg kg-1", &
           &   long_name="Aerosol mass mixing ratio")
    end if

    ! Write variables
    call out_file%put("solar_irradiance", single_level%solar_irradiance)
    if (present(lat)) then
      call out_file%put("lat", lat)
    end if
    if (present(lon)) then
      call out_file%put("lon", lon)
    end if
    call out_file%put("skin_temperature", single_level%skin_temperature)
    if (config%do_sw) then
      call out_file%put("cos_solar_zenith_angle", single_level%cos_sza)
    end if
    call out_file%put("sw_albedo", single_level%sw_albedo)
    if (allocated(single_level%sw_albedo_direct)) then
      call out_file%put("sw_albedo_direct", single_level%sw_albedo_direct)
    end if
    call out_file%put("lw_emissivity", single_level%lw_emissivity)
    if (config%do_clouds .and. allocated(single_level%iseed)) then
      allocate(seed(ncol))
      seed = single_level%iseed
      call out_file%put("iseed", seed)
      deallocate(seed)
    end if

    call out_file%put("pressure_hl", thermodynamics%pressure_hl)
    call out_file%put("temperature_hl", thermodynamics%temperature_hl)

    allocate(mixing_ratio(ncol,nlev))
    call gas%get(IH2O, IMassMixingRatio, mixing_ratio)
    call out_file%put("q", mixing_ratio)
    call gas%get(IO3, IMassMixingRatio, mixing_ratio)
    call out_file%put("o3_mmr", mixing_ratio)
    do jgas = 1,NMaxGases
      if (gas%is_present(jgas) .and. jgas /= IH2O .and. jgas /= IO3) then
        write(var_name,'(a,a)') trim(GasLowerCaseName(jgas)), '_vmr'
        call gas%get(jgas, IVolumeMixingRatio, mixing_ratio)
        call out_file%put(trim(var_name), mixing_ratio)
      end if
    end do
    deallocate(mixing_ratio)

    if (config%do_clouds) then
      call out_file%put("cloud_fraction", cloud%fraction)
      call out_file%put("q_liquid", cloud%q_liq)
      call out_file%put("q_ice", cloud%q_ice)
      call out_file%put("re_liquid", cloud%re_liq)
      if (associated(cloud%re_ice)) then
        call out_file%put("re_ice", cloud%re_ice)
      end if
      if (allocated(cloud%overlap_param)) then
        call out_file%put("overlap_param", cloud%overlap_param)
      end if
      if (allocated(cloud%fractional_std)) then
        call out_file%put("fractional_std", cloud%fractional_std)
      end if
      if (allocated(cloud%inv_cloud_effective_size)) then
        call out_file%put("inv_cloud_effective_size", cloud%inv_cloud_effective_size)
      end if
      if (allocated(cloud%inv_inhom_effective_size)) then
        call out_file%put("inv_inhom_effective_size", cloud%inv_inhom_effective_size)
      end if
    end if

    if (do_aerosol) then
      allocate(aerosol_mmr(ncol, nlev, size(aerosol%mixing_ratio,3)))
      aerosol_mmr = 0.0_jprb
      aerosol_mmr(:,aerosol%istartlev:aerosol%iendlev,:) = aerosol%mixing_ratio
      call out_file%put("aerosol_mmr", aerosol_mmr)
      deallocate(aerosol_mmr)
    end if

    ! Close the file
    call out_file%close()

    if (lhook) call dr_hook('radiation_save:save_inputs',1,hook_handle)
    
  end subroutine save_inputs

end module radiation_save

! $Id: lmdz_lscp_old.f90 6210 2026-05-07 08:59:55Z evignon $
!
!
!$gpum horizontal klon ngrid
MODULE lmdz_lscp_old
   PRIVATE

   INTEGER, PARAMETER :: ninter = 5 ! sous-intervals pour la precipitation
   LOGICAL, PARAMETER :: cpartiel = .TRUE. ! condensation partielle
   REAL, PARAMETER :: t_coup = 234.0
   REAL, PARAMETER :: DDT0 = .01
   REAL, PARAMETER :: ztfondue = 278.15

   LOGICAL, SAVE :: appel1er = .TRUE.
   !$OMP THREADPRIVATE(appel1er)

   PUBLIC fisrtilp

CONTAINS

   SUBROUTINE fisrtilp(klon, klev, dtime, paprs, pplay, t, q, ptconv, ratqs, sigma_qtherm, &
                       d_t, d_q, d_ql, d_qi, rneb, rneblsvol, radliq, rain, snow, &
                       pfrac_impa, pfrac_nucl, pfrac_1nucl, &
                       frac_impa, frac_nucl, beta, &
                       prfl, psfl, rhcl, zqta, fraca, &
                       ztv, zpspsk, ztla, zthl, &
                       cloudth_sth, cloudth_senv, cloudth_sigmath, cloudth_sigmaenv)

      USE yomcst_mod_h
      USE icefrac_lsc_mod ! compute ice fraction (JBM 3/14)
      USE lmdz_lscp_condensation, only: cloudth, cloudth_v3, cloudth_v6

      USE lmdz_lscp_ini, ONLY: prt_level, lunout
      USE lmdz_lscp_ini, ONLY: fl_cor_ebil
      USE lmdz_lscp_ini, ONLY: iflag_t_glace, t_glace_min, t_glace_max, exposant_glace
      USE lmdz_lscp_ini, ONLY: iflag_cld_th, iflag_ice_thermo
      USE lmdz_lscp_ini, ONLY: seuil_neb, rain_int_min, iflag_evap_prec, iflag_oldbug_fisrtilp, a_tr_sca
      USE lmdz_lscp_ini, ONLY: iflag_cloudth_vert, iflag_rain_incloud_vol
      USE lmdz_lscp_ini, ONLY: coef_eva, ffallv_lsc, ffallv_con
      USE lmdz_lscp_ini, ONLY: cld_tau_lsc, cld_tau_con, cld_lc_lsc, cld_lc_con
      USE lmdz_lscp_ini, ONLY: reevap_ice, iflag_bergeron, iflag_fisrtilp_qsat, iflag_pdf
      USE yoethf_mod_h

      IMPLICIT none
      !======================================================================
      ! Auteur(s): Z.X. Li (LMD/CNRS)
      ! Date: le 20 mars 1995
      ! Objet: condensation et precipitation stratiforme.
      !        schema de nuage
      ! Fusion de fisrt (physique sursaturation, P. LeVan K. Laval)
      !             et ilp (il pleut, L. Li)
      ! Principales parties:
      ! P0> Thermalisation des precipitations venant de la couche du dessus
      ! P1> Evaporation de la precipitation (qui vient du niveau k+1)
      ! P2> Formation du nuage (en k)
      ! P2.A.0> Calcul des grandeurs nuageuses une pdf en creneau
      ! P2.A.1> Avec les nouvelles PDFs, calcul des grandeurs nuageuses pour
      ! les valeurs de T et Q initiales
      ! P2.A.2> Prise en compte du couplage entre eau condensee et T.
      ! P2.A.3> Calcul des valeures finales associees a la formation des nuages
      ! P2.B> Nuage "tout ou rien"
      ! P2.C> Prise en compte de la Chaleur latente apres formation nuage
      ! P3> Formation de la precipitation (en k)
      !======================================================================
      ! JLD:
      ! * Routine probablement fausse (au moins incoherente) si thermcep = .false.
      ! * fl_cor_ebil doit etre > 0 ;
      !   fl_cor_ebil= 0 pour reproduire anciens bugs
      !======================================================================
      include "FCTTRE.h"
      !
      ! Principaux inputs:
      !
      REAL, INTENT(IN)                              :: dtime  ! intervalle du temps (s)
      INTEGER, INTENT(IN)                           :: klon, klev
      REAL, DIMENSION(klon, klev + 1), INTENT(IN)   :: paprs  ! pression a inter-couche
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: pplay  ! pression au milieu de couche
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: t      ! temperature (K)
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: q      ! humidite specifique (kg/kg)
      LOGICAL, DIMENSION(klon, klev), INTENT(IN)   :: ptconv ! points ou le schema de conv. prof. est actif
      !
      ! Inputs lies aux thermiques
      !
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: ztv
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: zqta, fraca
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: zpspsk, ztla
      REAL, DIMENSION(klon, klev), INTENT(INOUT)   :: zthl
      !
      !  Input/output
      REAL, DIMENSION(klon, klev), INTENT(INOUT):: ratqs, sigma_qtherm  ! determine la largeur de distribution de vapeur
      !
      ! Principaux outputs:
      !
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: d_t  ! incrementation de la temperature (K)
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: d_q  ! incrementation de la vapeur d'eau
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: d_ql ! incrementation de l'eau liquide
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: d_qi ! incrementation de l'eau glace
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: rneb, rneblsvol ! fraction nuageuse
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: beta ! taux de conversion de l'eau cond
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: radliq ! eau liquide utilisee dans rayonnements
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: rhcl ! humidite relative en ciel clair
      REAL, DIMENSION(klon), INTENT(OUT)  :: rain
      REAL, DIMENSION(klon), INTENT(OUT)  :: snow
      REAL, DIMENSION(klon, klev + 1), INTENT(OUT)  :: prfl
      REAL, DIMENSION(klon, klev + 1), INTENT(OUT)  :: psfl

      !AA
      ! Coeffients de fraction lessivee : pour OFF-LINE
      !
      REAL, DIMENSION(klon, klev), INTENT(INOUT)  :: pfrac_nucl
      REAL, DIMENSION(klon, klev), INTENT(INOUT)  :: pfrac_1nucl
      REAL, DIMENSION(klon, klev), INTENT(INOUT)  :: pfrac_impa
      !
      ! Fraction d'aerosols lessivee par impaction et par nucleation
      ! POur ON-LINE
      !
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: frac_impa
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: frac_nucl
      REAL, DIMENSION(klon, klev), INTENT(OUT) :: cloudth_sth, cloudth_senv
      REAL, DIMENSION(klon, klev), INTENT(OUT) :: cloudth_sigmath, cloudth_sigmaenv
      !AA
      ! --------------------------------------------------------------------------------
      !
      ! Options du programme:
      !

      REAL :: smallestreal

      ! --------------------------------------------------------------------------------
      !
      ! Variables locales:
      !
      INTEGER :: i, k, n, kk
      REAL :: qsl, qsi
      REAL :: zct, zcl
      INTEGER :: ncoreczq
      REAL, DIMENSION(klon, klev) :: ctot, ctot_vol
      REAL, DIMENSION(klon) :: zqs, zdqs, zdqsdT_raw, Tbef, qlbef, DT
      REAL :: zdelta, zcor, zcvm5
      REAL ::num, denom

      LOGICAL, DIMENSION(klon) :: lognormale, convergence
      LOGICAL :: ice_thermo
      INTEGER, DIMENSION(klon) :: n_i
      INTEGER :: iter
      REAL :: cste

      REAL, DIMENSION(klon) :: zpdf_sig, zpdf_k, zpdf_delta, Zpdf_a, zpdf_b, zpdf_e1, zpdf_e2, qcloud

      REAL :: zqev, zqevt, zqev0, zqevi, zqevti, zdelq
  REAL, DIMENSION(klon) :: zrfl(klon), zrfln(klon), zrflclr(klon), zrflcld(klon), d_zrfl_clr_cld(klon), d_zifl_clr_cld(klon), d_zrfl_cld_clr(klon), d_zifl_cld_clr(klon) 

      REAL, DIMENSION(klon) :: zifl, zifln, ziflclr, ziflcld, zoliq, zcond, zq, zqn, zoliqp, zoliqi, zt
! JBM (3/14) nexpo is replaced by exposant_glace
! REAL nexpo ! exponentiel pour glace/eau
! INTEGER, PARAMETER :: nexpo=6
      INTEGER :: exposant_glace_old
      REAL :: t_glace_min_old, ztot
      REAL, DIMENSION(klon) ::  zdz, zrho, zrhol, zfice, zneb, znebprecip
      REAL :: zchau, zfroi
  REAL, DIMENSION(klon) :: znebprecipclr, znebprecipcld, tot_zneb, tot_znebn, d_tot_zneb, d_znebprecip_clr_cld, d_znebprecip_cld_clr, dzfice
      REAL :: zmelt, zpluie, zice
      REAL :: zsolid
!!!!
!  Variables pour Bergeron
      REAL :: zcp, coef1, DeltaT, Deltaq, Deltaqprecl
      REAL, DIMENSION(klon) :: zqpreci, zqprecl
! Variable pour conservation enegie des precipitations
      REAL, DIMENSION(klon) :: zmqc
      !
      !
! iflag_oldbug_fisrtilp=0 enleve le BUG par JYG : tglace_min -> tglace_max
! iflag_oldbug_fisrtilp=1 ajoute le BUG
      !---------------------------------------------------------------
      !
      ! Fonctions en ligne:
      !
      REAL ::  fallvs, fallvc, zzz ! Vitesse de chute pour cristaux de glace
      ! (Heymsfield & Donner, 1990)
      fallvc(zzz) = 3.29/2.0*((zzz)**0.16)*ffallv_con
      fallvs(zzz) = 3.29/2.0*((zzz)**0.16)*ffallv_lsc
      !
      !---------------------------------------------------------------
      !AA Variables traceurs:
      !AA  Provisoire !!! Parametres alpha du lessivage
      !AA  A priori on a 4 scavenging # possibles
      !
      ! Variables intermediaires
      !
      REAL :: zalpha_tr, zfrac_lessi
      REAL, DIMENSION(klon) :: zprec_cond
      !AA
! RomP >>> 15 nov 2012
! RomP <<<
      REAL, DIMENSION(klon) :: zmair
      REAL :: zcpair, zcpeau
      !     Pour la conversion eau-neige
      REAL, DIMENSION(klon) :: zlh_solid
      REAL :: zm_solid
      REAL :: tmp_var1d(klon) ! temporary variable for call site

      !
      !ym
!CR: pour iflag_ice_thermo=2, on active que la convection
!  ice_thermo = iflag_ice_thermo .GE. 1

      znebprecip(:) = 0.

!<LTP
      smallestreal = 1.e-9
      znebprecipclr(:) = 0.
      znebprecipcld(:) = 0.
!>LTP

      ice_thermo = (iflag_ice_thermo .EQ. 1) .OR. (iflag_ice_thermo .GE. 3)
      zdelq = 0.0
      ctot_vol(1:klon, 1:klev) = 0.0
      rneblsvol(1:klon, 1:klev) = 0.0

      if (prt_level > 9) write (lunout, *) 'NUAGES4 A. JAM'

      beta(:, :) = 0.  !RomP initialisation => ym : could be probably removed but keept by security

      !
      !MAf Initialisation a 0 de zoliq
      !      DO i = 1, klon
      !         zoliq(i)=0.
      !      ENDDO
      ! Determiner les nuages froids par leur temperature
      !  nexpo regle la raideur de la transition eau liquide / eau glace.
      !
!CR: on est oblige de definir des valeurs fisrt car les valeurs de newmicro ne sont pas les memes par defaut
      IF (iflag_t_glace .EQ. 0) THEN
!   ztglace = RTT - 15.0
         t_glace_min_old = RTT - 15.0
         !AJ<
         IF (ice_thermo) THEN
!     nexpo = 2
            exposant_glace_old = 2
         ELSE
!     nexpo = 6
            exposant_glace_old = 6
         END IF

      END IF

!!  RLVTT = 2.501e6 ! pas de redefinition des constantes physiques (jyg)
!!  RLSTT = 2.834e6 ! pas de redefinition des constantes physiques (jyg)
!>AJ
      !cc      nexpo = 1
      !
      ! Initialiser les sorties:
      !
      !cdir collapse
      DO k = 1, klev + 1
         DO i = 1, klon
            prfl(i, k) = 0.0
            psfl(i, k) = 0.0
         END DO
      END DO

      !cdir collapse

      DO k = 1, klev
         DO i = 1, klon
            d_t(i, k) = 0.0
            d_q(i, k) = 0.0
            d_ql(i, k) = 0.0
            d_qi(i, k) = 0.0
            rneb(i, k) = 0.0
            radliq(i, k) = 0.0
            frac_nucl(i, k) = 1.
            frac_impa(i, k) = 1.
         END DO
      END DO
      DO i = 1, klon
         rain(i) = 0.0
         snow(i) = 0.0
         zoliq(i) = 0.
         !     ENDDO
         !
         ! Initialiser le flux de precipitation a zero
         !
         !     DO i = 1, klon
         zrfl(i) = 0.0
         zifl(i) = 0.0
!<LTP
         zrflclr(i) = 0.0
         ziflclr(i) = 0.0
         zrflcld(i) = 0.0
         ziflcld(i) = 0.0
         tot_zneb(i) = 0.0
         tot_znebn(i) = 0.0
         d_tot_zneb(i) = 0.0
!>LTP

         zneb(i) = seuil_neb
      END DO
      !
      !
      !AA Pour plus de securite

      zalpha_tr = 0.
      zfrac_lessi = 0.

      !AA==================================================================
      !
      ncoreczq = 0
      ! BOUCLE VERTICALE (DU HAUT VERS LE BAS)
      !
      DO k = klev, 1, -1
         !
         !AA===============================================================
         !
         ! Initialisation temperature et vapeur
         DO i = 1, klon
            zt(i) = t(i, k)
            zq(i) = q(i, k)
         END DO
         !
         ! ----------------------------------------------------------------
         ! P0> Thermalisation des precipitations venant de la couche du dessus
         ! ----------------------------------------------------------------
         ! Calculer la varition de temp. de l'air du a la chaleur sensible
         ! transporter par la pluie. On thermalise la pluie avec l'air de la couche.
         ! Cette quantite de pluie qui est thermalisee, et devra continue a l'etre lors
         ! des differentes transformations thermodynamiques. Cette masse d'eau doit
         ! donc etre ajoute a l'humidite de la couche lorsque l'on calcule la variation
         ! de l'enthalpie  de la couche avec la temperature
         ! Variables calculees ou modifiees:
         !   -  zt: temperature de la cocuhe
         !   - zmqc: masse de precip qui doit etre thermalisee
         !
         IF (k .LE. klev - 1) THEN
            DO i = 1, klon
               !IM
               zmair(i) = (paprs(i, k) - paprs(i, k + 1))/RG
               ! il n'y a pas encore d'eau liquide ni glace dans la maiille, donc zq suffit
               zcpair = RCPD*(1.0 + RVTMP2*zq(i))
               zcpeau = RCPD*RVTMP2
               if (fl_cor_ebil .GT. 0) then
                  ! zmqc: masse de precip qui doit etre thermalisee avec l'air de la couche atm
                  ! pour s'assurer que la precip arrivant au sol aura bien la temperature de la
                  ! derniere couche
                  zmqc(i) = (zrfl(i) + zifl(i))*dtime/zmair(i)
                  ! t(i,k+1)+d_t(i,k+1): nouvelle temp de la couche au dessus
                  zt(i) = ((t(i, k + 1) + d_t(i, k + 1))*zmqc(i)*zcpeau + zcpair*zt(i)) &
                          /(zcpair + zmqc(i)*zcpeau)
               else ! si on maintient les anciennes erreurs
                  zt(i) = ((t(i, k + 1) + d_t(i, k + 1))*zrfl(i)*dtime*zcpeau &
                           + zmair(i)*zcpair*zt(i)) &
                          /(zmair(i)*zcpair + zrfl(i)*dtime*zcpeau)
               end if
            END DO
         ELSE  ! IF(k.LE.klev-1)
            DO i = 1, klon
               zmair(i) = (paprs(i, k) - paprs(i, k + 1))/RG
               zmqc(i) = 0.
            END DO
         END IF ! end IF(k.LE.klev-1)
         !
         ! ----------------------------------------------------------------
         ! P1> Calcul de l'evaporation de la precipitation
         ! ----------------------------------------------------------------
         ! On evapore une partie des precipitations venant de la maille du dessus.
         ! On calcule l'evaporation et la sublimation des precipitations, jusqu'a
         ! ce que la fraction de cette couche qui est sous le nuage soit saturee.
         ! Variables calculees ou modifiees:
         !   - zrfl et zifl: flux de precip liquide et glace
         !   - zq, zt: humidite et temperature de la cocuhe
         !   - zmqc: masse de precip qui doit etre thermalisee
         !
         IF (iflag_evap_prec >= 1) THEN
            DO i = 1, klon
!          S'il y a des precipitations
               IF (zrfl(i) + zifl(i) .GT. 0.) THEN
                  ! Calcul du qsat
                  IF (thermcep) THEN
                     zdelta = MAX(0., SIGN(1., RTT - zt(i)))
                     zqs(i) = R2ES*FOEEW(zt(i), zdelta)/pplay(i, k)
                     zqs(i) = MIN(0.5, zqs(i))
                     zcor = 1./(1.-RETV*zqs(i))
                     zqs(i) = zqs(i)*zcor
                  ELSE
                     IF (zt(i) .LT. t_coup) THEN
                        zqs(i) = qsats(zt(i))/pplay(i, k)
                     ELSE
                        zqs(i) = qsatl(zt(i))/pplay(i, k)
                     END IF
                  END IF
               END IF ! (zrfl(i)+zifl(i).GT.0.)
            END DO
!AJ<

            IF (.NOT. ice_thermo) THEN
               DO i = 1, klon
!          S'il y a des precipitations
                  IF (zrfl(i) + zifl(i) .GT. 0.) THEN
                     ! Evap max pour ne pas saturer la fraction sous le nuage
                     ! Evap max jusqu'à atteindre la saturation dans la partie
                     ! de la maille qui est sous le nuage de la couche du dessus
                !!! On ne tient compte de cette fraction que sous une seule
                !!! couche sous le nuage
                     zqev = MAX(0.0, (zqs(i) - zq(i))*zneb(i))
                     ! Ajout de la prise en compte des precip a thermiser
                     ! avec petite reecriture
                     if (fl_cor_ebil .GT. 0) then ! nouveau
                        ! Calcul de l'evaporation du flux de precip herite
                        !   d'au-dessus
                        zqevt = coef_eva*(1.0 - zq(i)/zqs(i))*SQRT(zrfl(i)) &
                                *zmair(i)/pplay(i, k)*zt(i)*RD
                        zqevt = MAX(0.0, MIN(zqevt, zrfl(i)))*dtime/zmair(i)

                        ! Seuil pour ne pas saturer la fraction sous le nuage
                        zqev = MIN(zqev, zqevt)
                        ! Nouveau flux de precip
                        zrfln(i) = zrfl(i) - zqev*zmair(i)/dtime
                        ! Aucun flux liquide pour T < t_coup, on reevapore tout.
                        IF (zt(i) .LT. t_coup .and. reevap_ice) THEN
                           zrfln(i) = 0.
                           zqev = (zrfl(i) - zrfln(i))/zmair(i)*dtime
                        END IF
                        ! Nouvelle vapeur
                        zq(i) = zq(i) + zqev
                        zmqc(i) = zmqc(i) - zqev
                        ! Nouvelle temperature (chaleur latente)
                        zt(i) = zt(i) - zqev &
                                *RLVTT/RCPD/(1.0 + RVTMP2*(zq(i) + zmqc(i)))
!!JLD debut de partie a supprimer a terme
                     else ! if  (fl_cor_ebil .GT. 0)
                        ! Calcul de l'evaporation du flux de precip herite
                        !   d'au-dessus
                        zqevt = coef_eva*(1.0 - zq(i)/zqs(i))*SQRT(zrfl(i)) &
                                *(paprs(i, k) - paprs(i, k + 1))/pplay(i, k)*zt(i)*RD/RG
                        zqevt = MAX(0.0, MIN(zqevt, zrfl(i))) &
                                *RG*dtime/(paprs(i, k) - paprs(i, k + 1))
                        ! Seuil pour ne pas saturer la fraction sous le nuage
                        zqev = MIN(zqev, zqevt)
                        ! Nouveau flux de precip
                        zrfln(i) = zrfl(i) - zqev*(paprs(i, k) - paprs(i, k + 1)) &
                                   /RG/dtime
                        ! Aucun flux liquide pour T < t_coup
                        IF (zt(i) .LT. t_coup .and. reevap_ice) zrfln(i) = 0.
                        ! Nouvelle vapeur
                        zq(i) = zq(i) - (zrfln(i) - zrfl(i)) &
                                *(RG/(paprs(i, k) - paprs(i, k + 1)))*dtime
                        ! Nouvelle temperature (chaleur latente)
                        zt(i) = zt(i) + (zrfln(i) - zrfl(i)) &
                                *(RG/(paprs(i, k) - paprs(i, k + 1)))*dtime &
                                *RLVTT/RCPD/(1.0 + RVTMP2*zq(i))
                     end if ! if  (fl_cor_ebil .GT. 0)
!!JLD fin de partie a supprimer a terme
                     zrfl(i) = zrfln(i)
                     zifl(i) = 0.
                  END IF ! (zrfl(i)+zifl(i).GT.0.)
               END DO
!
            ELSE ! (.NOT. ice_thermo)
!      ================================
!      Avec thermodynamique de la glace
!      ================================
               DO i = 1, klon

!AJ<
!        S'il y a des precipitations
                  IF (zrfl(i) + zifl(i) .GT. 0.) THEN

                     !LTP<
                     !On ne tient compte que du flux de précipitation en ciel clair dans le calcul de l'évaporation.
                     IF (iflag_evap_prec == 4) THEN
                        zrfl(i) = zrflclr(i)
                        zifl(i) = ziflclr(i)
                     END IF

                     !>LTP

                     IF (iflag_evap_prec == 1) THEN
                        znebprecip(i) = zneb(i)
                     ELSE
                        znebprecip(i) = MAX(zneb(i), znebprecip(i))
                     END IF

                     IF (iflag_evap_prec == 4) THEN
                        ! Evap max pour ne pas saturer toute la maille
                        zqev0 = MAX(0.0, zqs(i) - zq(i))
                     ELSE
                        ! Evap max pour ne pas saturer la fraction sous le nuage
                        zqev0 = MAX(0.0, (zqs(i) - zq(i))*znebprecip(i))
                     END IF

                     !JAM
                     ! On differencie qsat pour l'eau et la glace
                     ! Si zdelta=1. --> glace
                     ! Si zdelta=0. --> eau liquide

                     ! Calcul du qsat par rapport a l'eau liquide
                     qsl = R2ES*FOEEW(zt(i), 0.)/pplay(i, k)
                     qsl = MIN(0.5, qsl)
                     zcor = 1./(1.-RETV*qsl)
                     qsl = qsl*zcor

                     ! Calcul de l'evaporation du flux de precip venant du dessus
                     ! Formulation en racine du flux de precip
                     ! (Klemp & Wilhelmson, 1978; Sundqvist, 1988)
                     IF (iflag_evap_prec == 3) THEN
                        zqevt = znebprecip(i)*coef_eva*(1.0 - zq(i)/qsl) &
                                *SQRT(zrfl(i)/max(1.e-4, znebprecip(i))) &
                                *(paprs(i, k) - paprs(i, k + 1))/pplay(i, k)*zt(i)*RD/RG
!<LTP
                     ELSE IF (iflag_evap_prec == 4) THEN
                        zqevt = znebprecipclr(i)*coef_eva*(1.0 - zq(i)/qsl) &
                                *SQRT(zrfl(i)/max(1.e-8, znebprecipclr(i))) &
                                *(paprs(i, k) - paprs(i, k + 1))/pplay(i, k)*zt(i)*RD/RG
!>LTP
                     ELSE
                        zqevt = 1.*coef_eva*(1.0 - zq(i)/qsl)*SQRT(zrfl(i)) &
                                *(paprs(i, k) - paprs(i, k + 1))/pplay(i, k)*zt(i)*RD/RG
                     END IF

                     zqevt = MAX(0.0, MIN(zqevt, zrfl(i))) &
                             *RG*dtime/(paprs(i, k) - paprs(i, k + 1))

                     ! Calcul du qsat par rapport a la glace
                     qsi = R2ES*FOEEW(zt(i), 1.)/pplay(i, k)
                     qsi = MIN(0.5, qsi)
                     zcor = 1./(1.-RETV*qsi)
                     qsi = qsi*zcor

                     ! Calcul de la sublimation du flux de precip solide herite
                     !   d'au-dessus
                     IF (iflag_evap_prec == 3) THEN
                        zqevti = znebprecip(i)*coef_eva*(1.0 - zq(i)/qsi) &
                                 *SQRT(zifl(i)/max(1.e-4, znebprecip(i))) &
                                 *(paprs(i, k) - paprs(i, k + 1))/pplay(i, k)*zt(i)*RD/RG
!<LTP
                     ELSE IF (iflag_evap_prec == 4) THEN
                        zqevti = znebprecipclr(i)*coef_eva*(1.0 - zq(i)/qsi) &
                                 *SQRT(zifl(i)/max(1.e-8, znebprecipclr(i))) &
                                 *(paprs(i, k) - paprs(i, k + 1))/pplay(i, k)*zt(i)*RD/RG
!>LTP
                     ELSE
                        zqevti = 1.*coef_eva*(1.0 - zq(i)/qsi)*SQRT(zifl(i)) &
                                 *(paprs(i, k) - paprs(i, k + 1))/pplay(i, k)*zt(i)*RD/RG
                     END IF
                     zqevti = MAX(0.0, MIN(zqevti, zifl(i))) &
                              *RG*dtime/(paprs(i, k) - paprs(i, k + 1))

                     !JAM
                     ! Limitation de l'evaporation. On s'assure qu'on ne sature pas
                     ! la fraction de la couche sous le nuage sinon on repartit zqev0
                     ! en conservant la proportion liquide / glace

                     IF (zqevt + zqevti .GT. zqev0) THEN
                        zqev = zqev0*zqevt/(zqevt + zqevti)
                        zqevi = zqev0*zqevti/(zqevt + zqevti)
                     ELSE
!JLD je ne comprends pas les lignes ci-dessous. On repartit les precips
!       liquides et solides meme si on ne sature pas la couche.
!       A mon avis, le test est inutile, et il faudrait tout remplacer par:
!            zqev=zqevt
!            zqevi=zqevti
                        IF (zqevt + zqevti .GT. 0.) THEN
                           zqev = MIN(zqev0*zqevt/(zqevt + zqevti), zqevt)
                           zqevi = MIN(zqev0*zqevti/(zqevt + zqevti), zqevti)
                        ELSE
                           zqev = 0.
                           zqevi = 0.
                        END IF
                     END IF

                     ! Nouveaux flux de precip liquide et solide
                     zrfln(i) = Max(0., zrfl(i) - zqev*(paprs(i, k) - paprs(i, k + 1)) &
                                    /RG/dtime)
                     zifln(i) = Max(0., zifl(i) - zqevi*(paprs(i, k) - paprs(i, k + 1)) &
                                    /RG/dtime)

                     ! Mise a jour de la vapeur, temperature et flux de precip
                     zq(i) = zq(i) - (zrfln(i) + zifln(i) - zrfl(i) - zifl(i)) &
                             *(RG/(paprs(i, k) - paprs(i, k + 1)))*dtime
                     if (fl_cor_ebil .GT. 0) then ! avec correction thermalisation des precips
                        zmqc(i) = zmqc(i) + (zrfln(i) + zifln(i) - zrfl(i) - zifl(i)) &
                                  *(RG/(paprs(i, k) - paprs(i, k + 1)))*dtime
                        zt(i) = zt(i) + (zrfln(i) - zrfl(i)) &
                                *(RG/(paprs(i, k) - paprs(i, k + 1)))*dtime &
                                *RLVTT/RCPD/(1.0 + RVTMP2*(zq(i) + zmqc(i))) &
                                + (zifln(i) - zifl(i)) &
                                *(RG/(paprs(i, k) - paprs(i, k + 1)))*dtime &
                                *RLSTT/RCPD/(1.0 + RVTMP2*(zq(i) + zmqc(i)))
                     else ! sans correction thermalisation des precips
                        zt(i) = zt(i) + (zrfln(i) - zrfl(i)) &
                                *(RG/(paprs(i, k) - paprs(i, k + 1)))*dtime &
                                *RLVTT/RCPD/(1.0 + RVTMP2*zq(i)) &
                                + (zifln(i) - zifl(i)) &
                                *(RG/(paprs(i, k) - paprs(i, k + 1)))*dtime &
                                *RLSTT/RCPD/(1.0 + RVTMP2*zq(i))
                     end if
                     ! Nouvelles vaeleurs des precips liquides et solides
                     zrfl(i) = zrfln(i)
                     zifl(i) = zifln(i)

!<LTP
                     IF (iflag_evap_prec == 4) THEN
                        zrflclr(i) = zrfl(i)
                        ziflclr(i) = zifl(i)
                        IF (zrflclr(i) + ziflclr(i) .LE. 0) THEN
                           znebprecipclr(i) = 0.
                        END IF
                        zrfl(i) = zrflclr(i) + zrflcld(i)
                        zifl(i) = ziflclr(i) + ziflcld(i)
                     END IF
!>LTP

!CR ATTENTION: deplacement de la fonte de la glace
!jyg : Bug !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! jyg
!!!        zmelt = ((zt(i)-273.15)/(ztfondue-273.15))**2  !!!!!!!!! jyg
!jyg : Bug !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! jyg
                     zmelt = ((zt(i) - 273.15)/(ztfondue - 273.15))             ! jyg
                     ! fraction de la precip solide qui est fondue
                     zmelt = MIN(MAX(zmelt, 0.), 1.)
                     ! Fusion de la glace
!<LTP
                     IF (iflag_evap_prec == 4) THEN
                        zrflclr(i) = zrflclr(i) + zmelt*ziflclr(i)
                        zrflcld(i) = zrflcld(i) + zmelt*ziflcld(i)
                        zrfl(i) = zrflclr(i) + zrflcld(i)
!>LTP
                     ELSE
                        zrfl(i) = zrfl(i) + zmelt*zifl(i)
                     END IF
                     if (fl_cor_ebil .LE. 0) then
                        ! the following line should not be here. Indeed, if zifl is modified
                        ! now, zifl(i)*zmelt is no more the amount of ice that has melt
                        ! and therefore the change in temperature computed below is wrong
                        zifl(i) = zifl(i)*(1.-zmelt)
                     end if
                     ! Chaleur latente de fusion
                     if (fl_cor_ebil .GT. 0) then ! avec correction thermalisation des precips
                        zt(i) = zt(i) - zifl(i)*zmelt*(RG*dtime)/(paprs(i, k) - paprs(i, k + 1)) &
                                *RLMLT/RCPD/(1.0 + RVTMP2*(zq(i) + zmqc(i)))
                     else ! sans correction thermalisation des precips
                        zt(i) = zt(i) - zifl(i)*zmelt*(RG*dtime)/(paprs(i, k) - paprs(i, k + 1)) &
                                *RLMLT/RCPD/(1.0 + RVTMP2*zq(i))
                     end if
                     if (fl_cor_ebil .GT. 0) then ! correction bug, deplacement ligne precedente
!<LTP
                        IF (iflag_evap_prec == 4) THEN
                           ziflclr(i) = ziflclr(i)*(1.-zmelt)
                           ziflcld(i) = ziflcld(i)*(1.-zmelt)
                           zifl(i) = ziflclr(i) + ziflcld(i)
!>LTP
                        ELSE
                           zifl(i) = zifl(i)*(1.-zmelt)
                        END IF
                     end if

                  ELSE
                     ! Si on n'a plus de pluies, on reinitialise a 0 la farcion
                     ! sous nuageuse utilisee pour la pluie.
                     znebprecip(i) = 0.
                  END IF ! (zrfl(i)+zifl(i).GT.0.)
               END DO

            END IF ! (.NOT. ice_thermo)

            ! ----------------------------------------------------------------
            ! Fin evaporation de la precipitation
            ! ----------------------------------------------------------------
         END IF ! (iflag_evap_prec>=1)
         !
         ! Calculer Qs et L/Cp*dQs/dT:
         !
         IF (thermcep) THEN
            DO i = 1, klon
               zdelta = MAX(0., SIGN(1., RTT - zt(i)))
               zcvm5 = R5LES*RLVTT*(1.-zdelta) + R5IES*RLSTT*zdelta
               if (fl_cor_ebil .GT. 0) then ! nouveau
                  zcvm5 = zcvm5/RCPD/(1.0 + RVTMP2*(zq(i) + zmqc(i)))
               else
                  zcvm5 = zcvm5/RCPD/(1.0 + RVTMP2*zq(i))
               end if
               zqs(i) = R2ES*FOEEW(zt(i), zdelta)/pplay(i, k)
               zqs(i) = MIN(0.5, zqs(i))
               zcor = 1./(1.-RETV*zqs(i))
               zqs(i) = zqs(i)*zcor
               zdqs(i) = FOEDE(zt(i), zdelta, zcvm5, zqs(i), zcor)
               zdqsdT_raw(i) = zdqs(i)*  &
             &         RCPD*(1.0 + RVTMP2*zq(i))/(RLVTT*(1.-zdelta) + RLSTT*zdelta)
            END DO
         ELSE
            DO i = 1, klon
               IF (zt(i) .LT. t_coup) THEN
                  zqs(i) = qsats(zt(i))/pplay(i, k)
                  zdqs(i) = dqsats(zt(i), zqs(i))
               ELSE
                  zqs(i) = qsatl(zt(i))/pplay(i, k)
                  zdqs(i) = dqsatl(zt(i), zqs(i))
               END IF
            END DO
         END IF
         !
         ! Determiner la condensation partielle et calculer la quantite
         ! de l'eau condensee:
         !
!verification de la valeur de iflag_fisrtilp_qsat pour iflag_ice_thermo=1
!       if ((iflag_ice_thermo.eq.1).and.(iflag_fisrtilp_qsat.ne.0)) then
!         write(*,*) " iflag_ice_thermo==1 requires iflag_fisrtilp_qsat==0", &
!        " but iflag_fisrtilp_qsat=",iflag_fisrtilp_qsat, ". Might as well stop here."
!         stop
!       endif

         ! ----------------------------------------------------------------
         ! P2> Formation du nuage
         ! ----------------------------------------------------------------
         ! Variables calculees:
         !   rneb  : fraction nuageuse
         !   zcond : eau condensee moyenne dans la maille.
         !   rhcl: humidite relative ciel-clair
         !   zt : temperature de la maille
         ! ----------------------------------------------------------------
         !
         IF (cpartiel) THEN
            ! -------------------------
            ! P2.A> Nuage fractionnaire
            ! -------------------------
            !
            !   Calcul de l'eau condensee et de la fraction nuageuse et de l'eau
            !   nuageuse a partir des PDF de Sandrine Bony.
            !   rneb  : fraction nuageuse
            !   zqn   : eau totale dans le nuage
            !   zcond : eau condensee moyenne dans la maille.
            !  on prend en compte le réchauffement qui diminue la partie
            ! condensee
            !
            !   Version avec les raqts

            ! ----------------------------------------------------------------
            ! P2.A.0> Calcul des grandeurs nuageuses une pdf en creneau
            ! ----------------------------------------------------------------
            if (iflag_pdf .eq. 0) then

               ! version creneau de (Li, 1998)
               do i = 1, klon
                  zdelq = min(ratqs(i, k), 0.99)*zq(i)
                  rneb(i, k) = (zq(i) + zdelq - zqs(i))/(2.0*zdelq)
                  zqn(i) = (zq(i) + zdelq + zqs(i))/2.0
               end do

            else !  if (iflag_pdf.eq.0)
               ! ----------------------------------------------------------------
               ! P2.A.1> Avec les nouvelles PDFs, calcul des grandeurs nuageuses pour
               ! les valeurs de T et Q initiales
               ! ----------------------------------------------------------------
               do i = 1, klon
                  if (zq(i) .lt. 1.e-15) then
                     ncoreczq = ncoreczq + 1
                     zq(i) = 1.e-15
                  end if
               end do

               if (iflag_cld_th >= 5) then

                  if (iflag_cloudth_vert <= 2) then
                     call cloudth(klon, klev, k, ztv, &
                                  zq, zqta, fraca, &
                                  qcloud, ctot, zpspsk, paprs, pplay, ztla, zthl, &
                                  ratqs, zqs, t, &
                                  cloudth_sth, cloudth_senv, cloudth_sigmath, cloudth_sigmaenv)

                  elseif (iflag_cloudth_vert >= 3 .and. iflag_cloudth_vert <= 5) then
                     call cloudth_v3(klon, klev, k, ztv, &
                                     zq, zqta, fraca, &
                                     qcloud, ctot, ctot_vol, zpspsk, paprs, pplay, ztla, zthl, &
                                     ratqs, sigma_qtherm, zqs, t, &
                                     cloudth_sth, cloudth_senv, cloudth_sigmath, cloudth_sigmaenv)
                     !----------------------------------
                     !Version these Jean Jouhaud, Decembre 2018
                     !----------------------------------
                  elseif (iflag_cloudth_vert == 6) then
                     call cloudth_v6(klon, klev, k, ztv, &
                                     zq, zqta, fraca, &
                                     qcloud, ctot, ctot_vol, zpspsk, paprs, pplay, ztla, zthl, &
                                     ratqs, zqs, t, &
                                     cloudth_sth, cloudth_senv, cloudth_sigmath, cloudth_sigmaenv)

                  end if
                  do i = 1, klon
                     rneb(i, k) = ctot(i, k)
                     rneblsvol(i, k) = ctot_vol(i, k)
                     zqn(i) = qcloud(i)
                  end do

               end if

               if (iflag_cld_th <= 4) then
                  lognormale = .true.
               elseif (iflag_cld_th >= 6) then
                  ! lognormale en l'absence des thermiques
                  lognormale = fraca(:, k) < 1e-10
               else
                  ! Dans le cas iflag_cld_th=5, on prend systématiquement la
                  ! bi-gaussienne
                  lognormale = .false.
               end if

!CR: variation de qsat avec T en presence de glace ou non
!initialisations
               do i = 1, klon
                  DT(i) = 0.
                  n_i(i) = 0
                  Tbef(i) = zt(i)
                  qlbef(i) = 0.
               end do

               ! ----------------------------------------------------------------
               ! P2.A.2> Prise en compte du couplage entre eau condensee et T.
               ! Calcul des grandeurs nuageuses en tenant compte de l'effet de
               ! la condensation sur T, et donc sur qsat et sur les grandeurs nuageuses
               ! qui en dependent. Ce changement de temperature est provisoire, et
               ! la valeur definitive sera calcule plus tard.
               ! Variables calculees:
               !   rneb : nebulosite
               !   zcond: eau condensee en moyenne dans la maille
               ! note JLD: si on n'a pas de pdf lognormale, ce qui se passe ne me semble
               ! pas clair, il n'y a probablement pas de prise en compte de l'effet de
               ! T sur qsat
               ! ----------------------------------------------------------------

!Boucle iterative: ATTENTION, l'option -1 n'est plus activable ici
               if (iflag_fisrtilp_qsat .ge. 0) then
                  ! Iteration pour condensation avec variation de qsat(T)
                  ! -----------------------------------------------------
                  do iter = 1, iflag_fisrtilp_qsat + 1

                     do i = 1, klon
!                 do while ((abs(DT(i)).gt.DDT0).or.(n_i(i).eq.0))
                        ! !! convergence = .true. tant que l'on n'a pas converge !!
                        ! ------------------------------
                        convergence(i) = abs(DT(i)) .gt. DDT0
                        if ((convergence(i) .or. (n_i(i) .eq. 0)) .and. lognormale(i)) then
                           ! si on n'a pas converge
                           !
                           ! P2.A.2.1> Calcul de la fraction nuageuse et de la quantite d'eau condensee
                           ! ---------------------------------------------------------------
                           ! Variables calculees:
                           ! rneb : nebulosite
                           ! zqn : eau condensee, dans le nuage (in cloud water content)
                           ! zcond: eau condensee en moyenne dans la maille
                           ! rhcl: humidite relative ciel-clair
                           !
                           Tbef(i) = Tbef(i) + DT(i) ! nouvelle temperature
                           if (.not. ice_thermo) then
                              zdelta = MAX(0., SIGN(1., RTT - Tbef(i)))
                           else
                              if (iflag_t_glace .eq. 0) then
                                 zdelta = MAX(0., SIGN(1., t_glace_min_old - Tbef(i)))
                              else if (iflag_t_glace .ge. 1) then
                                 if (iflag_oldbug_fisrtilp .EQ. 0) then
                                    zdelta = MAX(0., SIGN(1., t_glace_max - Tbef(i)))
                                 else
                                    !avec bug : zdelta = MAX(0.,SIGN(1.,t_glace_min-Tbef(i)))
                                    zdelta = MAX(0., SIGN(1., t_glace_min - Tbef(i)))
                                 end if
                              end if
                           end if
                           ! Calcul de rneb, qzn et zcond pour les PDF lognormales
                           zcvm5 = R5LES*RLVTT*(1.-zdelta) + R5IES*RLSTT*zdelta
                           if (fl_cor_ebil .GT. 0) then
                              zcvm5 = zcvm5/RCPD/(1.0 + RVTMP2*(zq(i) + zmqc(i)))
                           else
                              zcvm5 = zcvm5/RCPD/(1.0 + RVTMP2*zq(i))
                           end if
                           zqs(i) = R2ES*FOEEW(Tbef(i), zdelta)/pplay(i, k)
                           zqs(i) = MIN(0.5, zqs(i))
                           zcor = 1./(1.-RETV*zqs(i))
                           zqs(i) = zqs(i)*zcor
                           zdqs(i) = FOEDE(Tbef(i), zdelta, zcvm5, zqs(i), zcor)
                           zpdf_sig(i) = ratqs(i, k)*zq(i)
                           zpdf_k(i) = -sqrt(log(1.+(zpdf_sig(i)/zq(i))**2))
                           zpdf_delta(i) = log(zq(i)/zqs(i))
                           zpdf_a(i) = zpdf_delta(i)/(zpdf_k(i)*sqrt(2.))
                           zpdf_b(i) = zpdf_k(i)/(2.*sqrt(2.))
                           zpdf_e1(i) = zpdf_a(i) - zpdf_b(i)
                           zpdf_e1(i) = sign(min(abs(zpdf_e1(i)), 5.), zpdf_e1(i))
                           zpdf_e1(i) = 1.-erf(zpdf_e1(i))
                           zpdf_e2(i) = zpdf_a(i) + zpdf_b(i)
                           zpdf_e2(i) = sign(min(abs(zpdf_e2(i)), 5.), zpdf_e2(i))
                           zpdf_e2(i) = 1.-erf(zpdf_e2(i))

                           if (zpdf_e1(i) .lt. 1.e-10) then
                              rneb(i, k) = 0.
                              zqn(i) = zqs(i)
                           else
                              rneb(i, k) = 0.5*zpdf_e1(i)
                              zqn(i) = zq(i)*zpdf_e2(i)/zpdf_e1(i)
                           end if

                           ! If vertical heterogeneity, change fraction by volume as well
                           if (iflag_cloudth_vert >= 3) then
                              ctot_vol(i, k) = rneb(i, k)
                              rneblsvol(i, k) = ctot_vol(i, k)
                           end if

                        end if !convergence

                     end do ! boucle en i

                     ! P2.A.2.2> Calcul APPROCHE de la variation de temperature DT
                     !         due a la condensation.
                     ! ---------------------------------------------------------------
                     ! Variables calculees:
                     ! DT : variation de temperature due a la condensation

                     if (.not. ice_thermo) then
                        ! --------------------------
                        do i = 1, klon
                        if ((convergence(i) .or. (n_i(i) .eq. 0)) .and. lognormale(i)) then

                           qlbef(i) = max(0., zqn(i) - zqs(i))
                           if (fl_cor_ebil .GT. 0) then
                              num = -Tbef(i) + zt(i) + rneb(i, k)*RLVTT/RCPD/(1.0 + RVTMP2*(zq(i) + zmqc(i)))*qlbef(i)
                           else
                              num = -Tbef(i) + zt(i) + rneb(i, k)*RLVTT/RCPD/(1.0 + RVTMP2*zq(i))*qlbef(i)
                           end if
                           denom = 1.+rneb(i, k)*zdqs(i)
                           DT(i) = num/denom
                           n_i(i) = n_i(i) + 1
                        end if
                        end do

                     else ! if (.not. ice_thermo)
                        ! --------------------------
                        if (iflag_t_glace .ge. 1) then
                           tmp_var1d(:) = pplay(:, k)/paprs(:, 1)
                           CALL icefrac_lsc(klon, zt(:), tmp_var1d, zfice(:))
                        end if

                        do i = 1, klon
                        if ((convergence(i) .or. (n_i(i) .eq. 0)) .and. lognormale(i)) then

                           if (iflag_t_glace .eq. 0) then
                              zfice(i) = 1.0 - (Tbef(i) - t_glace_min_old)/(RTT - t_glace_min_old)
                              zfice(i) = MIN(MAX(zfice(i), 0.0), 1.0)
                              zfice(i) = zfice(i)**exposant_glace_old
                              dzfice(i) = exposant_glace_old*zfice(i)**(exposant_glace_old - 1) &
                    &                     /(t_glace_min_old - RTT)
                           end if

                           if (iflag_t_glace .ge. 1 .and. zfice(i) > 0.) then
                              dzfice(i) = exposant_glace*zfice(i)**(exposant_glace - 1) &
                       &                    /(t_glace_min - t_glace_max)
                           end if

                           if ((zfice(i) .eq. 0) .or. (zfice(i) .eq. 1)) then
                              dzfice(i) = 0.
                           end if

                           if (zfice(i) .lt. 1) then
                              cste = RLVTT
                           else
                              cste = RLSTT
                           end if

                           qlbef(i) = max(0., zqn(i) - zqs(i))
                           if (fl_cor_ebil .GT. 0) then
                              num = -Tbef(i) + zt(i) + rneb(i, k)*((1 - zfice(i))*RLVTT &
                        &          + zfice(i)*RLSTT)/RCPD/(1.0 + RVTMP2*(zq(i) + zmqc(i)))*qlbef(i)
                              denom = 1.+rneb(i, k)*((1 - zfice(i))*RLVTT + zfice(i)*RLSTT)/cste*zdqs(i) &
                                      - (RLSTT - RLVTT)/RCPD/(1.0 + RVTMP2*(zq(i) + zmqc(i)))*rneb(i, k)    &
                                     &               *qlbef(i)*dzfice(i)
                           else
                              num = -Tbef(i) + zt(i) + rneb(i, k)*((1 - zfice(i))*RLVTT &
                        &         + zfice(i)*RLSTT)/RCPD/(1.0 + RVTMP2*zq(i))*qlbef(i)
                              denom = 1.+rneb(i, k)*((1 - zfice(i))*RLVTT + zfice(i)*RLSTT)/cste*zdqs(i) &
                                      - (RLSTT - RLVTT)/RCPD/(1.0 + RVTMP2*zq(i))*rneb(i, k)*qlbef(i)*dzfice(i)
                           end if
                           DT(i) = num/denom
                           n_i(i) = n_i(i) + 1

                        end if ! fin convergence
                        end do ! fin boucle i

                     end if !ice_thermo

                  end do ! iter=1,iflag_fisrtilp_qsat+1
                  ! Fin d'iteration pour condensation avec variation de qsat(T)
                  ! -----------------------------------------------------------
               end if !  if (iflag_fisrtilp_qsat.ge.0)
               ! ----------------------------------------------------------------
               ! Fin de P2.A.2> la prise en compte du couplage entre eau condensee et T
               ! ----------------------------------------------------------------

            end if ! iflag_pdf

!        if (iflag_fisrtilp_qsat.eq.-1) then
!------------------------------------------
!CR: ATTENTION option fausse mais a existe:
! pour la re-activer, prendre iflag_fisrtilp_qsat=0 et
! activer les lignes suivantes:
            IF (1 .eq. 0) THEN
            DO i = 1, klon
               IF (rneb(i, k) .LE. 0.0) THEN
                  zqn(i) = 0.0
                  rneb(i, k) = 0.0
                  zcond(i) = 0.0
                  rhcl(i, k) = zq(i)/zqs(i)
               ELSE IF (rneb(i, k) .GE. 1.0) THEN
                  zqn(i) = zq(i)
                  rneb(i, k) = 1.0
                  zcond(i) = MAX(0.0, zqn(i) - zqs(i))/(1 + zdqs(i))
                  rhcl(i, k) = 1.0
               ELSE
                  zcond(i) = MAX(0.0, zqn(i) - zqs(i))*rneb(i, k)/(1 + zdqs(i))
                  rhcl(i, k) = (zqs(i) + zq(i) - zdelq)/2./zqs(i)
               END IF
            END DO
            END IF
!------------------------------------------

!        ELSE
            ! ----------------------------------------------------------------
            ! P2.A.3> Calcul des valeures finales associees a la formation des nuages
            ! Variables calculees:
            !   rneb : nebulosite
            !   zcond: eau condensee en moyenne dans la maille
            !   zq : eau vapeur dans la maille
            !   zt : temperature de la maille
            !   rhcl: humidite relative ciel-clair
            ! ----------------------------------------------------------------
            !
            ! Bornage de l'eau in-cloud (zqn) et de la fraction nuageuse (rneb)
            ! Calcule de l'eau condensee moyenne dans la maille (zcond),
            ! et de l'humidite relative ciel-clair (rhcl)
            DO i = 1, klon
               IF (rneb(i, k) .LE. 0.0) THEN
                  zqn(i) = 0.0
                  rneb(i, k) = 0.0
                  zcond(i) = 0.0
                  rhcl(i, k) = zq(i)/zqs(i)
               ELSE IF (rneb(i, k) .GE. 1.0) THEN
                  zqn(i) = zq(i)
                  rneb(i, k) = 1.0
                  zcond(i) = MAX(0.0, zqn(i) - zqs(i))
                  rhcl(i, k) = 1.0
               ELSE
                  zcond(i) = MAX(0.0, zqn(i) - zqs(i))*rneb(i, k)
                  rhcl(i, k) = (zqs(i) + zq(i) - zdelq)/2./zqs(i)
               END IF
            END DO

            ! If vertical heterogeneity, change fraction by volume as well
            if (iflag_cloudth_vert >= 3) then
               ctot_vol(1:klon, k) = min(max(ctot_vol(1:klon, k), 0.), 1.)
               rneblsvol(1:klon, k) = ctot_vol(1:klon, k)
            end if

!        ENDIF

         ELSE ! de IF (cpartiel)
            ! -------------------------
            ! P2.B> Nuage "tout ou rien"
            ! -------------------------
            ! note JLD: attention, rhcl non calcule. Ca peut avoir des consequences?
            DO i = 1, klon
               IF (zq(i) .GT. zqs(i)) THEN
                  rneb(i, k) = 1.0
               ELSE
                  rneb(i, k) = 0.0
               END IF
               zcond(i) = MAX(0.0, zq(i) - zqs(i))/(1.+zdqs(i))
            END DO
         END IF ! de IF (cpartiel)
         !
         ! Mise a jour vapeur d'eau
         ! -------------------------
         DO i = 1, klon
            zq(i) = zq(i) - zcond(i)
            !         zt(i) = zt(i) + zcond(i) * RLVTT/RCPD
         END DO
!AJ<
         ! ------------------------------------
         ! P2.C> Prise en compte de la Chaleur latente apres formation nuage
         ! -------------------------------------
         ! Variable calcule:
         !   zt : temperature de la maille
         !
         IF (.NOT. ice_thermo) THEN
            if (iflag_fisrtilp_qsat .lt. 1) then
               DO i = 1, klon
                  zt(i) = zt(i) + zcond(i)*RLVTT/RCPD/(1.0 + RVTMP2*zq(i))
               END DO
            else if (iflag_fisrtilp_qsat .gt. 0) then
               DO i = 1, klon
                  if (fl_cor_ebil .GT. 0) then
                     zt(i) = zt(i) + zcond(i)*RLVTT/RCPD/(1.0 + RVTMP2*(zq(i) + zmqc(i) + zcond(i)))
                  else
                     zt(i) = zt(i) + zcond(i)*RLVTT/RCPD/(1.0 + RVTMP2*(zq(i) + zcond(i)))
                  end if
               END DO
            end if
         ELSE
            if (iflag_t_glace .ge. 1) then
               tmp_var1d(:) = pplay(:, k)/paprs(:, 1)
               CALL icefrac_lsc(klon, zt(:), tmp_var1d, zfice(:))
            end if
            if (iflag_fisrtilp_qsat .lt. 1) then
               DO i = 1, klon
! JBM: icefrac_lsc is now a function contained in icefrac_lsc_mod
!              zfice(i) = icefrac_lsc(zt(i), t_glace_min, &
!                                     t_glace_max, exposant_glace)
                  if (iflag_t_glace .eq. 0) then
                     zfice(i) = 1.0 - (zt(i) - t_glace_min_old)/(RTT - t_glace_min_old)
                     zfice(i) = MIN(MAX(zfice(i), 0.0), 1.0)
                     zfice(i) = zfice(i)**exposant_glace_old
                  end if
                  zt(i) = zt(i) + (1.-zfice(i))*zcond(i)*RLVTT/RCPD/(1.0 + RVTMP2*zq(i)) &
                          + zfice(i)*zcond(i)*RLSTT/RCPD/(1.0 + RVTMP2*zq(i))
               END DO
            else
               DO i = 1, klon
! JBM: icefrac_lsc is now a function contained in icefrac_lsc_mod
!              zfice(i) = icefrac_lsc(zt(i), t_glace_min, &
!                                     t_glace_max, exposant_glace)
                  if (iflag_t_glace .eq. 0) then
                     zfice(i) = 1.0 - (zt(i) - t_glace_min_old)/(RTT - t_glace_min_old)
                     zfice(i) = MIN(MAX(zfice(i), 0.0), 1.0)
                     zfice(i) = zfice(i)**exposant_glace_old
                  end if
                  if (fl_cor_ebil .GT. 0) then
                     zt(i) = zt(i) + (1.-zfice(i))*zcond(i) &
                            &             *RLVTT/RCPD/(1.0 + RVTMP2*(zq(i) + zmqc(i) + zcond(i))) &
                             + zfice(i)*zcond(i)*RLSTT/RCPD/(1.0 + RVTMP2*(zq(i) + zmqc(i) + zcond(i)))
                  else
                     zt(i) = zt(i) + (1.-zfice(i))*zcond(i)*RLVTT/RCPD/(1.0 + RVTMP2*(zq(i) + zcond(i))) &
                             + zfice(i)*zcond(i)*RLSTT/RCPD/(1.0 + RVTMP2*(zq(i) + zcond(i)))
                  end if
               END DO
            end if
!         print*,zt(i),zrfl(i),zifl(i),'temp1'
         END IF
!>AJ

         ! ----------------------------------------------------------------
         ! P3> Formation des precipitations
         ! ----------------------------------------------------------------
         !
         ! Partager l'eau condensee en precipitation et eau liquide nuageuse
         !

!<LTP

         IF (iflag_evap_prec == 4) THEN
            !Partitionnement des precipitations venant du dessus en précipitations nuageuses
            !et précipitations ciel clair

            !0) Calculate tot_zneb, la fraction nuageuse totale au-dessus du nuage
            !en supposant un recouvrement maximum aléatoire (voir Jakob and Klein, 2000)

            DO i = 1, klon
               tot_znebn(i) = 1 - (1 - tot_zneb(i))*(1 - max(rneb(i, k), zneb(i))) &
                              /(1 - min(zneb(i), 1 - smallestreal))
               d_tot_zneb(i) = tot_znebn(i) - tot_zneb(i)
               tot_zneb(i) = tot_znebn(i)

               !1) Cloudy to clear air
               d_znebprecip_cld_clr(i) = znebprecipcld(i) - min(rneb(i, k), znebprecipcld(i))
               IF (znebprecipcld(i) .GT. 0) THEN
                  d_zrfl_cld_clr(i) = d_znebprecip_cld_clr(i)/znebprecipcld(i)*zrflcld(i)
                  d_zifl_cld_clr(i) = d_znebprecip_cld_clr(i)/znebprecipcld(i)*ziflcld(i)
               ELSE
                  d_zrfl_cld_clr(i) = 0.
                  d_zifl_cld_clr(i) = 0.
               END IF

               !2) Clear to cloudy air
               d_znebprecip_clr_cld(i) = max(0., min(znebprecipclr(i), rneb(i, k) &
                                                     - d_tot_zneb(i) - zneb(i)))
               IF (znebprecipclr(i) .GT. 0) THEN
                  d_zrfl_clr_cld(i) = d_znebprecip_clr_cld(i)/znebprecipclr(i)*zrflclr(i)
                  d_zifl_clr_cld(i) = d_znebprecip_clr_cld(i)/znebprecipclr(i)*ziflclr(i)
               ELSE
                  d_zrfl_clr_cld(i) = 0.
                  d_zifl_clr_cld(i) = 0.
               END IF

               !Update variables
               znebprecipcld(i) = znebprecipcld(i) + d_znebprecip_clr_cld(i) - d_znebprecip_cld_clr(i)
               znebprecipclr(i) = znebprecipclr(i) + d_znebprecip_cld_clr(i) - d_znebprecip_clr_cld(i)
               zrflcld(i) = zrflcld(i) + d_zrfl_clr_cld(i) - d_zrfl_cld_clr(i)
               ziflcld(i) = ziflcld(i) + d_zifl_clr_cld(i) - d_zifl_cld_clr(i)
               zrflclr(i) = zrflclr(i) + d_zrfl_cld_clr(i) - d_zrfl_clr_cld(i)
               ziflclr(i) = ziflclr(i) + d_zifl_cld_clr(i) - d_zifl_clr_cld(i)

            END DO
         END IF

!>LTP

         ! Initialisation de zoliq (eau condensee moyenne dans la maille)
         DO i = 1, klon
            IF (rneb(i, k) .GT. 0.0) THEN
               zoliq(i) = zcond(i)
               zrho(i) = pplay(i, k)/zt(i)/RD
               zdz(i) = (paprs(i, k) - paprs(i, k + 1))/(zrho(i)*RG)
            END IF
         END DO
!AJ<
         IF (.NOT. ice_thermo) THEN
            IF (iflag_t_glace .EQ. 0) THEN
               DO i = 1, klon
                  IF (rneb(i, k) .GT. 0.0) THEN
                     zfice(i) = 1.0 - (zt(i) - t_glace_min_old)/(273.13 - t_glace_min_old)
                     zfice(i) = MIN(MAX(zfice(i), 0.0), 1.0)
                     zfice(i) = zfice(i)**exposant_glace_old
!              zfice(i) = zfice(i)**nexpo
         !!      zfice(i)=0.
                  END IF
               END DO
            ELSE ! of IF (iflag_t_glace.EQ.0)
               tmp_var1d(:) = pplay(:, k)/paprs(:, 1)
               CALL icefrac_lsc(klon, zt(:), tmp_var1d, zfice(:))
!         DO i = 1, klon
!            IF (rneb(i,k).GT.0.0) THEN
! JBM: icefrac_lsc is now a function contained in icefrac_lsc_mod
!              zfice(i) = icefrac_lsc(zt(i), t_glace_min, &
!                                     t_glace_max, exposant_glace)
!            ENDIF
!         ENDDO
            END IF
         END IF

         ! Calcul de radliq (eau condensee pour le rayonnement)
         ! Iteration pour realiser une moyenne de l'eau nuageuse lors de la precip
         ! Remarque: ce n'est donc pas l'eau restante en fin de precip mais une
         ! eau moyenne restante dans le nuage sur la duree du pas de temps qui est
         ! transmise au rayonnement;
         ! ----------------------------------------------------------------
         DO i = 1, klon
            IF (rneb(i, k) .GT. 0.0) THEN
               zneb(i) = MAX(rneb(i, k), seuil_neb)
               !      zt(i) = zt(i)+zcond(i)*zfice(i)*RLMLT/RCPD/(1.0+RVTMP2*zq(i))
!           print*,zt(i),'fractionglace'
!>AJ
               radliq(i, k) = zoliq(i)/REAL(ninter + 1)
            END IF
         END DO
         !
         DO n = 1, ninter
            DO i = 1, klon
               IF (rneb(i, k) .GT. 0.0) THEN
                  zrhol(i) = zrho(i)*zoliq(i)/zneb(i)
                  ! Initialization of zpluie and zice:
                  zpluie = 0
                  zice = 0
                  IF (zneb(i) .EQ. seuil_neb) THEN
                     ztot = 0.0
                  ELSE
                     !  quantite d'eau a eliminer: zchau (Sundqvist, 1978)
                     !  meme chose pour la glace: zfroi (Zender & Kiehl, 1997)
                     if (ptconv(i, k)) then
                        zcl = cld_lc_con
                        zct = 1./cld_tau_con
                        zfroi = dtime/REAL(ninter)/zdz(i)*zoliq(i) &
                                *fallvc(zrhol(i))*zfice(i)
                     else
                        zcl = cld_lc_lsc
                        zct = 1./cld_tau_lsc
                        zfroi = dtime/REAL(ninter)/zdz(i)*zoliq(i) &
                                *fallvs(zrhol(i))*zfice(i)
                     end if

                     ! si l'heterogeneite verticale est active, on utilise
                     ! la fraction volumique "vraie" plutot que la fraction
                     ! surfacique modifiee, qui est plus grande et reduit
                     ! sinon l'eau in-cloud de facon artificielle
                     if ((iflag_cloudth_vert >= 3) .AND. (iflag_rain_incloud_vol == 1)) then
                        zchau = zct*dtime/REAL(ninter)*zoliq(i) &
                                *(1.0 - EXP(-(zoliq(i)/ctot_vol(i, k)/zcl)**2))*(1.-zfice(i))
                     else
                        zchau = zct*dtime/REAL(ninter)*zoliq(i) &
                                *(1.0 - EXP(-(zoliq(i)/zneb(i)/zcl)**2))*(1.-zfice(i))
                     end if
!AJ<
                     IF (.NOT. ice_thermo) THEN
                        ztot = zchau + zfroi
                     ELSE
                        zpluie = MIN(MAX(zchau, 0.0), zoliq(i)*(1.-zfice(i)))
                        zice = MIN(MAX(zfroi, 0.0), zoliq(i)*zfice(i))
                        ztot = zpluie + zice
                     END IF
!>AJ
                     ztot = MAX(ztot, 0.0)
                  END IF
                  ztot = MIN(ztot, zoliq(i))
!AJ<
                  !         zoliqp = MAX(zoliq(i)*(1.-zfice(i))-1.*zpluie   , 0.0)
                  !         zoliqi = MAX(zoliq(i)*zfice(i)-1.*zice   , 0.0)
!JLD : les 2 variables zoliqp et zoliqi crorresponent a des pseudo precip
!      temporaires et ne doivent pas etre calcule (alors qu'elles le sont
!      si iflag_bergeron <> 2
!      A SUPPRIMER A TERME
                  zoliqp(i) = MAX(zoliq(i)*(1.-zfice(i)) - 1.*zpluie, 0.0)
                  zoliqi(i) = MAX(zoliq(i)*zfice(i) - 1.*zice, 0.0)
                  zoliq(i) = MAX(zoliq(i) - ztot, 0.0)
!>AJ
                  radliq(i, k) = radliq(i, k) + zoliq(i)/REAL(ninter + 1)
               END IF
            END DO  ! i = 1,klon
         END DO     ! n = 1,ninter

         ! ----------------------------------------------------------------
         !
         IF (.NOT. ice_thermo) THEN
            DO i = 1, klon
               IF (rneb(i, k) .GT. 0.0) THEN
                  d_ql(i, k) = zoliq(i)
                  zrfl(i) = zrfl(i) + MAX(zcond(i) - zoliq(i), 0.0) &
                            *(paprs(i, k) - paprs(i, k + 1))/(RG*dtime)
               END IF
            END DO
         ELSE
!
!CR&JYG<
! On prend en compte l'effet Bergeron dans les flux de precipitation :
! Si T < 0 C, alors les precipitations liquides sont converties en glace, ce qui
! provoque un accroissement de temperature DeltaT. L'effet de DeltaT sur le condensat
! et les precipitations est grossierement pris en compte en linearisant les equations
! et en approximant le processus de precipitation liquide par un processus a seuil.
! On fait l'hypothese que le condensat nuageux n'est pas modifié dans cette opération.
! Le condensat precipitant liquide est supprime (dans la limite DeltaT<273-T).
! Le condensat precipitant solide est augmente.
! La vapeur d'eau est augmentee.
!
            IF ((iflag_bergeron .EQ. 2)) THEN
               DO i = 1, klon
                  IF (rneb(i, k) .GT. 0.0) THEN
                     zqpreci(i) = (zcond(i) - zoliq(i))*zfice(i)
                     zqprecl(i) = (zcond(i) - zoliq(i))*(1.-zfice(i))
                     if (fl_cor_ebil .GT. 0) then
                        zcp = RCPD*(1.0 + RVTMP2*(zq(i) + zmqc(i) + zcond(i)))
                        coef1 = rneb(i, k)*RLSTT/zcp*zdqsdT_raw(i)
!            Calcul de DT si toute les precips liquides congelent
                        DeltaT = RLMLT*zqprecl(i)/(zcp*(1.+coef1))
!            On ne veut pas que T devienne superieur a la temp. de congelation.
!            donc que Delta > RTT-zt(i
                        DeltaT = max(min(RTT - zt(i), DeltaT), 0.)
                        zt(i) = zt(i) + DeltaT
!            Eau vaporisee du fait de l'augmentation de T
                        Deltaq = rneb(i, k)*zdqsdT_raw(i)*DeltaT
!            on reajoute cette eau vaporise a la vapeur et on l'enleve des precips
                        zq(i) = zq(i) + Deltaq
!            Les 3 max si dessous prtotegent uniquement des erreurs d'arrondies
                        zcond(i) = max(zcond(i) - Deltaq, 0.)
!            precip liquide qui congele ou qui s'evapore
                        Deltaqprecl = -zcp/RLMLT*(1.+coef1)*DeltaT
                        zqprecl(i) = max(zqprecl(i) + Deltaqprecl, 0.)
!            bilan eau glacee
                        zqpreci(i) = max(zqpreci(i) - Deltaqprecl - Deltaq, 0.)
                     else ! if (fl_cor_ebil .GT. 0)
!            ancien calcul
                        zcp = RCPD*(1.0 + RVTMP2*(zq(i) + zcond(i)))
                        coef1 = RLMLT*zdqs(i)/RLVTT
                        DeltaT = max(min(RTT - zt(i), RLMLT*zqprecl(i)/zcp/(1.+coef1)), 0.)
                        zqpreci(i) = zqpreci(i) + zcp/RLMLT*DeltaT
                        zqprecl(i) = max(zqprecl(i) - zcp/RLMLT*(1.+coef1)*DeltaT, 0.)
                        zcond(i) = max(zcond(i) - zcp/RLVTT*zdqs(i)*DeltaT, 0.)
                        zq(i) = zq(i) + zcp/RLVTT*zdqs(i)*DeltaT
                        zt(i) = zt(i) + DeltaT
                     end if ! if (fl_cor_ebil .GT. 0)
                  END IF  ! rneb(i,k) .GT. 0.0
               END DO
               DO i = 1, klon
                  IF (rneb(i, k) .GT. 0.0) THEN
                     d_ql(i, k) = (1 - zfice(i))*zoliq(i)
                     d_qi(i, k) = zfice(i)*zoliq(i)
!<LTP
                     IF (iflag_evap_prec == 4) THEN
                        zrflcld(i) = zrflcld(i) + zqprecl(i) &
                                     *(paprs(i, k) - paprs(i, k + 1))/(RG*dtime)
                        ziflcld(i) = ziflcld(i) + zqpreci(i) &
                                     *(paprs(i, k) - paprs(i, k + 1))/(RG*dtime)
                        znebprecipcld(i) = rneb(i, k)
                        zrfl(i) = zrflcld(i) + zrflclr(i)
                        zifl(i) = ziflcld(i) + ziflclr(i)
!>LTP
                     ELSE
                        zrfl(i) = zrfl(i) + zqprecl(i) &
                                  *(paprs(i, k) - paprs(i, k + 1))/(RG*dtime)
                        zifl(i) = zifl(i) + zqpreci(i) &
                                  *(paprs(i, k) - paprs(i, k + 1))/(RG*dtime)

                     END IF !iflag_evap_prec==4

                  END IF
               END DO
!!
            ELSE  ! iflag_bergeron
!>CR&JYG
!!
               DO i = 1, klon
                  IF (rneb(i, k) .GT. 0.0) THEN
!CR on prend en compte la phase glace
!JLD inutile car on ne passe jamais ici si .not.ice_thermo
!           if (.not.ice_thermo) then
!           d_ql(i,k) = zoliq(i)
!           d_qi(i,k) = 0.
!           else
                     d_ql(i, k) = (1 - zfice(i))*zoliq(i)
                     d_qi(i, k) = zfice(i)*zoliq(i)
!           endif
!<LTP
                     IF (iflag_evap_prec == 4) THEN
                        zrflcld(i) = zrflcld(i) + MAX(zcond(i)*(1.-zfice(i)) - zoliqp(i), 0.0) &
                                     *(paprs(i, k) - paprs(i, k + 1))/(RG*dtime)
                        ziflcld(i) = ziflcld(i) + MAX(zcond(i)*zfice(i) - zoliqi(i), 0.0) &
                                     *(paprs(i, k) - paprs(i, k + 1))/(RG*dtime)
                        znebprecipcld(i) = rneb(i, k)
                        zrfl(i) = zrflcld(i) + zrflclr(i)
                        zifl(i) = ziflcld(i) + ziflclr(i)
!>LTP
                     ELSE
!AJ<
                        zrfl(i) = zrfl(i) + MAX(zcond(i)*(1.-zfice(i)) - zoliqp(i), 0.0) &
                                  *(paprs(i, k) - paprs(i, k + 1))/(RG*dtime)
                        zifl(i) = zifl(i) + MAX(zcond(i)*zfice(i) - zoliqi(i), 0.0) &
                                  *(paprs(i, k) - paprs(i, k + 1))/(RG*dtime)
                        !      zrfl(i) = zrfl(i)+  zpluie                         &
                        !          *(paprs(i,k)-paprs(i,k+1))/(RG*dtime)
                        !      zifl(i) = zifl(i)+  zice                    &
                        !               *(paprs(i,k)-paprs(i,k+1))/(RG*dtime)
                     END IF !iflag_evap_prec == 4

!CR : on prend en compte l'effet Bergeron dans les flux de precipitation
                     IF ((iflag_bergeron .EQ. 1) .AND. (zt(i) .LT. 273.15)) THEN
!<LTP
                        IF (iflag_evap_prec == 4) THEN
                           zsolid = zrfl(i)
                           ziflclr(i) = ziflclr(i) + zrflclr(i)
                           ziflcld(i) = ziflcld(i) + zrflcld(i)
                           zifl(i) = ziflclr(i) + ziflcld(i)
                           zrflcld(i) = 0.
                           zrflclr(i) = 0.
                           zrfl(i) = zrflclr(i) + zrflcld(i)
!>LTP
                        ELSE
                           zsolid = zrfl(i)
                           zifl(i) = zifl(i) + zrfl(i)
                           zrfl(i) = 0.
                        END IF!iflag_evap_prec==4

                        if (fl_cor_ebil .GT. 0) then
                           zt(i) = zt(i) + zsolid*(RG*dtime)/(paprs(i, k) - paprs(i, k + 1)) &
                                   *(RLSTT - RLVTT)/RCPD/(1.0 + RVTMP2*(zq(i) + zmqc(i)))
                        else
                           zt(i) = zt(i) + zsolid*(RG*dtime)/(paprs(i, k) - paprs(i, k + 1)) &
                                   *(RLSTT - RLVTT)/RCPD/(1.0 + RVTMP2*zq(i))
                        end if
                     END IF  ! (iflag_bergeron .EQ. 1) .AND. (zt(i) .LT. 273.15)
!RC

                  END IF ! rneb(i,k).GT.0.0
               END DO

            END IF  ! iflag_bergeron .EQ. 2
         END IF  ! .NOT. ice_thermo

!CR: la fonte est faite au debut
!      IF (ice_thermo) THEN
!       DO i = 1, klon
!           zmelt = ((zt(i)-273.15)/(ztfondue-273.15))**2
!           zmelt = MIN(MAX(zmelt,0.),1.)
!           zrfl(i)=zrfl(i)+zmelt*zifl(i)
!           zifl(i)=zifl(i)*(1.-zmelt)
!           print*,zt(i),'octavio1'
!           zt(i)=zt(i)-zifl(i)*zmelt*(RG*dtime)/(paprs(i,k)-paprs(i,k+1)) &
!                      *RLMLT/RCPD/(1.0+RVTMP2*zq(i))
!           print*,zt(i),zrfl(i),zifl(i),zmelt,'octavio2'
!       ENDDO
!     ENDIF

!<LTP

!Limitation de la fraction surfacique couverte par les précipitations lorsque l'intensité locale du flux de précipitation descend en
!dessous de rain_int_min
         IF (iflag_evap_prec == 4) THEN
            DO i = 1, klon
               IF (zrflclr(i) + ziflclr(i) .GT. 0) THEN
                  znebprecipclr(i) = min(znebprecipclr(i), max(zrflclr(i) &
                                                               /(znebprecipclr(i)*rain_int_min), &
                                                               ziflclr(i)/(znebprecipclr(i)*rain_int_min)))
               ELSE
                  znebprecipclr(i) = 0.
               END IF

               IF (zrflcld(i) + ziflcld(i) .GT. 0) THEN
                  znebprecipcld(i) = min(znebprecipcld(i), &
                                         max(zrflcld(i)/(znebprecipcld(i)*rain_int_min), &
                                             ziflcld(i)/(znebprecipcld(i)*rain_int_min)))
               ELSE
                  znebprecipcld(i) = 0.
               END IF
            END DO
         END If

!>LTP

         IF (.NOT. ice_thermo) THEN
            DO i = 1, klon
               IF (zt(i) .LT. RTT) THEN
                  psfl(i, k) = zrfl(i)
               ELSE
                  prfl(i, k) = zrfl(i)
               END IF
            END DO
         ELSE
            ! JAM*************************************************
            ! Revoir partie ci-dessous: a quoi servent psfl et prfl?
            ! *****************************************************

            DO i = 1, klon
               !   IF (zt(i).LT.RTT) THEN
               psfl(i, k) = zifl(i)
               !   ELSE
               prfl(i, k) = zrfl(i)
               !   ENDIF
!>AJ
            END DO
         END IF
         ! ----------------------------------------------------------------
         ! Fin de formation des precipitations
         ! ----------------------------------------------------------------
         !
         ! Calculer les tendances de q et de t:
         !
         DO i = 1, klon
            d_q(i, k) = zq(i) - q(i, k)
            d_t(i, k) = zt(i) - t(i, k)
         END DO
         !
         !AA--------------- Calcul du lessivage stratiforme  -------------

         DO i = 1, klon
            !
            if (zcond(i) .gt. zoliq(i) + 1.e-10) then
               beta(i, k) = (zcond(i) - zoliq(i))/zcond(i)/dtime
            else
               beta(i, k) = 0.
            end if
            zprec_cond(i) = MAX(zcond(i) - zoliq(i), 0.0) &
                            *(paprs(i, k) - paprs(i, k + 1))/RG
            IF (rneb(i, k) .GT. 0.0 .and. zprec_cond(i) .gt. 0.) THEN
               !AA lessivage nucleation LMD5 dans la couche elle-meme
               IF (iflag_t_glace .EQ. 0) THEN
                  if (t(i, k) .GE. t_glace_min_old) THEN
                     zalpha_tr = a_tr_sca(3)
                  else
                     zalpha_tr = a_tr_sca(4)
                  end if
               ELSE ! of IF (iflag_t_glace.EQ.0)
                  if (t(i, k) .GE. t_glace_min) THEN
                     zalpha_tr = a_tr_sca(3)
                  else
                     zalpha_tr = a_tr_sca(4)
                  end if
               END IF
               zfrac_lessi = 1.-EXP(zalpha_tr*zprec_cond(i)/zneb(i))
               pfrac_nucl(i, k) = pfrac_nucl(i, k)*(1.-zneb(i)*zfrac_lessi)
               frac_nucl(i, k) = 1.-zneb(i)*zfrac_lessi
               !
               ! nucleation avec un facteur -1 au lieu de -0.5
               zfrac_lessi = 1.-EXP(-zprec_cond(i)/zneb(i))
               pfrac_1nucl(i, k) = pfrac_1nucl(i, k)*(1.-zneb(i)*zfrac_lessi)
            END IF
            !
         END DO      ! boucle sur i
         !
         !AA Lessivage par impaction dans les couches en-dessous
         DO kk = k - 1, 1, -1
            DO i = 1, klon
               IF (rneb(i, k) .GT. 0.0 .and. zprec_cond(i) .gt. 0.) THEN
                  IF (iflag_t_glace .EQ. 0) THEN
                     if (t(i, kk) .GE. t_glace_min_old) THEN
                        zalpha_tr = a_tr_sca(1)
                     else
                        zalpha_tr = a_tr_sca(2)
                     end if
                  ELSE ! of IF (iflag_t_glace.EQ.0)
                     if (t(i, kk) .GE. t_glace_min) THEN
                        zalpha_tr = a_tr_sca(1)
                     else
                        zalpha_tr = a_tr_sca(2)
                     end if
                  END IF
                  zfrac_lessi = 1.-EXP(zalpha_tr*zprec_cond(i)/zneb(i))
                  pfrac_impa(i, kk) = pfrac_impa(i, kk)*(1.-zneb(i)*zfrac_lessi)
                  frac_impa(i, kk) = 1.-zneb(i)*zfrac_lessi
               END IF
            END DO
         END DO
         !
         !AA===============================================================
         !                     FIN DE LA BOUCLE VERTICALE
      end DO
      !
      !AA==================================================================
      !
      ! Pluie ou neige au sol selon la temperature de la 1ere couche
      !
!CR: si la thermo de la glace est active, on calcule zifl directement
      IF (.NOT. ice_thermo) THEN
      DO i = 1, klon
         IF ((t(i, 1) + d_t(i, 1)) .LT. RTT) THEN
!AJ<
!        snow(i) = zrfl(i)
            snow(i) = zrfl(i) + zifl(i)
!>AJ
            zlh_solid(i) = RLSTT - RLVTT
         ELSE
            rain(i) = zrfl(i)
            zlh_solid(i) = 0.
         END IF
      END DO

      ELSE
      DO i = 1, klon
         snow(i) = zifl(i)
         rain(i) = zrfl(i)
      END DO

      END IF
      !
      ! For energy conservation : when snow is present, the solification
      ! latent heat is considered.
!CR: si thermo de la glace, neige deja prise en compte
      IF (.not. ice_thermo) THEN
      DO k = 1, klev
         DO i = 1, klon
            zcpair = RCPD*(1.0 + RVTMP2*(q(i, k) + d_q(i, k)))
            zmair(i) = (paprs(i, k) - paprs(i, k + 1))/RG
            zm_solid = (prfl(i, k) - prfl(i, k + 1) + psfl(i, k) - psfl(i, k + 1))*dtime
            d_t(i, k) = d_t(i, k) + zlh_solid(i)*zm_solid/(zcpair*zmair(i))
         END DO
      END DO
      END IF
      !

      if (ncoreczq > 0) then
         WRITE (lunout, *) 'WARNING : ZQ dans fisrtilp ', ncoreczq, ' val < 1.e-15.'
      end if

      RETURN
   END SUBROUTINE fisrtilp
END MODULE lmdz_lscp_old

!
! $Header$
!
SUBROUTINE nxgradst (klevel,rot, x, y )
  USE comgeom_mod_h
  USE dimensions_mod, ONLY: iim, jjm, llm, ndm
  USE paramet_mod_h
IMPLICIT NONE
  ! Auteur :  P. Le Van
  !
  !   ********************************************************************
  !  calcul du gradient tourne de pi/2 du rotationnel du vect.v
  !   ********************************************************************
  !   rot          est un argument  d'entree pour le s-prog
  !   x  et y    sont des arguments de sortie pour le s-prog
  !


  INTEGER :: klevel
  REAL :: rot( ip1jm,klevel ),x( ip1jmp1,klevel ),y(ip1jm,klevel )
  INTEGER :: l,ij
  !
  DO l = 1,klevel
  !
  DO  ij = 2, ip1jm
  y(ij,l)=( rot(ij,l) - rot(ij-1,l))
  END DO
  !
  !    ..... correction pour  y ( 1,j,l )  ......
  !
  !    ....    y(1,j,l)= y(iip1,j,l) ....

  DO  ij = 1, ip1jm, iip1
  y( ij,l ) = y( ij +iim,l )
  END DO
  !
  DO  ij = iip2,ip1jm
  x(ij,l)= rot(ij,l)-rot(ij-iip1,l)
  END DO
  DO ij = 1,iip1
  x(    ij    ,l ) = 0.
  x( ij +ip1jm,l ) = 0.
  END DO
  !
  END DO
  RETURN
END SUBROUTINE nxgradst

! radiation_two_stream.F90 - Compute two-stream coefficients
!
! (C) Copyright 2014- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!
! Author:  Robin Hogan
! Email:   r.j.hogan@ecmwf.int
!
! Modifications
!   2017-05-04  P Dueben/R Hogan  Use JPRD where double precision essential
!   2017-07-12  R Hogan  Optimized LW coeffs in low optical depth case
!   2017-07-26  R Hogan  Added calc_frac_scattered_diffuse_sw routine
!   2017-10-23  R Hogan  Renamed single-character variables
!   2021-02-19  R Hogan  Security for shortwave singularity

module radiation_two_stream

  use parkind1, only : jprb, jprd

  implicit none
  public

  ! Elsasser's factor: the effective factor by which the zenith
  ! optical depth needs to be multiplied to account for longwave
  ! transmission at all angles through the atmosphere.  Alternatively
  ! think of acos(1/lw_diffusivity) to be the effective zenith angle
  ! of longwave radiation.
  real(jprd), parameter :: LwDiffusivity   = 1.66_jprd
  real(jprb), parameter :: LwDiffusivityWP = 1.66_jprb ! Working precision version

  ! Shortwave diffusivity factor assumes hemispheric isotropy, assumed
  ! by Zdunkowski's scheme and most others; note that for efficiency
  ! this parameter is not used in the calculation of the gamma values,
  ! but is used in the SPARTACUS solver.
  real(jprb), parameter :: SwDiffusivity = 2.00_jprb

  ! The routines in this module can be called millions of times, so
  !calling Dr Hook for each one may be a significant overhead.
  !Uncomment the following to turn Dr Hook on.
!#define DO_DR_HOOK_TWO_STREAM

contains

#ifdef FAST_EXPONENTIAL
  !---------------------------------------------------------------------
  ! Fast exponential for negative arguments: a Pade approximant that
  ! doesn't go negative for negative arguments, applied to arg/8, and
  ! the result is then squared three times
  elemental function exp_fast(arg) result(ex)
    real(jprd) :: arg, ex
    ex = 1.0_jprd / (1.0_jprd + arg*(-0.125_jprd &
         + arg*(0.0078125_jprd - 0.000325520833333333_jprd * arg)))
    ex = ex*ex
    ex = ex*ex
    ex = ex*ex
  end function exp_fast
#else
#define exp_fast exp
#endif

  !---------------------------------------------------------------------
  ! Calculate the two-stream coefficients gamma1 and gamma2 for the
  ! longwave
  subroutine calc_two_stream_gammas_lw(ng, ssa, g, &
       &                               gamma1, gamma2)

#ifdef DO_DR_HOOK_TWO_STREAM
    use yomhook, only : lhook, dr_hook
#endif

    integer, intent(in) :: ng
    ! Sngle scattering albedo and asymmetry factor:
    real(jprb), intent(in),  dimension(:) :: ssa, g
    real(jprb), intent(out), dimension(:) :: gamma1, gamma2

    real(jprb) :: factor

    integer    :: jg

#ifdef DO_DR_HOOK_TWO_STREAM
    real(jprb) :: hook_handle

    if (lhook) call dr_hook('radiation_two_stream:calc_two_stream_gammas_lw',0,hook_handle)
#endif
! Added for DWD (2020)
!NEC$ shortloop
    do jg = 1, ng
      ! Fu et al. (1997), Eq 2.9 and 2.10:
      !      gamma1(jg) = LwDiffusivity * (1.0_jprb - 0.5_jprb*ssa(jg) &
      !           &                    * (1.0_jprb + g(jg)))
      !      gamma2(jg) = LwDiffusivity * 0.5_jprb * ssa(jg) &
      !           &                    * (1.0_jprb - g(jg))
      ! Reduce number of multiplications
      factor = (LwDiffusivity * 0.5_jprb) * ssa(jg)
      gamma1(jg) = LwDiffusivity - factor*(1.0_jprb + g(jg))
      gamma2(jg) = factor * (1.0_jprb - g(jg))
    end do

#ifdef DO_DR_HOOK_TWO_STREAM
    if (lhook) call dr_hook('radiation_two_stream:calc_two_stream_gammas_lw',1,hook_handle)
#endif

  end subroutine calc_two_stream_gammas_lw


  !---------------------------------------------------------------------
  ! Calculate the two-stream coefficients gamma1-gamma4 in the
  ! shortwave
  subroutine calc_two_stream_gammas_sw(ng, mu0, ssa, g, &
       &                               gamma1, gamma2, gamma3)

#ifdef DO_DR_HOOK_TWO_STREAM
    use yomhook, only : lhook, dr_hook
#endif

    integer, intent(in) :: ng
    ! Cosine of solar zenith angle, single scattering albedo and
    ! asymmetry factor:
    real(jprb), intent(in)                :: mu0
    real(jprb), intent(in),  dimension(:) :: ssa, g
    real(jprb), intent(out), dimension(:) :: gamma1, gamma2, gamma3

    real(jprb) :: factor

    integer    :: jg

#ifdef DO_DR_HOOK_TWO_STREAM
    real(jprb) :: hook_handle

    if (lhook) call dr_hook('radiation_two_stream:calc_two_stream_gammas_sw',0,hook_handle)
#endif

    ! Zdunkowski "PIFM" (Zdunkowski et al., 1980; Contributions to
    ! Atmospheric Physics 53, 147-66)
! Added for DWD (2020)
!NEC$ shortloop
    do jg = 1, ng
      !      gamma1(jg) = 2.0_jprb  - ssa(jg) * (1.25_jprb + 0.75_jprb*g(jg))
      !      gamma2(jg) = 0.75_jprb *(ssa(jg) * (1.0_jprb - g(jg)))
      !      gamma3(jg) = 0.5_jprb  - (0.75_jprb*mu0)*g(jg)
      ! Optimized version:
      factor = 0.75_jprb*g(jg)
      gamma1(jg) = 2.0_jprb  - ssa(jg) * (1.25_jprb + factor)
      gamma2(jg) = ssa(jg) * (0.75_jprb - factor)
      gamma3(jg) = 0.5_jprb  - mu0*factor
    end do

#ifdef DO_DR_HOOK_TWO_STREAM
    if (lhook) call dr_hook('radiation_two_stream:calc_two_stream_gammas_sw',1,hook_handle)
#endif

  end subroutine calc_two_stream_gammas_sw


  !---------------------------------------------------------------------
  ! Compute the longwave reflectance and transmittance to diffuse
  ! radiation using the Meador & Weaver formulas, as well as the
  ! upward flux at the top and the downward flux at the base of the
  ! layer due to emission from within the layer assuming a linear
  ! variation of Planck function within the layer.
  subroutine calc_reflectance_transmittance_lw(ng, &
       &    od, gamma1, gamma2, planck_top, planck_bot, &
       &    reflectance, transmittance, source_up, source_dn)

#ifdef DO_DR_HOOK_TWO_STREAM
    use yomhook, only : lhook, dr_hook
#endif

    integer, intent(in) :: ng

    ! Optical depth and single scattering albedo
    real(jprb), intent(in), dimension(ng) :: od

    ! The two transfer coefficients from the two-stream
    ! differentiatial equations (computed by
    ! calc_two_stream_gammas_lw)
    real(jprb), intent(in), dimension(ng) :: gamma1, gamma2

    ! The Planck terms (functions of temperature) at the top and
    ! bottom of the layer
    real(jprb), intent(in), dimension(ng) :: planck_top, planck_bot

    ! The diffuse reflectance and transmittance, i.e. the fraction of
    ! diffuse radiation incident on a layer from either top or bottom
    ! that is reflected back or transmitted through
    real(jprb), intent(out), dimension(ng) :: reflectance, transmittance

    ! The upward emission at the top of the layer and the downward
    ! emission at its base, due to emission from within the layer
    real(jprb), intent(out), dimension(ng) :: source_up, source_dn

    real(jprd) :: k_exponent, reftrans_factor
    real(jprd) :: exponential  ! = exp(-k_exponent*od)
    real(jprd) :: exponential2 ! = exp(-2*k_exponent*od)

    real(jprd) :: coeff, coeff_up_top, coeff_up_bot, coeff_dn_top, coeff_dn_bot

    integer :: jg

#ifdef DO_DR_HOOK_TWO_STREAM
    real(jprb) :: hook_handle

    if (lhook) call dr_hook('radiation_two_stream:calc_reflectance_transmittance_lw',0,hook_handle)
#endif

! Added for DWD (2020)
!NEC$ shortloop
    do jg = 1, ng
      if (od(jg) > 1.0e-3_jprd) then
        k_exponent = sqrt(max((gamma1(jg) - gamma2(jg)) * (gamma1(jg) + gamma2(jg)), &
             1.E-12_jprd)) ! Eq 18 of Meador & Weaver (1980)
        exponential = exp_fast(-k_exponent*od(jg))
        exponential2 = exponential*exponential
        reftrans_factor = 1.0 / (k_exponent + gamma1(jg) + (k_exponent - gamma1(jg))*exponential2)
        ! Meador & Weaver (1980) Eq. 25
        reflectance(jg) = gamma2(jg) * (1.0_jprd - exponential2) * reftrans_factor
        ! Meador & Weaver (1980) Eq. 26
        transmittance(jg) = 2.0_jprd * k_exponent * exponential * reftrans_factor
      
        ! Compute upward and downward emission assuming the Planck
        ! function to vary linearly with optical depth within the layer
        ! (e.g. Wiscombe , JQSRT 1976).

        ! Stackhouse and Stephens (JAS 1991) Eqs 5 & 12
        coeff = (planck_bot(jg)-planck_top(jg)) / (od(jg)*(gamma1(jg)+gamma2(jg)))
        coeff_up_top  =  coeff + planck_top(jg)
        coeff_up_bot  =  coeff + planck_bot(jg)
        coeff_dn_top  = -coeff + planck_top(jg)
        coeff_dn_bot  = -coeff + planck_bot(jg)
        source_up(jg) =  coeff_up_top - reflectance(jg) * coeff_dn_top - transmittance(jg) * coeff_up_bot
        source_dn(jg) =  coeff_dn_bot - reflectance(jg) * coeff_up_bot - transmittance(jg) * coeff_dn_top
      else
        k_exponent = sqrt(max((gamma1(jg) - gamma2(jg)) * (gamma1(jg) + gamma2(jg)), &
             1.E-12_jprd)) ! Eq 18 of Meador & Weaver (1980)
        reflectance(jg) = gamma2(jg) * od(jg)
        transmittance(jg) = (1.0_jprb - k_exponent*od(jg)) / (1.0_jprb + od(jg)*(gamma1(jg)-k_exponent))
        source_up(jg) = (1.0_jprb - reflectance(jg) - transmittance(jg)) &
             &       * 0.5 * (planck_top(jg) + planck_bot(jg))
        source_dn(jg) = source_up(jg)
      end if
    end do
    
#ifdef DO_DR_HOOK_TWO_STREAM
    if (lhook) call dr_hook('radiation_two_stream:calc_reflectance_transmittance_lw',1,hook_handle)
#endif
  
  end subroutine calc_reflectance_transmittance_lw
  


  !---------------------------------------------------------------------
  ! As calc_reflectance_transmittance_lw but for an isothermal layer
  subroutine calc_reflectance_transmittance_isothermal_lw(ng, &
       &    od, gamma1, gamma2, planck, &
       &    reflectance, transmittance, source)

#ifdef DO_DR_HOOK_TWO_STREAM
    use yomhook, only : lhook, dr_hook
#endif

    integer, intent(in) :: ng

    ! Optical depth and single scattering albedo
    real(jprb), intent(in), dimension(ng) :: od

    ! The two transfer coefficients from the two-stream
    ! differentiatial equations (computed by
    ! calc_two_stream_gammas_lw)
    real(jprb), intent(in), dimension(ng) :: gamma1, gamma2

    ! The Planck terms (functions of temperature) constant through the
    ! layer
    real(jprb), intent(in), dimension(ng) :: planck

    ! The diffuse reflectance and transmittance, i.e. the fraction of
    ! diffuse radiation incident on a layer from either top or bottom
    ! that is reflected back or transmitted through
    real(jprb), intent(out), dimension(ng) :: reflectance, transmittance

    ! The upward emission at the top of the layer and the downward
    ! emission at its base, due to emission from within the layer
    real(jprb), intent(out), dimension(ng) :: source

    real(jprd) :: k_exponent, reftrans_factor
    real(jprd) :: exponential  ! = exp(-k_exponent*od)
    real(jprd) :: exponential2 ! = exp(-2*k_exponent*od)

    integer :: jg

#ifdef DO_DR_HOOK_TWO_STREAM
    real(jprb) :: hook_handle

    if (lhook) call dr_hook('radiation_two_stream:calc_reflectance_transmittance_isothermal_lw',0,hook_handle)
#endif

! Added for DWD (2020)
!NEC$ shortloop
    do jg = 1, ng
      k_exponent = sqrt(max((gamma1(jg) - gamma2(jg)) * (gamma1(jg) + gamma2(jg)), &
           1.E-12_jprd)) ! Eq 18 of Meador & Weaver (1980)
      exponential = exp_fast(-k_exponent*od(jg))
      exponential2 = exponential*exponential
      reftrans_factor = 1.0 / (k_exponent + gamma1(jg) + (k_exponent - gamma1(jg))*exponential2)
      ! Meador & Weaver (1980) Eq. 25
      reflectance(jg) = gamma2(jg) * (1.0_jprd - exponential2) * reftrans_factor
      ! Meador & Weaver (1980) Eq. 26
      transmittance(jg) = 2.0_jprd * k_exponent * exponential * reftrans_factor
      
      ! Emissivity of layer is one minus reflectance minus
      ! transmittance, multiply by Planck function to get emitted
      ! ousrce
      source(jg) = planck(jg) * (1.0_jprd - reflectance(jg) - transmittance(jg))
    end do
    
#ifdef DO_DR_HOOK_TWO_STREAM
    if (lhook) call dr_hook('radiation_two_stream:calc_reflectance_transmittance_isothermal_lw',1,hook_handle)
#endif
  
  end subroutine calc_reflectance_transmittance_isothermal_lw
  


  !---------------------------------------------------------------------
  ! Compute the longwave transmittance to diffuse radiation in the
  ! no-scattering case, as well as the upward flux at the top and the
  ! downward flux at the base of the layer due to emission from within
  ! the layer assuming a linear variation of Planck function within
  ! the layer.
  subroutine calc_no_scattering_transmittance_lw(ng, &
       &    od, planck_top, planck_bot, transmittance, source_up, source_dn)

#ifdef DO_DR_HOOK_TWO_STREAM
    use yomhook, only : lhook, dr_hook
#endif

    integer, intent(in) :: ng

    ! Optical depth and single scattering albedo
    real(jprb), intent(in), dimension(ng) :: od

    ! The Planck terms (functions of temperature) at the top and
    ! bottom of the layer
    real(jprb), intent(in), dimension(ng) :: planck_top, planck_bot

    ! The diffuse transmittance, i.e. the fraction of diffuse
    ! radiation incident on a layer from either top or bottom that is
    ! reflected back or transmitted through
    real(jprb), intent(out), dimension(ng) :: transmittance

    ! The upward emission at the top of the layer and the downward
    ! emission at its base, due to emission from within the layer
    real(jprb), intent(out), dimension(ng) :: source_up, source_dn

    real(jprd) :: coeff, coeff_up_top, coeff_up_bot, coeff_dn_top, coeff_dn_bot !, planck_mean

    integer :: jg

#ifdef DO_DR_HOOK_TWO_STREAM
    real(jprb) :: hook_handle

    if (lhook) call dr_hook('radiation_two_stream:calc_no_scattering_transmittance_lw',0,hook_handle)
#endif

! Added for DWD (2020)
!NEC$ shortloop
    do jg = 1, ng
      ! Compute upward and downward emission assuming the Planck
      ! function to vary linearly with optical depth within the layer
      ! (e.g. Wiscombe , JQSRT 1976).
      if (od(jg) > 1.0e-3) then
        ! Simplified from calc_reflectance_transmittance_lw above
        coeff = LwDiffusivity*od(jg)
        transmittance(jg) = exp_fast(-coeff)
        coeff = (planck_bot(jg)-planck_top(jg)) / coeff
        coeff_up_top  =  coeff + planck_top(jg)
        coeff_up_bot  =  coeff + planck_bot(jg)
        coeff_dn_top  = -coeff + planck_top(jg)
        coeff_dn_bot  = -coeff + planck_bot(jg)
        source_up(jg) =  coeff_up_top - transmittance(jg) * coeff_up_bot
        source_dn(jg) =  coeff_dn_bot - transmittance(jg) * coeff_dn_top
      else
        ! Linear limit at low optical depth
        coeff = LwDiffusivity*od(jg)
        transmittance(jg) = 1.0_jprb - coeff
        source_up(jg) = coeff * 0.5_jprb * (planck_top(jg)+planck_bot(jg))
        source_dn(jg) = source_up(jg)
      end if
    end do

    ! Method in the older IFS radiation scheme
    !    do j = 1, n
    !      coeff = od(jg) / (3.59712_jprd + od(jg))
    !      planck_mean = 0.5_jprd * (planck_top(jg) + planck_bot(jg))
    !      
    !      source_up(jg) = (1.0_jprd-transmittance(jg)) * (planck_mean + (planck_top(jg)    - planck_mean) * coeff)
    !      source_dn(jg) = (1.0_jprd-transmittance(jg)) * (planck_mean + (planck_bot(jg) - planck_mean) * coeff)
    !    end do

#ifdef DO_DR_HOOK_TWO_STREAM
    if (lhook) call dr_hook('radiation_two_stream:calc_no_scattering_transmittance_lw',1,hook_handle)
#endif

  end subroutine calc_no_scattering_transmittance_lw
   
   
  !---------------------------------------------------------------------
  ! Compute the shortwave reflectance and transmittance to diffuse
  ! radiation using the Meador & Weaver formulas, as well as the
  ! "direct" reflection and transmission, which really means the rate
  ! of transfer of direct solar radiation (into a plane perpendicular
  ! to the direct beam) into diffuse upward and downward streams at
  ! the top and bottom of the layer, respectively.  Finally,
  ! trans_dir_dir is the transmittance of the atmosphere to direct
  ! radiation with no scattering.
  subroutine calc_reflectance_transmittance_sw(ng, mu0, od, ssa, &
       &      gamma1, gamma2, gamma3, ref_diff, trans_diff, &
       &      ref_dir, trans_dir_diff, trans_dir_dir)
    
#ifdef DO_DR_HOOK_TWO_STREAM
    use yomhook, only : lhook, dr_hook
#endif

    integer, intent(in) :: ng

    ! Cosine of solar zenith angle
    real(jprb), intent(in) :: mu0

    ! Optical depth and single scattering albedo
    real(jprb), intent(in), dimension(ng) :: od, ssa

    ! The three transfer coefficients from the two-stream
    ! differentiatial equations (computed by calc_two_stream_gammas)
    real(jprb), intent(in), dimension(ng) :: gamma1, gamma2, gamma3

    ! The direct reflectance and transmittance, i.e. the fraction of
    ! incoming direct solar radiation incident at the top of a layer
    ! that is either reflected back (ref_dir) or scattered but
    ! transmitted through the layer to the base (trans_dir_diff)
    real(jprb), intent(out), dimension(ng) :: ref_dir, trans_dir_diff

    ! The diffuse reflectance and transmittance, i.e. the fraction of
    ! diffuse radiation incident on a layer from either top or bottom
    ! that is reflected back or transmitted through
    real(jprb), intent(out), dimension(ng) :: ref_diff, trans_diff

    ! Transmittance of the direct been with no scattering
    real(jprb), intent(out), dimension(ng) :: trans_dir_dir

    real(jprd) :: gamma4, alpha1, alpha2, k_exponent, reftrans_factor
    real(jprd) :: exponential0 ! = exp(-od/mu0)
    real(jprd) :: exponential  ! = exp(-k_exponent*od)
    real(jprd) :: exponential2 ! = exp(-2*k_exponent*od)
    real(jprd) :: k_mu0, k_gamma3, k_gamma4
    real(jprd) :: k_2_exponential, od_over_mu0
    integer    :: jg

    ! Local value of cosine of solar zenith angle, in case it needs to be
    ! tweaked to avoid near division by zero. This is intentionally in working
    ! precision (jprb) rather than fixing at double precision (jprd).
    real(jprb) :: mu0_local

#ifdef DO_DR_HOOK_TWO_STREAM
    real(jprb) :: hook_handle

    if (lhook) call dr_hook('radiation_two_stream:calc_reflectance_transmittance_sw',0,hook_handle)
#endif

! Added for DWD (2020)
!NEC$ shortloop
    do jg = 1, ng

        gamma4 = 1.0_jprd - gamma3(jg)
        alpha1 = gamma1(jg)*gamma4     + gamma2(jg)*gamma3(jg) ! Eq. 16
        alpha2 = gamma1(jg)*gamma3(jg) + gamma2(jg)*gamma4    ! Eq. 17

        k_exponent = sqrt(max((gamma1(jg) - gamma2(jg)) * (gamma1(jg) + gamma2(jg)), &
             &       1.0e-12_jprd)) ! Eq 18

        ! We had a rare crash where k*mu0 was within around 1e-13 of 1,
        ! leading to ref_dir and trans_dir_diff being well outside the range
        ! 0-1. The following approach is appropriate when k_exponent is double
        ! precision and mu0_local is single precision, although work is needed
        ! to make this entire routine secure in single precision.
        mu0_local = mu0
        if (abs(1.0_jprd - k_exponent*mu0) < 1000.0_jprd * epsilon(1.0_jprd)) then
          mu0_local = mu0 * (1.0_jprb - 10.0_jprb*epsilon(1.0_jprb))
        end if

        od_over_mu0 = max(od(jg) / mu0_local, 0.0_jprd)

        ! Note that if the minimum value is reduced (e.g. to 1.0e-24)
        ! then noise starts to appear as a function of solar zenith
        ! angle
        k_mu0 = k_exponent*mu0_local
        k_gamma3 = k_exponent*gamma3(jg)
        k_gamma4 = k_exponent*gamma4
        ! Check for mu0 <= 0!
        exponential0 = exp_fast(-od_over_mu0)
        trans_dir_dir(jg) = exponential0
        exponential = exp_fast(-k_exponent*od(jg))
        
        exponential2 = exponential*exponential
        k_2_exponential = 2.0_jprd * k_exponent * exponential
        
        reftrans_factor = 1.0_jprd / (k_exponent + gamma1(jg) + (k_exponent - gamma1(jg))*exponential2)
        
        ! Meador & Weaver (1980) Eq. 25
        ref_diff(jg) = gamma2(jg) * (1.0_jprd - exponential2) * reftrans_factor
        
        ! Meador & Weaver (1980) Eq. 26
        trans_diff(jg) = k_2_exponential * reftrans_factor
        
        ! Here we need mu0 even though it wasn't in Meador and Weaver
        ! because we are assuming the incoming direct flux is defined
        ! to be the flux into a plane perpendicular to the direction of
        ! the sun, not into a horizontal plane
        reftrans_factor = mu0_local * ssa(jg) * reftrans_factor / (1.0_jprd - k_mu0*k_mu0)
        
        ! Meador & Weaver (1980) Eq. 14, multiplying top & bottom by
        ! exp(-k_exponent*od) in case of very high optical depths
        ref_dir(jg) = reftrans_factor &
             &  * ( (1.0_jprd - k_mu0) * (alpha2 + k_gamma3) &
             &     -(1.0_jprd + k_mu0) * (alpha2 - k_gamma3)*exponential2 &
             &     -k_2_exponential*(gamma3(jg) - alpha2*mu0_local)*exponential0)
        
        ! Meador & Weaver (1980) Eq. 15, multiplying top & bottom by
        ! exp(-k_exponent*od), minus the 1*exp(-od/mu0) term representing direct
        ! unscattered transmittance.  
        trans_dir_diff(jg) = reftrans_factor * ( k_2_exponential*(gamma4 + alpha1*mu0_local) &
            & - exponential0 &
            & * ( (1.0_jprd + k_mu0) * (alpha1 + k_gamma4) &
            &    -(1.0_jprd - k_mu0) * (alpha1 - k_gamma4) * exponential2) )

        ! Final check that ref_dir + trans_dir_diff <= 1
        ref_dir(jg) = max(0.0_jprb, min(ref_dir(jg), 1.0_jprb))
        trans_dir_diff(jg) = max(0.0_jprb, min(trans_dir_diff(jg), 1.0_jprb-ref_dir(jg)))

    end do
    
#ifdef DO_DR_HOOK_TWO_STREAM
    if (lhook) call dr_hook('radiation_two_stream:calc_reflectance_transmittance_sw',1,hook_handle)
#endif
 
  end subroutine calc_reflectance_transmittance_sw
  
  !---------------------------------------------------------------------
  ! As above but with height as a vertical coordinate rather than
  ! optical depth
  subroutine calc_reflectance_transmittance_z_sw(ng, mu0, depth, &
       &      gamma0, gamma1, gamma2, gamma3, gamma4, &
       &      ref_diff, trans_diff, ref_dir, trans_dir_diff, trans_dir_dir)
    
#ifdef DO_DR_HOOK_TWO_STREAM
    use yomhook, only : lhook, dr_hook
#endif

    integer, intent(in) :: ng

    ! Cosine of solar zenith angle
    real(jprb), intent(in) :: mu0

    ! Layer depth
    real(jprb), intent(in) :: depth

    ! The four transfer coefficients from the two-stream
    ! differentiatial equations
    real(jprb), intent(in), dimension(ng) :: gamma1, gamma2, gamma3, gamma4

    ! An additional coefficient for direct unscattered flux "Fdir"
    ! such that dFdir/dz = -gamma0*Fdir
    real(jprb), intent(in), dimension(ng) :: gamma0

    ! The direct reflectance and transmittance, i.e. the fraction of
    ! incoming direct solar radiation incident at the top of a layer
    ! that is either reflected back (ref_dir) or scattered but
    ! transmitted through the layer to the base (trans_dir_diff)
    real(jprb), intent(out), dimension(ng) :: ref_dir, trans_dir_diff

    ! The diffuse reflectance and transmittance, i.e. the fraction of
    ! diffuse radiation incident on a layer from either top or bottom
    ! that is reflected back or transmitted through
    real(jprb), intent(out), dimension(ng) :: ref_diff, trans_diff

    ! Transmittance of the direct been with no scattering
    real(jprb), intent(out), dimension(ng) :: trans_dir_dir

    real(jprd) :: alpha1, alpha2, k_exponent, reftrans_factor
    real(jprd) :: exponential0 ! = exp(-od/mu0)
    real(jprd) :: exponential  ! = exp(-k_exponent*od)
    real(jprd) :: exponential2 ! = exp(-2*k_exponent*od)
    real(jprd) :: k_mu0, k_gamma3, k_gamma4
    real(jprd) :: k_2_exponential, od_over_mu0
    integer    :: jg

#ifdef DO_DR_HOOK_TWO_STREAM
    real(jprb) :: hook_handle

    if (lhook) call dr_hook('radiation_two_stream:calc_reflectance_transmittance_z_sw',0,hook_handle)
#endif

! Added for DWD (2020)
!NEC$ shortloop
    do jg = 1, ng
      od_over_mu0 = max(gamma0(jg) * depth, 0.0_jprd)
      ! In the IFS this appears to be faster without testing the value
      ! of od_over_mu0:
      if (.true.) then
!      if (od_over_mu0 > 1.0e-6_jprd) then
        alpha1 = gamma1(jg)*gamma4(jg) + gamma2(jg)*gamma3(jg) ! Eq. 16
        alpha2 = gamma1(jg)*gamma3(jg) + gamma2(jg)*gamma4(jg) ! Eq. 17
        
        ! Note that if the minimum value is reduced (e.g. to 1.0e-24)
        ! then noise starts to appear as a function of solar zenith
        ! angle
        k_exponent = sqrt(max((gamma1(jg) - gamma2(jg)) * (gamma1(jg) + gamma2(jg)), &
             &       1.0e-12_jprd)) ! Eq 18
        k_mu0 = k_exponent*mu0
        k_gamma3 = k_exponent*gamma3(jg)
        k_gamma4 = k_exponent*gamma4(jg)
        ! Check for mu0 <= 0!
        exponential0 = exp_fast(-od_over_mu0)
        trans_dir_dir(jg) = exponential0
        exponential = exp_fast(-k_exponent*depth)
        
        exponential2 = exponential*exponential
        k_2_exponential = 2.0_jprd * k_exponent * exponential
        
        if (k_mu0 == 1.0_jprd) then
          k_mu0 = 1.0_jprd - 10.0_jprd*epsilon(1.0_jprd)
        end if
        
        reftrans_factor = 1.0_jprd / (k_exponent + gamma1(jg) + (k_exponent - gamma1(jg))*exponential2)
        
        ! Meador & Weaver (1980) Eq. 25
        ref_diff(jg) = gamma2(jg) * (1.0_jprd - exponential2) * reftrans_factor
        
        ! Meador & Weaver (1980) Eq. 26
        trans_diff(jg) = k_2_exponential * reftrans_factor
        
        ! Here we need mu0 even though it wasn't in Meador and Weaver
        ! because we are assuming the incoming direct flux is defined
        ! to be the flux into a plane perpendicular to the direction of
        ! the sun, not into a horizontal plane
        reftrans_factor = mu0 * reftrans_factor / (1.0_jprd - k_mu0*k_mu0)
        
        ! Meador & Weaver (1980) Eq. 14, multiplying top & bottom by
        ! exp(-k_exponent*od) in case of very high optical depths
        ref_dir(jg) = reftrans_factor &
             &  * ( (1.0_jprd - k_mu0) * (alpha2 + k_gamma3) &
             &     -(1.0_jprd + k_mu0) * (alpha2 - k_gamma3)*exponential2 &
             &     -k_2_exponential*(gamma3(jg) - alpha2*mu0)*exponential0)
        
        ! Meador & Weaver (1980) Eq. 15, multiplying top & bottom by
        ! exp(-k_exponent*od), minus the 1*exp(-od/mu0) term representing direct
        ! unscattered transmittance.  
        trans_dir_diff(jg) = reftrans_factor * ( k_2_exponential*(gamma4(jg) + alpha1*mu0) &
            & - exponential0 &
            & * ( (1.0_jprd + k_mu0) * (alpha1 + k_gamma4) &
            &    -(1.0_jprd - k_mu0) * (alpha1 - k_gamma4) * exponential2) )

      else
        ! Low optical-depth limit; see equations 19, 20 and 27 from
        ! Meador & Weaver (1980)
        trans_diff(jg)     = 1.0_jprb - gamma1(jg) * depth
        ref_diff(jg)       = gamma2(jg) * depth
        trans_dir_diff(jg) = (1.0_jprb - gamma3(jg)) * depth
        ref_dir(jg)        = gamma3(jg) * depth
        trans_dir_dir(jg)  = 1.0_jprd - od_over_mu0
      end if
    end do
    
#ifdef DO_DR_HOOK_TWO_STREAM
    if (lhook) call dr_hook('radiation_two_stream:calc_reflectance_transmittance_z_sw',1,hook_handle)
#endif
 
  end subroutine calc_reflectance_transmittance_z_sw
  

  !---------------------------------------------------------------------
  ! Compute the fraction of shortwave transmitted diffuse radiation
  ! that is scattered during its transmission, used to compute
  ! entrapment in SPARTACUS
  subroutine calc_frac_scattered_diffuse_sw(ng, od, &
       &      gamma1, gamma2, frac_scat_diffuse)
    
#ifdef DO_DR_HOOK_TWO_STREAM
    use yomhook, only : lhook, dr_hook
#endif

    integer, intent(in) :: ng

    ! Optical depth
    real(jprb), intent(in), dimension(ng) :: od

    ! The first two transfer coefficients from the two-stream
    ! differentiatial equations (computed by calc_two_stream_gammas)
    real(jprb), intent(in), dimension(ng) :: gamma1, gamma2

    ! The fraction of shortwave transmitted diffuse radiation that is
    ! scattered during its transmission
    real(jprb), intent(out), dimension(ng) :: frac_scat_diffuse

    real(jprd) :: k_exponent, reftrans_factor
    real(jprd) :: exponential  ! = exp(-k_exponent*od)
    real(jprd) :: exponential2 ! = exp(-2*k_exponent*od)
    real(jprd) :: k_2_exponential
    integer    :: jg

#ifdef DO_DR_HOOK_TWO_STREAM
    real(jprb) :: hook_handle

    if (lhook) call dr_hook('radiation_two_stream:calc_frac_scattered_diffuse_sw',0,hook_handle)
#endif

! Added for DWD (2020)
!NEC$ shortloop
    do jg = 1, ng
      ! Note that if the minimum value is reduced (e.g. to 1.0e-24)
      ! then noise starts to appear as a function of solar zenith
      ! angle
      k_exponent = sqrt(max((gamma1(jg) - gamma2(jg)) * (gamma1(jg) + gamma2(jg)), &
           &       1.0e-12_jprd)) ! Eq 18
      exponential = exp_fast(-k_exponent*od(jg))
      exponential2 = exponential*exponential
      k_2_exponential = 2.0_jprd * k_exponent * exponential
        
      reftrans_factor = 1.0_jprd / (k_exponent + gamma1(jg) + (k_exponent - gamma1(jg))*exponential2)
        
      ! Meador & Weaver (1980) Eq. 26.
      ! Until 1.1.8, used LwDiffusivity instead of 2.0, although the
      ! effect is very small
      !      frac_scat_diffuse(jg) = 1.0_jprb - min(1.0_jprb,exp_fast(-LwDiffusivity*od(jg)) &
      !           &  / max(1.0e-8_jprb, k_2_exponential * reftrans_factor))
      frac_scat_diffuse(jg) = 1.0_jprb &
           &  - min(1.0_jprb,exp_fast(-2.0_jprb*od(jg)) &
           &  / max(1.0e-8_jprb, k_2_exponential * reftrans_factor))
    end do
    
#ifdef DO_DR_HOOK_TWO_STREAM
    if (lhook) call dr_hook('radiation_two_stream:calc_frac_scattered_diffuse_sw',1,hook_handle)
#endif
 
  end subroutine calc_frac_scattered_diffuse_sw

end module radiation_two_stream

! Contains the alpale subroutine, as well as the old content from alpale.h
!$gpum horizontal klon

MODULE alpale_mod
  IMPLICIT NONE; PRIVATE
  PUBLIC :: alpale

CONTAINS

  SUBROUTINE alpale(debut, itap, dtime, paprs, omega, t_seri, &
          alp_offset, it_wape_prescr, wape_prescr, fip_prescr, &
          ale_bl_prescr, alp_bl_prescr, &
          wake_pe, wake_fip, &
          Ale_bl, Ale_bl_trig, Alp_bl, &
          Ale, Alp, Ale_wake, Alp_wake)

    ! **************************************************************
    ! *
    ! ALPALE                                                       *
    ! *
    ! *
    ! written by   : Jean-Yves Grandpeix, 12/05/2016              *
    ! modified by :                                               *
    ! **************************************************************

    USE dimphy
    use conf_phys_m, only: iflag_coupl, iflag_trig_bl, iflag_wake
    USE ioipsl_getin_p_mod, ONLY: getin_p
    USE print_control_mod, ONLY: mydebug => debug, lunout, prt_level
    USE phys_local_var_mod, ONLY: zw2       ! Variables internes non sauvegardees de la physique
    USE yoethf_mod_h
    USE yomcst_mod_h

    IMPLICIT NONE

    !================================================================
    ! Auteur(s)   : Jean-Yves Grandpeix, 12/05/2016
    ! Objet : Sums up all contributions to Ale and Alp
    !================================================================

    ! Input arguments
    !----------------
    LOGICAL, INTENT(IN) :: debut
    INTEGER, INTENT(IN) :: itap
    REAL, INTENT(IN) :: dtime
    INTEGER, INTENT(IN) :: it_wape_prescr
    REAL, INTENT(IN) :: wape_prescr, fip_prescr
    REAL, INTENT(IN) :: Ale_bl_prescr, Alp_bl_prescr
    REAL, INTENT(IN) :: alp_offset
    REAL, DIMENSION(klon, klev + 1), INTENT(IN) :: paprs
    REAL, DIMENSION(klon, klev), INTENT(IN) :: t_seri
    REAL, DIMENSION(klon, klev), INTENT(IN) :: omega
    REAL, DIMENSION(klon), INTENT(IN) :: wake_pe, wake_fip
    REAL, DIMENSION(klon), INTENT(IN) :: Ale_bl, Ale_bl_trig, Alp_bl


    ! Output arguments
    !----------------
    REAL, DIMENSION(klon), INTENT(OUT) :: Ale, Alp
    REAL, DIMENSION(klon), INTENT(OUT) :: Ale_wake, Alp_wake

    ! Local variables
    !----------------
    INTEGER :: i, k
    REAL, DIMENSION(klon) :: www
    REAL, PARAMETER :: ale_max = 1000.
    REAL, PARAMETER :: alp_max = 2.
    CHARACTER (LEN=20), PARAMETER :: modname = 'alpale'
    CHARACTER (LEN=80) :: abort_message

    ! Calcul de l'energie disponible ALE (J/kg) et de la puissance
    ! disponible ALP (W/m2) pour le soulevement des particules dans
    ! le modele convectif

    DO i = 1, klon
      ALE(i) = 0.
      ALP(i) = 0.
    enddo

    !calcul de ale_wake et alp_wake
    IF (iflag_wake>=1) THEN
      IF (itap <= it_wape_prescr) THEN
        DO i = 1, klon
          ale_wake(i) = wape_prescr
          alp_wake(i) = fip_prescr
        enddo
      else
        DO i = 1, klon
          !jyg  ALE=WAPE au lieu de ALE = 1/2 Cstar**2
          !cc           ale_wake(i) = 0.5*wake_cstar(i)**2
          ale_wake(i) = wake_pe(i)
          alp_wake(i) = wake_fip(i)
        enddo
      endif
    else
      DO i = 1, klon
        ale_wake(i) = 0.
        alp_wake(i) = 0.
      enddo
    endif
    !combinaison avec ale et alp de couche limite: constantes si pas
    !de couplage, valeurs calculees dans le thermique sinon
    IF (iflag_coupl==0) THEN
      IF (debut.AND.prt_level>9) &
              WRITE(lunout, *)'ALE et ALP imposes'
      DO i = 1, klon
        !on ne couple que ale
        !           ALE(i) = max(ale_wake(i),Ale_bl(i))
        ALE(i) = max(ale_wake(i), ale_bl_prescr)
        !on ne couple que alp
        !           ALP(i) = alp_wake(i) + Alp_bl(i)
        ALP(i) = alp_wake(i) + alp_bl_prescr
      enddo
    else
      IF(prt_level>9)WRITE(lunout, *)'ALE et ALP couples au thermique'
      !         do i = 1,klon
      !             ALE(i) = max(ale_wake(i),Ale_bl(i))
      ! avant        ALP(i) = alp_wake(i) + Alp_bl(i)
      !             ALP(i) = alp_wake(i) + Alp_bl(i) + alp_offset ! modif sb
      !         WRITE(20,*)'ALE',ALE(i),Ale_bl(i),ale_wake(i)
      !         WRITE(21,*)'ALP',ALP(i),Alp_bl(i),alp_wake(i)
      !         enddo

      ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      ! Modif FH 2010/04/27. Sans doute temporaire.
      ! Deux options pour le alp_offset : constant si >?? 0 ou
      ! proportionnel ??a w si <0
      ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      ! Estimation d'une vitesse verticale effective pour ALP
      IF (1==0) THEN
        www(1:klon) = 0.
        DO k = 2, klev - 1
          DO i = 1, klon
            www(i) = max(www(i), -omega(i, k) * RD * t_seri(i, k) &
                    / (RG * paprs(i, k)) * zw2(i, k) * zw2(i, k))
            ! if (paprs(i,k)>pbase(i)) THEN
            ! calcul approche de la vitesse verticale en m/s
            !  www(i)=max(www(i),-omega(i,k)*RD*temp(i,k)/(RG*paprs(i,k))
            !             endif
            !   Le 0.1 est en gros H / ps = 1e4 / 1e5
          enddo
        enddo
        DO i = 1, klon
          IF (www(i)>0. .AND. ale_bl(i)>0.) www(i) = www(i) / ale_bl(i)
        enddo
      ENDIF

      DO i = 1, klon
        ALE(i) = max(ale_wake(i), Ale_bl(i))
        !cc nrlmd le 10/04/2012----------Stochastic triggering------------
        IF (iflag_trig_bl>=1) THEN
          ALE(i) = max(ale_wake(i), Ale_bl_trig(i))
        endif
        !cc fin nrlmd le 10/04/2012
        IF (alp_offset>=0.) THEN
          ALP(i) = alp_wake(i) + Alp_bl(i) + alp_offset ! modif sb
        else
          abort_message = 'Ne pas passer la car www non calcule'
          CALL abort_physic (modname, abort_message, 1)

          ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          !                                _                  _
          ! Ajout d'une composante 3 * A * w w'2 a w'3 avec
          ! w=www : w max sous pbase ou A est la fraction
          ! couverte par les ascendances w' on utilise le fait
          ! que A * w'3 = ALP et donc A * w'2 ~ ALP / sqrt(ALE)
          ! (on ajoute 0.1 pour les singularites)
          ALP(i) = alp_wake(i) * (1. + 3. * www(i) / (sqrt(ale_wake(i)) + 0.1)) &
                  + alp_bl(i) * (1. + 3. * www(i) / (sqrt(ale_bl(i)) + 0.1))
          !    ALP(i)=alp_wake(i)+Alp_bl(i)+alp_offset*min(omega(i,6),0.)
          !             if (alp(i)<0.) THEN
          !                PRINT*,'ALP ',alp(i),alp_wake(i) &
          !                     ,Alp_bl(i),alp_offset*min(omega(i,6),0.)
          !             endif
        endif
      enddo
      ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    endif
    DO i = 1, klon
      IF (alp(i)>alp_max) THEN
        IF(prt_level>9)WRITE(lunout, *)                             &
                'WARNING SUPER ALP (seuil=', alp_max, &
                '): i, alp, alp_wake,ale', i, alp(i), alp_wake(i), ale(i)
        alp(i) = alp_max
      endif
      IF (ale(i)>ale_max) THEN
        IF(prt_level>9)WRITE(lunout, *)                             &
                'WARNING SUPER ALE (seuil=', ale_max, &
                '): i, alp, alp_wake,ale', i, ale(i), ale_wake(i), alp(i)
        ale(i) = ale_max
      endif
    enddo

    !fin calcul ale et alp
    !=======================================================================

    RETURN
  END SUBROUTINE alpale

END MODULE alpale_mod

!*******************************************************************************
SUBROUTINE RRTM_TAUMOL8 (KIDIA,KFDIA,KLEV,P_TAU,P_WX,&
 & P_TAUAERL,P_FAC00,P_FAC01,P_FAC10,P_FAC11,P_FORFAC,P_FORFRAC,K_INDFOR,K_JP,K_JT,K_JT1,&
 & P_COLH2O,P_COLO3,P_COLN2O,P_COLCO2,P_COLDRY,K_LAYTROP,P_SELFFAC,P_SELFFRAC,K_INDSELF,PFRAC, &
 & PMINORFRAC,KINDMINOR)  

!     BAND 8:  1080-1180 cm-1 (low (i.e.>~300mb) - H2O; high - O3)

!     AUTHOR.
!     -------
!      JJMorcrette, ECMWF

!     MODIFICATIONS.
!     --------------
!      M.Hamrud      01-Oct-2003 CY28 Cleaning
!      NEC           25-Oct-2007 Optimisations
!      JJMorcrette 20110613 flexible number of g-points
!      ABozzo 201306 updated to rrtmg v4.85
!     band 8:  1080-1180 cm-1 (low key - h2o; low minor - co2,o3,n2o)
!                             (high key - o3; high minor - co2, n2o)
! ---------------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK, DR_HOOK, JPHOOK

USE PARRRTM  , ONLY : JPBAND ,JPXSEC
USE YOERRTM  , ONLY : JPGPT  ,NG8   ,NGS7
USE YOERRTWN , ONLY : NSPA   ,NSPB
USE YOERRTA8 , ONLY : ABSA   ,ABSB   ,FRACREFA, FRACREFB,SELFREF,KA_MCO2 ,KB_MCO2  ,&
 & KA_MN2O , KB_MN2O,KA_MO3,CFC12  ,CFC22ADJ,FORREF  
USE YOERRTRF, ONLY : CHI_MLS

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KIDIA
INTEGER(KIND=JPIM),INTENT(IN)    :: KFDIA
INTEGER(KIND=JPIM),INTENT(IN)    :: KLEV 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P_TAU(KIDIA:KFDIA,JPGPT,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: P_WX(KIDIA:KFDIA,JPXSEC,KLEV) ! Amount of trace gases
REAL(KIND=JPRB)   ,INTENT(IN)    :: P_TAUAERL(KIDIA:KFDIA,KLEV,JPBAND) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: P_FAC00(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: P_FAC01(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: P_FAC10(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: P_FAC11(KIDIA:KFDIA,KLEV) 
INTEGER(KIND=JPIM),INTENT(IN)    :: K_JP(KIDIA:KFDIA,KLEV) 
INTEGER(KIND=JPIM),INTENT(IN)    :: K_JT(KIDIA:KFDIA,KLEV) 
INTEGER(KIND=JPIM),INTENT(IN)    :: K_JT1(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: P_COLH2O(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: P_COLO3(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: P_COLN2O(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: P_COLCO2(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: P_COLDRY(KIDIA:KFDIA,KLEV) 
INTEGER(KIND=JPIM),INTENT(IN)    :: K_LAYTROP(KIDIA:KFDIA) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: P_SELFFAC(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: P_SELFFRAC(KIDIA:KFDIA,KLEV) 
INTEGER(KIND=JPIM),INTENT(IN)    :: K_INDSELF(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRAC(KIDIA:KFDIA,JPGPT,KLEV) 

INTEGER(KIND=JPIM),INTENT(IN)   :: K_INDFOR(KIDIA:KFDIA,KLEV)
REAL(KIND=JPRB)   ,INTENT(IN)   :: P_FORFRAC(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)   :: P_FORFAC(KIDIA:KFDIA,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)   :: PMINORFRAC(KIDIA:KFDIA,KLEV)
INTEGER(KIND=JPIM),INTENT(IN)   :: KINDMINOR(KIDIA:KFDIA,KLEV)

! ---------------------------------------------------------------------------

INTEGER(KIND=JPIM) :: IND0(KLEV),IND1(KLEV),INDS(KLEV),INDF(KLEV),INDM(KLEV)

INTEGER(KIND=JPIM) :: IG, JLAY
INTEGER(KIND=JPIM) :: JLON

REAL(KIND=JPRB) :: ZCHI_CO2, ZRATCO2, ZADJFAC, ZADJCOLCO2(KIDIA:KFDIA,KLEV)
REAL(KIND=JPRB) :: ZTAUFOR,ZTAUSELF, ZABSO3, ZABSCO2, ZABSN2O
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE

! Minor gas mapping level:
!     lower - co2, p = 1053.63 mb, t = 294.2 k
!     lower - o3,  p = 317.348 mb, t = 240.77 k
!     lower - n2o, p = 706.2720 mb, t= 278.94 k
!     lower - cfc12,cfc11
!     upper - co2, p = 35.1632 mb, t = 223.28 k
!     upper - n2o, p = 8.716e-2 mb, t = 226.03 k

! Compute the optical depth by interpolating in ln(pressure) and 
! temperature, and appropriate species.  Below laytrop, the water vapor 
! self-continuum and foreign continuum is interpolated (in temperature) 
! separately.

ASSOCIATE(NFLEVG=>KLEV)
IF (LHOOK) CALL DR_HOOK('RRTM_TAUMOL8',0,ZHOOK_HANDLE)

DO JLAY = 1, KLEV
  DO JLON = KIDIA, KFDIA
    IF (JLAY <= K_LAYTROP(JLON)) THEN
! In atmospheres where the amount of CO2 is too great to be considered
! a minor species, adjust the column amount of CO2 by an empirical factor 
! to obtain the proper contribution.
      ZCHI_CO2 = P_COLCO2(JLON,JLAY)/P_COLDRY(JLON,JLAY)
      ZRATCO2 = 1.E20_JPRB*ZCHI_CO2/CHI_MLS(2,K_JP(JLON,JLAY)+1)
      IF (ZRATCO2 > 3.0_JPRB) THEN
         ZADJFAC = 2.0_JPRB+(ZRATCO2-2.0_JPRB)**0.65_JPRB
         ZADJCOLCO2(JLON,JLAY) = ZADJFAC*CHI_MLS(2,K_JP(JLON,JLAY)+1)*P_COLDRY(JLON,JLAY)*1.E-20_JPRB
      ELSE
         ZADJCOLCO2(JLON,JLAY) = P_COLCO2(JLON,JLAY)
      ENDIF

    
      IND0(JLAY) = ((K_JP(JLON,JLAY)-1)*5+(K_JT(JLON,JLAY)-1))*NSPA(8) + 1
      IND1(JLAY) = (K_JP(JLON,JLAY)*5+(K_JT1(JLON,JLAY)-1))*NSPA(8) + 1
      INDS(JLAY) = K_INDSELF(JLON,JLAY)
      INDF(JLAY) = K_INDFOR(JLON,JLAY)
      INDM(JLAY) = KINDMINOR(JLON,JLAY)
      
!-- DS_000515
!CDIR UNROLL=NG8
      DO IG = 1, NG8
!-- DS_000515
         ZTAUSELF = P_SELFFAC(JLON,JLAY)* (SELFREF(INDS(JLAY),IG) + P_SELFFRAC(JLON,JLAY) * &
           &      (SELFREF(INDS(JLAY)+1,IG) - SELFREF(INDS(JLAY),IG)))
         ZTAUFOR = P_FORFAC(JLON,JLAY) * (FORREF(INDF(JLAY),IG) + P_FORFRAC(JLON,JLAY) * &
           &      (FORREF(INDF(JLAY)+1,IG) - FORREF(INDF(JLAY),IG))) 
         ZABSCO2 =  (KA_MCO2(INDM(JLAY),IG) + PMINORFRAC(JLON,JLAY) * &
           &      (KA_MCO2(INDM(JLAY)+1,IG) - KA_MCO2(INDM(JLAY),IG)))
         ZABSO3 =  (KA_MO3(INDM(JLAY),IG) + PMINORFRAC(JLON,JLAY) * &
           &      (KA_MO3(INDM(JLAY)+1,IG) - KA_MO3(INDM(JLAY),IG)))
         ZABSN2O =  (KA_MN2O(INDM(JLAY),IG) + PMINORFRAC(JLON,JLAY) * &
           &      (KA_MN2O(INDM(JLAY)+1,IG) - KA_MN2O(INDM(JLAY),IG)))

        P_TAU(JLON,NGS7+IG,JLAY) = P_COLH2O(JLON,JLAY) *&
         & (P_FAC00(JLON,JLAY) * ABSA(IND0(JLAY)  ,IG) +&
         & P_FAC10(JLON,JLAY) * ABSA(IND0(JLAY)+1,IG) +&
         & P_FAC01(JLON,JLAY) * ABSA(IND1(JLAY)  ,IG) +&
         & P_FAC11(JLON,JLAY) * ABSA(IND1(JLAY)+1,IG)) &
         & + ZTAUSELF + ZTAUFOR &
         & + ZADJCOLCO2(JLON,JLAY)*ZABSCO2 &
         & + P_COLO3(JLON,JLAY)*ZABSO3 &
         & + P_COLN2O(JLON,JLAY)*ZABSN2O &
         & + P_WX(JLON,3,JLAY) * CFC12(IG)&
         & + P_WX(JLON,4,JLAY) * CFC22ADJ(IG)&
         & + P_TAUAERL(JLON,JLAY,8)  
        PFRAC(JLON,NGS7+IG,JLAY) = FRACREFA(IG)
      ENDDO
    ENDIF

    IF (JLAY > K_LAYTROP(JLON)) THEN

! In atmospheres where the amount of CO2 is too great to be considered
! a minor species, adjust the column amount of CO2 by an empirical factor 
! to obtain the proper contribution.
      ZCHI_CO2 = P_COLCO2(JLON,JLAY)/P_COLDRY(JLON,JLAY)
      ZRATCO2 = 1.E20_JPRB*ZCHI_CO2/CHI_MLS(2,K_JP(JLON,JLAY)+1)
      IF (ZRATCO2 > 3.0_JPRB) THEN
         ZADJFAC = 2.0_JPRB+(ZRATCO2-2.0_JPRB)**0.65_JPRB
         ZADJCOLCO2(JLON,JLAY) = ZADJFAC*CHI_MLS(2,K_JP(JLON,JLAY)+1)*P_COLDRY(JLON,JLAY)*1.E-20_JPRB
      ELSE
         ZADJCOLCO2(JLON,JLAY) = P_COLCO2(JLON,JLAY)
      ENDIF


      IND0(JLAY) = ((K_JP(JLON,JLAY)-13)*5+(K_JT(JLON,JLAY)-1))*NSPB(8) + 1
      IND1(JLAY) = ((K_JP(JLON,JLAY)-12)*5+(K_JT1(JLON,JLAY)-1))*NSPB(8) + 1
      INDM(JLAY) = KINDMINOR(JLON,JLAY)
!-- JJM_000517
!CDIR UNROLL=NG8
      DO IG = 1, NG8
!-- JJM_000517
        ZABSCO2 =  (KB_MCO2(INDM(JLAY),IG) + PMINORFRAC(JLON,JLAY) * &
         &        (KB_MCO2(INDM(JLAY)+1,IG) - KB_MCO2(INDM(JLAY),IG)))
        ZABSN2O =  (KB_MN2O(INDM(JLAY),IG) + PMINORFRAC(JLON,JLAY) * &
         &        (KB_MN2O(INDM(JLAY)+1,IG) - KB_MN2O(INDM(JLAY),IG)))
        P_TAU(JLON,NGS7+IG,JLAY) = P_COLO3(JLON,JLAY) *&
         & (P_FAC00(JLON,JLAY) * ABSB(IND0(JLAY)  ,IG) +&
         & P_FAC10(JLON,JLAY) * ABSB(IND0(JLAY)+1,IG) +&
         & P_FAC01(JLON,JLAY) * ABSB(IND1(JLAY)  ,IG) +&
         & P_FAC11(JLON,JLAY) * ABSB(IND1(JLAY)+1,IG)) &
         & + ZADJCOLCO2(JLON,JLAY)*ZABSCO2 &
         & + P_COLN2O(JLON,JLAY)*ZABSN2O &
         & + P_WX(JLON,3,JLAY) * CFC12(IG)&
         & + P_WX(JLON,4,JLAY) * CFC22ADJ(IG)&
         & + P_TAUAERL(JLON,JLAY,8)  
        PFRAC(JLON,NGS7+IG,JLAY) = FRACREFB(IG)
      ENDDO
    ENDIF
  ENDDO
ENDDO

IF (LHOOK) CALL DR_HOOK('RRTM_TAUMOL8',1,ZHOOK_HANDLE)

END ASSOCIATE
END SUBROUTINE RRTM_TAUMOL8

!
MODULE surf_land_orchidee_noz0h_mod
#ifdef ORCHIDEE_NOZ0H
!
! This module controles the interface towards the model ORCHIDEE.
!
! Compatibility with ORCHIDIEE :
! This module is compiled only if CPP key ORCHIDEE_NOZ0H is defined.
! This version can be used with ORCHIDEE/trunk revision 2961-3525.
! It is possible to use this interface with later versions of ORCHIDEE/trunk than 3525 but 
! in that case the option ROUGH_DYN=y in ORCHIDEE should not be set. 
! This interface can also be used with ORCHIDEE/trunk revision 1078-2960 if changing 
! coszang=yrmu0 into sinang=yrmu0 at 2 places later below in this module. 
!
! Subroutines in this module : surf_land_orchidee
!                              Init_orchidee_index
!                              Get_orchidee_communicator
!                              Init_neighbours

  USE dimphy
#ifdef CPP_VEGET
  USE intersurf     ! module d'ORCHIDEE
#endif
  USE cpl_mod,      ONLY : cpl_send_land_fields
  USE surface_data, ONLY : type_ocean
  USE geometry_mod, ONLY : dx, dy
  USE mod_grid_phy_lmdz
  USE mod_phys_lmdz_para, mpi_root_rank=>mpi_master

  IMPLICIT NONE

  PRIVATE
  PUBLIC  :: surf_land_orchidee

CONTAINS
!
!****************************************************************************************
!  
  SUBROUTINE surf_land_orchidee(itime, dtime, date0, knon, &
       knindex, rlon, rlat, yrmu0, pctsrf, &
       debut, lafin, &
       plev,  u1_lay, v1_lay, gustiness, temp_air, spechum, epot_air, ccanopy, & 
       tq_cdrag, petAcoef, peqAcoef, petBcoef, peqBcoef, &
       precip_rain, precip_snow, lwdown, swnet, swdown, &
       ps, q2m, t2m, &
       evap, fluxsens, fluxlat, &              
       tsol_rad, tsurf_new, alb1_new, alb2_new, &
       emis_new, z0_new, z0h_new, qsurf, &
       veget, lai, height)

    USE mod_surf_para
    USE mod_synchro_omp
    USE carbon_cycle_mod, ONLY : carbon_cycle_cpl
    USE indice_sol_mod
    USE print_control_mod, ONLY: lunout
    USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
#ifdef CPP_VEGET
    USE time_phylmdz_mod, ONLY: itau_phy 
#endif
    USE yomcst_mod_h
    USE compbl_mod_h
    USE dimpft_mod_h
!    
! Cette routine sert d'interface entre le modele atmospherique et le 
! modele de sol continental. Appel a sechiba
!
! L. Fairhead 02/2000
!
! input:
!   itime        numero du pas de temps
!   dtime        pas de temps de la physique (en s)
!   nisurf       index de la surface a traiter (1 = sol continental)
!   knon         nombre de points de la surface a traiter
!   knindex      index des points de la surface a traiter
!   rlon         longitudes de la grille entiere
!   rlat         latitudes de la grille entiere
!   pctsrf       tableau des fractions de surface de chaque maille
!   debut        logical: 1er appel a la physique (lire les restart)
!   lafin        logical: dernier appel a la physique (ecrire les restart)
!                     (si false calcul simplifie des fluxs sur les continents)
!   plev         hauteur de la premiere couche (Pa)      
!   u1_lay       vitesse u 1ere couche
!   v1_lay       vitesse v 1ere couche
!   temp_air     temperature de l'air 1ere couche
!   spechum      humidite specifique 1ere couche
!   epot_air     temp pot de l'air
!   ccanopy      concentration CO2 canopee, correspond au co2_send de 
!                carbon_cycle_mod ou valeur constant co2_ppm
!   tq_cdrag     cdrag
!   petAcoef     coeff. A de la resolution de la CL pour t
!   peqAcoef     coeff. A de la resolution de la CL pour q
!   petBcoef     coeff. B de la resolution de la CL pour t
!   peqBcoef     coeff. B de la resolution de la CL pour q
!   precip_rain  precipitation liquide
!   precip_snow  precipitation solide
!   lwdown       flux IR descendant a la surface
!   swnet        flux solaire net
!   swdown       flux solaire entrant a la surface
!   ps           pression au sol
!   radsol       rayonnement net aus sol (LW + SW)
!   
!
! output:
!   evap         evaporation totale
!   fluxsens     flux de chaleur sensible
!   fluxlat      flux de chaleur latente
!   tsol_rad     
!   tsurf_new    temperature au sol
!   alb1_new     albedo in visible SW interval
!   alb2_new     albedo in near IR interval
!   emis_new     emissivite
!   z0_new       surface roughness
!   z0h_new      surface roughness, it is a copy from z0_new
!   qsurf        air moisture at surface
!
!
! Parametres d'entree
!****************************************************************************************
    INTEGER, INTENT(IN)                       :: itime
    REAL, INTENT(IN)                          :: dtime
    REAL, INTENT(IN)                          :: date0
    INTEGER, INTENT(IN)                       :: knon
    INTEGER, DIMENSION(klon), INTENT(IN)      :: knindex
    LOGICAL, INTENT(IN)                       :: debut, lafin
    REAL, DIMENSION(klon,nbsrf), INTENT(IN)   :: pctsrf
    REAL, DIMENSION(klon), INTENT(IN)         :: rlon, rlat
    REAL, DIMENSION(klon), INTENT(IN)         :: yrmu0 ! cosine of solar zenith angle
    REAL, DIMENSION(klon), INTENT(IN)         :: plev
    REAL, DIMENSION(klon), INTENT(IN)         :: u1_lay, v1_lay, gustiness
    REAL, DIMENSION(klon), INTENT(IN)         :: temp_air, spechum
    REAL, DIMENSION(klon), INTENT(IN)         :: epot_air, ccanopy
    REAL, DIMENSION(klon), INTENT(IN)         :: tq_cdrag
    REAL, DIMENSION(klon), INTENT(IN)         :: petAcoef, peqAcoef
    REAL, DIMENSION(klon), INTENT(IN)         :: petBcoef, peqBcoef
    REAL, DIMENSION(klon), INTENT(IN)         :: precip_rain, precip_snow
    REAL, DIMENSION(klon), INTENT(IN)         :: lwdown, swnet, swdown, ps
    REAL, DIMENSION(klon), INTENT(IN)         :: q2m, t2m

! Parametres de sortie
!****************************************************************************************
    REAL, DIMENSION(klon), INTENT(OUT)        :: evap, fluxsens, fluxlat, qsurf
    REAL, DIMENSION(klon), INTENT(OUT)        :: tsol_rad, tsurf_new
    REAL, DIMENSION(klon), INTENT(OUT)        :: alb1_new, alb2_new
    REAL, DIMENSION(klon), INTENT(OUT)        :: emis_new, z0_new, z0h_new
    REAL, DIMENSION(klon,nvm_lmdz), INTENT(OUT) :: veget ! dummy variables
    REAL, DIMENSION(klon,nvm_lmdz), INTENT(OUT) :: lai   ! dummy variables
    REAL, DIMENSION(klon,nvm_lmdz), INTENT(OUT) :: height! dummy variables

! Local
!****************************************************************************************
    INTEGER                                   :: ij, jj, igrid, ireal, index
    INTEGER                                   :: error
    REAL, DIMENSION(klon)                     :: swdown_vrai
    CHARACTER (len = 20)                      :: modname = 'surf_land_orchidee'
    CHARACTER (len = 80)                      :: abort_message
    LOGICAL,SAVE                              :: check = .FALSE.
    !$OMP THREADPRIVATE(check)

! type de couplage dans sechiba
!  character (len=10)   :: coupling = 'implicit' 
! drapeaux controlant les appels dans SECHIBA
!  type(control_type), save   :: control_in
! Preserved albedo
    REAL, ALLOCATABLE, DIMENSION(:), SAVE     :: albedo_keep, zlev
    !$OMP THREADPRIVATE(albedo_keep,zlev)
! coordonnees geographiques
    REAL, ALLOCATABLE, DIMENSION(:,:), SAVE   :: lalo
    !$OMP THREADPRIVATE(lalo)
! pts voisins
    INTEGER,ALLOCATABLE, DIMENSION(:,:), SAVE :: neighbours
    !$OMP THREADPRIVATE(neighbours)
! fractions continents
    REAL,ALLOCATABLE, DIMENSION(:), SAVE      :: contfrac
    !$OMP THREADPRIVATE(contfrac)
! resolution de la grille
    REAL, ALLOCATABLE, DIMENSION (:,:), SAVE  :: resolution
    !$OMP THREADPRIVATE(resolution)

    REAL, ALLOCATABLE, DIMENSION (:,:), SAVE  :: lon_scat, lat_scat  
    !$OMP THREADPRIVATE(lon_scat,lat_scat)

    LOGICAL, SAVE                             :: lrestart_read = .TRUE.
    !$OMP THREADPRIVATE(lrestart_read)
    LOGICAL, SAVE                             :: lrestart_write = .FALSE.
    !$OMP THREADPRIVATE(lrestart_write)

    REAL, DIMENSION(knon,2)                   :: albedo_out

! Pb de nomenclature
    REAL, DIMENSION(klon)                     :: petA_orc, peqA_orc
    REAL, DIMENSION(klon)                     :: petB_orc, peqB_orc
! Pb de correspondances de grilles
    INTEGER, DIMENSION(:), SAVE, ALLOCATABLE  :: ig, jg
    !$OMP THREADPRIVATE(ig,jg)
    INTEGER :: indi, indj
    INTEGER, SAVE, ALLOCATABLE,DIMENSION(:)   :: ktindex
    !$OMP THREADPRIVATE(ktindex)

! Essai cdrag
    REAL, DIMENSION(klon)                     :: cdrag
    INTEGER,SAVE                              :: offset
    !$OMP THREADPRIVATE(offset)

    REAL, DIMENSION(klon_glo)                 :: rlon_g,rlat_g
    INTEGER, SAVE                             :: orch_comm
    !$OMP THREADPRIVATE(orch_comm)

    REAL, ALLOCATABLE, DIMENSION(:), SAVE     :: coastalflow
    !$OMP THREADPRIVATE(coastalflow)
    REAL, ALLOCATABLE, DIMENSION(:), SAVE     :: riverflow
    !$OMP THREADPRIVATE(riverflow)
    
    INTEGER :: orch_omp_rank
    INTEGER :: orch_omp_size
!
! Fin definition
!****************************************************************************************

    IF (check) WRITE(lunout,*)'Entree ', modname

    IF (ifl_pbltree == 1) THEN
       abort_message='Pb de coherence: cette interface vers ORCHIDEE ne peut pas etre utilise avec ifl_pbltree'
       CALL abort_physic(modname,abort_message,1)
    END IF
  
! Initialisation
  
    IF (debut) THEN
! Test of coherence between variable ok_veget and cpp key CPP_VEGET
#ifndef CPP_VEGET
       abort_message='Pb de coherence: ok_veget = .true. mais CPP_VEGET = .false.'
       CALL abort_physic(modname,abort_message,1)
#endif

       CALL Init_surf_para(knon)
       ALLOCATE(ktindex(knon))
       IF ( .NOT. ALLOCATED(albedo_keep)) THEN
!ym          ALLOCATE(albedo_keep(klon))
!ym bizarre que non allou� en knon precedement
          ALLOCATE(albedo_keep(knon))
          ALLOCATE(zlev(knon))
       ENDIF
! Pb de correspondances de grilles
       ALLOCATE(ig(klon))
       ALLOCATE(jg(klon))
       ig(1) = 1
       jg(1) = 1
       indi = 0
       indj = 2
       DO igrid = 2, klon - 1
          indi = indi + 1
          IF ( indi > nbp_lon) THEN
             indi = 1
             indj = indj + 1
          ENDIF
          ig(igrid) = indi
          jg(igrid) = indj
       ENDDO
       ig(klon) = 1
       jg(klon) = nbp_lat

       IF ((.NOT. ALLOCATED(lalo))) THEN
          ALLOCATE(lalo(knon,2), stat = error)
          IF (error /= 0) THEN
             abort_message='Pb allocation lalo'
             CALL abort_physic(modname,abort_message,1)
          ENDIF
       ENDIF
       IF ((.NOT. ALLOCATED(lon_scat))) THEN
          ALLOCATE(lon_scat(nbp_lon,nbp_lat), stat = error)
          IF (error /= 0) THEN
             abort_message='Pb allocation lon_scat'
             CALL abort_physic(modname,abort_message,1)
          ENDIF
       ENDIF
       IF ((.NOT. ALLOCATED(lat_scat))) THEN
          ALLOCATE(lat_scat(nbp_lon,nbp_lat), stat = error)
          IF (error /= 0) THEN
             abort_message='Pb allocation lat_scat'
             CALL abort_physic(modname,abort_message,1)
          ENDIF
       ENDIF
       lon_scat = 0.
       lat_scat = 0.
       DO igrid = 1, knon
          index = knindex(igrid)
          lalo(igrid,2) = rlon(index)
          lalo(igrid,1) = rlat(index)
       ENDDO

       
       
       CALL Gather(rlon,rlon_g)
       CALL Gather(rlat,rlat_g)

       IF (is_mpi_root) THEN
          index = 1
          DO jj = 2, nbp_lat-1
             DO ij = 1, nbp_lon
                index = index + 1
                lon_scat(ij,jj) = rlon_g(index)
                lat_scat(ij,jj) = rlat_g(index)
             ENDDO
          ENDDO
          lon_scat(:,1) = lon_scat(:,2)
          lat_scat(:,1) = rlat_g(1)
          lon_scat(:,nbp_lat) = lon_scat(:,2)
          lat_scat(:,nbp_lat) = rlat_g(klon_glo)
       ENDIF
   
       CALL bcast(lon_scat)
       CALL bcast(lat_scat)
!
! Allouer et initialiser le tableau des voisins et des fraction de continents
!
       IF ( (.NOT.ALLOCATED(neighbours))) THEN
          ALLOCATE(neighbours(knon,8), stat = error)
          IF (error /= 0) THEN
             abort_message='Pb allocation neighbours'
             CALL abort_physic(modname,abort_message,1)
          ENDIF
       ENDIF
       neighbours = -1.
       IF (( .NOT. ALLOCATED(contfrac))) THEN
          ALLOCATE(contfrac(knon), stat = error)
          IF (error /= 0) THEN
             abort_message='Pb allocation contfrac'
             CALL abort_physic(modname,abort_message,1)
          ENDIF
       ENDIF

       DO igrid = 1, knon
          ireal = knindex(igrid)
          contfrac(igrid) = pctsrf(ireal,is_ter)
       ENDDO


       CALL Init_neighbours(knon,neighbours,knindex,pctsrf(:,is_ter))

!
!  Allocation et calcul resolutions
       IF ( (.NOT.ALLOCATED(resolution))) THEN
          ALLOCATE(resolution(knon,2), stat = error)
          IF (error /= 0) THEN
             abort_message='Pb allocation resolution'
             CALL abort_physic(modname,abort_message,1)
          ENDIF
       ENDIF
       DO igrid = 1, knon
          ij = knindex(igrid)
          resolution(igrid,1) = dx(ij)
          resolution(igrid,2) = dy(ij)
       ENDDO
     
       ALLOCATE(coastalflow(klon), stat = error)
       IF (error /= 0) THEN
          abort_message='Pb allocation coastalflow'
          CALL abort_physic(modname,abort_message,1)
       ENDIF
       
       ALLOCATE(riverflow(klon), stat = error)
       IF (error /= 0) THEN
          abort_message='Pb allocation riverflow'
          CALL abort_physic(modname,abort_message,1)
       ENDIF
!
! carbon_cycle_cpl not possible with this interface and version of ORHCHIDEE
!
       IF (carbon_cycle_cpl) THEN
          abort_message='carbon_cycle_cpl not yet possible with this interface of ORCHIDEE'
          CALL abort_physic(modname,abort_message,1)
       END IF
       
    ENDIF                          ! (fin debut) 
 

! 
! Appel a la routine sols continentaux
!
    IF (lafin) lrestart_write = .TRUE.
    IF (check) WRITE(lunout,*)'lafin ',lafin,lrestart_write
     
    petA_orc(1:knon) = petBcoef(1:knon) * dtime
    petB_orc(1:knon) = petAcoef(1:knon)
    peqA_orc(1:knon) = peqBcoef(1:knon) * dtime
    peqB_orc(1:knon) = peqAcoef(1:knon)

    cdrag = 0.
    cdrag(1:knon) = tq_cdrag(1:knon)

! zlev(1:knon) = (100.*plev(1:knon))/((ps(1:knon)/287.05*temp_air(1:knon))*9.80665)
!    zlev(1:knon) = (100.*plev(1:knon))/((ps(1:knon)/RD*temp_air(1:knon))*RG)
     zlev(1:knon) = plev(1:knon)*RD*temp_air(1:knon)/((ps(1:knon)*100.0)*RG)


! PF et PASB
!   where(cdrag > 0.01) 
!     cdrag = 0.01
!   endwhere
!  write(*,*)'Cdrag = ',minval(cdrag),maxval(cdrag)

  
    IF (debut) THEN
       CALL Init_orchidee_index(knon,knindex,offset,ktindex)
       CALL Get_orchidee_communicator(orch_comm,orch_omp_size,orch_omp_rank)
       CALL Init_synchro_omp
       
       IF (knon > 0) THEN
#ifdef CPP_VEGET
         CALL Init_intersurf(nbp_lon,nbp_lat,knon,ktindex,offset,orch_omp_size,orch_omp_rank,orch_comm)
#endif
       ENDIF

       
       IF (knon > 0) THEN

#ifdef CPP_VEGET
          CALL intersurf_main (itime+itau_phy-1, nbp_lon, nbp_lat, knon, ktindex, dtime, &
               lrestart_read, lrestart_write, lalo, &
               contfrac, neighbours, resolution, date0, &
               zlev,  u1_lay, v1_lay, spechum, temp_air, epot_air, ccanopy, &
               cdrag, petA_orc, peqA_orc, petB_orc, peqB_orc, &
               precip_rain, precip_snow, lwdown, swnet, swdown, ps, &
               evap, fluxsens, fluxlat, coastalflow, riverflow, &
               tsol_rad, tsurf_new, qsurf, albedo_out, emis_new, z0_new, &
               lon_scat, lat_scat, q2m, t2m, coszang=yrmu0)
#endif         
       ENDIF

       CALL Synchro_omp

       albedo_keep(1:knon) = (albedo_out(1:knon,1)+albedo_out(1:knon,2))/2.

    ENDIF

    
!  swdown_vrai(1:knon) = swnet(1:knon)/(1. - albedo_keep(1:knon))
    swdown_vrai(1:knon) = swdown(1:knon)

    IF (knon > 0) THEN
#ifdef CPP_VEGET    

       CALL intersurf_main (itime+itau_phy, nbp_lon, nbp_lat, knon, ktindex, dtime,  &
            lrestart_read, lrestart_write, lalo, &
            contfrac, neighbours, resolution, date0, &
            zlev,  u1_lay(1:knon), v1_lay(1:knon), spechum(1:knon), temp_air(1:knon), epot_air(1:knon), ccanopy(1:knon), &
            cdrag(1:knon), petA_orc(1:knon), peqA_orc(1:knon), petB_orc(1:knon), peqB_orc(1:knon), &
            precip_rain(1:knon), precip_snow(1:knon), lwdown(1:knon), swnet(1:knon), swdown_vrai(1:knon), ps(1:knon), &
            evap(1:knon), fluxsens(1:knon), fluxlat(1:knon), coastalflow(1:knon), riverflow(1:knon), &
            tsol_rad(1:knon), tsurf_new(1:knon), qsurf(1:knon), albedo_out(1:knon,:), emis_new(1:knon), z0_new(1:knon), &
            lon_scat, lat_scat, q2m(1:knon), t2m(1:knon), coszang=yrmu0(1:knon))
#endif       
    ENDIF
    z0h_new(:)=z0_new(:)

    CALL Synchro_omp
    
    albedo_keep(1:knon) = (albedo_out(1:knon,1)+albedo_out(1:knon,2))/2.

!* Send to coupler
!
    IF (type_ocean=='couple') THEN
       CALL cpl_send_land_fields(itime, knon, knindex, &
            riverflow, coastalflow)
    ENDIF

    alb1_new(1:knon) = albedo_out(1:knon,1) 
    alb2_new(1:knon) = albedo_out(1:knon,2)

! Convention orchidee: positif vers le haut
    fluxsens(1:knon) = -1. * fluxsens(1:knon)
    fluxlat(1:knon)  = -1. * fluxlat(1:knon)
    
!  evap     = -1. * evap

    IF (debut) lrestart_read = .FALSE.
    
    IF (debut) CALL Finalize_surf_para

    
  END SUBROUTINE surf_land_orchidee
!
!****************************************************************************************
!
  SUBROUTINE Init_orchidee_index(knon,knindex,offset,ktindex)
  USE mod_surf_para
  USE mod_grid_phy_lmdz
  
    INTEGER,INTENT(IN)    :: knon
    INTEGER,INTENT(IN)    :: knindex(klon)    
    INTEGER,INTENT(OUT)   :: offset
    INTEGER,INTENT(OUT)   :: ktindex(klon)
    
    INTEGER               :: ktindex_glo(knon_glo)
    INTEGER               :: offset_para(0:omp_size*mpi_size-1)
    INTEGER               :: LastPoint
    INTEGER               :: task
    
    ktindex(1:knon)=knindex(1:knon)+(klon_mpi_begin-1)+(klon_omp_begin-1)+nbp_lon-1
    
    CALL gather_surf(ktindex(1:knon),ktindex_glo) 
    
    IF (is_mpi_root .AND. is_omp_root) THEN
      LastPoint=0
      DO Task=0,mpi_size*omp_size-1
        IF (knon_glo_para(Task)>0) THEN
           offset_para(task)= LastPoint-MOD(LastPoint,nbp_lon)
           LastPoint=ktindex_glo(knon_glo_end_para(task))
        ENDIF
      ENDDO
    ENDIF
    
    CALL bcast(offset_para)
    
    offset=offset_para(omp_size*mpi_rank+omp_rank)
    
    ktindex(1:knon)=ktindex(1:knon)-offset

  END SUBROUTINE Init_orchidee_index

!
!************************* ***************************************************************
! 

  SUBROUTINE Get_orchidee_communicator(orch_comm,orch_omp_size,orch_omp_rank)
  USE  mod_surf_para
  USE lmdz_mpi
      
    INTEGER,INTENT(OUT) :: orch_comm
    INTEGER,INTENT(OUT) :: orch_omp_size
    INTEGER,INTENT(OUT) :: orch_omp_rank
    INTEGER             :: color
    INTEGER             :: i,ierr
!
! End definition
!****************************************************************************************
    
    
    IF (is_omp_root) THEN          
      
      IF (knon_mpi==0) THEN 
         color = 0
      ELSE 
         color = 1
      ENDIF
    
      IF (using_mpi) THEN
        CALL MPI_COMM_SPLIT(COMM_LMDZ_PHY,color,mpi_rank,orch_comm,ierr)
      ENDIF
    
    ENDIF
    CALL bcast_omp(orch_comm)
    
    IF (knon_mpi /= 0) THEN
      orch_omp_size=0
      DO i=0,omp_size-1
        IF (knon_omp_para(i) /=0) THEN
          orch_omp_size=orch_omp_size+1
          IF (i==omp_rank) orch_omp_rank=orch_omp_size-1
        ENDIF
      ENDDO
    ENDIF
   
    
  END SUBROUTINE Get_orchidee_communicator
!
!****************************************************************************************
!  

  SUBROUTINE Init_neighbours(knon,neighbours,knindex,pctsrf)
    USE mod_grid_phy_lmdz
    USE mod_surf_para    
    USE indice_sol_mod
    USE lmdz_mpi

! Input arguments
!****************************************************************************************
    INTEGER, INTENT(IN)                     :: knon
    INTEGER, DIMENSION(klon), INTENT(IN)    :: knindex
    REAL, DIMENSION(klon), INTENT(IN)       :: pctsrf
    
! Output arguments
!****************************************************************************************
    INTEGER, DIMENSION(knon,8), INTENT(OUT) :: neighbours

! Local variables
!****************************************************************************************
    INTEGER                              :: i, igrid, jj, ij, iglob
    INTEGER                              :: ierr, ireal, index
    INTEGER, DIMENSION(8,3)              :: off_ini
    INTEGER, DIMENSION(8)                :: offset  
    INTEGER, DIMENSION(nbp_lon,nbp_lat)  :: correspond
    INTEGER, DIMENSION(knon_glo)         :: ktindex_glo
    INTEGER, DIMENSION(knon_glo,8)       :: neighbours_glo
    REAL, DIMENSION(klon_glo)            :: pctsrf_glo
    INTEGER                              :: ktindex(klon)
!
! End definition
!****************************************************************************************

    ktindex(1:knon)=knindex(1:knon)+(klon_mpi_begin-1)+(klon_omp_begin-1)+nbp_lon-1
    
    CALL gather_surf(ktindex(1:knon),ktindex_glo)
    CALL gather(pctsrf,pctsrf_glo)
    
    IF (is_mpi_root .AND. is_omp_root) THEN
      neighbours_glo(:,:)=-1
!  Initialisation des offset    
!
! offset bord ouest
       off_ini(1,1) = - nbp_lon   ; off_ini(2,1) = - nbp_lon + 1     ; off_ini(3,1) = 1
       off_ini(4,1) = nbp_lon + 1 ; off_ini(5,1) = nbp_lon           ; off_ini(6,1) = 2 * nbp_lon - 1
       off_ini(7,1) = nbp_lon -1  ; off_ini(8,1) = - 1 
! offset point normal
       off_ini(1,2) = - nbp_lon   ; off_ini(2,2) = - nbp_lon + 1     ; off_ini(3,2) = 1
       off_ini(4,2) = nbp_lon + 1 ; off_ini(5,2) = nbp_lon           ; off_ini(6,2) = nbp_lon - 1
       off_ini(7,2) = -1          ; off_ini(8,2) = - nbp_lon - 1
! offset bord   est
       off_ini(1,3) = - nbp_lon   ; off_ini(2,3) = - 2 * nbp_lon + 1 ; off_ini(3,3) = - nbp_lon + 1
       off_ini(4,3) =  1          ; off_ini(5,3) = nbp_lon           ; off_ini(6,3) = nbp_lon - 1
       off_ini(7,3) = -1          ; off_ini(8,3) = - nbp_lon - 1
!
!
! Attention aux poles
!
       DO igrid = 1, knon_glo
          index = ktindex_glo(igrid)
          jj = INT((index - 1)/nbp_lon) + 1
          ij = index - (jj - 1) * nbp_lon
          correspond(ij,jj) = igrid
       ENDDO
!sonia : Les mailles des voisines doivent etre toutes egales (pour couplage orchidee)
       IF (knon_glo == 1) THEN
         igrid = 1
         DO i = 1,8
           neighbours_glo(igrid, i) = igrid
         ENDDO
       ELSE
       print*,'sonia : knon_glo,ij,jj', knon_glo, ij,jj
       
       DO igrid = 1, knon_glo
          iglob = ktindex_glo(igrid)
          
          IF (MOD(iglob, nbp_lon) == 1) THEN
             offset = off_ini(:,1)
          ELSE IF(MOD(iglob, nbp_lon) == 0) THEN
             offset = off_ini(:,3)
          ELSE
             offset = off_ini(:,2)
          ENDIF
          
          DO i = 1, 8
             index = iglob + offset(i)
             ireal = (MIN(MAX(1, index - nbp_lon + 1), klon_glo))
             IF (pctsrf_glo(ireal) > EPSFRA) THEN
                jj = INT((index - 1)/nbp_lon) + 1
                ij = index - (jj - 1) * nbp_lon
                neighbours_glo(igrid, i) = correspond(ij, jj)
             ENDIF
          ENDDO
       ENDDO
       ENDIF !fin knon_glo == 1

    ENDIF
    
    DO i = 1, 8
      CALL scatter_surf(neighbours_glo(:,i),neighbours(1:knon,i))
    ENDDO
  END SUBROUTINE Init_neighbours

!
!****************************************************************************************
!
#endif
END MODULE surf_land_orchidee_noz0h_mod

!$gpum horizontal klon
MODULE lmdz_call_lscp

   IMPLICIT NONE

CONTAINS

   SUBROUTINE call_lscp(klon, klev, nbsrf, is_ter, is_lic, &
                        abortphy, flag_inhib_tend, itap, &
                        nqo, dtime, missing_val, ok_new_lscp, &
                        paprs, pplay, omega, temp, qt, &
                        zmasse, ptconv, ratqsc, ratqs, ratqs_inter_, sigma_qtherm, &
                        qtc_cv, sigt_cv, detrain_cv, fm_cv, fqd, fqcomp, &
                        sigd, qsat, ratio_ql_qtot, ratio_qi_qtot, &
                        pctsrf, s_pblh, zstd, wake_s, wake_deltaq, &
                        d_t, d_q, d_ql, d_qi, rneb, rneblsvol, &
                        pfraclr, pfracld, &
                        cldfraliq, cldfraliqth, &
                        sigma2_icefracturb, sigma2_icefracturbth, &
                        mean_icefracturb, mean_icefracturbth, &
                        radocond, radicefrac, rain_lsc, snow_lsc, rain_num, &
                        rain_fall, snow_fall, &
                        frac_impa, frac_nucl, beta, &
                        pfrac_impa, pfrac_nucl, pfrac_1nucl, &
                        prfl, psfl, rhcl, qta, fraca, &
                        tv, pspsk, tla, thl, wth, &
                        distcltop, temp_cltop, &
                        tke, tke_dissip, &
                        fm_therm, entr_therm, detr_therm, &
                        cell_area, &
                        cf, rvc, u, v, &
                        qsub, qissr, qcld, subfra, issrfra, gamma_cond, &
                        dcf_sub, dcf_con, dcf_mix, &
                        dqi_adj, dqi_sub, dqi_con, dqi_mix, dqvc_adj, &
                        dqvc_sub, dqvc_con, dqvc_mix, qsatliq, qsatice, &
                        Tcontr, qcontr, qcontr2, fcontrN, fcontrP, dcf_avi, &
                        dqi_avi, dqvc_avi, flight_dist, flight_h2o, &
                        cloudth_sth, cloudth_senv, cloudth_sigmath, cloudth_sigmaenv, &
                        qraindiag, qsnowdiag, dqreva, dqssub, dqrauto, &
                        dqrcol, dqrmelt, dqrfreez, dqsauto, dqsagg, dqsrim, &
                        dqsmelt, dqsfreez, rh, rhl, rhi)

      USE lmdz_lscp_main, ONLY: lscp
      USE lmdz_lscp_old, ONLY: fisrtilp
      USE lmdz_lscp_subgridvarq, ONLY: ratqs_main
      USE lmdz_lscp_ini, ONLY: qlmax, qimax, RTT
      USE lmdz_lscp_tools, ONLY: calc_qsat_ecmwf
      USE add_phys_tend_mod, ONLY: add_phys_tend, prt_enerbil
      USE phys_local_var_mod, ONLY: t_seri, q_seri, ql_seri, qs_seri

      IMPLICIT NONE

!============================================================================
! call_lscp in the main interface between the LMDZ physics monitor physiq_mod
! and the large scale clouds and precipitation (lscp) parameterizations
!
! The aim of lscp routines is to compute the cloud fraction, cloud water 
! contents, precipitation and temperature and water tendencies from the
! 'large scale' (i.e. not from deep convection)
!
! contact: Etienne Vignon etienne.vignon@lmd.ipsl.fr
!============================================================================

!===============================================================================
! VARIABLES DECLARATION
!===============================================================================

! INPUT VARIABLES:
!-----------------

      INTEGER, INTENT(IN)   :: klon, klev       ! number of horizontal grid points and vertical levels
      INTEGER, INTENT(IN)   :: nbsrf, is_ter, is_lic ! number of subgrid tiles and indices for land and landice
      INTEGER, INTENT(IN)   :: abortphy, flag_inhib_tend, itap ! flag and physics time counter for add_phys_tend
      INTEGER, INTENT(IN)   :: nqo             ! number of water species
      LOGICAL, INTENT(IN)   :: ok_new_lscp     ! flag that controls the version of lscp code used

      REAL, INTENT(IN)   :: dtime           ! time step [s]
      REAL, INTENT(IN)   :: missing_val     ! missing value for output

      REAL, DIMENSION(klon, klev + 1), INTENT(IN)   :: paprs           ! inter-layer pressure [Pa]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: pplay           ! mid-layer pressure [Pa]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: zmasse          ! masse of layers [kg/m2]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: temp            ! temperature (K)
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: omega           ! vertical velocity [Pa/s]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: qt              ! total specific humidity (in vapor phase in input) [kg/kg]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: ratio_ql_qtot   ! ratio ql/qt at the beginning of physics time step [-]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: ratio_qi_qtot   ! ratio qi/qt at the beginning of physics time step [-]
      REAL, DIMENSION(klon, klev + 1), INTENT(IN)   :: tke             ! turbulent kinetic energy [m2/s2]
      REAL, DIMENSION(klon, klev + 1), INTENT(IN)   :: tke_dissip      ! TKE dissipation [m2/s3]

      LOGICAL, DIMENSION(klon, klev), INTENT(IN)   :: ptconv          ! grid points where deep convection scheme is active

      !Inputs associated with thermal plumes

      REAL, DIMENSION(klon, klev), INTENT(IN)   :: tv              ! virtual potential temperature [K]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: qta             ! specific humidity within thermals [kg/kg]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: fraca           ! fraction of thermals within the mesh [-]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: pspsk           ! exner potential (p/100000)**(R/cp)
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: tla             ! liquid potential temperature within thermals [K]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: wth             ! vertical velocity within thermals [m/s]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: entr_therm      ! thermal plume entrainment rate * dz [kg/s/m2]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: detr_therm      ! thermal plume detrainment rate * dz [kg/s/m2]
      REAL, DIMENSION(klon, klev + 1), INTENT(IN)   :: fm_therm        ! convective mass flux of thermals [kg/s/m2]

      ! Inputs associated with subgrid water variability

      REAL, DIMENSION(klon, klev), INTENT(IN)   :: wake_deltaq     ! difference in humidity between wakes and environment [kg/kg]
      REAL, DIMENSION(klon), INTENT(IN)   :: wake_s          ! wake fraction area [-]
      REAL, DIMENSION(klon, nbsrf), INTENT(IN)   :: pctsrf          ! fraction of each subgrid tiles [0-1]
      REAL, DIMENSION(klon), INTENT(IN)   :: s_pblh          ! boundary layer height [m]
      REAL, DIMENSION(klon), INTENT(IN)   :: zstd            ! sub grid orography standard deviation [m]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: ratqsc          ! normalized subgrid distribution of water due to deep convection
      real, dimension(klon, klev), intent(in)   :: qtc_cv          ! total specific moisture in convective saturated draughts  [kg/kg]
      real, dimension(klon, klev), intent(in)   :: sigt_cv         ! surface fraction of convective saturated draughts [-]
      real, dimension(klon, klev), intent(in)   :: detrain_cv      ! deep convection detrainment of specific humidity variance [kg/s/m2*(kg/kg)^2]
      real, dimension(klon, klev), intent(in)   :: fm_cv           ! deep convective mass flux [kg/s/m2]
      real, dimension(klon, klev), intent(in)   :: fqd             ! specific humidity tendency due to convective precip [kg/kg/s]
      real, dimension(klon, klev), intent(in)   :: fqcomp          ! specific humidity tendency due to convective mixed draughts [kg/ks/s]
      real, dimension(klon), intent(in)   :: sigd            ! fractional area covered by unsaturated convective downdrafts [-]

      ! INPUT/OUTPUT variables
      !------------------------
      REAL, DIMENSION(klon, klev), INTENT(INOUT)   :: qsat            ! saturation specific humidity [kg/kg] from/to the physics
      REAL, DIMENSION(klon, klev), INTENT(INOUT)   :: thl          ! liquid potential temperature [K]
      REAL, DIMENSION(klon, klev), INTENT(INOUT)   :: pfrac_impa   ! product of impaction scavenging coeff.
      REAL, DIMENSION(klon, klev), INTENT(INOUT)   :: pfrac_nucl   ! product of nucleation scavenging coeff.
      REAL, DIMENSION(klon, klev), INTENT(INOUT)   :: pfrac_1nucl  ! product of nucleation scavenging coeff. (alpha=1)
      REAL, DIMENSION(klon), INTENT(INOUT)   :: rain_fall    ! total surface rainfall [kg/m2/s]
      REAL, DIMENSION(klon), INTENT(INOUT)   :: snow_fall    ! total surface snowfall [kg/m2/s]

      ! INPUT/OUTPUT condensation and ice supersaturation
      !--------------------------------------------------
      REAL, DIMENSION(klon, klev), INTENT(INOUT):: cf          ! cloud fraction [-]
      REAL, DIMENSION(klon, klev), INTENT(INOUT):: rvc         ! cloudy water vapor to total water vapor ratio [-]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: u           ! eastward wind [m/s]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: v           ! northward wind [m/s]
      REAL, DIMENSION(klon), INTENT(IN)   :: cell_area        ! area of each cell [m2]

      ! INPUT/OUTPUT aviation
      !--------------------------------------------------
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: flight_dist      ! Aviation distance flown within the mesh [m/s/mesh]
      REAL, DIMENSION(klon, klev), INTENT(IN)   :: flight_h2o       ! Aviation H2O emitted within the mesh [kg H2O/s/mesh]

      ! OUTPUT variables
      !-------------------

      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: d_t              ! temperature increment [K]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: d_q              ! specific humidity increment [kg/kg]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: d_ql             ! liquid water increment [kg/kg]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: d_qi             ! cloud ice mass increment [kg/kg]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: rneb             ! cloud fraction [-]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: rneblsvol        ! cloud fraction per unit volume [-]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: pfraclr          ! precip fraction clear-sky part [-]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: pfracld          ! precip fraction cloudy part [-]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: cldfraliq        ! liquid fraction of cloud fraction [-]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: cldfraliqth      ! liquid fraction of cloud fraction in thermals [-]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: sigma2_icefracturb  ! Variance of the diagnostic supersaturation distribution (icefrac_turb) [-]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: mean_icefracturb    ! Mean of the diagnostic supersaturation distribution (icefrac_turb) [-]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: sigma2_icefracturbth ! Variance of the diagnostic supersaturation distribution in thermals (icefrac_turb) [-]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: mean_icefracturbth   ! Mean of the diagnostic supersaturation distribution in thermals (icefrac_turb) [-]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: radocond         ! condensed water used in the radiation scheme [kg/kg]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: radicefrac       ! ice fraction of condensed water for radiation scheme
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: rhcl             ! clear-sky relative humidity [-]
      REAL, DIMENSION(klon), INTENT(OUT)  :: rain_lsc             ! surface large-scale rainfall [kg/s/m2]
      REAL, DIMENSION(klon), INTENT(OUT)  :: snow_lsc             ! surface large-scale snowfall [kg/s/m2]
      REAL, DIMENSION(klon), INTENT(OUT)  :: rain_num             ! surface "numerical" precip [kg/s/m2]
      REAL, DIMENSION(klon, klev + 1), INTENT(OUT)  :: prfl             ! large-scale rainfall flux in the column [kg/s/m2]
      REAL, DIMENSION(klon, klev + 1), INTENT(OUT)  :: psfl             ! large-scale snowfall flux in the column [kg/s/m2]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: distcltop        ! distance to cloud top [m]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: temp_cltop       ! temperature of cloud top [K]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: beta             ! conversion rate of condensed water
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: rh              ! relative humidity [0-1], wrt liq if T>0C, wrt ice if T<0C
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: rhl             ! relative humidity [0-1] wrt liq
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: rhi             ! relative humidity [0-1] wrt ice

      ! for subgrid variability of water

      real, dimension(klon, klev), intent(out) :: ratqs             ! ratqs i.e. factor for subgrid standard deviation of humidit
      real, dimension(klon, klev), intent(out) :: ratqs_inter_      ! interactive ratqs
      real, dimension(klon, klev), intent(out) :: sigma_qtherm      ! standard deviation of humidity in thermals [kg/kg]

      ! fraction of aerosol scavenging through impaction and nucleation    (for on-line)

      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: frac_impa           ! scavenging fraction due tu impaction [-]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: frac_nucl           ! scavenging fraction due tu nucleation [-]

! for condensation and ice supersaturation

      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: qsub           !--specific total water content in sub-saturated clear sky region [kg/kg]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: qissr          !--specific total water content in supersat region [kg/kg]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: qcld           !--specific total water content in cloudy region [kg/kg]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: subfra         !--mesh fraction of subsaturated clear sky [-]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: issrfra        !--mesh fraction of ISSR [-]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: gamma_cond     !--coefficient governing the ice nucleation RHi threshold [-]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dcf_sub        !--cloud fraction tendency because of sublimation [s-1]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dcf_con        !--cloud fraction tendency because of condensation [s-1]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dcf_mix        !--cloud fraction tendency because of cloud mixing [s-1]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqi_adj        !--specific ice content tendency because of temperature adjustment [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqi_sub        !--specific ice content tendency because of sublimation [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqi_con        !--specific ice content tendency because of condensation [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqi_mix        !--specific ice content tendency because of cloud mixing [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqvc_adj       !--specific cloud water vapor tendency because of temperature adjustment [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqvc_sub       !--specific cloud water vapor tendency because of sublimation [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqvc_con       !--specific cloud water vapor tendency because of condensation [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqvc_mix       !--specific cloud water vapor tendency because of cloud mixing [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: qsatliq        !--saturation specific humidity wrt liquid [kg/kg]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: qsatice        !--saturation specific humidity wrt ice [kg/kg]

      ! for contrails and aviation

      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: Tcontr         !--threshold temperature for contrail formation [K]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: qcontr         !--threshold humidity for contrail formation [kg/kg]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: qcontr2        !--// (2nd expression more consistent with LMDZ expression of q)
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: fcontrN        !--fraction of grid favourable to non-persistent contrails
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: fcontrP        !--fraction of grid favourable to persistent contrails
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dcf_avi        !--cloud fraction tendency because of aviation [s-1]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqi_avi        !--specific ice content tendency because of aviation [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqvc_avi       !--specific cloud water vapor tendency because of aviation [kg/kg/s]

      ! for POPRECIP

      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: qraindiag      !--DIAGNOSTIC specific rain content [kg/kg]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: qsnowdiag      !--DIAGNOSTIC specific snow content [kg/kg]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqreva         !--rain tendendy due to evaporation [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqssub         !--snow tendency due to sublimation [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqrcol         !--rain tendendy due to collection by rain of liquid cloud droplets [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqsagg         !--snow tendency due to collection of lcoud ice by aggregation [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqrauto        !--rain tendency due to autoconversion of cloud liquid [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqsauto        !--snow tendency due to autoconversion of cloud ice [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqsrim         !--snow tendency due to riming [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqsmelt        !--snow tendency due to melting [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqrmelt        !--rain tendency due to melting [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqsfreez       !--snow tendency due to freezing [kg/kg/s]
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: dqrfreez       !--rain tendency due to freezing [kg/kg/s]

      ! for thermals
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: cloudth_sth      !--mean saturation deficit in thermals
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: cloudth_senv     !--mean saturation deficit in environment
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: cloudth_sigmath  !--std of saturation deficit in thermals
      REAL, DIMENSION(klon, klev), INTENT(OUT)  :: cloudth_sigmaenv !--std of saturation deficit in environment

      ! LOCAL variables
      !-------------------

      INTEGER                                      :: i, k
      REAL, DIMENSION(klon, klev)                  :: ql_estimate_lscp, qi_estimate_lscp
      REAL, DIMENSION(klon, klev)                  :: du0, dv0, dqbs0

      REAL, DIMENSION(klon) :: z_q, z_t, z_p, z_qs
      REAL, DIMENSION(klon) ::  z_qsl, z_qsi, z_dqs, z_dqsl, z_dqsi

!===============================================================================
! Computation of subgrid water variability
!===============================================================================

      CALL ratqs_main(klon, klev, nbsrf, is_ter, is_lic, dtime, &
                      pctsrf, s_pblh, zstd, wake_s, wake_deltaq, &
                      paprs, pplay, temp, qt, &
                      qtc_cv, sigt_cv, detrain_cv, fm_cv, fqd, fqcomp, sigd, qsat, &
                      fm_therm, entr_therm, detr_therm, cell_area, &
                      ratqsc, ratqs, ratqs_inter_, sigma_qtherm)

!===============================================================================
! Computation of large scale clouds and precipitation
!===============================================================================

      IF (ok_new_lscp) THEN

         ! recentmost version of the lscp routine. To use by default.

         DO k = 1, klev
            DO i = 1, klon
               ql_estimate_lscp(i, k) = ratio_ql_qtot(i, k)*qt(i, k)
               qi_estimate_lscp(i, k) = ratio_qi_qtot(i, k)*qt(i, k)
            END DO
         END DO

         CALL lscp(klon, klev, dtime, missing_val, paprs, pplay, omega, &
                   temp, qt, ql_estimate_lscp, qi_estimate_lscp, ptconv, ratqs, sigma_qtherm, &
                   d_t, d_q, d_ql, d_qi, rneb, rneblsvol, &
                   pfraclr, pfracld, cldfraliq, cldfraliqth, &
                   sigma2_icefracturb, sigma2_icefracturbth, &
                   mean_icefracturb, mean_icefracturbth, &
                   radocond, radicefrac, rain_lsc, snow_lsc, &
                   frac_impa, frac_nucl, beta, &
                   prfl, psfl, rhcl, &
                   qta, fraca, tv, pspsk, tla, thl, wth, &
                   distcltop, temp_cltop, &
                   tke, tke_dissip, &
                   entr_therm, detr_therm, &
                   cell_area, &
                   cf, rvc, u, v, &
                   qsub, qissr, qcld, subfra, issrfra, gamma_cond, &
                   dcf_sub, dcf_con, dcf_mix, dqi_adj, dqi_sub, dqi_con, dqi_mix, &
                   dqvc_adj, dqvc_sub, dqvc_con, dqvc_mix, qsatliq, qsatice, &
                   Tcontr, qcontr, qcontr2, fcontrN, fcontrP, &
                   dcf_avi, dqi_avi, dqvc_avi, flight_dist, flight_h2o, &
                   cloudth_sth, cloudth_senv, cloudth_sigmath, cloudth_sigmaenv, &
                   qraindiag, qsnowdiag, dqreva, dqssub, dqrauto, dqrcol, dqrmelt, &
                   dqrfreez, dqsauto, dqsagg, dqsrim, dqsmelt, dqsfreez)

      ELSE

         CALL fisrtilp(klon, klev, dtime, paprs, pplay, &
                       temp, qt, ptconv, ratqs, sigma_qtherm, &
                       d_t, d_q, d_ql, d_qi, rneb, rneblsvol, radocond, &
                       rain_lsc, snow_lsc, &
                       pfrac_impa, pfrac_nucl, pfrac_1nucl, &
                       frac_impa, frac_nucl, beta, &
                       prfl, psfl, rhcl, &
                       qta, fraca, tv, pspsk, tla, thl, &
                       cloudth_sth, cloudth_senv, cloudth_sigmath, cloudth_sigmaenv)

      END IF

!===============================================================================
! Add tendencies
!===============================================================================
      du0(:, :) = 0.
      dv0(:, :) = 0.
      dqbs0(:, :) = 0.
      CALL add_phys_tend(du0, dv0, d_t, d_q, d_ql, d_qi, dqbs0, paprs, &
                         'lsc', abortphy, flag_inhib_tend, itap, 0)
      CALL prt_enerbil('lsc', itap)

!===============================================================================
! Final computations
!===============================================================================

      ! rain and snow are set to 0 when negative
      WHERE (rain_lsc < 0) rain_lsc = 0.
      WHERE (snow_lsc < 0) snow_lsc = 0.

      ! so-called 'numerical rain' is computed when qlnew=ql+dql>qlmax and qinew=qi+dqi>qimax
      ! i.e. when the condensed content is unrealistically large
      ! qlnew is set to qlmax and qinew to qimax

      rain_num(:) = 0.
      DO k = 1, klev
         DO i = 1, klon
            IF (ql_seri(i, k) > qlmax) THEN
               rain_num(i) = rain_num(i) + (ql_seri(i, k) - qlmax)*zmasse(i, k)/dtime
               ql_seri(i, k) = qlmax
            END IF
         END DO
      END DO
      IF (nqo >= 3) THEN
      DO k = 1, klev
         DO i = 1, klon
            IF (qs_seri(i, k) > qimax) THEN
               rain_num(i) = rain_num(i) + (qs_seri(i, k) - qimax)*zmasse(i, k)/dtime
               qs_seri(i, k) = qimax
            END IF
         END DO
      END DO
      END IF

      ! total precipitation
      DO i = 1, klon
         rain_fall(i) = rain_fall(i) + rain_lsc(i)
         snow_fall(i) = snow_fall(i) + snow_lsc(i)
      END DO

      ! relative humidity diagnostics
      DO k = 1, klev

         DO i=1, klon
            z_q(i) = q_seri(i, k)
            z_t(i) = t_seri(i, k)
            z_p(i) = pplay(i, k)
         END DO

         CALL CALC_QSAT_ECMWF(klon, z_t, z_q, z_p, RTT, 0, .false., z_qs, z_dqs)
         CALL CALC_QSAT_ECMWF(klon, z_t, z_q, z_p, RTT, 1, .false., z_qsl, z_dqsl)
         CALL CALC_QSAT_ECMWF(klon, z_t, z_q, z_p, RTT, 2, .false., z_qsi, z_dqsi)

         DO i = 1, klon
            rhl(i, k) = z_q(i)/z_qsl(i)
            rhi(i, k) = z_q(i)/z_qsi(i)
            rh(i, k) = z_q(i)/z_qs(i)
            qsat(i, k) = z_qs(i)
         END DO

      ENDDO



   END SUBROUTINE call_lscp

END MODULE lmdz_call_lscp

!
! $Id: calfis_loc.F90 5927 2025-12-12 16:26:10Z snguyen $
!
!
!
#ifdef CPP_PARA

SUBROUTINE calfis_loc(lafin, &
        jD_cur, jH_cur, &
        pucov, &
        pvcov, &
        pteta, &
        pq, &
        pmasse, &
        pps, &
        pp, &
        ppk, &
        pphis, &
        pphi, &
        pducov, &
        pdvcov, &
        pdteta, &
        pdq, &
        flxw, &
        pdufi, &
        pdvfi, &
        pdhfi, &
        pdqfi, &
        pdpsfi)

  !    Auteur :  P. Le Van, F. Hourdin
  !   .........
  USE dimphy
  USE mod_phys_lmdz_mpi_data, mpi_root_xx=>mpi_master
  USE mod_phys_lmdz_omp_data, ONLY: klon_omp, klon_omp_begin
  USE mod_const_mpi, ONLY: COMM_LMDZ
  USE mod_interface_dyn_phys
  USE IOPHY
  USE lmdz_mpi

  USE parallel_lmdz,ONLY:omp_chunk,using_mpi,jjb_u,jje_u,jjb_v,jje_v &
        ,jj_begin_dyn=>jj_begin,jj_end_dyn=>jj_end
  USE Write_Field
  Use Write_field_p
  USE Times
  USE infotrac, ONLY: nqtot, tracers
  USE control_mod, ONLY: planet_type, nsplit_phys
  USE callphysiq_mod, ONLY: call_physiq
  USE comvert_mod, ONLY: preff, presnivs
  USE comconst_mod, ONLY: cpp, daysec, dtphys, dtvr, kappa, pi
  USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_PHYS
  USE iniprint_mod_h
  USE comgeom2_mod_h
  USE dimensions_mod, ONLY: iim, jjm, llm, ndm
  USE paramet_mod_h

  IMPLICIT NONE

  !=======================================================================
  !
  !   1. rearrangement des tableaux et transformation
  !  variables dynamiques  >  variables physiques
  !   2. calcul des termes physiques
  !   3. retransformation des tendances physiques en tendances dynamiques
  !
  !   remarques:
  !   ----------
  !
  !    - les vents sont donnes dans la physique par leurs composantes
  !  naturelles.
  !    - la variable thermodynamique de la physique est une variable
  !  intensive :   T
  !  pour la dynamique on prend    T * ( preff / p(l) ) **kappa
  !    - les deux seules variables dependant de la geometrie necessaires
  !  pour la physique sont la latitude pour le rayonnement et
  !  l'aire de la maille quand on veut integrer une grandeur
  !  horizontalement.
  !    - les points de la physique sont les points scalaires de la
  !  la dynamique; numerotation:
  !      1 pour le pole nord
  !      (jjm-1)*iim pour l'interieur du domaine
  !      ngridmx pour le pole sud
  !  ---> ngridmx=2+(jjm-1)*iim
  !
  ! Input :
  ! -------
  !   ecritphy        frequence d'ecriture (en jours)de histphy
  !   pucov           covariant zonal velocity
  !   pvcov           covariant meridional velocity
  !   pteta           potential temperature
  !   pps             surface pressure
  !   pmasse          masse d'air dans chaque maille
  !   pts             surface temperature  (K)
  !   callrad         clef d'appel au rayonnement
  !
  !    Output :
  !    --------
  !    pdufi          tendency for the natural zonal velocity (ms-1)
  !    pdvfi          tendency for the natural meridional velocity
  !    pdhfi          tendency for the potential temperature
  !    pdtsfi         tendency for the surface temperature
  !
  !    pdtrad         radiative tendencies  \  both input
  !    pfluxrad       radiative fluxes      /  and output
  !
  !=======================================================================
  !
  !-----------------------------------------------------------------------
  !
  !    0.  Declarations :
  !    ------------------
  INTEGER :: ngridmx
  PARAMETER( ngridmx = 2+(jjm-1)*iim - 1/jjm   )

  !    Arguments :
  !    -----------
  LOGICAL,INTENT(IN) ::  lafin ! .true. for the very last call to physics
  REAL,INTENT(IN):: jD_cur, jH_cur
  REAL,INTENT(IN):: pvcov(iip1,jjb_v:jje_v,llm) ! covariant meridional velocity
  REAL,INTENT(IN):: pucov(iip1,jjb_u:jje_u,llm) ! covariant zonal velocity
  REAL,INTENT(IN):: pteta(iip1,jjb_u:jje_u,llm) ! potential temperature
  REAL,INTENT(IN):: pmasse(iip1,jjb_u:jje_u,llm) ! mass in each cell ! not used
  REAL,INTENT(IN):: pq(iip1,jjb_u:jje_u,llm,nqtot) ! tracers
  REAL,INTENT(IN):: pphis(iip1,jjb_u:jje_u) ! surface geopotential
  REAL,INTENT(IN):: pphi(iip1,jjb_u:jje_u,llm) ! geopotential

  REAL,INTENT(IN) :: pdvcov(iip1,jjb_v:jje_v,llm) ! dynamical tendency on vcov ! not used
  REAL,INTENT(IN) :: pducov(iip1,jjb_u:jje_u,llm) ! dynamical tendency on ucov
  REAL,INTENT(IN) :: pdteta(iip1,jjb_u:jje_u,llm) ! dynamical tendency on teta ! not used
  REAL,INTENT(IN) :: pdq(iip1,jjb_u:jje_u,llm,nqtot) ! dynamical tendency on tracers ! not used

  REAL,INTENT(IN) :: pps(iip1,jjb_u:jje_u) ! surface pressure (Pa)
  REAL,INTENT(IN) :: pp(iip1,jjb_u:jje_u,llmp1) ! pressure at mesh interfaces (Pa)
  REAL,INTENT(IN) :: ppk(iip1,jjb_u:jje_u,llm) ! Exner at mid-layer
  REAL,INTENT(IN) :: flxw(iip1,jjb_u:jje_u,llm) ! Vertical mass flux on lower mesh interfaces (kg/s) (on llm because flxw(:,:,llm+1)=0)

  ! ! tendencies (in */s) from the physics
  REAL,INTENT(OUT) :: pdvfi(iip1,jjb_v:jje_v,llm) ! tendency on covariant meridional wind
  REAL,INTENT(OUT) :: pdufi(iip1,jjb_u:jje_u,llm) ! tendency on covariant zonal wind
  REAL,INTENT(OUT) :: pdhfi(iip1,jjb_u:jje_u,llm) ! tendency on potential temperature (K/s)
  REAL,INTENT(OUT) :: pdqfi(iip1,jjb_u:jje_u,llm,nqtot) ! tendency on tracers
  REAL,INTENT(OUT) :: pdpsfi(iip1,jjb_u:jje_u) ! tendency on surface pressure (Pa/s)

  ! Ehouarn: for now calfis_p needs some informations from physics to compile
  !    Local variables :
  !    -----------------

  INTEGER :: i,j,l,ig0,ig,iq,itr
  REAL,ALLOCATABLE,SAVE :: zpsrf(:)
  REAL,ALLOCATABLE,SAVE :: zplev(:,:),zplay(:,:)
  REAL,ALLOCATABLE,SAVE :: zphi(:,:),zphis(:)
  !
  REAL :: zrot(iip1,jjb_v:jje_v,llm) ! AdlC May 2014
  REAL,ALLOCATABLE,SAVE :: zufi(:,:), zvfi(:,:), zrfi(:,:)
  REAL,ALLOCATABLE,SAVE :: ztfi(:,:),zqfi(:,:,:)
  REAL,ALLOCATABLE,SAVE ::  zpk(:,:)
  !
  REAL,ALLOCATABLE,SAVE :: pcvgu(:,:), pcvgv(:,:)
  REAL,ALLOCATABLE,SAVE :: pcvgt(:,:), pcvgq(:,:,:)
  !
  REAL,ALLOCATABLE,SAVE :: zdufi(:,:),zdvfi(:,:)
  REAL,ALLOCATABLE,SAVE :: zdtfi(:,:),zdqfi(:,:,:)
  REAL,ALLOCATABLE,SAVE :: zdpsrf(:)
  REAL,SAVE,ALLOCATABLE ::  flxwfi(:,:)     ! Flux de masse verticale sur la grille physiq

  !
  REAL,ALLOCATABLE,SAVE :: zplev_omp(:,:)
  REAL,ALLOCATABLE,SAVE :: zplay_omp(:,:)
  REAL,ALLOCATABLE,SAVE :: zpk_omp(:,:)
  REAL,ALLOCATABLE,SAVE :: zphi_omp(:,:)
  REAL,ALLOCATABLE,SAVE :: zphis_omp(:)
  REAL,ALLOCATABLE,SAVE :: presnivs_omp(:)
  REAL,ALLOCATABLE,SAVE :: zufi_omp(:,:)
  REAL,ALLOCATABLE,SAVE :: zvfi_omp(:,:)
  REAL,ALLOCATABLE,SAVE :: zrfi_omp(:,:)
  REAL,ALLOCATABLE,SAVE :: ztfi_omp(:,:)
  REAL,ALLOCATABLE,SAVE :: zqfi_omp(:,:,:)
  REAL,ALLOCATABLE,SAVE :: zdufi_omp(:,:)
  REAL,ALLOCATABLE,SAVE :: zdvfi_omp(:,:)
  REAL,ALLOCATABLE,SAVE :: zdtfi_omp(:,:)
  REAL,ALLOCATABLE,SAVE :: zdqfi_omp(:,:,:)
  REAL,ALLOCATABLE,SAVE :: zdpsrf_omp(:)
  REAL,SAVE,ALLOCATABLE ::  flxwfi_omp(:,:)     ! Flux de masse verticale sur la grille physiq

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Introduction du splitting (FH)
  ! Question pour Yann :
  ! J'ai ete surpris au debut que les tableaux zufi_omp, zdufi_omp n'co soient
  ! en SAVE. Je crois comprendre que c'est parce que tu voulais qu'ils
  ! soient allocatable (plutot par exemple que de passer une dimension
  ! dependant du process en argument des routines) et que, du coup,
  ! le SAVE evite d'avoir a refaire l'allocation a chaque appel.
  ! Tu confirmes ?
  ! J'ai suivi le meme principe pour les zdufic_omp
  ! Mais c'est surement bien que tu controles.
  !

  REAL,ALLOCATABLE,SAVE :: zdufic_omp(:,:)
  REAL,ALLOCATABLE,SAVE :: zdvfic_omp(:,:)
  REAL,ALLOCATABLE,SAVE :: zdtfic_omp(:,:)
  REAL,ALLOCATABLE,SAVE :: zdqfic_omp(:,:,:)
  REAL :: jH_cur_split,zdt_split
  LOGICAL :: debut_split,lafin_split
  INTEGER :: isplit
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!$OMP THREADPRIVATE(zplev_omp,zplay_omp,zpk_omp,zphi_omp,zphis_omp, &
!$OMP                  presnivs_omp,zufi_omp,zvfi_omp,ztfi_omp, &
!$OMP                  zrfi_omp,zqfi_omp,zdufi_omp,zdvfi_omp, &
!$OMP                  zdtfi_omp,zdqfi_omp,zdpsrf_omp,flxwfi_omp, &
!$OMP                  zdufic_omp,zdvfic_omp,zdtfic_omp,zdqfic_omp)

  LOGICAL,SAVE :: first_omp=.true.
!$OMP THREADPRIVATE(first_omp)

  REAL :: zsin(iim),zcos(iim),z1(iim)
  REAL :: zsinbis(iim),zcosbis(iim),z1bis(iim)
  REAL :: unskap, pksurcp
  !
  REAL :: SSUM

  LOGICAL,SAVE :: firstcal=.true., debut=.true.
!$OMP THREADPRIVATE(firstcal,debut)

  REAL,SAVE,dimension(1:iim,1:llm):: du_send,du_recv,dv_send,dv_recv
  INTEGER :: ierr
  INTEGER,dimension(MPI_STATUS_SIZE,4) :: Status
  INTEGER, dimension(4) :: Req
  REAL,ALLOCATABLE,SAVE:: zdufi2(:,:),zdvfi2(:,:)
  integer :: k,kstart,kend
  INTEGER :: offset
  INTEGER :: jjb,jje

  IF (CPPKEY_PHYS) THEN

  !
  !-----------------------------------------------------------------------
  !
  !    1. Initialisations :
  !    --------------------
  !

  klon=klon_mpi

  !
  IF ( firstcal )  THEN
    debut = .TRUE.
    IF (ngridmx.NE.2+(jjm-1)*iim) THEN
      write(lunout,*) 'STOP dans calfis'
      write(lunout,*) &
            'La dimension ngridmx doit etre egale a 2 + (jjm-1)*iim'
      write(lunout,*) '  ngridmx  jjm   iim   '
      write(lunout,*) ngridmx,jjm,iim
      call abort_gcm("calfis_loc", "", 1)
    ENDIF
!$OMP MASTER
    ALLOCATE(zpsrf(klon))
    ALLOCATE(zplev(klon,llm+1),zplay(klon,llm))
    ALLOCATE(zphi(klon,llm),zphis(klon))
    ALLOCATE(zufi(klon,llm), zvfi(klon,llm),zrfi(klon,llm))
    ALLOCATE(ztfi(klon,llm),zqfi(klon,llm,nqtot))
    ALLOCATE(pcvgu(klon,llm), pcvgv(klon,llm))
    ALLOCATE(pcvgt(klon,llm), pcvgq(klon,llm,2))
    ALLOCATE(zdufi(klon,llm),zdvfi(klon,llm))
    ALLOCATE(zdtfi(klon,llm),zdqfi(klon,llm,nqtot))
    ALLOCATE(zdpsrf(klon))
    ALLOCATE(zdufi2(klon+iim,llm),zdvfi2(klon+iim,llm))
    ALLOCATE(flxwfi(klon,llm))
    ALLOCATE(zpk(klon,llm))
!$OMP END MASTER
!$OMP BARRIER
  ELSE
    debut = .FALSE.
  ENDIF

  !
  !
  !-----------------------------------------------------------------------
  !   40. transformation des variables dynamiques en variables physiques:
  !   ---------------------------------------------------------------

  !   41. pressions au sol (en Pascals)
  !   ----------------------------------

!$OMP MASTER
  CALL start_timer(timer_physic)
!$OMP END MASTER

!$OMP MASTER
  !CDIR ON_ADB(index_i)
  !CDIR ON_ADB(index_j)
  DO ig0=1,klon
    i=index_i(ig0)
    j=index_j(ig0)
    zpsrf(ig0)=pps(i,j)
  ENDDO
!$OMP END MASTER


  !   42. pression intercouches :
  !
  !   -----------------------------------------------------------------
  ! .... zplev  definis aux (llm +1) interfaces des couches  ....
  ! .... zplay  definis aux (  llm )    milieux des couches  ....
  !   -----------------------------------------------------------------

  !    ...    Exner = cp * ( p(l) / preff ) ** kappa     ....
  !
   unskap   = 1./ kappa
  !
  !  print *,omp_rank,'klon--->',klon
!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
  DO l = 1, llmp1
  !CDIR ON_ADB(index_i)
  !CDIR ON_ADB(index_j)
    DO ig0=1,klon
      i=index_i(ig0)
      j=index_j(ig0)
      zplev( ig0,l ) = pp(i,j,l)
    ENDDO
  ENDDO
!$OMP END DO NOWAIT

!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
  DO l=1,llm
    DO ig0=1,klon
      i=index_i(ig0)
      j=index_j(ig0)
      zpk(ig0,l)=ppk(i,j,l)
    ENDDO
  ENDDO
!$OMP END DO NOWAIT

  !
  !

  !   43. temperature naturelle (en K) et pressions milieux couches .
  !   ---------------------------------------------------------------
!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
  DO l=1,llm
  !CDIR ON_ADB(index_i)
  !CDIR ON_ADB(index_j)
    DO ig0=1,klon
      i=index_i(ig0)
      j=index_j(ig0)
      pksurcp        = ppk(i,j,l) / cpp
      zplay(ig0,l)   = preff * pksurcp ** unskap
      ztfi(ig0,l)    = pteta(i,j,l)  * pksurcp
    ENDDO

  ENDDO
!$OMP END DO NOWAIT

  !   43.bis traceurs
  !   ---------------
  !

  itr = 0
  DO iq=1,nqtot
     IF(tracers(iq)%iadv < 0) CYCLE
     itr = itr + 1
!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
     DO l=1,llm
  !CDIR ON_ADB(index_i)
  !CDIR ON_ADB(index_j)
       DO ig0=1,klon
         i=index_i(ig0)
         j=index_j(ig0)
         zqfi(ig0,l,itr)  = pq(i,j,l,iq)
       ENDDO
     ENDDO
!$OMP END DO NOWAIT
  ENDDO


  !   Geopotentiel calcule par rapport a la surface locale:
  !   -----------------------------------------------------

!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
  DO l=1,llm
  !CDIR ON_ADB(index_i)
  !CDIR ON_ADB(index_j)
     DO ig0=1,klon
       i=index_i(ig0)
       j=index_j(ig0)
       zphi(ig0,l)  = pphi(i,j,l)
     ENDDO
  ENDDO
!$OMP END DO NOWAIT

   ! CALL gr_dyn_fi_p(llm,iip1,jjp1,klon,pphi,zphi)

!$OMP MASTER
  !CDIR ON_ADB(index_i)
  !CDIR ON_ADB(index_j)
  DO ig0=1,klon
    i=index_i(ig0)
    j=index_j(ig0)
    zphis(ig0)  = pphis(i,j)
  ENDDO
!$OMP END MASTER


   ! CALL gr_dyn_fi_p(1,iip1,jjp1,klon,pphis,zphis)

!$OMP BARRIER

!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
  DO l=1,llm
     DO ig=1,klon
       zphi(ig,l)=zphi(ig,l)-zphis(ig)
     ENDDO
  ENDDO
!$OMP END DO NOWAIT


  !
  !   45. champ u:
  !   ------------

  kstart=1
  kend=klon

  if (is_north_pole_dyn) kstart=2
  if (is_south_pole_dyn) kend=klon-1

!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
  DO l=1,llm
  !CDIR ON_ADB(index_i)
  !CDIR ON_ADB(index_j)
  !CDIR SPARSE
    do ig0=kstart,kend
      i=index_i(ig0)
      j=index_j(ig0)
      if (i==1) then
        zufi(ig0,l)= 0.5 *(  pucov(iim,j,l)/cu(iim,j) &
              + pucov(1,j,l)/cu(1,j) )
      else
        zufi(ig0,l)= 0.5*(  pucov(i-1,j,l)/cu(i-1,j) &
              + pucov(i,j,l)/cu(i,j) )
      endif
    enddo
  ENDDO
!$OMP END DO NOWAIT

  !
  !  Alvaro de la Camara (May 2014)
  !  46.1 Calcul de la vorticite et passage sur la grille physique
  !  --------------------------------------------------------------

  jjb=jj_begin_dyn-1
  jje=jj_end_dyn+1
  if (is_north_pole_dyn) jjb=1
  if (is_south_pole_dyn) jje=jjm

!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)

  DO l=1,llm
    do i=1,iim
      do j=jjb,jje
        zrot(i,j,l) = (pvcov(i+1,j,l) - pvcov(i,j,l) &
                     + pucov(i,j+1,l) - pucov(i,j,l)) &
                     / (cu(i,j)+cu(i,j+1)) &
                     / (cv(i+1,j)+cv(i,j)) *4
      enddo
    enddo
  ENDDO


  !   46.2champ v:
  !   -----------

!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
  DO l=1,llm
  !CDIR ON_ADB(index_i)
  !CDIR ON_ADB(index_j)
    DO ig0=kstart,kend
      i=index_i(ig0)
      j=index_j(ig0)
      zvfi(ig0,l)= 0.5 *(  pvcov(i,j-1,l)/cv(i,j-1) &
                         + pvcov(i,j,l)/cv(i,j) )
      if (j==1 .OR. j==jjp1) then !  AdlC MAY 2014
        zrfi(ig0,l) = 0 !  AdlC MAY 2014
      else
        if(i==1)then
        zrfi(ig0,l)= 0.25 *(zrot(iim,j-1,l)+zrot(iim,j,l) &
                     +zrot(1,j-1,l)+zrot(1,j,l))   !  AdlC MAY 2014
        else
        zrfi(ig0,l)= 0.25 *(zrot(i-1,j-1,l)+zrot(i-1,j,l) &
                     +zrot(i,j-1,l)+zrot(i,j,l))   !  AdlC MAY 2014
        endif
      endif


     ENDDO
  ENDDO
!$OMP END DO NOWAIT

  !   47. champs de vents aux pole nord
  !   ------------------------------
     ! U = 1 / pi  *  integrale [ v * cos(long) * d long ]
     ! V = 1 / pi  *  integrale [ v * sin(long) * d long ]

  if (is_north_pole_dyn) then
!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
    DO l=1,llm

       z1(1)   =(rlonu(1)-rlonu(iim)+2.*pi)*pvcov(1,1,l)/cv(1,1)
       DO i=2,iim
          z1(i)   =(rlonu(i)-rlonu(i-1))*pvcov(i,1,l)/cv(i,1)
       ENDDO

       DO i=1,iim
          zcos(i)   = COS(rlonv(i))*z1(i)
          zsin(i)   = SIN(rlonv(i))*z1(i)
       ENDDO

       zufi(1,l)  = SSUM(iim,zcos,1)/pi
       zvfi(1,l)  = SSUM(iim,zsin,1)/pi
       zrfi(1,l)  = 0.

    ENDDO
!$OMP END DO NOWAIT
  endif


  !   48. champs de vents aux pole sud:
  !   ---------------------------------
     ! U = 1 / pi  *  integrale [ v * cos(long) * d long ]
     ! V = 1 / pi  *  integrale [ v * sin(long) * d long ]

  if (is_south_pole_dyn) then
!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
    DO l=1,llm

     z1(1)   =(rlonu(1)-rlonu(iim)+2.*pi)*pvcov(1,jjm,l)/cv(1,jjm)
       DO i=2,iim
         z1(i)   =(rlonu(i)-rlonu(i-1))*pvcov(i,jjm,l)/cv(i,jjm)
       ENDDO

       DO i=1,iim
          zcos(i)    = COS(rlonv(i))*z1(i)
          zsin(i)    = SIN(rlonv(i))*z1(i)
       ENDDO

       zufi(klon,l)  = SSUM(iim,zcos,1)/pi
       zvfi(klon,l)  = SSUM(iim,zsin,1)/pi
       zrfi(klon,l)  = 0.
    ENDDO
!$OMP END DO NOWAIT
  endif

  ! On change de grille, dynamique vers physiq, pour le flux de masse verticale
!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
     DO l=1,llm
  !CDIR ON_ADB(index_i)
  !CDIR ON_ADB(index_j)
       do ig0=1,klon
         i=index_i(ig0)
         j=index_j(ig0)
         flxwfi(ig0,l)  = flxw(i,j,l)
       enddo
     ENDDO
!$OMP END DO NOWAIT

   ! CALL gr_dyn_fi_p(llm,iip1,jjp1,klon,flxw,flxwfi)

  !-----------------------------------------------------------------------
  !   Appel de la physique:
  !   ---------------------


!$OMP BARRIER
  if (first_omp) then
    klon=klon_omp

    allocate(zplev_omp(klon,llm+1))
    allocate(zplay_omp(klon,llm))
    allocate(zpk_omp(klon,llm))
    allocate(zphi_omp(klon,llm))
    allocate(zphis_omp(klon))
    allocate(presnivs_omp(llm))
    allocate(zufi_omp(klon,llm))
    allocate(zvfi_omp(klon,llm))
    allocate(zrfi_omp(klon,llm))  ! LG Ari 2014
    allocate(ztfi_omp(klon,llm))
    allocate(zqfi_omp(klon,llm,nqtot))
    allocate(zdufi_omp(klon,llm))
    allocate(zdvfi_omp(klon,llm))
    allocate(zdtfi_omp(klon,llm))
    allocate(zdqfi_omp(klon,llm,nqtot))
    allocate(zdufic_omp(klon,llm))
    allocate(zdvfic_omp(klon,llm))
    allocate(zdtfic_omp(klon,llm))
    allocate(zdqfic_omp(klon,llm,nqtot))
    allocate(zdpsrf_omp(klon))
    allocate(flxwfi_omp(klon,llm))
    first_omp=.false.
  endif


  klon=klon_omp
  offset=klon_omp_begin-1

  do l=1,llm+1
    do i=1,klon
      zplev_omp(i,l)=zplev(offset+i,l)
    enddo
  enddo

   do l=1,llm
    do i=1,klon
      zplay_omp(i,l)=zplay(offset+i,l)
    enddo
  enddo

   do l=1,llm
    do i=1,klon
      zpk_omp(i,l)=zpk(offset+i,l)
    enddo
  enddo

  do l=1,llm
    do i=1,klon
      zphi_omp(i,l)=zphi(offset+i,l)
    enddo
  enddo

  do i=1,klon
    zphis_omp(i)=zphis(offset+i)
  enddo


  do l=1,llm
    presnivs_omp(l)=presnivs(l)
  enddo

  do l=1,llm
    do i=1,klon
      zufi_omp(i,l)=zufi(offset+i,l)
    enddo
  enddo

  do l=1,llm
    do i=1,klon
      zvfi_omp(i,l)=zvfi(offset+i,l)
    enddo
  enddo

  do l=1,llm
    do i=1,klon
      zrfi_omp(i,l)=zrfi(offset+i,l)
    enddo
  enddo

  do l=1,llm
    do i=1,klon
      ztfi_omp(i,l)=ztfi(offset+i,l)
    enddo
  enddo

  do iq=1,nqtot
    do l=1,llm
      do i=1,klon
        zqfi_omp(i,l,iq)=zqfi(offset+i,l,iq)
      enddo
    enddo
  enddo

  do l=1,llm
    do i=1,klon
      zdufi_omp(i,l)=zdufi(offset+i,l)
    enddo
  enddo

  do l=1,llm
    do i=1,klon
      zdvfi_omp(i,l)=zdvfi(offset+i,l)
    enddo
  enddo

  do l=1,llm
    do i=1,klon
      zdtfi_omp(i,l)=zdtfi(offset+i,l)
    enddo
  enddo

  do iq=1,nqtot
    do l=1,llm
      do i=1,klon
        zdqfi_omp(i,l,iq)=zdqfi(offset+i,l,iq)
      enddo
    enddo
  enddo

  do i=1,klon
    zdpsrf_omp(i)=zdpsrf(offset+i)
  enddo

  do l=1,llm
    do i=1,klon
      flxwfi_omp(i,l)=flxwfi(offset+i,l)
    enddo
  enddo

!$OMP BARRIER


!$OMP MASTER
   ! write(lunout,*) 'PHYSIQUE AVEC NSPLIT_PHYS=',nsplit_phys
!$OMP END MASTER
  zdt_split=dtphys/nsplit_phys
  zdufic_omp(:,:)=0.
  zdvfic_omp(:,:)=0.
  zdtfic_omp(:,:)=0.
  zdqfic_omp(:,:,:)=0.

IF (CPPKEY_PHYS) THEN
  do isplit=1,nsplit_phys

     jH_cur_split=jH_cur+(isplit-1) * dtvr / (daysec *nsplit_phys)
     debut_split=debut.and.isplit==1
     lafin_split=lafin.and.isplit==nsplit_phys

    CALL call_physiq(klon,llm,nqtot,tracers(:)%name, &
                     debut_split,lafin_split, &
                     jD_cur,jH_cur_split,zdt_split, &
                     zplev_omp,zplay_omp, &
                     zpk_omp,zphi_omp,zphis_omp, &
                     presnivs_omp, &
                     zufi_omp,zvfi_omp,zrfi_omp,ztfi_omp,zqfi_omp, &
                     flxwfi_omp,pducov, &
                     zdufi_omp,zdvfi_omp,zdtfi_omp,zdqfi_omp, &
                     zdpsrf_omp)


     zufi_omp(:,:)=zufi_omp(:,:)+zdufi_omp(:,:)*zdt_split
     zvfi_omp(:,:)=zvfi_omp(:,:)+zdvfi_omp(:,:)*zdt_split
     ztfi_omp(:,:)=ztfi_omp(:,:)+zdtfi_omp(:,:)*zdt_split
     zqfi_omp(:,:,:)=zqfi_omp(:,:,:)+zdqfi_omp(:,:,:)*zdt_split

     zdufic_omp(:,:)=zdufic_omp(:,:)+zdufi_omp(:,:)
     zdvfic_omp(:,:)=zdvfic_omp(:,:)+zdvfi_omp(:,:)
     zdtfic_omp(:,:)=zdtfic_omp(:,:)+zdtfi_omp(:,:)
     zdqfic_omp(:,:,:)=zdqfic_omp(:,:,:)+zdqfi_omp(:,:,:)

  enddo

END IF
  ! of #ifdef CPP_PHYS


  zdufi_omp(:,:)=zdufic_omp(:,:)/nsplit_phys
  zdvfi_omp(:,:)=zdvfic_omp(:,:)/nsplit_phys
  zdtfi_omp(:,:)=zdtfic_omp(:,:)/nsplit_phys
  zdqfi_omp(:,:,:)=zdqfic_omp(:,:,:)/nsplit_phys

!$OMP BARRIER

  do l=1,llm+1
    do i=1,klon
      zplev(offset+i,l)=zplev_omp(i,l)
    enddo
  enddo

   do l=1,llm
    do i=1,klon
      zplay(offset+i,l)=zplay_omp(i,l)
    enddo
  enddo

  do l=1,llm
    do i=1,klon
      zphi(offset+i,l)=zphi_omp(i,l)
    enddo
  enddo


  do i=1,klon
    zphis(offset+i)=zphis_omp(i)
  enddo


  do l=1,llm
    presnivs(l)=presnivs_omp(l)
  enddo

  do l=1,llm
    do i=1,klon
      zufi(offset+i,l)=zufi_omp(i,l)
    enddo
  enddo

  do l=1,llm
    do i=1,klon
      zvfi(offset+i,l)=zvfi_omp(i,l)
    enddo
  enddo

  do l=1,llm
    do i=1,klon
      ztfi(offset+i,l)=ztfi_omp(i,l)
    enddo
  enddo

  do iq=1,nqtot
    do l=1,llm
      do i=1,klon
        zqfi(offset+i,l,iq)=zqfi_omp(i,l,iq)
      enddo
    enddo
  enddo

  do l=1,llm
    do i=1,klon
      zdufi(offset+i,l)=zdufi_omp(i,l)
    enddo
  enddo

  do l=1,llm
    do i=1,klon
      zdvfi(offset+i,l)=zdvfi_omp(i,l)
    enddo
  enddo

  do l=1,llm
    do i=1,klon
      zdtfi(offset+i,l)=zdtfi_omp(i,l)
    enddo
  enddo

  do iq=1,nqtot
    do l=1,llm
      do i=1,klon
        zdqfi(offset+i,l,iq)=zdqfi_omp(i,l,iq)
      enddo
    enddo
  enddo

  do i=1,klon
    zdpsrf(offset+i)=zdpsrf_omp(i)
  enddo


  klon=klon_mpi

!!SN 500   CONTINUE !not used

!$OMP BARRIER

!$OMP MASTER
  call stop_timer(timer_physic)
!$OMP END MASTER

  IF (using_mpi) THEN

  if (MPI_rank>0) then

!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
   DO l=1,llm
    du_send(1:iim,l)=zdufi(1:iim,l)
    dv_send(1:iim,l)=zdvfi(1:iim,l)
   ENDDO
!$OMP END DO NOWAIT

!$OMP BARRIER

!$OMP MASTER
!$OMP CRITICAL (MPI)
    call MPI_ISSEND(du_send,iim*llm,MPI_REAL8,MPI_Rank-1,401, &
          COMM_LMDZ,Req(1),ierr)
    call MPI_ISSEND(dv_send,iim*llm,MPI_REAL8,MPI_Rank-1,402, &
          COMM_LMDZ,Req(2),ierr)
!$OMP END CRITICAL (MPI)
!$OMP END MASTER

!$OMP BARRIER

  endif

  if (MPI_rank<MPI_Size-1) then
!$OMP BARRIER

!$OMP MASTER
!$OMP CRITICAL (MPI)
    call MPI_IRECV(du_recv,iim*llm,MPI_REAL8,MPI_Rank+1,401, &
          COMM_LMDZ,Req(3),ierr)
    call MPI_IRECV(dv_recv,iim*llm,MPI_REAL8,MPI_Rank+1,402, &
          COMM_LMDZ,Req(4),ierr)
!$OMP END CRITICAL (MPI)
!$OMP END MASTER

  endif

!$OMP BARRIER


!$OMP MASTER
!$OMP CRITICAL (MPI)
  if (MPI_rank>0 .and. MPI_rank< MPI_Size-1) then
    call MPI_WAITALL(4,Req(1),Status,ierr)
  else if (MPI_rank>0) then
    call MPI_WAITALL(2,Req(1),Status,ierr)
  else if (MPI_rank <MPI_Size-1) then
    call MPI_WAITALL(2,Req(3),Status,ierr)
  endif
!$OMP END CRITICAL (MPI)
!$OMP END MASTER

!$OMP BARRIER

  ENDIF ! using_mpi


!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
  DO l=1,llm

    zdufi2(1:klon,l)=zdufi(1:klon,l)
    zdufi2(klon+1:klon+iim,l)=du_recv(1:iim,l)

    zdvfi2(1:klon,l)=zdvfi(1:klon,l)
    zdvfi2(klon+1:klon+iim,l)=dv_recv(1:iim,l)

    pdhfi(:,jj_begin,l)=0
    pdqfi(:,jj_begin,l,:)=0
    pdufi(:,jj_begin,l)=0
    pdvfi(:,jj_begin,l)=0

    if (.not. is_south_pole_dyn) then
      pdhfi(:,jj_end:jj_end+1,l)=0
      pdqfi(:,jj_end:jj_end+1,l,:)=0
      pdufi(:,jj_end:jj_end+1,l)=0
      pdvfi(:,jj_end:jj_end+1,l)=0
    endif

   ENDDO
!$OMP END DO NOWAIT

!$OMP MASTER
    pdpsfi(:,jj_begin)=0

   if (.not. is_south_pole_dyn) then
     pdpsfi(:,jj_end:jj_end+1)=0
   endif
!$OMP END MASTER
  !-----------------------------------------------------------------------
  !   transformation des tendances physiques en tendances dynamiques:
  !   ---------------------------------------------------------------

  !  tendance sur la pression :
  !  -----------------------------------
   ! CALL gr_fi_dyn_p(1,klon,iip1,jjp1,zdpsrf,pdpsfi)

!$OMP MASTER
  kstart=1
  kend=klon

  if (is_north_pole_dyn) kstart=2
  if (is_south_pole_dyn)  kend=klon-1

  !CDIR ON_ADB(index_i)
  !CDIR ON_ADB(index_j)
  !cdir NODEP
    do ig0=kstart,kend
      i=index_i(ig0)
      j=index_j(ig0)
      pdpsfi(i,j) = zdpsrf(ig0)
      if (i==1) pdpsfi(iip1,j) =  zdpsrf(ig0)
     enddo

    if (is_north_pole_dyn) then
        DO i=1,iip1
          pdpsfi(i,1)    = zdpsrf(1)
        enddo
    endif

    if (is_south_pole_dyn) then
        DO i=1,iip1
          pdpsfi(i,jjp1) = zdpsrf(klon)
        ENDDO
    endif
!$OMP END MASTER
  !c$OMP BARRIER

  !
  !   62. enthalpie potentielle
  !   ---------------------

  kstart=1
  kend=klon

  if (is_north_pole_dyn) kstart=2
  if (is_south_pole_dyn)  kend=klon-1

!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
  DO l=1,llm

  !CDIR ON_ADB(index_i)
  !CDIR ON_ADB(index_j)
  !cdir NODEP
    do ig0=kstart,kend
      i=index_i(ig0)
      j=index_j(ig0)
      pdhfi(i,j,l) = cpp * zdtfi(ig0,l) / ppk(i,j,l)
      if (i==1) pdhfi(iip1,j,l) =  cpp * zdtfi(ig0,l) / ppk(i,j,l)
     enddo

    if (is_north_pole_dyn) then
        DO i=1,iip1
          pdhfi(i,1,l)    = cpp *  zdtfi(1,l)      / ppk(i, 1  ,l)
        enddo
    endif

    if (is_south_pole_dyn) then
        DO i=1,iip1
          pdhfi(i,jjp1,l) = cpp *  zdtfi(klon,l)/ ppk(i,jjp1,l)
        ENDDO
    endif
  ENDDO
!$OMP END DO NOWAIT

  !   62. humidite specifique
  !   ---------------------
  ! Ehouarn: removed this useless bit: was overwritten at step 63 anyways
   ! DO iq=1,nqtot
  !c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
   !    DO l=1,llm
  !!!cdir NODEP
   !      do ig0=kstart,kend
   !        i=index_i(ig0)
   !        j=index_j(ig0)
   !        pdqfi(i,j,l,iq) = zdqfi(ig0,l,iq)
   !        if (i==1) pdqfi(iip1,j,l,iq) = zdqfi(ig0,l,iq)
   !      enddo
  !
  !       if (is_north_pole_dyn) then
  !         do i=1,iip1
  !           pdqfi(i,1,l,iq)    = zdqfi(1,l,iq)
  !         enddo
  !       endif
  !
  !       if (is_south_pole_dyn) then
  !         do i=1,iip1
  !           pdqfi(i,jjp1,l,iq) = zdqfi(klon,l,iq)
  !         enddo
  !       endif
  !     ENDDO
  !c$OMP END DO NOWAIT
  !  ENDDO

  !   63. traceurs
  !   ------------
  ! initialisation des tendances

!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
  DO l=1,llm
    pdqfi(:,jj_begin:jj_end,l,:)=0.
  ENDDO
!$OMP END DO NOWAIT

  !
  !cdir NODEP
  itr = 0
  DO iq=1,nqtot
     IF(tracers(iq)%iadv < 0) CYCLE
     itr = itr + 1
!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
     DO l=1,llm
  !CDIR ON_ADB(index_i)
  !CDIR ON_ADB(index_j)
  !cdir NODEP
         DO ig0=kstart,kend
          i=index_i(ig0)
          j=index_j(ig0)
          pdqfi(i,j,l,iq) = zdqfi(ig0,l,itr)
          if (i==1) pdqfi(iip1,j,l,iq) = zdqfi(ig0,l,itr)
        ENDDO

        IF (is_north_pole_dyn) then
          DO i=1,iip1
            pdqfi(i,1,l,iq)    = zdqfi(1,l,itr)
          ENDDO
        ENDIF

        IF (is_south_pole_dyn) then
          DO i=1,iip1
            pdqfi(i,jjp1,l,iq) = zdqfi(klon,l,itr)
          ENDDO
        ENDIF

     ENDDO
!$OMP END DO NOWAIT
  ENDDO

  !   65. champ u:
  !   ------------
!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
  DO l=1,llm
  !CDIR ON_ADB(index_i)
  !CDIR ON_ADB(index_j)
  !cdir NODEP
     do ig0=kstart,kend
       i=index_i(ig0)
       j=index_j(ig0)

       if (i/=iim) then
         pdufi(i,j,l)=0.5*(zdufi2(ig0,l)+zdufi2(ig0+1,l))*cu(i,j)
       endif

       if (i==1) then
         pdufi(iim,j,l)=0.5*(  zdufi2(ig0,l) &
                             + zdufi2(ig0+iim-1,l))*cu(iim,j)
         pdufi(iip1,j,l)=0.5*(zdufi2(ig0,l)+zdufi2(ig0+1,l))*cu(i,j)
       endif

     enddo

     if (is_north_pole_dyn) then
       DO i=1,iip1
        pdufi(i,1,l)    = 0.
       ENDDO
     endif

     if (is_south_pole_dyn) then
       DO i=1,iip1
        pdufi(i,jjp1,l) = 0.
       ENDDO
     endif

  ENDDO
!$OMP END DO NOWAIT

  !   67. champ v:
  !   ------------

  kstart=1
  kend=klon

  if (is_north_pole_dyn) kstart=2
  if (is_south_pole_dyn)  kend=klon-1-iim

!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
  DO l=1,llm
  !CDIR ON_ADB(index_i)
  !CDIR ON_ADB(index_j)
  !cdir NODEP
    do ig0=kstart,kend
       i=index_i(ig0)
       j=index_j(ig0)
       pdvfi(i,j,l)=0.5*(zdvfi2(ig0,l)+zdvfi2(ig0+iim,l))*cv(i,j)
       if (i==1) pdvfi(iip1,j,l) = 0.5*(zdvfi2(ig0,l) &
                                        + zdvfi2(ig0+iim,l))*cv(i,j)
    enddo

  ENDDO
!$OMP END DO NOWAIT


  !   68. champ v pres des poles:
  !   ---------------------------
   ! v = U * cos(long) + V * SIN(long)

  if (is_north_pole_dyn) then

!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
    DO l=1,llm

      DO i=1,iim
        pdvfi(i,1,l)= &
              zdufi(1,l)*COS(rlonv(i))+zdvfi(1,l)*SIN(rlonv(i))

        pdvfi(i,1,l)= &
              0.5*(pdvfi(i,1,l)+zdvfi(i+1,l))*cv(i,1)
      ENDDO

      pdvfi(iip1,1,l)  = pdvfi(1,1,l)

    ENDDO
!$OMP END DO NOWAIT

  endif

  if (is_south_pole_dyn) then

!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
     DO l=1,llm

       DO i=1,iim
          pdvfi(i,jjm,l)=zdufi(klon,l)*COS(rlonv(i)) &
                        +zdvfi(klon,l)*SIN(rlonv(i))

          pdvfi(i,jjm,l)= &
                0.5*(pdvfi(i,jjm,l)+zdvfi(klon-iip1+i,l))*cv(i,jjm)
       ENDDO

       pdvfi(iip1,jjm,l)= pdvfi(1,jjm,l)

    ENDDO
!$OMP END DO NOWAIT

  endif
  !-----------------------------------------------------------------------

!!SN 700   CONTINUE !not used

  firstcal = .FALSE.

ELSE
  call abort_gcm("calfis_loc", &
        "calfis_p: for now can only work with parallel physics", 1)
END IF
END SUBROUTINE calfis_loc
#endif

MODULE lmdz_lscp_ini

!----------------------------------------------------------
! This module initializes all the parameters needed for the
! lscp (large scale clouds and precipitation) routines.
!----------------------------------------------------------

   IMPLICIT NONE

   ! PARAMETERS for lscp_main:
   !-------------------------

   REAL RCPD, RLSTT, RLVTT, RLMLT, RVTMP2, RTT, RD, RV, RG, RPI, EPS_W
   !$OMP THREADPRIVATE(RCPD, RLSTT, RLVTT, RLMLT, RVTMP2, RTT, RD, RV, RG, RPI, EPS_W)

   REAL, SAVE, PROTECTED :: seuil_neb = 0.001       ! cloud fraction threshold: a cloud can precipitate when exceeded
   !$OMP THREADPRIVATE(seuil_neb)

   REAL, SAVE, PROTECTED :: min_neb_th = 1e-10      ! a cloud produced by bi-gaussian really exists when exceeded
   !$OMP THREADPRIVATE(min_neb_th)

   REAL, SAVE, PROTECTED :: min_frac_thermals = 1.e-10   ! minimum thermals fraction for use of bigaussian distribution
   !$OMP THREADPRIVATE(min_frac_thermals)

   REAL, SAVE, PROTECTED :: qlmax = 999.           ! maximum possible liquid water specific content in a mesh [kg/kg]
   !$OMP THREADPRIVATE(qlmax)

   REAL, SAVE, PROTECTED :: qimax = 999.           ! maximum possible ice water specific content in a mesh [kg/kg]
   !$OMP THREADPRIVATE(qimax)

   INTEGER, SAVE :: lunout, prt_level            ! Logical unit number and level for standard output
   !$OMP THREADPRIVATE(lunout,prt_level)

   INTEGER, SAVE, PROTECTED :: niter_lscp = 5      ! number of iterations to calculate autoconversion to precipitation
   !$OMP THREADPRIVATE(niter_lscp)

   INTEGER, SAVE, PROTECTED :: iflag_ice_thermo    ! activation of ice thermodynamics
   !$OMP THREADPRIVATE(iflag_ice_thermo)

   INTEGER, SAVE, PROTECTED :: iflag_cld_th        ! controls the properties of clouds in presence of thermals
   !$OMP THREADPRIVATE(iflag_cld_th)

   INTEGER, SAVE, PROTECTED :: iflag_evap_prec = 1 ! precipitation evaporation flag. 0: nothing, 1: "old way",
   ! 2: Max cloud fraction above to calculate the max of reevaporation
   ! >=4: LTP'method i.e. evaporation in the clear-sky fraction of the mesh only
   ! pay attention that iflag_evap_prec=4 may lead to unrealistic and overestimated
   ! evaporation. Use 5 instead
   !$OMP THREADPRIVATE(iflag_evap_prec)

   REAL, SAVE, PROTECTED :: t_coup = 234.0         ! temperature threshold which determines the phase
   ! for which the saturation vapor pressure is calculated
   !$OMP THREADPRIVATE(t_coup)
   REAL, SAVE, PROTECTED :: DDT0 = 0.01            ! iteration parameter
   !$OMP THREADPRIVATE(DDT0)

   REAL, SAVE, PROTECTED :: ztfondue = 278.15      ! parameter to calculate melting fraction of precipitation
   !$OMP THREADPRIVATE(ztfondue)

   REAL, SAVE, PROTECTED :: temp_nowater = 235.15  ! temperature below which liquid water no longer exists
   !$OMP THREADPRIVATE(temp_nowater)

   REAL, SAVE, PROTECTED :: a_tr_sca(4)          ! Variables for tracers temporary: alpha parameter for scavenging, 4 possible scavenging processes
   !$OMP THREADPRIVATE(a_tr_sca)

   REAL, SAVE, PROTECTED ::  min_frac_th_cld = 1.e-10   ! minimum thermal fraction to compute a thermal cloud fraction
   !$OMP THREADPRIVATE(min_frac_th_cld)

   LOGICAL, SAVE, PROTECTED :: ok_radocond_snow = .false. ! take into account the mass of ice precip in the cloud ice content seen by radiation
   !$OMP THREADPRIVATE(ok_radocond_snow)

   REAL, SAVE, PROTECTED :: t_glace_min = 258.0    ! lower-bound temperature parameter for cloud phase determination
   !$OMP THREADPRIVATE(t_glace_min)

   REAL, SAVE, PROTECTED :: t_glace_max = 273.15   ! upper-bound temperature parameter for cloud phase determination
   !$OMP THREADPRIVATE(t_glace_max)

   REAL, SAVE, PROTECTED :: exposant_glace = 1.0   ! parameter for cloud phase determination
   !$OMP THREADPRIVATE(exposant_glace)

   INTEGER, SAVE, PROTECTED :: iflag_vice = 0      ! which expression for ice crystall fall velocity
   !$OMP THREADPRIVATE(iflag_vice)

   INTEGER, SAVE, PROTECTED :: iflag_t_glace = 0   ! which expression for cloud phase partitioning
   !$OMP THREADPRIVATE(iflag_t_glace)

   INTEGER, SAVE, PROTECTED :: iflag_gammasat = 0              ! which threshold for homogeneous nucleation below -40oC
   !$OMP THREADPRIVATE(iflag_gammasat)

   INTEGER, SAVE, PROTECTED :: iflag_rain_incloud_vol = 0      ! use of volume cloud fraction for rain autoconversion
   !$OMP THREADPRIVATE(iflag_rain_incloud_vol)

   INTEGER, SAVE, PROTECTED :: iflag_bergeron = 0              ! bergeron effect for liquid precipitation treatment
   !$OMP THREADPRIVATE(iflag_bergeron)

   INTEGER, SAVE, PROTECTED :: iflag_fisrtilp_qsat = 0         ! qsat adjustment (iterative) during autoconversion
   !$OMP THREADPRIVATE(iflag_fisrtilp_qsat)

   INTEGER, SAVE, PROTECTED :: iflag_pdf = 0                   ! type of subgrid scale qtot pdf
   !$OMP THREADPRIVATE(iflag_pdf)

   INTEGER, SAVE, PROTECTED :: iflag_icefrac = 0               ! which phase partitioning function to use
   !$OMP THREADPRIVATE(iflag_icefrac)

   INTEGER, SAVE, PROTECTED :: iflag_autoconversion = 0        ! autoconversion option
   !$OMP THREADPRIVATE(iflag_autoconversion)

   LOGICAL, SAVE, PROTECTED :: ok_bug_phase_lscp = .true.      ! bug on phase partitioning after precipitation processes
   !$OMP THREADPRIVATE(ok_bug_phase_lscp)

   LOGICAL, SAVE, PROTECTED :: reevap_ice = .false.            ! no liquid precip for T< threshold
   !$OMP THREADPRIVATE(reevap_ice)

   REAL, SAVE, PROTECTED :: cld_lc_lsc = 2.6e-4                ! liquid autoconversion coefficient, stratiform rain
   !$OMP THREADPRIVATE(cld_lc_lsc)

   REAL, SAVE, PROTECTED :: cld_lc_con = 2.6e-4                ! liquid autoconversion coefficient, convective rain
   !$OMP THREADPRIVATE(cld_lc_con)

   REAL, SAVE, PROTECTED :: cld_tau_lsc = 3600.                ! liquid autoconversion timescale, stratiform rain
   !$OMP THREADPRIVATE(cld_tau_lsc)

   REAL, SAVE, PROTECTED :: cld_tau_con = 3600.                ! liquid autoconversion timescale, convective rain
   !$OMP THREADPRIVATE(cld_tau_con)

   REAL, SAVE, PROTECTED :: cld_expo_lsc = 2.                  ! liquid autoconversion threshold exponent, stratiform rain
   !$OMP THREADPRIVATE(cld_expo_lsc)

   REAL, SAVE, PROTECTED :: cld_expo_con = 2.                  ! liquid autoconversion threshold exponent, convective rain
   !$OMP THREADPRIVATE(cld_expo_con)

   REAL, SAVE, PROTECTED :: ffallv_lsc = 1.                    ! tuning coefficient crystal fall velocity, stratiform
   !$OMP THREADPRIVATE(ffallv_lsc)

   REAL, SAVE, PROTECTED :: ffallv_con = 1.                    ! tuning coefficient crystal fall velocity, convective
   !$OMP THREADPRIVATE(ffallv_con)

   REAL, SAVE, PROTECTED :: coef_eva = 2e-5                    ! tuning coefficient liquid precip evaporation
   !$OMP THREADPRIVATE(coef_eva)

   REAL, SAVE, PROTECTED :: coef_sub                         ! tuning coefficient ice precip sublimation
   !$OMP THREADPRIVATE(coef_sub)

   REAL, SAVE, PROTECTED :: expo_eva = 0.5                     ! tuning coefficient liquid precip evaporation
   !$OMP THREADPRIVATE(expo_eva)

   REAL, SAVE, PROTECTED :: expo_sub                         ! tuning coefficient ice precip sublimation
   !$OMP THREADPRIVATE(expo_sub)

   REAL, SAVE, PROTECTED :: cice_velo = 1.645                  ! factor in the ice fall velocity formulation. It is half the value of
   ! Heymsfield and Donner 1990 to concur with previous LMDZ versions
   !$OMP THREADPRIVATE(cice_velo)

   REAL, SAVE, PROTECTED ::  dice_velo = 0.16                  ! exponent in the ice fall velocity formulation
   !$OMP THREADPRIVATE(dice_velo)

   REAL, SAVE, PROTECTED :: dist_liq = 300.                    ! typical deph of cloud-top liquid layer in mpcs
   !$OMP THREADPRIVATE(dist_liq)

   REAL, SAVE, PROTECTED  :: tresh_cl = 0.0                  ! cloud fraction threshold for cloud top search
   !$OMP THREADPRIVATE(tresh_cl)

   !--Parameters for condensation and ice supersaturation

   LOGICAL, SAVE, PROTECTED :: ok_ice_supersat = .FALSE.        ! activates the condensation scheme that allows for ice supersaturation
   !$OMP THREADPRIVATE(ok_ice_supersat)

   LOGICAL, SAVE, PROTECTED :: ok_unadjusted_clouds = .FALSE.   ! if True, relax the saturation adjustment assumption for ice clouds
   !$OMP THREADPRIVATE(ok_unadjusted_clouds)

   LOGICAL, SAVE, PROTECTED :: ok_weibull_warm_clouds = .FALSE. ! if True, the weibull condensation scheme replaces the lognormal condensation scheme at positive temperatures
   !$OMP THREADPRIVATE(ok_weibull_warm_clouds)

   INTEGER, SAVE, PROTECTED :: iflag_cloud_sublim_pdf = 4       ! iflag for the distribution of water inside ice clouds
   !$OMP THREADPRIVATE(iflag_cloud_sublim_pdf)

   REAL, SAVE, PROTECTED :: depo_coef_cirrus = .7               ! [-] deposition coefficient for growth of ice crystals in cirrus clouds
   !$OMP THREADPRIVATE(depo_coef_cirrus)

   REAL, SAVE, PROTECTED :: capa_cond_cirrus = .5               ! [-] capacitance factor for growth/sublimation of ice crystals in cirrus clouds
   !$OMP THREADPRIVATE(capa_cond_cirrus)

   REAL, SAVE, PROTECTED :: std_subl_pdf_lscp = 2.              ! [%] standard deviation of the gaussian distribution of water inside ice clouds
   !$OMP THREADPRIVATE(std_subl_pdf_lscp)

   REAL, SAVE, PROTECTED :: mu_subl_pdf_lscp = 1./3.            ! [-] shape factor of the gamma distribution of water inside ice clouds
   !$OMP THREADPRIVATE(mu_subl_pdf_lscp)

   REAL, SAVE, PROTECTED :: beta_pdf_lscp = 1.E-3               ! [SI] tuning coefficient for the standard deviation of the PDF of water vapor in the clear sky region
   !$OMP THREADPRIVATE(beta_pdf_lscp)

   REAL, SAVE, PROTECTED :: temp_thresh_pdf_lscp = 189.         ! [K] factor for the PDF fit of water vapor in UTLS - below this temperature, water vapor is homogeneously distributed in the clear sky region
   !$OMP THREADPRIVATE(temp_thresh_pdf_lscp)

   REAL, SAVE, PROTECTED :: k0_pdf_lscp = 3.01                  ! [-] factor for the PDF fit of water vapor in UTLS
   !$OMP THREADPRIVATE(k0_pdf_lscp)

   REAL, SAVE, PROTECTED :: kappa_pdf_lscp = 0.0192             ! [] factor for the PDF fit of water vapor in UTLS
   !$OMP THREADPRIVATE(kappa_pdf_lscp)

   REAL, SAVE, PROTECTED :: std100_pdf_lscp = 4.08              ! [%] standard deviation at RHliq=100% of the PDF fit of water vapor in UTLS
   !$OMP THREADPRIVATE(std100_pdf_lscp)

   REAL, SAVE, PROTECTED :: a_homofreez = 2.349                 ! [-] factor for the Koop homogeneous freezing fit
   !$OMP THREADPRIVATE(a_homofreez)

   REAL, SAVE, PROTECTED :: b_homofreez = 259.                  ! [K] factor for the Koop homogeneous freezing fit
   !$OMP THREADPRIVATE(b_homofreez)

   REAL, SAVE, PROTECTED :: delta_hetfreez = 1.                 ! [-] value between 0 and 1 to simulate for heterogeneous freezing.
   !$OMP THREADPRIVATE(delta_hetfreez)

   REAL, SAVE, PROTECTED :: coef_mixing_lscp = 1.E-3            ! [-] tuning coefficient for the mixing process
   !$OMP THREADPRIVATE(coef_mixing_lscp)

   REAL, SAVE, PROTECTED :: coef_shear_lscp = 0.72              ! [-] additional coefficient for the shearing process (subprocess of the mixing process)
   !$OMP THREADPRIVATE(coef_shear_lscp)

   REAL, SAVE, PROTECTED :: chi_mixing_lscp = 1.                ! [-] factor for the macro distribution of ISSRs wrt clouds in a gridbox
   !$OMP THREADPRIVATE(chi_mixing_lscp)
   !--End of the parameters for condensation and ice supersaturation

   !--Parameters for poprecip and cloud phase
   LOGICAL, SAVE, PROTECTED :: ok_poprecip = .FALSE.           ! use the processes-oriented formulation of precipitations
   !$OMP THREADPRIVATE(ok_poprecip)

   LOGICAL, SAVE, PROTECTED :: ok_corr_vap_evasub = .FALSE.    ! use the corrected version of clear-sky water vapor for the evap / subl processes
   !$OMP THREADPRIVATE(ok_corr_vap_evasub)

   LOGICAL, SAVE, PROTECTED :: ok_growth_precip_deposition = .FALSE. ! allows growth of snowfall through vapor deposition in supersat. regions
   !$OMP THREADPRIVATE(ok_growth_precip_deposition)

   REAL, SAVE, PROTECTED :: cld_lc_lsc_snow = 2.e-5            ! snow autoconversion coefficient, stratiform. default from  Chaboureau and PInty 2006
   !$OMP THREADPRIVATE(cld_lc_lsc_snow)

   REAL, SAVE, PROTECTED :: cld_lc_con_snow = 2.e-5            ! snow autoconversion coefficient, convective
   !$OMP THREADPRIVATE(cld_lc_con_snow)

   REAL, SAVE, PROTECTED :: rain_int_min = 1.e-5               ! Minimum local rain intensity [mm/s] before the decrease in associated precipitation fraction
   !$OMP THREADPRIVATE(rain_int_min)

   REAL, SAVE, PROTECTED :: thresh_precip_frac = 1.E-6         ! precipitation fraction threshold [-]
   !$OMP THREADPRIVATE(thresh_precip_frac)

   REAL, SAVE, PROTECTED :: capa_crystal = 1.                  ! Crystal capacitance (shape factor) for lscp_icefrac_turb [-]
   !$OMP THREADPRIVATE(capa_crystal)

   LOGICAL, SAVE, PROTECTED :: fix_icnc = .FALSE.             ! fix ice crystal number concentration for cloud phase determination  
   !$OMP THREADPRIVATE(fix_icnc)

   REAL, SAVE, PROTECTED :: icnc0 = 10.                       ! prescribed ice crystal number concentration for cloud phase determination  [L-1]
   !$OMP THREADPRIVATE(icnc0)

   REAL, SAVE, PROTECTED :: naero5 = 0.5                       ! Number concentration of aerosol larger than 0.5 microns [scm-3]
   !$OMP THREADPRIVATE(naero5)

   REAL, SAVE, PROTECTED :: gamma_snwretro = 0.              ! Proportion of snow taken into account in ice retroaction in lscp_icefrac_turb [-]
   !$OMP THREADPRIVATE(gamma_snwretro)

   REAL, SAVE, PROTECTED :: gamma_mixth = 1.                 ! Tuning coeff for mixing with thermals/env in lscp_icefrac_turb [-]
   !$OMP THREADPRIVATE(gamma_mixth)

   REAL, SAVE, PROTECTED :: gamma_taud = 1.                  ! Tuning coeff for Lagrangian decorrelation timescale in lscp_icefrac_turb [-]
   !$OMP THREADPRIVATE(gamma_taud)

   REAL, SAVE, PROTECTED :: gamma_col = 1.                     ! Tuning coefficient for rain collection efficiency (poprecip) [-]
   !$OMP THREADPRIVATE(gamma_col)

   REAL, SAVE, PROTECTED :: gamma_agg = 1.                     ! Tuning coefficient for snow aggregation efficiency (poprecip) [-]
   !$OMP THREADPRIVATE(gamma_agg)

   REAL, SAVE, PROTECTED :: gamma_rim = 1.                     ! Tuning coefficient for riming efficiency (poprecip) [-]
   !$OMP THREADPRIVATE(gamma_rim)

   REAL, SAVE, PROTECTED :: gamma_melt = 1.                    ! Tuning coefficient for snow melting efficiency (poprecip) [-]
   !$OMP THREADPRIVATE(gamma_melt)

   REAL, SAVE, PROTECTED :: gamma_freez = 1.                   ! Tuning coefficient for rain collision freezing efficiency (poprecip) [-]
   !$OMP THREADPRIVATE(gamma_freez)

   REAL, SAVE, PROTECTED :: rho_rain = 1000.                   ! Rain density [kg/m3]
   !$OMP THREADPRIVATE(rho_rain)

   REAL, SAVE, PROTECTED :: rho_ice = 920.                     ! Ice crystal density (assuming spherical geometry) [kg/m3]
   !$OMP THREADPRIVATE(rho_ice)

   REAL, SAVE, PROTECTED :: r_rain = 500.E-6                   ! Rain droplets radius (poprecip) [m]
   !$OMP THREADPRIVATE(r_rain)

   REAL, SAVE, PROTECTED :: r_snow = 1.E-3                     ! Ice crystals radius (poprecip) [m]
   !$OMP THREADPRIVATE(r_snow)

   REAL, SAVE, PROTECTED :: tau_auto_snow_min = 1200.           ! Snow autoconversion minimal timescale (when liquid) [s]
   !$OMP THREADPRIVATE(tau_auto_snow_min)

   REAL, SAVE, PROTECTED :: tau_auto_snow_max = 3600.          ! Snow autoconversion minimal timescale (when only ice) [s]
   !$OMP THREADPRIVATE(tau_auto_snow_max)

   REAL, SAVE, PROTECTED :: expo_tau_auto_snow = 0.1          ! Snow autoconversion timescale exponent for icefrac dependency
   !$OMP THREADPRIVATE(expo_tau_auto_snow)

   REAL, SAVE, PROTECTED :: eps = 1.E-10                       ! Treshold 0 [-]
   !$OMP THREADPRIVATE(eps)

   REAL, SAVE, PROTECTED :: alpha_freez = 4.                   ! Slope of exponential for immersion freezing timescale [-]
   !$OMP THREADPRIVATE(alpha_freez)

   REAL, SAVE, PROTECTED :: beta_freez = 0.1                   ! Inv.time immersion freezing [s-1]
   !$OMP THREADPRIVATE(beta_freez)

   REAL, SAVE, PROTECTED :: rain_fallspeed = 4.                ! Rain fall velocity [m/s]
   !$OMP THREADPRIVATE(rain_fallspeed)

   REAL, SAVE, PROTECTED :: rain_fallspeed_clr               ! Rain fall velocity in clear sky [m/s]
   !$OMP THREADPRIVATE(rain_fallspeed_clr)

   REAL, SAVE, PROTECTED :: rain_fallspeed_cld               ! Rain fall velocity in cloudy sky [m/s]
   !$OMP THREADPRIVATE(rain_fallspeed_cld)

   REAL, SAVE, PROTECTED :: snow_fallspeed = 1.                ! Snow fall velocity [m/s]
   !$OMP THREADPRIVATE(snow_fallspeed)

   REAL, SAVE, PROTECTED :: snow_fallspeed_clr               ! Snow fall velocity in clear sky [m/s]
   !$OMP THREADPRIVATE(snow_fallspeed_clr)

   REAL, SAVE, PROTECTED :: snow_fallspeed_cld               ! Snow fall velocity in cloudy sky [m/s]
   !$OMP THREADPRIVATE(snow_fallspeed_cld)
   !--End of the parameters for poprecip

   ! Parameters for cloudth routines
   LOGICAL, SAVE, PROTECTED :: ok_lscp_mergecond = .false.     ! more consistent condensation stratiform and shallow convective clouds
   !$OMP THREADPRIVATE(ok_lscp_mergecond)

   LOGICAL, SAVE, PROTECTED :: ok_bug_deficit = .true.        ! bug in saturation deficit calculation (in old cloudth routines) found out by JYG in 02/2026 true by default.
   !$OMP THREADPRIVATE(ok_bug_deficit)

   INTEGER, SAVE, PROTECTED :: iflag_cloudth_vert = 0          ! option for determining cloud fraction and content in convective boundary layers
   !$OMP THREADPRIVATE(iflag_cloudth_vert)

   INTEGER, SAVE, PROTECTED :: iflag_cloudth_vert_noratqs = 0  ! option to control the width of gaussian distrib in a specific case
   !$OMP THREADPRIVATE(iflag_cloudth_vert_noratqs)

   REAL, SAVE, PROTECTED :: cloudth_ratqsmin = -1.             ! minimum ratqs in cloudth
   !$OMP THREADPRIVATE(cloudth_ratqsmin)

   REAL, SAVE, PROTECTED :: sigma1s_factor = 1.1               ! factor for standard deviation of gaussian distribution of environment
   !$OMP THREADPRIVATE(sigma1s_factor)

   REAL, SAVE, PROTECTED :: sigma2s_factor = 0.09              ! factor for standard deviation of gaussian distribution of thermals
   !$OMP THREADPRIVATE(sigma2s_factor)

   REAL, SAVE, PROTECTED :: sigma1s_power = 0.6                ! exponent for standard deviation of gaussian distribution of environment
   !$OMP THREADPRIVATE(sigma1s_power)

   REAL, SAVE, PROTECTED :: sigma2s_power = 0.5                ! exponent for standard deviation of gaussian distribution of thermals
   !$OMP THREADPRIVATE(sigma2s_power)

   REAL, SAVE, PROTECTED :: vert_alpha = 0.5                   ! tuning coefficient for standard deviation of gaussian distribution of thermals
   !$OMP THREADPRIVATE(vert_alpha)

   REAL, SAVE, PROTECTED :: vert_alpha_th = 0.5                ! tuning coefficient for standard deviation of gaussian distribution of thermals
   !$OMP THREADPRIVATE(vert_alpha_th)
   ! End of parameters for cloudth routines

   ! parameters for subgrid variability (ratqs) routines

   INTEGER, SAVE, PROTECTED :: iflag_ratqs = 1               ! control of ratqs option
   !$OMP THREADPRIVATE(iflag_ratqs)

   REAL, SAVE, PROTECTED :: ratqshaut = 0.3                  ! ratqs [-] value at the top of the atmosphere
   !$OMP THREADPRIVATE(ratqshaut)

   REAL, SAVE, PROTECTED :: ratqsbas = 0.01                  ! ratqs [-] value near the ground
   !$OMP THREADPRIVATE(ratqsbas)

   REAL, SAVE, PROTECTED :: ratqsdp = 20000.                 ! delta pressure [Pa] that controls the atan variation of ratqs with pressure
   !$OMP THREADPRIVATE(ratqsdp)

   REAL, SAVE, PROTECTED :: ratqsp0 = 50000.                 ! pressure [Pa] where the atan variation of ratqs with pressure occurs
   !$OMP THREADPRIVATE(ratqsp0)

   REAL, SAVE, PROTECTED :: tau_ratqs = 1800.                ! timescale [s] used when combining convective and stratiform ratqs
   !$OMP THREADPRIVATE(tau_ratqs)

   REAL, SAVE, PROTECTED :: a_ratqs_cv = 1.                  ! a_ratqs_cv and a_ratqs_wake control the contibution of cold pools to
   ! water subgrid variability
   !$OMP THREADPRIVATE(a_ratqs_cv)

   REAL, SAVE, PROTECTED :: a_ratqs_wake = 3.
   !$OMP THREADPRIVATE(a_ratqs_wake)

   REAL, SAVE, PROTECTED :: tau_var = 700.0                  ! relaxation time for variability in thermals [s]
   !$OMP THREADPRIVATE(tau_var)

   REAL, SAVE, PROTECTED :: fac_tau = 2.
   !$OMP THREADPRIVATE(fac_tau)

   REAL, SAVE, PROTECTED :: tau_cumul = 1000.
   !$OMP THREADPRIVATE(tau_cumul)

   INTEGER, SAVE, PROTECTED :: dqimpl = 1
   !$OMP THREADPRIVATE(dqimpl)

   REAL, ALLOCATABLE, SAVE :: povariance(:, :)
   !$OMP THREADPRIVATE(povariance)

   REAL, ALLOCATABLE, SAVE :: var_conv(:, :)
   !$OMP THREADPRIVATE(var_conv)

   ! Two parameters used for lmdz_lscp_old only
   INTEGER, SAVE, PROTECTED :: iflag_oldbug_fisrtilp = 0, fl_cor_ebil
   !$OMP THREADPRIVATE(iflag_oldbug_fisrtilp,fl_cor_ebil)

CONTAINS

      SUBROUTINE lscp_ini(dtime, klon, klev, iflag_thermals, iflag_cld_th_in,  &
                       iflag_ice_thermo_in, lunout_in, prt_level_in,           &
                       ok_ice_supersat_in, fl_cor_ebil_in, &
                       RCPD_in, RLSTT_in, RLVTT_in, RLMLT_in, RVTMP2_in, &
                       RTT_in, RD_in, RV_in, RG_in, RPI_in, EPS_W_in, &
                       pfrac_nucl, pfrac_1nucl, pfrac_impa)

      USE ioipsl_getin_p_mod, ONLY: getin_p

      REAL, INTENT(IN)      :: dtime
      INTEGER, INTENT(IN)   :: klon, klev, iflag_thermals
      INTEGER, INTENT(IN)   :: iflag_cld_th_in, iflag_ice_thermo_in
      INTEGER, INTENT(IN)   :: lunout_in, prt_level_in, fl_cor_ebil_in
      LOGICAL, INTENT(IN)   :: ok_ice_supersat_in
      REAL, INTENT(IN)      :: RCPD_in, RLSTT_in, RLVTT_in, RLMLT_in
      REAL, INTENT(IN)      :: RVTMP2_in, RTT_in, RD_in, RV_in, RG_in, RPI_in, EPS_W_in
      ! Coeffients for off-line aerosols scavenging
      REAL, DIMENSION(klon, klev), INTENT(INOUT)  :: pfrac_nucl
      REAL, DIMENSION(klon, klev), INTENT(INOUT)  :: pfrac_1nucl
      REAL, DIMENSION(klon, klev), INTENT(INOUT)  :: pfrac_impa


      CHARACTER(len=20) :: modname = 'lscp_ini_mod'
      CHARACTER(len=80) :: abort_message

      INTEGER               :: i, k

      lunout = lunout_in
      prt_level = prt_level_in
      fl_cor_ebil = fl_cor_ebil_in
      ok_ice_supersat = ok_ice_supersat_in
      iflag_cld_th=iflag_cld_th_in
      iflag_ice_thermo=iflag_ice_thermo_in

      RG = RG_in
      RD = RD_in
      RV = RV_in
      RCPD = RCPD_in
      RLVTT = RLVTT_in
      RLSTT = RLSTT_in
      RLMLT = RLMLT_in
      RTT = RTT_in
      RV = RV_in
      RVTMP2 = RVTMP2_in
      RPI = RPI_in
      EPS_W = EPS_W_in

      IF (iflag_thermals == 15 .OR. iflag_thermals == 16) THEN
         dqimpl = -1
      END IF

      CALL getin_p('niter_lscp', niter_lscp)
      CALL getin_p('iflag_evap_prec', iflag_evap_prec)
      CALL getin_p('seuil_neb', seuil_neb)

      CALL getin_p('oliqmax', qlmax)
      CALL getin_p('qlmax', qlmax)

      CALL getin_p('oicemax', qimax)
      CALL getin_p('qimax', qimax)

      CALL getin_p('ok_radocond_snow', ok_radocond_snow)
      CALL getin_p('t_glace_max', t_glace_max)
      CALL getin_p('t_glace_min', t_glace_min)
      CALL getin_p('exposant_glace', exposant_glace)
      CALL getin_p('iflag_vice', iflag_vice)
      CALL getin_p('iflag_t_glace', iflag_t_glace)
      CALL getin_p('iflag_gammasat', iflag_gammasat)
      CALL getin_p('iflag_rain_incloud_vol', iflag_rain_incloud_vol)
      CALL getin_p('iflag_bergeron', iflag_bergeron)
      CALL getin_p('iflag_fisrtilp_qsat', iflag_fisrtilp_qsat)
      CALL getin_p('iflag_pdf', iflag_pdf)
      CALL getin_p('iflag_icefrac', iflag_icefrac)
      CALL getin_p('reevap_ice', reevap_ice)
      CALL getin_p('cld_lc_lsc', cld_lc_lsc)
      CALL getin_p('cld_lc_con', cld_lc_con)
      CALL getin_p('cld_lc_lsc_snow', cld_lc_lsc_snow)
      CALL getin_p('cld_lc_con_snow', cld_lc_con_snow)
      CALL getin_p('cld_tau_lsc', cld_tau_lsc)
      CALL getin_p('cld_tau_con', cld_tau_con)
      CALL getin_p('cld_expo_lsc', cld_expo_lsc)
      CALL getin_p('cld_expo_con', cld_expo_con)
      CALL getin_p('ffallv_lsc', ffallv_lsc)
      CALL getin_p('ffallv_lsc', ffallv_con)

      ! for poprecip and cloud phase
      CALL getin_p('coef_eva', coef_eva)
      coef_sub = coef_eva
      CALL getin_p('coef_eva_i', coef_sub)
      CALL getin_p('coef_sub', coef_sub)
      CALL getin_p('expo_eva', expo_eva)
      expo_sub = expo_eva
      CALL getin_p('expo_sub', expo_sub)
      CALL getin_p('iflag_autoconversion', iflag_autoconversion)
      CALL getin_p('dist_liq', dist_liq)
      CALL getin_p('tresh_cl', tresh_cl)
      CALL getin_p('fix_icnc', fix_icnc)
      CALL getin_p('icnc0', icnc0)
      CALL getin_p('capa_crystal', capa_crystal)
      CALL getin_p('naero5', naero5)
      CALL getin_p('gamma_snwretro', gamma_snwretro)
      CALL getin_p('gamma_taud', gamma_taud)
      CALL getin_p('gamma_mixth', gamma_mixth)
      CALL getin_p('iflag_oldbug_fisrtilp', iflag_oldbug_fisrtilp)
      CALL getin_p('temp_nowater', temp_nowater)
      CALL getin_p('ok_bug_phase_lscp', ok_bug_phase_lscp)
      CALL getin_p('ok_poprecip', ok_poprecip)
      CALL getin_p('ok_corr_vap_evasub', ok_corr_vap_evasub)
      CALL getin_p('ok_growth_precip_deposition', ok_growth_precip_deposition)
      CALL getin_p('rain_int_min', rain_int_min)
      CALL getin_p('gamma_agg', gamma_agg)
      CALL getin_p('gamma_col', gamma_col)
      CALL getin_p('gamma_rim', gamma_rim)
      CALL getin_p('gamma_freez', gamma_freez)
      CALL getin_p('gamma_melt', gamma_melt)
      CALL getin_p('tau_auto_snow_max', tau_auto_snow_max)
      CALL getin_p('tau_auto_snow_min', tau_auto_snow_min)
      CALL getin_p('expo_tau_auto_snow', expo_tau_auto_snow)
      CALL getin_p('alpha_freez', alpha_freez)
      CALL getin_p('beta_freez', beta_freez)
      CALL getin_p('r_snow', r_snow)
      CALL getin_p('rain_fallspeed', rain_fallspeed)
      rain_fallspeed_clr = rain_fallspeed
      rain_fallspeed_cld = rain_fallspeed
      CALL getin_p('rain_fallspeed_clr', rain_fallspeed_clr)
      CALL getin_p('rain_fallspeed_cld', rain_fallspeed_cld)
      CALL getin_p('snow_fallspeed', snow_fallspeed)
      snow_fallspeed_clr = snow_fallspeed
      snow_fallspeed_cld = snow_fallspeed
      CALL getin_p('snow_fallspeed_clr', snow_fallspeed_clr)
      CALL getin_p('snow_fallspeed_cld', snow_fallspeed_cld)

      ! for condensation and ice supersaturation
      CALL getin_p('ok_unadjusted_clouds', ok_unadjusted_clouds)
      CALL getin_p('ok_weibull_warm_clouds', ok_weibull_warm_clouds)
      CALL getin_p('iflag_cloud_sublim_pdf', iflag_cloud_sublim_pdf)
      CALL getin_p('depo_coef_cirrus', depo_coef_cirrus)
      CALL getin_p('capa_cond_cirrus', capa_cond_cirrus)
      CALL getin_p('std_subl_pdf_lscp', std_subl_pdf_lscp)
      CALL getin_p('mu_subl_pdf_lscp', mu_subl_pdf_lscp)
      CALL getin_p('beta_pdf_lscp', beta_pdf_lscp)
      CALL getin_p('temp_thresh_pdf_lscp', temp_thresh_pdf_lscp)
      CALL getin_p('k0_pdf_lscp', k0_pdf_lscp)
      CALL getin_p('kappa_pdf_lscp', kappa_pdf_lscp)
      CALL getin_p('std100_pdf_lscp', std100_pdf_lscp)
      CALL getin_p('a_homofreez', a_homofreez)
      CALL getin_p('b_homofreez', b_homofreez)
      CALL getin_p('delta_hetfreez', delta_hetfreez)
      CALL getin_p('coef_mixing_lscp', coef_mixing_lscp)
      CALL getin_p('coef_shear_lscp', coef_shear_lscp)
      CALL getin_p('chi_mixing_lscp', chi_mixing_lscp)

      ! for cloudth routines
      CALL getin_p('ok_lscp_mergecond', ok_lscp_mergecond)
      CALL getin_p('ok_bug_deficit', ok_bug_deficit)
      CALL getin_p('iflag_cloudth_vert', iflag_cloudth_vert)
      CALL getin_p('cloudth_ratqsmin', cloudth_ratqsmin)
      CALL getin_p('cloudth_sigma1s_factor', sigma1s_factor)
      CALL getin_p('cloudth_sigma1s_power', sigma1s_power)
      CALL getin_p('cloudth_sigma2s_factor', sigma2s_factor)
      CALL getin_p('cloudth_sigma2s_power', sigma2s_power)
      CALL getin_p('cloudth_vert_alpha', vert_alpha)
      vert_alpha_th = vert_alpha
      CALL getin_p('cloudth_vert_alpha_th', vert_alpha_th)
      CALL getin_p('iflag_cloudth_vert_noratqs', iflag_cloudth_vert_noratqs)

      ! for subgrid water variability (ratqs) routines
      CALL getin_p('iflag_ratqs', iflag_ratqs)
      CALL getin_p('ratqshaut', ratqshaut)
      CALL getin_p('ratqsbas', ratqsbas)
      CALL getin_p('ratqsdp', ratqsdp)
      CALL getin_p('ratqsp0', ratqsp0)
      CALL getin_p('tau_ratqs', tau_ratqs)
      CALL getin_p('tau_var', tau_var)
      CALL getin_p('fac_tau', fac_tau)
      CALL getin_p('tau_cumul', tau_cumul)
      CALL getin_p('a_ratqs_wake', a_ratqs_wake)
      CALL getin_p('a_ratqs_cv', a_ratqs_cv)

      WRITE (lunout, *) 'lscp_ini, niter_lscp:', niter_lscp
      WRITE (lunout, *) 'lscp_ini, iflag_evap_prec:', iflag_evap_prec
      WRITE (lunout, *) 'lscp_ini, seuil_neb:', seuil_neb
      WRITE (lunout, *) 'lscp_ini, qlmax:', qlmax
      WRITE (lunout, *) 'lscp_ini, qimax:', qimax
      WRITE (lunout, *) 'lscp_ini, ok_radocond_snow:', ok_radocond_snow
      WRITE (lunout, *) 'lscp_ini, t_glace_max:', t_glace_max
      WRITE (lunout, *) 'lscp_ini, t_glace_min:', t_glace_min
      WRITE (lunout, *) 'lscp_ini, exposant_glace:', exposant_glace
      WRITE (lunout, *) 'lscp_ini, iflag_vice:', iflag_vice
      WRITE (lunout, *) 'lscp_ini, iflag_t_glace:', iflag_t_glace
      WRITE (lunout, *) 'lscp_ini, iflag_gammasat:', iflag_gammasat
      WRITE (lunout, *) 'lscp_ini, iflag_rain_incloud_vol:', iflag_rain_incloud_vol
      WRITE (lunout, *) 'lscp_ini, iflag_bergeron:', iflag_bergeron
      WRITE (lunout, *) 'lscp_ini, iflag_fisrtilp_qsat:', iflag_fisrtilp_qsat
      WRITE (lunout, *) 'lscp_ini, iflag_pdf', iflag_pdf
      WRITE (lunout, *) 'lscp_ini, iflag_icefrac', iflag_icefrac
      WRITE (lunout, *) 'lscp_ini, reevap_ice', reevap_ice
      WRITE (lunout, *) 'lscp_ini, cld_lc_lsc', cld_lc_lsc
      WRITE (lunout, *) 'lscp_ini, cld_lc_con', cld_lc_con
      WRITE (lunout, *) 'lscp_ini, cld_lc_lsc_snow', cld_lc_lsc_snow
      WRITE (lunout, *) 'lscp_ini, cld_lc_con_snow', cld_lc_con_snow
      WRITE (lunout, *) 'lscp_ini, cld_tau_lsc', cld_tau_lsc
      WRITE (lunout, *) 'lscp_ini, cld_tau_con', cld_tau_con
      WRITE (lunout, *) 'lscp_ini, cld_expo_lsc', cld_expo_lsc
      WRITE (lunout, *) 'lscp_ini, cld_expo_con', cld_expo_con
      WRITE (lunout, *) 'lscp_ini, ffallv_lsc', ffallv_lsc
      WRITE (lunout, *) 'lscp_ini, ffallv_con', ffallv_con
      WRITE (lunout, *) 'lscp_ini, coef_eva', coef_eva
      WRITE (lunout, *) 'lscp_ini, coef_sub', coef_sub
      WRITE (lunout, *) 'lscp_ini, expo_eva', expo_eva
      WRITE (lunout, *) 'lscp_ini, expo_sub', expo_sub
      WRITE (lunout, *) 'lscp_ini, iflag_autoconversion', iflag_autoconversion
      WRITE (lunout, *) 'lscp_ini, dist_liq', dist_liq
      WRITE (lunout, *) 'lscp_ini, tresh_cl', tresh_cl
      WRITE (lunout, *) 'lscp_ini, capa_crystal', capa_crystal
      WRITE (lunout, *) 'lscp_ini, naero5', naero5
      WRITE (lunout, *) 'lscp_ini, fix_icnc', fix_icnc
      WRITE (lunout, *) 'lscp_ini, icnc0', icnc0
      WRITE (lunout, *) 'lscp_ini, gamma_snwretro', gamma_snwretro
      WRITE (lunout, *) 'lscp_ini, gamma_mixth', gamma_mixth
      WRITE (lunout, *) 'lscp_ini, gamma_taud', gamma_taud
      WRITE (lunout, *) 'lscp_ini, iflag_oldbug_fisrtilp', iflag_oldbug_fisrtilp
      WRITE (lunout, *) 'lscp_ini, fl_cor_ebil', fl_cor_ebil
      WRITE (lunout, *) 'lscp_ini, temp_nowater', temp_nowater
      WRITE (lunout, *) 'lscp_ini, ok_bug_phase_lscp', ok_bug_phase_lscp
      WRITE (lunout, *) 'lscp_ini, iflag_cld_th', iflag_cld_th
      WRITE (lunout, *) 'lscp_ini, iflag_ice_thermo', iflag_ice_thermo

      ! for poprecip
      WRITE (lunout, *) 'lscp_ini, ok_poprecip', ok_poprecip
      WRITE (lunout, *) 'lscp_ini, ok_corr_vap_evasub', ok_corr_vap_evasub
      WRITE (lunout, *) 'lscp_ini, ok_growth_precip_deposition', ok_growth_precip_deposition
      WRITE (lunout, *) 'lscp_ini, rain_int_min:', rain_int_min
      WRITE (lunout, *) 'lscp_ini, gamma_agg:', gamma_agg
      WRITE (lunout, *) 'lscp_ini, gamma_col:', gamma_col
      WRITE (lunout, *) 'lscp_ini, gamma_rim:', gamma_rim
      WRITE (lunout, *) 'lscp_ini, gamma_freez:', gamma_freez
      WRITE (lunout, *) 'lscp_ini, gamma_melt:', gamma_melt
      WRITE (lunout, *) 'lscp_ini, tau_auto_snow_max:', tau_auto_snow_max
      WRITE (lunout, *) 'lscp_ini, tau_auto_snow_min:', tau_auto_snow_min
      WRITE (lunout, *) 'lscp_ini, expo_tau_auto_snow:', expo_tau_auto_snow
      WRITE (lunout, *) 'lscp_ini, r_snow:', r_snow
      WRITE (lunout, *) 'lscp_ini, alpha_freez:', alpha_freez
      WRITE (lunout, *) 'lscp_ini, beta_freez:', beta_freez
      WRITE (lunout, *) 'lscp_ini, rain_fallspeed_clr:', rain_fallspeed_clr
      WRITE (lunout, *) 'lscp_ini, rain_fallspeed_cld:', rain_fallspeed_cld
      WRITE (lunout, *) 'lscp_ini, snow_fallspeed_clr:', snow_fallspeed_clr
      WRITE (lunout, *) 'lscp_ini, snow_fallspeed_cld:', snow_fallspeed_cld
      ! for condensation and ice supersaturation
      WRITE (lunout, *) 'lscp_ini, ok_ice_supersat:', ok_ice_supersat
      WRITE (lunout, *) 'lscp_ini, ok_unadjusted_clouds:', ok_unadjusted_clouds
      WRITE (lunout, *) 'lscp_ini, ok_weibull_warm_clouds:', ok_weibull_warm_clouds
      WRITE (lunout, *) 'lscp_ini, iflag_cloud_sublim_pdf:', iflag_cloud_sublim_pdf
      WRITE (lunout, *) 'lscp_ini, depo_coef_cirrus:', depo_coef_cirrus
      WRITE (lunout, *) 'lscp_ini, capa_cond_cirrus:', capa_cond_cirrus
      WRITE (lunout, *) 'lscp_ini, std_subl_pdf_lscp:', std_subl_pdf_lscp
      WRITE (lunout, *) 'lscp_ini, mu_subl_pdf_lscp:', mu_subl_pdf_lscp
      WRITE (lunout, *) 'lscp_ini, beta_pdf_lscp:', beta_pdf_lscp
      WRITE (lunout, *) 'lscp_ini, temp_thresh_pdf_lscp:', temp_thresh_pdf_lscp
      WRITE (lunout, *) 'lscp_ini, k0_pdf_lscp:', k0_pdf_lscp
      WRITE (lunout, *) 'lscp_ini, kappa_pdf_lscp:', kappa_pdf_lscp
      WRITE (lunout, *) 'lscp_ini, std100_pdf_lscp:', std100_pdf_lscp
      WRITE (lunout, *) 'lscp_ini, a_homofreez:', a_homofreez
      WRITE (lunout, *) 'lscp_ini, b_homofreez:', b_homofreez
      WRITE (lunout, *) 'lscp_ini, delta_hetfreez', delta_hetfreez
      WRITE (lunout, *) 'lscp_ini, coef_mixing_lscp:', coef_mixing_lscp
      WRITE (lunout, *) 'lscp_ini, coef_shear_lscp:', coef_shear_lscp
      WRITE (lunout, *) 'lscp_ini, chi_mixing_lscp:', chi_mixing_lscp
      ! for cloudth routines
      WRITE (lunout, *) 'lscp_ini, ok_lscp_mergecond:', ok_lscp_mergecond
      WRITE (lunout, *) 'lscp_ini, ok_bug_deficit:', ok_bug_deficit
      WRITE (lunout, *) 'lscp_ini, iflag_cloudth_vert:', iflag_cloudth_vert
      WRITE (lunout, *) 'lscp_ini, cloudth_ratqsmin:', cloudth_ratqsmin
      WRITE (lunout, *) 'lscp_ini, cloudth_sigma1s_factor:', sigma1s_factor
      WRITE (lunout, *) 'lscp_ini, cloudth_sigma1s_power:', sigma1s_power
      WRITE (lunout, *) 'lscp_ini, cloudth_sigma2s_factor:', sigma2s_factor
      WRITE (lunout, *) 'lscp_ini, cloudth_sigma2s_power:', sigma2s_power
      WRITE (lunout, *) 'lscp_ini, cloudth_vert_alpha:', vert_alpha
      WRITE (lunout, *) 'lscp_ini, cloudth_vert_alpha_th:', vert_alpha_th
      WRITE (lunout, *) 'lscp_ini, iflag_cloudth_vert_noratqs:', iflag_cloudth_vert_noratqs
      ! for subgrid water variability (ratqs) routines
      WRITE (lunout, *) 'lscp_ini, iflag_ratqs:', iflag_ratqs
      WRITE (lunout, *) 'lscp_ini, ratqshaut:', ratqshaut
      WRITE (lunout, *) 'lscp_ini, ratqsbas:', ratqsbas
      WRITE (lunout, *) 'lscp_ini, ratqsdp:', ratqsdp
      WRITE (lunout, *) 'lscp_ini, ratqsp0', ratqsp0
      WRITE (lunout, *) 'lscp_ini, tau_ratqs:', tau_ratqs
      WRITE (lunout, *) 'lscp_ini, tau_var:', tau_var
      WRITE (lunout, *) 'lscp_ini, fac_tau:', fac_tau
      WRITE (lunout, *) 'lscp_ini, tau_cumulu:', tau_cumul
      WRITE (lunout, *) 'lscp_ini, a_ratqs_wake:', a_ratqs_wake
      WRITE (lunout, *) 'lscp_ini, a_ratqs_cv:', a_ratqs_cv

      ! check consistency for cloud phase partitioning options

      IF ((iflag_icefrac .GE. 2) .AND. (.NOT. ok_lscp_mergecond)) THEN
         abort_message = 'in lscp, iflag_icefrac .GE. 2 works only if ok_lscp_mergecond=.TRUE.'
         CALL abort_physic(modname, abort_message, 1)
      END IF

      ! check for precipitation sub-time steps
      IF (ABS(dtime/REAL(niter_lscp) - 360.0) .GT. 0.001) THEN
         WRITE (lunout, *) 'lscp: it is not expected, see Z.X.Li', dtime
         WRITE (lunout, *) 'I would prefer a 6 min sub-timestep'
      END IF

      ! check consistency between numerical resolution of autoconversion
      ! and other options

      IF ((iflag_autoconversion .EQ. 2) .AND. .NOT. ok_poprecip) THEN
         IF ((iflag_vice .NE. 0) .OR. (niter_lscp .GT. 1)) THEN
            abort_message = 'in lscp, iflag_autoconversion=2 requires iflag_vice=0 and niter_lscp=1'
            CALL abort_physic(modname, abort_message, 1)
         END IF
      END IF

      IF (ok_weibull_warm_clouds .AND. .NOT. ok_ice_supersat) THEN
         abort_message = 'in lscp, ok_weibull_warm_clouds=y needs ok_ice_supersat=y'
         CALL abort_physic(modname, abort_message, 1)
      END IF

      IF (ok_unadjusted_clouds .AND. .NOT. ok_ice_supersat) THEN
         abort_message = 'in lscp, ok_unadjusted_clouds=y needs ok_ice_supersat=y'
         CALL abort_physic(modname, abort_message, 1)
      END IF

      ! Initialisations
      a_tr_sca(1) = -0.5
      a_tr_sca(2) = -0.5
      a_tr_sca(3) = -0.5
      a_tr_sca(4) = -0.5

      DO k = 1, klev
         DO i = 1, klon
            pfrac_nucl(i, k) = 1.
            pfrac_1nucl(i, k) = 1.
            pfrac_impa(i, k) = 1.
         END DO
      END DO


      ! Initialisation of variances of subgrid variability of water
      ! for the prognostic parameterisation
      ! Works only in 1D so far, but should become a state variable
      ! of the model and an argument of the routines

      allocate (povariance(klon, klev))
      allocate (var_conv(klon, klev))

      IF (klon .EQ. 1) THEN
         DO k = 1, klev
            DO i = 1, klon
               povariance(i, k) = 0.00000000001
               var_conv(i, k) = 0.00000000001
            END DO
         END DO
      ELSE
         WRITE (lunout, *) 'variance of subgrid variability of water should be conserved in restart files'
      END IF

      RETURN

   END SUBROUTINE lscp_ini

END MODULE lmdz_lscp_ini

! $Id $
MODULE cvltr_mod
CONTAINS
!
!
SUBROUTINE cvltr(pdtime, da, phi,phi2,d1a,dam, mpIN,epIN, &
!!           sigd,sij,clw,elij,epmlmMm,eplaMm,              &   !RL
           sigd,sij,wght_cvfd,clw,elij,epmlmMm,eplaMm,    &     !RL
           pmflxrIN,pmflxsIN,ev,te,wdtrainA,wdtrainM,     &
           paprs,it,tr,upd,dnd,inb,icb,                   &
           dtrcv,trsptd,dtrSscav,dtrsat,dtrUscav,qDi,qPr, &
           qPa,qMel,qTrdi,dtrcvMA,Mint,                   &
           zmfd1a,zmfphi2,zmfdam)
USE yoecumf_mod_h
! Replayisation USE conema3_mod_h
USE lmdz_cv_ini, ONLY : epmax
    USE IOIPSL
  USE dimphy
  USE infotrac_phy, ONLY : nbtr
! Replayisation USE yomcst_mod_h
USE lmdz_cv_ini, ONLY : g
IMPLICIT NONE
!=====================================================================
! Objet : convection des traceurs / KE
! Auteurs: M-A Filiberti and J-Y Grandpeix
! modifiee par R Pilon : lessivage des traceurs / KE
!=====================================================================



! Entree
  REAL,INTENT(IN)                           :: pdtime
  REAL,DIMENSION(klon,klev),INTENT(IN)      :: da
  REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: phi
! RomP
  REAL,DIMENSION(klon,klev),INTENT(IN)      :: d1a,dam ! matrices pour simplifier
  REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: phi2    ! l'ecriture des tendances
!
  REAL,DIMENSION(klon,klev),INTENT(IN)      :: mpIN
  REAL,DIMENSION(klon,klev+1),INTENT(IN)    :: paprs  ! pression aux 1/2 couches (bas en haut)
!  REAL,DIMENSION(klon,klev),INTENT(IN)    :: pplay ! pression aux 1/2 couches (bas en haut)
  REAL,DIMENSION(klon,klev,nbtr),INTENT(IN) :: tr     ! q de traceur (bas en haut)
  INTEGER,INTENT(IN)                        :: it 
  REAL,DIMENSION(klon,klev),INTENT(IN)      :: upd   ! saturated updraft mass flux
  REAL,DIMENSION(klon,klev),INTENT(IN)      :: dnd   ! saturated downdraft mass flux
!
  REAL,DIMENSION(klon,klev),INTENT(IN)      :: wdtrainA   ! masses precipitantes de l'asc adiab
  REAL,DIMENSION(klon,klev),INTENT(IN)      :: wdtrainM   ! masses precipitantes des melanges
  REAL,DIMENSION(klon,klev),INTENT(IN)      :: pmflxrIN   ! vprecip: eau
  REAL,DIMENSION(klon,klev),INTENT(IN)      :: pmflxsIN   ! vprecip: neige
  REAL,DIMENSION(klon,klev),INTENT(IN)      :: ev         ! evaporation cv30_routine
  REAL,DIMENSION(klon,klev),INTENT(IN)      :: epIN
  REAL,DIMENSION(klon,klev),INTENT(IN)      :: te 
  REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: sij        ! fraction dair de lenv
  REAL,DIMENSION(klon,klev),INTENT(IN)      :: wght_cvfd  ! weights of the layers feeding convection
  REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: elij       ! contenu en eau condens�e sp�cifique/conc deau condens�e massique
  REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: epmlmMm    ! eau condensee precipitee dans mel masse dair sat
  REAL,DIMENSION(klon,klev),INTENT(IN)      :: eplaMm    ! eau condensee precipitee dans aa masse dair sat

  REAL,DIMENSION(klon,klev),INTENT(IN)      :: clw        ! contenu en eau condens�e dans lasc adiab
  REAL,DIMENSION(klon),INTENT(IN)           :: sigd
  INTEGER,DIMENSION(klon),INTENT(IN)        :: icb,inb
! Sortie
  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)     :: dtrcv     ! tendance totale (bas en haut)
  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)     :: dtrcvMA ! M-A Filiberti
  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)     :: trsptd    ! tendance du transport 
  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)     :: dtrSscav  ! tendance du lessivage courant sat
  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)     :: dtrsat    ! tendance trsp+sat scav
  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)     :: dtrUscav  ! tendance du lessivage courant unsat
!
! Variables locales
  INTEGER                           :: i,j,k
  REAL,DIMENSION(klon,klev)         :: dxpres   ! difference de pression entre niveau (j+1) et (j)
  REAL                              :: pdtimeRG ! pas de temps * gravite
! variables pour les courants satures
  REAL,DIMENSION(klon,klev,klev)    :: zmd
  REAL,DIMENSION(klon,klev,klev)    :: za
  REAL,DIMENSION(klon,klev,nbtr)    :: zmfd,zmfa
  REAL,DIMENSION(klon,klev,nbtr)    :: zmfp,zmfu
  REAL,DIMENSION(klon,nbtr)         :: qfeed     ! tracer concentration feeding convection

  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)    :: zmfd1a
  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)    :: zmfdam
  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)    :: zmfphi2

! RomP ! les variables sont nettoyees des valeurs aberrantes
  REAL,DIMENSION(klon,klev)         :: Pa, Pm  ! pluie AA et m�langes, var temporaire
  REAL,DIMENSION(klon,klev)         :: pmflxs,pmflxr ! pmflxrIN,pmflxsIN sans valeur aberante
  REAL,DIMENSION(klon,klev)         :: mp            ! flux de masse
  REAL,DIMENSION(klon,klev)         :: ep            ! fraction d'eau convertie en precipitation 
  REAL,DIMENSION(klon,klev)         :: evap          ! evaporation : variable temporaire 
  REAL,DIMENSION(klon,klev)         :: rho    !environmental density

  REAL,DIMENSION(klon,klev)         :: kappa ! denominateur du au calcul de la matrice 
                                             ! pour obtenir qd et qp
  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)    :: qTrdi ! traceurs descente air insature transport MA
  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)    :: qDi  ! traceurs descente insaturees
  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)    :: qPr  ! traceurs colonne precipitante
  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)    :: qPa  ! traceurs dans les precip issues lasc. adiab.
  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)    :: qMel ! traceurs dans les precip issues des melanges
  REAL,DIMENSION(klon,klev,nbtr)                :: qMeltmp ! variable temporaire 
  REAL,DIMENSION(klon,klev,nbtr)                :: qpmMint
  REAL,DIMENSION(klon,klev),INTENT(OUT)         :: Mint
! tendances
  REAL                              :: tdcvMA           ! terme de transport de traceur (schema Marie Angele)
  REAL                              :: trsptrac         ! terme de transport de traceur par l'air
  REAL                              :: scavtrac         ! terme de lessivage courant sature
  REAL                              :: uscavtrac        ! terme de lessivage courant insature
! impaction
!!!       Correction apres discussion Romain P. / Olivier B. 
!!!  REAL,PARAMETER                    :: rdrop=2.5e-3     ! rayon des gouttes d'eau
  REAL,PARAMETER                    :: rdrop=1.e-3     ! rayon des gouttes d'eau 
!!!
  REAL,DIMENSION(klon,klev)         :: imp              ! coefficient d'impaction
! parametres lessivage
  REAL                    :: ccntrAA_coef        ! \alpha_a : fract aerosols de l'AA convertis en CCN
  REAL                    :: ccntrENV_coef       ! \beta_m  : fract aerosols de l'env convertis en CCN
  REAL                    :: coefcoli            ! coefficient de collision des gouttes sur les aerosols
!
  LOGICAL,DIMENSION(klon,klev) :: NO_precip
!  LOGICAL                      :: scavON
! var tmp tests
  REAL                           :: conserv
  real                           :: conservMA

real :: rg

rg=g ! FH 2026/01/27 historique cohabitation constantes cv et yomcst A nettoyer

! coefficient lessivage
   ccntrAA_coef     = 0.
   ccntrENV_coef    = 0.
   coefcoli         = 0.

!$OMP MASTER
  call getin('ccntrAA_coef',ccntrAA_coef)
  call getin('ccntrENV_coef',ccntrENV_coef)
  call getin('coefcoli',coefcoli)
!$OMP END MASTER
!$OMP BARRIER
  print*,'cvltr coef lessivage convectif', ccntrAA_coef,ccntrENV_coef,coefcoli

!  scavON=.TRUE.
!  if(scavON) then
!   ccntrAA_coef     = 1.
!   ccntrENV_coef    = 1.
!   coefcoli         = 1.
!  else
!   ccntrAA_coef     = 0.
!   ccntrENV_coef    = 0.
!   coefcoli         = 0.
!  endif

! ======================================================
! calcul de l'impaction
! ======================================================
!initialisation
  do j=1,klev
   do i=1,klon
     imp(i,j)=0.
   enddo
  enddo
! impaction sur la surface de la colonne de la descente insaturee
! On prend la moyenne des precip entre le niveau i+1 et i
! I=3/4* (P(1+1)+P(i))/2 / (sigd*r*rho_l)
!  1000kg/m3= densit� de l'eau
! 0.75e-3 = 3/4 /1000
! Par la suite, I est tout le temps multipli� par sig_d pour avoir l'impaction sur la surface de la maille
! on le n�glige ici pour simplifier le code
  do j=1,klev-1
   do i=1,klon
    imp(i,j) = coefcoli*0.75e-3/rdrop *&
             0.5*(pmflxr(i,j+1)+pmflxs(i,j+1)+pmflxr(i,j)+pmflxs(i,j))
!    rho(i,j)=pplay(i,j)/(rd*te(i,j))
   enddo
  enddo
!
! initialisation pour flux de traceurs, td et autre
   trsptrac = 0.
   scavtrac = 0.
   uscavtrac = 0.
   qfeed(:,it) = 0.              !RL
  DO j=1,klev
   DO i=1,klon
    zmfd(i,j,it)=0.
    zmfa(i,j,it)=0.
    zmfu(i,j,it)=0.
    zmfp(i,j,it)=0.
    zmfphi2(i,j,it)=0.
    zmfd1a(i,j,it)=0.
    zmfdam(i,j,it)=0.
    qDi(i,j,it)=0.
    qPr(i,j,it)=0.
    qPa(i,j,it)=0.
    qMel(i,j,it)=0.
    qMeltmp(i,j,it)=0.
    qTrdi(i,j,it)=0.
    kappa(i,j)=0.
    trsptd(i,j,it)=0.
    dtrsat(i,j,it)=0.
    dtrSscav(i,j,it)=0.
    dtrUscav(i,j,it)=0.
    dtrcv(i,j,it)=0.
    dtrcvMA(i,j,it)=0.
    evap(i,j)=0.
    dxpres(i,j)=0.
    qpmMint(i,j,it)=0.
    Mint(i,j)=0.
   END DO
  END DO

! suppression des valeurs tr�s faibles (~1e-320)
! multiplication de levaporation pour lavoir par unite de temps
! et par unite de surface de la maille
! -> cv30_unsat : evap : masse evaporee/s/(m2 de la descente)
  DO j=1,klev
   DO i=1,klon
    if(ev(i,j).lt.1.e-16) then
     evap(i,j)=0.
    else
     evap(i,j)=ev(i,j)*sigd(i)
    endif
   END DO
  END DO

  DO j=1,klev
   DO i=1,klon
   if(j.lt.klev) then
    if(epIN(i,j).lt.1.e-32) then
     ep(i,j)=0.
    else
     ep(i,j)=epIN(i,j)
    endif
   else
    ep(i,j)=epmax
   endif
    if(mpIN(i,j).lt.1.e-32) then
     mp(i,j)=0.
    else
     mp(i,j)=mpIN(i,j)
    endif
    if(pmflxsIN(i,j).lt.1.e-32) then
     pmflxs(i,j)=0.
    else
     pmflxs(i,j)=pmflxsIN(i,j)
    endif
    if(pmflxrIN(i,j).lt.1.e-32) then
     pmflxr(i,j)=0.
    else
     pmflxr(i,j)=pmflxrIN(i,j)
    endif
    if(wdtrainA(i,j).lt.1.e-32) then
     Pa(i,j)=0.
    else
     Pa(i,j)=wdtrainA(i,j)
    endif
    if(wdtrainM(i,j).lt.1.e-32) then
     Pm(i,j)=0.
    else
     Pm(i,j)=wdtrainM(i,j)
    endif
   END DO
  END DO

!==========================================
  DO j = klev-1,1,-1
   DO i = 1,klon
     NO_precip(i,j) = (pmflxr(i,j+1)+pmflxs(i,j+1)).lt.1.e-10&
                    .and.Pa(i,j).lt.1.e-10.and.Pm(i,j).lt.1.e-10
   END DO
  END DO

! =========================================
! calcul des tendances liees au downdraft
! =========================================
!cdir collapse
  DO k=1,klev
   DO j=1,klev
    DO i=1,klon
     zmd(i,j,k)=0.
     za (i,j,k)=0.
    END DO
   END DO
  END DO
! calcul de la matrice d echange
! matrice de distribution de la masse entrainee en k
! commmentaire RomP : mp > 0
  DO k=1,klev-1
     DO i=1,klon
        zmd(i,k,k)=max(0.,mp(i,k)-mp(i,k+1))   ! ~ mk(k)
     END DO
  END DO
  DO k=2,klev
     DO j=k-1,1,-1
        DO i=1,klon
           if(mp(i,j+1).gt.1.e-10) then
              zmd(i,j,k)=zmd(i,j+1,k)*min(1.,mp(i,j)/mp(i,j+1)) !det ~ mk(j)=mk(j+1)*mp(i,j)/mp(i,j+1)
           ENDif
        END DO
     END DO
  END DO
  DO k=1,klev
     DO j=1,klev-1
        DO i=1,klon
           za(i,j,k)=max(0.,zmd(i,j+1,k)-zmd(i,j,k))
        END DO
     END DO
  END DO
!!!!! quantite  de traceur dans la descente d'air insaturee  :   4 juin 2012
  DO k=1,klev
     DO j=1,klev-1
        DO i=1,klon
        if(mp(i,j+1).gt.1.e-10) then
          qTrdi(i,j+1,it)=qTrdi(i,j+1,it)+(zmd(i,j+1,k)/mp(i,j+1))*tr(i,k,it)
        else
          qTrdi(i,j,it)=0.!tr(i,j,it)
        endif
        ENDDO
     ENDDO
  ENDDO
!!!!!
!
! rajout du terme lie a l ascendance induite
!
  DO j=2,klev
     DO i=1,klon
        za(i,j,j-1)=za(i,j,j-1)+mp(i,j)
     END DO
  END DO
!
! tendance courants insatures  ! sans lessivage ancien schema
!
  DO k=1,klev
     DO j=1,klev
        DO i=1,klon
           zmfd(i,j,it)=zmfd(i,j,it)+za(i,j,k)*(tr(i,k,it)-tr(i,j,it))
        END DO
     END DO
  END DO
!
! =========================================
! calcul des tendances liees aux courants satures   j <-> z ; k <-> z'
! =========================================
!
!RL
!  Feeding concentrations
  DO j=1,klev
     DO i=1,klon
        qfeed(i,it)=qfeed(i,it)+wght_cvfd(i,j)*tr(i,j,it)
     END DO
  END DO
!RL
!
  DO j=1,klev
     DO i=1,klon
!RL
!!        zmfa(i,j,it)=da(i,j)*(tr(i,1,it)-tr(i,j,it))                     ! da
        zmfa(i,j,it)=da(i,j)*(qfeed(i,it)-tr(i,j,it))                     ! da
!RL
     END DO
  END DO
!
  DO k=1,klev
     DO j=1,klev
        DO i=1,klon
           zmfp(i,j,it)=zmfp(i,j,it)+phi(i,j,k)*(tr(i,k,it)-tr(i,j,it))  ! phi
        END DO
     END DO
  END DO
! RomP ajout des matrices liees au lessivage
  DO j=1,klev
     DO i=1,klon
        zmfd1a(i,j,it)=d1a(i,j)*tr(i,1,it)   ! da1
        zmfdam(i,j,it)=dam(i,j)*tr(i,1,it)   ! dam
     END DO
  END DO
  DO k=1,klev
     DO j=1,klev
        DO i=1,klon
          zmfphi2(i,j,it)=zmfphi2(i,j,it)+phi2(i,j,k)*tr(i,k,it)  ! psi
        END DO
     END DO
  END DO
  DO j=1,klev-1
     DO i=1,klon
        zmfu(i,j,it)=max(0.,upd(i,j+1)+dnd(i,j+1))*(tr(i,j+1,it)-tr(i,j,it))
     END DO
  END DO
  DO j=2,klev
     DO i=1,klon
        zmfu(i,j,it)=zmfu(i,j,it)+min(0.,upd(i,j)+dnd(i,j))*(tr(i,j,it)-tr(i,j-1,it))
     END DO
  END DO
! ===================================================
! calcul des tendances liees aux courants insatures
! ===================================================
!  pression  
  DO k=1, klev
     DO i=1, klon
        dxpres(i,k)=paprs(i,k)-paprs(i,k+1)
     ENDDO
  ENDDO
  pdtimeRG=pdtime*RG

! q_pa et q_pm    traceurs issues des courants satures se retrouvant dans les precipitations
  DO j=1,klev
     DO i=1,klon
        if(j.ge.icb(i).and.j.le.inb(i)) then
          if(clw(i,j).gt.1.e-16) then
           qPa(i,j,it)=ccntrAA_coef*tr(i,1,it)/clw(i,j)
          else
           qPa(i,j,it)=0.
          endif
        endif
     END DO
  END DO

! calcul de q_pm en 2 parties :
! 1) calcul de sa valeur pour un niveau z' donne
! 2) integration sur la verticale sur z'
     DO j=1,klev
      DO k=1,j-1
        DO i=1,klon
        if(k.ge.icb(i).and.k.le.inb(i).and.& 
           j.le.inb(i)) then
            if(elij(i,k,j).gt.1.e-16) then
             qMeltmp(i,j,it)=((1-ep(i,k))*ccntrAA_coef*tr(i,1,it)&
                         *(1.-sij(i,k,j))  +ccntrENV_coef&
                         *tr(i,k,it)*sij(i,k,j)) / elij(i,k,j)
            else
             qMeltmp(i,j,it)=0.
            endif
          qpmMint(i,j,it)=qpmMint(i,j,it) + qMeltmp(i,j,it)*epmlmMm(i,j,k)
          Mint(i,j)=Mint(i,j) + epmlmMm(i,j,k)
        endif ! end if dans nuage
        END DO
     END DO
  END DO

     DO j=1,klev
        DO i=1,klon
          if(Mint(i,j).gt.1.e-16) then
           qMel(i,j,it)=qpmMint(i,j,it)/Mint(i,j)
          else
           qMel(i,j,it)=0.
          endif
     END DO
  END DO

! calcul de q_d et q_p    traceurs de la descente precipitante 
   DO j=klev-1,1,-1
    DO i=1,klon
     if(mp(i,j+1).gt.mp(i,j).and.mp(i,j+1).gt.1.e-10) then  ! detrainement
       kappa(i,j)=((pmflxr(i,j+1)+pmflxs(i,j+1)+Pa(i,j)+Pm(i,j))*&
                (-mp(i,j+1)-imp(i,j)/RG*dxpres(i,j))&
                + (imp(i,j)/RG*dxpres(i,j))*(evap(i,j)/RG*dxpres(i,j)))
             
     elseif(mp(i,j).gt.mp(i,j+1).and.mp(i,j).gt.1.e-10) then! entrainement
       if(j.eq.1) then
        kappa(i,j)=((pmflxr(i,j+1)+pmflxs(i,j+1)+Pa(i,j)+Pm(i,j))*&
                 (-mp(i,2)-imp(i,j)/RG*dxpres(i,j))&
                 + (imp(i,j)/RG*dxpres(i,j))*(evap(i,j)/RG*dxpres(i,j)))
       else
        kappa(i,j)=((pmflxr(i,j+1)+pmflxs(i,j+1)+Pa(i,j)+Pm(i,j))*&
                 (-mp(i,j)-imp(i,j)/RG*dxpres(i,j))&
                 + (imp(i,j)/RG*dxpres(i,j))*(evap(i,j)/RG*dxpres(i,j)))
       endif
      else
        kappa(i,j)=1.
      endif
    ENDDO
   ENDDO

  DO j=klev-1,1,-1
   DO i=1,klon
    if (abs(kappa(i,j)).lt.1.e-25) then    !si denominateur nul (il peut y avoir des mp!=0)
     kappa(i,j)=1.
     if(j.eq.1) then
       qDi(i,j,it)=qDi(i,j+1,it) !orig tr(i,j,it)   ! mp(1)=0 donc tout vient de la couche sup�rieure
     elseif(mp(i,j+1).gt.mp(i,j).and.mp(i,j+1).gt.1.e-10) then
       qDi(i,j,it)=qDi(i,j+1,it)
     elseif(mp(i,j).gt.mp(i,j+1).and.mp(i,j).gt.1.e-10) then! entrainement
       qDi(i,j,it)=(-mp(i,j+1)*(qDi(i,j+1,it)-tr(i,j,it))-mp(i,j)*tr(i,j,it))/(-mp(i,j))
     else  ! si  mp (i)=0 et mp(j+1)=0
       qDi(i,j,it)=tr(i,j,it) ! orig 0.
     endif 

      if(NO_precip(i,j)) then
       qPr(i,j,it)=0.
      else
       qPr(i,j,it)=((pmflxr(i,j+1)+pmflxs(i,j+1))*qPr(i,j+1,it)+&
                   Pa(i,j)*qPa(i,j,it)+Pm(i,j)*qMel(i,j,it)&
                   +imp(i,j)/RG*dxpres(i,j)*qDi(i,j,it))/&
                  (pmflxr(i,j+1)+pmflxs(i,j+1)+Pa(i,j)+Pm(i,j))
      endif
    else   !     denominateur non nul
     kappa(i,j)=1./kappa(i,j)     
! calcul de qd et qp
!!jyg  (20130119) correction pour le sommet du nuage
!!     if(j.ge.inb(i)) then       !au-dessus du nuage, sommet inclu
     if(j.gt.inb(i)) then       !au-dessus du nuage
       qDi(i,j,it)=tr(i,j,it)   ! pas de descente => environnement = descente insaturee
       qPr(i,j,it)=0.

!  vvv premiere couche du modele ou mp(1)=0  ! det tout le temps  vvv
     elseif(j.eq.1) then 
      if(mp(i,2).gt.1.e-10) then !mp(2) non nul -> detrainement (car mp(1) = 0) !ent pas possible
       if(NO_precip(i,j)) then !pas de precip en (i)
        qDi(i,j,it)=qDi(i,j+1,it)
        qPr(i,j,it)=0.
       else
        qDi(i,j,it)=kappa(i,j)*(&
            (-evap(i,j)/RG*dxpres(i,j))*((pmflxr(i,j+1)+pmflxs(i,j+1))*qPr(i,j+1,it)+&
            Pa(i,j)*qPa(i,j,it)+Pm(i,j)*qMel(i,j,it)) +&
            (pmflxr(i,j+1)+pmflxs(i,j+1)+Pa(i,j)+Pm(i,j))*&
            (-mp(i,j+1)*qDi(i,j+1,it)))

        qPr(i,j,it)=kappa(i,j)*(&
            (-mp(i,j+1)-imp(i,j)/RG*dxpres(i,j))*&
            ((pmflxr(i,j+1)+pmflxs(i,j+1))*qPr(i,j+1,it)+&
            Pa(i,j)*qPa(i,j,it)+Pm(i,j)*qMel(i,j,it))&
            +(-mp(i,j+1)*qDi(i,j+1,it)) * (imp(i,j)/RG*dxpres(i,j)))
       endif

      else !mp(2) nul -> plus de descente insaturee -> pluie agit sur environnement
        qDi(i,j,it)=tr(i,j,it) ! orig 0.
        if(NO_precip(i,j)) then
         qPr(i,j,it)=0.
        else
         qPr(i,j,it)=((pmflxr(i,j+1)+pmflxs(i,j+1))*qPr(i,j+1,it)+&
                   Pa(i,j)*qPa(i,j,it)+Pm(i,j)*qMel(i,j,it)&
                   +imp(i,j)/RG*dxpres(i,j)*tr(i,j,it))/&
                  (pmflxr(i,j+1)+pmflxs(i,j+1)+Pa(i,j)+Pm(i,j))
        endif

      endif  !mp(2) nul ou non

! vvv  (j!=1.and.j.lt.inb(i))  en-dessous du sommet nuage   vvv
     else 
!------------------------------------------------------------- detrainement 
      if(mp(i,j+1).gt.mp(i,j).and.mp(i,j+1).gt.1.e-10) then !mp(i,j).gt.1.e-10) then
         if(NO_precip(i,j)) then 
          qDi(i,j,it)=qDi(i,j+1,it)
          qPr(i,j,it)=0.
         else
          qDi(i,j,it)=kappa(i,j)*(&
            (-evap(i,j)/RG*dxpres(i,j))*((pmflxr(i,j+1)+pmflxs(i,j+1))*qPr(i,j+1,it)+&
            Pa(i,j)*qPa(i,j,it)+Pm(i,j)*qMel(i,j,it)) +&
            (pmflxr(i,j+1)+pmflxs(i,j+1)+Pa(i,j)+Pm(i,j))*&
            (-mp(i,j+1)*qDi(i,j+1,it)))
!
          qPr(i,j,it)=kappa(i,j)*(&
            (-mp(i,j+1)-imp(i,j)/RG*dxpres(i,j))*&
            ((pmflxr(i,j+1)+pmflxs(i,j+1))*qPr(i,j+1,it)+&
            Pa(i,j)*qPa(i,j,it)+Pm(i,j)*qMel(i,j,it))&
            +(-mp(i,j+1)*qDi(i,j+1,it)) * (imp(i,j)/RG*dxpres(i,j)))
         endif !precip
!------------------------------------------------------------- entrainement 
      elseif(mp(i,j).gt.mp(i,j+1).and.mp(i,j).gt.1.e-10) then 
         if(NO_precip(i,j)) then
          qDi(i,j,it)=(-mp(i,j+1)*(qDi(i,j+1,it)-tr(i,j,it))-mp(i,j)*tr(i,j,it))/(-mp(i,j))
          qPr(i,j,it)=0.
         else
          qDi(i,j,it)=kappa(i,j)*(&
            (-evap(i,j)/RG*dxpres(i,j))*((pmflxr(i,j+1)+pmflxs(i,j+1))*qPr(i,j+1,it)+&
            Pa(i,j)*qPa(i,j,it)+Pm(i,j)*qMel(i,j,it)) +&
            (pmflxr(i,j+1)+pmflxs(i,j+1)+Pa(i,j)+Pm(i,j))*&
            (-mp(i,j+1)*(qDi(i,j+1,it)-tr(i,j,it))-mp(i,j)*tr(i,j,it)))
!
          qPr(i,j,it)=kappa(i,j)*(&
            (-mp(i,j)-imp(i,j)/RG*dxpres(i,j))*&
            ((pmflxr(i,j+1)+pmflxs(i,j+1))*qPr(i,j+1,it)+&
            Pa(i,j)*qPa(i,j,it)+Pm(i,j)*qMel(i,j,it))&
            +(-mp(i,j+1)*(qDi(i,j+1,it)-tr(i,j,it))-mp(i,j)*tr(i,j,it))*&
            (imp(i,j)/RG*dxpres(i,j)))
         endif !precip
!------------------------------------------------------------- endif ! ent/det
      else  !mp nul
        qDi(i,j,it)=tr(i,j,it) ! orig 0.
        if(NO_precip(i,j)) then
         qPr(i,j,it)=0.
        else
         qPr(i,j,it)=((pmflxr(i,j+1)+pmflxs(i,j+1))*qPr(i,j+1,it)+&
                   Pa(i,j)*qPa(i,j,it)+Pm(i,j)*qMel(i,j,it)&
                   +imp(i,j)/RG*dxpres(i,j)*tr(i,j,it))/&
                  (pmflxr(i,j+1)+pmflxs(i,j+1)+Pa(i,j)+Pm(i,j))
        endif
      endif ! mp nul ou non
     endif ! condition sur j
    endif ! kappa
   ENDDO
  ENDDO

!! print test descente insaturee
!  DO j=klev,1,-1
!   DO i=1,klon
!     if(it.eq.3) then
!   write(*,'(I2,2X,a,e20.12,2X,a,e20.12,2X,a,e20.12,2X,a,e20.12,2X,a,e20.12,2X,a,e20.12,2X,a,e20.12)') j,&
!!         'zmfdam',zmfdam(i,j,it),'zmfpsi',zmfphi2(i,j,it),&
!          'zmfdam+zmfpsi',zmfdam(i,j,it)+zmfphi2(i,j,it),'qpmMint',qpmMint(i,j,it),&
!          'Pm',Pm(i,j),'Mint',Mint(i,j),&
!!          'zmfa',zmfa(i,j,it),'zmfp',zmfp(i,j,it),&
!        'zmfdam',zmfdam(i,j,it),'zmfpsi',zmfphi2(i,j,it),'zmfd1a',zmfd1a(i,j,it)
!!          'Pa',Pa(i,j),'eplaMm',eplaMm(i,j)
!!         'zmfd1a=da1*qa',zmfd1a(i,j,it),'Pa*qPa',wdtrainA(i,j)*qPa(i,j,it),'da1',d1a(i,j)
!     endif
!   ENDDO
!  ENDDO


! ===================================================
! calcul final des tendances
! ===================================================

  DO k=klev-1,1,-1
    DO i=1, klon
! transport
     tdcvMA=zmfd(i,k,it)+zmfu(i,k,it)+zmfa(i,k,it)+zmfp(i,k,it)   ! double comptage des downdraft insatures
     trsptrac=zmfu(i,k,it)+zmfa(i,k,it)+zmfp(i,k,it)
! lessivage courants satures
     scavtrac=-ccntrAA_coef*zmfd1a(i,k,it)&
               -zmfphi2(i,k,it)*ccntrENV_coef&
               -zmfdam(i,k,it)*ccntrAA_coef
! lessivage courants insatures
   if(k.le.inb(i).and.k.gt.1) then   ! tendances dans le nuage
!------------------------------------------------------------- detrainement
      if(mp(i,k+1).gt.mp(i,k).and.mp(i,k+1).gt.1.e-10) then
        uscavtrac= (-mp(i,k)+mp(i,k+1))*(qDi(i,k,it)-tr(i,k,it))&
                   + mp(i,k)*(tr(i,k-1,it)-tr(i,k,it))
!
!        if(it.eq.3) write(*,'(I2,1X,a,5X,e20.12,82X,a,e20.12)')k,' det incloud',&
!                    (-mp(i,k)+mp(i,k+1))*(qDi(i,k,it)-tr(i,k,it))*pdtimeRG/dxpres(i,k)+&
!                    mp(i,k)*(tr(i,k-1,it)-tr(i,k,it))*pdtimeRG/dxpres(i,k),&
!                    'mp',mp(i,k)
!------------------------------------------------------------- entrainement 
      elseif(mp(i,k).gt.mp(i,k+1).and.mp(i,k).gt.1.e-10) then
         uscavtrac= mp(i,k)*(tr(i,k-1,it)-tr(i,k,it))
!
!         if(it.eq.3) write(*,'(I2,1X,a,5X,e20.12,82X,a,e20.12)')k,' ent incloud',uscavtrac*pdtimeRG/dxpres(i,k), 'mp',mp(i,k)
!=!------------------------------------------------------------- end ent/det 
      else !        mp(i,k+1)=0. et mp(i,k)=0.    pluie directement sur l environnement

        if(NO_precip(i,k)) then
          uscavtrac=0.
!         if(it.eq.3) write(*,'(I2,1X,a,e20.12,82X,a,e20.12)')k,' no P ent incloud',uscavtrac*pdtimeRG/dxpres(i,k), 'mp',mp(i,k)
        else
          uscavtrac=-imp(i,k)*tr(i,k,it)*dxpres(i,k)/RG+evap(i,k)*qPr(i,k,it)*dxpres(i,k)/RG
!         if(it.eq.3) write(*,'(I2,1X,a,3X,e20.12,82X,a,e20.12)')k,' P env incloud',uscavtrac*pdtimeRG/dxpres(i,k), 'mp',mp(i,k)
        endif
      endif  ! mp/det/ent
!------------------------------------------------------------- premiere couche 
   elseif(k.eq.1) then  !                                      mp(1)=0.
      if(mp(i,2).gt.1.e-10) then  !detrainement
         uscavtrac= (-0.+mp(i,2))*(qDi(i,k,it)-tr(i,k,it)) !&
!                   + mp(i,2)*(0.-tr(i,k,it))
!
!       if(it.eq.3) write(*,'(I2,1X,a,e20.12,84X,a,e20.12)')k,' 1 det',&
!                  (-0.+mp(i,2))*(qDi(i,k,it)-tr(i,k,it))*pdtimeRG/dxpres(i,k)+&
!                  mp(i,2)*(0.-tr(i,k,it))*pdtimeRG/dxpres(i,k),&
!                   'mp',mp(i,k)
      else   ! mp(2) = 0 = mp(1) pas de descente insaturee, rien ne se passe s'il ne pleut pas, sinon pluie->env
        if(NO_precip(i,1)) then
          uscavtrac=0.
        else
          uscavtrac=-imp(i,k)*tr(i,k,it)*dxpres(i,k)/RG+evap(i,k)*qPr(i,k,it)*dxpres(i,k)/RG
        endif
!         if(it.eq.3) write(*,'(I2,1X,a,2X,e20.12,82X,a,e20.12)')k,'1 P env incloud',uscavtrac*pdtimeRG/dxpres(i,k), 'mp',mp(i,k)
      endif

   else   ! k > INB  au-dessus du nuage
    uscavtrac=0.
   endif

! =====    tendances finales  ======
     trsptd(i,k,it)=trsptrac*pdtimeRG/dxpres(i,k)              ! td transport sans eau dans courants satures
     dtrSscav(i,k,it)=scavtrac*pdtimeRG/dxpres(i,k)            ! td du lessivage dans courants satures
     dtrUscav(i,k,it)=uscavtrac*pdtimeRG/dxpres(i,k)           ! td courant insat
     dtrsat(i,k,it)=(trsptrac+scavtrac)*pdtimeRG/dxpres(i,k)   ! td courant sat
     dtrcv(i,k,it)=(trsptrac+scavtrac+uscavtrac)*pdtimeRG/dxpres(i,k)!dtrsat(i,k,it)+dtrUscav(i,k,it)         td conv
!!!!!!
     dtrcvMA(i,k,it)=tdcvMA*pdtimeRG/dxpres(i,k) ! MA tendance convection
     ENDDO
  ENDDO

! test de conservation du traceur
!print*,"_____________________________________________________________"
!print*,"                                                             "
!      conserv=0.
!      conservMA=0.
!      DO k= klev-1,1,-1
!        DO i=1, klon
!         conserv=conserv+dtrcv(i,k,it)*   &
!        (paprs(i,k)-paprs(i,k+1))/RG
!         conservMA=conservMA+dtrcvMA(i,k,it)*   &
!        (paprs(i,k)-paprs(i,k+1))/RG
!
!      if(it.eq.3)  write(*,'(I2,2X,a,e20.12,2X,a,e20.12,2X,a,e20.12,2X,a,e20.12)') k,&
!         'MA td ',dtrcvMA(i,k,it)*dxpres(i,k)/RG,&
!         ' td',dtrcv(i,k,it)*dxpres(i,k)/RG,'         conservMA ',conservMA,'conserv ',conserv
!!
!        ENDDO
!      ENDDO
!       if(it.eq.3) print *,'it',it,'conserv ',conserv,'conservMA ',conservMA

END SUBROUTINE cvltr
END MODULE cvltr_mod
